/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

/* First part of user prologue.  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "access/tableam.h"
#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "gramparse.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 298 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_UIDENT = 4,                     /* UIDENT  */
  YYSYMBOL_FCONST = 5,                     /* FCONST  */
  YYSYMBOL_SCONST = 6,                     /* SCONST  */
  YYSYMBOL_USCONST = 7,                    /* USCONST  */
  YYSYMBOL_BCONST = 8,                     /* BCONST  */
  YYSYMBOL_XCONST = 9,                     /* XCONST  */
  YYSYMBOL_Op = 10,                        /* Op  */
  YYSYMBOL_ICONST = 11,                    /* ICONST  */
  YYSYMBOL_PARAM = 12,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 13,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 14,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 15,              /* COLON_EQUALS  */
  YYSYMBOL_EQUALS_GREATER = 16,            /* EQUALS_GREATER  */
  YYSYMBOL_LESS_EQUALS = 17,               /* LESS_EQUALS  */
  YYSYMBOL_GREATER_EQUALS = 18,            /* GREATER_EQUALS  */
  YYSYMBOL_NOT_EQUALS = 19,                /* NOT_EQUALS  */
  YYSYMBOL_ABORT_P = 20,                   /* ABORT_P  */
  YYSYMBOL_ABSENT = 21,                    /* ABSENT  */
  YYSYMBOL_ABSOLUTE_P = 22,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 23,                    /* ACCESS  */
  YYSYMBOL_ACTION = 24,                    /* ACTION  */
  YYSYMBOL_ADD_P = 25,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 26,                     /* ADMIN  */
  YYSYMBOL_AFTER = 27,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 28,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 29,                       /* ALL  */
  YYSYMBOL_ALSO = 30,                      /* ALSO  */
  YYSYMBOL_ALTER = 31,                     /* ALTER  */
  YYSYMBOL_ALWAYS = 32,                    /* ALWAYS  */
  YYSYMBOL_ANALYSE = 33,                   /* ANALYSE  */
  YYSYMBOL_ANALYZE = 34,                   /* ANALYZE  */
  YYSYMBOL_AND = 35,                       /* AND  */
  YYSYMBOL_ANY = 36,                       /* ANY  */
  YYSYMBOL_ARRAY = 37,                     /* ARRAY  */
  YYSYMBOL_AS = 38,                        /* AS  */
  YYSYMBOL_ASC = 39,                       /* ASC  */
  YYSYMBOL_ASENSITIVE = 40,                /* ASENSITIVE  */
  YYSYMBOL_ASSERTION = 41,                 /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 42,                /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 43,                /* ASYMMETRIC  */
  YYSYMBOL_ATOMIC = 44,                    /* ATOMIC  */
  YYSYMBOL_AT = 45,                        /* AT  */
  YYSYMBOL_ATTACH = 46,                    /* ATTACH  */
  YYSYMBOL_ATTRIBUTE = 47,                 /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 48,             /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 49,                  /* BACKWARD  */
  YYSYMBOL_BEFORE = 50,                    /* BEFORE  */
  YYSYMBOL_BEGIN_P = 51,                   /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 52,                   /* BETWEEN  */
  YYSYMBOL_BIGINT = 53,                    /* BIGINT  */
  YYSYMBOL_BINARY = 54,                    /* BINARY  */
  YYSYMBOL_BIT = 55,                       /* BIT  */
  YYSYMBOL_BOOLEAN_P = 56,                 /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 57,                      /* BOTH  */
  YYSYMBOL_BREADTH = 58,                   /* BREADTH  */
  YYSYMBOL_BY = 59,                        /* BY  */
  YYSYMBOL_CACHE = 60,                     /* CACHE  */
  YYSYMBOL_CALL = 61,                      /* CALL  */
  YYSYMBOL_CALLED = 62,                    /* CALLED  */
  YYSYMBOL_CASCADE = 63,                   /* CASCADE  */
  YYSYMBOL_CASCADED = 64,                  /* CASCADED  */
  YYSYMBOL_CASE = 65,                      /* CASE  */
  YYSYMBOL_CAST = 66,                      /* CAST  */
  YYSYMBOL_CATALOG_P = 67,                 /* CATALOG_P  */
  YYSYMBOL_CHAIN = 68,                     /* CHAIN  */
  YYSYMBOL_CHAR_P = 69,                    /* CHAR_P  */
  YYSYMBOL_CHARACTER = 70,                 /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 71,           /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 72,                     /* CHECK  */
  YYSYMBOL_CHECKPOINT = 73,                /* CHECKPOINT  */
  YYSYMBOL_CLASS = 74,                     /* CLASS  */
  YYSYMBOL_CLOSE = 75,                     /* CLOSE  */
  YYSYMBOL_CLUSTER = 76,                   /* CLUSTER  */
  YYSYMBOL_COALESCE = 77,                  /* COALESCE  */
  YYSYMBOL_COLLATE = 78,                   /* COLLATE  */
  YYSYMBOL_COLLATION = 79,                 /* COLLATION  */
  YYSYMBOL_COLUMN = 80,                    /* COLUMN  */
  YYSYMBOL_COLUMNS = 81,                   /* COLUMNS  */
  YYSYMBOL_COMMENT = 82,                   /* COMMENT  */
  YYSYMBOL_COMMENTS = 83,                  /* COMMENTS  */
  YYSYMBOL_COMMIT = 84,                    /* COMMIT  */
  YYSYMBOL_COMMITTED = 85,                 /* COMMITTED  */
  YYSYMBOL_COMPRESSION = 86,               /* COMPRESSION  */
  YYSYMBOL_CONCURRENTLY = 87,              /* CONCURRENTLY  */
  YYSYMBOL_CONFIGURATION = 88,             /* CONFIGURATION  */
  YYSYMBOL_CONFLICT = 89,                  /* CONFLICT  */
  YYSYMBOL_CONNECTION = 90,                /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 91,                /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 92,               /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 93,                 /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 94,                /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 95,              /* CONVERSION_P  */
  YYSYMBOL_COPY = 96,                      /* COPY  */
  YYSYMBOL_COST = 97,                      /* COST  */
  YYSYMBOL_CREATE = 98,                    /* CREATE  */
  YYSYMBOL_CROSS = 99,                     /* CROSS  */
  YYSYMBOL_CSV = 100,                      /* CSV  */
  YYSYMBOL_CUBE = 101,                     /* CUBE  */
  YYSYMBOL_CURRENT_P = 102,                /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 103,          /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 104,             /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 105,             /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 106,           /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 107,             /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 108,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 109,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 110,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 111,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 112,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 113,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 114,                    /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 115,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 116,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 117,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 118,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 119,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 120,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 121,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 122,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 123,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 124,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 125,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 126,               /* DELIMITERS  */
  YYSYMBOL_DEPENDS = 127,                  /* DEPENDS  */
  YYSYMBOL_DEPTH = 128,                    /* DEPTH  */
  YYSYMBOL_DESC = 129,                     /* DESC  */
  YYSYMBOL_DETACH = 130,                   /* DETACH  */
  YYSYMBOL_DICTIONARY = 131,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 132,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 133,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 134,                 /* DISTINCT  */
  YYSYMBOL_DO = 135,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 136,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 137,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 138,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 139,                     /* DROP  */
  YYSYMBOL_EACH = 140,                     /* EACH  */
  YYSYMBOL_ELSE = 141,                     /* ELSE  */
  YYSYMBOL_ENABLE_P = 142,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 143,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 144,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 145,                    /* END_P  */
  YYSYMBOL_ENUM_P = 146,                   /* ENUM_P  */
  YYSYMBOL_ESCAPE = 147,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 148,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 149,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 150,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 151,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 152,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 153,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 154,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 155,                  /* EXPLAIN  */
  YYSYMBOL_EXPRESSION = 156,               /* EXPRESSION  */
  YYSYMBOL_EXTENSION = 157,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 158,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 159,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 160,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 161,                   /* FAMILY  */
  YYSYMBOL_FETCH = 162,                    /* FETCH  */
  YYSYMBOL_FILTER = 163,                   /* FILTER  */
  YYSYMBOL_FINALIZE = 164,                 /* FINALIZE  */
  YYSYMBOL_FIRST_P = 165,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 166,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 167,                /* FOLLOWING  */
  YYSYMBOL_FOR = 168,                      /* FOR  */
  YYSYMBOL_FORCE = 169,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 170,                  /* FOREIGN  */
  YYSYMBOL_FORMAT = 171,                   /* FORMAT  */
  YYSYMBOL_FORWARD = 172,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 173,                   /* FREEZE  */
  YYSYMBOL_FROM = 174,                     /* FROM  */
  YYSYMBOL_FULL = 175,                     /* FULL  */
  YYSYMBOL_FUNCTION = 176,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 177,                /* FUNCTIONS  */
  YYSYMBOL_GENERATED = 178,                /* GENERATED  */
  YYSYMBOL_GLOBAL = 179,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 180,                    /* GRANT  */
  YYSYMBOL_GRANTED = 181,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 182,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 183,                  /* GROUP_P  */
  YYSYMBOL_GROUPING = 184,                 /* GROUPING  */
  YYSYMBOL_GROUPS = 185,                   /* GROUPS  */
  YYSYMBOL_HANDLER = 186,                  /* HANDLER  */
  YYSYMBOL_HAVING = 187,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 188,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 189,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 190,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 191,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 192,                     /* IF_P  */
  YYSYMBOL_ILIKE = 193,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 194,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 195,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 196,               /* IMPLICIT_P  */
  YYSYMBOL_IMPORT_P = 197,                 /* IMPORT_P  */
  YYSYMBOL_IN_P = 198,                     /* IN_P  */
  YYSYMBOL_INCLUDE = 199,                  /* INCLUDE  */
  YYSYMBOL_INCLUDING = 200,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 201,                /* INCREMENT  */
  YYSYMBOL_INDENT = 202,                   /* INDENT  */
  YYSYMBOL_INDEX = 203,                    /* INDEX  */
  YYSYMBOL_INDEXES = 204,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 205,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 206,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 207,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 208,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 209,                  /* INNER_P  */
  YYSYMBOL_INOUT = 210,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 211,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 212,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 213,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 214,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 215,                    /* INT_P  */
  YYSYMBOL_INTEGER = 216,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 217,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 218,                 /* INTERVAL  */
  YYSYMBOL_INTO = 219,                     /* INTO  */
  YYSYMBOL_INVOKER = 220,                  /* INVOKER  */
  YYSYMBOL_IS = 221,                       /* IS  */
  YYSYMBOL_ISNULL = 222,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 223,                /* ISOLATION  */
  YYSYMBOL_JOIN = 224,                     /* JOIN  */
  YYSYMBOL_JSON = 225,                     /* JSON  */
  YYSYMBOL_JSON_ARRAY = 226,               /* JSON_ARRAY  */
  YYSYMBOL_JSON_ARRAYAGG = 227,            /* JSON_ARRAYAGG  */
  YYSYMBOL_JSON_OBJECT = 228,              /* JSON_OBJECT  */
  YYSYMBOL_JSON_OBJECTAGG = 229,           /* JSON_OBJECTAGG  */
  YYSYMBOL_KEY = 230,                      /* KEY  */
  YYSYMBOL_KEYS = 231,                     /* KEYS  */
  YYSYMBOL_LABEL = 232,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 233,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 234,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 235,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 236,                /* LATERAL_P  */
  YYSYMBOL_LEADING = 237,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 238,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 239,                    /* LEAST  */
  YYSYMBOL_LEFT = 240,                     /* LEFT  */
  YYSYMBOL_LEVEL = 241,                    /* LEVEL  */
  YYSYMBOL_LIKE = 242,                     /* LIKE  */
  YYSYMBOL_LIMIT = 243,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 244,                   /* LISTEN  */
  YYSYMBOL_LOAD = 245,                     /* LOAD  */
  YYSYMBOL_LOCAL = 246,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 247,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 248,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 249,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 250,                   /* LOCK_P  */
  YYSYMBOL_LOCKED = 251,                   /* LOCKED  */
  YYSYMBOL_LOGGED = 252,                   /* LOGGED  */
  YYSYMBOL_MAPPING = 253,                  /* MAPPING  */
  YYSYMBOL_MATCH = 254,                    /* MATCH  */
  YYSYMBOL_MATCHED = 255,                  /* MATCHED  */
  YYSYMBOL_MATERIALIZED = 256,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 257,                 /* MAXVALUE  */
  YYSYMBOL_MERGE = 258,                    /* MERGE  */
  YYSYMBOL_METHOD = 259,                   /* METHOD  */
  YYSYMBOL_MINUTE_P = 260,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 261,                 /* MINVALUE  */
  YYSYMBOL_MODE = 262,                     /* MODE  */
  YYSYMBOL_MONTH_P = 263,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 264,                     /* MOVE  */
  YYSYMBOL_NAME_P = 265,                   /* NAME_P  */
  YYSYMBOL_NAMES = 266,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 267,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 268,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 269,                    /* NCHAR  */
  YYSYMBOL_NEW = 270,                      /* NEW  */
  YYSYMBOL_NEXT = 271,                     /* NEXT  */
  YYSYMBOL_NFC = 272,                      /* NFC  */
  YYSYMBOL_NFD = 273,                      /* NFD  */
  YYSYMBOL_NFKC = 274,                     /* NFKC  */
  YYSYMBOL_NFKD = 275,                     /* NFKD  */
  YYSYMBOL_NO = 276,                       /* NO  */
  YYSYMBOL_NONE = 277,                     /* NONE  */
  YYSYMBOL_NORMALIZE = 278,                /* NORMALIZE  */
  YYSYMBOL_NORMALIZED = 279,               /* NORMALIZED  */
  YYSYMBOL_NOT = 280,                      /* NOT  */
  YYSYMBOL_NOTHING = 281,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 282,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 283,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 284,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 285,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 286,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 287,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 288,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 289,                 /* OBJECT_P  */
  YYSYMBOL_OF = 290,                       /* OF  */
  YYSYMBOL_OFF = 291,                      /* OFF  */
  YYSYMBOL_OFFSET = 292,                   /* OFFSET  */
  YYSYMBOL_OIDS = 293,                     /* OIDS  */
  YYSYMBOL_OLD = 294,                      /* OLD  */
  YYSYMBOL_ON = 295,                       /* ON  */
  YYSYMBOL_ONLY = 296,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 297,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 298,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 299,                  /* OPTIONS  */
  YYSYMBOL_OR = 300,                       /* OR  */
  YYSYMBOL_ORDER = 301,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 302,               /* ORDINALITY  */
  YYSYMBOL_OTHERS = 303,                   /* OTHERS  */
  YYSYMBOL_OUT_P = 304,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 305,                  /* OUTER_P  */
  YYSYMBOL_OVER = 306,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 307,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 308,                  /* OVERLAY  */
  YYSYMBOL_OVERRIDING = 309,               /* OVERRIDING  */
  YYSYMBOL_OWNED = 310,                    /* OWNED  */
  YYSYMBOL_OWNER = 311,                    /* OWNER  */
  YYSYMBOL_PARALLEL = 312,                 /* PARALLEL  */
  YYSYMBOL_PARAMETER = 313,                /* PARAMETER  */
  YYSYMBOL_PARSER = 314,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 315,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 316,                /* PARTITION  */
  YYSYMBOL_PASSING = 317,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 318,                 /* PASSWORD  */
  YYSYMBOL_PLACING = 319,                  /* PLACING  */
  YYSYMBOL_PLANS = 320,                    /* PLANS  */
  YYSYMBOL_POLICY = 321,                   /* POLICY  */
  YYSYMBOL_POSITION = 322,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 323,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 324,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 325,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 326,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 327,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 328,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 329,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 330,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 331,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 332,                /* PROCEDURE  */
  YYSYMBOL_PROCEDURES = 333,               /* PROCEDURES  */
  YYSYMBOL_PROGRAM = 334,                  /* PROGRAM  */
  YYSYMBOL_PUBLICATION = 335,              /* PUBLICATION  */
  YYSYMBOL_QUOTE = 336,                    /* QUOTE  */
  YYSYMBOL_RANGE = 337,                    /* RANGE  */
  YYSYMBOL_READ = 338,                     /* READ  */
  YYSYMBOL_REAL = 339,                     /* REAL  */
  YYSYMBOL_REASSIGN = 340,                 /* REASSIGN  */
  YYSYMBOL_RECHECK = 341,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 342,                /* RECURSIVE  */
  YYSYMBOL_REF_P = 343,                    /* REF_P  */
  YYSYMBOL_REFERENCES = 344,               /* REFERENCES  */
  YYSYMBOL_REFERENCING = 345,              /* REFERENCING  */
  YYSYMBOL_REFRESH = 346,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 347,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 348,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 349,                  /* RELEASE  */
  YYSYMBOL_RENAME = 350,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 351,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 352,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 353,                  /* REPLICA  */
  YYSYMBOL_RESET = 354,                    /* RESET  */
  YYSYMBOL_RESTART = 355,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 356,                 /* RESTRICT  */
  YYSYMBOL_RETURN = 357,                   /* RETURN  */
  YYSYMBOL_RETURNING = 358,                /* RETURNING  */
  YYSYMBOL_RETURNS = 359,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 360,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 361,                    /* RIGHT  */
  YYSYMBOL_ROLE = 362,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 363,                 /* ROLLBACK  */
  YYSYMBOL_ROLLUP = 364,                   /* ROLLUP  */
  YYSYMBOL_ROUTINE = 365,                  /* ROUTINE  */
  YYSYMBOL_ROUTINES = 366,                 /* ROUTINES  */
  YYSYMBOL_ROW = 367,                      /* ROW  */
  YYSYMBOL_ROWS = 368,                     /* ROWS  */
  YYSYMBOL_RULE = 369,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 370,                /* SAVEPOINT  */
  YYSYMBOL_SCALAR = 371,                   /* SCALAR  */
  YYSYMBOL_SCHEMA = 372,                   /* SCHEMA  */
  YYSYMBOL_SCHEMAS = 373,                  /* SCHEMAS  */
  YYSYMBOL_SCROLL = 374,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 375,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 376,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 377,                 /* SECURITY  */
  YYSYMBOL_SELECT = 378,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 379,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 380,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 381,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 382,                   /* SERVER  */
  YYSYMBOL_SESSION = 383,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 384,             /* SESSION_USER  */
  YYSYMBOL_SET = 385,                      /* SET  */
  YYSYMBOL_SETS = 386,                     /* SETS  */
  YYSYMBOL_SETOF = 387,                    /* SETOF  */
  YYSYMBOL_SHARE = 388,                    /* SHARE  */
  YYSYMBOL_SHOW = 389,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 390,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 391,                   /* SIMPLE  */
  YYSYMBOL_SKIP = 392,                     /* SKIP  */
  YYSYMBOL_SMALLINT = 393,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 394,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 395,                     /* SOME  */
  YYSYMBOL_SQL_P = 396,                    /* SQL_P  */
  YYSYMBOL_STABLE = 397,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 398,             /* STANDALONE_P  */
  YYSYMBOL_START = 399,                    /* START  */
  YYSYMBOL_STATEMENT = 400,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 401,               /* STATISTICS  */
  YYSYMBOL_STDIN = 402,                    /* STDIN  */
  YYSYMBOL_STDOUT = 403,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 404,                  /* STORAGE  */
  YYSYMBOL_STORED = 405,                   /* STORED  */
  YYSYMBOL_STRICT_P = 406,                 /* STRICT_P  */
  YYSYMBOL_STRIP_P = 407,                  /* STRIP_P  */
  YYSYMBOL_SUBSCRIPTION = 408,             /* SUBSCRIPTION  */
  YYSYMBOL_SUBSTRING = 409,                /* SUBSTRING  */
  YYSYMBOL_SUPPORT = 410,                  /* SUPPORT  */
  YYSYMBOL_SYMMETRIC = 411,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 412,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 413,                 /* SYSTEM_P  */
  YYSYMBOL_SYSTEM_USER = 414,              /* SYSTEM_USER  */
  YYSYMBOL_TABLE = 415,                    /* TABLE  */
  YYSYMBOL_TABLES = 416,                   /* TABLES  */
  YYSYMBOL_TABLESAMPLE = 417,              /* TABLESAMPLE  */
  YYSYMBOL_TABLESPACE = 418,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 419,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 420,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 421,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 422,                   /* TEXT_P  */
  YYSYMBOL_THEN = 423,                     /* THEN  */
  YYSYMBOL_TIES = 424,                     /* TIES  */
  YYSYMBOL_TIME = 425,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 426,                /* TIMESTAMP  */
  YYSYMBOL_TO = 427,                       /* TO  */
  YYSYMBOL_TRAILING = 428,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 429,              /* TRANSACTION  */
  YYSYMBOL_TRANSFORM = 430,                /* TRANSFORM  */
  YYSYMBOL_TREAT = 431,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 432,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 433,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 434,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 435,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 436,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 437,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 438,                  /* TYPES_P  */
  YYSYMBOL_UESCAPE = 439,                  /* UESCAPE  */
  YYSYMBOL_UNBOUNDED = 440,                /* UNBOUNDED  */
  YYSYMBOL_UNCOMMITTED = 441,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 442,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 443,                    /* UNION  */
  YYSYMBOL_UNIQUE = 444,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 445,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 446,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 447,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 448,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 449,                   /* UPDATE  */
  YYSYMBOL_USER = 450,                     /* USER  */
  YYSYMBOL_USING = 451,                    /* USING  */
  YYSYMBOL_VACUUM = 452,                   /* VACUUM  */
  YYSYMBOL_VALID = 453,                    /* VALID  */
  YYSYMBOL_VALIDATE = 454,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 455,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 456,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 457,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 458,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 459,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 460,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 461,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 462,                /* VERSION_P  */
  YYSYMBOL_VIEW = 463,                     /* VIEW  */
  YYSYMBOL_VIEWS = 464,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 465,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 466,                     /* WHEN  */
  YYSYMBOL_WHERE = 467,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 468,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 469,                   /* WINDOW  */
  YYSYMBOL_WITH = 470,                     /* WITH  */
  YYSYMBOL_WITHIN = 471,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 472,                  /* WITHOUT  */
  YYSYMBOL_WORK = 473,                     /* WORK  */
  YYSYMBOL_WRAPPER = 474,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 475,                    /* WRITE  */
  YYSYMBOL_XML_P = 476,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 477,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 478,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 479,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 480,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 481,                /* XMLFOREST  */
  YYSYMBOL_XMLNAMESPACES = 482,            /* XMLNAMESPACES  */
  YYSYMBOL_XMLPARSE = 483,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 484,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 485,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 486,             /* XMLSERIALIZE  */
  YYSYMBOL_XMLTABLE = 487,                 /* XMLTABLE  */
  YYSYMBOL_YEAR_P = 488,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 489,                    /* YES_P  */
  YYSYMBOL_ZONE = 490,                     /* ZONE  */
  YYSYMBOL_FORMAT_LA = 491,                /* FORMAT_LA  */
  YYSYMBOL_NOT_LA = 492,                   /* NOT_LA  */
  YYSYMBOL_NULLS_LA = 493,                 /* NULLS_LA  */
  YYSYMBOL_WITH_LA = 494,                  /* WITH_LA  */
  YYSYMBOL_WITHOUT_LA = 495,               /* WITHOUT_LA  */
  YYSYMBOL_MODE_TYPE_NAME = 496,           /* MODE_TYPE_NAME  */
  YYSYMBOL_MODE_PLPGSQL_EXPR = 497,        /* MODE_PLPGSQL_EXPR  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN1 = 498,     /* MODE_PLPGSQL_ASSIGN1  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN2 = 499,     /* MODE_PLPGSQL_ASSIGN2  */
  YYSYMBOL_MODE_PLPGSQL_ASSIGN3 = 500,     /* MODE_PLPGSQL_ASSIGN3  */
  YYSYMBOL_501_ = 501,                     /* '<'  */
  YYSYMBOL_502_ = 502,                     /* '>'  */
  YYSYMBOL_503_ = 503,                     /* '='  */
  YYSYMBOL_504_ = 504,                     /* '+'  */
  YYSYMBOL_505_ = 505,                     /* '-'  */
  YYSYMBOL_506_ = 506,                     /* '*'  */
  YYSYMBOL_507_ = 507,                     /* '/'  */
  YYSYMBOL_508_ = 508,                     /* '%'  */
  YYSYMBOL_509_ = 509,                     /* '^'  */
  YYSYMBOL_UMINUS = 510,                   /* UMINUS  */
  YYSYMBOL_511_ = 511,                     /* '['  */
  YYSYMBOL_512_ = 512,                     /* ']'  */
  YYSYMBOL_513_ = 513,                     /* '('  */
  YYSYMBOL_514_ = 514,                     /* ')'  */
  YYSYMBOL_515_ = 515,                     /* '.'  */
  YYSYMBOL_516_ = 516,                     /* ';'  */
  YYSYMBOL_517_ = 517,                     /* ','  */
  YYSYMBOL_518_ = 518,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 519,                 /* $accept  */
  YYSYMBOL_parse_toplevel = 520,           /* parse_toplevel  */
  YYSYMBOL_stmtmulti = 521,                /* stmtmulti  */
  YYSYMBOL_toplevel_stmt = 522,            /* toplevel_stmt  */
  YYSYMBOL_stmt = 523,                     /* stmt  */
  YYSYMBOL_opt_single_name = 524,          /* opt_single_name  */
  YYSYMBOL_opt_qualified_name = 525,       /* opt_qualified_name  */
  YYSYMBOL_opt_concurrently = 526,         /* opt_concurrently  */
  YYSYMBOL_opt_drop_behavior = 527,        /* opt_drop_behavior  */
  YYSYMBOL_CallStmt = 528,                 /* CallStmt  */
  YYSYMBOL_CreateRoleStmt = 529,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 530,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 531,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 532,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOptRoleElem = 533,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 534,        /* CreateOptRoleElem  */
  YYSYMBOL_CreateUserStmt = 535,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 536,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 537,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 538,         /* AlterRoleSetStmt  */
  YYSYMBOL_DropRoleStmt = 539,             /* DropRoleStmt  */
  YYSYMBOL_CreateGroupStmt = 540,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 541,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 542,                 /* add_drop  */
  YYSYMBOL_CreateSchemaStmt = 543,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaEltList = 544,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 545,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 546,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 547,                 /* set_rest  */
  YYSYMBOL_generic_set = 548,              /* generic_set  */
  YYSYMBOL_set_rest_more = 549,            /* set_rest_more  */
  YYSYMBOL_var_name = 550,                 /* var_name  */
  YYSYMBOL_var_list = 551,                 /* var_list  */
  YYSYMBOL_var_value = 552,                /* var_value  */
  YYSYMBOL_iso_level = 553,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 554,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 555,               /* zone_value  */
  YYSYMBOL_opt_encoding = 556,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 557, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 558,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 559,               /* reset_rest  */
  YYSYMBOL_generic_reset = 560,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 561,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 562,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 563,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 564,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 565,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 566,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 567,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 568,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 569,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 570,         /* alter_table_cmds  */
  YYSYMBOL_partition_cmd = 571,            /* partition_cmd  */
  YYSYMBOL_index_partition_cmd = 572,      /* index_partition_cmd  */
  YYSYMBOL_alter_table_cmd = 573,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 574,     /* alter_column_default  */
  YYSYMBOL_opt_collate_clause = 575,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 576,              /* alter_using  */
  YYSYMBOL_replica_identity = 577,         /* replica_identity  */
  YYSYMBOL_reloptions = 578,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 579,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 580,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 581,           /* reloption_elem  */
  YYSYMBOL_alter_identity_column_option_list = 582, /* alter_identity_column_option_list  */
  YYSYMBOL_alter_identity_column_option = 583, /* alter_identity_column_option  */
  YYSYMBOL_PartitionBoundSpec = 584,       /* PartitionBoundSpec  */
  YYSYMBOL_hash_partbound_elem = 585,      /* hash_partbound_elem  */
  YYSYMBOL_hash_partbound = 586,           /* hash_partbound  */
  YYSYMBOL_AlterCompositeTypeStmt = 587,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 588,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 589,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 590,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 591,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 592,                /* copy_from  */
  YYSYMBOL_opt_program = 593,              /* opt_program  */
  YYSYMBOL_copy_file_name = 594,           /* copy_file_name  */
  YYSYMBOL_copy_options = 595,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 596,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 597,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 598,               /* opt_binary  */
  YYSYMBOL_copy_delimiter = 599,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 600,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 601,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 602,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 603,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 604, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 605, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 606,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 607,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 608,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 609, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 610,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 611,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 612,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 613,        /* TypedTableElement  */
  YYSYMBOL_columnDef = 614,                /* columnDef  */
  YYSYMBOL_columnOptions = 615,            /* columnOptions  */
  YYSYMBOL_column_compression = 616,       /* column_compression  */
  YYSYMBOL_opt_column_compression = 617,   /* opt_column_compression  */
  YYSYMBOL_column_storage = 618,           /* column_storage  */
  YYSYMBOL_opt_column_storage = 619,       /* opt_column_storage  */
  YYSYMBOL_ColQualList = 620,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 621,            /* ColConstraint  */
  YYSYMBOL_ColConstraintElem = 622,        /* ColConstraintElem  */
  YYSYMBOL_opt_unique_null_treatment = 623, /* opt_unique_null_treatment  */
  YYSYMBOL_generated_when = 624,           /* generated_when  */
  YYSYMBOL_ConstraintAttr = 625,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 626,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 627,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 628,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 629,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 630,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 631,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 632,          /* opt_column_list  */
  YYSYMBOL_columnList = 633,               /* columnList  */
  YYSYMBOL_columnElem = 634,               /* columnElem  */
  YYSYMBOL_opt_c_include = 635,            /* opt_c_include  */
  YYSYMBOL_key_match = 636,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 637,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 638,  /* ExclusionConstraintElem  */
  YYSYMBOL_OptWhereClause = 639,           /* OptWhereClause  */
  YYSYMBOL_key_actions = 640,              /* key_actions  */
  YYSYMBOL_key_update = 641,               /* key_update  */
  YYSYMBOL_key_delete = 642,               /* key_delete  */
  YYSYMBOL_key_action = 643,               /* key_action  */
  YYSYMBOL_OptInherit = 644,               /* OptInherit  */
  YYSYMBOL_OptPartitionSpec = 645,         /* OptPartitionSpec  */
  YYSYMBOL_PartitionSpec = 646,            /* PartitionSpec  */
  YYSYMBOL_part_params = 647,              /* part_params  */
  YYSYMBOL_part_elem = 648,                /* part_elem  */
  YYSYMBOL_table_access_method_clause = 649, /* table_access_method_clause  */
  YYSYMBOL_OptWith = 650,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 651,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 652,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 653,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 654,            /* ExistingIndex  */
  YYSYMBOL_CreateStatsStmt = 655,          /* CreateStatsStmt  */
  YYSYMBOL_stats_params = 656,             /* stats_params  */
  YYSYMBOL_stats_param = 657,              /* stats_param  */
  YYSYMBOL_AlterStatsStmt = 658,           /* AlterStatsStmt  */
  YYSYMBOL_CreateAsStmt = 659,             /* CreateAsStmt  */
  YYSYMBOL_create_as_target = 660,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 661,            /* opt_with_data  */
  YYSYMBOL_CreateMatViewStmt = 662,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 663,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 664,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 665,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 666,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 667,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 668,            /* OptSeqOptList  */
  YYSYMBOL_OptParenthesizedSeqOptList = 669, /* OptParenthesizedSeqOptList  */
  YYSYMBOL_SeqOptList = 670,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 671,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 672,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 673,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 674,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 675,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 676,              /* opt_trusted  */
  YYSYMBOL_handler_name = 677,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 678,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 679,         /* validator_clause  */
  YYSYMBOL_opt_validator = 680,            /* opt_validator  */
  YYSYMBOL_opt_procedural = 681,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 682,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 683,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 684,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 685,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 686, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 687, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 688,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 689, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 690, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 691, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 692,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 693,               /* fdw_option  */
  YYSYMBOL_fdw_options = 694,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 695,          /* opt_fdw_options  */
  YYSYMBOL_AlterFdwStmt = 696,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 697,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 698,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 699,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 700, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 701, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 702,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 703,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 704,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 705,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 706,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 707,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 708, /* opt_foreign_server_version  */
  YYSYMBOL_AlterForeignServerStmt = 709,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 710,   /* CreateForeignTableStmt  */
  YYSYMBOL_ImportForeignSchemaStmt = 711,  /* ImportForeignSchemaStmt  */
  YYSYMBOL_import_qualification_type = 712, /* import_qualification_type  */
  YYSYMBOL_import_qualification = 713,     /* import_qualification  */
  YYSYMBOL_CreateUserMappingStmt = 714,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 715,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 716,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 717,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreatePolicyStmt = 718,         /* CreatePolicyStmt  */
  YYSYMBOL_AlterPolicyStmt = 719,          /* AlterPolicyStmt  */
  YYSYMBOL_RowSecurityOptionalExpr = 720,  /* RowSecurityOptionalExpr  */
  YYSYMBOL_RowSecurityOptionalWithCheck = 721, /* RowSecurityOptionalWithCheck  */
  YYSYMBOL_RowSecurityDefaultToRole = 722, /* RowSecurityDefaultToRole  */
  YYSYMBOL_RowSecurityOptionalToRole = 723, /* RowSecurityOptionalToRole  */
  YYSYMBOL_RowSecurityDefaultPermissive = 724, /* RowSecurityDefaultPermissive  */
  YYSYMBOL_RowSecurityDefaultForCmd = 725, /* RowSecurityDefaultForCmd  */
  YYSYMBOL_row_security_cmd = 726,         /* row_security_cmd  */
  YYSYMBOL_CreateAmStmt = 727,             /* CreateAmStmt  */
  YYSYMBOL_am_type = 728,                  /* am_type  */
  YYSYMBOL_CreateTrigStmt = 729,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 730,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 731,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 732,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerReferencing = 733,       /* TriggerReferencing  */
  YYSYMBOL_TriggerTransitions = 734,       /* TriggerTransitions  */
  YYSYMBOL_TriggerTransition = 735,        /* TriggerTransition  */
  YYSYMBOL_TransitionOldOrNew = 736,       /* TransitionOldOrNew  */
  YYSYMBOL_TransitionRowOrTable = 737,     /* TransitionRowOrTable  */
  YYSYMBOL_TransitionRelName = 738,        /* TransitionRelName  */
  YYSYMBOL_TriggerForSpec = 739,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 740,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 741,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 742,              /* TriggerWhen  */
  YYSYMBOL_FUNCTION_or_PROCEDURE = 743,    /* FUNCTION_or_PROCEDURE  */
  YYSYMBOL_TriggerFuncArgs = 744,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 745,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 746,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 747,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 748,  /* ConstraintAttributeElem  */
  YYSYMBOL_CreateEventTrigStmt = 749,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 750,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 751,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 752, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 753,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 754,           /* enable_trigger  */
  YYSYMBOL_CreateAssertionStmt = 755,      /* CreateAssertionStmt  */
  YYSYMBOL_DefineStmt = 756,               /* DefineStmt  */
  YYSYMBOL_definition = 757,               /* definition  */
  YYSYMBOL_def_list = 758,                 /* def_list  */
  YYSYMBOL_def_elem = 759,                 /* def_elem  */
  YYSYMBOL_def_arg = 760,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 761,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 762,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 763,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 764,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 765,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 766,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 767,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 768,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 769,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 770,             /* opclass_item  */
  YYSYMBOL_opt_default = 771,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 772,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 773,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 774,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 775,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 776,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 777,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 778,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 779,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 780,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 781,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 782,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 783,                 /* DropStmt  */
  YYSYMBOL_object_type_any_name = 784,     /* object_type_any_name  */
  YYSYMBOL_object_type_name = 785,         /* object_type_name  */
  YYSYMBOL_drop_type_name = 786,           /* drop_type_name  */
  YYSYMBOL_object_type_name_on_any_name = 787, /* object_type_name_on_any_name  */
  YYSYMBOL_any_name_list = 788,            /* any_name_list  */
  YYSYMBOL_any_name = 789,                 /* any_name  */
  YYSYMBOL_attrs = 790,                    /* attrs  */
  YYSYMBOL_type_name_list = 791,           /* type_name_list  */
  YYSYMBOL_TruncateStmt = 792,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 793,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 794,              /* CommentStmt  */
  YYSYMBOL_comment_text = 795,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 796,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 797,             /* opt_provider  */
  YYSYMBOL_security_label = 798,           /* security_label  */
  YYSYMBOL_FetchStmt = 799,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 800,               /* fetch_args  */
  YYSYMBOL_from_in = 801,                  /* from_in  */
  YYSYMBOL_opt_from_in = 802,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 803,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 804,               /* RevokeStmt  */
  YYSYMBOL_privileges = 805,               /* privileges  */
  YYSYMBOL_privilege_list = 806,           /* privilege_list  */
  YYSYMBOL_privilege = 807,                /* privilege  */
  YYSYMBOL_parameter_name_list = 808,      /* parameter_name_list  */
  YYSYMBOL_parameter_name = 809,           /* parameter_name  */
  YYSYMBOL_privilege_target = 810,         /* privilege_target  */
  YYSYMBOL_grantee_list = 811,             /* grantee_list  */
  YYSYMBOL_grantee = 812,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 813,   /* opt_grant_grant_option  */
  YYSYMBOL_GrantRoleStmt = 814,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 815,           /* RevokeRoleStmt  */
  YYSYMBOL_grant_role_opt_list = 816,      /* grant_role_opt_list  */
  YYSYMBOL_grant_role_opt = 817,           /* grant_role_opt  */
  YYSYMBOL_grant_role_opt_value = 818,     /* grant_role_opt_value  */
  YYSYMBOL_opt_granted_by = 819,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 820, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 821,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 822,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 823,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 824,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 825,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 826,               /* opt_unique  */
  YYSYMBOL_access_method_clause = 827,     /* access_method_clause  */
  YYSYMBOL_index_params = 828,             /* index_params  */
  YYSYMBOL_index_elem_options = 829,       /* index_elem_options  */
  YYSYMBOL_index_elem = 830,               /* index_elem  */
  YYSYMBOL_opt_include = 831,              /* opt_include  */
  YYSYMBOL_index_including_params = 832,   /* index_including_params  */
  YYSYMBOL_opt_collate = 833,              /* opt_collate  */
  YYSYMBOL_opt_asc_desc = 834,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 835,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 836,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 837,           /* opt_or_replace  */
  YYSYMBOL_func_args = 838,                /* func_args  */
  YYSYMBOL_func_args_list = 839,           /* func_args_list  */
  YYSYMBOL_function_with_argtypes_list = 840, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 841,   /* function_with_argtypes  */
  YYSYMBOL_func_args_with_defaults = 842,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 843, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 844,                 /* func_arg  */
  YYSYMBOL_arg_class = 845,                /* arg_class  */
  YYSYMBOL_param_name = 846,               /* param_name  */
  YYSYMBOL_func_return = 847,              /* func_return  */
  YYSYMBOL_func_type = 848,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 849,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 850,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 851,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 852,           /* aggr_args_list  */
  YYSYMBOL_aggregate_with_argtypes = 853,  /* aggregate_with_argtypes  */
  YYSYMBOL_aggregate_with_argtypes_list = 854, /* aggregate_with_argtypes_list  */
  YYSYMBOL_opt_createfunc_opt_list = 855,  /* opt_createfunc_opt_list  */
  YYSYMBOL_createfunc_opt_list = 856,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 857,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 858,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 859,                  /* func_as  */
  YYSYMBOL_ReturnStmt = 860,               /* ReturnStmt  */
  YYSYMBOL_opt_routine_body = 861,         /* opt_routine_body  */
  YYSYMBOL_routine_body_stmt_list = 862,   /* routine_body_stmt_list  */
  YYSYMBOL_routine_body_stmt = 863,        /* routine_body_stmt  */
  YYSYMBOL_transform_type_list = 864,      /* transform_type_list  */
  YYSYMBOL_opt_definition = 865,           /* opt_definition  */
  YYSYMBOL_table_func_column = 866,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 867,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 868,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 869,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 870,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 871,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 872,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 873,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 874,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 875,             /* any_operator  */
  YYSYMBOL_operator_with_argtypes_list = 876, /* operator_with_argtypes_list  */
  YYSYMBOL_operator_with_argtypes = 877,   /* operator_with_argtypes  */
  YYSYMBOL_DoStmt = 878,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 879,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 880,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 881,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 882,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 883,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 884,            /* opt_if_exists  */
  YYSYMBOL_CreateTransformStmt = 885,      /* CreateTransformStmt  */
  YYSYMBOL_transform_element_list = 886,   /* transform_element_list  */
  YYSYMBOL_DropTransformStmt = 887,        /* DropTransformStmt  */
  YYSYMBOL_ReindexStmt = 888,              /* ReindexStmt  */
  YYSYMBOL_reindex_target_relation = 889,  /* reindex_target_relation  */
  YYSYMBOL_reindex_target_all = 890,       /* reindex_target_all  */
  YYSYMBOL_opt_reindex_option_list = 891,  /* opt_reindex_option_list  */
  YYSYMBOL_AlterTblSpcStmt = 892,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 893,               /* RenameStmt  */
  YYSYMBOL_opt_column = 894,               /* opt_column  */
  YYSYMBOL_opt_set_data = 895,             /* opt_set_data  */
  YYSYMBOL_AlterObjectDependsStmt = 896,   /* AlterObjectDependsStmt  */
  YYSYMBOL_opt_no = 897,                   /* opt_no  */
  YYSYMBOL_AlterObjectSchemaStmt = 898,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOperatorStmt = 899,        /* AlterOperatorStmt  */
  YYSYMBOL_operator_def_list = 900,        /* operator_def_list  */
  YYSYMBOL_operator_def_elem = 901,        /* operator_def_elem  */
  YYSYMBOL_operator_def_arg = 902,         /* operator_def_arg  */
  YYSYMBOL_AlterTypeStmt = 903,            /* AlterTypeStmt  */
  YYSYMBOL_AlterOwnerStmt = 904,           /* AlterOwnerStmt  */
  YYSYMBOL_CreatePublicationStmt = 905,    /* CreatePublicationStmt  */
  YYSYMBOL_PublicationObjSpec = 906,       /* PublicationObjSpec  */
  YYSYMBOL_pub_obj_list = 907,             /* pub_obj_list  */
  YYSYMBOL_AlterPublicationStmt = 908,     /* AlterPublicationStmt  */
  YYSYMBOL_CreateSubscriptionStmt = 909,   /* CreateSubscriptionStmt  */
  YYSYMBOL_AlterSubscriptionStmt = 910,    /* AlterSubscriptionStmt  */
  YYSYMBOL_DropSubscriptionStmt = 911,     /* DropSubscriptionStmt  */
  YYSYMBOL_RuleStmt = 912,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 913,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 914,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 915,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 916,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 917,                    /* event  */
  YYSYMBOL_opt_instead = 918,              /* opt_instead  */
  YYSYMBOL_NotifyStmt = 919,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 920,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 921,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 922,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 923,          /* TransactionStmt  */
  YYSYMBOL_TransactionStmtLegacy = 924,    /* TransactionStmtLegacy  */
  YYSYMBOL_opt_transaction = 925,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 926,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 927,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 928, /* transaction_mode_list_or_empty  */
  YYSYMBOL_opt_transaction_chain = 929,    /* opt_transaction_chain  */
  YYSYMBOL_ViewStmt = 930,                 /* ViewStmt  */
  YYSYMBOL_opt_check_option = 931,         /* opt_check_option  */
  YYSYMBOL_LoadStmt = 932,                 /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 933,             /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 934,        /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_items = 935,       /* createdb_opt_items  */
  YYSYMBOL_createdb_opt_item = 936,        /* createdb_opt_item  */
  YYSYMBOL_createdb_opt_name = 937,        /* createdb_opt_name  */
  YYSYMBOL_opt_equal = 938,                /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 939,        /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 940,     /* AlterDatabaseSetStmt  */
  YYSYMBOL_DropdbStmt = 941,               /* DropdbStmt  */
  YYSYMBOL_drop_option_list = 942,         /* drop_option_list  */
  YYSYMBOL_drop_option = 943,              /* drop_option  */
  YYSYMBOL_AlterCollationStmt = 944,       /* AlterCollationStmt  */
  YYSYMBOL_AlterSystemStmt = 945,          /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 946,         /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 947,          /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 948,                   /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 949,    /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 950, /* AlterTSConfigurationStmt  */
  YYSYMBOL_any_with = 951,                 /* any_with  */
  YYSYMBOL_CreateConversionStmt = 952,     /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 953,              /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 954, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 955,               /* VacuumStmt  */
  YYSYMBOL_AnalyzeStmt = 956,              /* AnalyzeStmt  */
  YYSYMBOL_utility_option_list = 957,      /* utility_option_list  */
  YYSYMBOL_analyze_keyword = 958,          /* analyze_keyword  */
  YYSYMBOL_utility_option_elem = 959,      /* utility_option_elem  */
  YYSYMBOL_utility_option_name = 960,      /* utility_option_name  */
  YYSYMBOL_utility_option_arg = 961,       /* utility_option_arg  */
  YYSYMBOL_opt_analyze = 962,              /* opt_analyze  */
  YYSYMBOL_opt_verbose = 963,              /* opt_verbose  */
  YYSYMBOL_opt_full = 964,                 /* opt_full  */
  YYSYMBOL_opt_freeze = 965,               /* opt_freeze  */
  YYSYMBOL_opt_name_list = 966,            /* opt_name_list  */
  YYSYMBOL_vacuum_relation = 967,          /* vacuum_relation  */
  YYSYMBOL_vacuum_relation_list = 968,     /* vacuum_relation_list  */
  YYSYMBOL_opt_vacuum_relation_list = 969, /* opt_vacuum_relation_list  */
  YYSYMBOL_ExplainStmt = 970,              /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 971,          /* ExplainableStmt  */
  YYSYMBOL_PrepareStmt = 972,              /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 973,         /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 974,           /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 975,              /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 976,     /* execute_param_clause  */
  YYSYMBOL_DeallocateStmt = 977,           /* DeallocateStmt  */
  YYSYMBOL_InsertStmt = 978,               /* InsertStmt  */
  YYSYMBOL_insert_target = 979,            /* insert_target  */
  YYSYMBOL_insert_rest = 980,              /* insert_rest  */
  YYSYMBOL_override_kind = 981,            /* override_kind  */
  YYSYMBOL_insert_column_list = 982,       /* insert_column_list  */
  YYSYMBOL_insert_column_item = 983,       /* insert_column_item  */
  YYSYMBOL_opt_on_conflict = 984,          /* opt_on_conflict  */
  YYSYMBOL_opt_conf_expr = 985,            /* opt_conf_expr  */
  YYSYMBOL_returning_clause = 986,         /* returning_clause  */
  YYSYMBOL_DeleteStmt = 987,               /* DeleteStmt  */
  YYSYMBOL_using_clause = 988,             /* using_clause  */
  YYSYMBOL_LockStmt = 989,                 /* LockStmt  */
  YYSYMBOL_opt_lock = 990,                 /* opt_lock  */
  YYSYMBOL_lock_type = 991,                /* lock_type  */
  YYSYMBOL_opt_nowait = 992,               /* opt_nowait  */
  YYSYMBOL_opt_nowait_or_skip = 993,       /* opt_nowait_or_skip  */
  YYSYMBOL_UpdateStmt = 994,               /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 995,          /* set_clause_list  */
  YYSYMBOL_set_clause = 996,               /* set_clause  */
  YYSYMBOL_set_target = 997,               /* set_target  */
  YYSYMBOL_set_target_list = 998,          /* set_target_list  */
  YYSYMBOL_MergeStmt = 999,                /* MergeStmt  */
  YYSYMBOL_merge_when_list = 1000,         /* merge_when_list  */
  YYSYMBOL_merge_when_clause = 1001,       /* merge_when_clause  */
  YYSYMBOL_opt_merge_when_condition = 1002, /* opt_merge_when_condition  */
  YYSYMBOL_merge_update = 1003,            /* merge_update  */
  YYSYMBOL_merge_delete = 1004,            /* merge_delete  */
  YYSYMBOL_merge_insert = 1005,            /* merge_insert  */
  YYSYMBOL_merge_values_clause = 1006,     /* merge_values_clause  */
  YYSYMBOL_DeclareCursorStmt = 1007,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1008,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1009,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1010,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1011,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1012,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1013,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1014,           /* select_clause  */
  YYSYMBOL_simple_select = 1015,           /* simple_select  */
  YYSYMBOL_with_clause = 1016,             /* with_clause  */
  YYSYMBOL_cte_list = 1017,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1018,       /* common_table_expr  */
  YYSYMBOL_opt_materialized = 1019,        /* opt_materialized  */
  YYSYMBOL_opt_search_clause = 1020,       /* opt_search_clause  */
  YYSYMBOL_opt_cycle_clause = 1021,        /* opt_cycle_clause  */
  YYSYMBOL_opt_with_clause = 1022,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1023,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1024,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1025,               /* opt_table  */
  YYSYMBOL_set_quantifier = 1026,          /* set_quantifier  */
  YYSYMBOL_distinct_clause = 1027,         /* distinct_clause  */
  YYSYMBOL_opt_all_clause = 1028,          /* opt_all_clause  */
  YYSYMBOL_opt_distinct_clause = 1029,     /* opt_distinct_clause  */
  YYSYMBOL_opt_sort_clause = 1030,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1031,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1032,             /* sortby_list  */
  YYSYMBOL_sortby = 1033,                  /* sortby  */
  YYSYMBOL_select_limit = 1034,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1035,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1036,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1037,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1038,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1039,     /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 1040, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 1041,            /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 1042,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1043,           /* first_or_next  */
  YYSYMBOL_group_clause = 1044,            /* group_clause  */
  YYSYMBOL_group_by_list = 1045,           /* group_by_list  */
  YYSYMBOL_group_by_item = 1046,           /* group_by_item  */
  YYSYMBOL_empty_grouping_set = 1047,      /* empty_grouping_set  */
  YYSYMBOL_rollup_clause = 1048,           /* rollup_clause  */
  YYSYMBOL_cube_clause = 1049,             /* cube_clause  */
  YYSYMBOL_grouping_sets_clause = 1050,    /* grouping_sets_clause  */
  YYSYMBOL_having_clause = 1051,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1052,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1053,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1054,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1055,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1056,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1057,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1058,           /* values_clause  */
  YYSYMBOL_from_clause = 1059,             /* from_clause  */
  YYSYMBOL_from_list = 1060,               /* from_list  */
  YYSYMBOL_table_ref = 1061,               /* table_ref  */
  YYSYMBOL_joined_table = 1062,            /* joined_table  */
  YYSYMBOL_alias_clause = 1063,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1064,        /* opt_alias_clause  */
  YYSYMBOL_opt_alias_clause_for_join_using = 1065, /* opt_alias_clause_for_join_using  */
  YYSYMBOL_func_alias_clause = 1066,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1067,               /* join_type  */
  YYSYMBOL_opt_outer = 1068,               /* opt_outer  */
  YYSYMBOL_join_qual = 1069,               /* join_qual  */
  YYSYMBOL_relation_expr = 1070,           /* relation_expr  */
  YYSYMBOL_extended_relation_expr = 1071,  /* extended_relation_expr  */
  YYSYMBOL_relation_expr_list = 1072,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1073, /* relation_expr_opt_alias  */
  YYSYMBOL_tablesample_clause = 1074,      /* tablesample_clause  */
  YYSYMBOL_opt_repeatable_clause = 1075,   /* opt_repeatable_clause  */
  YYSYMBOL_func_table = 1076,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1077,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1078,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1079,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1080,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1081,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1082, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1083, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1084,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1085,        /* TableFuncElement  */
  YYSYMBOL_xmltable = 1086,                /* xmltable  */
  YYSYMBOL_xmltable_column_list = 1087,    /* xmltable_column_list  */
  YYSYMBOL_xmltable_column_el = 1088,      /* xmltable_column_el  */
  YYSYMBOL_xmltable_column_option_list = 1089, /* xmltable_column_option_list  */
  YYSYMBOL_xmltable_column_option_el = 1090, /* xmltable_column_option_el  */
  YYSYMBOL_xml_namespace_list = 1091,      /* xml_namespace_list  */
  YYSYMBOL_xml_namespace_el = 1092,        /* xml_namespace_el  */
  YYSYMBOL_Typename = 1093,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1094,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1095,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1096,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1097,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1098,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1099,                 /* Numeric  */
  YYSYMBOL_opt_float = 1100,               /* opt_float  */
  YYSYMBOL_Bit = 1101,                     /* Bit  */
  YYSYMBOL_ConstBit = 1102,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1103,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1104,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1105,               /* Character  */
  YYSYMBOL_ConstCharacter = 1106,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1107,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1108,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1109,               /* character  */
  YYSYMBOL_opt_varying = 1110,             /* opt_varying  */
  YYSYMBOL_ConstDatetime = 1111,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1112,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1113,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1114,            /* opt_interval  */
  YYSYMBOL_interval_second = 1115,         /* interval_second  */
  YYSYMBOL_a_expr = 1116,                  /* a_expr  */
  YYSYMBOL_b_expr = 1117,                  /* b_expr  */
  YYSYMBOL_c_expr = 1118,                  /* c_expr  */
  YYSYMBOL_func_application = 1119,        /* func_application  */
  YYSYMBOL_func_expr = 1120,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1121,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1122, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1123,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1124, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1125,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1126,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1127,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1128,     /* document_or_content  */
  YYSYMBOL_xml_indent_option = 1129,       /* xml_indent_option  */
  YYSYMBOL_xml_whitespace_option = 1130,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1131,      /* xmlexists_argument  */
  YYSYMBOL_xml_passing_mech = 1132,        /* xml_passing_mech  */
  YYSYMBOL_within_group_clause = 1133,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1134,           /* filter_clause  */
  YYSYMBOL_window_clause = 1135,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1136,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1137,       /* window_definition  */
  YYSYMBOL_over_clause = 1138,             /* over_clause  */
  YYSYMBOL_window_specification = 1139,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1140, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1141,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1142,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1143,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1144,             /* frame_bound  */
  YYSYMBOL_opt_window_exclusion_clause = 1145, /* opt_window_exclusion_clause  */
  YYSYMBOL_row = 1146,                     /* row  */
  YYSYMBOL_explicit_row = 1147,            /* explicit_row  */
  YYSYMBOL_implicit_row = 1148,            /* implicit_row  */
  YYSYMBOL_sub_type = 1149,                /* sub_type  */
  YYSYMBOL_all_Op = 1150,                  /* all_Op  */
  YYSYMBOL_MathOp = 1151,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1152,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1153,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1154,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1155,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1156,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1157,           /* func_arg_expr  */
  YYSYMBOL_func_arg_list_opt = 1158,       /* func_arg_list_opt  */
  YYSYMBOL_type_list = 1159,               /* type_list  */
  YYSYMBOL_array_expr = 1160,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1161,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1162,            /* extract_list  */
  YYSYMBOL_extract_arg = 1163,             /* extract_arg  */
  YYSYMBOL_unicode_normal_form = 1164,     /* unicode_normal_form  */
  YYSYMBOL_overlay_list = 1165,            /* overlay_list  */
  YYSYMBOL_position_list = 1166,           /* position_list  */
  YYSYMBOL_substr_list = 1167,             /* substr_list  */
  YYSYMBOL_trim_list = 1168,               /* trim_list  */
  YYSYMBOL_in_expr = 1169,                 /* in_expr  */
  YYSYMBOL_case_expr = 1170,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1171,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1172,             /* when_clause  */
  YYSYMBOL_case_default = 1173,            /* case_default  */
  YYSYMBOL_case_arg = 1174,                /* case_arg  */
  YYSYMBOL_columnref = 1175,               /* columnref  */
  YYSYMBOL_indirection_el = 1176,          /* indirection_el  */
  YYSYMBOL_opt_slice_bound = 1177,         /* opt_slice_bound  */
  YYSYMBOL_indirection = 1178,             /* indirection  */
  YYSYMBOL_opt_indirection = 1179,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1180,          /* opt_asymmetric  */
  YYSYMBOL_json_value_expr = 1181,         /* json_value_expr  */
  YYSYMBOL_json_format_clause_opt = 1182,  /* json_format_clause_opt  */
  YYSYMBOL_json_encoding_clause_opt = 1183, /* json_encoding_clause_opt  */
  YYSYMBOL_json_output_clause_opt = 1184,  /* json_output_clause_opt  */
  YYSYMBOL_json_predicate_type_constraint = 1185, /* json_predicate_type_constraint  */
  YYSYMBOL_json_key_uniqueness_constraint_opt = 1186, /* json_key_uniqueness_constraint_opt  */
  YYSYMBOL_json_name_and_value_list = 1187, /* json_name_and_value_list  */
  YYSYMBOL_json_name_and_value = 1188,     /* json_name_and_value  */
  YYSYMBOL_json_object_constructor_null_clause_opt = 1189, /* json_object_constructor_null_clause_opt  */
  YYSYMBOL_json_array_constructor_null_clause_opt = 1190, /* json_array_constructor_null_clause_opt  */
  YYSYMBOL_json_value_expr_list = 1191,    /* json_value_expr_list  */
  YYSYMBOL_json_aggregate_func = 1192,     /* json_aggregate_func  */
  YYSYMBOL_json_array_aggregate_order_by_clause_opt = 1193, /* json_array_aggregate_order_by_clause_opt  */
  YYSYMBOL_opt_target_list = 1194,         /* opt_target_list  */
  YYSYMBOL_target_list = 1195,             /* target_list  */
  YYSYMBOL_target_el = 1196,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1197,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1198,          /* qualified_name  */
  YYSYMBOL_name_list = 1199,               /* name_list  */
  YYSYMBOL_name = 1200,                    /* name  */
  YYSYMBOL_attr_name = 1201,               /* attr_name  */
  YYSYMBOL_file_name = 1202,               /* file_name  */
  YYSYMBOL_func_name = 1203,               /* func_name  */
  YYSYMBOL_AexprConst = 1204,              /* AexprConst  */
  YYSYMBOL_Iconst = 1205,                  /* Iconst  */
  YYSYMBOL_Sconst = 1206,                  /* Sconst  */
  YYSYMBOL_SignedIconst = 1207,            /* SignedIconst  */
  YYSYMBOL_RoleId = 1208,                  /* RoleId  */
  YYSYMBOL_RoleSpec = 1209,                /* RoleSpec  */
  YYSYMBOL_role_list = 1210,               /* role_list  */
  YYSYMBOL_PLpgSQL_Expr = 1211,            /* PLpgSQL_Expr  */
  YYSYMBOL_PLAssignStmt = 1212,            /* PLAssignStmt  */
  YYSYMBOL_plassign_target = 1213,         /* plassign_target  */
  YYSYMBOL_plassign_equals = 1214,         /* plassign_equals  */
  YYSYMBOL_ColId = 1215,                   /* ColId  */
  YYSYMBOL_type_function_name = 1216,      /* type_function_name  */
  YYSYMBOL_NonReservedWord = 1217,         /* NonReservedWord  */
  YYSYMBOL_ColLabel = 1218,                /* ColLabel  */
  YYSYMBOL_BareColLabel = 1219,            /* BareColLabel  */
  YYSYMBOL_unreserved_keyword = 1220,      /* unreserved_keyword  */
  YYSYMBOL_col_name_keyword = 1221,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1222,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1223,        /* reserved_keyword  */
  YYSYMBOL_bare_label_keyword = 1224       /* bare_label_keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  906
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   115488

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  519
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  706
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3285
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6223

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   756


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   508,     2,     2,
     513,   514,   506,   504,   517,   505,   515,   507,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   518,   516,
     501,   503,   502,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   511,     2,   512,   509,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   510
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   886,   886,   891,   895,   900,   908,   916,   936,   948,
     962,   963,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1092,  1099,  1100,  1104,
    1105,  1109,  1110,  1114,  1115,  1116,  1125,  1141,  1153,  1154,
    1155,  1164,  1165,  1169,  1170,  1174,  1179,  1183,  1193,  1201,
    1205,  1209,  1214,  1218,  1266,  1268,  1272,  1276,  1280,  1284,
    1298,  1317,  1326,  1338,  1339,  1343,  1352,  1361,  1370,  1392,
    1400,  1408,  1416,  1424,  1432,  1450,  1469,  1481,  1482,  1493,
    1504,  1515,  1531,  1550,  1557,  1565,  1566,  1567,  1568,  1569,
    1570,  1584,  1591,  1598,  1608,  1617,  1626,  1630,  1639,  1648,
    1656,  1667,  1668,  1677,  1689,  1697,  1706,  1718,  1727,  1736,
    1744,  1754,  1765,  1766,  1770,  1771,  1774,  1776,  1780,  1781,
    1782,  1783,  1787,  1788,  1789,  1795,  1807,  1811,  1815,  1832,
    1840,  1841,  1842,  1846,  1847,  1848,  1852,  1853,  1857,  1861,
    1862,  1870,  1878,  1889,  1897,  1908,  1909,  1914,  1915,  1920,
    1927,  1934,  1941,  1948,  1959,  1970,  1971,  1975,  1976,  1984,
    2000,  2007,  2014,  2021,  2028,  2048,  2058,  2068,  2078,  2088,
    2100,  2112,  2122,  2132,  2142,  2154,  2166,  2176,  2186,  2196,
    2206,  2216,  2226,  2238,  2250,  2260,  2273,  2274,  2279,  2293,
    2306,  2322,  2339,  2349,  2359,  2369,  2379,  2389,  2398,  2407,
    2416,  2426,  2436,  2452,  2462,  2472,  2482,  2492,  2509,  2519,
    2529,  2539,  2550,  2564,  2580,  2590,  2599,  2615,  2624,  2635,
    2646,  2654,  2663,  2672,  2680,  2688,  2697,  2706,  2715,  2723,
    2731,  2740,  2748,  2756,  2765,  2774,  2783,  2792,  2801,  2810,
    2821,  2829,  2838,  2847,  2856,  2865,  2874,  2883,  2891,  2899,
    2907,  2914,  2925,  2926,  2930,  2939,  2943,  2944,  2948,  2956,
    2964,  2972,  2983,  2986,  2987,  2991,  2992,  2997,  3001,  3005,
    3010,  3017,  3019,  3024,  3028,  3032,  3043,  3051,  3104,  3117,
    3131,  3143,  3150,  3154,  3168,  3181,  3182,  3187,  3197,  3208,
    3219,  3246,  3253,  3287,  3323,  3346,  3347,  3351,  3352,  3361,
    3362,  3363,  3366,  3367,  3372,  3373,  3377,  3381,  3385,  3389,
    3393,  3397,  3401,  3405,  3409,  3413,  3417,  3421,  3425,  3434,
    3438,  3442,  3446,  3450,  3451,  3456,  3460,  3467,  3474,  3475,
    3476,  3477,  3478,  3482,  3486,  3494,  3505,  3525,  3545,  3566,
    3587,  3608,  3642,  3643,  3644,  3645,  3646,  3653,  3660,  3661,
    3665,  3666,  3670,  3671,  3675,  3679,  3686,  3690,  3697,  3698,
    3699,  3703,  3704,  3707,  3731,  3750,  3772,  3773,  3777,  3778,
    3782,  3783,  3787,  3788,  3792,  3793,  3797,  3805,  3806,  3807,
    3839,  3847,  3855,  3868,  3880,  3893,  3903,  3913,  3937,  3957,
    3958,  3959,  3963,  3964,  3983,  3991,  3999,  4007,  4019,  4031,
    4032,  4033,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  4044,
    4045,  4046,  4055,  4063,  4067,  4081,  4099,  4115,  4132,  4148,
    4168,  4191,  4192,  4196,  4197,  4201,  4202,  4205,  4211,  4212,
    4215,  4219,  4227,  4232,  4238,  4239,  4243,  4248,  4255,  4256,
    4260,  4270,  4280,  4288,  4297,  4310,  4322,  4329,  4337,  4345,
    4353,  4361,  4371,  4372,  4376,  4377,  4380,  4392,  4393,  4396,
    4407,  4418,  4432,  4433,  4438,  4439,  4440,  4443,  4444,  4445,
    4446,  4449,  4450,  4453,  4454,  4457,  4477,  4490,  4512,  4513,
    4516,  4522,  4528,  4545,  4554,  4576,  4590,  4607,  4623,  4624,
    4625,  4637,  4651,  4668,  4682,  4683,  4695,  4716,  4727,  4741,
    4750,  4762,  4763,  4766,  4767,  4770,  4771,  4774,  4778,  4782,
    4786,  4790,  4794,  4798,  4802,  4806,  4810,  4814,  4818,  4822,
    4826,  4830,  4834,  4840,  4841,  4845,  4846,  4847,  4854,  4857,
    4858,  4870,  4886,  4902,  4903,  4911,  4912,  4916,  4917,  4921,
    4922,  4926,  4927,  4931,  4932,  4942,  4954,  4955,  4968,  4976,
    4994,  5003,  5015,  5018,  5022,  5026,  5030,  5037,  5049,  5060,
    5063,  5067,  5080,  5090,  5100,  5110,  5120,  5130,  5140,  5150,
    5160,  5170,  5180,  5190,  5200,  5219,  5231,  5232,  5233,  5234,
    5238,  5239,  5243,  5244,  5254,  5263,  5276,  5277,  5281,  5285,
    5293,  5297,  5301,  5308,  5312,  5317,  5322,  5329,  5336,  5341,
    5351,  5364,  5380,  5381,  5386,  5387,  5391,  5392,  5402,  5412,
    5421,  5439,  5460,  5481,  5503,  5537,  5553,  5554,  5558,  5567,
    5582,  5592,  5605,  5606,  5618,  5627,  5645,  5670,  5688,  5703,
    5704,  5708,  5709,  5713,  5714,  5718,  5719,  5723,  5737,  5741,
    5742,  5746,  5747,  5748,  5749,  5750,  5760,  5772,  5773,  5784,
    5807,  5839,  5840,  5841,  5845,  5847,  5869,  5871,  5873,  5875,
    5877,  5882,  5883,  5887,  5888,  5892,  5904,  5905,  5909,  5918,
    5922,  5926,  5931,  5941,  5942,  5946,  5947,  5951,  5952,  5956,
    5957,  5961,  5962,  5963,  5967,  5971,  5972,  5973,  5977,  5978,
    5983,  5984,  6011,  6012,  6013,  6014,  6015,  6016,  6029,  6040,
    6055,  6057,  6062,  6067,  6069,  6074,  6085,  6086,  6087,  6088,
    6099,  6118,  6130,  6143,  6154,  6165,  6177,  6186,  6194,  6202,
    6212,  6222,  6232,  6242,  6252,  6263,  6273,  6286,  6289,  6290,
    6293,  6297,  6304,  6305,  6306,  6307,  6308,  6309,  6312,  6315,
    6316,  6324,  6331,  6332,  6335,  6337,  6348,  6360,  6372,  6384,
    6398,  6399,  6415,  6431,  6432,  6436,  6449,  6460,  6469,  6479,
    6489,  6490,  6493,  6494,  6497,  6498,  6499,  6502,  6516,  6521,
    6532,  6542,  6555,  6556,  6560,  6569,  6582,  6593,  6607,  6618,
    6641,  6652,  6671,  6682,  6693,  6704,  6715,  6726,  6737,  6748,
    6759,  6770,  6781,  6792,  6807,  6808,  6809,  6810,  6811,  6812,
    6813,  6814,  6815,  6816,  6817,  6818,  6819,  6829,  6830,  6831,
    6832,  6833,  6837,  6838,  6839,  6840,  6841,  6842,  6843,  6844,
    6849,  6850,  6851,  6855,  6856,  6859,  6860,  6863,  6865,  6870,
    6871,  6882,  6894,  6895,  6896,  6906,  6915,  6924,  6933,  6942,
    6951,  6960,  6969,  6978,  6987,  7001,  7010,  7019,  7028,  7037,
    7046,  7055,  7064,  7076,  7077,  7091,  7102,  7113,  7124,  7135,
    7146,  7157,  7168,  7179,  7190,  7203,  7204,  7207,  7208,  7218,
    7225,  7234,  7243,  7252,  7261,  7270,  7279,  7288,  7297,  7306,
    7315,  7324,  7333,  7342,  7351,  7360,  7369,  7380,  7381,  7384,
    7385,  7395,  7413,  7429,  7457,  7459,  7461,  7463,  7471,  7481,
    7482,  7485,  7493,  7501,  7509,  7516,  7527,  7531,  7538,  7542,
    7553,  7562,  7571,  7580,  7589,  7598,  7607,  7616,  7625,  7634,
    7643,  7652,  7661,  7669,  7678,  7687,  7696,  7705,  7714,  7723,
    7732,  7745,  7746,  7750,  7751,  7756,  7757,  7767,  7778,  7792,
    7804,  7822,  7823,  7827,  7834,  7835,  7836,  7839,  7840,  7850,
    7861,  7862,  7866,  7870,  7874,  7885,  7899,  7914,  7932,  7933,
    7934,  7935,  7936,  7937,  7949,  7981,  8016,  8017,  8021,  8022,
    8025,  8026,  8031,  8043,  8062,  8067,  8072,  8079,  8080,  8083,
    8084,  8087,  8088,  8092,  8093,  8094,  8097,  8098,  8099,  8115,
    8129,  8144,  8158,  8175,  8176,  8179,  8180,  8184,  8185,  8189,
    8190,  8195,  8209,  8217,  8225,  8241,  8242,  8246,  8247,  8262,
    8272,  8282,  8292,  8302,  8315,  8316,  8317,  8318,  8319,  8325,
    8329,  8344,  8345,  8351,  8361,  8365,  8370,  8378,  8420,  8424,
    8428,  8432,  8440,  8441,  8445,  8457,  8458,  8463,  8464,  8469,
    8470,  8477,  8481,  8485,  8489,  8493,  8497,  8501,  8505,  8509,
    8513,  8517,  8521,  8525,  8529,  8533,  8537,  8542,  8549,  8553,
    8557,  8561,  8565,  8571,  8572,  8578,  8588,  8592,  8603,  8609,
    8618,  8624,  8625,  8629,  8630,  8634,  8635,  8638,  8651,  8655,
    8670,  8679,  8688,  8701,  8702,  8707,  8708,  8725,  8736,  8747,
    8758,  8769,  8780,  8794,  8805,  8819,  8830,  8844,  8852,  8854,
    8856,  8861,  8863,  8868,  8869,  8874,  8893,  8903,  8904,  8908,
    8912,  8924,  8936,  8948,  8962,  8963,  8964,  8968,  8981,  8982,
    8992,  9005,  9009,  9013,  9017,  9024,  9046,  9059,  9072,  9087,
    9088,  9091,  9092,  9095,  9096,  9106,  9116,  9134,  9144,  9154,
    9164,  9174,  9184,  9194,  9204,  9214,  9224,  9234,  9244,  9254,
    9265,  9276,  9286,  9296,  9306,  9316,  9326,  9336,  9347,  9358,
    9369,  9380,  9391,  9402,  9413,  9424,  9435,  9446,  9457,  9468,
    9480,  9492,  9504,  9516,  9528,  9540,  9551,  9562,  9574,  9586,
    9597,  9608,  9617,  9627,  9637,  9647,  9657,  9667,  9677,  9687,
    9697,  9707,  9722,  9723,  9726,  9727,  9737,  9747,  9757,  9767,
    9778,  9788,  9800,  9801,  9811,  9821,  9831,  9841,  9851,  9861,
    9871,  9881,  9891,  9901,  9911,  9921,  9931,  9941,  9951,  9961,
    9971,  9981,  9991, 10001, 10011, 10021, 10031, 10041, 10051, 10061,
   10071, 10090, 10100, 10101, 10104, 10106, 10112, 10113, 10114, 10115,
   10116, 10128, 10144, 10153, 10162, 10171, 10180, 10189, 10198, 10207,
   10216, 10225, 10234, 10243, 10252, 10261, 10270, 10279, 10288, 10297,
   10306, 10315, 10324, 10333, 10342, 10351, 10379, 10387, 10396, 10422,
   10431, 10438, 10444, 10471, 10482, 10491, 10499, 10501, 10523, 10531,
   10541, 10551, 10570, 10589, 10599, 10609, 10619, 10630, 10641, 10652,
   10663, 10674, 10692, 10701, 10718, 10736, 10737, 10738, 10743, 10749,
   10758, 10759, 10760, 10761, 10762, 10766, 10767, 10770, 10771, 10772,
   10773, 10777, 10778, 10779, 10791, 10802, 10803, 10806, 10816, 10823,
   10843, 10852, 10860, 10869, 10878, 10886, 10894, 10902, 10910, 10918,
   10926, 10934, 10945, 10953, 10964, 10965, 10966, 10970, 10973, 10976,
   10979, 10982, 10989, 10991, 10993, 10998, 11000, 11004, 11005, 11006,
   11018, 11032, 11046, 11065, 11087, 11088, 11089, 11090, 11100, 11117,
   11128, 11129, 11133, 11134, 11138, 11142, 11146, 11164, 11165, 11166,
   11167, 11168, 11169, 11170, 11177, 11178, 11189, 11197, 11205, 11214,
   11224, 11242, 11251, 11260, 11269, 11281, 11285, 11296, 11308, 11326,
   11333, 11350, 11364, 11374, 11383, 11392, 11402, 11414, 11426, 11437,
   11438, 11449, 11460, 11472, 11484, 11496, 11508, 11518, 11531, 11532,
   11546, 11571, 11583, 11592, 11604, 11618, 11619, 11631, 11652, 11663,
   11675, 11687, 11691, 11698, 11699, 11703, 11710, 11711, 11712, 11716,
   11717, 11718, 11722, 11723, 11727, 11728, 11731, 11732, 11735, 11736,
   11740, 11741, 11745, 11752, 11754, 11759, 11760, 11773, 11781, 11792,
   11800, 11811, 11812, 11813, 11814, 11815, 11816, 11817, 11818, 11819,
   11820, 11830, 11841, 11842, 11846, 11847, 11848, 11849, 11850, 11860,
   11868, 11886, 11906, 11907, 11917, 11924, 11931, 11938, 11955, 11973,
   11977, 11985, 11991, 11998, 12004, 12011, 12020, 12021, 12025, 12027,
   12032, 12043, 12053, 12063, 12069, 12078, 12087, 12093, 12094, 12105,
   12120, 12121, 12132, 12143, 12144, 12147, 12148, 12149, 12150, 12151,
   12152, 12153, 12154, 12157, 12158, 12162, 12163, 12164, 12175, 12194,
   12195, 12199, 12204, 12228, 12239, 12240, 12252, 12270, 12271, 12275,
   12282, 12289, 12296, 12306, 12319, 12320, 12324, 12337, 12350, 12359,
   12368, 12377, 12386, 12398, 12410, 12422, 12425, 12426, 12427, 12428,
   12429, 12430, 12433, 12434, 12435, 12483, 12484, 12488, 12489, 12504,
   12505, 12512, 12520, 12528, 12536, 12544, 12552, 12563, 12564, 12596,
   12612, 12629, 12630, 12649, 12653, 12657, 12672, 12679, 12686, 12696,
   12697, 12700, 12716, 12717, 12718, 12722, 12732, 12743, 12749, 12761,
   12774, 12780, 12781, 12785, 12797, 12805, 12810, 12815, 12820, 12825,
   12833, 12841, 12846, 12851, 12858, 12859, 12863, 12864, 12865, 12872,
   12873, 12877, 12878, 12882, 12883, 12887, 12888, 12892, 12896, 12897,
   12900, 12909, 12922, 12927, 12932, 12936, 12948, 12949, 12953, 12962,
   12978, 12987, 12996, 13005, 13017, 13020, 13025, 13026, 13034, 13054,
   13055, 13057, 13062, 13063, 13067, 13068, 13071, 13072, 13097, 13106,
   13116, 13117, 13121, 13122, 13123, 13124, 13125, 13129, 13142, 13149,
   13156, 13163, 13164, 13168, 13169, 13173, 13174, 13178, 13179, 13183,
   13195, 13196, 13197, 13198, 13202, 13203, 13213, 13220, 13239, 13240,
   13244, 13245, 13251, 13256, 13265, 13273, 13282, 13289, 13297, 13306,
   13315, 13319, 13345, 13349, 13363, 13384, 13406, 13419, 13436, 13442,
   13447, 13453, 13460, 13461, 13471, 13477, 13485, 13489, 13493, 13500,
   13508, 13513, 13514, 13515, 13516, 13520, 13521, 13536, 13540, 13548,
   13555, 13562, 13569, 13576, 13587, 13588, 13601, 13605, 13613, 13627,
   13641, 13642, 13657, 13668, 13681, 13686, 13687, 13690, 13691, 13694,
   13695, 13700, 13701, 13706, 13707, 13716, 13721, 13722, 13726, 13730,
   13736, 13761, 13772, 13786, 13787, 13791, 13805, 13862, 13876, 13878,
   13883, 13885, 13887, 13889, 13894, 13896, 13901, 13909, 13929, 13934,
   13941, 13946, 13952, 13957, 13966, 13968, 13971, 13975, 13976, 13977,
   13978, 13979, 13980, 13985, 14005, 14006, 14007, 14008, 14019, 14025,
   14033, 14034, 14040, 14045, 14050, 14055, 14060, 14065, 14070, 14075,
   14081, 14087, 14093, 14100, 14122, 14131, 14135, 14143, 14147, 14155,
   14167, 14188, 14192, 14198, 14202, 14215, 14223, 14233, 14235, 14237,
   14239, 14241, 14243, 14248, 14249, 14256, 14265, 14273, 14282, 14293,
   14301, 14302, 14303, 14307, 14309, 14311, 14313, 14315, 14317, 14319,
   14324, 14329, 14335, 14343, 14348, 14355, 14362, 14366, 14370, 14406,
   14407, 14409, 14418, 14434, 14436, 14438, 14440, 14442, 14444, 14446,
   14448, 14450, 14452, 14454, 14456, 14458, 14460, 14463, 14465, 14468,
   14470, 14472, 14474, 14477, 14482, 14491, 14496, 14505, 14510, 14519,
   14524, 14534, 14543, 14552, 14561, 14580, 14589, 14598, 14607, 14616,
   14633, 14642, 14651, 14660, 14669, 14678, 14687, 14691, 14695, 14703,
   14711, 14719, 14727, 14748, 14771, 14783, 14790, 14806, 14811, 14817,
   14824, 14831, 14839, 14847, 14865, 14885, 14911, 14913, 14915, 14917,
   14919, 14921, 14923, 14925, 14927, 14929, 14931, 14933, 14935, 14937,
   14939, 14941, 14943, 14945, 14947, 14951, 14955, 14960, 14976, 14977,
   14978, 14995, 15008, 15010, 15012, 15024, 15049, 15061, 15073, 15081,
   15092, 15103, 15113, 15119, 15128, 15138, 15148, 15161, 15171, 15202,
   15238, 15248, 15259, 15260, 15261, 15268, 15275, 15279, 15283, 15287,
   15291, 15295, 15299, 15303, 15307, 15311, 15315, 15319, 15323, 15330,
   15334, 15338, 15342, 15344, 15351, 15358, 15365, 15372, 15383, 15397,
   15407, 15418, 15434, 15444, 15451, 15458, 15465, 15469, 15477, 15486,
   15495, 15499, 15503, 15507, 15511, 15515, 15524, 15528, 15538, 15542,
   15546, 15551, 15562, 15568, 15582, 15593, 15607, 15623, 15640, 15642,
   15646, 15648, 15650, 15653, 15656, 15659, 15660, 15663, 15671, 15681,
   15682, 15685, 15686, 15687, 15690, 15691, 15692, 15697, 15701, 15705,
   15709, 15716, 15717, 15725, 15726, 15730, 15731, 15739, 15740, 15744,
   15745, 15750, 15759, 15761, 15776, 15779, 15807, 15808, 15811, 15812,
   15820, 15828, 15836, 15845, 15855, 15873, 15919, 15928, 15937, 15946,
   15955, 15967, 15968, 15969, 15970, 15971, 15985, 15986, 15987, 15990,
   15991, 15994, 15997, 15998, 15999, 16002, 16003, 16006, 16007, 16008,
   16009, 16010, 16011, 16012, 16013, 16014, 16015, 16016, 16017, 16020,
   16022, 16027, 16029, 16034, 16036, 16038, 16040, 16042, 16044, 16056,
   16060, 16067, 16071, 16077, 16081, 16091, 16103, 16104, 16107, 16108,
   16111, 16115, 16119, 16125, 16126, 16131, 16141, 16142, 16143, 16144,
   16145, 16146, 16147, 16148, 16152, 16153, 16154, 16155, 16160, 16165,
   16174, 16195, 16199, 16204, 16215, 16232, 16238, 16239, 16240, 16243,
   16251, 16261, 16276, 16277, 16281, 16293, 16294, 16297, 16298, 16301,
   16305, 16312, 16316, 16320, 16329, 16341, 16342, 16346, 16347, 16351,
   16352, 16355, 16356, 16361, 16370, 16375, 16381, 16382, 16386, 16395,
   16399, 16400, 16401, 16402, 16403, 16408, 16409, 16410, 16411, 16412,
   16416, 16418, 16428, 16431, 16437, 16438, 16439, 16443, 16444, 16445,
   16449, 16450, 16454, 16472, 16492, 16493, 16502, 16503, 16507, 16508,
   16511, 16519, 16527, 16535, 16558, 16559, 16570, 16574, 16580, 16582,
   16587, 16589, 16591, 16601, 16603, 16614, 16618, 16622, 16626, 16630,
   16639, 16647, 16679, 16683, 16690, 16698, 16702, 16706, 16712, 16713,
   16715, 16716, 16717, 16721, 16762, 16790, 16794, 16798, 16804, 16806,
   16820, 16856, 16869, 16870, 16873, 16874, 16891, 16892, 16893, 16898,
   16899, 16900, 16905, 16906, 16907, 16908, 16914, 16915, 16916, 16917,
   16918, 16924, 16925, 16945, 16946, 16947, 16948, 16949, 16950, 16951,
   16952, 16953, 16954, 16955, 16956, 16957, 16958, 16959, 16960, 16961,
   16962, 16963, 16964, 16965, 16966, 16967, 16968, 16969, 16970, 16971,
   16972, 16973, 16974, 16975, 16976, 16977, 16978, 16979, 16980, 16981,
   16982, 16983, 16984, 16985, 16986, 16987, 16988, 16989, 16990, 16991,
   16992, 16993, 16994, 16995, 16996, 16997, 16998, 16999, 17000, 17001,
   17002, 17003, 17004, 17005, 17006, 17007, 17008, 17009, 17010, 17011,
   17012, 17013, 17014, 17015, 17016, 17017, 17018, 17019, 17020, 17021,
   17022, 17023, 17024, 17025, 17026, 17027, 17028, 17029, 17030, 17031,
   17032, 17033, 17034, 17035, 17036, 17037, 17038, 17039, 17040, 17041,
   17042, 17043, 17044, 17045, 17046, 17047, 17048, 17049, 17050, 17051,
   17052, 17053, 17054, 17055, 17056, 17057, 17058, 17059, 17060, 17061,
   17062, 17063, 17064, 17065, 17066, 17067, 17068, 17069, 17070, 17071,
   17072, 17073, 17074, 17075, 17076, 17077, 17078, 17079, 17080, 17081,
   17082, 17083, 17084, 17085, 17086, 17087, 17088, 17089, 17090, 17091,
   17092, 17093, 17094, 17095, 17096, 17097, 17098, 17099, 17100, 17101,
   17102, 17103, 17104, 17105, 17106, 17107, 17108, 17109, 17110, 17111,
   17112, 17113, 17114, 17115, 17116, 17117, 17118, 17119, 17120, 17121,
   17122, 17123, 17124, 17125, 17126, 17127, 17128, 17129, 17130, 17131,
   17132, 17133, 17134, 17135, 17136, 17137, 17138, 17139, 17140, 17141,
   17142, 17143, 17144, 17145, 17146, 17147, 17148, 17149, 17150, 17151,
   17152, 17153, 17154, 17155, 17156, 17157, 17158, 17159, 17160, 17161,
   17162, 17163, 17164, 17165, 17166, 17167, 17168, 17169, 17170, 17171,
   17172, 17173, 17174, 17175, 17176, 17177, 17178, 17179, 17180, 17181,
   17182, 17183, 17184, 17185, 17186, 17187, 17188, 17189, 17190, 17191,
   17192, 17193, 17194, 17195, 17196, 17197, 17198, 17199, 17200, 17201,
   17202, 17203, 17204, 17205, 17206, 17207, 17208, 17209, 17210, 17211,
   17212, 17213, 17214, 17215, 17216, 17217, 17218, 17219, 17220, 17221,
   17222, 17223, 17224, 17225, 17226, 17227, 17228, 17229, 17230, 17231,
   17232, 17233, 17234, 17235, 17236, 17237, 17238, 17239, 17240, 17241,
   17242, 17243, 17244, 17245, 17246, 17247, 17248, 17249, 17250, 17251,
   17252, 17253, 17254, 17255, 17256, 17257, 17258, 17259, 17273, 17274,
   17275, 17276, 17277, 17278, 17279, 17280, 17281, 17282, 17283, 17284,
   17285, 17286, 17287, 17288, 17289, 17290, 17291, 17292, 17293, 17294,
   17295, 17296, 17297, 17298, 17299, 17300, 17301, 17302, 17303, 17304,
   17305, 17306, 17307, 17308, 17309, 17310, 17311, 17312, 17313, 17314,
   17315, 17316, 17317, 17318, 17319, 17320, 17321, 17322, 17323, 17324,
   17325, 17326, 17327, 17341, 17342, 17343, 17344, 17345, 17346, 17347,
   17348, 17349, 17350, 17351, 17352, 17353, 17354, 17355, 17356, 17357,
   17358, 17359, 17360, 17361, 17362, 17363, 17373, 17374, 17375, 17376,
   17377, 17378, 17379, 17380, 17381, 17382, 17383, 17384, 17385, 17386,
   17387, 17388, 17389, 17390, 17391, 17392, 17393, 17394, 17395, 17396,
   17397, 17398, 17399, 17400, 17401, 17402, 17403, 17404, 17405, 17406,
   17407, 17408, 17409, 17410, 17411, 17412, 17413, 17414, 17415, 17416,
   17417, 17418, 17419, 17420, 17421, 17422, 17423, 17424, 17425, 17426,
   17427, 17428, 17429, 17430, 17431, 17432, 17433, 17434, 17435, 17436,
   17437, 17438, 17439, 17440, 17441, 17442, 17443, 17444, 17445, 17446,
   17447, 17448, 17449, 17450, 17463, 17464, 17465, 17466, 17467, 17468,
   17469, 17470, 17471, 17472, 17473, 17474, 17475, 17476, 17477, 17478,
   17479, 17480, 17481, 17482, 17483, 17484, 17485, 17486, 17487, 17488,
   17489, 17490, 17491, 17492, 17493, 17494, 17495, 17496, 17497, 17498,
   17499, 17500, 17501, 17502, 17503, 17504, 17505, 17506, 17507, 17508,
   17509, 17510, 17511, 17512, 17513, 17514, 17515, 17516, 17517, 17518,
   17519, 17520, 17521, 17522, 17523, 17524, 17525, 17526, 17527, 17528,
   17529, 17530, 17531, 17532, 17533, 17534, 17535, 17536, 17537, 17538,
   17539, 17540, 17541, 17542, 17543, 17544, 17545, 17546, 17547, 17548,
   17549, 17550, 17551, 17552, 17553, 17554, 17555, 17556, 17557, 17558,
   17559, 17560, 17561, 17562, 17563, 17564, 17565, 17566, 17567, 17568,
   17569, 17570, 17571, 17572, 17573, 17574, 17575, 17576, 17577, 17578,
   17579, 17580, 17581, 17582, 17583, 17584, 17585, 17586, 17587, 17588,
   17589, 17590, 17591, 17592, 17593, 17594, 17595, 17596, 17597, 17598,
   17599, 17600, 17601, 17602, 17603, 17604, 17605, 17606, 17607, 17608,
   17609, 17610, 17611, 17612, 17613, 17614, 17615, 17616, 17617, 17618,
   17619, 17620, 17621, 17622, 17623, 17624, 17625, 17626, 17627, 17628,
   17629, 17630, 17631, 17632, 17633, 17634, 17635, 17636, 17637, 17638,
   17639, 17640, 17641, 17642, 17643, 17644, 17645, 17646, 17647, 17648,
   17649, 17650, 17651, 17652, 17653, 17654, 17655, 17656, 17657, 17658,
   17659, 17660, 17661, 17662, 17663, 17664, 17665, 17666, 17667, 17668,
   17669, 17670, 17671, 17672, 17673, 17674, 17675, 17676, 17677, 17678,
   17679, 17680, 17681, 17682, 17683, 17684, 17685, 17686, 17687, 17688,
   17689, 17690, 17691, 17692, 17693, 17694, 17695, 17696, 17697, 17698,
   17699, 17700, 17701, 17702, 17703, 17704, 17705, 17706, 17707, 17708,
   17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716, 17717, 17718,
   17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726, 17727, 17728,
   17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736, 17737, 17738,
   17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746, 17747, 17748,
   17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756, 17757, 17758,
   17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766, 17767, 17768,
   17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776, 17777, 17778,
   17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786, 17787, 17788,
   17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796, 17797, 17798,
   17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806, 17807, 17808,
   17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816, 17817, 17818,
   17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826, 17827, 17828,
   17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836, 17837, 17838,
   17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846, 17847, 17848,
   17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857, 17858,
   17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867, 17868,
   17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876, 17877, 17878,
   17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886, 17887, 17888,
   17889, 17890, 17891, 17892, 17893, 17894
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "UIDENT",
  "FCONST", "SCONST", "USCONST", "BCONST", "XCONST", "Op", "ICONST",
  "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER",
  "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT",
  "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE",
  "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY",
  "ARRAY", "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED",
  "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P",
  "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE",
  "CLUSTER", "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS",
  "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH",
  "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING",
  "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE",
  "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION",
  "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORMAT", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD",
  "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT",
  "INDENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "JSON", "JSON_ARRAY",
  "JSON_ARRAYAGG", "JSON_OBJECT", "JSON_OBJECTAGG", "KEY", "KEYS", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED",
  "MAPPING", "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE",
  "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD",
  "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON",
  "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY",
  "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY",
  "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER", "PARSER",
  "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS",
  "POLICY", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP",
  "ROUTINE", "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR",
  "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "SYSTEM_USER", "TABLE",
  "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED",
  "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC",
  "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN",
  "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "FORMAT_LA", "NOT_LA", "NULLS_LA", "WITH_LA", "WITHOUT_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "opt_single_name",
  "opt_qualified_name", "opt_concurrently", "opt_drop_behavior",
  "CallStmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "DropRoleStmt", "CreateGroupStmt", "AlterGroupStmt", "add_drop",
  "CreateSchemaStmt", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "PartitionBoundSpec", "hash_partbound_elem", "hash_partbound",
  "AlterCompositeTypeStmt", "alter_type_cmds", "alter_type_cmd",
  "ClosePortalStmt", "CopyStmt", "copy_from", "opt_program",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "column_compression", "opt_column_compression", "column_storage",
  "opt_column_storage", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_indent_option",
  "xml_whitespace_option", "xmlexists_argument", "xml_passing_mech",
  "within_group_clause", "filter_clause", "window_clause",
  "window_definition_list", "window_definition", "over_clause",
  "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_value_expr",
  "json_format_clause_opt", "json_encoding_clause_opt",
  "json_output_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,    60,    62,    61,    43,    45,    42,    47,    37,    94,
     756,    91,    93,    40,    41,    46,    59,    44,    58
};
#endif

#define YYPACT_NINF (-5567)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-2885)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    7658,  1081, 21115, -5567, -5567,  1081, 68778, -5567, 78050,  1285,
     195,   727,   214, 19451, 78538, 88298,   620,   370, 14060,  1081,
   88298,  2492, 59505, 74146,   950, 88298,  1511,  1143, 59505, 88298,
   88786,  1353,  1422,   629, 89274, 79026, 72682,  1192, 88298,  1576,
     984, 89762, 79514,  1404, 80002,  1143, 55612,   349,  1346, 90250,
   88298,112628,   984, 80490, 80490, 80490,  1893,  1980,  1619, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567,  1468, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567,  2174, -5567,   845,
    2717,  1600,   184,  1497, -5567, -5567,  2158, 68778, 88298, 88298,
   88298,  1797, 88298,  1793, 88298,   858, 68778, 65362, 80978,  1932,
    1792, 51592, 90738, -5567, 68778, 88298, 62922, 68778, 88298, 88298,
   91226, 88298, 91714, 88298,  1719, 76586, 88298,  1927, 88298, 88298,
   63410, 92202,  2077,  1539,   216, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,  1847,
    1665, -5567,   241, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, 59993, 88298, 19928,  1511,  2158, -5567,  1893, 88298,
    2058, 88298,  1851, 92690, 88298, -5567, 88298,  1964, 93178,   892,
     644, 65362,  1614, 52099,  2066, 88298, 88298, 65362, 93666, 94154,
   94642, 88298, 88298, -5567, -5567,  2033, 88298, -5567,  2193, 65850,
    1499,  2221,  2391,  2287,  1068, -5567, 81466, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, 68290,   370, -5567, -5567,  2237,
   69266,  2342, -5567, -5567, 95130,113102,  2133, -5567,   910, 69754,
   66338,  2465,  2106, 52606,  2540, -5567, 70242, -5567, 66826, 70730,
   -5567, -5567, -5567, -5567, -5567, 95618, -5567, 96106,  2210,  2342,
   -5567,113576, 67314, -5567,  2374, 96594, 97082, 97570,  2158,  2111,
    2074,  2753, 46116, -5567, -5567, -5567,  2168, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567,   247,  1722,   310,   234,
     317, -5567, -5567,   239,   243,   249,   247,  2625,  2625, -5567,
   88298, -5567, -5567,  1722,   729,  2254,  2188,  2188,  2188,  2424,
    1061, -5567,  2188,  2352, -5567, -5567, -5567, -5567, 80002, -5567,
    2227,  1511,  2309,  2741,  2369, 59993,  1357, 88298, -5567, -5567,
    2794,  2358,  2631,  2343, -5567, -5567, -5567,  2578,  2596,   158,
      69,  1511,   254, -5567,  2715, -5567,  2609, 31568, 31568,  1511,
   81954, 98058,   238, 68290,  1511, 82442,  2432,  1565,  2619, -5567,
   -5567, -5567,   506, -5567,  2880,  2439,  2712,  2343,  1539, 48092,
   -5567, -5567,  2440,  1665, 80002, -5567, -5567, -5567, 59993,  2782,
   34604, 88298,  2449, -5567,  2475,  2449, -5567, -5567,  2547, -5567,
    2547,  2547,  2495,  2495,  2725,  2502, -5567, -5567, -5567,   407,
    2547,  2495, -5567,114524, -5567,  1947,  2007, -5567, -5567,  2979,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,  2510, -5567,
    1355,  1759, -5567, -5567, -5567, 31568, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567,  2527,  2546,  1600, -5567,  8312, 59993, 88298,
    1456,  1456,  3007,  1456,  1547,  1730, -5567,  2752, -5567,  2893,
    2854,  2868, 80002,  2576,   328, -5567,  1615,  2582,  1838,  2603,
    1616,  2302, -5567,   265, 88298,   505,  2617, 82930,  4023,  2590,
    1665,  2607, -5567, -5567, -5567, -5567,  2779,  1043, -5567, -5567,
   -5567, -5567,  2932,  2980,  7576,   342, 83418, -5567, -5567, -5567,
   -5567, 88298, 88298, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567,  2643,   149, -5567, -5567,  2620,  2988,  2863,  4423,
    1262,  2965,  2815,  1231,  5540,  2875,  1751,  3022, 16949,  1866,
    3035,  1949,  2308, 83906, 88298,  3003,  3053,  5966,  1946,   904,
    2924,  1114,  2965,  3057,  2876,  1231,  3073,  8466, 88298, -5567,
    2989,  3108,    97, -5567,   231, -5567, 24539, 34604, 55124, -5567,
    1665, -5567,  1804, -5567, -5567, 59017, -5567,  2780,  2937,   957,
   68778,  2720, 88298, 88298, -5567,112628, 68778, -5567,  2945, 53113,
   68778, -5567, 68778, -5567, -5567,  3067,112628, 88298, 88298, -5567,
   88298, -5567, -5567,  2723, -5567, -5567, -5567, -5567, -5567,  2188,
   88298,  3166,112628,  2966,   266,  1527,  3207, 88298,  2970,  1527,
    2777, 98546, -5567, -5567,  1527, -5567, -5567, -5567, 88298, 88298,
    2743,  1324,  2964,   152,  1527,  2982,  3217,  3219,  2990,  2835,
    2994,  2475, -5567,  3185,  2971,   945,   215,  2086,  1527,  2823,
   99034, 99522, 88298,  2826, 88298,  3205, 68778,  2862, 68778, 68778,
   88298,  3132, 88298, -5567,  2972, -5567, -5567,  1528, -5567, -5567,
   -5567, -5567, -5567,  3147, -5567,   228,  3148,  2791,  3153,  1721,
    3154,   271, -5567, -5567,  2836, -5567,  3158,   332, -5567,  3160,
   -5567,  2800,100010, -5567,100498,100986,  3164,   339, -5567, 65362,
    3165,   332,  3167,  2800,  3168,   332,  3169,   905,  3170, -5567,
    1006,  3159,  3172,   271,  3174,  2115,  2800, -5567,  3175,   351,
   -5567,  3177,   352, -5567,  3181,  3041, -5567, 34604, -5567,  2922,
   -5567,  1346,  1872,  2753,  1722, -5567, 88298,  1722, 88298,  1722,
   88298,  1722, 88298,  1722, 88298, 88298, 88298,  1722, -5567, -5567,
   -5567, 88298,  2825, 88298, -5567, 88298, -5567, -5567, -5567, 75122,
   65362, 75610, -5567, 88298, -5567,   120,  1511, -5567, -5567,112628,
    3301, 65362,  3205,  1929, -5567, -5567,  3205, -5567, -5567,  3205,
    3205, -5567, -5567, -5567,  3100, 88298,  3176, 75122, 65362,  3182,
   -5567,101474, -5567, 68290,  3047,  2832, -5567, -5567, -5567, -5567,
   -5567,  1724,  3345,   222,  3348, 34604,  2842,   222,   222,  2843,
    3189, -5567, -5567, -5567,   256,  2845,  2847, -5567,   244,   244,
   -5567,  2849,  2850, -5567,   245,  2851,  2856,  3361,  3364,   264,
    2858,  2860,  2861,  2864,  2865,  2866,  2867,   407,   222,  2870,
   34604, -5567,  2873,   244,  2874,  2884,  2885,  3370,  2886, -5567,
    3375,  2887, -5567,   229,   303,  2888,  2889, -5567,  3102, -5567,
     270,  2892,  2894,  2897,  2898,  2899,  2901,  2903,  2905, 34604,
   34604, 34604, -5567, 29033,  1665,  1511, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567,   272, 51085, -5567,  2935, -5567, -5567,
    3113, -5567, -5567, 34604, -5567, -5567,  3258,   104, -5567,   277,
   -5567, -5567, -5567,  1665,  3203,  2906, -5567, -5567,  1705,  2910,
   -5567,  2107, -5567, -5567, -5567, -5567, -5567, -5567, 67802,  3390,
   -5567,   319,  1511,   231,  2025,  3327, 57553, 58041, -5567, -5567,
    3190, -5567, 88298, -5567, -5567,  1665,   213,  2001, -5567,  2168,
   18878,  2049,  2449, 88298, 88298,  3392, -5567,  2919, -5567, -5567,
   34604, -5567, -5567, -5567,  2625, -5567,  2547,  2547, -5567, -5567,
    3396,  3009,  3010,  2625, -5567,  2625, -5567,  2925,  2926,  2625,
    3012,  3014,  3015, -5567,  2930,  3017,  2625, -5567, -5567, 60970,
    1921, -5567,  3271,   316, -5567, -5567, -5567,  2056, -5567,  2933,
   -5567,  2475, -5567, -5567,  1600,  1600, 34604,  1600,   936,  1267,
   32074, 35110,  3281,  3161,  1572,   930,  3283, -5567,  3162,  1547,
    1730, 80002, 88298, 80002,101962,  3069, 34604, -5567,  3387,  3029,
    3032,  3090, 56588, -5567,  3037,  3004,  3042,  3098,  2958,  3048,
    3049,  3105, -5567,  3231, -5567, -5567,  3051,  3400,  3054,102450,
   -5567, -5567,   883, -5567, -5567, -5567,   883, -5567,  2977,  1350,
    1047,   308,  3059,   357,  1058,  3399, -5567,  1374, -5567, -5567,
    3120, -5567,  9816, 88298,  3339,  8879,  3208,   342,  3131, -5567,
   -5567, -5567,  3274,  3082, 88298,  3088,  3233,   342,   313,102938,
   -5567, -5567, 88298, -5567, -5567, -5567, -5567,  6331,  3393, 27577,
   -5567,  2047,  3092,  3071,  3109, 88298, 71706,  2092,  3213,  3235,
    1694,  2288,   279,  3171, 88298,   298,  3241, 88298,  3019,  3106,
    3107,  3344,  3023,  1015,  3446,  3025, -5567, -5567, -5567,  3413,
   -5567,  2392,  2408,  3236, -5567,  3350,  3389,  9056,  3099,  3103,
  111206, -5567,  3126,    34, 53620, 88298, 88298,  3128,  3129,103426,
    6331,  3431, 76098, 76098,  3135,  3136, 47598,  3451,  1821,  3139,
   -5567, -5567, -5567,  1821,  3140,  3141,103914,  6331,  3442, 88298,
    3143,  3146, 88298,114524,   342, -5567,  3512, -5567,   342,   342,
    2230,  3516,  3163,   359,  3323,   585,  1527, -5567,  3025,  2213,
   -5567,  3173,  3178,   329, -5567,  3290, 88298,  3179,  3180,  1512,
    3256,  1511, -5567,  3259, -5567,  3184,  3260,  3188,  1071,  2743,
   -5567, -5567,  1227,  3186, 80002,  3277,  3280,   298,   269,   679,
    3025, -5567,  3191,  3193,  3023,  3023, 88298, 88298, 88298, 88298,
   88298,   227,  3551,  3552,  3195,   478,  1023,  3085, -5567,  1821,
   63898,  3196, -5567,  1821, 88298,   220,   711,  3025,  1876,  1867,
   -5567, -5567, -5567,  1539, -5567, 34604, 34604, 34604,  3089, -5567,
    1523, 18878,    81, -5567,   278, 12973,  3091, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, 88298, 59993, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, 88298, -5567, 88298,  3391,112628,  3403,  3313,
    3404,  3407,   342, 88298, 88298,  3410,  3412,  3416,112628,  3421,
    3422,  3423,  3322,  3218,   819,  3197,  3134,  3610,  3496, 88298,
   60970, -5567,   883, -5567,112628,  3357,  3499, -5567, 88298,  3376,
      62, -5567,  3536,  3209, -5567, -5567,   110, 88298, 74634,  2743,
   -5567, -5567,  3504, 65362,  1524,  3505,  1511,  3200,  3510,  3373,
    1511, 65362,  3420, 88298, 88298, 88298, 88298,   157, -5567, 63898,
    3385, -5567, 88298,  3395,  2213,  3401,  3632,    78,  2188,104402,
    3503, -5567,104890,  3194, 88298,  3199,  3199,  3634,112628,  1434,
    3440, -5567, -5567,  2087, -5567,  3302, -5567, 68778, -5567, -5567,
   68778, -5567, -5567,112628, 88298,  3201,112628,112628, -5567, -5567,
   68778, 68778, -5567, 65362, 65362,  3525,   351,  3528,  3234,  3530,
    3237, 53620, 53620, -5567,   382, 68778, -5567, 65362, 68778, -5567,
   88298, -5567, 88298, -5567, -5567, -5567, -5567,112628,112628, -5567,
   65362, 63898,  3532, 88298, 88298, -5567, 88298, 88298, -5567, 88298,
   88298,  2063,105378,  2753, -5567, 88298, -5567, 88298, -5567, 88298,
   -5567, 88298, -5567, 88298, -5567, -5567, -5567, 88298, -5567, 88298,
    2070, -5567, -5567,  2147,  1384, 88298, 88298,   886, 68778, 88298,
    3402, 88298, 68778, 68778, 88298, 88298, 88298, 88298, 88298,  3262,
    2910,   763, -5567,  1478,   790, 80002,  3406, -5567, -5567,  2155,
    1893,  1097, 88298, -5567, 88298, 88298, 88298, -5567, -5567, 74146,
    3518,   123, 75610, 88298, -5567, -5567, 10401, 34604,  1665, 31057,
   -5567, -5567, 18878,  3228, 34604, 34604,  3204,  2625,  2625, -5567,
    1232, 34604, 34604, 28527, 34604, 32580, 34604, 34604,  2625,  2625,
   34604,  7977, 34604, 53620, 34604, 40170, 25563, 34604, 34604, 29539,
    1264,  2849, 34604,  3430, 41176, 34604,  2025,  3432, 34604,  2025,
    7977,  3685,  3685,  2548,  6867,  3202,  1665, -5567,  2625,   198,
   -5567,   297,112628, 34604, 34604, 34604, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, 34604, -5567, 60970, -5567, -5567, -5567, -5567, -5567, -5567,
    3291, -5567, -5567, -5567, -5567, -5567, -5567,  1340, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, 88298, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, 30045, -5567, -5567, -5567, -5567,
    3210, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567,  2853, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, 30551, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567,  3211, -5567, -5567, 34604, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,  3272,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567,  2004, 34604, 34604, 34604, 34604, 34604, 34604, 34604, 34604,
   34604, -5567, 34604,   345, -5567, -5567,  3539,  3258,  1082,   541,
    3214,  3424, 84394, 31568,  3271, 24539, -5567,   293,  3271, -5567,
   -5567, -5567, 88298,  3390, -5567, -5567,  3297, -5567, -5567, -5567,
   -5567, -5567,   286, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
    3212, -5567, -5567, -5567, -5567,  3212, -5567,  3220,  3537,  3540,
     905, 88298,  2581, 34604,  3291,   273, 88298, 34604,  3210,  2853,
   34604,  3211, 34604,  3272, -5567, 34604, -5567,  2159,  2031, 34604,
    2161,  3224, -5567, -5567,  3222,  2926,  3249,  3250,  3230,  3238,
    2625,   262,  3240,   833,   179,  3369,  2625,  3483,  3242, -5567,
   60970, -5567, 43152,  3282, -5567, -5567, -5567,   984, 88298, 88298,
   -5567,  3533, -5567,  3243, -5567, 13266,  3533, -5567, -5567, 40673,
    3359,  3529,  3459, -5567, -5567, -5567,  3245, 18878, 35616, 35616,
   -5567,  2273, 18878,  2316, -5567, -5567, -5567, -5567, -5567, -5567,
    1505, -5567, 88298,   798,  3281,   930,  3307,  1458,  3726,  3314,
   88298, -5567, 48586,  2165, -5567, 65362, 88298, 88298,  3464, -5567,
    3710, -5567,114524, -5567,  3257, -5567,114050,110258, -5567, -5567,
      88, -5567,  1265, 65362, -5567, 88298, 88298, 65362, 88298, 88298,
   -5567, 65362,  3308, 88298, 88298, -5567, -5567, -5567, -5567, -5567,
   58529,  1201, 74146,  3405, 73170, -5567, -5567,  3263, 88298,  3321,
    3543,  3545,  1116, -5567, -5567,105866, -5567,  3493, 65362, 88298,
   88298, 34604,  3494, 88298, 88298, -5567,   834,  3353,  3354, -5567,
   88298,  3355, 68778,  3270,112628, 68778, 54127, 68778, 68778,  3618,
  112628, 88298, 88298,  1253, 80002,   274,   836,  3025,  3506, -5567,
     326, -5567, 65362, -5567, 88298,  3498, -5567, -5567, -5567, 84882,
    3741,  3408, -5567, -5567, -5567,106354, -5567, -5567,  3500, -5567,
    2185, -5567, 65362, 65362, 88298,  9085,106842,   635,  3514, -5567,
   -5567,112628, -5567, 88298, 85370, 88298, 88298,  3555, 88298, 77074,
  107330,107818,   748,  1334,  3556, 88298, 77562,  3557, -5567,  3433,
   88298, -5567, -5567, 61458, 65362, 88298,   841, 60970, -5567,  3544,
   -5567, 88298, -5567,   895, -5567, 88298,  6676,  3509, -5567, -5567,
    3372,  3388, 88298,   341,   939,  3025,  3682, 88298, 88298,  3293,
    2189, 65362, 88298, 60970, -5567,  3519,    93, 65362, 88298, 84882,
   -5567,  3521, -5567, 80002,  3620, -5567,  3306,  2188,  2440,  1916,
    3306, 65362, 88298, -5567,  3306, 88298, 98058, -5567, 65362,  1040,
   -5567, 65362, 88298, 84882, -5567,  3524,  3474, 65362, 88298, 19716,
   -5567, -5567, -5567,   342, -5567, -5567, -5567, -5567, -5567, 88298,
   88298,   342, 88298, 88298,   342,  1372, -5567, 65362, 88298, -5567,
   -5567, -5567,  3441, 65362, 88298, 88298,   247, 88298, -5567, 88298,
   65362,  3358, 88298, 88298, -5567, -5567, 88298,  6889, 88298, 88298,
   88298, 88298, 88298, 88298, 65362, 88298, -5567, -5567,  1500,  1473,
     116,  1823,  1498, 88298,  3633, 88298,108306, 65362, 88298, 88298,
    1511, 88298, 60970,  1771, -5567, -5567,  3447, -5567, 65362,  1040,
   -5567,  9640, 88298, 88298, 88298,  3414,  3415,   202,  3502, -5567,
   -5567, -5567,   783,   783,  3546, -5567, 34604, 34604, 33086,  3332,
   -5567, -5567, 34604,  2780, -5567, -5567, -5567,   971,  3812,   971,
  108794,   971,   971,  3630,  3409,  3411,   971,   971,   971,  3619,
     971,   971,   971, 88298,  3520, -5567, -5567,  3520,   928, 34604,
  112628, 88298, -5567,  2216, -5567,  3356, -5567, -5567, 60970, 88298,
     217,   175,  3702,  3567, 72194,  1269,  3690, 88298,  3398, 88298,
    3825,  3449,   -15, -5567,  1269, 88298, -5567,  2109, 74146, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, 88298, -5567, -5567,  3696,
   88298, 43646,  3534, -5567,  1511,  2743,  2743,  2743,  2743,  3360,
    2743, 88298,  3485,  3714,  1269,  3363,  3717, -5567,  2213,  3718,
    1213, 88298,  3587, 72194,  3428,  3417,  3600,  3843,  2188,  1511,
    3603,  3589, -5567, 57065, -5567,  2743,  3858, 28052,  4948,  7415,
    3593,  3658, -5567, -5567,  3602,  1045, 88298,  3704,  3706,  3728,
   -5567,   228, -5567,  3860,  1721,  3731,   271, -5567,   332, -5567,
    2800, -5567, 88298, -5567, 88298, 88298, 88298, 88298,   339, -5567,
   -5567,   332,  2800,   332,   905, -5567,  3669,   271,  2800,  3523,
    3740,   351, -5567,   352, -5567,  3614,   905, -5567,  3631,  2188,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567,  2223, -5567, 88298,
   -5567,  3712,  3715,  3719,  3722,  3724,  3419,  3425,  3450, 88298,
    3426,  3419,   342,  3429,  3418, -5567,  3426,  3426,  3419,  2910,
    2910,  3419,  3425, 64386,  3864, 60970, -5567, -5567,  3501,  3427,
    3751,   223, -5567,   832,  1263,  3664, -5567, -5567, -5567, -5567,
  112628, -5567, 65362,  3457, -5567, -5567, -5567,  3635,  3434, 64386,
     905,   176, -5567, 68778, 88298,112628, 68778,  3640, 68778, 68778,
  112628, 88298, 88298,  2224, -5567,  1956, -5567,  1987, 34604,   475,
   -5567, 13655,  2225, 34604,  3435,  3436, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567,  3439,  3757, -5567,  2231,  2233,112628,  2805,
    3443, 14101, -5567,  3444,   324,  3636,  3330,  3476,  2259,  3448,
     344, -5567,  3330,   335,  2270,  3454,  3455,  4961,  6475,  3456,
   14267,  3437,  3458,  3460,  3462, 40170, 40170, 29033,   659, -5567,
   40170,  3463,  3638,  2272, 13406,  3466,  3468, 14895, 33592, 34604,
   33592, 33592, 14976,  3438,  3472, -5567,  3804, -5567,  2276, 60970,
    3639, 15296,  2278, -5567, 34604, 60970,  6546, 34604, -5567, 34604,
    3473, -5567, -5567,  3622,  3622,  3622,  7977, -5567,  3467, -5567,
   40170, 40170, -5567,  4058, 29033, -5567, -5567,  3773, -5567, -5567,
     242, -5567, -5567, -5567, -5567, -5567,  3232, -5567, -5567, -5567,
    3692,  2119,  4385, 53620,  6804, 34604,   276, 34604,  3210, 34604,
    3563,  3622,  3622,  3622,   444,   444,   284,   284,   284,  2051,
     541, -5567, -5567, -5567,  3465,  3478,  3424,  3479, 34604, -5567,
    3481, 49080, -5567,  2244,  2330, 88298,  5910,  6156,  6278, -5567,
   -5567, -5567,  3282,    81,  3282, -5567,  1539,  2625,   198, 59017,
   -5567, -5567, -5567, -5567, -5567, -5567, 88298, 18878, -5567, -5567,
    3705,  3488,  2285, -5567, -5567,  2625, -5567, -5567,  2197,  2197,
    3484, -5567,  3486, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
    3489, -5567, -5567, -5567, 44140,  3830,  3495, 42658, 85858,  3490,
    1977, -5567, 85858, 86346, 85858, -5567,  3517, -5567, -5567,  1665,
   34604,  3823, -5567, -5567, -5567, 34604, -5567, -5567,  1869,  3526,
     682,   709,  2421,  2421,  2273,   857, -5567, -5567,  3561, -5567,
   34604,  2340, -5567,  2412, -5567, -5567, -5567, -5567,  2910, -5567,
    3763, -5567, -5567, -5567, 43152,  3549,  3560,    50, 47104,  3725,
   -5567, 88298, 43152, -5567, 88298,   189, -5567,  3547, -5567, -5567,
   -5567, -5567, -5567, -5567,110258,  1759, -5567,114050, -5567,114050,
   -5567,  1759,  3969, -5567,110258,  1990, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, 65362,
   65362,  3744, 88298,  3742,  3753, 34604,   230, 88298,  3538,  3541,
    1236,  3846,  3542, -5567,  3902,   905, -5567, -5567,  3637, -5567,
   18878, -5567, -5567, -5567, -5567, -5567, 65362, 88298, -5567, 68290,
   -5567, -5567,112628, -5567, -5567, 88298, 88298, -5567, -5567, -5567,
  112628, -5567, -5567, -5567, 88298,   162,  3643,  3646, 88298, -5567,
    1293,  3290,  9921, 88298, 88298, 88298,  3847, -5567, -5567, -5567,
   -5567,  3775, -5567,  3906, -5567,110258, -5567,  2800,  1437,  3648,
    3025,  3785, -5567,  3912,  3663, -5567,  3693,   856, -5567, -5567,
    3699, -5567, -5567, -5567, -5567,  3925,   905,  3928,   905, 88298,
   88298, 88298, 88298,  3707, -5567, -5567, -5567, -5567,  3709,  3842,
   -5567, 60970, 60970, 60970,  2290, -5567, -5567,  1511, -5567, -5567,
   -5567, -5567, -5567, -5567,  3884, -5567,  2291, -5567,  1850, 88298,
   -5567, -5567, -5567, -5567, -5567,  3931, 65362, 88298, 10475, 88298,
   88298, 88298,  3795,  1954,  1480,112628, -5567,111680, -5567, -5567,
    2292, -5567,  3588, 88298,  3666, 65362,  3647, -5567, -5567, -5567,
    3937,  2188,  3727, 76098,  3641,  3641,  2136, -5567, -5567, -5567,
   -5567, -5567,  3854,  3784, -5567,  1014,  3786, 65362,  3665, -5567,
   -5567, -5567, -5567,  3949,  3684, -5567, -5567,  3688,  1093,  3025,
    2213, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
    3711, -5567, -5567, -5567, -5567,  1611,  1611, -5567, -5567, -5567,
    1611,  1467,   479,  1104,  3025, -5567,  1819,   363,  3689, -5567,
    3694, -5567, -5567, -5567,  3865,  3879,  3880,  3716,  3720,  3745,
    3730,  3732,  3762, -5567,  3733,  3769,  3734,  3777,  3735,  4018,
     905,112628,  3871,  1511,  3768,  4001,   905, -5567,  3736, -5567,
    3737, -5567,  2296,  4111, -5567, 88298, -5567,   449,  1124,  3025,
   -5567,  3746, -5567, 65362, 88298, -5567, -5567, -5567, 34604,  3655,
    3657,  3660, 18878, 18878, 34604, -5567, -5567, 18878,  3668, -5567,
   -5567, -5567, -5567,112628, -5567, 88298,  3951, -5567, -5567,   971,
   88298, 88298, -5567, -5567, -5567, 88298, -5567, -5567, -5567,  3954,
   -5567,   534,   534, -5567, -5567,  3990,  7463,  3671,   330, -5567,
   60970, 50071,  2120,   160,  1527, -5567, 68290, 88298, 68290, -5567,
     175,  3878, 88298, 88298, 88298,  3672,  3661, -5567, -5567, -5567,
   -5567, 65362,   966, 65362,  2625, -5567, -5567,  3750, -5567, 88298,
    2188,  4179,  4015,  3358, -5567,  4140,  3219,  1524,  1780,   210,
    2835,  4077,  2475, 34604,   197, -5567, -5567,  1665, 88298,  3417,
   -5567, -5567, -5567, -5567,  1511, -5567,  3677,  3686, -5567, 88298,
    4034, 88298, 88298, 88298, 88298,  3457,  3695, 88298,  3697,112628,
   88298,  2253,  3023,  4168,  4055,  1893,  3428,  3783,  4059, 80002,
    3713,  2304, -5567, -5567,  1045, -5567,  2306,   156, -5567,  1511,
   68290,110732,  4044, -5567,   937,  7415, -5567, -5567,   937,   983,
   88298, -5567, -5567, -5567, -5567,  3924,  2236, -5567,  4031, -5567,
   -5567,  1893, -5567,112628,  3723, -5567,  2319, -5567, -5567, -5567,
     351,  3774,   905,  3776,   905, -5567, -5567, -5567, -5567, 88298,
   -5567, 88298, 63898, -5567, -5567, 88298, -5567,  4066, -5567, -5567,
    3852,  3859,  3861,  3863,  3866, 88298,  3419, -5567,  3729, 88298,
   88298, 65362,  1636, -5567, -5567, 65362,   361, -5567,   900, -5567,
   80002,  3844, -5567, -5567, -5567, -5567,  4078,  4080, -5567, -5567,
   -5567,  1303, -5567, 75122,   362, -5567, 65362,  4016,  4020,  4021,
    4022,   342,  4024,  4026,  4027,  4028,  4029, -5567, -5567, -5567,
    3743, 15564, 34604, -5567,  4094,112628, -5567,  7816, -5567, -5567,
   -5567, 34604, -5567, -5567,  3443,  4019,  3894, -5567, -5567,  3958,
    3960, 34604,  3894,  4198,   934, 34604, 34604, -5567, -5567,  3963,
    3967, 34604,  2119,  2119, -5567, -5567, -5567, -5567,  2322, 34604,
   -5567, 34604, -5567, -5567, 26075,  4250,  4250,  3747,112628, 40170,
   40170, 40170, 40170,   282,  2874, 40170, 40170, 40170, 40170, 40170,
   40170, 40170, 40170, 40170, 40170,   566, -5567,  3959, 34604, 34604,
   34098, -5567, -5567,112628,  3754,  3438,  3755,  3758, 34604, -5567,
   -5567, -5567,  2320, 41670,  3759, 60970, -5567, 34604, 13493,  2327,
    3803, 15617,  1665,  8483,  1511, 34604,  1440,  1950, 34604,  2329,
   34604, -5567, -5567, -5567, -5567,  4093, -5567, -5567, -5567, -5567,
   -5567, -5567,  3992,  2119, -5567,  3831,  3832, -5567, 34604,  3760,
    4937, 40170, 40170,  5373, -5567,  5783, 34604, 29033, -5567,  3546,
   -5567, 26587,  3761, 34604,109770, -5567, -5567,  1143,  1143,  1143,
    1143, -5567, 88298, 88298, 88298,  3823,  3766,  3823,   231,  3767,
   -5567, -5567, -5567, -5567,  1893, -5567,  3765, -5567, -5567, -5567,
   -5567, -5567, 85858, 86346, 85858,  3770, 42164, 27082,  1977,  3772,
   88298, -5567, -5567,  3771, 43152,  4063,  3977, -5567, 43152,  3977,
     965,  3977,  4064,  3872, 49574, -5567, -5567,  3779, -5567,  3988,
   -5567,  2047, 18878,  4234,  4107, -5567,  3782, -5567,  3526,   291,
   -5567, -5567, -5567,   880, -5567,  3877, -5567, -5567, -5567,  3490,
   36122,  3944, -5567, -5567, -5567,  3848,  2339, -5567, -5567,  4216,
    3944, -5567,  1945, -5567,  2346, 48586,  3549, 34604,  1665,  2348,
    2009, -5567, -5567,110258, -5567,  3869,  2800,  2800,  1974,  3419,
    4139,  1974,  8922, -5567, -5567, 44634, 88298, 88298, -5567, 88298,
   88298,  1699, 88298, -5567, 88298, -5567, -5567, -5567,  4270,  3867,
    3868,  4076, -5567,  2603, -5567, -5567, 65362, 88298, -5567, -5567,
   -5567,   461,  1162,  3025, -5567,  3887, -5567, -5567,  4104, 88298,
   -5567,  4261,  3903, 88298,  4171, 88298, 86834, -5567,  4240,  1699,
    3926,  4150,  1939,  3023,   359,  4292, -5567,  1652, -5567, -5567,
    3892, -5567, 88298, -5567, 88298, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567,  3955, -5567, -5567, -5567, -5567, 61458, -5567, -5567,
   88298, -5567, 60970, 50071, 60970, -5567, 88298, -5567,  1496,   498,
    1225,  3025, -5567,  3904, -5567,  4180,  3909,  3911,  3968,   190,
     902,  3915,  3916,  3972,  3833,  3834,  3835, -5567, 60970, 50578,
    3989, 88298,  2800,  3838,  3875, 88298,  3641, 87322, -5567,  3840,
   -5567, -5567,  3641,   247,  1511, -5567, -5567,  1511,  2800,  1511,
   88298, 88298, 88298, 88298,   247, -5567, -5567, -5567,  4287,  3936,
   88298, 88298, 88298, 88298, -5567,  3899, -5567, -5567, -5567, 88298,
   88298,  4189,   233,  2124, 65362, 88298, 88298, 65362, 88298, 88298,
   88298, 88298, 88298, 88298, 88298,  4065, -5567,  4280,  4205,  2263,
    4249,  3927, 88298, -5567, 88298,  1511, -5567,  3290, 88298, 88298,
   88298, 88298, -5567, -5567, -5567, -5567, -5567,  3546, -5567,  3851,
    4145,   971, -5567,  4148,  4149,  4151,   971, -5567, -5567,  1527,
   -5567,   492, 88298, -5567,  2299, 88298, -5567, -5567, -5567,  3782,
    2392,  2408, -5567, -5567, -5567, -5567, -5567, -5567,  3862, 88298,
   88298, 40170, -5567,   436,  1789,  1391, -5567,  4146, 88298,  3102,
   -5567, -5567, -5567,   235, 88298, -5567, -5567, -5567, -5567,  3870,
   -5567,    67,  3695, -5567,  4173, 72194,  2800, 65362, 65362,  2800,
   -5567,112628,  3873,  3417, -5567,   322,  3953, -5567, 65362,  1524,
  109282,  3200,  3907,  4090,  8960, 43152, 43646,  1611, -5567,  3874,
    3876, -5567, -5567, 88298,  3878, 63898,  2350,  2213,  4349,    87,
    2111, -5567, 73658,  4073,  3695,  4173, -5567,  3023,  4099,  4101,
   -5567,  1893, 88298,  3457,  3417,  1511, 88298,  3321, 50071, -5567,
    4391,  2238, -5567,110258, 34604, 34604, -5567,  3882, -5567,  3888,
    7415, -5567,  3965,  3889,  4353, 34604, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567,  3978,  3897, 88298, 88298,  1045, 88298,
   -5567,  3893,  3731, -5567,  3731, -5567, 88298, -5567, 88298, -5567,
     905, -5567,  4030,   905, 88298, 88298, 88298, 88298, 88298, 88298,
    3419,   342,  3418, -5567, -5567,  4233, 64386,  4235, -5567, 60970,
   -5567, -5567, -5567, -5567, -5567,  2361, 88298, -5567, -5567, -5567,
    4302,  4241,   905,   123,  1021,  1021,  1021,  1021,  4196,  1021,
    1021,  1021,  1021,  1021, -5567, 34604, 18878, -5567,  3905, -5567,
   18878, -5567,  4275,  3908,  4136,  4138, -5567,  3910, 34604,  3894,
   -5567, -5567,  4141,  4142, -5567,  3894,  3894,  3914,  9321, 16216,
   -5567,  2363, 34604, -5567,  1252,  1252,  1252,  3075,  4257, -5567,
    2627,  1252,  1252,  1252,   366,   366,   301,   301,   301,  4250,
     566, 17445, 18034, 18128,  3918, -5567, -5567, -5567,  3438, -5567,
   36628,    92,  4375, 41176, -5567, -5567, -5567,  3970,  3974,  3922,
   -5567, 34604, 37134,  3923,114524,  4137, -5567,  1782, 34604, 34604,
    2772, -5567,  9257, 34604, -5567, -5567,  4212,  4214,  2772,   470,
   34604,  2251,  2993, 34604, 34604,  5805,  9836,  3938, -5567,  2375,
   34604,  9964,  4135, -5567, 88298, 88298, 88298, 88298, -5567, -5567,
   -5567,  4107,  1511,  4107,  1511,  3940, -5567, -5567, -5567, -5567,
   61946,  3942,  3639, 85858,  3943, 88298,  1977, 43152, -5567, -5567,
    1594, -5567, 43152,  4236, -5567, 43152, 68778, -5567, 88298,  3945,
   88298, -5567,  1456, 34604,  3995, 53620, -5567, -5567, -5567, -5567,
    4035, -5567,  4176, 18878, 31568, -5567,  1893,  2006, 88298,  1665,
      64, -5567, 34604,  3964, 88298, -5567,  3944, 18878, -5567,  4036,
    2379, -5567, -5567, -5567, -5567, -5567, -5567, -5567,  4041, 74146,
    4297, -5567, 34604,  2386, -5567,  4004,  4397,   207,  2395,  2396,
    1699, -5567,  2401, -5567,  1860,  4272,   402, -5567,   905, -5567,
  112628, 88298, 88298, 88298,  2958, -5567, -5567, 88298, 88298, 88298,
   88298, -5567, -5567, 65362, 88298, -5567, 88298, -5567, -5567, -5567,
   87810, -5567,  3878,   247,   436,  4286,  4291,  4199, -5567,   342,
   -5567,   436,  4201,   247, -5567, -5567, -5567, -5567,  1585, -5567,
  112628,   905,   905, -5567, -5567, -5567, -5567, -5567,  3984, -5567,
    4432,  4074, 88298, 88298, 88298, 88298, 88298, 65362, 88298, 88298,
    2625,  2625,112628,  3979, -5567,  2625,  2625,  3980, -5567, 65362,
   88298, 88298, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567,  4067, -5567, 34604,  4426, -5567, -5567, -5567,
   -5567, -5567, 34604, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, 65362, 88298,  4068, -5567,  4072, -5567,   816,
   -5567, -5567, 88298, 88298, 88298, 88298,  4346, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,  4344, 88298,
   -5567, -5567,  1511,  1511,112628,   905,   905, -5567, -5567, -5567,
    4075, -5567, -5567,  3993,  4283,   971, -5567,   971,   971,   971,
   -5567,  3996, -5567,  1527,  4380, -5567,  1699,   307,  4332, -5567,
   34604, -5567,  1308,  3075, -5567,  4392,  4472, -5567, -5567, -5567,
   -5567,  3358,  2188,  3358, -5567, -5567, 68778,   398, -5567,  4315,
     217, 60970,  4224, 72194,  1819,  1806,  4002,  4143, -5567,  2800,
    2800,  4070, 88298,  4484, -5567, -5567, -5567, -5567, -5567, -5567,
   65362,  3647, -5567,  4246,   838,  4358, 88298, 43646, -5567,  3490,
   -5567, -5567, -5567,  1511, -5567, -5567,  4152,  3417, -5567,  1931,
   88298,  4243, 72194,  3457,  2410, -5567, -5567, -5567,  4060,  4476,
    3428, -5567,  1819,  4073, -5567, -5567,  4447,  4118,  4069,  4499,
   -5567,  4118,  4364,  4245,  4032, -5567,  3713, -5567, 88298, -5567,
   18878, 18878,  1511,114998,   937,112628,  4373, -5567, 18878, 88298,
     903,  4038,  4202, -5567,  4338,   905,  2416, -5567,   905,   905,
   -5567, 88298, -5567,  3419,  3419,  3419,  3419,  3419, -5567,  4254,
   -5567, -5567, -5567, -5567,  4329, -5567, 64386, -5567,   905, -5567,
   -5567, -5567, -5567, -5567, -5567,  1021, -5567, -5567, -5567, -5567,
   -5567, 18878, -5567, 88298, -5567, -5567, -5567, -5567, -5567,  3243,
    4042, -5567, -5567,  4043,  4045, -5567, -5567, 34604, -5567, 10339,
   40170,  4384, -5567, 34604, 34604, 34604, -5567,  4047,  2425,  2426,
   -5567, -5567,    92, -5567,  4375, -5567, -5567, -5567, 11141,  4105,
   18878,  4178,  4057,  1633,  2772,  2772,  9257, -5567, -5567,  2772,
   34604, 34604,  2772,  2772, 34604, -5567, -5567, -5567, 11399, -5567,
    4510,  3546, -5567, -5567, -5567, -5567,  3995, -5567,  3995, -5567,
    4204, -5567,  2427,  4536, 39158,  4496, -5567, 88298,  2431, -5567,
   34604,  4071, -5567, -5567, 43152,  1594,  4079,  2447, 88298,  2454,
  112628, 37640, 18878, 88298,  3546,  4081, -5567, 88298,  2906, -5567,
      50, -5567, -5567,  4489, 44634,  4452, 18273, 34604, -5567, -5567,
   -5567, -5567, 64386,  4295, 64386,  1699, 11752,  4383, 44634, 54634,
   88298, -5567, 88298, -5567,  4247,  4383,  4383, -5567, -5567, -5567,
   -5567, -5567, -5567,  4083, -5567, -5567, -5567, -5567,  4166, -5567,
   -5567,    39,  3406, -5567, -5567, -5567, -5567, -5567,  4556,  4444,
    4446, -5567, -5567, -5567, -5567, -5567,  4280, -5567, -5567, 50071,
   65362, 88298, -5567,  4174, -5567, -5567, -5567, -5567, -5567, -5567,
   46610, 53620, -5567,   190,  4091,  4092,   902, -5567, -5567, -5567,
   88298, 11923,  4095, 11996,    44,  3406, 88298, 88298,  4096,  4098,
    4100,  1786,  1327,  1849,  3419,  4435, 88298, -5567, -5567, -5567,
    4280, -5567, -5567, 88298, -5567,   971, -5567, -5567, -5567, -5567,
   60970, -5567,  2998,  3996,  1511, 68778,  4568,  4568, 12070,  4322,
   -5567, -5567,   372,  4163,  4361,  4163,  4103, 88298,   235,  4106,
    2458, -5567, 88298,  4108,  4238,  1746,  1746, 88298, 88298, 88298,
    2460,  1893,  2800,  3875,  1524,  4467, 72194,  4511,  3878,   311,
   -5567, 88298,  4586, 88298,  3457,  3695, 88298,  4119, -5567, -5567,
   73658,  4326,  2120, 88298,  2253,  4073,  3428,  1408, 88298, -5567,
     994, -5567,  1893, -5567, 88298, 80002, 44634,  4458, -5567,114050,
   -5567,  2462, -5567, -5567, -5567,  4207, 20798,  3282,  4253,  4255,
    4131,  2055,  4478, 88298,   917, -5567, -5567, -5567, -5567, -5567,
   -5567, 88298,   362, -5567, -5567, -5567, -5567, -5567, -5567, 18808,
   -5567,  3691, 40170, 18878, 18878, 18878, 34604, -5567, 34604, -5567,
   -5567, -5567, -5567,   108, -5567, -5567,  4448,  4144,  2772,  2772,
    2772, -5567, 34604,   879, -5567, -5567,  1747,  4541,  3517, 61946,
    4147, -5567, 40170,  2468, -5567,  2608, 88298,  2476, -5567, 18878,
   88298, -5567, -5567, 34604, -5567,  2480, -5567,  4154,    36,  4156,
   25051,  4153, -5567, -5567, -5567, -5567, -5567, 18878,  4157, -5567,
    4615,   930, -5567, -5567,  4200, 88298,  2482, -5567,   117,  1537,
    4193, -5567, 18878,  1636,  1974,   390,  4397,  4162,  3358, -5567,
    4165, -5567, -5567,  1517,  3023, 88298,  3358,  3358, -5567, 88298,
    4237, -5567,  2120,  4473, -5567, -5567,  4225, -5567,   695,  3406,
   88298,112628, -5567,   126,  4495, -5567,112628,112628, -5567, -5567,
   -5567, 34604, -5567,  4263, -5567, -5567, -5567, 34604, 34604, 71218,
   -5567, -5567, 88298, 88298, 88298, 88298, 88298, -5567,   905, -5567,
   -5567,  2503, -5567, 45622, -5567, -5567,  3207,  1511,  3207,  1638,
   -5567, -5567,  3207,  3207, -5567,  3282, -5567,  4568,   368, -5567,
   -5567,  4403,  4170, 34604,  4482, -5567,  1222,  4394, -5567,  4172,
   -5567, 68778,  4684, -5567, 60970,  3695,  4173, 88298, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
    2507,  3878,  4531,  3417,  4069, -5567, 88298,  4221, -5567, 43152,
    3878,  1893,  2111, -5567,  4073,  3695,  4173, -5567, -5567,  4184,
    4101,  3428,  2253,  4330, -5567,  4334, -5567,  4632,  4407,  4634,
    3457, -5567,  3321,  2515, 88298, -5567, -5567,  7415,114998,112628,
   -5567, -5567, -5567,  4192,  4574,  4242,  4248, -5567, -5567, -5567,
    2055, -5567,    95,  4570,  4251, -5567,  4256, 88298, -5567, -5567,
    3878,   905, 34604,  3691,  2516,  2521,  4259, -5567, -5567, -5567,
    3438, 38146, 38146, 38146,  4206,  4548,  4554, 88298, -5567, -5567,
   -5567, 88298,  3075,  4208, 39158, 60970,  2525, -5567,112154, -5567,
    2526,  2537, -5567, 34604,  4209, 34604, -5567, 37640, 88298,  4211,
    3281,  1893, -5567,  3282, 44634, -5567,  4342,  4698,  4481, -5567,
   -5567,  4564, -5567, -5567, 88298,  4163, 53620,  3526,  1517,  2188,
    4163,  4163, -5567, 88298,  4170, 34604, -5567,  4325, -5567, -5567,
    2557,  1550,  4399,  4399,  2558,  2563, 12121, 88298,  2569,  2588,
   -5567,  2622,  2625,  3425,  1849,  3425, -5567,  3419, -5567, -5567,
   60970, -5567, 64874, -5567, -5567, -5567,  1511, -5567,  1511,  4459,
   88298, 56100,  1511,  1511, -5567, -5567, -5567, -5567,  4542, -5567,
    2213, -5567, 12444,  4328, -5567, -5567, -5567,   510, -5567,  4454,
    4455, -5567,  4239, -5567,  2629, -5567,  1819,  4369,  3878, -5567,
   -5567, 88298,  4715,  4716, -5567,   854, 88298,  3490, -5567,  4069,
    3457,  3428,  1819,  4073,  2120, 45128,  4118,  2253,  4101, -5567,
   -5567,  4457, -5567,  4460, -5567,  4244,  4561, -5567,  2068,   937,
   -5567, -5567, -5567,  1012,  4588,  4589, -5567, -5567, -5567,  3207,
   -5567,  1426,  4258,  4613, -5567, -5567, -5567, -5567, 18878, -5567,
   -5567, -5567, 39664,  4400,  1287, 13599,  4618, -5567,  4618,  4618,
   -5567,  4710,  4711,  1136,  2634, 41176, -5567, -5567, -5567, 88298,
    4470,  1309,  4736,  4427,  2636, 37640,  2638, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, 48586, 34604,  4356,  4698, 64386,  2640,
    3641,  4266, -5567,  3526,  4361, -5567, -5567,  3406, -5567, 18878,
   88298, 68778,  4724, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
    3406,  4359, -5567, -5567, 71218, -5567, 88298, -5567, -5567,  2658,
   -5567, -5567, -5567, 88298,  4038, -5567,  4038, -5567, -5567, -5567,
    3642,  4382, 88298,  1078,  1078,  4664, -5567,  4340, -5567,  4276,
   -5567,  4786,  4411, 88298, -5567, -5567,   190,  1893, 72194,  3878,
   -5567, -5567,  2253,  4073,  3428, 34604,  2664, -5567,  4397,   207,
   -5567,  4101,  4118, -5567, -5567, 44634,  4282,  3102,  4658, -5567,
   -5567, -5567,  3144, 68778, 68778, 88298, -5567, -5567, -5567, 34604,
     235,  4764, -5567, -5567, -5567, -5567, -5567,   204, -5567, -5567,
   -5567, 88298, 88298, 88298, -5567,  3639, -5567, -5567, 40170, 40170,
    4516, -5567,  1309, -5567, 88298, -5567,  4289, -5567, -5567,  2671,
   -5567,    -3, 18878,   872,  4381,   390, -5567, -5567, -5567, -5567,
    4394,  1699,  1699, -5567,  3406, -5567, 88298, -5567,  4293, -5567,
   -5567, -5567, 64874,  4038, -5567, -5567, -5567, -5567,  4787, -5567,
    1277, -5567, -5567, -5567, -5567, 88298,  3878,  3979,  4069, -5567,
    4101,  3428,  2253, 12642, -5567, 45128, 88298, 88298,  4118, -5567,
    2676, 44634,  3417,  4445, -5567,  1967, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567,   882,  4296,  4299, -5567, -5567, 12733, 68778,
   38652,  4450, -5567,  4515, -5567,  1141,  1165,  1908,  4733,  3075,
    3075, -5567, -5567, -5567, 34604, -5567, -5567, -5567,  4540,  4437,
   -5567, -5567,   296, -5567,  1699, -5567, -5567, -5567, 34604, -5567,
   -5567,  2188,  2188,  3878, -5567, -5567,  4118,  2253,  4101,  4397,
   -5567, -5567, -5567, -5567,  4561, -5567,  2677,  4118,  4251,  2141,
   -5567, -5567,  2248,  2546,  4396,  4650, -5567,  4312, -5567, -5567,
   -5567, 88298, 88298, 62434, 88298, 88298, 12882, -5567, 48586,  4545,
     150, -5567,  1699,  2682, -5567, -5567, -5567, -5567,  4101,  4118,
   88298,  3102, -5567, 44634,  3282,  4675, -5567,  1967,  4434,  4436,
   60482, -5567, -5567,   287,  4712, -5567,  2686, -5567,  4318, -5567,
    4379,    50,  4324, 88298, -5567, -5567,  4118, -5567, -5567,  3417,
   -5567, -5567,   235, -5567,  4368,  4370, -5567,  2691, -5567, -5567,
   -5567, -5567, 34604, 62434, -5567, -5567,  4386, 34604,  2692, -5567,
    4118, 68778,  4663,  4665, -5567, 60482,   783,  4393,  4388,  2699,
     744,  3282,  4333, 68778, 68778, -5567,  4335, 88298, -5567, -5567,
      50, -5567, -5567, 60482, -5567, -5567,  1511, -5567,  4401,  2704,
    4388, -5567, -5567
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    1702,  1446,   654,  1534,  1533,  1446,     0,   269,     0,  1545,
       0,  1446,   430,  1104,     0,     0,     0,     0,   654,  1446,
       0,  1702,     0,     0,     0,     0,     0,  1715,     0,     0,
       0,     0,     0,  1244,     0,     0,     0,  1446,     0,     0,
    1722,     0,     0,     0,     0,  1715,     0,  1547,     0,     0,
       0,     0,  1722,     0,     0,     0,     0,     0,     2,     9,
      10,    45,    80,    81,    38,    37,    98,    63,    24,    71,
     133,   132,   134,    50,    46,    88,    33,    35,    47,    51,
      73,    75,    40,    53,    64,   110,    72,    31,    70,    76,
      96,    58,    19,    20,    59,    21,    60,    22,    61,   106,
      82,    99,    43,    69,    30,    52,    78,    79,    12,    54,
      86,    18,    65,    66,    68,    91,    92,    93,   116,    94,
     128,    49,   125,   103,   104,   122,   105,   123,    16,   107,
      62,    23,   119,   118,   120,    89,    55,    90,    77,    97,
     117,    34,   121,    25,    26,    28,    29,    27,    67,    36,
      74,    39,    95,   124,   114,   109,   129,   127,    11,   135,
     111,    83,    14,    15,   100,    13,    32,    57,    17,    42,
      41,    56,    48,   131,    44,  1545,   102,   115,   101,    84,
     108,    87,   112,   130,   113,    85,   126,  1666,  1665,  1726,
    1669,  1701,     0,  1681,  1445,  1444,  1459,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1456,  2366,  2383,  2384,  2385,  2386,  2387,
    2388,  2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,
    2399,  2398,  2400,  2401,  2753,  2402,  2403,  2404,  2698,  2699,
    2754,  2700,  2701,  2405,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,  2413,  2702,  2703,  2414,  2415,  2416,  2417,  2418,  2704,
    2755,  2419,  2420,  2421,  2422,  2423,  2424,  2756,  2425,  2426,
    2427,  2428,  2429,  2430,  2431,  2432,  2433,  2757,  2434,  2435,
    2436,  2758,  2437,  2438,  2439,  2440,  2441,  2442,  2705,  2706,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,  2707,  2471,
    2472,  2473,  2474,  2708,  2475,  2476,  2477,  2478,  2709,  2479,
    2480,  2481,  2482,  2759,  2760,  2483,  2484,  2485,  2486,  2487,
    2710,  2711,  2488,  2489,  2490,  2491,  2492,  2493,  2494,  2761,
    2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,
    2505,  2506,  2507,  2762,  2712,  2508,  2509,  2510,  2511,  2713,
    2714,  2715,  2512,  2763,  2764,  2513,  2765,  2514,  2716,  2717,
    2718,  2719,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2720,
    2766,  2522,  2767,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,  2542,  2543,  2721,  2768,  2722,  2544,  2545,  2546,
    2547,  2548,  2549,  2550,  2723,  2724,  2551,  2552,  2553,  2769,
    2554,  2725,  2555,  2726,  2556,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2727,  2770,  2566,  2771,  2728,  2567,
    2568,  2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,  2577,
    2578,  2729,  2579,  2730,  2582,  2580,  2581,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,  2590,  2591,  2592,  2731,  2593,  2594,
    2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,  2603,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2772,  2612,  2613,
    2614,  2615,  2616,  2732,  2617,  2618,  2619,  2620,  2621,  2622,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,
    2633,  2733,  2634,  2635,  2773,  2636,  2637,  2734,  2638,  2639,
    2640,  2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2649,
    2650,  2651,  2735,  2652,  2653,  2654,  2655,  2774,  2656,  2657,
    2658,  2659,  2660,  2661,  2736,  2737,  2662,  2663,  2738,  2664,
    2739,  2665,  2666,  2667,  2668,  2669,  2670,  2671,  2672,  2673,
    2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,  2682,  2740,
    2741,  2683,  2775,  2684,  2685,  2686,  2687,  2688,  2689,  2690,
    2691,  2692,  2693,  2694,  2742,  2743,  2744,  2745,  2746,  2747,
    2748,  2749,  2750,  2751,  2752,  2695,  2696,  2697,   146,     0,
       0,  2333,  2367,  2368,  2371,  2366,   402,   401,  1655,  2330,
    2367,  1544,     0,  1523,   654,     0,  1459,   429,  1702,     0,
       0,     0,     0,     0,     0,   870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   138,     0,
     140,     0,     0,   453,   452,     0,     0,  1076,   458,     0,
       0,     0,     0,     0,   644,  1586,  2580,  1584,  1656,   270,
     273,   274,   271,   272,  2349,     0,  1216,  1217,  1219,     0,
       0,  1229,   910,   911,     0,     0,     0,   924,     0,     0,
       0,   908,     0,     0,     0,   930,     0,   927,     0,     0,
     931,   928,   905,   929,   912,     0,   904,     0,     0,  1229,
     932,     0,     0,   906,     0,     0,     0,     0,  1459,  1583,
     459,  1702,     0,  1567,  1568,  1569,  1545,  1557,  1570,  1562,
    1564,  1563,  1565,  1566,  1561,  2348,  2385,  1000,  1000,  1000,
    1000,   997,   998,  1000,  1000,  1000,  2600,     0,     0,   979,
       0,   981,  2350,  1000,  1005,  2393,   534,   534,   534,     0,
    1004,  1009,   534,     0,  1427,  1468,  2332,  1714,     0,   980,
    1426,  2662,  1573,     0,     0,     0,     0,  2619,  1436,   254,
    2631,  2736,  2662,   253,   248,   249,   222,     0,     0,  1004,
     534,     0,  1459,  1434,   976,  1721,  1719,     0,  2317,  2412,
    2428,  2525,   245,  2612,  2621,  2631,  2736,  2662,  2694,   201,
     211,   206,     0,   263,  2631,  2736,  2662,   259,  1456,     0,
    1682,  1830,  1829,  2326,     0,  1429,  1428,  1546,     0,  1549,
       0,  2595,  1686,  1689,  1551,  1687,  2369,  1905,  1934,  1912,
    1934,  1934,  1901,  1901,  2458,  1914,  1902,  1903,  1939,     0,
    1934,  1901,  1906,     0,  1904,  1942,  1942,  1929,     3,  1886,
    1887,  1888,  1889,  1915,  1916,  1890,  1921,  1922,  1926,  1891,
    1956,  1901,  2370,  1723,  1724,  2317,     4,  2363,     5,  2279,
    2362,     6,     7,  1678,     0,     0,     1,  1702,     0,  1556,
    1718,  1718,     0,  1718,     0,  1670,  1678,  1673,  1677,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,   935,
       0,  1471,  1061,     0,     0,     0,     0,     0,  1313,     0,
    1113,  1112,  2372,  2355,  2356,  2357,     0,  2353,  2354,  2373,
    2374,  2375,     0,  2494,  1313,     0,     0,  2195,  2206,  2207,
    2208,  2416,  2475,  2203,  2204,  2205,  2197,  2198,  2199,  2200,
    2201,  2202,     0,     0,  1211,  2196,     0,  2494,     0,  1313,
       0,   173,     0,   150,  1313,     0,     0,  2494,     0,     0,
    2494,     0,     0,     0,     0,     0,  2494,     0,     0,     0,
       0,     0,   173,  2530,     0,   150,  2494,     0,     0,  1450,
       0,     0,     0,  1452,  1455,  1442,     0,  2276,     0,  2277,
    2334,  1538,     0,  1537,  1531,  1541,  1536,  1526,     0,  2326,
       0,     0,     0,     0,   918,     0,     0,   908,     0,     0,
       0,   919,     0,   920,   921,     0,     0,     0,     0,   917,
       0,  1440,  1432,     0,  1575,  1577,  1576,  1578,  1574,   534,
       0,     0,     0,  2494,     0,   150,  1510,     0,  2494,   150,
       0,     0,   457,   456,   150,  2353,   455,   454,  2416,  2475,
       0,  1103,     0,  1186,   150,  2494,     0,   194,  2494,   713,
    2494,  1551,   139,     0,   657,     0,   825,  2530,   150,     0,
       0,     0,     0,     0,     0,   142,     0,     0,     0,     0,
       0,     0,     0,   643,   654,  1587,  1585,     0,  1220,   247,
     246,  1218,   922,  2494,  1145,   145,     0,     0,  2494,  1491,
    2494,   145,   939,   923,     0,   909,  2494,   145,  1109,  2494,
    2358,   183,     0,   907,  2416,  2475,  2494,   145,  1213,     0,
    2494,   145,  2494,   179,  2494,   145,  2494,   145,  2494,   658,
       0,     0,  2494,   145,  2494,  2530,   181,   926,  2494,   145,
     933,  2494,   145,  2328,  2494,     0,  1443,     0,  1579,     0,
    1559,  2740,     0,  1702,  1000,   999,     0,  1000,     0,  1000,
       0,  1000,     0,  1000,     0,     0,     0,  1000,  2351,  2352,
     982,     0,  1006,     0,  1014,     0,  1013,  1012,  1011,     0,
       0,     0,  1015,     0,  1834,  1614,     0,  1424,  1439,     0,
       0,     0,   142,     0,  1242,  1239,   142,  1241,  1240,   142,
     142,  1435,   252,   250,     0,     0,     0,     0,     0,     0,
    1441,     0,  1433,     0,     0,     0,  2336,  2338,  2339,  2209,
    2279,     0,  2699,  2700,  2701,  2268,     0,  2702,  2703,  2704,
    2755,  2090,  2076,  2085,  2091,  2077,  2079,  2086,  2705,  2706,
    2025,  2707,  2708,  2346,  2709,  2710,  2711,  2713,  2714,  2715,
    2716,  2717,  2718,  2719,  2720,  2081,  2083,  2721,  2722,  2724,
       0,  2347,  2725,  2726,  2561,  2728,  2729,  2731,  2732,  2087,
    2734,  2735,  2088,  2736,  2737,  2738,  2739,  2345,   501,  2089,
    2741,  2743,  2744,  2745,  2746,  2748,  2749,  2750,  2751,     0,
       0,     0,  2323,     0,  2054,     0,  1894,  1895,  1917,  1918,
    1896,  1923,  1924,  1897,     0,  2322,  1959,  2154,  2053,  2071,
       0,  2059,  2060,     0,  2052,  2048,  2156,  1704,  2318,     0,
    2049,  2335,  2337,  2269,  1704,  2316,   214,   265,     0,   266,
    2324,  2631,   202,   244,   216,   243,   217,   215,     0,  2414,
     203,     0,     0,   204,     0,     0,     0,     0,   262,   260,
       0,  1431,     0,  1832,  1831,  2327,   944,     0,  1548,  1545,
    2219,     0,  1688,     0,     0,     0,  1933,  1920,  1928,  1927,
       0,  1910,  1909,  1908,     0,  1907,  1934,  1934,  1932,  1911,
    1886,     0,     0,     0,  1938,     0,  1936,  1882,  1878,     0,
    1945,  1946,  1947,  1944,  1957,  1943,     0,  1892,  1948,     0,
    1901,  1898,  1789,     0,  1668,  1667,     8,     0,  1553,  1555,
    1529,  1551,  1716,  1717,     0,     0,     0,     0,     0,     0,
       0,     0,  1776,  1734,  1735,  1737,  1773,  1777,  1785,     0,
    1674,     0,     0,     0,  1836,     0,     0,  1457,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,   936,     0,
       0,     0,  1477,     0,  1479,  1480,  1481,     0,     0,     0,
    1482,  1483,  1471,   256,  1490,  1487,  1470,  1472,  1485,     0,
       0,     0,     0,     0,     0,     0,  1502,     0,   187,   188,
       0,   670,   654,     0,  2494,     0,     0,     0,     0,  1154,
    1161,  1312,     0,     0,     0,     0,     0,     0,     0,     0,
    1155,  1153,     0,  1156,   258,  1166,  1193,  1196,     0,     0,
    1111,  1114,     0,     0,     0,     0,     0,  1303,     0,     0,
       0,  1303,     0,     0,     0,  1312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   281,   283,   296,   361,     0,
     635,     0,     0,     0,   638,     0,  2494,  1313,     0,     0,
       0,  1215,     0,     0,     0,     0,     0,     0,     0,     0,
    1196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     148,   149,   154,     0,     0,     0,     0,  1196,     0,     0,
       0,     0,     0,     0,     0,   619,   634,   622,     0,     0,
       0,     0,     0,   630,     0,     0,   150,   632,   286,   609,
     615,     0,     0,     0,   720,   719,     0,     0,     0,     0,
       0,     0,  1400,     0,  1399,     0,     0,     0,     0,     0,
    1500,  1499,     0,     0,     0,     0,     0,     0,  1303,     0,
     275,   277,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   394,   395,     0,
       0,     0,   154,     0,     0,  1303,     0,   288,     0,     0,
    1451,  1448,  1449,     0,  1454,     0,     0,     0,     0,  2062,
       0,  2223,  1726,  2221,  1129,  2275,     0,  2376,  2776,  2777,
    2778,  2779,  2780,  2781,  2782,  2783,  2784,  2785,  2786,  2787,
    2788,  2789,  2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,
    2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,  2806,  2807,
    2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,
    2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,
    2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,  2836,  2837,
    2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,
    2848,  2849,  2850,  2851,  2852,  2853,  2272,  2271,  2331,  2377,
    2378,  2379,  2380,  2278,     0,     0,   233,   234,   232,  1539,
     235,  1540,  1535,     0,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,  2416,  2475,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,  1471,  1509,     0,     0,     0,   663,     0,  2494,
       0,   152,   871,     0,   823,   458,     0,     0,     0,     0,
    1376,   152,     0,     0,   190,     0,     0,   717,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   824,     0,
       0,   152,     0,  2494,   612,  2494,     0,   534,   534,     0,
       0,   141,   138,     0,     0,     0,     0,     0,     0,     0,
       0,  1660,  1659,  1662,  1661,     0,  1658,     0,   143,   144,
       0,  1203,  1228,     0,     0,     0,     0,     0,   900,   925,
       0,     0,  1197,     0,     0,  2494,   145,  2494,     0,  2494,
       0,     0,     0,  1205,   145,     0,  1199,     0,     0,  1201,
       0,  1402,     0,   916,   914,   913,   915,     0,     0,   898,
       0,     0,     0,     0,     0,   893,     0,     0,   895,     0,
       0,     0,     0,  1702,  1558,     0,   990,     0,   994,     0,
     985,     0,   991,     0,   986,   983,   984,     0,   989,     0,
       0,   535,   537,     0,     0,  2440,  2457,     0,  2483,  2518,
    2519,  2571,  2586,  2615,  2621,  2627,     0,  2656,  2667,     0,
    1020,  1058,  1010,   729,     0,     0,  1624,  1425,  2228,     0,
    1702,     0,     0,  1243,     0,     0,   138,   251,   223,     0,
       0,  1058,     0,  2619,  1438,   975,   654,     0,  2050,     0,
    2057,  2058,  2267,     0,     0,     0,     0,     0,     0,  2056,
       0,     0,     0,  2289,     0,  2289,     0,     0,     0,     0,
       0,  1981,     0,     0,  2227,     0,     0,  2227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1982,  1963,  1964,  2054,  2219,     0,  2055,  2342,     0,  1956,
    2381,  2209,     0,  2206,  2207,  2208,  2854,  2855,  2856,  2857,
    2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,
    2868,  2869,  2870,     0,  2871,  2872,  2873,  2874,  2875,  2877,
    2876,  2878,  2879,  2880,  2881,  2882,  2883,  2282,  2885,  2886,
    2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2906,
    2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,
    2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,
    2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,
    2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,
    2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,
    2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,
    3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,  3026,
    3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,  3035,  3036,
    3037,  3038,  1996,  3039,  3040,  3041,  3042,  3043,  3044,  3045,
    3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,
    3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,  3065,
    3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,  3075,
    3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,
    3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,  3095,
    1998,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,
    3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,
    3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,
    3125,  3126,  3127,  3128,  3129,  3130,  3133,  3131,  3132,  3134,
    3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,  3144,
    3145,  3146,  3147,  3148,  3149,  3150,  3151,  3152,  3153,  3154,
    3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,  3164,
    3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,  3174,
    3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,  3184,
    3185,  3186,  3187,  3188,  3189,  3191,  3190,  3192,  3193,  3194,
    3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,
    3205,  3206,  3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,
    3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,  3223,  3224,
    3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,  3234,
    3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,  3243,  3244,
    3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,  3253,  3254,
    3255,  3256,  3257,  3258,  3259,  3260,  3261,  3262,  3263,  3264,
    3265,  3266,  3267,  3268,  3269,  3270,  3271,  3272,  3273,  3274,
    3275,  3276,  3277,  3278,  3279,  3280,  3281,  3282,  3283,  3284,
    3285,     0,  2203,  2204,  2205,  2197,  2198,  2199,  2200,  2201,
    2202,  2213,     0,     0,  2321,  2382,     0,  2156,     0,  1978,
       0,  2164,     0,     0,  1789,     0,  2340,  2270,  1789,   267,
     268,   264,     0,     0,   219,   218,     0,   237,   241,   242,
     213,   240,     0,   236,   221,  2140,  2139,   220,   212,   209,
     207,   224,   226,   227,   210,   208,   261,     0,     0,     0,
     145,  1556,  1543,     0,     0,  2282,     0,  2217,     0,     0,
    2215,     0,     0,     0,  1786,     0,  1690,     0,  1694,     0,
       0,     0,  1931,  1930,  1883,  1879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   937,
       0,  1899,     0,  1852,  2364,  2365,  2280,  1722,  1556,     0,
    1552,  1685,  1684,  1727,  1728,  1095,  1683,  1756,  1757,     0,
       0,     0,     0,  1782,  1780,  1747,  1738,  1746,     0,     0,
    1744,     0,  1748,  1959,  1775,  1672,  1732,  1733,  1736,  1671,
       0,  1778,     0,  1627,  1776,  1737,  1611,     0,  1589,     0,
       0,  1837,     0,     0,  1458,     0,     0,     0,  1124,  1126,
       0,  1125,     0,  1128,     0,  1137,     0,     0,  1123,  1142,
       0,  1131,  1129,     0,  1498,     0,     0,     0,     0,     0,
    1478,     0,     0,     0,  2656,   255,  1481,  1486,  1473,  1484,
       0,     0,     0,     0,     0,  1060,  1059,     0,     0,  1079,
       0,     0,   501,  1505,   523,     0,   363,     0,     0,     0,
       0,     0,     0,     0,     0,   819,   816,     0,     0,   815,
       0,   668,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   693,     0,  1303,     0,   294,     0,  1163,
       0,  1162,     0,  1167,     0,     0,  1164,  1159,  1160,  2621,
    2631,  2662,   257,  1165,  1195,     0,  1194,  1190,     0,  1106,
       0,  1107,     0,     0,     0,     0,     0,  2467,  2494,   302,
     325,     0,  1302,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   347,     0,
       0,   350,   349,     0,     0,     0,     0,     0,   355,     0,
     333,     0,   334,     0,   354,     0,     0,     0,   636,   637,
       0,     0,     0,  1303,     0,   290,     0,     0,     0,     0,
       0,     0,     0,     0,  1212,     0,   746,     0,     0,  2621,
    1191,     0,  1385,     0,  2655,  1386,  1389,   534,     0,   534,
    1391,     0,     0,  1388,  1390,     0,     0,   176,     0,   171,
     175,     0,     0,  2621,  1192,     0,     0,     0,     0,     0,
     617,   618,   633,     0,   623,   624,   620,   625,   626,     0,
       0,     0,     0,     0,     0,     0,   616,     0,     0,   715,
     714,   718,     0,     0,     0,     0,     0,     0,  1394,     0,
       0,  1186,     0,     0,  1393,  1401,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1246,  1245,     0,     0,
       0,     0,  1313,     0,   861,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   178,   733,     0,   732,     0,   172,
     177,     0,     0,     0,     0,     0,     0,     0,     0,   231,
    1447,  1453,  1726,  1726,  1726,  2068,     0,     0,     0,     0,
    1725,  2273,  2276,  1526,  1532,  1525,  1524,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   408,   405,   406,   408,     0,     0,
       0,     0,   835,     0,   838,   841,  1469,   485,     0,     0,
     660,   693,     0,     0,   461,   185,     0,     0,     0,     0,
     748,     0,  1186,  1185,   147,   138,   194,   459,     0,   193,
     195,   197,   198,   199,   196,   200,     0,   712,   716,     0,
       0,     0,     0,   656,     0,     0,     0,     0,     0,     0,
       0,  1857,     0,     0,   170,     0,     0,   607,   611,     0,
       0,     0,     0,   461,   573,   374,  2494,     0,   534,     0,
    2494,     0,   137,     0,   822,     0,     0,     0,  1148,  1148,
       0,     0,   762,   761,     0,     0,     0,     0,     0,     0,
    1657,   145,  1146,     0,  1492,     0,   145,   940,   145,  1110,
     184,  2359,     0,   902,     0,     0,     0,     0,   145,  1214,
     890,   145,   180,   145,   145,   659,     0,   145,   182,     0,
       0,   145,   934,   145,  2329,     0,   145,  1582,  2494,   534,
    1560,   987,   996,   995,   993,   992,   988,     0,  1007,     0,
     533,     0,     0,     0,     0,     0,  1028,  1029,     0,     0,
    1025,  1030,     0,  1032,  1016,  1018,  1026,  1027,  1033,  1022,
    1021,  1034,  1035,     0,     0,     0,  1047,   727,     0,     0,
       0,     0,  1621,     0,  1619,     0,  1835,  1623,  1612,  1572,
       0,  1571,     0,   600,  1237,  1236,  1238,     0,  1004,     0,
     145,     0,  1437,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2232,     0,  2233,     0,     0,  2266,
    2262,     0,     0,     0,     0,     0,  2236,  2239,  2240,  2241,
    2238,  2242,  2237,     0,     0,  2243,     0,     0,     0,  2054,
    2285,  2285,  2310,     0,  2309,  2315,  2223,  1959,     0,     0,
    2306,  2300,     0,  2306,     0,     0,     0,     0,     0,     0,
    2223,  2226,     0,     0,  2732,     0,     0,     0,     0,  2026,
       0,     0,  2190,     0,  2223,     0,     0,     0,     0,     0,
       0,     0,  2219,  2258,     0,   499,     0,  2016,     0,     0,
       0,  2138,     0,  2135,     0,     0,     0,     0,  2279,     0,
       0,  2343,  1960,  1974,  1975,  1976,  1979,  2320,     0,  2281,
       0,     0,  1961,  1987,     0,  2259,  2012,     0,  2017,  2002,
    2290,  2244,  2245,  2246,  2247,  2019,     0,  1995,  2000,  2004,
       0,  2299,  1983,     0,  1980,     0,  2282,  2218,     0,  2216,
       0,  1971,  1972,  1973,  1965,  1966,  1967,  1968,  1969,  1970,
    1977,  2194,  2192,  2193,     0,     0,  2164,     0,     0,  1999,
       0,     0,  2070,  2486,  2525,     0,  1715,  1715,  1715,  1703,
    1713,  2319,  1852,  1726,  1852,  2325,     0,     0,  1956,     0,
    1833,   942,   943,   941,  1528,  1542,  1556,  2220,  1550,  1692,
       0,     0,     0,  1900,  1913,     0,  1940,  1941,  1942,  1942,
       0,  1884,     0,  1925,  1950,  1951,  1952,  1953,  1954,  1955,
       0,  1949,  1893,   938,     0,  2617,  2752,     0,  1813,  1788,
    1790,  1800,  1813,  1820,  1813,  2072,  1850,  2073,  2074,  2326,
       0,  1759,  2361,  1530,  1554,     0,  1093,  1094,     0,  1098,
    2732,  2617,     0,     0,     0,     0,  1749,  1783,     0,  1774,
       0,  2336,  1750,  2335,  1751,  1754,  1755,  1745,  1784,  1625,
       0,  1779,  1676,  1675,     0,  1855,     0,     0,     0,  1603,
    1591,     0,     0,  1838,     0,  1789,  1629,     0,  2279,  1787,
    1352,  1247,  1314,  1127,     0,  1901,  1138,     0,  1122,     0,
    1121,  1901,     0,  1139,     0,  1901,  1353,  1248,  1315,  1354,
    1249,  1316,  1355,  1489,  1250,  1488,  1476,  1475,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   800,  2494,   145,  1503,  1356,     0,  1251,
     362,  1504,  1317,  1508,   818,   817,     0,     0,  1318,     0,
     669,   674,     0,   676,   677,  2416,  2475,   678,   681,   682,
       0,   684,   673,   672,     0,     0,     0,     0,     0,   690,
     695,     0,     0,     0,     0,     0,     0,  1157,  1158,  1357,
    1254,     0,  1319,     0,  1105,     0,  1255,   186,     0,     0,
     282,  2494,   304,     0,   483,   800,     0,  1305,   301,   331,
       0,   346,   341,   342,   340,  2494,   145,  2494,   145,     0,
       0,     0,     0,     0,   343,   338,   339,   335,     0,     0,
     348,  2388,  2459,  2632,     0,   701,   703,     0,   708,   351,
    1275,   370,   369,   368,     0,   356,     0,   375,   378,     0,
     353,   332,   330,   327,   297,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1207,     0,  1360,  1320,
       0,  1342,     0,     0,     0,     0,   740,  1363,  1261,  1323,
       0,   534,     0,     0,   549,   549,   534,  1374,  1262,   174,
    1292,   163,     0,     0,   159,     0,     0,     0,     0,   153,
    1364,  1263,  1324,     0,     0,  1365,  1264,     0,     0,   287,
     610,   621,   627,  1269,   631,   628,  1332,   629,  1372,  1265,
       0,  1368,  1295,  1327,   593,  1186,  1186,  1375,  1395,  1266,
    1186,     0,  1303,     0,   276,   278,     0,   142,     0,  1267,
       0,  1325,  1367,  1294,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1511,     0,     0,     0,     0,     0,     0,
     145,     0,     0,     0,  1305,  2494,   145,  1366,     0,  1300,
       0,  1340,     0,     0,   396,     0,  1293,  1303,     0,   289,
    1271,     0,  1334,     0,     0,   229,   228,   230,     0,     0,
       0,     0,  2224,  2225,     0,  2222,  2063,  2275,     0,  1522,
     964,   950,   963,     0,   946,  2457,     0,   949,   951,     0,
       0,     0,   952,   956,   957,     0,   948,   945,   947,     0,
     407,     0,     0,   757,   758,     0,     0,     0,     0,   837,
       0,     0,  1501,     0,   150,   667,     0,     0,     0,   662,
     692,   697,     0,     0,     0,     0,   460,   464,   468,   469,
     470,     0,     0,     0,     0,   164,   151,     0,   879,     0,
     534,     0,   750,  1186,  1378,     0,   194,   189,     0,     0,
     713,     0,  1551,     0,     0,   588,   591,   590,     0,   374,
     832,   830,   829,   831,   853,   828,     0,  1856,  1858,     0,
       0,     0,     0,     0,     0,   600,   463,     0,     0,   537,
       0,   576,     0,     0,     0,     0,   573,     0,     0,     0,
    2369,     0,   849,   821,     0,  1116,     0,  1134,  1117,     0,
       0,     0,     0,  1171,  1178,  1147,  1172,  1149,  1178,     0,
       0,   763,   767,   766,   770,   768,     0,   764,   641,  1663,
    1664,     0,  1204,     0,     0,  1497,     0,  1495,   901,  1198,
     145,     0,   145,     0,   145,  1206,  1200,  1202,  1403,     0,
     899,     0,     0,   892,   894,     0,   896,     0,  1008,   536,
       0,     0,     0,     0,     0,     0,  1024,   639,  1031,     0,
       0,     0,  1046,  1041,  1043,     0,  1058,  1052,     0,   726,
       0,     0,  1622,  1615,  1617,  1616,     0,     0,  1613,  2229,
     891,     0,   606,     0,  1058,  1049,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1720,  2230,  2231,
       0,     0,     0,  2263,     0,     0,  2107,     0,  2078,  2080,
    2093,     0,  2108,  2061,  2285,     0,  2289,  2283,  2127,     0,
       0,     0,  2289,     0,  2309,     0,     0,  2122,  2124,     0,
       0,     0,  2299,  2299,  2109,  2082,  2084,  2094,     0,     0,
    2210,     0,  2097,  2096,     0,  2028,  2029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2043,  2098,  2189,     0,     0,
       0,  2100,  2099,     0,     0,  2257,     0,     0,     0,  2105,
     500,  2110,     0,     0,     0,     0,  2116,     0,  2146,     0,
       0,     0,  2051,  2220,     0,     0,     0,     0,     0,     0,
       0,  2292,  2293,  2294,  2291,     0,  2018,  2003,  2021,  1997,
    2001,  2005,     0,  2299,  2020,     0,     0,  2023,     0,     0,
    1991,     0,     0,  1989,  2013,  1985,     0,     0,  2014,     0,
    2069,     0,     0,     0,  2167,  2162,  2163,  1715,  1715,  1715,
    1715,  1712,     0,     0,     0,  1759,     0,  1759,   205,     0,
     238,   225,  1527,  1693,  1702,  1919,     0,  1937,  1935,  1880,
    1885,  1958,  1813,  1820,  1813,     0,     0,  1678,     0,  1800,
       0,  1812,  1798,  1811,     0,     0,  1826,  1824,     0,  1826,
       0,  1826,     0,  1792,     0,  1816,  1794,  1811,  1796,     0,
    1842,  2327,  1851,     0,  1772,  1729,     0,  2211,  1098,     0,
    1731,  1753,  1752,     0,  1742,     0,  1781,  1739,  1626,  1610,
       0,  1608,  1595,  1597,  1596,     0,     0,  1598,  2279,     0,
    1608,  1590,     0,  1634,     0,     0,  1855,     0,  1633,     0,
    1901,  1119,  1120,     0,  1143,     0,  1063,  1064,     0,  1062,
       0,     0,     0,   522,  1078,     0,     0,     0,   800,     0,
       0,   526,     0,  1506,     0,  1373,  1291,   671,     0,     0,
       0,     0,   686,   645,   687,   689,     0,     0,   688,   691,
     694,  1303,     0,   295,  1277,     0,  1338,  1151,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,   482,   479,   326,
       0,     0,     0,     0,   383,     0,   306,   318,   381,   324,
       0,   358,     0,   329,     0,   322,   344,   336,   345,   337,
     357,   359,     0,   705,   706,   704,   700,     0,   707,   709,
       0,   372,     0,     0,     0,   352,     0,  1359,     0,  1303,
       0,   291,  1273,     0,  1336,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
       0,     0,   745,     0,   742,     0,   549,     0,  1387,     0,
    1384,  1382,   549,     0,     0,   156,   155,     0,   162,     0,
       0,     0,     0,     0,     0,  1396,  1397,  1398,     0,     0,
       0,     0,     0,     0,   390,     0,   298,   300,   299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   397,   365,     0,   856,
       0,     0,     0,   399,     0,     0,  1351,     0,     0,     0,
       0,     0,  1358,  1256,  2066,  2067,  2064,  1726,  2274,     0,
       0,     0,   961,     0,     0,     0,     0,   410,   411,   150,
     409,   432,     0,   800,     0,     0,   834,   839,   847,  2561,
    2197,  2198,   845,   840,   842,   844,   846,   843,     0,     0,
       0,     0,   504,     0,     0,     0,   491,     0,     0,   501,
     484,   487,   488,     0,     0,   663,   666,   664,   665,     0,
     685,     0,   463,   511,   563,     0,   166,     0,     0,   167,
     165,     0,     0,   374,   747,     0,   744,  1377,     0,   192,
       0,   717,     0,     0,     0,     0,     0,  1186,   655,     0,
     852,   854,   826,     0,   697,     0,     0,   612,     0,   534,
    1583,   595,     0,   565,   463,   563,   572,     0,     0,   580,
     373,     0,     0,   600,   374,     0,     0,  1079,     0,   848,
       0,     0,  1115,     0,     0,     0,  1168,  1173,  1169,     0,
    1148,  1130,     0,  1170,     0,     0,  1176,  1101,  1150,  1102,
    1419,  1420,  1417,  1418,     0,     0,     0,     0,     0,     0,
    1654,     0,     0,  1493,     0,   903,     0,   886,     0,   888,
     145,   734,     0,   145,     0,     0,     0,     0,     0,     0,
    1023,     0,  1017,  1019,  1044,     0,     0,  1058,  1057,     0,
    1048,  1056,  1054,  1055,  1053,     0,     0,  1620,  1618,   598,
       0,     0,   145,  1058,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2234,     0,  2265,  2261,     0,  2075,
    2235,  2288,  2287,     0,     0,     0,  2311,     0,     0,  2289,
    2303,  2302,     0,     0,  2301,  2289,  2289,     0,     0,     0,
    2190,     0,     0,  2027,  2039,  2040,  2041,  2250,     0,  2046,
       0,  2036,  2037,  2038,  2030,  2031,  2032,  2033,  2034,  2035,
    2042,  2254,  2253,     0,     0,  2102,  2103,  2104,  2256,  2111,
       0,  2406,  2147,     0,  2115,  2137,  2136,     0,     0,     0,
    2118,     0,     0,  2133,     0,  2191,  2344,  1962,     0,     0,
    1988,  2260,  2006,     0,  2022,  2024,  2296,  2298,  1984,  2210,
       0,     0,     0,     0,     0,  1993,     0,     0,  2187,     0,
       0,     0,  2169,  2166,     0,     0,     0,     0,  1706,  1705,
    1711,  1772,  2063,  1772,     0,     0,  1881,  1799,  1795,  1797,
       0,  2747,     0,  1802,  1809,     0,  1791,     0,  1825,  1821,
       0,  1822,     0,     0,  1823,     0,     0,  1793,     0,  1809,
       0,  1849,  1718,     0,  2158,     0,  1730,  1096,  1097,  1740,
       0,  1743,  2436,  1853,     0,  1609,     0,     0,     0,  1600,
    1606,  1588,     0,     0,     0,  1630,  1608,  1631,  1140,     0,
       0,  1132,  1069,  1070,  1073,  1071,  1068,  1072,     0,     0,
       0,   800,     0,     0,   544,     0,  1092,  1092,     0,     0,
     528,   585,     0,   803,     0,     0,     0,   801,   145,  1252,
       0,     0,     0,     0,   646,  1371,  1253,     0,     0,     0,
       0,  1152,  1306,     0,     0,  1276,     0,   303,   481,   480,
       0,   478,   697,     0,     0,   309,   319,     0,   314,     0,
    1304,     0,     0,     0,   313,   316,   315,   385,     0,   382,
       0,   145,   145,   360,   702,   371,   376,   377,   380,  1311,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   880,   863,     0,     0,   881,   882,     0,
       0,     0,  1209,  1210,  1208,  1343,  1344,  1349,  1346,  1345,
    1348,  1350,  1347,     0,  1259,     0,     0,   738,  1307,  1379,
    1381,  1380,     0,  1383,   160,   157,   158,   161,  1308,  1289,
    1270,  1333,   594,     0,     0,     0,  1268,     0,  1326,     0,
    1285,  1279,     0,     0,     0,     0,     0,  1370,  1299,  1331,
    1369,  1297,  1329,  1296,  1328,  1298,  1330,  1290,     0,     0,
    1860,   860,     0,     0,     0,   145,   145,   859,   736,  1272,
       0,  1335,  1281,     0,     0,     0,   953,     0,     0,     0,
     955,   415,   433,   150,     0,   756,   820,     0,     0,   836,
       0,   489,     0,   495,   502,     0,     0,   506,   507,   505,
     490,  1186,   534,  1186,   789,   790,     0,     0,   810,     0,
     661,     0,     0,   461,     0,   508,     0,     0,   465,   169,
     168,     0,     0,     0,   751,   755,   753,   752,   754,   749,
       0,   740,   194,  2494,     0,     0,     0,     0,   592,   586,
     589,  1392,   827,     0,  1859,   730,     0,   374,   608,     0,
       0,     0,   461,   600,     0,   466,   471,   472,   485,     0,
     573,   564,     0,   565,   574,   575,     0,   582,  1467,     0,
     601,   582,     0,     0,     0,   851,     0,   850,     0,  1118,
    1135,  1136,     0,     0,  1178,     0,     0,  1180,  1175,     0,
       0,   769,   772,   765,   648,   145,     0,  1496,   145,   145,
    1235,     0,   897,  1038,  1039,  1040,  1037,  1036,   640,     0,
    1042,  1001,  1051,   728,     0,   599,     0,  1002,   145,   978,
     970,   977,   966,   969,   971,     0,   973,   974,   968,   965,
     967,  2264,  2092,     0,  2284,  2126,  2308,  2307,  2125,  2314,
       0,  2305,  2304,     0,     0,  2095,  2106,     0,  2189,  2220,
       0,     0,  2047,     0,     0,     0,  2101,  2742,     0,     0,
    2151,  2152,     0,  2148,  2149,  2144,  2145,  2117,     0,  2550,
    2128,     0,     0,  2143,  2010,  2008,  2007,  2295,  2297,  1992,
       0,     0,  1990,  1986,     0,  2015,  2153,  2186,  2220,  2155,
       0,  1726,  1710,  1709,  1708,  1707,  2158,  2341,  2158,   239,
    1697,  1845,     0,  1848,     0,     0,  1801,     0,     0,  1803,
       0,     0,  1805,  1807,     0,     0,     0,     0,     0,     0,
    2330,     0,  1771,     0,  1726,     0,  1741,     0,  1607,  1592,
       0,  1593,  1599,     0,     0,     0,     0,     0,  1635,  1628,
    1133,  1141,     0,     0,     0,   524,     0,   539,     0,     0,
       0,  1085,   140,  1084,     0,   539,   539,   805,   804,   807,
     802,   806,  1507,     0,   679,   680,   683,  1278,     0,  1339,
    1287,     0,  1624,   305,   477,   476,   485,   312,     0,     0,
       0,   307,   384,   386,   308,   311,   365,   328,   321,     0,
       0,     0,  1274,     0,  1337,  1283,  1310,  1361,  1257,  1321,
       0,     0,   869,     0,     0,     0,     0,  1362,  1258,  1322,
       0,     0,     0,     0,     0,  1624,     0,     0,     0,     0,
       0,     0,     0,     0,  1516,     0,     0,   364,   858,   857,
     365,   398,  1301,     0,  2065,     0,   954,   959,   960,   958,
       0,   404,   412,   415,     0,     0,  1226,  1226,     0,     0,
     486,   503,     0,   584,   543,   584,     0,     0,     0,     0,
       0,   698,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   743,   742,   191,     0,   461,     0,   697,     0,
     855,     0,     0,     0,   600,   463,     0,     0,  1580,   462,
       0,     0,   474,     0,   576,   565,   573,     0,     0,   597,
       0,  1460,     0,   603,     0,     0,     0,   799,  1174,     0,
    1188,     0,  1129,  1099,  1183,     0,  1702,  1852,     0,     0,
       0,     0,   782,     0,   652,  1227,  1494,   887,   889,   735,
    1045,     0,  1058,  1050,   972,  2286,  2313,  2123,  2312,  2249,
    2191,  2044,     0,  2252,  2251,  2255,     0,  2112,     0,  2113,
    2150,  2119,  2129,     0,  2120,  2141,     0,     0,  2011,  2009,
    1994,  2188,     0,  2173,  1680,  1679,     0,  1700,  1850,     0,
       0,  1844,     0,     0,  1874,     0,     0,     0,  1810,  1828,
       0,  1806,  1804,     0,  1817,     0,  1819,  2435,  2711,  2614,
       0,  1758,  1760,  1763,  1765,  1764,  1766,  1762,  2157,  2159,
       0,  1737,  2212,  1854,     0,     0,     0,  1080,     0,     0,
    1636,  1637,  1632,  1046,     0,   145,  1092,     0,  1186,   545,
    2561,   546,  1091,  1095,   139,     0,  1186,  1186,   675,     0,
       0,   284,   473,     0,   310,   320,   367,   379,     0,  1624,
       0,     0,   867,   876,   876,   864,     0,     0,   883,  1260,
     739,     0,   548,     0,   279,  1286,  1280,     0,     0,     0,
    1518,  1519,     0,     0,     0,     0,     0,  1309,   145,  1282,
     962,     0,   435,   442,   416,   420,  1510,     0,  1510,     0,
     417,   421,  1510,  1510,   414,  1852,   431,  1226,     0,  1223,
    1222,   532,   614,     0,     0,   493,     0,   554,   492,     0,
     811,     0,     0,   696,     0,   463,   563,     0,   521,   512,
     513,   514,   515,   517,   516,   518,   519,   520,   510,   509,
       0,   697,   873,   374,  1467,   737,     0,     0,   710,     0,
     697,     0,  1583,   596,   565,   463,   563,   467,   485,     0,
     580,   573,   576,     0,   577,     0,   581,     0,     0,     0,
     600,  1520,  1079,     0,     0,   800,  1187,  1148,     0,     0,
    1177,  1181,  1182,     0,     0,     0,     0,  1230,   776,   777,
     771,   773,     0,   784,   788,   647,     0,     0,   651,   642,
     697,   145,     0,  2045,     0,     0,  2131,  2130,  2142,  2121,
    2168,     0,     0,     0,     0,     0,     0,     0,  1691,  1843,
    1846,     0,  1877,     0,     0,     0,     0,  1863,     0,  1808,
       0,     0,  1818,     0,     0,     0,  1767,     0,     0,     0,
    1776,     0,  1605,  1852,     0,  1602,     0,  1645,     0,  1638,
    1065,     0,  1066,  1086,     0,   584,     0,  1098,  1095,   534,
     584,   584,  1288,     0,   614,     0,   323,     0,   292,  1284,
       0,     0,   878,   878,     0,     0,     0,     0,     0,     0,
     392,     0,     0,  1512,     0,  1513,  1514,  1517,   400,   413,
       0,   440,     0,   438,   437,   439,     0,   428,     0,     0,
       0,     0,     0,     0,   403,  1221,  1225,  1224,     0,   494,
       0,   496,     0,     0,   540,   541,   542,     0,   498,   550,
     551,   808,     0,   813,     0,   699,     0,     0,   697,   562,
     721,     0,     0,     0,  1461,     0,     0,   587,   731,  1467,
     600,   573,     0,   565,   475,     0,   582,   576,   580,   578,
     579,     0,  1464,     0,   602,     0,  1088,   798,     0,  1178,
    1189,  1184,  1179,  1423,     0,     0,   774,   779,   778,  1510,
     783,     0,     0,     0,   650,   649,   725,  1003,  2248,  2134,
    2114,  2132,  2698,  2436,  2670,     0,  2185,  2174,  2185,  2185,
    2165,     0,     0,     0,     0,     0,  1875,  1876,  1861,     0,
       0,  1865,  1815,  1841,     0,     0,     0,  1761,  2160,  2161,
    2360,  1594,  1604,  1081,     0,     0,     0,  1645,     0,     0,
     549,     0,  1082,  1098,   543,   800,   800,  1624,   317,   366,
       0,     0,     0,   874,   877,   865,   866,   885,   884,   741,
    1624,     0,   388,   387,     0,   391,     0,   436,   445,     0,
     443,   418,   423,     0,   427,   425,   424,   419,   422,   531,
       0,     0,     0,     0,     0,     0,   552,     0,   553,     0,
     812,     0,     0,     0,   723,   872,     0,     0,   461,   697,
    1462,  1581,   576,   565,   573,     0,     0,   567,  1092,  1092,
     448,   580,   582,  1465,  1466,     0,     0,   501,     0,  1100,
    1422,  1421,  1702,     0,     0,     0,   785,   786,   781,     0,
       0,     0,  2178,  2177,  2176,  2180,  2179,     0,  2172,  2170,
    2171,     0,     0,     0,  1847,     0,  1864,  1867,     0,     0,
       0,  1873,  1866,  1868,     0,  1827,     0,  1839,  1769,     0,
    1768,  1852,  1644,     0,     0,   145,   538,   800,   547,  1083,
     554,   527,   525,   285,  1624,   868,     0,   280,     0,   393,
    1515,   441,     0,   426,   613,   497,   583,   559,     0,   558,
       0,   556,   555,   809,   814,     0,   697,   862,  1467,   711,
     580,   573,   576,     0,   566,     0,   140,   140,   582,   446,
       0,     0,   374,     0,  1405,  1702,  1404,  1406,  1414,  1411,
    1413,  1412,  1410,     0,  1233,  1234,   775,   780,     0,     0,
       0,     0,  2182,     0,  2183,     0,     0,     0,     0,  1870,
    1871,  1872,  1869,  1814,     0,  1770,  1601,  1647,     0,     0,
    1639,  1640,     0,  1067,   529,   800,   293,   875,     0,   444,
     557,   534,   534,   697,   722,  1463,   582,   576,   580,  1092,
     568,   570,   569,   450,  1088,  1089,     0,   582,   788,     0,
    1415,  1409,  1678,  1665,     0,     0,   787,     0,  2175,  2181,
    2184,     0,     0,     0,     0,     0,     0,  1642,     0,     0,
       0,  1641,   530,     0,   561,   560,   724,   449,   580,   582,
     140,   501,  1087,     0,  1852,     0,  1407,  1702,     0,     0,
     793,  1696,  1695,     0,     0,  1699,     0,  1840,  1646,  1643,
       0,     0,     0,     0,  1648,   389,   582,   447,   571,   374,
    1090,  1074,     0,  1408,     0,     0,   795,     0,   791,   794,
     796,   797,     0,     0,  1862,  1652,     0,     0,     0,   451,
     582,     0,     0,     0,   759,     0,  1726,     0,     0,     0,
       0,  1852,     0,     0,     0,   792,     0,     0,  1649,  1653,
       0,  1650,  1075,   793,  1231,  1232,     0,  1698,     0,     0,
       0,   760,  1651
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5567, -5567, -5567,  3948,  -539, -1724, -5035, -1125,  -619, -5567,
   -5567,  -959, -1379,  3183, -1684, -5567, -5567, -5567,  1402, -5567,
   -5567, -5567, -5567,  3913, -5567, -2888, -5567, -5567,   151,  3856,
   -1376,   131,  3475,  1502, -5567, -1000, -5567, -5567,  -637,     1,
   -5567,  3881,   559, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
   -5567,  -759,  1951, -5567,  2043,  1295, -3132, -5567, -5567, -1505,
   -3753, -5567,   562, -5567,   590, -4809, -1026, -5567, -5567, -5567,
    1936, -5567, -5567, -5567,  1883,  1089,  -441, -5567, -5567, -5567,
   -5567, -5567, -5567,  -867, -5567, -5567, -1137,     7,  -651, -2924,
   -4286, -5567, -5567,   411,  -482, -1491, -5567,   606, -5567,   607,
   -5567, -4826, -5567,   -79, -2650, -3092, -5567, -5567, -5567,  -452,
   -1456,  1389, -5567,  -744, -1162,  1758, -2512,  -979, -5567,  -322,
   -3533, -1102,  -871,  -869, -1012, -4325, -4844, -5567, -5567, -1134,
   -3740, -5131, -5389, -4857, -4730,  1403, -5567,  -103,   419, -5567,
       9, -3637, -3681,    13,   394, -5567,    14,    15, -5567,   410,
    -806,  -957, -1577, -5567,  -784, -5567, -5567, -5567, -3440, -5567,
   -5567, -5567,   165, -5567, -5567, -5567, -5567,   454, -5567, -5567,
   -5567, -5567, -5567, -5567, -2496,  1909,  1910, -5567, -4357, -5567,
    -930, -5567,   615, -3472,  1321, -5567, -5567,  1084,  3929,   434,
   -5567, -5567, -5567, -5567, -5567, -5567, -1786, -5567, -5567, -5567,
   -5567,   -85,  -426, -5567, -5567, -5567, -5567, -5567, -5567, -5567,
      16, -5567,  1046,   373, -5567, -5567,  -718, -5567, -5567, -5567,
   -5567, -5567, -5567, -1185, -5135, -1289, -1270, -5567, -3465, -5567,
   -5567, -5567,  -401, -5567, -5567, -5567, -5567, -5567,  -958, -5567,
    1137, -4126, -5567, -5567,   409, -5567, -5567, -5567, -5567, -5567,
    -996,  -341,  3093, -5567,  -578,  -790, -5567, -5567, -5567,  -339,
   -5567, -5567, -5567, -5567, -5567,  -515, -1246,  4920,  4298, -1093,
   12871,  -826,  -583, -5567, -5567, -5567, -2717, -5567, -5567, -4259,
   -5567,  4911,  2411,   683,    19, -5567,   -16,   100,  3738, -5567,
    1001, -1160, -3091,   365,  -540, -5567, -5567, -5567,   367, -5567,
   -1955, -5567, -5567, -5567, -5567, -4080,    21, -5567, -4365, -5164,
   -4562, -4083, -1159, -5567, -4314, -4372, -4048, -5567,  1934, -5567,
   -5567,  -547,  -188,  3058, -5567, -1465,  2275, -1399, -5567, -2585,
     430,  1481,  3074, -3267,  -127,  3061, -2984, -5567,  -698,  1074,
   -5567,  -430, -3756, -5567, -5567, -5567, -2792,  -668, -5567, -5567,
    1556, -1119, -5567, -5567, -5567, -5567,  -623,  3040,  -181, -5567,
   -5567,  4267, -5567, -4932, -5567,  4252, -5567, -5567, -5567, -5567,
   -5567, -5567, -5567, -5567, -5567, -1470,  1240, -5567,  -830, -5567,
   -5567,  2034,   639, -5567, -5567, -5567, -5567,  1325, -1238, -5567,
   -5567, -5567, -5567, -5567, -5567, -5567,  -983, -1175, -5567, -5567,
   -5566, -5567, -5567, -5567, -5567, -5567,  2247,  -954,  -740,  4155,
    -241,    22, -5296, -5567, -5567, -1066, -5567,  3477, -5567, -5567,
   -5567, -5567, -5567,   424,   423, -5567, -5567, -5567, -5567, -4440,
   -5567, -5567, -4997, -5567, -5567,  2020, -5567, -5567,  1175,     6,
    3192, -5567, -5567, -5567,   -25, -5567, -5567, -1013,  2365, -5567,
   -2381, -5567,  -584, -5567, -5567, -1901,    23, -4336, -5567,     4,
   -5567, -5567, -5038, -1178,   232, -5567, -5567, -3991,    10, -5567,
   -5567, -5567, -5567, -5039, -5567,    12, -4900,   786, -3309, -5567,
       8, -5567,  -492,  -875, -5567, -5567, -5567, -3805,    28,    35,
   -5567, -5567,     5,   369,   -45,   -35,   -28,     3,   135,  3604,
   -5567, -5567, -5567, -4445,  3644, -5567,    48,  -860,  4955,  4959,
   -5567,  -882,  -150,   384,  1589,  -697, -2583,  3553,  3558, -5567,
    1570,  2376, -2444, -2437, -5567, -1299,  -847,  -678, -5567, -5567,
   -5567, -5567, -1788,  -695, -2590, -5567,  3562, -5567, -5567, -5567,
   -2356, -3349, -3254,  1617, -3272, -3197, -5567,   873,   860, -1181,
    -168,    52, -1476,  -781,  1584, -5567, -5567,  1628,  -416, -5567,
   -5567,  -410, -3270,   823, -5567, -4557, -2805,  1639, -1095,  -813,
   -5567,  -945, -5567,  -636,   356,  3645,  -819, -5567, -5567,  -795,
   13313, -5567, -5567, -5567, 14283, 14998, -5567, -5567, 15533, 15926,
   -5567,  -634, 16495, 12824,  -797, -1934,   -59, 18147, -1898,   599,
      -4, -5567, -2837, -2134, -5567, -5567, -5567,  -374,   974,   544,
   -5567, -5567, -4576, -4417, -5567,  2517, -2087, -5567,  -642,  1712,
    -639, -5567, -5567, -5567, -2851, -5459, -2970,  2523, -5567, -5567,
   -5567,  -194, -5567, 18485, -3250, -5567,  -375,  -980, -1590,  3005,
   -3155, -1906, -5567, -5567, -5567, -3100, -5567, -5567, -5567,  -630,
    1735, -5567, -5567,  1855, -5567, -5567, -5567,  -951,  2094,  -741,
   -1179,  1742, -1890, -3025, -5567, -1908,  1753, -2299, -5567, -1925,
    1827,  1057, -5567, -1014, -5567,  4167,  -770,  2530,  -783, 16800,
    -602, 11339, -1278, -5567,   299, -4418,  7499,  6087,    20,  -122,
     874,  -553,  2450,  2844, -5567, -5567,  5550,  8073,  -581,  -943,
   -5567,    -6, 13595, 11953, -3658, -5567
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    57,    58,    59,    60,  1086,  1091,  1882,  1901,    61,
      62,  1602,  3005,  2859,  3815,  3816,    63,    64,  1598,    65,
      66,    67,    68,  1512,    69,  1854,  3019,    70,  2695,   830,
     831,   832,  2560,  2561,  2950,  2562,  2550,  1364,  1800,  1534,
     804,   805,  1494,  1535,    72,    73,  1358,  2541,    74,    75,
      76,  1565,  1661,  1566,  1567,  1506,  4930,  5716,  3605,  2814,
    3863,  3606,  3607,  4277,  4278,  4366,  5730,  5731,    77,  1677,
    1678,    78,    79,  2987,  3781,  4419,  5311,  5312,  5554,   649,
    4953,  4954,  5541,  5542,  5744,  5899,  5900,  3020,   680,  3858,
    4503,  3806,  5024,  3807,  5025,  3808,  5026,  4821,  4822,  4267,
    4268,  3792,  4450,  4451,  2051,  4966,  4452,  3809,  4985,  5588,
    3810,  2714,  5759,  3054,  1973,  1971,  5488,  5567,  4783,  4784,
    4340,  5768,  5769,  5770,  6021,  4987,  5030,  5031,  5936,  5937,
    3861,  4509,  5037,  5369,  5565,  3503,    81,  3834,  3835,    82,
     743,  1876,  3962,   744,  3057,   681,   745,  3021,    87,  3047,
    5761,  3048,  1630,  2873,  4432,  3938,    88,  1114,  4242,  5394,
    5648,  5649,   734,    89,  1862,    90,    91,  3000,  3799,    92,
    2731,  3520,    93,    94,  3539,  3540,  3541,    95,  4460,  5330,
    1568,  3594,  3595,  3596,  3597,  4298,    96,  1857,  3028,  3029,
      97,    98,    99,  3159,  3160,   100,  2936,   101,   102,   103,
     104,  4334,  4887,  5001,  3636,  3822,  4476,  4999,   105,  3785,
    3022,  3075,  3896,  3897,  5392,  5640,  5641,  5642,  5819,  6056,
    5644,  5821,  5958,  5823,  4976,  6177,  6178,  5625,  4231,  4797,
     107,  4977,  4978,  5774,   108,  2729,   109,   110,  1831,  2993,
    2994,  4433,  3064,  3871,  3872,  4489,  4490,   111,  3723,   112,
    4863,  4864,   682,  5782,  5722,  5885,   113,   114,  4867,  4868,
     115,   116,   117,   118,   119,   735,  1048,  1049,   737,  1169,
    1170,  3475,  1131,   120,  2570,   121,  3761,   122,  1244,  5090,
     123,   769,  1185,  1186,  3023,   125,   779,  3178,   781,  3143,
    3144,  1989,  3942,  3943,  4577,   126,   127,  3946,  3947,  4584,
    3156,   128,  1499,  2705,  2706,  4778,  3024,   683,  3498,  5476,
    5221,  5477,  5947,  6106,  5222,  3419,  4180,   130,   684,  1540,
    2770,  1137,  1138,  3068,  3876,  2675,  2676,  1700,  4530,  2678,
    3878,  2679,  1473,  2680,  1124,  1125,  3884,  3885,  3886,  3887,
    4526,  4536,  4537,  5386,  5633,  4533,  1850,  5380,  5381,   131,
    1537,  2767,   132,   133,   134,  1581,   972,  1147,  1148,   135,
     696,   697,   136,  5559,   137,  1127,   138,  5390,   139,   140,
    1229,  1230,   796,   141,   142,  2784,  4280,   143,  1538,   144,
     145,  3630,  3631,  4879,   146,   147,   148,  2845,  2846,   149,
     150,   151,   152,   153,  6046,  6109,  6110,  6111,  4544,  5952,
     154,  1217,   155,   156,   157,   158,   196,  1013,  1014,  1015,
     925,  3025,  5371,   160,   161,  1495,  1496,  1497,  1498,  2700,
     162,   163,   164,  3906,  3907,   165,   166,   167,   168,  1834,
     169,   170,  5532,   171,   172,  1804,   173,   174,  1022,  1023,
    1024,  1025,  1802,  3366,   643,   849,  1389,  1395,  1438,  1439,
    1440,   176,   747,   177,  1220,  1053,   748,  1178,   179,   749,
    2657,  3449,  4195,  4196,  4197,  4200,  5205,  4755,   750,  3445,
     182,  1996,  3165,  3168,  3441,   751,  3455,  3456,  3457,  4204,
     752,  5480,  5481,  5866,  6080,  6081,  6131,  6164,   753,   771,
    1117,  3079,   754,  1324,   188,   189,   190,   905,   852,   853,
    3371,  5437,  5668,   192,  2534,  3349,   788,  1444,   893,   894,
     895,   914,  2960,  2623,  2624,  2648,  2649,  1453,  1454,  2636,
    2640,  2641,  3432,  3425,  2629,  4174,  5461,  5462,  5463,  5464,
    5465,  5466,  4744,  2644,  2645,  1456,  1457,  1458,  2653,   193,
    2613,  3399,  3400,  3401,  4151,  4152,  5985,  4166,  4162,  4729,
    5182,  3402,   841,  1215,  1465,  4737,  5987,  3403,  5171,  5172,
    5441,  4170,  3411,  4191,  3846,  3847,  3848,  3404,  5676,  5677,
    5982,  5983,  5443,  5444,  2681,  1418,   879,  1325,   880,  1431,
    1326,  1405,   882,  1327,  1328,  1329,   885,  1330,  1331,  1332,
     888,  1397,  1333,  1334,  1414,  1427,  1428,  1390,  5445,  1336,
    1337,  1338,  3406,  1339,  4673,  5142,  5128,  3272,  3273,  2557,
    5427,  4669,  4064,  4663,  2527,  2531,  5194,  5468,  5469,  3342,
    4115,  4702,  5161,  5664,  5836,  5837,  5968,  1340,  1341,  1342,
    3334,  2521,   975,  1343,  4435,  2523,  3263,  3241,  1703,  3242,
    1999,  2021,  3197,  3213,  3214,  3310,  3243,  3251,  3256,  3264,
    3296,  1344,  3199,  3200,  3984,  2023,  1345,  1019,  1706,  1020,
    1433,  3291,  3222,  3996,  5104,  3223,  3311,  4097,  3230,  3231,
    4012,  4002,  3224,  1346,  4004,  1354,  1355,  1348,  1990,   842,
    5178,  1173,  1787,   785,  1349,  1350,  1351,  1352,  1574,   946,
    1140,  1141,   896,   898,   899,  2617,   639,   631,   948,  3598,
    2524,   640,   633,   634,  1792,  2525
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     632,    71,   628,   191,   180,   186,   175,    80,   184,    83,
     181,   904,   183,    84,    85,    86,   106,   974,   938,   124,
     808,   129,   159,   178,   191,  1799,   979,   746,   185,   984,
     973,  1629,  1206,  1207,  1208,  1459,  1702,  1359,  1212,   915,
    1080,  1970,   773,   637,  2713,   892,  1682,  1347,   773,  1916,
     688,  1445,  2886,  1447,  1410,  2779,  3180,  2808,  1118,  1634,
    1694,  1026,  3502,  1386,  3442,  1430,  1212,  1401,  1402,  1793,
     926,  2018,  3443,  2677,  2771,  1788,  1409,  2010,  1859,  1416,
    3805,  2791,  4125,  3042,  4127,  3888,  4488,  1373,  3964,  1179,
    2780,  3468,  3470,   844,   982,  4189,   840,  2002,  4248,  3171,
    4269,  2004,  1385,  1478,  2005,  2006,  1832,  2954,  1004,  3688,
    1837,  3233,  4341,  3196,  1120,  1841,  2847,  2847,  3720,  4293,
    2847,  4295,  1844,   780,  1569,  1851,  4514,  3229,  3827,  1047,
    4746,  4165,  4539,  4437,  1172,  3281,   809,  5015,  1868,  1871,
    2677,  4780,  4785,  4148,  3225,  4203,  5175,  3248,  1163,  1591,
     909,  2609,  5044,  2762,  1608,  3109,   917,  1180,  3061,  2916,
    2917,  1026,  5474,   918,  5023,  1153,   803,   232,  4178,  1151,
    1905,  1573,  1155,   837,  4501,  5334,  4984,  4847,  3352,  1166,
    5033,  5187,  3354,  5189,  5373,   855,  1366,  5493,  2912,  5366,
    3364,   632,   829,  5571,  3836,  3434,  3997,  4209,  4202,  1541,
     632,   949,  5362,  5501,  3437,  4163,  4092,  4168,   632,  4761,
     949,   632,  5623,  2762,  1026,  2943,  4498,  1452,  5032,  1455,
    3824,  5796, -2369,  5365,   949,  5223,  1398,  1399, -1934,  1628,
    2762, -2369, -2369,  5610, -2478, -1942,  1408,  3413,  1660, -2520,
    1536,  1801,  1120, -2545,   694,  5133,  5524, -2370,  1687, -2583,
   -1901, -1914,  3764,  1867,  3767,  3768, -2370, -2370,   755,  3772,
    3773,  3774, -2758,  3776,  3777,  3778,  2742,  1026,   647,  6160,
   -1939, -2758, -2758,   755,  2923,  4524, -1929,   997,   694,  4081,
    3795,  1536,  3176,   694, -2333,  5220,  1536,  3745,  1385,   924,
    1500,  1898,   694,   694,  5721,  5534,  5535,  2072,  5784, -2334,
    2782,  1107,  2707,  3039,  3154,   629,  6061,  2568,   919, -1942,
   -2402,  2792,  1420,  4453,  4028,  1824,  3289, -2482,  1994,  3289,
    1848,   755,  2547,  2532,  1570,   694, -2195,  1026,   755,  2574,
     755,  2614,  1238, -2195,  1898,   694,  5092,  5093,  5094,  1187,
    5096,  5097,  5098,  5099,  5100,  3999,  1191,  1570,  4244,  2782,
    3966,  4994,  1009,   755,  2782,  2850,  4009,  1363,  2854,  5203,
    2910,  3534,  2576,  2612,  -150,  4009,  4860,  1239,  3051,   187,
    -150,  4485,  2847,  5961,  3331,  3952,   694,  5020,  3003,  4028,
    2709,  3332,   912,  4982,  5656,  5560,  6048,  6062,  1421,  3472,
     187,  3796,  5045,  1691,  3052,  1898,  1467,   920,  5695,  2715,
    2710,  4913,  1898,  5021,  1501,  1052,  2832,   878,   761,  5942,
    5756,  4974, -2543,   761,  1898,  1898,  4638,   761,  4639,  1694,
    5502,  2782,  5684,   761,  5500,   903,  2697,  2716,  2620,  5523,
    1846,  6129,   762,  5327,  1793,  5130,  2757,   762,  2548,  3387,
    1829,   762,   921,  3634,  1120,  1898,  4995,   762,  2719,  3547,
    1881,  3535,  3008,  1898,  1010,  1849,  4747,  2072,  1422,  6161,
    1582,  1423,  5817,  4193,  3410,  5246,  3714,  2799,  4964,   974,
    5718,  2840,  3014,  1401,  1402,  1391,  1406,  1407,  3407,  6048,
    6063,  5798,  2616,  5315,   761,  5599,  1788,  4861,  2864,  2574,
     644,   761,  3044,  5930,  3040,  4965,   927,  1176,  1409, -2214,
    4194,  3715,  3643,  2800,  4425,   939, -2214,  1416,   762,  6130,
    5818,  1011,  1908,   939,  4205,   762,   939,  5316,  1912,   974,
    3635,  5611,  2576,  5230,   847,  2928,  4748,  4367,  1923,  2782,
    1508,  4082,  1926,  2758,  1583,  4996,  1929,   868,  1931,  1074,
     694,  2782,  3154,  3154,  1939,  1084,  3548,  2833,  5131,  2032,
    1945,  5328,  6038,  1948,  2072,  1424,  1914,  1098,  2711,  2782,
     916,  1914,  4640,  5562,  5757,  2549,  5696,  4975,  2569,  1012,
    4360,  1242,  1692,  3009,  1424,  3004,  1502,  5204,  2782,  4028,
    4983,  6048,  1205,  2066,  1899,  4914,  2574,  2551,  2717,  3797,
    1793,  3053,  2563,  2563,  4862,  5568,  1924,  5657,  2958,  1954,
    5022,  6118,  3473,   695,  1468,  3474,  2015,  6162,  2809,  4000,
    3012,  3953,  2537,  4083,  2889,  1503,  3982,  4245,  -434,  2576,
    4010,  2533,  1849,  1398,  1399,  5755,  4454,  1899,  6064,  4010,
    3538,  5455,  2793,   922,  5913,  2611,   949,  1995,  2853,  1580,
    1914,  6096,  1112,  3746,  1509,  4437,  2794,  2942,  2795,   689,
    1504,   191,  1054,  1058,  1408,   949,  1057,  1991,  1055,  4525,
    1056,   949,  1120,  6163,  2881, -2543,  5941,  2884,  2001,  1249,
    3041,  4882,  4028,   949,  2712,  1211,  4029,  4030,  4031,  3798,
    1375,  1241,  1396,  2924,  3290,  2011,  1425,  4101,  1899,   949,
    2904,  2905, -2195,  1211,   632,  1899,  2911,   904,  4084,   892,
    4997,  3543,  2809,   632,   949,  2891,  4205,  1899,  1899,  6139,
     632,  2796,   949,   632,  4486,  2952,  2953,  5420,  1017,  1505,
    4993,  1183,  1018,  1411,  1412,   892,   949,   648,  1830, -2369,
    1995,  2545,  6095,  2749,  2809, -1934,   949,  5896,  1899,  2951,
    3333, -2543,  1413,  2756,   191,  1900,  1899,  2826,  1693,  6166,
   -2478,   767,   768, -2543, -2370, -2520,  2747,  1400,  1404, -2545,
    5791,  5041,  2654,  4790,  2655, -2583,  2996,  1460,  3619, -2758,
    3192,  4998,  2592,  2593,  3381,  5209,  1184, -1939,  1189,  1830,
    1193,  6040,  5794, -1929,  2720,  2068,  1197,  1120,  1907,   949,
    2535, -2333,  2587,  2520,  2870,  1120,  1120,  1411,  1412,  3357,
    6182,  6030,  1951,  4889,  1017,  1200, -2334,  3127,  1018,  4893,
    4043,   632,   632,  3161,   767,   768,  1415,   949,  2825,  2615,
    2959,   767,   768,  1571,  1572,  6059, -2402,  1017,  4486,  1600,
    2871,  1018,  5040, -2482,  2874,  2875,  5404,  2810,  6003,  2766,
    1214,  4001,   949,  1830,   632,   974,  1571,  1572,  1811,  1911,
    3111,  6007,  1816,  1601,  1817,  5231,  1922,  4032,  1815,  2809,
    4437,  4011,   848,  -150,  -150, -2214,  3514,   892,  1944,  1947,
     917,  4165,  4040,  4041,  4042,  4043,  4398,   918,  4579,  4576,
    4033,  4271,  4211,  3137,  4212,  5563,  1482,  2995,  4807,   632,
    1510,  3013,  2766,  4355,  4356,  3152,  1214,  3407,  4357,  1914,
    4726,  6098,   949,  1806,  4730,  2929,  4361,  4576,    71,  2766,
     191,   180,   186,   175,    80,   184,    83,   181,  4627,   183,
      84,    85,    86,   106,  5703,  4852,   124,  4498,   129,   159,
     178,  2810,  1493,  1376,  2930,   185,  4417,  4418,  4479,  5940,
     690,  3198,  3162,  4952,  3154,  4717,  4770,  4719,  2065,  5934,
    2517,  2518,  2519,  2520,  1511,  3999,  4034,  2883,  4956,  5914,
    3601,  2834,  2809,  2810,  5991,  6086,  6138,  5922,  1898,  4611,
     936,  3611,  1362,  1483,  1464,  5870,  1370,   694, -1754,  3434,
    5875,  5876,  4955,  5933,  3954,  4132,  1392,  4183,  4534,  1515,
    5288,  5598,  1666,  2985,   910,  4272,  6077,  2741,  3138,   927,
     691,  6101,  6102,  2811,  1070, -1755,   919,  6078,   939,  1377,
     632,   632,  1789,   815,  5289,   939,  3602,   187,   939,   949,
     694,  1235,  1134,  3384,   632,  2590,  1484,   694,  2973,   892,
     632,  4477,  2812,  1863,   632,  1667,   632,  6191,  2809,   692,
     892,   693,  5950,  3651,  4249,  2515,  2516,  2517,  2518,  2519,
    2520,  2913,  4412,  6210,   645,  3228,   892,  2813,  5617,  1202,
    4581,  1132,   911,  1072,  5661,  1073,  5618,  2616,  1508,  5604,
    4038,  4039,  4040,  4041,  4042,  4043,  1864,  5388,  4865,  4880,
    5717,   947,  3439,  2944,   912,  6039,  3497,  1132,  2810,  6031,
     983,  2663,  1448,  3385,  1933,   920,  1106,  2811,  2807,  4206,
     632,  2627,   632,   632,  1005,  6168,  5746,  4540,  5748,  5064,
     187,   903,  5752,  5753,  5844,  1793,  2809,  3579,   816,  2707,
     783,  5707,  3603,  6186,   803,  1652,  2812,  2809,  3051,  2811,
    3652,  3783,  1485,  5507,  3055,  4785,  5009,  1934,  2708,  1671,
    4156,  6017,   795,   949,  5020,  1672,   912,  2809, -1079,  4467,
    3287,  2813, -1754,  4184,  3052,  1558,   194,  3163,  2812,  1107,
    4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  3892,
    5021,   632,  6218,  1450,  4157,  3659,  4749,  2721,  3164, -1755,
    3580,  6103,  1509,  2813,  3653,  2809,   191,  3515,  3612,  4732,
    3440,  2810,  2807,  5646,  2696,  4024,  4541,  2709,  4582,  4866,
     195,  6162,  3149,  3150,   949,  4159,  4434,  2628,  3545,  1424,
    4273,  4274,  1914,   892,  1026,   949,  5662,  2710,  1668,  4000,
    3955,  1956,  1451,  1958,  2807,  1960,  5951,  1962,  6158,  1964,
    1965,  1966,   949,  3155,  5780,  3206,  1968,   949,   694,  6137,
    5619,  4275,  1203,  5788,  1108,  3654,  2986,  5663,  2809,   632,
    6144,  5777, -2330,  1673,  2811,  3659,  3760,  5805,  3893,  1865,
    3407,  1899,  1249,  3407,  5352,  4028,  5790,  2810,  3139, -2885,
   -2885, -2885,  3651,   937,   916,  3544,   187,  3467,   904,  1890,
    1914,  5793,  6167,  2812,   632,  3562,  5290,  1592,   913,  5776,
    5364,  3825,  3604,  5826,  4535,  3811,  4531,  3093,  5383,  4345,
    3748,  1490, -1901,  1491,  4249,  3100,  5089,  1071,  2813,  6189,
    3407,  3621,  5978,   632,   632,   632,  5215,   632,  3407,  5792,
    1935,  6079,  2066,  3086,  1669,  1135,  4161,  4185,  4468,   927,
    5389,   922,  3393,  6201,  4583,   939,  5873,   632,  2722,   939,
   -2884,   939,  5358,  3784,  3113,  2810,  3207,  4025,  4026,  2807,
    4750,  5346,  4045,  3620,  6018,  3107,  2810,  2811,  3655,  3652,
    3090,  4542,   949,  3088,  2572,  1866,  3854,  5928,  3755,  3120,
     949,   949,  5647,  3136,  3102,  2711,  2810,  3141,  3101,  5955,
    4438,  3103,  3148,  3289, -1901,  3151,  2812,  3108,  4786,  2762,
     974,  1810,  4076,  4077,   632,  2931,  6091,  5764,  3265,  6068,
    1109,  1593,  1819,  2050,  5701,  1883,  2903,  1885,  1886,  2621,
    2622,  2813,  2626,  3653,  2810,  4589,   918,   918,  1827,   918,
    3239,  5924,  3208,  1789,  4130,  1674,  1936,  4441,  5979,  1597,
    2723,  3140,  4543,  2811,  6019,  3146,  3147,  1110, -2884,  3534,
     632,  1188,  1190,  1192,   632,   632,  1194,  1195,  1196,  3337,
    1249,  5176,  2807,  4028,  5963,  5208,  1201,  4029,  4030,  4031,
     632,  3072,  2812,  6020,  1675,  4353,   892,  3812,  1017,  1420,
    1224,  2886,  1018,  5179,  3654,  4678,  4363,  2810,  5183,  3534,
    3894,  5185,  3656,  2876,  3073,  1442,  4443,  2813,  1210, -2884,
    3657,  2712,  3209,  3658,  3895,  3210,  4400,  2630,  1111,  1676,
    1112,  3191, -2884,   660,  1113,  4319,  2725,  6053, -2884,  5331,
     194,  2811,  4969,  1464, -2884,  1464,  2726,   694,  2701,   811,
   -2884,  5973,  2811, -2884,  3172,  3704,  6121, -2884,  2807,  3535,
    2702,  3705,  5613,   892,  4809,  1075,  2932,  5765,  2956,  2957,
    2812,  1075,  2811,  2631,  3266,  1421,  5054,  5614,  2703,  4034,
    6122,  2812,   187,  1075,   195,  3353,  3416, -2884,   787, -2884,
    1225,  3131,  6092,  3489,  3536,  2813, -1901,  3501,  1891,  3535,
     662,  2812,  6029,  1594,   892,  1998,  2813,  3446,  1211,  4590,
    2811, -2353,  1892, -2884,  1830,  -173,  1793,  3655,  5319,  5980,
    1443,    40,  -692,  4446,  5981,  3338,  2813,  4854,  3408,  1493,
    6053,  4437,  3877,  3537,  1493,  2632,  2807,   892,  3211,  2812,
    5964,  5863,  1595,  5766,  1914,  1422,  -173,  2807,  1423,  4320,
    2020,   194,  3017,  1613,  6036,  6037,  5612,  3157,    44,  2877,
    3956,  3813, -2884,  2878,  2813, -2884,  4447,  2807,  1893,  3706,
    2029, -2884,  3193,  2811,  3195,  1614,  3417,  1596,  3074,  3836,
    3202,  3490,  4448,  3129,  1376,  2633,  3216,  3217,  3129,  5872,
    1009,  4033,  3234,   793,  2677,   195,  -459,  1788,  2677,  6094,
      48,  3253,  2812,  5603,   949,  2807,  4970,  3268,   794,  5533,
    1493,  3814,  3129,    49,  1493,  2727,  1009,  3501,  5014,   632,
     632,   632,  2063,  4155,  4946,  5011,  1615,  2813, -2884,  4950,
    3487,  1600,  6053,  3581,  3018,  6154,  2907,    50,  3538,  1448,
    2704,  3656,  3957,  4625,  4626,  1449,  2634,  3132,  4434,  3657,
    3212,  3158,  3658,  3089,  2728,  1601,    56,   974,   974,  1226,
    1377,  1424,  5248,  5615,  1448,  2630,  6136,  4034,  2807,  5253,
    1894,  3099,  1235,   673,  4878,   674,   641,  4261,  3538,  4227,
    3133,  3290,  4449, -2885, -2885, -2885,  4038,  4039,  4040,  4041,
    4042,  4043,  1010,  4831,  3134,  6197,  3582,  3447, -1901,  4156,
    1227,  1845,  1228,  3082,  1521,  5578, -1901,  4358,  1400, -1901,
    1429,  2631, -1901, -2884,  3710,  6140,  1616,  -459,  1010,   949,
    1450,  4321,  5697,  5956,  4685,  2072,  3733,  5530,   642,  4973,
    3135,   892,  1672,  4157,  1895,  5665,  4850, -2884,   814, -2884,
   -2884,  3707,   892,   916,   916,  1450,   916,  5698,  4158,  1011,
    4793,  5531,  4262,  3711,  1789,  5999,  5957,  2539,   892,  5579,
    4322, -2884,  5580,   838,  4159,  5425,    40,  1617,  5581,  1451,
    5783,  1099,  1618,  1425,  1947,  1011,  1619,   949,  3718,   974,
    3708,  5882,  4359,  1410, -2884,   949, -2884, -2884,  3712,   850,
    2576,  2885,  4160,   949,  3608,  4323,  5582,  1955,  1426,  3438,
    1957,  5797,  1959,    44,  1961,  5666,  1963,  1012,  1100,   957,
    1967,  4851,   892,  5173,  2895,  3709,   958,   959,   960,  5180,
    3632,   632, -1725,  2633,   632,  1621,   761,   892, -1725,  2540,
     892,   892,  1896,  1012,   632,   632,  4794,   949,   949,  5426,
    1673,  4967,  3670,  2896,  1101,    48,  3488,  1182,  5749,   632,
     762,   949,   632,  5750,  5583,  5883,  1469,  1479,    49,   641,
    5451,   892,   892,  4434,   949,   949,  2830,  5584,  4364,  5804,
    1623,  4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,
    5585,  3363,    50,  5645,  2634,  4161,   191,  5335,  6105,  1372,
    1249,  3713,  1102,  4028,  1624,  1470,  1480,  4029,  4030,  4031,
    1223,  3448,   632, -1725,  5751,  4795,   632,   632,    40,  4796,
     906,   908,  5227,  4968,  1626,  4679,  1830,  4365,  3220,  3632,
    3121,  4580,  3122,  3177,  3123,  5402,  3124,  1600,  3125,  3910,
    1471,  1481,  3126,   191,  1054,  1058,  5336,  4274,  1057,  4592,
    1055,   632,  1056,   632,   923,    44,  3560,  3408,   632,   632,
    3407,  1601, -1725,  1387,  3407,   632,   632,   632,   632,   632,
     632,   632,  1627,  1076,   632,  1077,   632,  4838,   632,   632,
     632,   632,   632,   632,  4155,  5181,   632,  3166,   632,   632,
    2643,  5932,   632,  5949,  5228,  3793,  3316,    48,  2716,  5333,
    6170,  2787,  1610,  2788,  2072,  2677,   892,   632,   632,   632,
    3749,  3750,  3751,   993,  4604,  2677,  4155,  3840,  3841,  3842,
    3843,  1849,  3845,  1437,  5353,   632,  4624,  1789,  4613,  3671,
    4260,  3407,  3719,  2886,  4617,  4825,  2574,  3674,  5357,  4072,
    3677,  1611,  5775,  3644,   994,  3645,  4575,  3873,  3646,  5931,
    3669,  4616,  3181,    56,  5344,  4620,  4621,  5634,  2555,  1120,
    4156,  5483,  1099,  5485,  5506,  3904,  2789,   932,  1947,  2576,
    4826,  4634,  4635,  4636,  4637,   907,  4562,  4641,  4642,  4643,
    4644,  4645,  4646,  4647,  4648,  4649,  4650,  5586,  3694,  1474,
    5587,  4772,  4156,  4576,  4157,  1368,  2677,  2857,  3755,  1100,
    5808,  2556,  2860,  2968,  4407,  1558,  4176,  2847,  5538,  4158,
    3836,  4033,  2782,  3716,  2979,    35,  1017,  1631,  2543,  5323,
    1018,  5325,  3739,  2783,  1475,  4159,  4157,  2945,  1476,  4793,
    2997,  1600,  4438,   924,  6032,  4480,   927,  3317,  4439,   927,
   -1104,  4158,  3318,  4691,  4692,  2947,  2856,  5825,  3717,   939,
     939,  4440,  3948,  4160,  3372,  1601,  1632,  4159,  2948,  4827,
    3557,   955,  4362,  1477,   939,   934,  2946,   939,  5306,   632,
    5307,  5308,  5309,  4715,  -150,  2019,  5948,    56,  2934,  4441,
    4762,  4442,  2940,  1102,  3071,  4160,  3319,  4034,  2949,    29,
    5787,  1613,   233,   660,  1869,   956,  5530,  1662,   646,  3083,
    1637,  1249,  1132,  3087,  4028,  4316,   738,  4399,  4029,  4030,
    4031,    40,  1400,  1614,  1429,  4794,   632,   939,  1870,  4208,
    5531,   939,   939,  1941,   812,  5754,  5150,  3369,   660,  6107,
    4932,  6097,  4915,  3106,  1132,  3685,  1663,  3686,  4443,  1638,
    1664,  3690,   999,  1947,  4317,  1482,  4161,  1942,    44,    40,
    1008,  3370, -1077,  4933,  3866,  5200,  4916,  1060,  1794,  5530,
     662,  1795,   187, -1678,  1615,  5638,  4062,  4444,  1633,   632,
    -605,  1665,  4069,  1640,  1639,  6123, -1678,  5997,  4161,  4318,
    4773,  2876, -1678,  5531,  4795,    40,    44,  4774,  4796,  5639,
      48,  3407,  3407,  4303,  4775,   662,  5720,  4510,  3937,  6124,
    1016,  5724,  5725,    49,  1062,  4304,  3828,  4786,  2782,   187,
     963,   964,   965,   966,   967,   968,   969,   970,   971,  2790,
    3408,  4786,    44,  3408,    40,  1603,  1953,    50,    48,  1795,
    4776, -1678,  1483,  6208,  3320,  6211,  1067,  2818,  1641,  2799,
    4445,    49,  3219,   755,  1679,  4446,    56,  1683,  1095,   664,
    6001,  6002,  4777,  2819,  1616,  6222,  6190, -1678,  1081,   755,
    3267,    44, -2326,  5862,    48,    50,  4181,  1017,  3282,  1205,
    3408,  1018,   755,   770,  1400,  2800,  2610,    49,  3408,   770,
    1642,  1411,  1412,  2003,    56,  1484,  1795,  1643,  4447,  -604,
    1644,  4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,
    1413,    50,  3902,    48,  4448,  1617, -1678,  3908,  3978,  3909,
    1618,  4126,  4033,  2585,  1619, -1678,    49,  1103,  2066,  3915,
      56, -1416,  3916, -1416,  3917,  3918,  1104,  2877,  3920,  2885,
    1105,  2878,  3923,   673,  3924,   674,  1122,  3926,  4215,  3979,
      50,  1411,  1412,  1400,  3980,  2610,   632,   632,   632,   632,
     632,   632,   632,   632,   632,  2571,   632,  4769,  1795,    56,
    1415,   678,  1400,  1621,  2610,     3,     4,   632,   673,   632,
     674,  4547,  6084,  5048,  1126,  1590,  4548,  3936,  4548,  4786,
    1607, -1104,   974,  4963,  3386,  3388,  3389,  3524,  4034,  3528,
    3529,  1485,  1142,   677,  2937,  3527,  1845,  3077,  1017,  3078,
   -2334,  3965,  1018,  2584,  4449,  1133,  2585,   632,  1623,  1143,
    2618,   632,  4368,  1795,   632,  2563,   632,  3117,  3365,   632,
    2585,  4137,  4138,   632,  3128,  1160,  3407,  3129,  5540,  4095,
     740,  4096,  1624,  3407,  3301,  3302,  3303,  3304,  3407,  1149,
    3274,  3407,  5173,  3277,  1789,  3521,   632,  1167,  3405,  3295,
      15,  4250,  1626,  1486,     3,     4,  4128, -1678,  1249,  1645,
    6132,  4028,  5081,   632,  1177,  4029,  4030,  4031,  4054,   641,
    4056,  4057,   632,   632,  3227,  3227,   755,  4279,  5088,  4210,
    3435,  3436, -2327,  5809,  3249,    20,  5675,  1017,  1487,  1205,
    3556,  1018,  1488,  3270,  1646,  6146,    35,  6147,  1647,   949,
    1627,  3130,  3450,  4117,  3129,  4118,   892,  1204,  4171,  3169,
     892,   892,  3170,  3368,  4434,  3373,  1947,   949,  2585,  3459,
    2611,   949,  2585, -1749, -1749,   949,  3491,  1489,  3494,  4496,
    4099,  1411,  1412,  1648,   949,  1793,  5705, -1678,  4837,  3554,
    1649,  1205,  3555,  3626,  5710,  5711,  3627, -1753, -1753,  5016,
   -1678,  5110,   949,  5496,  5497,   632, -1678,  5113,  5114,  1209,
    1490,  6076,  1491,  4507,  1213,  4508,   632,  3016,   892,   632,
    3789,   632,   632,  3790,   892,  3033,  3650,  3928,  3977,  3986,
    3129,  2585,  2585,  2937,  1216,  3992,   949,  3993,  2585,  4119,
    2585,  4120,  4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,
    4043,  5121,  1434,  5122, -1666, -1678,   949,   949,  4828,  4957,
    4834,  4958,  1492,  4007,  4817,   892,  3748,  5995,  1120, -1752,
   -1752,  4808,  2071,  4253,  4014,  2072,  4047,  2585,  3091,  2585,
    4061, -1678,  4066,  2585,  5626,  4067,  3542,  1789,   949,  4135,
    1221,  1789,  2585,  4591,  4296,  4301,  4327,  4297,  4302,  4328,
    4396,  5838,  5839,  4328,  2677,  2937,  3736,  2574,  4519,  4483,
    4522,  4520,  1219,  4523, -2885,   949,  4711,  1789,  4713,  4033,
    4426,   949,  1222,  4553,  4659,  4455,  4554,  4660,    32,  4853,
   -1678,  4670,  1232,  4681,  4671,   949,  2585,  2995,  1233, -1678,
    2576,   740,   949,  4757,  1234,   949,  4758,  4786,  1235,  4311,
    4763,   949,  4768,  4764,  5017,  3474, -1677,  3129,  5969,  5970,
      40,    15,  4027,  3407,  6171,  5083,  1236,  5118,  1995, -1677,
    2585,   949,  4237,  1243,  4055, -1677,  4233,   949,  5690,  5157,
    4219,  1237,  2585,  5211,   949,  3641,  3474,  4336,   901,   902,
    5217,   910,  4342,  5218,  1245,  4034,    20,    44,   949,  5224,
    5225,   629,  3129,  3129, -1726,  5226,  3684,  1374,  3129,  4079,
   -1726,   949,  1371,  5166,  5359,  5168,  1789,  5360,  1378,  1379,
    5396,  6212,   949,  4554, -1677,  1380,  4216,  4217,  1120,  5417,
    5419,  5438,  5418,  2585,  5439,  5448,  1384,  3295,  1947,    48,
     632,   632,   632,   741, -1678,  1388,   632,  4283,  5938,  4285,
   -1677,  5454,    49,  4112,  4493, -2885,  1393, -1678,  5456,   911,
   -2885,  4493,  5573, -1678,  5593,  5574,  5627,  3129,  4731,  5628,
    4734,  3398,  5673,   632,   892,  5674,    50,  3297,  1394,  3298,
    5679, -1678,  1789,  1947,  5682, -1726,  5693,  4493,  3970,  5694,
    3972,  3973,  5034,  1249,  5357,   742,  4028,  1396,  1400, -1677,
    4029,  4030,  4031,  3299, -2885,  1404,  1417,  5739, -1677,  4759,
    5740,  5779, -1678,  1419,  2542,   632,   187,  3405,  5151,  5806,
    5829,   927,  5694,  4067,   939,  5830,   939,   939,  2585,  5848,
    5852,  1434,  5849,  1947, -1726,  2656,  5027,  2659, -1678,  1403,
    3407,  5853,  5544,   912,  2585,  3855,  3967,   892,  3877,  1017,
    1435,   892,  1434,  1018,  4788,  4789,  1446,  1461,  4792,  2581,
    3407,  5881,  5887,  1462,  3170,  3170,  4473,  5888,  3300,  5434,
    3170,  5435,  4332,  5891,  3407,  1249,  2585,  1463,  4028,  1466,
    3523,  1513,  4029,  4030,  4031,  1472,  3531, -1678,  5545,    32,
    5860,  4386,  5892,  1539,  4348,  2585, -1678,  4393,  4786,  4035,
    4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  1429,   974,
   -2371,  2616,  4665,  5546,  2677,  3301,  3302,  3303,  3304,  1542,
    1544,    40,  3305,  3306,  1545,  1584,  5893,  3564,  3307,  5894,
    3408,  5547,  1585,  5920,  3408,  5548,  5921,   949,  5974,  1789,
    5988,  4493,  5990,  2585,  5996,  2585,  1580,  3129,  1586,  4456,
   -1677,  4458, -2885,  1597,   892,  1599,   949,  5549,    44,  4585,
    1609,  5550,  6011,   949,  1694,  6012,  1612,   632,  6034,   892,
     632,  6035,   632,   632,   892,  6075,  5551,  4598,  5687,  1636,
    6104,  6142,   632,  5694,  6143,   913,  6165,   632,  5938,  2585,
    6184,  1653,   904,  5849,  4786,  6194,  6200,  1654,  6195,  4758,
      48,  3408,   892,  6209,  4033,  1120,  2585,  1120,  6221,  1670,
    1793,  6195,  5411,    49,  4177,  1680,  1681,  1684,  3426,  1690,
    1689,  1803,  1805,  1807,  1812,  1818,  4487,  1823,  1826,   632,
     632,   632,  3407,  4528,   632,  1833,  1828,    50, -1678,   904,
    1836,  1838,   632,   632,   632,   632,  1830,  2616,  4466,  1847,
    4469,  4837,  1852,  1789, -2885,  1853,    56,  -137,   632,  1789,
    1855,   632,  1856,   632,  1858,  1860,  2515,  2516,  2517,  2518,
    2519,  2520,  1861,  5552,   632,   632,  1872,  3308,   632,  1879,
    4034,  4555,  1881,  4557,  1884,  4559,  4033,  6042,  3309,  1120,
    1888,  1897,  1902,   213,  1903,  3407,  4786,  1904,  1906,   632,
    1909,   632,  1910,   632,  1913,  4829,  1017,  1914,  1921,  1925,
    1018,  1927,  1928,  1930,  1932,  5243,  1938,  1937,  1940,  1943,
     629,  1946,   632,  4570,  5553,  1949,  1950,  1952,  1969,  2000,
    2071,  2007,  2016,  2072,  2009,  2017,  3787,  2073,  2074,  2075,
    2012, -1905,   904,   949, -1912,  2024,  2025,  2026,  2027,  3608,
    2028,  4848,    56,  2030,  2031,  2573,  4085, -1902,  4086,  2032,
   -1903,  2033,  4034,  2034,  2035,  2574, -1906,  2036,  2037,  2038,
    2039, -1904,  2575,  2040,  5061,  3632,  2042,  2043,   632,  2050,
    3405,   632,  4087,  3405,  4122,  4123,  4124,  2044,  2045,  2046,
    2047,  2048,  2049,   904,   632,  2052,  2526,  2053,  2576,   632,
    2054,  2055,  2056,  4593,  2057,  2611,  2058,  4804,  2059,   187,
    2528,  2530,  2532,  2533,   632,  6044,    29,  2542,  2546,  2558,
    2588,  2566,  2589,  2594,  2596,  2597,  2600,  2601,   632,  2603,
    3405,  2604,  2605,  2606,  2607,  2612,   632,  5651,  3405,  1449,
    2619,  2650,  2652,  1451,  2662,  2664,  2665,  3300,   892,  2666,
    4951,   892,  2667,   892,  2683,  3407,  2684,  4938,   892,  2685,
    2686,  3408,  3408,  2610,  2690,  2687,  2688,  2689,  2691,  2692,
    2699,  2693,   927,   949,   949,   939,  2718,   939,   939,   632,
    2724,  6169,  2730,  2744,  4035,  4036,  4037,  4038,  4039,  4040,
    4041,  4042,  4043,  2748,  3301,  3302,  3303,  3304,  2750,  2752,
     949,  4088,  2751,   949,  5653,  2754,   892,  4089,  2755,  2772,
    2768,  2773,    40,  2577,   892,  4943,  3959,  2774,  2578,  2785,
    2786,  2801,  2803,  2804,  2805,  2806,  2807,  2815,  2797,  3460,
    2817,  3969,  2816,  2822,  5672,  4877,  3974,  2820,  2821,   892,
    2827,  2579,  2262,  2831,  2828,  2837,  2838,  3476,  2841,    44,
    3407,  3479,  2851,  2852,  2855,  3482,  2858,  2861,  2862,  2865,
    2867,  2872,  2580,  2868,  3994,  2879,  4035,  4036,  4037,  4038,
    4039,  4040,  4041,  4042,  4043,  1789,  1789,  1789,  2882,  1558,
    2880,  2897,  3507,  2908,  2899,  2901,  2909,  4177,  2925,  2926,
    2887,    48,  2933,  2955,  2906,  2888,  2893,  2894,  2970,  2962,
     949,  2900,  2967,  2320,    49,  2902,  2063,  2983,  2914,   892,
    2915,   892,  2927,  2938,  2969,  2971,  3549,  2581,  2972,   949,
    2582,  2976,  2071,  2977,  2988,  2072,  3948,  2978,    50, -2885,
   -2885, -2885,  2980,  2981,  2982,  2984,  1075,  2989,  2990,  4631,
    2991,   949,  2998,  2999,  5379,   655,  3002,  6045,  3015,  3026,
    3007,  3407,  1633,  2063,  3030,  3043,  4090,  2574,  3031,  3034,
    3050,  3059,  3070,  3076,  2575,  3046,  3080,  4091,  3599,  3092,
    1613,  3049,  3094,  4658,  3096,  3095,  3110,  3295,  3097,  3153,
    3167,  3142,  3179,   629,  3198,  3269,   629,  3275,  2072,  3315,
    2576,  1249,  1614,  4108,  4028,  3628,  3408,  3063,  4029,  4030,
    4031,  3637,  3067,  3408,  3085,   892,  3288,  3203,  3408,  3279,
    2583,  3408,  3335,  3294,  3313,  3647,  3356,  3340,  3361,  3359,
    3341,  3362,  1075,  3375,  3360,  3660,  4699,   949,  3374,  3376,
    3377,  3665,   632,   629,  3378,  1424,  3391,  3427,   632,  3410,
     911,   629,  3379,  1615,  3383,  3429,  3392,   892,  3444,  3428,
    3415,  3678,  3430,  4142,  3451,  3452,  4147,  3681,  3463,  3464,
    3483,  3466,  3497,  3499,  3687,  3500,  3495,  3492,  3506,  3511,
    3516,  3517,  3519,  3522,  1789,   892,  3530,  5078,  3702,  1368,
     949,  3546,   949,  3551,  3563,  3553,  3570,  3583,  3588,  3616,
    3589,  3727,  1372,  3609,  3615,   949,  3617,   949,  2616,  3622,
    3625,  3407,  1075,  3398,  3633,  2577,  3640,   903,  3642,  3663,
    2578,  3398,  2511,  3643,  3664,  3722,  3680,   632,  1849,  3735,
    5340,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,
    3747,  3743,  3744,  1616,  3249,  3249,  3756,   912,  4005,  3249,
    3763,  3769,  3775,   892,  3780,  5143,  3802,  3803,  3817,  3791,
    3770,  3819,  3771,  3821,  2580,  3823,  3831,  3849,  3850,  3838,
    4513,  3852,  3853,  3844,   949,   892,  3851,  3857,  4238,  3860,
    3864,  3865,  5191,  3868,  3869,  3874,  4241,  3862,  3889,  3249,
    3249,  3890,  3891,  3899,  1617,  3900,  3901,   892,  3903,  1618,
    3905,  3407,  3919,  1619,  5027,  3921,  4550,  3407,  3922,  3925,
    3930,  3927, -2885,  3931,  4989,  4990,   949,  3932,  2885,  2581,
    3933,  4517,  3934,  3945,  3935,  3951,  3958,  3961,  3949,  3971,
    3963,  3991,  4006,  3940,  3995,   949,  1947,  4003,  4060,   949,
    3950,  5070,  1944,  1911,  5072, -2187,  3939,  4080,  4113,  3988,
    3989,  1211,  1621,  3990,  3748,  2585,  4063,  4075,  3998,  4697,
     949,  4133,  4008,  5073,  5074,  5075,  5076,  5077,  4015,  4016,
    4020,  4094,  4022,  5087,  4023,  4024,   632,  4046,  4107,   892,
    4051,  4324,  4052,  4326,  5198,   632,  4059,  4074,  4034,  5708,
    4106,  4109,  4111,  3408,  5313,   632,  4139,  1623,  4140,   632,
     632,  4134,  1214,  4141,  4145,   632,  4173,  4154,  4146,  3407,
    4186,  4169,  2583,   632,  4188,   632,  4190,  4192,   632,  4179,
    4199,  1624,   892,   632,   632,   632,   632,  3944,  4213,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,  4218,
    4220,  1626,   632,   632,   632,  5252,  3960,   892,  4221,  4229,
    4207,  4225,   632,  3944,  4226,  4230,  4232,   632,  4257,  1789,
    4258,   632,   904,  4259,  4234,  4264,  4265,  4266,  2071,   632,
    4246,  2072,   632,  4247,   632,  4263,  4281,  4387,  4270,  4282,
    6069,  6070,  4284,  4292,  4290,  1516,  4291,  4300,  4306,  1627,
    4315,  4329,   632,  4331,  4335,   632,   632,  4343,  4333,  4337,
     632,   632,  4344,  2574,  4347,   632,  4350,   632,  4339,  4177,
   -2885,  4351,  4354,  4349,  2511,  4352,  4369,  4376,  4371,  4409,
    1517,  4370,  5195, -2885, -2885, -2885,  2515,  2516,  2517,  2518,
    2519,  2520,  4372,  4373,  4379,  4177,  2576,   191,  1054,  1058,
     632,  4381,  1057,  4374,  1055,  4385,  1056,  4375,   632,  4383,
    3405,  4388,   632,  4390,  3405,  4392,  6014,  4377,  2923,  4378,
    4380,  4382,  4384,  4394,  4395,  4704,  4705,  4706,  4707,  4404,
    3408,  4405,  4411,  4401,  4406,  4416,  4422,  4459,  4465,  5232,
    4408,  1518,  4474,  4475,   632,  4424,  4464,  4471,  4478,  4482,
    3408,  4492,  4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,
    4043,   632,  4495,  4493,  3408,  4078,  4511,   892,  4502,  4512,
    4515,  4505,  4532,  4516,  4546,  3564,  4518,  4549,  1519,   632,
    4564,  3405,  5257,  5258,  4565,  4556,  4586,  4558,  5324,  5379,
    4587,  4566,  4588,  4567,   187,  4568,  4552,  4594,  4569,  4607,
     949,  4595,  4596,  4597,  4612,  4599,  4571,  4600,  4601,  4602,
    4603, -2885,  3218,  4614,  2019,  4615, -2885,  4618,  4622,  4551,
    5241,  1520,  4623,  4028,  4632,  4672, -2186,  4683,  4655,  4656,
     187,  4684,  4657,  4664,  4689,  4686,  4687,  4716,  4700,  5433,
    4712,  4714,  4728,  4720,  4725,  5129,  4723,  4727,  4735,  4736,
    4741,  1789,  4740,  4742,  4743,  4745,  1789,   892,  1789,  1521,
   -2885,  4751,  4754,  1522,  4756,  4760,  4771,  4779,  4800,  4803,
    5291,  5292,  5471,  5294,  4810,  4811,  5301,  5302,  4801,  4802,
    4813,  4814,  1789,   892,  4177,  4816,  4820,  4823,  4824,  4840,
    1613,  4855,  4843,  2886,  1523,  1524,  4857,  4856,  4858,  4883,
    4859,  4608,  4869,  4870,  4871,  4886,  4903,  4872,  4873,  4874,
    5284,  4885,  1614,  4892,  4904,  2581,  4909,  4912,  4929,  4931,
    4928,  4830,  3408,  4894,  4934,  4944,  4945,  5543,   949,  4947,
    4948,   949,  4949,  1525,  4902,  4960,  4971,    35,  4820,  4986,
    5000,  5006,  1526,  4981,  4633,  5007,  4992,  5019,  5012,  5029,
    4235,  1527,  5035,  5013,  5046,  2071,  5036,  5057,  2072,  5052,
    1528,  5053,  5055,  1615,  4830,  5059,  5056,  5065,  1529,  4654,
    5060,  2721,  5071,  5079,  5085,  5086,  3154,  5095,  5103,  5102,
    1530,  5106,  5105,  5107,  5108,  3408,  5111,  5112,  5115,  1531,
    2574,  5120,  5126,  1532,  5132,   632,  5137, -2885,  5135,  5733,
    5141,  5735,  5136,  5147, -2188,  5148,  5395,  5342, -2885,  5397,
    5398,  5160,  5156,   629,  5170,  5174,  5177,   629,  5188,  5196,
    5184,   949,   949,  2576,  5193,   892,  5197,  5207,  5212,  5403,
    4831,  5214,   949,  5210,  5219,  5220,  2063,  5229,  5249,   632,
     632,  3405,  3405,  5250,  5251,  1516,  5254,  5259,  1533,   949,
    4307,  5260,  5261,  1616,  5280,  5286,  5273,  5276,  5282,  5287,
    5295,  5296,  5303,   187,  5305,  5843,  5314,  5304,  5317,  5310,
    5322,  5321,   892,  5329,  5332,  5337,  5038,   892,   632,   632,
    1517,  5339,  5341,  3398,   629,  5338,  5345,  3398,  5347,   632,
    5361,  5367,  4098,  5356,  5351,  5363,  5368,  5372,  5374,  5370,
    5375,  5385,  5869,  5743,  1617,  5376,  5393,  5391,  5401,  1618,
   -2885,   974,  5400,  1619,  5590,  3129,  5406,  5407,  5412,  5408,
    5416,  5422,  2515,  2516,  2517,  2518,  2519,  2520,  2885,  5432,
     949,  5424,  4832,  1789,  5440,  5447,  5423,  5446, -2885,  5436,
    5475,  1518,  5487, -2885,  5450,  3408,  5447,  5478,  5904,  5906,
    5484,  5495,  5453,  5499,  5503,  5472,  5491,  5498,  5504,   632,
    5505,  5510,  1621,  5536,  5516,  5517,  5558,  4970,  5521,  5527,
    3227,  5528,   632,  5529,  5564,  5566,  5569,  4402,  1519,  5572,
    5577,  5596,  5576,  5597,  5601,  5608,   632, -2885,  3249,  3249,
    3249,  3249,  5624,  5606,  3249,  3249,  3249,  3249,  3249,  3249,
    3249,  3249,  3249,  3249,  5629,  5637,  5643,  1623,  5513,  5635,
    5658,  5636,  5667,  5689,   632,  5713,  5691,   632,  5659,  5479,
    5671,  1520,  4662,  5721,  5714,   632,   632,  5683,   892,  5685,
    5687,  1624,   632,   632,  5688,  5704,  5715,   632,  5706,  5758,
    3408,  5727,  2581,  5760,   632,  5763,  5771,   632,   632,  5767,
    5773,  1626,  5781,  4833,   632,  5786,  4266,  5795,  5799,  1521,
    3249,  3249,  5800,  1522,  5801,  5802,  5803,  5508,  5812,  5813,
    5820,  5824,  5814,  5841,   632,  5831,  3405,  5822,  5815,  5842,
    5840,   632,  5855,  3405,  4114,  5845,   632,  5864,  3405,   632,
     632,  3405,  5847,  5865,  1587,  1524,  5867,   632,  5868,  1627,
    5884,  6013,  5898,  5880,  5903,  4722,  5912,  5909,   632,  5915,
    5917,  5923,  5919,  5926,  5927,  5943,   632,  5945,  5944,  5745,
    5946,  5199,  5201,  5213,  5953,  5954,  5960,  5962,  5967,  5971,
    5972,  5959,  5977,  1588,  5984, -2885,   632,    35,  5986,  5993,
    5998,  3408,  1526,  6006,   629,   629,  6008,  6015,  5913,  5914,
    6023,  1527,  6024,  6025,   892,  6041,  2937,  5543,  6043,  6060,
    1528,  6071,  6074,  5910,  6082,  2807,  6088,   949,  1589,  6065,
    6066,  6090,  6108,  6114,  6125,  4574,  6115,  6119,  6120,  4578,
    1530,  6127,  6128,  6148,  6149,  6150,  6159,  4991,  6172,  1531,
    6174,  6183,  6175,  1532,   892,  4205,  6185,  6187,  6192,  6203,
    6193,  6204,  6198,  5247,  6207,  6162,  6213,  5631,  5680,  6216,
    1651,   949,  2565,  5255,  3398,  1436,   892,  6220,  3695,  3614,
    1543,  4131,  4276,   949,  4846,  2939,  5702,  4839,  6009,  3734,
    3782,  4421,  5555,  5897,  1650,  6089,  4988, -2885,  5607,   632,
     187,  4835,  4836,  5320,  5589,  4223,   632,  3929,  1533,  2515,
    2516,  2517,  2518,  2519,  2520,  6000,  5489,   949,  6085,  5918,
    5916,  6100,  6022,  4228,  5349,  5010,  5039,  5018,  5878,  4980,
    3800,  3801,  4844,  4294,  4481,  5005,  5343,  5595,  1635,  5738,
    4521,  5063,  5816,  6145,  6219,  6205,  5570,  4427,   892,  5047,
    6027,  3408,  5515,  5886,  5737,  3006,  5723,  5518,   736,   789,
    4572,  5080,  1050,  5700,  3069,  6141,  5082,  2071,  5732,  1992,
    2072,  3829,  3469,  5049,   632,  4214,  5632,  3065,  3081,  4538,
    5810,  3098,  1120,  1121,  4391,  5874,  3732,  4875,  4338,  6047,
     632,  2071,  6173,  2698,  2072,  1789,  5066,  5067,  2073,  2074,
    2075,  1161,  2574,  3759,  3414,  6188,  3879,  2964,  5699, -2885,
    5202,  4765,  5994,  1381,   949,   817,  2573,  2586,  2538,   818,
    4187,   632,  5109,  3405,  4175,  3424,  2574,  2647,  5989,  5857,
    1516,  2646,  5898,  2575,  4149,  2576,  4718,  5452,  2651,   629,
    4733,  3408,  4143,  5670,  5354,   974,   629,  3408,  5669,  4766,
    6156,   629,  5827,  4144,   629,  5186,  5976,  6072,  5846,  2576,
    3249,  4666,  5654,  5655,  3336,  1517,  5858,   892,  4110,   892,
    5859,  3339,  3255,  4104,  3983,  2595,  3758,  5660,  4102,  4093,
    4013,  4619,  1432,  3351,     0,  4177,     0,  3412,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   974,  5681,     0,
     949,     0,  5512,  5871,  4690,  2065,     0,     0,     0,     0,
    5514,     0,     0,     0,     0,     0,  3398,     0,     0,     0,
       0,  3398,     0,     0,  3398,     0,  1518,     0,     0,     0,
       0,   632,     0,     0,   632,     0,     0,   632,   632,   632,
    4805,     0,     0,     0,     0,   187,   187,  5557,     0,  3408,
   -2885,     0,     0,     0,     0, -2885,     0,     0,     0,     0,
       0,     0,     0,  1519,   632,   632,     0,     0,   632,     0,
       0,     0,  5728,  5729,  2577,     0,  5233,     0,     0,  2578,
       0,  1120,     0,     0,     0,     0,     0,     0,   632,     0,
       0,     0,     0,     0,   632,     0,     0,     0,   632, -2885,
    3405,  3880,  2579,  2262,   892,   632,  1520,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5256,     0,   632,     0,
    3405,   632,  6196,  2580,     0,     0,   949,  6181,   949,     0,
       0,     0,   632,     0,  3405,     0,     0,     0,  5272,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1522,     0,
       0,     0,  5473,     0,  2581,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2320,     0,     0,     0,  4917,     0,
       0,  4920,  6181,   892,   949,     0,     0,     0,  2581,     0,
    1524,  2582,  5134,     0,   632,     0,     0,     0,     0,     0,
    6181,     0,     0,     0,     0,  5326,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5300,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,  1789,     0,   629,  3881,  5854,   632,
    5856,     0,     0,  5732,  6206,     0,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0, -2885,     0,     0,
       0,     0,     0,  2765,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1530,  5594,  6134,  6135,     0,
       0,  2583,  5002,     0,  1531,     0,     0,     0,  1532,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2937,
     632,     0,  3405,   892,     0,     0,  6083,  5620,  3882,     0,
       0,     0,     0,  2071,     0,     0,  2072,    71,   187,   191,
     180,   186,   175,    80,   184,    83,   181,     0,   183,    84,
      85,    86,   106,     0,     0,   124,   632,   129,   159,   178,
     632,  5384,   632,  1533,   185,   904,     0,  3883,  2574,     0,
       0,     0,     0,     0,     0, -2885,   632,  5622,     0, -2885,
       0,  1120,     0,   632,     0,  3405,   632,     0,     0,     0,
       0,  2515,  2516,  2517,  2518,  2519,  2520,   632,     0,     0,
    3944,  2576,     0,  2511,   632,     0,     0,     0,     0,     0,
       0,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,     0,     0,     0,     0,  4017,     0,     0,  4018,     0,
       0,     0,     0,   629,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   629,     0,   892,     0,     0,     0,     0,
     892,   892,   974,     0,     0,   632,     0,   629,     0,     0,
    4693,   632,   632,   949,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   949,     0,     0,
       0,     0,     0,     0,     0,     0,  4387,     0,     0,     0,
       0,     0,     0,  3398,     0,     0,   630,   632,     0,     0,
       0,     0,     0,     0,     0,   632, -2885,     0,  1789,   939,
       0, -2885,     0,   782,     0,   784,     0,     0,     0,   790,
       0,     0,     0,     0,   798,   806,   810,     0,   813,     0,
       0,   806,   806,   632,   843,  3405,   846,     0,     0,     0,
       0,     0,  1516,   900,   900,   900,  5789,     0,     0,     0,
       0,     0,     0,     0,   939, -2885,     0,     0,     0,     0,
       0,     0,   892,   892,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1517,     0,     0,
       0,     0,     0,     0,     0,     0,   632,     0,     0,     0,
       0,     0,     0,     0,     0,   632,   632,   632,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   632,  1789,
    2581,     0,   892,     0,     0,   629,     0,   632,     0,   632,
       0,   632,     0,     0,     0,     0,     0,     0,   632,     0,
    3405,     0,     0,  6005,     0,     0,  5861,     0,  1518,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   632,
     187,     0,     0,  6133,     0,     0,     0,     0,     0,  3249,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5267,     0,     0,  1789,  1519,   949,     0,   629,     0,
       0,   187,     0,  5277,     0,     0,     0,   630,   929,   929,
       0,     0,   929,     0,     0,   187,   940,     0,   843,     0,
       0,   976,     0, -2885,   940,  6054,  6055,   940,     0,     0,
     843,     0,   929,  3249,     0,   843,     0,     0,  1520,   929,
       0,   843,     0,     0,     0,     0,     0,     0,     0,   632,
       0,  3405,     0,  2071,     0,     0,  2072,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6199,     0,     0,  2071,  1521,     0,  2072,     0,
    1522,     0,     0,     0,     0,     0,   632,     0,  2574,  2063,
       0,     0,     0,     0,     0, -2885,     0,     0,     0,   632,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   632,
    2574,  1604,  1524,     0,     0,     0,     0, -2885,     0,   632,
       0,  2576,   949,     0,     0, -2885,     0,  1998,     0,     0,
    5772,     0,  1998,  1998,     0,   632,     0,  2515,  2516,  2517,
    2518,  2519,  2520,  2576,     0,     0,     0,     0,   949,     0,
    1605,     0,     0,     0,    35,     0,     0,     0,   629,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,  1527,     0,
   -2657,     0,     0,     0,     0,     0,     0,  1528,     0,     0,
       0,     0,     0,     0,     0,  1606,     0,     0,     0,   632,
    4694,     0,  6028,     0,     0,     0,     0,  1530,     0,   632,
       0,  3405,     0,     0,     0,     0,  1531,   632,   632,     0,
    1532,     0,  5154,   632,     0,   191,  6049,  6052,     0,     0,
    3944,     0,  6050,     0,  6051,     0,     0,     0,  3398,     0,
     187,     0,   632,   632,     0,     0, -2885,     0,     0,     0,
       0, -2885,     0,     0,     0,  5811,     0,     0,     0,     0,
       0,  1546,     0,   629,     0,     0,     0,  1547, -2885,     0,
    6113,     0,     0, -2885,     0,  1533,   949,     0, -2657,     0,
       0,  3249,  1655,     0,     0,  6214,  6215,     0,     0,     0,
       0,     0,     0,     0,     0, -2885,     0,     0,     0,   632,
       0,  3405,     0,     0,  5851,   632,     0,  3405,     0,     0,
       0,  3249,  1549,     0,     0,     0,     0, -2885,   191,  6049,
    6052,     0,     0,   632,   632,  6050,     0,  6051,     0, -2657,
     187,     0,     0,     0,     0,     0,     0,     0,   632,     0,
       0,     0, -2657,     0,     0,     0,     0,     0, -2657,     0,
    2581,     0,   632,     0, -2657,     0,  3944,     0,  3944,     0,
   -2657,     0,     0, -2657,   629,     0,  1656, -2657,  1550,     0,
       0,     0,  2581,     0,   698,  1551,     0,     0,  1552,     0,
       0,     0,     0,   786,     0,     0,     0,   632,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2657,     0,     0,
       0,     0,     0,     0,     0,  1553,     0,   632,     0,  3405,
       0,     0,     0,     0,  1789,     0,     0,     0,     0,     0,
     191,  6049,  6052, -2657,     0,     0, -2659,  6050,     0,  6051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1554,     0, -2885,     0,     0,   632,   632,     0,     0,
     939,   632,     0,     0,     0,   632,     0,     0,     0,  1789,
       0,     0,     0,  1029,     0, -2885,     0,   632,   632,   843,
       0,   929, -2657,   929,     0, -2657,   929,  1789,     0,     0,
       0, -2657,     0,   976,     0,     0,     0,     0,  1087,     0,
     929,     0,     0,     0,     0,     0,   929,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,   629,     0,  1556,     0,     0,     0,
     630,     0,   939,   939, -2659,     0,  1557,     0,     0,   940,
       0,     0,     0,   976,     0,  1558,   940,     0, -2657,   940,
       0,     0,     0,  3249,     0, -2885,     0,  1559, -2675,     0,
       0,     0,     0,     0,     0,   929,     0,  2515,  2516,  2517,
    2518,  2519,  2520,     0,     0,     0,   187, -2885,     0,     0,
       0,     0,     0,     0,     0, -2659,     0,     0,     0,  2515,
    2516,  2517,  2518,  2519,  2520,     0,  1658,     0, -2659,  1561,
    1562,   187,     0,     0, -2659,   787,     0,     0,     0,     0,
   -2659,     0,     0,     0,   629,     0, -2659,     0,   843, -2659,
     629,     0,     0, -2659,     0,     0,     0,  1231,     0,     0,
       0,  1659,     0, -2657,     0,     0,     0,     0,  6117,     0,
       0,     0,     0,     0,     0,     0,     0,  1353,  1353,     0,
     843,   806,     0, -2659,     0,   806, -2675, -2657,     0, -2657,
   -2657,     0,     0,     0,     0,     0,     0,     0,     0,   843,
       0,     0,     0,  1516,   843,     0,     0,     0,     0, -2659,
    1353, -2657,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6112,     0,     0,     0,     0,     0,
    1564, -2657,  6153,     0, -2657, -2657, -2657, -2675,  1517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2675,     0,   629,     0,  5975,  1353, -2675,     0, -2659,     0,
       0, -2659, -2675,     0,     0,     0,     0, -2659, -2675,   843,
       0, -2675,     0,     0,     0, -2675,     0,     0,     0,     0,
       0,     0,   843,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6153,     0,     0,  2071,     0,   843,  2072,  1518,
    6202,     0,  2073,  2074,  2075, -2675,     0,     0,     0,     0,
       0,     0,   939,   939,     0,     0,   843,     0,     0,     0,
    2573,   929,   929,     0, -2659,     0,   187,     0,     0,     0,
    2574, -2675,     0,     0,     0,     0,  1519,  2575,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,   806,     0,     0,     0,     0,     0,
       0,     0,     0,  2576,     0,     0,  2071,     0,     0,  2072,
       0,     0,     0,  2073,  2074,  2075,  1353,  1353,     0,  1520,
   -2675,   787,     0, -2675,     0,     0,     0,  3249,  3249, -2675,
     630,  2573,   929,     0,     0,     0,   940,     0,     0,   976,
     940,  2574,   940,     0,     0,     0,     0,   929,  2575, -2659,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   843,     0, -2659,  2576, -2659, -2659,     0,   929,   929,
       0,     0,     0,     0,     0,     0, -2675,     0,     0,     0,
       0,     0,     0,  1524,     0,     0,     0, -2659,     0,     0,
     843,   843,   843,     0,   929,     0,   630,     0,   630,   630,
       0,     0,     0,     0,     0,     0,     0, -2659,  2577,     0,
   -2659, -2659, -2659,  2578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,  2764,     0,     0,
    1526,     0,   929,   787,   929,   929,  2579,  2262,     0,  1527,
       0,  1546,     0,     0,     0,     0,     0,  1547,  1528,     0,
       0,     0,     0,     0,     0,     0,  2765,  2580,     0,     0,
       0, -2675,     0,     0,     0,     0,     0,  1353,  1530,     0,
       0,     0,  1051,     0,     0,     0,     0,  1531,     0,  2577,
       0,  1532,  3944,     0,  2578, -2675,     0, -2675, -2675,     0,
       0,     0,  1549,  1972,     0,  1972,     0,     0,  2320,   843,
       0,   782,     0,     0,     0,     0,     0,  2579,  2262, -2675,
       0,     0,  2581,     0,     0,  2582,     0,     0,     0,     0,
       0,     0,  1119,   698,     0,  2008,     0,   843,  2580, -2675,
       0,  2014, -2675, -2675, -2675,     0,  1533,     0,     0,     0,
       0,     0,     0,     0,     0,  1353,     0,     0,  1550,     0,
       0,     0,     0,     0,  2071,  1551,     0,  2072,  1552,     0,
       0,  2073,  2074,  2075,     0,     0,     0,     0,     0,  2320,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2573,
    1353,     0,     0,  2581,     0,  1553,  2582,     0,     0,  2574,
       0,     0,     0,     0,     0,     0,  2575,     0,     0,     0,
       0,     0,     0,     0,     0,  2583,     0,     0,     0,  1353,
    1353,  1353,     0,  1353,     0,     0,     0,  2071,  1218,     0,
    2072,  1554,  2576,     0,  2073,  2074,  2075,     0,     0,     0,
       0,     0,     0,  1353,     0,     0,     0,     0,  1240,     0,
       0,     0,  2573,     0,     0,     0,  1356,     0,     0,  1365,
    1119,  1367,  2574,     0,  1546,     0,     0,     0,     0,  2575,
    1547,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   843,     0,     0,  1655,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,  2576,     0,     0,     0,     0,
    1353,     0,  1657,     0,     0,     0,  1556,     0,     0,     0,
       0,     0,     0,     0,     0,  1549,  1557,  2511,     0,     0,
       0,     0,     0,     0,     0,  1558,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,     0,     0,  1559,     0,     0,
       0,     0,  4019,     0,     0,     0,  1353,  2577,     0,     0,
    1353,  1353,  2578,     0,     0,     0,     0,     0,     0,     0,
       0,   843,   843,   843,  2661,     0,  1353,     0,     0,  1656,
       0,  1550,     0,     0,     0,  2579,  2262,     0,  1551,  1561,
    1562,  1552,     0,     0,     0,     0,     0,     0,  2511,   806,
       0,     0,     0,     0,     0,     0,  2580,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,     0,  1553,     0,
    2577,  1563,     0,  4070,     0,  2578,     0,     0,     0,     0,
       0,     0,     0,     0,  2753,     0,     0,     0,     0,   806,
       0,     0,   929,     0,     0,     0,     0,  2320,  2579,  2262,
       0,     0,     0,     0,  1554,   843,  2781,     0,     0,     0,
       0,  2581,     0,     0,   843,     0,     0,   929,     0,  2580,
       0,     0,  1119,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1564,     0,     0,     0,   976,     0,   843,     0,     0,   806,
       0,     0,  2849,  2849,     0,     0,  2849,     0,     0,     0,
    2320,     0,     0,     0,     0,     0,   806,     0,     0,   843,
       0,     0,   843,     0,  2581,  1657,     0,  2582,     0,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1557,
       0,     0,     0,     0,     0,     0,   929,     0,  1558,     0,
       0,     0,     0,     0,  2583,     0,     0,     0,     0,     0,
    1559,     0,     0,     0,   843,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   929,   929,   929,   929,
     843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   843,     0,     0,     0,     0,  3692,
       0,     0,  1561,  1562,     0,  1353,  1353,  1353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3693,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2511,     0,     0,     0,
       0,     0,     0,  1997,     0,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1119,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1564,   843,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   843,     0,     0,     0,  2511,
       0,     0,     0,   929,   929,     0,     0,     0,  2512,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,   929,
       0,  3278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   843,  2849,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2067,   929,   929,   929,   929,     0,     0,     0,
       0,  2069,   843,     0,     0,     0,     0,     0,     0,   843,
       0,     0,  3062,     0,     0,     0,  2536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   630,     0,     0,
     630,     0,     0,  3879,     0,  1119,     0,     0,  2553,  2554,
     940,   940,     0,  1119,  1119,     0,     0,     0,     0,     0,
       0,   976,   976,  2071,     0,   940,  2072,  1516,   940,     0,
    2073,  2074,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   929,   929,     0,     0,     0,  2573,     0,
     929,     0,   843,     0,     0,     0,     0,     0,  2574,     0,
       0,     0,  1517,     0,     0,  2575,     0,     0,     0,  1972,
       0,   772,     0,     0,     0,     0,   929,   772,   940,     0,
       0,  3145,   940,   940,     0,   843,   843,     0,   929,     0,
       0,  2576,     0,     0,     0,   843,     0,     0,     0,     0,
       0,     0,   843,     0,     0,   843,  3062,     0,     0,   782,
       0,     0,   782,  3182,     0,     0,     0,  1353,     0,  1353,
       0,     0,     0,  1518,  1353,  1353,     0,     0,     0,     0,
       0,  1353,  1353,  1353,  1353,  1353,  1353,  1353,     0,     0,
    1353,     0,  1353,   976,  1353,  1353,  1353,  1353,  1353,  1353,
       0,  1546,  1353,     0,  1353,  1353,     0,  1547,  1353,     0,
    1519,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1548,  1353,  1353,  1353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1353,     0,     0,     0,     0,     0,     0,  3880,     0,
       0,     0,  1549,  1520,     0,     0,  2577,     0,  -136,     0,
       0,  2578,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,   929,     0,     0,  2579,  2262,     0,     0,     0,     2,
       0,     3,     4,     0,     0,  1522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2580,     0,     0,  1550,     5,
       0,     0,     0,     0,     0,  1551,     0,     0,  1552,     6,
    2890,     0,     0,     0,     0,     0,     0,  1524,  2898,     0,
       0,     7,     0,     8,     9,     0,     0,     0,     0,     0,
      10,     0,    11,     0,     0,  1553,  2320,     0,     0,     0,
       0,     0,     0,     0,    12,     0,    13,     0,     0,     0,
    2581,     0,     0,  2582,     0,     0,     0,     0,     0,    35,
       0,     0,     0,    14,  1526,     0,    15,     0,     0,     0,
       0,  1554,     0,  1527,     0,  1353,     0,     0,     0,     0,
       0,    16,  1528,    17,     0,     0,     0,    18,     0,     0,
    2765,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,    20,  1530,    21,     0,     0,     0,     0,     0,     0,
      22,  1531,     0,     0,     0,  1532,  2071,     0,     0,  2072,
       0,     0,  1353,  2073,  2074,  2075,     0,     0,    23,     0,
       0,     0,     0,     0,     0,  3882,     0,     0,     0,     0,
       0,  2573,  1555,  2583,     0,    24,  1556,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,  1557,     0,  2575,     0,
       0,     0,     0,     0,     0,  1558,     0,     0,     0,     0,
    1533,     0,     0,     0,  3883,  1353,     0,  1559,     0,     0,
       0,     0,     0,     0,  2576,     0,     0,     0,     0,     0,
       0,     0,    25,    26,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,  1560,     0,     0,  1561,
    1562,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      29,     0,     0,  3027,     0,     0,     0,  3032,     0,     0,
       0,     0,     0,     0,     0,  2511,     0,     0,     0,     0,
       0,  1563,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,     0,     0,     0,  4423,     0,     0,
       0,     0,     0,     0,    30,     0,     0,  2071,     0,     0,
    2072,     0,     0,     0,  2073,  2074,  2075,     0,    31,     0,
       0,     0,     0,     0,    32,    33,     0,    34,     0,  2577,
       0,     0,    35,     0,  2578,     0,     0,     0,    36,     0,
       0,    37,  2574,     0,     0,     0,     0,     0,    38,  2575,
    1564,     0,     0,     0,     0,    39,    40,  2579,  2262,     0,
       0,     0,     0,    41,     0,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,  2576,     0,    43,  2580,     0,
       0,     0,  1353,  1353,  1353,  1353,  1353,  1353,  1353,  1353,
    1353,     0,  1353,    44,     0,     0,     0,     0,     0,     0,
       0,     0,   843,  1353,     0,  1353,     0,     0,     0,     0,
       0,     0,   843,    45,     0,     0,     0,     0,     0,  2320,
       0,     0,     0,     0,    46,     0,     0,     0,     0,     0,
      47,     0,     0,  2581,     0,    48,  2582,  3215,     0,     0,
       0,   843,     0,  1353,   891,     0,   929,  1353,    49,     0,
    1353,     0,  1353,     0,     0,  1353,     0,     0,     0,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,     0,    51,    52,    53,    54,    55,     0,
       0,     0,  3409,     0,     0,     0,     0,     0,   843,   843,
    2577,    56,     0,     0,  -136,  2578,     0,     0,     0,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,  1353,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,  2579,  2262,
       0,     0,   843,     0,     0,     0,  2583,     0,     0,     0,
    3453,     0,  3458,     0,     0,     0,     0,     0,     0,  2580,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   782,     0,   782,   772,     0,   772,     0,   772,
    2320,     0,     0,     0,     0,   772,  1198,  1199,     0,     0,
       0,  1353,     0,     0,  2581,     0,     0,     0,     0,     0,
       0,     0,   630,     0,     0,   940,   976,   940,   940,     0,
       0,   929,     0,     0,   843,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2511,     0,
       0,     0,  -136,     0,     0,   806,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,  2781,     0,     0,     0,
    4609,     0,     1,     0,  3567,   843,     0,     0,     0,     0,
       0,  3578,     0,     2,     0,     3,     4,     0,     0,     0,
     843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,  2583,     0,     0,
       0,     0,   843,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     8,     9,     0,
       0,     0,     0,   843,    10,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,    12,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    14,     0,   929,
      15,     0,   929,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,    17,     0,     0,
       0,    18,     0,     0,   772,     0,     0,    19,   843,   843,
       0,     0,     0,     0,     0,    20,     0,    21,     0,  2511,
       0,     0,     0,  3721,    22,  3724,  3726,     0,  2512,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,
       0,  1546,    23,  2071,     0,     0,  2072,  1547,     0,     0,
    2073,  2074,  2075,     0,     0,     0,  1353,  1353,  1353,    24,
       0,     0,  1353,     0,     0,     0,     0,     0,  2573,     0,
     929,     0,     0,     0,   772,     0,     0,     0,  2574,     0,
       0,     0,     0,   929,     0,  2575,     0,     0,     0,  1353,
       0,   929,  1549,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2781,     0,    25,    26,     0,   843,
       0,  2576,    27,     0,     0,  3826,     0,     0,   782,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
     929,  3837,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3721,     0,     0,    29,     0,     0,     0,  1550,     0,
       0,   929,     0,  3859,     0,  1551,     0,     0,  1552,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1553,     0,     0,    30,  3358,
       0,     0,   929,     0,   929,     0,   929,     0,     0,     0,
       0,     0,    31,     0,     0,     0,     0,     0,    32,    33,
       0,    34,     0,     0,     0,     0,    35,     0,     0,     0,
       0,  1554,    36,     0,     0,    37,  2577,     0,     0,  1972,
       0,  2578,    38,     0,     0,     0,     0,     0,     0,    39,
      40,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,     0,     0,  2579,  2262,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2580,     0,    44,     0,     0,
       0,     0,     0,   630,   929,     0,   940,     0,   940,   940,
       0,   929,  1657,     0,     0,     0,  1556,    45,  1353,     0,
       0,     0,     0,  1353,     0,     0,  1557,     0,    46,     0,
       0,     0,     0,     0,    47,  1558,  2320,     0,     0,    48,
       0,     0,     0,     0,     0,     0,     0,  1559,   891,     0,
    2581,     0,    49,  2582,     0,     0,     0,  1119,     0,     0,
       0,     0,     0,     0,     0,  1353,  1353,  1353,     0,     0,
    1353,     0,     0,     0,   891,     0,    50,     0,  1353,  1353,
    1353,  1353,     0,     0,     0,     0,  1685,     0,     0,  1561,
    1562,     0,     0,     0,  1353,    56,     0,  1353,  -136,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1353,  1353,     0,     0,  1353,     0,  1367,     0,     0,     0,
       0,  1686,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,  1353,     0,  1353,     0,  1353,
     772,     0,     0,  2583,     0,   772,   772,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1353,     0,
       0,  4116,     0,     0,     0,   843,     0,     0,     0,     0,
       0,     0,     0,  2591,  1546,     0,     0,     0,     0,     0,
    1547,     0,  2598,     0,  2599,     0,   843,     0,  2602,     0,
    1564,     0,     0,     0,     0,  2608,  1367,     0,     0,     0,
       0,     0,  2071,     0,     0,  2072,     0,     0,     0,  2073,
    2074,  2075,     0,     0,   630,     0,   891,  3409,  4153,     0,
    1367,     0,  4153,  4167,  4153,  1549,     0,  2573,     0,     0,
    1353,     0,     0,     0,     0,  1353,     0,  2574,     0,     0,
    2071,     0,     0,  2072,  2575,  2511,     0,  2073,  2074,  2075,
    1353,     0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,  3409,  2573,     0,  4675,  4198,     0,
    2576,  4201,  3409,     0,  3458,  2574,     0,     0,     0,     0,
       0,  1550,  2575,     0,     0,     0,   772,  3730,  1551,     0,
       0,  1552,     0,     0,     0,     0,   772,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2576,     0,
       0,     0,     0,     0,     0,  1353,     0,     0,  1553,     0,
       0,     0,     0,     0,  3762,     0,  3762,     0,  3762,  3762,
       0,     0,     0,  3762,  3762,  3762,     0,  3762,  3762,  3762,
    1198,  1199,     0,     0,     0,   929,   929,     0,     0,     0,
       0,  1546,     0,     0,  1554,     0,     0,  1547,     0,  1704,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,     0,
    1546,     0,     0,   772,     0,  2577,  1547,   772,   772,   891,
    2578,  3839,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1549,     0,     0,   891,     0,     0,     0,     0,
       0,     0,     0,  2579,  2262,     0,  3867,     0,     0,     0,
       0,     0,     0,  2577,     0,  1657,     0,     0,  2578,  1556,
       0,  1549,     0,     0,  2580,     0,     0,     0,     0,  1557,
       0,     0,     0,     0,     0,     0,     0,     0,  1558,     0,
       0,  2579,  2262,   843,     0,     0,     0,     0,  1550,     0,
    1559,     0,     0,  2849,     0,  1551,     0,     0,  1552,     0,
       0,     0,  2580,     0,     0,  2320,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1550,     0,  2581,
       0,     0,  2582,     0,  1551,  1553,     0,  1552,     0,  2745,
       0,     0,  1561,  1562,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2320,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1553,     0,     0,  2581,     0,     0,
    2582,  1554,     0,     0,  2746,     0,     0,  2071,     0,     0,
    2072,     0,     0,     0,  2073,  2074,  2075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1554,     0,   891,     0,     0,     0,     0,     0,  1353,     0,
       0,     0,  2574,     0,  1353,     0,     0,     0,     0,  2575,
       0,   772,  2583,     0,     0,   929,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2071,  1555,  1564,  2072,  2576,  1556,     0,  2073,  2074,
    2075,     0,     0,     0,     0,     0,  1557,     0,     0,     0,
    2583,     0,   843,   843,   843,  1558,  2573,     0,     0,     0,
       0,  1657,     0,     0,     0,  1556,  2574,  1559,     0,   843,
       0,     0,     0,  2575,     0,  1557,     0,     0,     0,     0,
       0,     0,     0,  1353,  1558,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1559,     0,     0,  2576,
       0,  1972,   843,   843,     0,     0,  2823,   843,     0,  1561,
    1562,     0,     0,     0,  2511,     0,     0,     0,     0,   843,
       0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,     0,     0,     0,  3559,  4781,     0,  1561,  1562,
       0,  2824,     0,     0,     0,     0,  1119,     0,     0,     0,
    2577,     0,  2511,     0,     0,  2578,     0,     0,     0,     0,
       0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,
    1563,     0,     0,     0,  5008,   929,     0,     0, -2885, -2885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3145,
    4573,     0,     0,     0,     0,     0,     0,     0,     0,  2580,
     843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1564,     0,     0,   843,  2577,     0,     0,     0,     0,  2578,
       0,     0,     0,     0,     0,     0,  3204,  3205,     0,     0,
       0,     0,  1353,     0,     0,     0,     0,  3235,  3236,  1564,
   -2885,  1353,  2579,  2262,     0,  2682,     0,     0,     0,     0,
       0,  1353,     0,     0,  2581,  1353,  1353,     0,     0,     0,
       0,  1353,     0,  2580,     0,     0,     0,  3280,     0,  1353,
       0,  1353,     0,     0,  1353,     0,     0,     0,     0,  1353,
    1353,  1353,  1353,     0,     0,  1353,  1353,  1353,  1353,  1353,
    1353,  1353,  1353,  1353,  1353,     0,     0,     0,  1353,  1353,
    1353,     0,     0,     0,  2320,     0,  1119,     0,  1353,     0,
       0,     0,  2682,  1353,     0,     0,     0,  1353,  2581,     0,
       0,  2582,     0,     0,     0,  1353,     0,     0,  1353,     0,
    1353,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,  1353,     0,
       0,  1353,  1353,   891,     0,     0,  1353,  1353,     0,     0,
       0,  1353,     0,  1353,  4703,  1546,     0,     0,     0,     0,
       0,  1547,   843,   843,   843,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4299,     0,   891,     0,     0,     0,
       0,     0,  4153,  4167,  4153,     0,  1353,  4153,     0,     0,
    4724,     0,     0,     0,  3409,     0,     0,     0,  3409,     0,
       0,  2583,     0,     0,  4739,     0,  1549,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1353,     0,  4346,     0,     0,     0,     0,     0,     0,  2511,
       0,     0,     0,     0,     0,  3458,     0,  1353,  2512,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,  1704,  1704,
    1704,     0,  1550,     0,     0,  4787,  1972,  1972,     0,  1551,
    1972,     0,  1552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1553,
    4389,     0,     0,  2511,     0,  2781,  4819,     0,     0,     0,
       0,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,     0,     0,     0,  4842,  5116,     0,     0,     0,   699,
       0,     0,     0,     0,  2732,  1554,  2071,     0,     0,  2072,
       0,     0,     0,  2073,  2074,  2075,  3762,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4420,  4420,
       0,  2573,     0,     0,     0,     0,     0,     0,  4436,     0,
     891,  2574,  2733,  1119,     0,  1119,     0,  4891,  2575,     0,
       0,   891,     0,     0,     0,   702,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   891,     0,     0,
       0,   703,     0,     0,  2576,     0,  1657,     0,     0,     0,
    1556,     0,     0,     0,     0,     0,     0,     0,     0,  1034,
    1557,  4491,     0,     0,     0,     0,     0,     0,     0,  1558,
       0,     0,  4935,     0,     0,     0,  1546,     0,     0,     0,
       0,  1559,  1547,  2734,     0,     0,     0,     0,     0,     0,
       0,   891,     0,     0,   706,     0,  4527,  1119,     0,     0,
       0,     0,     0,   707,  2071,   929,   891,  2072,     0,   891,
     891,  2073,  2074,  2075,     0,     0,   708,     0,     0,   929,
    3737,  1353,  2735,  1561,  1562,     0,     0,  1549,   843,  2573,
       0,     0,     0,     0,  4979,     0,     0,     0,     0,  2574,
     891,   891,     0,     0,     0,  2781,  2575,     0,     0,  1037,
       0,     0,     0,     0,     0,  3738,     0,     0,     0,  2577,
     843,     0,     0,     0,  2578,  3409,  3837,     0,     0,     0,
       0,     0,  2576,  3721,     0,     0,     0,     0,     0,     0,
       0,     0,  5028,  1550,     0,     0,     0,  2579,  2262,     0,
    1551,     0,   843,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,   712,     0,  1353,  1353,     0,     0,  2580,     0,
       0,     0,     0,     0,     0,  1353,     0,     0,     0,     0,
    1553,     0,     0,     0,  1564,     0,  1972,   843,     0,  3380,
    3382,     0,     0,     0,     0,  3390,     0,     0,  1704,     0,
       0,     0,     0,  2736,   843,     0,     0,  1704,     0,  2320,
    1704,     0,     0,     0,     0,     0,  1554,     0,     0,     0,
       0,     0,     0,  2581,     0,     0,  2582,  3433,  3433,     0,
       0,     0,     0,     0,     0,   891,     0,   213,  2737,     0,
       0,   717,     0,     0,     0,  1353,     0,  2577,     0,     0,
       0,  4676,  2578,     0,     0,     0,     0,     0,  1353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  2738,  1353,     0,     0,  2579,  2262,     0,   721,     0,
       0,     0,     0,     0,     0,   722,     0,  1657,   723,   772,
       0,  1556,     0,     0,     0,     0,  2580,     0,     0,     0,
    1353,  1557,     0,  1353,     0,     0,     0,   724,     0,     0,
    1558,  1353,  1353,     0,  1043,     0,  2583,     0,  1353,  1353,
       0,   726,  1559,  1353,  1044,     0,     0,     0,   728,     0,
    1353,     0,     0,  1353,  1353,     0,  2739,  2320,     0,     0,
    1353,     0,     0,  2740,   843,   843,   843,   843,     0,     0,
       0,  2581,     0,     0,  2582,     0,     0,     0,     0,     0,
     630,  4251,     0,  4153,  1561,  1562,     0,  3409,     0,   733,
       0,     0,  3409,  3566,     0,  3409,   630,     0,  3721,     0,
    5190,     0,     0,  1353,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,  1353,     0,  4252,     0,  4198,     0,
       0,     0,  1353,     0,  3458,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2511,   782,
       0,     0,  1353,     0,     0,     0,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,  2071,
    5155,     0,  2072,     0,  2583,     0,  2073,  2074,  2075,     0,
       0,     0,     0,     0,     0,     0,  2781,     0,     0,     0,
    5245,     0,   772,     0,  2573,  1564,     0,     0,     0,     0,
     772,     0,     0,   772,  2574,     0,     0,     0,     0,     0,
    4436,  2575,     0,     0,     0,   772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4881,  2576,     0,     0,
       0,     0,     0,     0,   699,     0,     0,     0,     0,  3183,
       0,  4895,     0,     0,  4896,  1353,  4897,     0,     0,     0,
       0,     0,  1353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2511,     0,     0,     0,
       0,     0,     0,     0,   929,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,     0,     0,     0,     0,  5159,   929,
     702,  3184,  4937,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   703,     0,  3762,     0,
    1546,     0,     0,  3762,     0,     0,  1547,     0,     0,     0,
    1353,     0,     0,     0,  1034,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   630,     0,     0,     0,
       0,     0,  2577,  2781,     0,     0,     0,  2578,  3185,     0,
       0,     0,  1972,     0,     0,     0,     0,     0,     0,   706,
       0,  1549,     0,     0,     0,     0,     0,  3837,   707,     0,
    2579,  2262,     0,     0,     0,     0,     0,     0,     0,     0,
     929,   708,  3859,     0,     0,     0,     0,  3186,     0,     0,
       0,  2580,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   843,     0,
       0,     0,  5042,     0,  1037,  4436,     0,  1550,  1704,   843,
       0,     0,     0,     0,  1551,     0,     0,  1552,     0,     0,
       0,     0,  2320,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3187,  2581,     0,     0,  2582,
       0,   772,     0,     0,  1553,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   712,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1353,     0,     0,
    1353,     0,     0,  1353,  1353,  1353,     0,     0,     0,     0,
    1554,  5091,  5091,  5091,  5091,     0,  5091,  5091,  5091,  5091,
    5091,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1353,  1353,     0,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1353,     0,     0,     0,     0,  2583,
    1353,     0,   213,  3188,  3409,     0,   717,     0,  5190,     0,
       0,  1353,     0,  5470,     0,  3465,     0,     0,     0,  2682,
    3471,  1657,     0,     0,  4787,  1556,     0,  1353,     0,     0,
       0,     0,     0,  1041,     0,  1557,  3189,     0,  4787,   976,
     929,     0,   929,   721,  1558,     0,     0,     0,     0,     0,
     722,     0,     0,   723,     0,     0,  1559,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5167,
       0,  5169,   724,     0,     0,     0,     0,   891,     0,  1043,
       0,     0,     0,   891,     0,     0,   726,     0,     0,  1044,
     940,   976,     0,   728,     0,  4309,     0,     0,  1561,  1562,
       0,  2511,     0,     0,     0,     0,     0,     0,  3190,     0,
    2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,
       0,     0,     0,  5410,   891,     0,  4129,     0,   772,     0,
    4310,     0,     0,     0,   733,   940,     0,     0,     0,     0,
       0,     0,     0,     0,  4136,     0,     0,  4979,     0,     0,
       0,     0,   843,     0,     0,     0,     0,   843,     0,     0,
       0,     0,     0,     0,     0,     0,  2781,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   843,     0,     0,     0,
    5028,     0,     0,  5609,     0,     0,     0,     0,     0,     0,
       0,  4182,  4182,     0,   929,   843,  4787,     0,     0,  1564,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,     0,     0,     0,  1353,     0,  1353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,     0,     0,     0,     0,     0,     0,   630,
       0,     0,  1353,     0,     0,     0,  5678,     0,     0,     0,
       0,     0,     0,  1353,     0,     0,     0,     0,     0,     0,
    1353,     0,     0,     0,     0,     0,     0,     0,     0,  5298,
    5299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1704,  3762,     0,  3762,  3762,  3762,     0,     0,     0,
       0,     0,     0,     0,     0,   843,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
       0,  1353,     0,     0,     0,     0,     0,  1353,  1353,     0,
       0,     0,   929,   929,   929,   929,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5350,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1353,     0,     0,     0,     0,     0,     0,
       0,   630,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2682,     0,     0,  5378,
    2682,     0,     0,     0,     0,     0,   843,     0,     0,  3409,
       0,  2071,     0,     0,  2072,     0,     0,     0,  2073,  2074,
    2075,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   843,     0,  2573,     0,     0,     0,
       0,     0,  5091,     0,     0,     0,  2574,     0,     0,     0,
       0,     0,     0,  2575,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,     0,     0,     0,     0,     0,     0,     0,
       0,  1353,  1353,  1353,     0,     0,     0,  1972,     0,  2576,
       0,  3721,     0,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,  1353,     0,  1353,     0,  1353,  5470,     0,
       0,     0,     0,   891,  4787,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1972,     0,   976,     0,   891,     0,
       0,     0,     0,   891,     0,  1353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     772,   891,     0,     0,     0,     0,     0,     0,     0,     0,
    1972,  1972,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4470,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   929,     0,     0,  2577,     0,     0,     0,     0,  2578,
       0,     0,     0,     0,     0,  5939,  4436,   638,     0,     0,
       0,     0,     0,   687,   638,     0,     0,     0,     0,   739,
       0,   638,  2579,  2262,     0,     0,     0,   638,     0,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,  2580,     0,     0,     0,     0,   854,   854,
       0,     0,  3762,     0,     0,  1353,     0,     0,     0,  5678,
       0,  5556,     0,     0,     0,  1353,     0,     0,     0,  2071,
       0,     0,  2072,     0,  3458,  1353,  2073,  2074,  2075,     0,
       0,     0,     0,     0,  2320,     0,     0,     0,     0,     0,
       0,   940,     0,     0,  2573,     0,     0,     0,  2581,     0,
       0,  2582,     0,     0,  2574,     0,   929,     0,     0,     0,
       0,  2575,     0,  1972,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     772,     0,     0,     0,     0,     0,     0,  2576,  2781,     0,
       0,     0,     0,     0,     0,  1353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4787,     0,     0,     0,     0,
       0,     0,     0,   940,   940,  6057,     0,     0,     0,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1972,  1972,  6067,     0,     0,     0,     0,  1353,  1353,
       0,  2583,     0,     0,  6073,     0,     0,  2682,     0,   931,
    3471,     0,  3471,   935,     0,     0,     0,  2682,     0,     0,
       0,   978,     0,     0,   980,     0,   929,   985,   986,     0,
     989,     0,   992,     0,     0,   998,     0,  1000,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5939,   929,   929,     0,     0,
       0,  4787,  2577,     0,     0,   891,     0,  2578,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,   630,
    1353,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2579,  2262,     0,     0,  1353,     0,     0,     0,  2682,     0,
    1119,     0,     0,  2511,  5747,     0,     0,     0,  1353,     0,
       0,  2580,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,     0,     0,     0,     0,  5421,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6151,  6152,   630,  6155,  5678,     0,     0,  3458,     0,
       0,     0,  2320,     0,     0,     0,     0,     0,     0,     0,
     929,     0,     0,  4787,     0,     0,  2581,     0,   891,  2582,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4198,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,   630,     0,     0,     0,  1353,     0,     0,
       0,   630,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   940,   940,     0,     0,  6217,     0,     0,
       0,     0,  2071,     0,     0,  2072,     0,     0,     0,  2073,
    2074,  2075,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2573,     0,  2583,
       0,     0,     0,     0,   891,     0,     0,  2574,     0,     0,
       0,     0,   772,     0,  2575,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1704,     0,     0,     0,     0,     0,  1704,   772,  1119,
    2576,     0,     0,  5901,     0,  5902,   891,     0,     0,  5907,
    5908,     0,   772,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   772,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3471,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2511,     0,     0,     0,     0,     0,     0,     0,     0,
    2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,
       0,     0,     0,  5431,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
    1199,     0,   891,  2071,     0,     0,  2072,     0,     0,     0,
    2073,  2074,  2075,     0,     0,  2577,     0,     0,     0,     0,
    2578,     0,     0,     0,  3471,     0,     0,     0,  2573,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
       0,     0,     0,  2579,  2262,  2575,   891,     0,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,  2580,     0,     0,  1069,     0,     0,
       0,  2576,     0,     0,  1082,  1083,  2071,     0,  1089,  2072,
    1093,  1094,     0,  2073,  2074,  2075,     0,   772,     0,     0,
       0,     0,     0,     0,     0,  1116,     0,     0,     0,     0,
       0,  2573,     0,     0,     0,  2320,     0,     0,     0,     0,
       0,  2574,     0,  1129,     0,     0,     0,     0,  2575,  2581,
       0,     0,  2582,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,  1157,     0,  1159,     0,     0,     0,
     772,     0,     0,     0,  2576,     0,  1175,     0,     0,     0,
    2071,     0,     0,  2072,     0,     0,     0,  2073,  2074,  2075,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1119,
       0,   891,     0,     0,     0,  2573,     0,     0,     0,   638,
       0,     0,     0,     0,     0,  2574,  2577,     0,     0,     0,
       0,  2578,  2575,     0,     0,     0,   891,     0,     0,     0,
       0,  2071,     0,     0,  2072,     0,     0,     0,  2073,  2074,
    2075,     0,  2583,     0,  2579,  2262,     0,     0,  2576,     0,
       0,     0,     0,     0,     0,     0,  2573,     0,     0,   941,
     951,     0,     0,     0,     0,  2580,  2574,   941,     0,   951,
     941,     0,     0,  2575,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,     0,     0,  2577,
     854,     0,     0,     0,  2578,     0,     0,     0,     0,  2576,
       0,     0,     0,     0,     0,     0,  2320,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2579,  2262,     0,
    2581,     0,     0,  2582,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6180,  2580,     0,
    2536,     0,     0,     0,  2511,     0,     0,     0,     0,     0,
       0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,     0,  2577,     0,     0,  5486,     0,  2578,     0,
       0,     0,     0,  1507,     0,     0,     0,     0,     0,  2320,
       0,     0,  6180,     0,     0,     0,  2682,     0,     0,     0,
       0,  2579,  2262,  2581,     0,     0,  2582,     0,     0,     0,
    6180,     0,     0,  5167,     0,     0,     0,     0,     0,     0,
       0,     0,  2580,  2583,  2577,     0,     0,     0,     0,  2578,
       0,     0,   772,     0,     0,     0,     0,     0,   772,     0,
       0,     0,   772,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2579,  2262,     0,     0,     0,  1688,     0,     0,
       0,     0,     0,  2320,     0,     0,     0,     0,     0,  5270,
    5271,     0,     0,  2580,  5274,  5275,     0,  2581,     0,     0,
    2582,     0,  1809,     0,     0,     0,  3471,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,  1821,     0,  1822,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1825,
       0,     0,  3471,     0,  2320,     0,  1835,     0,     0,     0,
       0,     0,     0,     0,     0,  2511,     0,     0,  2581,     0,
       0,  2582,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,     0,     0,     0,  5520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1887,
       0,  1889,     0,     0,  2071,     0,     0,  2072,     0,     0,
    2583,  2073,  2074,  2075,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2573,
       0,     0,     0,     0,     0,     0,     0,     0,  2511,  2574,
       0,     0,     0,     0,     0,     0,  2575,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,     0,
    5522,  2583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2576,     0,     0,   638,     0,   638,     0,   638,
       0,   638,     0,   638,   638,   638,     0,     0,     0,     0,
     638,     0,     0,     0,   891,     0,     0,     0,     0,     0,
       0,     0,  1993,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2511,     0,     0,     0,     0,     0,     0,     0,
       0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,
       0,     0,     0,     0,  5561,     0,     0,     0,     0,     0,
       0,  3471,     0,     0,     0,   951,  2682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2511,   951,     0,     0,     0,     0,     0,
     951,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,     0,   951,     0,     0,  5889,     0,  2577,     0,     0,
       0,     0,  2578,     0,     0,     0,     0,     0,   951,     0,
       0,     0,  2071,     0,     0,  2072,     0,     0,     0,  2073,
    2074,  2075,   941,   951,     0,  2579,  2262,     0,     0,   941,
       0,   951,   941,     0,     0,     0,     0,  2573,     0,     0,
       0,     0,     0,     0,     0,   951,  2580,  2574,     0,     0,
       0,     0,     0,     0,  2575,   951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2576,     0,     0,     0,     0,     0,     0,  2320,     0,     0,
       0,     0,   854,     0,     0,     0,     0,     0,     0,     0,
       0,  2581,     0,  2071,  2582,     0,  2072,   891,   951,     0,
    2073,  2074,  2075,     0,     0,     0,     0,     0,   772,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2573,     0,
       0,     0,     0,     0,     0,     0,   951,     0,  2574,     0,
       0,     0,     0,     0,     0,  2575,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,  2577,     0,     0,     0,     0,
    2578,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2743,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,  2579,  2262,     0,     0,     0,     0,     0,
       0,     0,     0,   891,     0,   890,     0,     0,     0,     0,
       0,     0,     0,     0,  2580,     0,     0,     0,     0,     0,
       0,     0,  2071,     0,     0,  2072,     0,     0,     0,  2073,
    2074,  2075,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,  2573,     0,     0,
       0,     0,     0,     0,  2835,  2320,  2577,  2574,     0,     0,
       0,  2578,     0,     0,  2575,   891,  2511,     0,     0,  2581,
       0,     0,  2582,     0,     0,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,  2579,  2262,     0,     0,  5911,     0,
    2576,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1791,     0,     0,     0,  2580,     0,     0,   951,     0,
       0,     0,     0,  2071,     0,     0,  2072,     0,     0,   941,
    2073,  2074,  2075,   941,     0,   941,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   891,  2573,     0,
       0,     0,     0,     0,     0,     0,  2320,     0,  2574,     0,
       0,     0,     0,     0,     0,  2575,     0,     0,     0,     0,
    2581,     0,  2583,  2582,     0,     0,     0,     0,     0,     0,
       0,     0,   772,     0,     0,     0,     0,     0,     0,     0,
       0,  2576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   928,
     930,     0,     0,   933,     0,  2577,     0,     0,     0,     0,
    2578,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   991,     0,     0,     0,     0,     0,     0,
    1001,     0,   951,  2579,  2262,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,  2580,     0,  5382,     0,   891,     0,
       0,     0,     0,     0,  2511,     0,     0,     0,     0,     0,
       0,     0,  2965,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,     0,     0,     0,     0,  6099,     0,     0,     0,
       0,     0,     0,   951,     0,  2320,  2577,     0,     0,     0,
       0,  2578,     0,     0,   951,     0,     0,  3001,     0,  2581,
       0,     0,  2582,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,     0,  2579,  2262,   951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2580,     0,     0,     0,     0,
       0,     0,     0,  3066,     0,  2511,     0,     0,     0,     0,
       0,  5895,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  3084,     0,     0,     0,  6116,     0,     0,
       0,     0,     0,     0,     0,     0,  2320,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,  3104,
    2581,  3105,  2583,  2582,     0,     0,  2071,     0,     0,  2072,
       0,     0,     0,  2073,  2074,  2075,  3114,     0,  3115,     0,
       0,     0,     0,     0,   638,     0,   638,     0,   638,     0,
     638,  2573,   638,     0,     0,  3416,   638,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,     0,     0,  2575,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,   951,
     951,     0,  3471,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3174,  2576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,   881,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2511,     0,     0,     0,     0,     0,
       0,     0,  1791,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,     0,     0,     0,  3417,  6157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2071,     0,     0,  2072,
       0,     0,     0,  2073,  2074,  2075,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2574,  3471,     0,     0,     0,     0,     0,  2575,  2577,
       0,     0,     0,     0,  2578,  2511,     0,     0,     0,     0,
       0,     0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,  2576,  2961,     0,  2579,  2262,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2071,     0,     0,  2072,     0,  2580,     0,
    2073,  2074,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1061,     0,  1064,     0,     0,  1066,  2573,   890,
       0,     0,     0,     0,     0,     0,     0,     0,  2574,     0,
       0,  1092,     0,     0,     0,  2575,     0,  1096,     0,  2320,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,  2581,     0,     0,  2582,     0,     0,     0,
       0,  2576,     0,     0,  4048,     0,     0,     0,     0,     0,
    4049,     0,     0,     0,   891,     0,     0,     0,     0,   891,
     891,     0,     0,     0,     0,     0,     0,     0,     0,  2577,
       0,     0,     0,     0,  2578,     0,     0,     0,     0,  2071,
       0,     0,  2072,     0,     0,     0,  2073,  2074,  2075,     0,
       0,     0,     0,     0,     0,     0,     0,  2579,  2262,     0,
       0,     0,     0,   951,  2573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2574,     0,     0,     0,  2580,  6179,
       0,  2575,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,  2071,     0,     0,  2072,     0,
       0,     0,  2073,  2074,  2075,     0,     0,  2576,     0,     0,
       0,     0,     0,     0,     0,     0,  2577,     0,     0,  2320,
    2573,  2578,     0,  3985,  6179,     0,     0,   890,     0,     0,
    2574,  5382,   891,  2581,     0,     0,  2582,  2575,     0,     0,
       0,     0,  6179,     0,  2579,  2262,     0,  3418,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2576,     0,  2580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,   891,     0,     0,     0,     0,     0,     0,  2511,     0,
       0,     0,     0,     0,     0,     0,  5965,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,  2320,     0,     0,     0,
       0,     0,     0,  1791,     0,     0,     0,     0,     0,     0,
    2581,     0,  2577,  2582,     0,     0,  4050,  2578,     0,     0,
       0,     0,   950,     0,     0,     0,   951,     0,     0,     0,
       0,   950,     0,     0,   951,     0,     0,     0,  4667,     0,
    2579,  2262,   951,     0,     0,   950,     0,     0,     0,     0,
       0,     0,  1578,  1579,     0,     0,     0,     0,     0,     0,
       0,  2580,     0,     0,     0,     0,     0,     0,  2577,     0,
       0,     0,     0,  2578,     0,     0,     0,     0,     0,   890,
       0,     0,     0,   941,   941,     0,   951,   951,     0,     0,
     890,     0,     0,     0,     0,     0,  2579,  2262,   941,     0,
     951,   941,  2320,  2583,     0,     0,   890,     0,     0,     0,
       0,     0,     0,   951,   951,     0,  2581,  2580,  2511,  2582,
    4668,     0,     0,  1808,     0,     0,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,     0,  1820,     0,
       0,     0,  5966,     0,     0,     0,     0,     0,     0,     0,
       0,   941,     0,     0,     0,   941,   941,     0,  2320,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1842,
    1843,     0,  2581,     0,     0,  2582,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1880,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2511,     0,     0,     0,  2583,
       0,     0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,     0,  3461,  3462,     0,     0,     0,
       0,     0,     0,     0,     0,  1918,  1920,     0,   881,     0,
       0,     0,     0,     0,  3477,  3478,     0,  3480,  3481,     0,
       0,     0,  3484,  3485,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,   881,  2583,  1791,  3496,     0,     0,
       0,     0,     0,     0,  3505,     0,     0,     0,  3508,  3509,
       0,     0,  3512,  3513,     0,     0,     0,     0,     0,  3518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3533,     0,   699,     0,     0,     0,     0,   700,     0,
       0,  2511,     0,  3550,     0,     0,     0,     0,  3552,     0,
    2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,
       0,  2071,     0,  3558,  2072,     0,     0,     0,  2073,  2074,
    2075,     0,  3565,     0,     0,  3569,   701,  3571,  3574,  3576,
       0,     0,     0,     0,  3584,  3587,  2573,     0,     0,   702,
       0,     0,     0,     0,  3600,     0,  2574,  2511,     0,     0,
    3610,     0,     0,  2575,  3613,   703,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,     0,  3623,  3624,     0,     0,
       0,  3629,     0,   704,     0,     0,     0,  3638,  3639,  2576,
       0,     0,     0,     0,     0,     0,   881,     0,     0,     0,
       0,  3648,     0,     0,  3649,  2552,     0,   705,     0,     0,
       0,  3661,  3662,     0,     0,     0,     0,  3666,   706,     0,
       0,     0,     0,     0,     0,     0,     0,   707,     0,  3673,
       0,     0,  3676,     0,     0,     0,     0,  3679,     0,     0,
     708,     0,     0,  3682,  3683,     0,   709,   950,     0,     0,
       0,  3689,     0,   710,     0,  3691,     0,     0,     0,  3698,
    3699,  3700,  3701,     0,  3703,  1704,   950,     0,     0,     0,
       0,     0,   950,   711,     0,     0,     0,  3728,  3729,     0,
    3731,     0,     0,     0,   950,     0,     0,  2071,     0,     0,
    2072,  3740,  3741,  3742,  2073,  2074,  2075,     0,     0,     0,
     950,     0,     0,     0,  2577,     0,   890,     0,     0,  2578,
       0,     0,  2573,     0,     0,   950,     0,     0,     0,     0,
       0,     0,  2574,   950,     0,     0,   712,     0,     0,  2575,
       0,     0,  2579,  2262,     0,     0,     0,   950,     0,     0,
       0,     0,     0,     0,   883,     0,     0,   950,  3794,     0,
       0,     0,     0,  2580,     0,  2576,  3818,     0,   881,     0,
       0,     0,     0,     0,     0,     0,     0,   713,     0,   881,
       0,     0,     0,   890,     0,  3830,     0,     0,     0,     0,
     714,     0,     0,     0,     0,   881,     0,     0,     0,     0,
       0,   715,     0,     0,  2320,     0,     0,     0,     0,     0,
     950,   213,   716,     0,     0,   717,     0,     0,  2581,     0,
       0,  2582,     0,  2763,   890,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3898,     0,     0,   950,     0,
       0,     0,   718,     0,     0,   719,     0,     0,  2802,   720,
       0,     0,   721,     0,  3912,     0,  3914,   890,     0,   722,
       0,     0,   723,   950,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2577,   724,     0,     0,     0,  2578,     0,     0,   725,     0,
       0,     0,     0,     0,     0,   726,     0,     0,   727,     0,
       0,     0,   728,     0,     0,     0,     0,     0,  2579,  2262,
     729,  2583,   730,     0,     0,     0,     0,   731,     0,     0,
       0,     0,     0,   950,     0,     0,     0,  2892,     0,  2580,
     732,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   733,     0,     0,     0,     0,     0,     0,
       0,  3976,   881,     0,     0,     0,     0,  2918,  2919,  2920,
    2921,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2320,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1791,  2581,     0,     0,  2582,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4021,     0,     0,     0,
       0,     0,  3995,  2511,     0,     0,     0,     0,     0,     0,
       0,     0,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,     0,     0,  1790,     0,     0,     0,     0,   951,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,   951,     0,     0,     0,
     951,     0,   890,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,  2583,   890,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2974,  2975,     0,     0,   941,     0,
     941,   941,     0,     0,     0,     0,     0,     0,     0,     0,
    2992,     0,     0,     0,     0,   951,     0,     0,     0,     0,
       0,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,   951,   890,     0,     0,
     890,   890,     0,     0,  3035,  3036,  3037,  3038,     0,     0,
       0,     0,     0,     0,   950,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1791,   951,     0,  2511,
    1791,   890,   890,     0,     0,     0,     0,     0,  2512,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,
       0,     0,     0,     0,   951,   881,  1791,     0,     0,     0,
     951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   951,   950,     0,     0,     0,     0,
       0,   951,     0,     0,   951,  3112,   950,     0,     0,     0,
     951,  3116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,  4224,     0,   950,     0,
     951,     0,     0,     0,     0,     0,   951,     0,     0,     0,
       0,     0,   881,   951,     0,     0,  4236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
       0,     0,     0,  4243,     0,     0,     0,  4243,     0,     0,
     951,     0,  4254,  4255,  4256,  1791,     0,     0,     0,     0,
       0,   951,     0,   881,     0,     0,   890,     0,     0,     0,
       0,     0,     0,     0,     0,  2071,     0,     0,  2072,     0,
       0,     0,  2073,  2074,  2075,     0,     0,     0,  4286,  4287,
    4288,  4289,     0,     0,     0,     0,   881,     0,     0,     0,
    2573,     0,     0,  4053,     0,     0,     0,     0,     0,     0,
    2574,     0,     0,     0,     0,     0,     0,  2575,  4305,     0,
       0,  1791,     0,     0,     0,     0,  4308,     0,  4312,  4313,
    4314,     0,     0,   950,     0,     0,     0,     0,     0,     0,
       0,   950,   950,  2576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2071,     0,   883,  2072,
       0,     0,     0,  2073,  2074,  2075,     0,     0,     0,     0,
       0,     0,  3292,     0,     0,     0,     0,     0,     0,     0,
       0,  2573,     0,     0,   883,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,  1790,     0,     0,     0,  2575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,  2576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4397,     0,     0,     0,     0,     0,
       0,     0,     0,  4403,     0,     0,     0,     0,  2577,     0,
       0,     0,     0,  2578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,     0,  1791,  4413,
    4414,     0,     0,     0,  4415,     0,  2579,  2262,     0,     0,
     881,     0,     0,     0,     0,   951,     0,     0,     0,     0,
       0,   881,   951,     0,     0,     0,  4457,  2580,     0,   941,
       0,   941,   941,     0,     0,     0,     0,   881,     0,     0,
    4058,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2577,
       0,     0,     0,     0,  2578,     0,     0,     0,  2320,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4494,     0,
       0,     0,  2581,  4500,     0,  2582,     0,  2579,  2262,  4506,
       0,   881,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   881,     0,  2580,   881,
     881,     0,  1791,     0,     0,     0,     0,     0,  1791,  4545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     881,   881,     0,     0,     0,     0,     0,     0,  4560,  2320,
    4561,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2581,     0,   950,  2582,     0,     0,     0,
       0,     0,     0,     0,     0,  2583,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2071,     0,     0,  2072,
       0,     0,   951,  2073,  2074,  2075,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   883,
       0,  2573,     0,     0,  4065,     0,     0,     0,     0,     0,
       0,  2574,     0,     0,     0,   883,     0,     0,  2575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,  2576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   881,     0,  2511,     0,     0,
     950,     0,     0,     0,     0,     0,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,   951,     0,     0,     0,  3292,   950,     0,
       0,     0,     0,     0,     0,     0,   950,     0,     0,     0,
       0,     0,     0,     0,   950,     0,     0,     0,  2511,   951,
       0,     0,   951,     0,     0,     0,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,  2577,
       0,     0,     0,     0,  2578,     0,   890,     0,     0,     0,
     890,   890,   883,     0,     0,     0,     0,     0,   950,   950,
       0,     0,     0,     0,     0,     0,     0,  2579,  2262,     0,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,   950,     0,  2580,     0,
       0,     0,     0,     0,  1791,  1791,  1791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   890,     0,
       0,     0,     0,     0,   890,     0,     0,     0,  4791,   951,
       0,  4798,     0,  4799,  2071,     0,     0,  2072,     0,  2320,
       0,  2073,  2074,  2075,   886,     0,  4806,     0,   951,     0,
       0,     0,     0,  2581,     0,     0,  2582,     0,  4812,  2573,
       0,     0,  4815,     0,     0,   890,     0,     0,     0,  2574,
     951,     0,  3532,     0,     0,     0,  2575,     0,     0,     0,
       0,  4841,     0,     0,     0,     0,     0,  2071,     0,     0,
    2072,     0,     0,     0,  2073,  2074,  2075,     0,     0,  4845,
       0,     0,  2576,     0,     0,  4849,     0,     0,     0,     0,
       0,     0,  2573,     0,     0,  4674,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,  2575,
    4884,     0,     0,     0,  4888,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,  1790,  4898,
    4899,  4900,  4901,     0,     0,  2576,   951,     0,     0,  4905,
    4906,  4907,  4908,   884,     0,     0,     0,     0,  4910,  4911,
       0,     0,     0,     0,  4918,  4919,     0,  4921,  4922,  4923,
    4924,  4925,  4926,  4927,     0,     0,     0,     0,     0,   884,
       0,     0,     0,  4936,     0,     0,     0,  4939,  4940,  4941,
    4942,     0,     0,  1791,     0,     0,     0,     0,     0,   951,
    3672,   951,     0,  3675,     0,   883,     0,  2577,     0,     0,
       0,  4243,  2578,     0,   951,     0,   951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4962,
       0,     0,     0,     0,     0,  2579,  2262,     0,  2511,     0,
       0,     0,     0,     0,     0,     0,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,  2580,     0,     0,     0,
    2577,     0,     0,     0,   890,  2578,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,     0,  2579,  2262,
       0,  3766,     0,     0,     0,     0,     0,  2320,     0,     0,
       0,     0,     0,     0,  3779,  5043,     0,     0,     0,  2580,
       0,  2581,  3788,   883,  2582,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,   951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,  4243,     0,
       0,   890,     0,     0,   951,  5068,   883,  5069,   951,     0,
    2320,  3832,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2581,     0,     0,  2582,     0,   951,
       0,     0,  3856,     0,     0,  5084,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3911,     0,  3913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,   881,     0,  4605,     0,   881,
     881,     0,     0,     0,   890,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,   890,
       0,     0,     0,     0,   890,     0,     0,     0,  1791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,   890,     0,   884,     0,     0,   881,     0,     0,
       0,     0,     0,   881,     0,  3968,  2511,     0,     0,     0,
     884,     0,  3975,     0,     0,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     883,     0,     0,     0,   881,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,     0,     0,  2511,
       0,     0,     0,     0,     0,     0,     0,   883,  2512,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5234,  5235,  5236,     0,     0,     0,  5237,  5238,  5239,  5240,
       0,     0,     0,  5242,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,   883,
     883,  5262,  5263,  5264,  5265,  5266,     0,  5268,  5269,   951,
       0,     0,     0,     0,     0,  1790,     0,     0,     0,  5278,
    5279,     0,     0,     0,     0,     0,     0,   884,     0,     0,
     883,   883,     0,     0,     0,     0,  2071,     0,     0,  2072,
       0,     0,     0,  2073,  2074,  2075,     0,     0,   886,     0,
       0,     0,     0,  5285,     0,     0,     0,     0,     0,     0,
    1791,  2573,     0,     0,     0,  1791,     0,  1791,     0,     0,
     950,  2574,     0,     0,   886,     0,     0,     0,  2575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,     0,
       0,  1791,   950,     0,     0,     0,   950,     0,   890,     0,
       0,   890,     0,   890,  2576,   950,     0,     0,   890,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
     951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5348,   890,   950,     0,     0,
       0,     0,     0,     0,   890,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,   950,     0,
       0,     0,     0,     0,     0,     0,   881,     0,     0,   890,
     881,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5117,     0,     0,     0,     0,     0,  4239,  4240,  1790,   950,
       0,     0,  1790,     0,     0,     0,   886,     0,     0,  2577,
    5399,     0,     0,     0,  2578,     0,     0,     0,     0,     0,
     951,   951,     0,     0,     0,     0,   950,     0,  1790,     0,
       0,   951,   950,     0,     0,     0,     0,  2579,  2262,     0,
       0,     0,  5405,     0,     0,     0,   950,     0,   951,   890,
       0,   890,     0,   950,     0,     0,   950,     0,  2580,     0,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,   881,     0,     0,     0,     0,   950,     0,
       0,     0,     0,     0,     0,   950,     0,     0,   881,  2320,
       0,     0,     0,   881,     0,     0,     0,     0,     0,   950,
       0,     0,     0,  2581,     0,     0,  2582,     0,     0,     0,
       0,     0,   950,     0,     0,     0,     0,  1790,     0,   951,
       0,   881,  1791,   950,     0,     0,   638,   884,     0,     0,
       0,     0,     0,     0,     0,   890,   889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   884,   886,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,  1790,     0,   886,     0,     0,     0,     0,
    5509,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,   884,     0,     0,     0,   890,     0,     0,     0,  5519,
       0,     0,     0,     0,     0,  5525,  5526,     0,     0,     0,
       0,   887,     0,     0,     0,  5537,  4410,     0,     0,     0,
       0,     0,  5539,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5591,  5592,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
    5600,     0,  5602,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   890,     0,  5616,  2511,     0,
       0,     0,     0,     0,     0,     0,     0,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,  2520,     0,   890,     0,     0,
       0,     0,  4243,     0,     0,     0,     0,     0,     0,     0,
    5650,     0,     0,     0,     0,     0,     0,     0,   950,     0,
    1790,     0,   886,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,   950,     0,     0,
       0,     0,     0,     0,   950,     0,     0,   881,     0,     0,
     881,     0,   881,     0,     0,     0,     0,   881,     0,     0,
       0,     0,     0,     0,     0,     0,  4563,     0,     0,   887,
       0,     0,     0,     0,     0,   884,     0,     0,     0,   890,
     951,     0,     0,     0,  5692,     0,   884,     0,     0,     0,
       0,     0,   951,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,   881,     0,     0,  5712,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,  5719,
       0,     0,   890,     0,     0,     0,   951,     0,     0,     0,
       0,     0,     0,     0,  1790,     0,     0,     0,   881,     0,
    1790,     0,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,   884,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5778,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1791,   884,   884,     0,   881,     0,
     881,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,   950,   883,     0,     0,     0,   883,
     883,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,     0,  1546,     0,     0,     0,     0,     0,
    1547,     0,     0,     0,     0,     0,  4243,  1613,   887,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,     0,     0,   954,  1614,
       0,     0,     0,     0,     0,     0,     0,   883,     0,     0,
     988,     0,     0,   883,     0,  1549,     0,     0,     0,     0,
       0,  1007,     0,     0,   881,     0,     0,   890,     0,   951,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5877,     0,     0,     0,     0,     0,     0,     0,
    1615,     0,     0,     0,   883,     0,  5890,     0,     0,     0,
     884,     0,   886,     0,     0,     0,   881,     0,     0,     0,
       0,  1550,     0,     0,   950,   950,     0,     0,  1551,     0,
       0,  1552,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   881,     0,     0,     0,     0,     0,
       0,   950,     0,   886,   950,     0,     0,     0,  1553,     0,
       0,     0,     0,     0,     0,  5929,     0,   890,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,   886,     0,     0,     0,
    1616,     0,     0,   890,  1554,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,     0,   951,     0,     0,
       0,     0,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1790,  1790,  1790,     0,
       0,     0,     0,     0,   881,     0,     0,     0,     0,     0,
     889,  1617,     0,     0,     0,     0,  1618,     0,     0,     0,
    1619,   950,     0,   951,     0,     0,   881,     0,     0,  6004,
       0,     0,     0,   941,     0,  1620,   889,     0,     0,  1556,
     950,     0,     0,     0,     0,     0,     0,     0,     0,  1557,
       0,     0,     0,     0,     0,     0,     0,     0,  1558,     0,
       0,  6016,   950,     0,     0,     0,     0,     0,     0,  1621,
    1559,     0,  6026,  1791,     0,     0,     0,     0,   941,     0,
       0,     0,     0,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   890,  4959,     0,   881,  1622,
       0,     0,  1561,  1562,  1623,     0,     0,     0,     0,     0,
    4961,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1624,     0,
       0,     0,     0,     0,  1625,     0,     0,     0,   950,     0,
     886,   881,   890,     0,     0,     0,   883,   890,  1626,     0,
     883,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6093,     0,   881,   886,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1790,     0,     0,     0,     0,
       0,   950,     0,   950,     0,     0,  1627,     0,   887,     0,
       0,     0,     0,  1564,     0,     0,   950,     0,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,     0,     0,   886,
     886,     0,     0,  1027,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,   883,     0,  2071,     0,     0,  2072,     0,
       0,     0,  2073,  2074,  2075,   887,     0,     0,   883,     0,
     886,   886,     0,   883,     0,   950,     0,     0,     0,     0,
    2573,     0,   951,     0,     0,     0,     0,     0,     0,     0,
    2574,     0,     0,     0,     0,     0,   951,  2575,   890,     0,
       0,   883,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,     0,     0,
       0,     0,     0,  2576,     0,     0,   881,  1791,     0,     0,
     889,     0,     0,     0,     0,     0,   950,     0,     0,   887,
     950,   889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,   950,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   881,     0,     0,  5123,
    1360,     0,     0,     0,   890,     0,     0,     0,  1791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2577,  1383,
       0,     0,   881,  2578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1790,     0,     0,     0,   890,     0,  2579,  2262,     0,     0,
     884,     0,     0,     0,   884,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   890,  2580,     0,     0,
       0,     0,     0,  1791,     0,   951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1441,
       0,     0,     0,     0,   889,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2320,     0,
       0,     0,   884,   887,     0,     0,     0,     0,   884,     0,
       0,     0,  2581,     0,   887,  2582,     0,   883,     0,     0,
     883,     0,   883,     0,     0,     0,  1577,   883,   890,     0,
     887,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,   881,  5293,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5297,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,   883,   887,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,   887,
       0,   881,   887,   887,   941,  2583,   881,     0,   883,     0,
       0,   950,     0,     0,     0,     0,     0,   951,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,   887,     0,     0,     0,     0,     0,
       0,  1840,     0,     0,     0,     0,     0,     0,     0,   890,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5355,  1790,     0,     0,     0,     0,  1790,     0,  1790,
    1874,  1877,  1878,     0,     0,     0,   941,   941,   883,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2511,     0,     0,
       0,     0,     0,     0,     0,     0,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,     0,   889,     0,   950,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   881,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,     0,     0,     0,   883,     0,     0,     0,     0,  1360,
       0,     0,     0,     0,   890,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,  2071,     0,   883,  2072,     0,     0,
       0,  2073,  2074,  2075,     0,     0,     0,     0,     0,     0,
       0,   884,   950,   950,     0,   884,     0,     0,     0,  2573,
       0,     0,     0,   950,   883,   889,     0,     0,     0,  2574,
       0,     0,     0,   890,     0,     0,  2575,     0,     0,     0,
     950,  5492,     0,  5494,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1791,     0,     0,     0,     0,   889,     0,
       0,     0,  2576,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2071,     0,
       0,  2072,   883,     0,     0,  2073,  2074,  2075,  1791,     0,
       0,     0,     0,   881,     0,     0,   941,   941,     0,     0,
       0,     0,     0,  2573,   883,     0,  1791,     0,   884,     0,
       0,   950,     0,  2574,  1790,   881,     0,     0,     0,     0,
    2575,     0,  2567,   884,     0,     0,   883,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5124,   890,     0,   886,  2576,     0,     0,   886,
     886,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2577,     0,     0,
       0,     0,  2578,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5621,     0,   881,     0,     0,
       0,     0,     0,     0,     0,  2579,  2262,     0,     0,     0,
       0,     0,  2658,     0,     0,     0,     0,   886,   883,     0,
       0,     0,     0,   886,     0,  5125,  2580,     0,     0,     0,
       0,     0,     0,  2071,     0,     0,  2072,     0,     0,     0,
    2073,  2074,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,  2573,     0,
       0,   883,     0,   889,   886,     0,     0,  2320,  2574,     0,
       0,  2577,     0,     0,     0,  2575,  2578,     0,     0,   889,
       0,  2581,     0,     0,  2582,   890,   883,     0,     0,     0,
     890,   890,     0,     0,     0,  2775,     0,     0,     0,  2579,
    2262,  2576,     0,     0,  2798,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   881,     0,
    2580,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,  2836,     0,     0,     0,
       0,     0,  2848,  2848,     0,     0,  2848,     0,   889,     0,
       0,   889,   889,     0,  5734,     0,  5736,     0,   950,  2866,
       0,  2320,  2869,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,  2581,     0,     0,  2582,     0,
       0,     0,   889,   889,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,   890,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,   950,   884,  2577,   884,     0,     0,
    2922,  2578,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2941,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2579,  2262,   883,     0,   950,     0,
       0,     0,   890,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2580,     0,     0,  2583,     0,
     884,     0,     0,   886,     0,     0,  2511,     0,   884,     0,
       0,     0,     0,     0,     0,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,  2320,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
    2581,     0,   881,  2582,     0,     0,  1790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,  2963,   950,   886,     0,   887,     0,
     886,     0,   887,   887,     0,  2966,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
    2511,     0,     0,   884,     0,   884,     0,     0,     0,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3010,  2848,     0,
       0,     0,  5925,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,  2583,     0,     0,   887,     0,     0,     0,
       0,     0,  3045,     0,     0,     0,     0,     0,     0,  3058,
       0,   950,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,   884,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5479,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,  3119,     0,   883,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,  2511,     0,  6010,     0,     0,
       0,     0,     0,     0,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,     0,     0,  1360,  1360,     0,     0,   884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,  3173,     0,     0,  3175,   883,   950,     0,   950,
       0,     0,     0,     0,     0,     0,     0,     0,  2071,     0,
       0,  2072,     0,     0,   881,  2073,  2074,  2075,     0,   881,
     881,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2574,     0,   950,     0,   884,     0,     0,
    2575,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6087,     0,   884,
       0,     0,     0,     0,     0,     0,  2576,     0,  2071,     0,
       0,  2072,     0,     0,     0,  2073,  2074,  2075,     0,     0,
       0,   884,     0,     0,     0,  1790,     0,  1092,  1092,     0,
       0,     0,     0,  2573,     0,     0,   887,     0,     0,     0,
       0,     0,     0,  2574,     0,     0,     0,     0,     0,     0,
    2575,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2576,   883,     0,     0,
       0,     0,     0,     0,  1335,  1335,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5652,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,   887,
       0,   881,     0,   887,     0,     0,     0,   886,     0,     0,
     886,  2577,   886,     0,     0,     0,  2578,   886,     0,     0,
       0,  1092,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,     0,  2579,
    2262,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1335,     0,     0,     0,     0,     0,     0,     0,
    2580,   884,     0,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,  2577,     0,     0,     0,     0,  2578,     0,     0,     0,
       0,     0,     0,   883,     0,     0,     0,     0,   886,     0,
       0,  2320,     0,     0,     0,     0,   887,     0,     0,  2579,
    2262,     0,     0,     0,     0,  2581,     0,     0,  2582,     0,
       0,   887,     0,     0,     0,     0,   887,     0,     0,     0,
    2580,     0,     0,   883,   950,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,     0,
       0,     0,     0,     0,   887,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,     0,
     886,  2320,     0,  1701,  1705,     0,     0,   889,     0,  1790,
       0,   889,   889,     0,     0,  2581,     0,     0,  2582,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,   883,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   889,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
    1790,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,     0,     0,     0,
    2511,   884,     0,     0,     0,     0,     0,     0,     0,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,
       0,     0,     0,     0,   886,     0,     0,   884,     0,     0,
       0,     0,  3350,     0,     0,  1790,     0,   950,   883,     0,
       0,     0,  3355,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2511,  1441,     0,     0,     0,     0,     0,     0,     0,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,     0,     0,
     887,     0,   886,   887,     0,   887,     0,     0,     0,     0,
     887,     0,  2022,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,  1441,  1441,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,  2041,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,     0,  1360,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,   950,     0,     0,  2060,  2061,  2062,   884,
    2064,     0,     0,   883,   650,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,   889,     0,     0,     0,   950,
    2529,     0,   651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,   652,   886,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
     653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,  -871,     0,     0,     0,
       0,   887,     0,   887,     0,     0,     0,     0,   889,     0,
       0,   886,   889,     0,   654,     0,     0,     0,     0,     0,
     655,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3568,   886,     0,   656,     0,
       0,     0,     0,  2625,     0,     0,     0,  2637,  2642,   657,
    3590,     0,     0,     0,     0,     0,     0,   950,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   659,  3618,     0,     0,     0,     0,     0,     0,     0,
     660,     0,     0,     0,   661,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0, -1077,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,   889,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
     889,     0,     0,     0,     0,   889,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,   662,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -605,  3696,  3697,
       0,     0,     0,   889,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1546,     0,     0,     0,  1790,   886,  1547,   663,     0,
       0,   664,     0,     0,  1613,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   665,     0,     0,     0,  1614,     0,     0,     0,
       0,     0,     0,     0,     0,   887,   666,     0,     0,     0,
    1790,     0,  1549,  -459,   883,     0,     0,     0,   884,   883,
     883,     0,     0,     0,     0,     0,     0,   887,  1790,  3820,
       0,     0,     0,   667,     0,     0,     0,     0,     0,     0,
    2522,     0,     0,   668,     0,     0,     0,  1615,     0,   887,
    -459,     0,     0,   669,     0,     0,   886,     0,   884,     0,
       0,     0,  1701,  1701,  1701,     0,     0,     0,  1550,     0,
       0,     0,   670,     0,     0,  1551,     0,     0,  1552,   671,
     884,     0,   886,     0,     0,     0,  -459,     0,     0,   672,
     673,     0,   674,   675,     0,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1553,     0,     0,   676,     0,
       0,     0,     0,     0,     0,   677,     0,     0,   678,     0,
       0,   679,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   887,   883,     0,  -459,     0,     0,  1616,     0,     0,
       0,  1554,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,     0,   887,     0,  1030,     0,     0,   889,
       0,   883,   889,     0,   889,     0,     0,     0,  1617,   889,
       0,     0,     0,  1618,     0,     0,     0,  1619,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1620,     0,  1031,     0,  1556,     0,     0,     0,
       0,     0,     0,     0,   886,     0,  1557,   702,  1032,     0,
       0,     0,     0,     0,     0,  1558,     0,   889,     0,  1033,
       0,     0,     0,   703,     0,   889,  1621,  1559,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
     889,   886,     0,   884,     0,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,  1035,  3667,     0,     0,  1561,
    1562,  1623,     0,     0,     0,     0,   706,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1624,     0,     0,   708,     0,
       0,  3668,     0,     0,  1036,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1626,     0,     0,     0,     0,
     889,     0,   889,     0,     0,     0,     0,     0,     0,     0,
       0,  1037,     0,     0,     0,     0,     0,     0,     0,   887,
       0,     0,     0,     0,     0,  4121,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1038,  1627,     0,     0,  1441,     0,     0,     0,
    1564,  3201,     0,     0,     0,     0,     0,     0,     0,     0,
    3221,  3221,  3226,  3232,   712,     0,  2522,  3237,   884,  3238,
    2522,  3240,     0,     0,  3254,  3257,  3262,     0,     0,     0,
       0,     0,  3271,     0,     0,  3276,     0,   886,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
    3283,  3284,  3285,     0,     0,  1039,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,  3286,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   715,
       0,     0,     0,     0,     0,   887,     0,   884,   889,   213,
    1040,     0,     0,   717,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,   720,     0,     0,
     721,     0,     0,     0,     0,     0,     0,   722,     0,     0,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   724,
       0,     0,     0,   886,     0,     0,  1043,     0,     0,     0,
       0,     0,     0,   726,     0,     0,  1044,     0,     0,     0,
     728,     0,     0,     0,   889,     0,     0,     0,  1045,     0,
     730,     0,     0,     0,     0,  1046,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,   889,   884,     0,     0,
       0,     0,  3293,     0,     0,     0,     0,     0,     0,     0,
       0,   733,     0,     0,     0,   886,     0,   887,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3312,
       0,     0,     0,  4330,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2848,   887,     0,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     889,     0,  3314,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,   884,
       0,     0,     0,     0,   884,   884,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,  2522,     0,     0,     0,
    3250,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2522,  2522,  2522,   889,  2522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   886,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,  4461,  4462,  4463,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4472,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4497,  4499,     0,     0,     0,  4504,     0,  3321,
    3322,  3323,  3324,  3325,  3326,  3327,  3328,  3329,     0,  3330,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
    1335,     0,  1701,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3286,     0,     0,   886,  3293,     0,   887,  3312,     0,  3314,
       0,     0,  3367,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1360,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2061,  2062,     0,   887,     0,
       0,     0,   886,     0,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,     2,
       0,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     6,
     887,     0,     0,     0,     0,     0,     0,     0,  3510,     0,
       0,     7,     0,     8,     9,     0,     0,     0,     0,     0,
      10,     0,    11,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   886,    14,     0,     0,    15,     0,     0,     0,
       0,     0,  4708,  4709,  4710,     0,     0,     0,     0,     0,
       0,    16,     0,    17,     0,     0,     0,    18,     0,     0,
       0,     0,     0,  5630,     0,     0,     0,     0,     0,     0,
       0,    20,     0,    21,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,     0,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,  2522,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    25,    26,   886,     0,     0,     0,    27,   886,
     886,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3752,  3753,  1701,     0,     0,     0,  3757,
    2522,     0,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,  2522,     0,    30,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,  3786,     0,    31,     0,
       0,     0,     0,   197,    32,    33,     0,    34,     0,     0,
       0,     0,    35,     0,     0,  4535,     0,     0,    36,     0,
       0,    37,   886,     0,     0,     0,     0,     0,    38,   889,
       0,     0,     0,     0,     0,    39,    40,     0,     0,     0,
       0,     0,     0,    41,     0,   887,     0,    42,     0,     0,
       0,     0,     0,     0,   198,     0,     0,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     199,   886,     0,    44,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,     0,
       0,     0,     0,    45,   201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,     0,  4972,     0,
      47,     0,   202,     0,     0,    48,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,    49,     0,
       0,     0,   204,     0,     0,     0,     0,     0,     0,     0,
    5004,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,   206,    50,     0,     0,   889,     0,     0,   207,     0,
       0,     0,     0,     0,     0,   887,     0,     0,     0,     0,
       0,    56,  3058,     0,  -136,     0,     0,     0,   208,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3981,     0,  5062,     0,   209,
    3987,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,     0,     0,     0,  3119,     0,     0,     0,     0,     0,
       0,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2064,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3262,     0,  3262,  3262,     0,
       0,     0,   211,     0,     0,     0,     0,     0,     0,     0,
       0,  4068,     0,     0,  4071,     0,  4073,     0,     0,   889,
       0,     0,     0,     0,     0,     0,   212,   887,     0,     0,
       0,     0,   887,   887,     0,     0,   213,   214,     0,     0,
     215,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4100,     0,  4103,     0,  4105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   216,     0,     0,
     217,     0,     0,     0,   218,     0,     0,   219,     0,     0,
       0,     0,     0,     0,   220,     0,     0,   221,     0,     0,
       0,     0,     0,     0,  5162,  5163,  5164,  5165,     0,     0,
       0,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,     0,
     225,     0,     0,   226,     0,     0,     0,   227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     889,     0,   229,     0,     0,   887,     0,  4172,     0,     0,
       0,     0,  2625,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2642,   231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,  2522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2522,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,  2522,  2522,     0,  2522,     0,     0,     0,     0,
    3250,  3250,     0,  4044,     0,  3250,     0,     0,     0,  2522,
       0,     0,  2522,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,   889,     0,  2522,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,  2522,  2522,
    2522,  2522,     0,     0,     0,  3250,  3250,     0,  2522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,  2522,
       0,     0,     0,     0,     0,     0,  2522,  2522,  2522,  2522,
    2522,  2522,  2522,  2522,  2522,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5377,     0,
       0,     0,  2522,     0,     0,     0,     0,     0,     0,  5387,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1701,     0,     0,     0,     0,
       0,  1701,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4484,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,   889,   889,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,  4606,
       0,     0,  5575,     0,     0,     0,     0,  1360,  4610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3221,     0,
       0,     0,  3221,  3221,     0,     0,  5605,     0,  3232,     0,
       0,     0,     0,     0,     0,     0,  4628,     0,  4629,     0,
       0,     0,     0,   889,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4651,  4652,  4653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3271,     0,     0,     0,     0,     0,
       0,     0,  4677,     0,     0,  4680,     0,  4682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,  2522,     0,
       0,     0,  2522,     0,     0,  4688,     0,     0,     0,     0,
       0,     0,     0,  4695,  4696,     0,     0,     0,     0,     0,
    4701,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5709,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4753,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4767,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5785,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5807,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2522,     0,     0,     0,
       0,     0,  2522,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4044,  4044,     0,     0,  3250,  3250,  3250,  3250,     0,     0,
    3250,  3250,  3250,  3250,  3250,  3250,  3250,  3250,  3250,  3250,
    4044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2522,     0,     0,  2522,     0,  2522,     0,
       0,  4044,  4044,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2522,  3250,  3250,  2522,     0,
    2522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5050,  5051,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5101,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2625,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5119,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5138,  5140,
       0,     0,     0,     0,     0,  5144,  5145,     0,     0,     0,
    5146,     0,     0,     0,     0,     0,     0,  5149,     0,     0,
    5152,  5153,     0,     0,     0,     0,     0,  5158,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1335,     0,     0,     0,     0,     0,     0,     0,  5206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3250,     0,     0,  5216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5281,     0,     0,     0,     0,     0,     0,  5283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2522,     0,     0,     0,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5318,     0,     0,
       0,     0,     0,  2522,  2522,     0,     0,     0,     0,  4044,
    4044,  4044,  4044,     0,     0,     0,  4044,  4044,  4044,  4044,
    4044,  4044,  4044,  4044,  4044,  4044,  2522,  2522,  2522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2522,     0,     0,  2522,     0,  2522,     0,     0,
       0,     0,     0,  2522,     0,     0,  4044,  4044,     0,     0,
    2522,  2522,     0,     0,     0,     0,  2522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2522,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5409,     0,     0,     0,     0,     0,
    5413,  5414,  5415,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5428,  5429,     0,
       0,  5430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5449,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5467,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5482,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2522,  2522,     0,     0,     0,
       0,     0,     0,  2522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2522,  3250,     0,  2064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2522,     0,  2522,     0,     0,     0,  2522,
    2522,  2522,     0,     0,  2522,     0,     0,  2522,  2522,     0,
       0,     0,     0,  2522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3250,
       0,     0,     0,     0,     0,     0,     0,     0,  5726,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,     0,     0,
    5762,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2522,     0,  2522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5828,
       0,     0,     0,  2522,     0,     0,     0,     0,  5835,  5835,
    5835,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2522,     0,  4044,  3250,  2522,  2522,
    2522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2522,  2522,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3250,     0,     0,
    4044,     0,     0,     0,  2522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2522,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5835,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5992,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6033,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6058,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4044,     0,  3250,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5835,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6126,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2522,     0,     0,     0,     0,     0,     0,
    2522,     0,     0,     0,     0,     0,     0,     0,     0,  1701,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3250,  3250,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,  2522,  1246,   694,     0,  1247,  1248,  1249,
     755,  1250,     0,     0,  4044,  4044,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1695,   244,
     245,   246,     0,     0,     0,     0,  1251,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1252,   260,  1253,  1254,     0,   263,   264,   265,
     266,   267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,
     274,  2522,   275,   276,   277,   278,  1259,     0,  1260,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,
     303,   304,   305,   306,   307,  1268,  1269,   310,  1270,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,  1696,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1271,   339,   340,   341,   342,  1272,  1273,
     344,     0,   345,   346,   347,  1274,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,  1275,     0,  1276,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1277,  1278,     0,  1279,     0,   392,
     393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,
     403,   404,   405,   406,   407,     0,     0,   408,  1284,   410,
     411,   412,     0,   413,   414,   415,  1285,  1286,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,  1287,   435,  1288,   437,
     438,   439,   440,   441,   442,   443,   444,  1289,   446,  1290,
     447,   448,   449,   450,  1291,  1292,   452,  1293,   454,   455,
     456,     0,   457,   458,     0,     0,  1294,   460,   461,     0,
       0,   462,   463,   464,   465,   466,   467,  1295,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,  1296,   482,   483,   484,   485,   486,     0,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,  1297,   498,
     499,   500,   501,     0,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   515,   516,
     517,   518,   519,   520,   521,   522,  1298,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,  1299,   539,   540,   541,   542,   543,   544,
     545,   546,  1300,   548,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,  1301,   563,
       0,   564,   565,  1302,     0,   566,   567,   568,   569,   570,
     571,   572,     0,   573,  1303,  1304,     0,     0,   576,   577,
    1305,   579,  1306,  1307,   581,   582,   583,   584,   585,   586,
     587,   588,     0,  1308,   589,   590,   591,   592,   593,  1309,
       0,   594,   595,   596,   597,   598,   599,  1310,  1697,   601,
     602,   603,   604,   605,   606,     0,     0,   607,     0,     0,
     608,   609,   610,   611,   612,   613,   614,  1311,  1312,  1313,
    1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,
       0,  1319,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1320,  1321,  1698,     0,     0,     0,     0,
       0,     0,  1323,  1699,   234,     0,  1246,   694,     0,  1247,
    1248,  1249,   755,  1250,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1251,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1252,   260,  1253,  1254,     0,   263,
     264,   265,   266,   267,   268,   269,  1255,  1256,   270,   271,
    1257,  1258,   274,     0,   275,   276,   277,   278,  1259,     0,
    1260,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,   302,   303,   304,   305,   306,   307,  1268,  1269,   310,
    1270,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1271,   339,   340,   341,   342,
    1272,  1273,   344,     0,   345,   346,   347,  1274,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,  1275,     0,  1276,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1277,  1278,     0,  1279,
       0,   392,   393,   394,   395,   396,   397,  1280,  1281,  1282,
    1283,   402,   403,   404,   405,   406,   407,     0,     0,   408,
    1284,   410,   411,   412,     0,   413,   414,   415,  1285,  1286,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1287,   435,
    1288,   437,   438,   439,   440,   441,   442,   443,   444,  1289,
     446,  1290,   447,   448,   449,   450,  1291,  1292,   452,  1293,
     454,   455,   456,     0,   457,   458,     0,     0,  1294,   460,
     461,     0,     0,   462,   463,   464,   465,   466,   467,  1295,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,  1296,   482,   483,   484,   485,   486,     0,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
    1297,   498,   499,   500,   501,     0,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     515,   516,   517,   518,   519,   520,   521,   522,  1298,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,    40,
     534,   535,   536,   537,   538,  1299,   539,   540,   541,   542,
     543,   544,   545,   546,  1300,   548,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
    1301,   563,     0,   564,   565,  1302,    44,   566,   567,   568,
     569,   570,   571,   572,     0,   573,  1303,  1304,     0,     0,
     576,   577,  1305,   579,  1306,  1307,   581,   582,   583,   584,
     585,   586,   587,   588,     0,  1308,   589,   590,   591,   592,
     593,  1309,     0,   594,   595,   596,   597,   598,  1181,  1310,
       0,   601,   602,   603,   604,   605,   606,     0,     0,   607,
       0,    49,   608,   609,   610,   611,   612,   613,   614,  1311,
    1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,
     626,   627,     0,  1319,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1320,  1321,     0,     0,     0,
       0,     0,     0,     0,  1323,  5686,   234,     0,  1246,   694,
       0,  1247,  1248,  1249,   755,  1250,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1251,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1252,   260,  1253,  1254,
       0,   263,   264,   265,   266,   267,   268,   269,  1255,  1256,
     270,   271,  1257,  1258,   274,     0,   275,   276,   277,   278,
    1259,     0,  1260,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,   302,   303,   304,   305,   306,   307,  1268,
    1269,   310,  1270,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1271,   339,   340,
     341,   342,  1272,  1273,   344,     0,   345,   346,   347,  1274,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,  1275,     0,  1276,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1277,  1278,
       0,  1279,     0,   392,   393,   394,   395,   396,   397,  1280,
    1281,  1282,  1283,   402,   403,   404,   405,   406,   407,     0,
       0,   408,  1284,   410,   411,   412,     0,   413,   414,   415,
    1285,  1286,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
    1287,   435,  1288,   437,   438,   439,   440,   441,   442,   443,
     444,  1289,   446,  1290,   447,   448,   449,   450,  1291,  1292,
     452,  1293,   454,   455,   456,     0,   457,   458,     0,     0,
    1294,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,  1295,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,  1296,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,  1297,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,   517,   518,   519,   520,   521,   522,
    1298,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,  1299,   539,   540,
     541,   542,   543,   544,   545,   546,  1300,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,  1301,   563,     0,   564,   565,  1302,     0,   566,
     567,   568,   569,   570,   571,   572,     0,   573,  1303,  1304,
       0,     0,   576,   577,  1305,   579,  1306,  1307,   581,   582,
     583,   584,   585,   586,   587,   588,     0,  1308,   589,   590,
     591,   592,   593,  1309,     0,   594,   595,   596,   597,   598,
     599,  1310,     0,   601,   602,   603,   604,   605,   606,     0,
       0,   607,     0,     0,   608,   609,   610,   611,   612,   613,
     614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,
     624,   625,   626,   627,     0,  1319,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1320,  1321,     0,
       0,     0,     0,     0,     0,     0,  1323,  3252,   234,     0,
    1246,   694,     0,  1247,  1248,  1249,   755,  1250,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1251,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1252,   260,
    1253,  1254,     0,   263,   264,   265,   266,   267,   268,   269,
    1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,   276,
     277,   278,  1259,     0,  1260,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,
     307,  1268,  1269,   310,  1270,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1271,
     339,   340,   341,   342,  1272,  1273,   344,     0,   345,   346,
     347,  1274,   349,     0,   350,     0,   351,   352,   353,     0,
     354,   355,   356,   357,   358,     0,   359,  1275,     0,  1276,
     362,   363,     0,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1277,  1278,     0,  1279,     0,   392,   393,   394,   395,   396,
     397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,
     407,     0,     0,   408,  1284,   410,   411,   412,     0,   413,
     414,   415,  1285,  1286,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1287,   435,  1288,   437,   438,   439,   440,   441,
     442,   443,   444,  1289,   446,  1290,   447,   448,   449,   450,
    1291,  1292,   452,  1293,   454,   455,   456,     0,   457,   458,
       0,     0,  1294,   460,   461,     0,     0,   462,   463,   464,
     465,   466,   467,  1295,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,  1296,   482,   483,
     484,   485,   486,     0,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,  1297,   498,   499,   500,   501,     0,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   515,   516,   517,   518,   519,   520,
     521,   522,  1298,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,  1299,
     539,   540,   541,   542,   543,   544,   545,   546,  1300,   548,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,  1301,   563,     0,   564,   565,  1302,
       0,   566,   567,   568,   569,   570,   571,   572,     0,   573,
    1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,
     581,   582,   583,   584,   585,   586,   587,   588,     0,  1308,
     589,   590,   591,   592,   593,  1309,     0,   594,   595,   596,
     597,   598,   599,  1310,     0,   601,   602,   603,   604,   605,
     606,     0,     0,   607,     0,     0,   608,   609,   610,   611,
     612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,
    1317,  1318,   624,   625,   626,   627,     0,  1319,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1320,
    1321,     0,     0,     0,     0,     0,     0,     0,  1323,  4630,
     234,     0,  1246,   694,     0,  1247,  1248,  1249,   755,  1250,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1251,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1252,   260,  1253,  1254,     0,   263,   264,   265,   266,   267,
     268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,
     275,   276,   277,   278,  1259,     0,  1260,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,
     305,   306,   307,  1268,  1269,   310,  1270,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1271,   339,   340,   341,   342,  1272,  1273,   344,     0,
     345,   346,   347,  1274,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1275,
       0,  1276,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1277,  1278,     0,  1279,     0,   392,   393,   394,
     395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,
     405,   406,   407,     0,     0,   408,  1284,   410,   411,   412,
       0,   413,   414,   415,  1285,  1286,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1287,   435,  1288,   437,   438,   439,
     440,   441,   442,   443,   444,  1289,   446,  1290,   447,   448,
     449,   450,  1291,  1292,   452,  1293,   454,   455,   456,     0,
     457,   458,     0,     0,  1294,   460,   461,     0,     0,   462,
     463,   464,   465,   466,   467,  1295,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,  1296,
     482,   483,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,  1297,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   515,   516,   517,   518,
     519,   520,   521,   522,  1298,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,  1299,   539,   540,   541,   542,   543,   544,   545,   546,
    1300,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,  1301,   563,     0,   564,
     565,  1302,     0,   566,   567,   568,   569,   570,   571,   572,
       0,   573,  1303,  1304,     0,     0,   576,   577,  1305,   579,
    1306,  1307,   581,   582,   583,   584,   585,   586,   587,   588,
       0,  1308,   589,   590,   591,   592,   593,  1309,     0,   594,
     595,   596,   597,   598,   599,  1310,     0,   601,   602,   603,
     604,   605,   606,     0,     0,   607,     0,     0,   608,   609,
     610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,
    1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,
       0,     0,     0,     0,     0,   635,     0,     0,     0,     0,
       0,  1320,  1321,     0,     0,     0,     0,     0,     0,     0,
    1323,  4698,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
    4150,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0, -1813,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0, -1813,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382, -1813,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395, -1813,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409, -1813,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
   -1813,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516, -1813,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,     0,     0,     0,     0,     0,     0,     0,
     856,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1434,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     857,   260,   858,   859,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   860,   861,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   862,   863,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,   865,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,     0,
       0,     0,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,  2668,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,  2669,   385,   386,
     387,   388,   866,   867,     0,   868,     0,   392,   393,   394,
     395,   396,   397,     0,     0,     0,     0,   402,   403,   404,
     405,   406,   407,     0,     0,   408,     0,   410,   411,   412,
       0,   413,   414,   415,     0,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   869,   435,   870,   437,   438,   439,
     440,   441,   442,   443,     0,     0,   446,     0,   447,   448,
     449,   450,     0,     0,   452,   871,   454,   455,   456,     0,
     457,   458,     0,     0,   459,   460,   461,     0,     0,   462,
     463,  2671,   465,   466,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     482,     0,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   872,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   515,   516,   517,   518,
     519,   520,   521,   522,     0,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,     0,   539,   540,  2672,   542,   543,   544,   545,   546,
     874,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     0,   563,     0,   564,
     565,     0,     0,   566,   567,   568,   569,   570,   571,   572,
       0,   573,   875,   876,     0,     0,   576,   577,     0,   579,
       0,     0,   581,   582,   583,   584,   585,   586,   587,   588,
       0,     0,   589,   590,   591,   592,   593,     0,     0,   594,
     595,   596,   597,   598,     0,   877,  2673,   601,   602,   603,
     604,   605,   606,     0,     0,   607,     0,     0,   608,   609,
     610,   611,   612,   613,     0,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   625,   626,   627,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,  2769,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   857,   260,   858,   859,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   860,   861,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   862,   863,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   339,   340,   341,
     342,     0,     0,   344,     0,   345,   346,   347,   865,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,     0,     0,     0,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
    2668,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,  2669,   385,   386,   387,   388,   866,   867,     0,
     868,     0,   392,   393,   394,   395,   396,   397,     0,     0,
       0,     0,   402,   403,   404,   405,   406,   407,     0,     0,
     408,     0,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   869,
     435,   870,   437,   438,   439,   440,   441,   442,   443,     0,
       0,   446,     0,   447,   448,   449,   450,     0,     0,   452,
     871,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,  2671,   465,   466,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   482,     0,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   872,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,  2672,
     542,   543,   544,   545,   546,   874,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,     0,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   875,   876,     0,
       0,   576,   577,     0,   579,     0,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,     0,
     877,  2673,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,     0,
     234,     0,  1246,   694,     0,  1247,  1248,  1249,   755,  1250,
     625,   626,   627,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1251,     0,  3875,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1252,   260,  1253,  1254,     0,   263,   264,   265,   266,   267,
     268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,
     275,   276,   277,   278,  1259,     0,  1260,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,
     305,   306,   307,  1268,  1269,   310,  1270,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1271,   339,   340,   341,   342,  1272,  1273,   344,     0,
     345,   346,   347,  1274,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1275,
       0,  1276,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1277,  1278,     0,  1279,     0,   392,   393,   394,
     395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,
     405,   406,   407,     0,     0,   408,  1284,   410,   411,   412,
       0,   413,   414,   415,  1285,  1286,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1287,   435,  1288,   437,   438,   439,
     440,   441,   442,   443,   444,  1289,   446,  1290,   447,   448,
     449,   450,  1291,  1292,   452,  1293,   454,   455,   456,     0,
     457,   458,     0,     0,  1294,   460,   461,     0,     0,   462,
     463,   464,   465,   466,   467,  1295,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,  1296,
     482,   483,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,  1297,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,  3218,   515,   516,   517,   518,
     519,   520,   521,   522,  1298,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,    40,   534,   535,   536,   537,
     538,  1299,   539,   540,   541,   542,   543,   544,   545,   546,
    1300,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,  1301,   563,     0,   564,
     565,  1302,    44,   566,   567,   568,   569,   570,   571,   572,
       0,   573,  1303,  1304,     0,     0,   576,   577,  1305,   579,
    1306,  1307,   581,   582,   583,   584,   585,   586,   587,   588,
       0,  1308,   589,   590,   591,   592,   593,  1309,     0,   594,
     595,   596,   597,   598,  1181,  1310,     0,   601,   602,   603,
     604,   605,   606,     0,     0,   607,     0,    49,   608,   609,
     610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,
    1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1320,  1321,     0,     0,     0,   234,     0,  1246,   694,
    1323,  1247,  1248,  1249,   755,  1250,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1251,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1252,   260,  1253,  1254,
       0,   263,   264,   265,   266,   267,   268,   269,  1255,  1256,
     270,   271,  1257,  1258,   274,     0,   275,   276,   277,   278,
    1259,     0,  1260,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,   302,   303,   304,   305,   306,   307,  1268,
    1269,   310,  1270,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1271,   339,   340,
     341,   342,  1272,  1273,   344,     0,   345,   346,   347,  1274,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,  1275,     0,  1276,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1277,  1278,
       0,  1279,     0,   392,   393,   394,   395,   396,   397,  1280,
    1281,  1282,  1283,   402,   403,   404,   405,   406,   407,     0,
       0,   408,  1284,   410,   411,   412,     0,   413,   414,   415,
    1285,  1286,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
    1287,   435,  1288,   437,   438,   439,   440,   441,   442,   443,
     444,  1289,   446,  1290,   447,   448,   449,   450,  1291,  1292,
     452,  1293,   454,   455,   456,     0,   457,   458,     0,     0,
    1294,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,  1295,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,  1296,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,  1297,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,   517,   518,   519,   520,   521,   522,
    1298,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,    40,   534,   535,   536,   537,   538,  1299,   539,   540,
     541,   542,   543,   544,   545,   546,  1300,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,  1301,   563,     0,   564,   565,  1302,    44,   566,
     567,   568,   569,   570,   571,   572,     0,   573,  1303,  1304,
       0,     0,   576,   577,  1305,   579,  1306,  1307,   581,   582,
     583,   584,   585,   586,   587,   588,     0,  1308,   589,   590,
     591,   592,   593,  1309,     0,   594,   595,   596,   597,   598,
    1181,  1310,     0,   601,   602,   603,   604,   605,   606,     0,
       0,   607,     0,    49,   608,   609,   610,   611,   612,   613,
     614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,
     624,   625,   626,   627,     0,  1319,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1320,  1321,     0,
       0,     0,   234,     0,  1246,   694,  1323,  1247,  1248,  1249,
     755,  1250,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1251,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1252,   260,  1253,  1254,  3258,   263,   264,   265,
     266,   267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,
     274,     0,   275,   276,   277,   278,  1259,     0,  1260,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,
     303,   304,   305,   306,   307,  1268,  1269,   310,  1270,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1271,   339,   340,   341,   342,  1272,  1273,
     344,     0,   345,   346,   347,  1274,   349,     0,   350,     0,
     351,   352,   353,  3259,   354,   355,   356,   357,   358,     0,
     359,  1275,     0,  1276,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1277,  1278,     0,  1279,     0,   392,
     393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,
     403,   404,   405,   406,   407,     0,  3260,   408,  1284,   410,
     411,   412,     0,   413,   414,   415,  1285,  1286,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,  1287,   435,  1288,   437,
     438,   439,   440,   441,   442,   443,   444,  1289,   446,  1290,
     447,   448,   449,   450,  1291,  1292,   452,  1293,   454,   455,
     456,     0,   457,   458,     0,     0,  1294,   460,   461,     0,
       0,   462,   463,   464,   465,   466,   467,  1295,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,  1296,   482,   483,   484,   485,   486,     0,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,  1297,   498,
     499,   500,   501,     0,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   515,   516,
     517,   518,   519,   520,   521,   522,  1298,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,  1299,   539,   540,   541,   542,   543,   544,
     545,   546,  1300,   548,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,  1301,   563,
       0,   564,   565,  1302,     0,   566,   567,   568,   569,   570,
     571,   572,     0,   573,  1303,  1304,     0,  3261,   576,   577,
    1305,   579,  1306,  1307,   581,   582,   583,   584,   585,   586,
     587,   588,     0,  1308,   589,   590,   591,   592,   593,  1309,
       0,   594,   595,   596,   597,   598,   599,  1310,     0,   601,
     602,   603,   604,   605,   606,     0,     0,   607,     0,     0,
     608,   609,   610,   611,   612,   613,   614,  1311,  1312,  1313,
    1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,
       0,  1319,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1320,  1321,     0,     0,     0,   234,     0,
    1246,   694,  1323,  1247,  1248,  1249,   755,  1250,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243, -2217,   244,   245,   246,     0,     0,
       0, -2217,  1251,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1252,   260,
    1253,  1254,     0,   263,   264,   265,   266,   267,   268,   269,
    1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,   276,
     277,   278,  1259,     0,  1260,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,
     307,  1268,  1269,   310,  1270,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1271,
     339,   340,   341,   342,  1272,  1273,   344,     0,   345,   346,
     347,  1274,   349,     0,   350,     0,   351,   352,   353,     0,
     354,   355,   356,   357,   358,     0,   359,  1275,     0,  1276,
     362,   363,     0,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1277,  1278,     0,  1279,     0,   392,   393,   394,   395,   396,
     397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,
     407,     0,     0,   408,  1284,   410,   411,   412,     0,   413,
     414,   415,  1285,  1286,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1287,   435,  1288,   437,   438,   439,   440,   441,
     442,   443,   444,  1289,   446,  1290,   447,   448,   449,   450,
    1291,  1292,   452,  1293,   454,   455,   456,     0,   457,   458,
       0,     0,  1294,   460,   461,     0,     0,   462,   463,   464,
     465,   466,   467,  1295,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,  1296,   482,   483,
     484,   485,   486,     0,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,  1297,   498,   499,   500,   501,     0,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   515,   516,   517,   518,   519,   520,
     521,   522,  1298,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,  1299,
     539,   540,   541,   542,   543,   544,   545,   546,  1300,   548,
   -2217,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,  1301,   563,     0,   564,   565,  1302,
       0,   566,   567,   568,   569,   570,   571,   572,     0,   573,
    1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,
     581,   582,   583,   584,   585,   586,   587,   588,     0,  1308,
     589,   590,   591,   592,   593,  1309,     0,   594,   595,   596,
     597,   598,   599,  1310,     0,   601,   602,   603,   604,   605,
     606,     0,     0,   607,     0,     0,   608,   609,   610,   611,
     612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,
    1317,  1318,   624,   625,   626,   627,     0,  1319,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1320,
    1321,     0,     0,     0,   234,     0,  1246,   694,  1323,  1247,
    1248,  1249,   755,  1250,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
   -2215,   244,   245,   246,     0,     0,     0, -2215,  1251,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1252,   260,  1253,  1254,     0,   263,
     264,   265,   266,   267,   268,   269,  1255,  1256,   270,   271,
    1257,  1258,   274,     0,   275,   276,   277,   278,  1259,     0,
    1260,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,   302,   303,   304,   305,   306,   307,  1268,  1269,   310,
    1270,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1271,   339,   340,   341,   342,
    1272,  1273,   344,     0,   345,   346,   347,  1274,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,  1275,     0,  1276,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1277,  1278,     0,  1279,
       0,   392,   393,   394,   395,   396,   397,  1280,  1281,  1282,
    1283,   402,   403,   404,   405,   406,   407,     0,     0,   408,
    1284,   410,   411,   412,     0,   413,   414,   415,  1285,  1286,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1287,   435,
    1288,   437,   438,   439,   440,   441,   442,   443,   444,  1289,
     446,  1290,   447,   448,   449,   450,  1291,  1292,   452,  1293,
     454,   455,   456,     0,   457,   458,     0,     0,  1294,   460,
     461,     0,     0,   462,   463,   464,   465,   466,   467,  1295,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,  1296,   482,   483,   484,   485,   486,     0,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
    1297,   498,   499,   500,   501,     0,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     515,   516,   517,   518,   519,   520,   521,   522,  1298,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,  1299,   539,   540,   541,   542,
     543,   544,   545,   546,  1300,   548, -2215,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
    1301,   563,     0,   564,   565,  1302,     0,   566,   567,   568,
     569,   570,   571,   572,     0,   573,  1303,  1304,     0,     0,
     576,   577,  1305,   579,  1306,  1307,   581,   582,   583,   584,
     585,   586,   587,   588,     0,  1308,   589,   590,   591,   592,
     593,  1309,     0,   594,   595,   596,   597,   598,   599,  1310,
       0,   601,   602,   603,   604,   605,   606,     0,     0,   607,
       0,     0,   608,   609,   610,   611,   612,   613,   614,  1311,
    1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,
     626,   627,     0,  1319,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1320,  1321,     0,     0,     0,
     234,     0,  1246,   694,  1323,  1247,  1248,  1249,   755,  1250,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1251,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1252,   260,  1253,  1254,     0,   263,   264,   265,   266,   267,
     268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,
     275,   276,   277,   278,  1259,     0,  1260,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,
     305,   306,   307,  1268,  1269,   310,  1270,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1271,   339,   340,   341,   342,  1272,  1273,   344,     0,
     345,   346,   347,  1274,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1275,
       0,  1276,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1277,  1278,     0,  1279,     0,   392,   393,   394,
     395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,
     405,   406,   407,     0,     0,   408,  1284,   410,   411,   412,
       0,   413,   414,   415,  1285,  1286,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1287,   435,  1288,   437,   438,   439,
     440,   441,   442,   443,   444,  1289,   446,  1290,   447,   448,
     449,   450,  1291,  1292,   452,  1293,   454,   455,   456,     0,
     457,   458,     0,     0,  1294,   460,   461,     0,     0,   462,
     463,   464,   465,   466,   467,  1295,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,  1296,
     482,   483,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,  1297,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   515,   516,   517,   518,
     519,   520,   521,   522,  1298,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,  1299,   539,   540,   541,   542,   543,   544,   545,   546,
    1300,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,  1301,   563,     0,   564,
     565,  1302,     0,   566,   567,   568,   569,   570,   571,   572,
       0,   573,  1303,  1304,     0,     0,   576,   577,  1305,   579,
    1306,  1307,   581,   582,   583,   584,   585,   586,   587,   588,
       0,  1308,   589,   590,   591,   592,   593,  1309,     0,   594,
     595,   596,   597,   598,   599,  1310,     0,   601,   602,   603,
     604,   605,   606,     0,     0,   607,     0,     0,   608,   609,
     610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,
    1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1320,  1321,     0,     0,     0,     0,     0,  2019,  3194,
    1323,   234,     0,  1246,   694,     0,  1247,  1248,  1249,   755,
    1250,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1251,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1252,   260,  1253,  1254,     0,   263,   264,   265,   266,
     267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,  1268,  1269,   310,  1270,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1271,   339,   340,   341,   342,  1272,  1273,   344,
       0,   345,   346,   347,  1274,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,  1276,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1277,  1278,     0,  1279,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,     0,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,  1287,   435,  1288,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,  1290,   447,
     448,   449,   450,  1291,  1292,   452,  1293,   454,   455,   456,
       0,   457,   458,     0,     0,  1294,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,  1297,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,  1298,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,  1300,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,  1303,  1304,     0,     0,   576,   577,  1305,
     579,  1306,  1307,   581,   582,   583,   584,   585,   586,   587,
     588,     0,  1308,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,   599,  1310,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,
    1319,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1320,  1321,  1322,     0,     0,   234,     0,  1246,
     694,  1323,  1247,  1248,  1249,   755,  1250,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  2635,   244,   245,   246,     0,     0,     0,
       0,  1251,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,  1255,
    1256,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,  1270,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1271,   339,
     340,   341,   342,  1272,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,  1276,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,   393,   394,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411,   412,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
     443,   444,  1289,   446,  1290,   447,   448,   449,   450,  1291,
    1292,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,  1294,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,  1298,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543,   544,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,   581,
     582,   583,   584,   585,   586,   587,   588,     0,  1308,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0,  1319,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1320,  1321,
       0,     0,     0,   234,     0,  1246,   694,  1323,  1247,  1248,
    1249,   755,  1250,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1251,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1252,   260,  1253,  1254,     0,   263,   264,
     265,   266,   267,   268,   269,  1255,  1256,   270,   271,  1257,
    1258,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,  1268,  1269,   310,  1270,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1271,   339,   340,   341,   342,  1272,
    1273,   344,     0,   345,   346,   347,  1274,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,  1276,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1277,  1278,     0,  1279,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1287,   435,  1288,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
    1290,   447,   448,   449,   450,  1291,  1292,   452,  1293,   454,
     455,   456,     0,   457,   458,     0,     0,  1294,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,  1297,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,  3218,   515,
     516,   517,   518,   519,   520,   521,   522,  1298,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,  1300,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,  1303,  1304,     0,     0,   576,
     577,  1305,   579,  1306,  1307,   581,   582,   583,   584,   585,
     586,   587,   588,     0,  1308,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,  1310,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,
     627,     0,  1319,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1320,  1321,     0,     0,     0,   234,
       0,  1246,   694,  1323,  1247,  1248,  1249,   755,  1250,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1251,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1252,
     260,  1253,  1254,     0,   263,   264,   265,   266,   267,   268,
     269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,  1268,  1269,   310,  1270,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1271,   339,   340,   341,   342,  1272,  1273,   344,     0,   345,
     346,   347,  1274,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
    1276,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1277,  1278,     0,  1279,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1287,   435,  1288,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,  1290,   447,   448,   449,
     450,  1291,  1292,   452,  1293,   454,   455,   456,     0,   457,
     458,     0,     0,  1294,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,  1297,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,  1298,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,  1300,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,  1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,
    1307,   581,   582,   583,   584,   585,   586,   587,   588,     0,
    1308,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,  1310,  3754,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1320,  1321,     0,     0,     0,   234,     0,  1246,   694,  1323,
    1247,  1248,  1249,   755,  1250,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1251,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1252,   260,  1253,  1254,     0,
     263,   264,   265,   266,   267,   268,   269,  1255,  1256,   270,
     271,  1257,  1258,   274,     0,   275,   276,   277,   278,  1259,
       0,  1260,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,   302,   303,   304,   305,   306,   307,  1268,  1269,
     310,  1270,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1271,   339,   340,   341,
     342,  1272,  1273,   344,     0,   345,   346,   347,  1274,   349,
       0,   350,     0,   351,   352,   353,  3259,   354,   355,   356,
     357,   358,     0,   359,  1275,     0,  1276,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1277,  1278,     0,
    1279,     0,   392,   393,   394,   395,   396,   397,  1280,  1281,
    1282,  1283,   402,   403,   404,   405,   406,   407,     0,     0,
     408,  1284,   410,   411,   412,     0,   413,   414,   415,  1285,
    1286,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,  1287,
     435,  1288,   437,   438,   439,   440,   441,   442,   443,   444,
    1289,   446,  1290,   447,   448,   449,   450,  1291,  1292,   452,
    1293,   454,   455,   456,     0,   457,   458,     0,     0,  1294,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
    1295,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,  1296,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,  1297,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,  1298,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,  1299,   539,   540,   541,
     542,   543,   544,   545,   546,  1300,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,  1301,   563,     0,   564,   565,  1302,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,  1303,  1304,     0,
       0,   576,   577,  1305,   579,  1306,  1307,   581,   582,   583,
     584,   585,   586,   587,   588,     0,  1308,   589,   590,   591,
     592,   593,  1309,     0,   594,   595,   596,   597,   598,   599,
    1310,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
    1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,   624,
     625,   626,   627,     0,  1319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1320,  1321,     0,     0,
       0,   234,     0,  1246,   694,  1323,  1247,  1248,  1249,   755,
    1250,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1251,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1252,   260,  1253,  1254,     0,   263,   264,   265,   266,
     267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,  1268,  1269,   310,  1270,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1271,   339,   340,   341,   342,  1272,  1273,   344,
       0,   345,   346,   347,  1274,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,  1276,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1277,  1278,     0,  1279,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,     0,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,  1287,   435,  1288,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,  1290,   447,
     448,   449,   450,  1291,  1292,   452,  1293,   454,   455,   456,
       0,   457,   458,     0,     0,  1294,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,  1297,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,  1298,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,  1300,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,  1303,  1304,  3315,     0,   576,   577,  1305,
     579,  1306,  1307,   581,   582,   583,   584,   585,   586,   587,
     588,     0,  1308,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,   599,  1310,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,
    1319,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1320,  1321,     0,     0,     0,   234,     0,  1246,
     694,  1323,  1247,  1248,  1249,   755,  1250,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1251,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,  1255,
    1256,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,  1270,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1271,   339,
     340,   341,   342,  1272,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,  1276,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,   393,   394,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411,   412,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
     443,   444,  1289,   446,  1290,   447,   448,   449,   450,  1291,
    1292,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,  1294,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,  1298,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543,   544,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,   581,
     582,   583,   584,   585,   586,   587,   588,     0,  1308,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0,  1319,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1320,  1321,
       0,     0,     0,   234,     0,  1246,   694,  1323,  1247,  1248,
    1249,   755,  1250,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1251,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1252,   260,  1253,  1254,     0,   263,   264,
     265,   266,   267,   268,   269,  1255,  1256,   270,   271,  1257,
    1258,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,  1268,  1269,   310,  1270,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1271,   339,   340,   341,   342,  1272,
    1273,   344,     0,   345,   346,   347,  1274,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,  1276,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1277,  1278,     0,  1279,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1287,   435,  1288,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
    1290,   447,   448,   449,   450,  1291,  1292,   452,  1293,   454,
     455,   456,     0,   457,   458,     0,     0,  1294,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,  1297,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,  1298,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,  1300,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,  1303,  1304,     0,     0,   576,
     577,  1305,   579,  1306,  1307,   581,   582,   583,   584,   585,
     586,   587,   588,     0,  1308,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,  1310,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,
     627,     0,  1319,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2638,  2639,     0,     0,     0,   234,
       0,  3431,   694,  1323,  1247,  1248,  1249,   755,  1250,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1251,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1252,
     260,  1253,  1254,     0,   263,   264,   265,   266,   267,   268,
     269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,  1268,  1269,   310,  1270,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1271,   339,   340,   341,   342,  1272,  1273,   344,     0,   345,
     346,   347,  1274,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
    1276,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1277,  1278,     0,  1279,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1287,   435,  1288,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,  1290,   447,   448,   449,
     450,  1291,  1292,   452,  1293,   454,   455,   456,     0,   457,
     458,     0,     0,  1294,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,  1297,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,  1298,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,  1300,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,  1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,
    1307,   581,   582,   583,   584,   585,   586,   587,   588,     0,
    1308,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,  1310,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1320,  1321,     0,     0,     0,   234,     0,  1246,   694,  1323,
    1247,  1248,  1249,   755,  1250,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1251,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1252,   260,  1253,  1254,     0,
     263,   264,   265,   266,   267,   268,   269,  1255,  1256,   270,
     271,  1257,  1258,   274,     0,   275,   276,   277,   278,  1259,
       0,  1260,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,  4752,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,   302,   303,   304,   305,   306,   307,  1268,  1269,
     310,  1270,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1271,   339,   340,   341,
     342,  1272,  1273,   344,     0,   345,   346,   347,  1274,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1275,     0,  1276,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1277,  1278,     0,
    1279,     0,   392,   393,   394,   395,   396,   397,  1280,  1281,
    1282,  1283,   402,   403,   404,   405,   406,   407,     0,     0,
     408,  1284,   410,   411,   412,     0,   413,   414,   415,  1285,
    1286,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,  1287,
     435,  1288,   437,   438,   439,   440,   441,   442,   443,   444,
    1289,   446,  1290,   447,   448,   449,   450,  1291,  1292,   452,
    1293,   454,   455,   456,     0,   457,   458,     0,     0,  1294,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
    1295,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,  1296,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,  1297,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,  1298,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,  1299,   539,   540,   541,
     542,   543,   544,   545,   546,  1300,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,  1301,   563,     0,   564,   565,  1302,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,  1303,  1304,     0,
       0,   576,   577,  1305,   579,  1306,  1307,   581,   582,   583,
     584,   585,   586,   587,   588,     0,  1308,   589,   590,   591,
     592,   593,  1309,     0,   594,   595,   596,   597,   598,   599,
    1310,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
    1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,   624,
     625,   626,   627,     0,  1319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1320,  1321,     0,     0,
       0,   234,     0,  1246,   694,  1323,  1247,  1248,  1249,   755,
    1250,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1251,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1252,   260,  1253,  1254,     0,   263,   264,   265,   266,
     267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,  1268,  1269,   310,  1270,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1271,   339,   340,   341,   342,  1272,  1273,   344,
       0,   345,   346,   347,  1274,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,  1276,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1277,  1278,     0,  1279,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,     0,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,  1287,   435,  1288,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,  1290,   447,
     448,   449,   450,  1291,  1292,   452,  1293,   454,   455,   456,
       0,   457,   458,     0,     0,  1294,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,  1297,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,  1298,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,  1300,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,  1303,  1304,     0,     0,   576,   577,  1305,
     579,  1306,  1307,   581,   582,   583,   584,   585,   586,   587,
     588,     0,  1308,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,   599,  1310,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,  5127,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,
    1319,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1320,  1321,     0,     0,     0,   234,     0,  1246,
     694,  1323,  1247,  1248,  1249,   755,  1250,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1251,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,  1255,
    1256,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,  1270,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1271,   339,
     340,   341,   342,  1272,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,  1276,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,   393,   394,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411,   412,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
    5139,   444,  1289,   446,  1290,   447,   448,   449,   450,  1291,
    1292,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,  1294,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,  1298,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543,   544,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,   581,
     582,   583,   584,   585,   586,   587,   588,     0,  1308,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0,  1319,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1320,  1321,
       0,     0,     0,   234,     0,  1246,   694,  1323,  1247,  1248,
    1249,   755,  1250,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1251,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1252,   260,  1253,  1254,     0,   263,   264,
     265,   266,   267,   268,   269,  1255,  1256,   270,   271,  1257,
    1258,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,  5457,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,  1268,  1269,   310,  1270,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1271,   339,   340,   341,   342,  1272,
    1273,   344,     0,   345,   346,   347,  1274,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,  5458,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1277,  1278,     0,  1279,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1287,   435,  1288,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
    1290,   447,   448,   449,   450,  1291,  1292,   452,  1293,   454,
     455,   456,     0,   457,   458,     0,     0,  1294,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,  1297,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,  5459,   521,   522,  1298,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,  1300,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,  1303,  1304,     0,     0,   576,
     577,  1305,   579,  1306,  1307,   581,   582,   583,   584,   585,
     586,   587,   588,     0,  1308,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,  1310,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,
     627,     0,  1319,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1320,  1321,     0,     0,     0,   234,
       0,  1246,   694,  5460,  1247,  1248,  1249,   755,  1250,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1251,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,  5832,  1252,
     260,  1253,  1254,     0,   263,   264,   265,   266,   267,   268,
     269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,  5833,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,  1268,  1269,   310,  1270,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1271,   339,   340,   341,   342,  1272,  1273,   344,     0,   345,
     346,   347,  1274,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
    1276,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1277,  1278,     0,  1279,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1287,   435,  1288,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,  1290,   447,   448,   449,
     450,  1291,  1292,   452,  1293,   454,   455,   456,     0,   457,
     458,     0,     0,  1294,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,  1297,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,  1298,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,  1300,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,  1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,
    1307,   581,   582,   583,   584,   585,  5834,   587,   588,     0,
    1308,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,  1310,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,     0,  1319,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1320,  1321,     0,     0,     0,   234,     0,  1246,   694,  1323,
    1247,  1248,  1249,   755,  1250,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1251,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1252,   260,  1253,  1254,     0,
     263,   264,   265,   266,   267,   268,   269,  1255,  1256,   270,
     271,  1257,  1258,   274,     0,   275,   276,   277,   278,  1259,
       0,  1260,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,  5833,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,   302,   303,   304,   305,   306,   307,  1268,  1269,
     310,  1270,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1271,   339,   340,   341,
     342,  1272,  1273,   344,     0,   345,   346,   347,  1274,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1275,     0,  1276,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1277,  1278,     0,
    1279,     0,   392,   393,   394,   395,   396,   397,  1280,  1281,
    1282,  1283,   402,   403,   404,   405,   406,   407,     0,     0,
     408,  1284,   410,   411,   412,     0,   413,   414,   415,  1285,
    1286,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,  1287,
     435,  1288,   437,   438,   439,   440,   441,   442,   443,   444,
    1289,   446,  1290,   447,   448,   449,   450,  1291,  1292,   452,
    1293,   454,   455,   456,     0,   457,   458,     0,     0,  1294,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
    1295,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,  1296,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,  1297,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,  1298,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,  1299,   539,   540,   541,
     542,   543,   544,   545,   546,  1300,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,  1301,   563,     0,   564,   565,  1302,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,  1303,  1304,     0,
       0,   576,   577,  1305,   579,  1306,  1307,   581,   582,   583,
     584,   585,  5834,   587,   588,     0,  1308,   589,   590,   591,
     592,   593,  1309,     0,   594,   595,   596,   597,   598,   599,
    1310,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
    1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,   624,
     625,   626,   627,     0,  1319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1320,  1321,     0,     0,
       0,   234,     0,  1246,   694,  1323,  1247,  1248,  1249,   755,
    1250,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1251,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1252,   260,  1253,  1254,     0,   263,   264,   265,   266,
     267,   268,   269,  1255,  1256,   270,   271,  1257,  1258,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,  1268,  1269,   310,  5442,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1271,   339,   340,   341,   342,  1272,  1273,   344,
       0,   345,   346,   347,  1274,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,  1276,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1277,  1278,     0,  1279,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,     0,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,  1287,   435,  1288,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,     0,   447,
     448,   449,   450,  1291,  1292,   452,  1293,   454,   455,   456,
       0,   457,   458,     0,     0,  1294,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,  1297,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,  3244,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,  1300,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,  1303,  1304,     0,     0,   576,   577,  1305,
     579,  1306,  1307,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,   599,  1310,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3245,  3246,     0,     0,     0,   234,     0,  1246,
     694,  3247,  1247,  1248,  1249,   755,  1250,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1251,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257, -2885,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,  1255,
    1256,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,  5833,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,  1270,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1271,   339,
     340,   341,   342,  1272,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,  1276,   362,
     363,     0,   364,   365,   366,   367,   368, -2885,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,     0,     0,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411, -2885,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
     443,   444,  1289,   446,  1290,   447,   448,     0,   450,  1291,
    1292,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,  1294,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,  1298,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543, -2885,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,   581,
     582,   583,   584,   585,  5834,   587,   588,     0,  1308,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0, -2885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1320,  1321,
       0,     0,     0,   234,     0,  1246,   694,  1323,  1247,  1248,
    1249,   755,  1250,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1251,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1252,   260,  1253,  1254,     0,   263,   264,
     265,   266,   267,   268,   269,  1255,  1256,   270,   271,  1257,
    1258,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,  1268,  1269,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1271,   339,   340,   341,   342,  1272,
    1273,   344,     0,   345,   346,   347,  1274,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,  1276,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1277,  1278,     0,  1279,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1287,   435,  1288,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
       0,   447,   448,   449,   450,  1291,  1292,   452,  1293,   454,
     455,   456,     0,   457,   458,     0,     0,  1294,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,  1297,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,  3244,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,  1300,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,  1303,  1304,     0,     0,   576,
     577,  1305,   579,  1306,  1307,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,  1310,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,
     627,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3245,  3246,   234,     0,  1246,   694,
       0,  1247,  1248,  3247,   755,  1250,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1251,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1252,   260,  1253,  1254,
       0,   263,   264,   265,   266,   267,   268,   269,  1255,  1256,
     270,   271,  1257,  1258,   274,     0,   275,   276,   277,   278,
    1259,     0,  1260,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,   302,   303,   304,   305,   306,   307,  1268,
    1269,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1271,   339,   340,
     341,   342,  1272,  1273,   344,     0,   345,   346,   347,  1274,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,  1275,     0,  1276,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1277,  1278,
       0,  1279,     0,   392,   393,   394,   395,   396,   397,  1280,
    1281,  1282,  1283,   402,   403,   404,   405,   406,   407,     0,
       0,   408,  1284,   410,   411,   412,     0,   413,   414,   415,
    1285,  1286,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
    1287,   435,  1288,   437,   438,   439,   440,   441,   442,   443,
     444,  1289,   446,     0,   447,   448,   449,   450,  1291,  1292,
     452,  1293,   454,   455,   456,     0,   457,   458,     0,     0,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,  1295,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,  1296,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,  1297,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,   517,   518,   519,   520,   521,   522,
    3420,  3421,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,  1299,   539,   540,
     541,   542,   543,   544,   545,   546,  1300,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,  1301,   563,     0,   564,   565,  1302,     0,   566,
     567,   568,   569,   570,   571,   572,     0,   573,  1303,  1304,
       0,     0,   576,   577,  1305,   579,  1306,  1307,   581,   582,
     583,   584,   585,   586,   587,   588,     0,     0,   589,   590,
     591,   592,   593,  1309,     0,   594,   595,   596,   597,   598,
     599,  1310,     0,   601,   602,   603,   604,   605,   606,     0,
       0,   607,     0,     0,   608,   609,   610,   611,   612,   613,
     614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,
     624,   625,   626,   627,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3422,  3423,   234,
       0,  1246,   694,     0,  1247,  1248,  3247,   755,  1250,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1251,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1252,
     260,  1253,  1254,     0,   263,   264,   265,   266,   267,   268,
     269,  1255,  1256,   270,   271,  1257,  1258,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,  1268,  1269,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1271,   339,   340,   341,   342,  1272,  1273,   344,     0,   345,
     346,   347,  1274,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
    1276,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1277,  1278,     0,  1279,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1287,   435,  1288,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,     0,   447,   448,   449,
     450,  1291,  1292,   452,  1293,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,  1297,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,  3244,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,  1300,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,  1303,  1304,     0,     0,   576,   577,  1305,   579,  1306,
    1307,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,  1310,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,     0,     0,     0,
       0,     0,     0,   234,     0,  1246,   694,     0,  1247,  1248,
       0,   755,  1250,     0,     0,     0,     0,     0,     0,  3247,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1251,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1252,   260,  1253,  1254,     0,   263,  4661,
     265,   266,   267,   268,   269,  1255,  1256,   270,   271,  1257,
    1258,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,  1268,  1269,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1271,   339,   340,   341,   342,  1272,
    1273,   344,     0,   345,   346,   347,  1274,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,  1276,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1277,  1278,     0,  1279,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1287,   435,  1288,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
       0,   447,   448,   449,   450,  1291,  1292,   452,  1293,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,  1297,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,  3244,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,  1300,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,  1303,  1304,     0,     0,   576,
     577,  1305,   579,  1306,  1307,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,  1310,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,   624,   625,   626,
     627,     0,     0,     0,     0,     0,     0,   234,     0,  1246,
     694,     0,  1247,  1248,     0,   755,  1250,     0,     0,     0,
       0,     0,     0,  3247,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1251,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,  1255,
    1256,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1271,   339,
     340,   341,   342,  1272,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,  1276,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,   393,   394,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411,   412,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
     443,   444,  1289,   446,     0,   447,   448,   449,   450,  1291,
    1292,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,  3244,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543,   544,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,  1305,   579,  1306,  1307,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,  4721,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3247,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1256,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1272,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,  3394,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,     0,   447,
     448,   449,   450,     0,  1292,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   839,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,  3395,   525,   526,   527,
     528,   529,   530,   531,   532,   533,    40,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,    44,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,  1305,
     579,  1306,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,  1181,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,    49,   608,
     609,   610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,  3396,   625,   626,   627,     0,
       0,     0,    50,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3397,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,  1256,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,  1259,
       0,  1260,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,  1272,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1275,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,  1280,  1281,
    1282,  1283,   402,   403,   404,   405,   406,   407,  3394,     0,
     408,  1284,   410,   411,   412,     0,   413,   414,   415,  1285,
    1286,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
    1289,   446,     0,   447,   448,   449,   450,     0,  1292,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   839,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
    1295,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,  1296,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
    3395,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,  1299,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,  1301,   563,     0,   564,   565,  1302,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,  1305,   579,  1306,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,  1309,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
    1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,  1318,  3396,
     625,   626,   627,     0,     0,     0,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3397,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,  1256,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,  1272,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,     0,   447,   448,   449,
     450,     0,  1292,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,  1305,   579,  1306,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,     0,     0,     0,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3833,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1256,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1259,     0,  1260,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1272,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1275,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,  1280,  1281,  1282,  1283,
     402,   403,   404,   405,   406,   407,     0,     0,   408,  1284,
     410,   411,   412,     0,   413,   414,   415,  1285,  1286,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,  1289,   446,
       0,   447,   448,   449,   450,     0,  1292,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,  1295,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,  1296,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,  3395,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,  1299,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,  1301,
     563,     0,   564,   565,  1302,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,  1305,   579,  1306,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
    1309,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,  1311,  1312,
    1313,  1314,   619,  1315,  1316,  1317,  1318,  3396,   625,   626,
     627,     0,     0,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    56,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
    1256,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,  1259,     0,  1260,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1272,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1275,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
    1280,  1281,  1282,  1283,   402,   403,   404,   405,   406,   407,
       0,     0,   408,  1284,   410,   411,   412,     0,   413,   414,
     415,  1285,  1286,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,  1289,   446,     0,   447,   448,   449,   450,     0,
    1292,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,  1295,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,  1296,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,  1299,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,  1301,   563,     0,   564,   565,  1302,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,  1305,   579,  1306,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,  1309,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,  1311,  1312,  1313,  1314,   619,  1315,  1316,  1317,
    1318,   624,   625,   626,   627,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4782,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1256,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1259,     0,  1260,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1261,  1262,  1263,  1264,  1265,  1266,  1267,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1272,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1275,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,  1280,  1281,  1282,  1283,   402,   403,
     404,   405,   406,   407,     0,     0,   408,  1284,   410,   411,
     412,     0,   413,   414,   415,  1285,  1286,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,  1289,   446,     0,   447,
     448,   449,   450,     0,  1292,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,  1295,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
    1296,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,  1299,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,  1301,   563,     0,
     564,   565,  1302,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,  1305,
     579,  1306,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,  1309,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,  1311,  1312,  1313,  1314,
     619,  1315,  1316,  1317,  1318,   624,   625,   626,   627,     0,
       0,     0,     0,     0,     0,   942,     0,  1570,   694,     0,
       0,     0,     0,   755,     0,     0,     0,     0,     0,     0,
       0,  5935,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,  1796,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,  1797,     0,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  1798,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,  1571,  1572,  5741,     0,
       0,     0,     0,     0,     0,  5742,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     3,
       4,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,    40,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,    44,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,  1181,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,    49,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,  1021,     0,     0,
      50,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    56,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,     0,     0,     0,     0,     0,     0,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5511,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,    40,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,    44,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,  1181,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,    49,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,     0,    50,     0,
       0,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,  2842,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   839,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,  2843,  2844,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,     0,
       0,     0,     0,     0,     0,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1830,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,     0,     0,     0,     0,     0,     0,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1382,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,     0,     0,     0,
       0,     0,     0,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3454,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,     0,     0,     0,     0,     0,     0,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4114,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   856,     0,  1570,   694,     0,     0,
       0,   957,   755,     0,     0,     0,     0,  4738,   958,   959,
     960,   235,   236,   237,   238,   239,   240,   241,   242,   243,
    1708,   244,   245,   246,  1709,  1710,  1711,  1712,  1713,  1714,
    1715,   247,   248,   249,  1716,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   857,   260,   858,   859,  1717,   263,
     264,   265,   266,   267,   268,   269,  1718,  1719,   270,   271,
     860,   861,   274,  1720,   275,   276,   277,   278,     0,  1721,
     280,  1722,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,  1723,   291,   292,   293,   294,   295,   296,  1724,
     297,   298,   299,   300,  1725,  1726,  1727,   301,  1728,  1729,
    1730,   302,   303,   304,   305,   306,   307,   862,   863,   310,
    1731,   311,  1732,   312,   313,   314,   315,   316,   317,   318,
    1733,   319,   320,   321,   322,  1734,  1735,   323,   324,   864,
     326,   327,  1736,   328,   329,   330,  1737,   331,   332,   333,
    1738,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,  1739,   344,  1740,   345,   346,   347,   865,   349,  1741,
     350,  1742,   351,   352,   353,  1743,   354,   355,   356,   357,
     358,  1744,   359,     0,  1745,     0,   362,   363,  1746,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,  1747,
     374,   375,   376,   377,   378,   379,   380,   381,  1748,   382,
     383,     0,   385,   386,   387,   388,   866,   867,  1749,   868,
    1750,   392,   393,   394,   395,   396,   397,     0,     0,     0,
       0,   402,   403,   404,   405,   406,   407,  1751,  1752,   408,
       0,   410,   411,   412,  1753,   413,   414,   415,  1754,  1755,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   869,   435,
     870,   437,   438,   439,   440,   441,   442,   443,  4428,     0,
     446,  1756,   447,   448,   449,   450,  1757,     0,   452,   871,
     454,   455,   456,  1758,   457,   458,  1759,  1760,  4429,   460,
     461,  1761,  1762,   462,   463,     0,   465,   466,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
    1763,   479,   480,     0,   482,     0,   484,   485,   486,  1764,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     872,   498,   499,   500,   501,  1765,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,  1766,
     515,   516,   517,   518,   519,   520,   521,   522,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  1767,
     534,   535,   536,   537,   538,  1768,   539,   540,  2672,   542,
     543,   544,   545,   546,   874,   548,  1769,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       0,   563,  1770,   564,   565,  1771,  1772,   566,   567,   568,
     569,   570,   571,   572,  1773,   573,   875,   876,  1774,  1775,
     576,   577,     0,   579,     0,  1776,   581,   582,   583,   584,
     585,   586,   587,   588,  1777,  1778,   589,   590,   591,   592,
     593,  1779,  1780,   594,   595,   596,   597,   598,     0,   877,
    1781,   601,   602,   603,   604,   605,   606,  1782,  1783,   607,
    1784,  1785,   608,   609,   610,   611,   612,   613,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   625,
     626,   627,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   963,   964,   965,  4430,  4431,   968,   969,   970,
     971,   856,     0,  1570,   694,     0,     0,     0,   957,   755,
       0,     0,     0,     0,     0,   958,   959,   960,   235,   236,
     237,   238,   239,   240,   241,   242,   243,  1708,   244,   245,
     246,  1709,  1710,  1711,  1712,  1713,  1714,  1715,   247,   248,
     249,  1716,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   857,   260,   858,   859,  1717,   263,   264,   265,   266,
     267,   268,   269,  1718,  1719,   270,   271,   860,   861,   274,
    1720,   275,   276,   277,   278,     0,  1721,   280,  1722,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,  1723,
     291,   292,   293,   294,   295,   296,  1724,   297,   298,   299,
     300,  1725,  1726,  1727,   301,  1728,  1729,  1730,   302,   303,
     304,   305,   306,   307,   862,   863,   310,  1731,   311,  1732,
     312,   313,   314,   315,   316,   317,   318,  1733,   319,   320,
     321,   322,  1734,  1735,   323,   324,   864,   326,   327,  1736,
     328,   329,   330,  1737,   331,   332,   333,  1738,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,  1739,   344,
    1740,   345,   346,   347,   865,   349,  1741,   350,  1742,   351,
     352,   353,  1743,   354,   355,   356,   357,   358,  1744,   359,
       0,  1745,     0,   362,   363,  1746,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,  1747,   374,   375,   376,
     377,   378,   379,   380,   381,  1748,   382,   383,     0,   385,
     386,   387,   388,   866,   867,  1749,   868,  1750,   392,   393,
     394,   395,   396,   397,     0,     0,     0,     0,   402,   403,
     404,   405,   406,   407,  1751,  1752,   408,     0,   410,   411,
     412,  1753,   413,   414,   415,  1754,  1755,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   869,   435,   870,   437,   438,
     439,   440,   441,   442,   443,  4876,     0,   446,  1756,   447,
     448,   449,   450,  1757,     0,   452,   871,   454,   455,   456,
    1758,   457,   458,  1759,  1760,  4429,   460,   461,  1761,  1762,
     462,   463,     0,   465,   466,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,  1763,   479,   480,
       0,   482,     0,   484,   485,   486,  1764,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   872,   498,   499,
     500,   501,  1765,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,  1766,   515,   516,   517,
     518,   519,   520,   521,   522,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,  1767,   534,   535,   536,
     537,   538,  1768,   539,   540,  2672,   542,   543,   544,   545,
     546,   874,   548,  1769,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     0,   563,  1770,
     564,   565,  1771,  1772,   566,   567,   568,   569,   570,   571,
     572,  1773,   573,   875,   876,  1774,  1775,   576,   577,     0,
     579,     0,  1776,   581,   582,   583,   584,   585,   586,   587,
     588,  1777,  1778,   589,   590,   591,   592,   593,  1779,  1780,
     594,   595,   596,   597,   598,     0,   877,  1781,   601,   602,
     603,   604,   605,   606,  1782,  1783,   607,  1784,  1785,   608,
     609,   610,   611,   612,   613,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   625,   626,   627,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,  4430,  4431,   968,   969,   970,   971,  2070,     0,
       0,     0,     0,     0,     0,  2071,     0,     0,  2072,     0,
       0,     0,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,
    2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,     0,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,     0,     0,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,  2149,  2150,     0,  2151,  2152,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,  2165,     0,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,     0,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  2207,  2208,  2209,  2210,  2211,     0,     0,  2212,
    2213,  2214,  2215,     0,  2216,  2217,  2218,  2219,  2220,     0,
    2221,  2222,  2223,  2224,  2225,     0,  2226,  2227,     0,  2228,
    2229,  2230,     0,  2231,  2232,     0,  2233,  2234,  2235,  2236,
    2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,
    2247,  2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,
    2257,  2258,     0,  2259,     0,  2260,  2261,  2262,  2263,  2264,
    2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,  2273,  2274,
    2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,     0,  2283,
    2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,
    2294,  2295,  2296,  2297,  2298,     0,  2299,  2300,     0,  2301,
    2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,
    2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,
    2322,  2323,  2324,  2325,  2326,  2327,  2328,     0,  2329,  2330,
       0,  2331,  2332,  2333,  2334,  2335,     0,  2336,  2337,  2338,
    2339,     0,     0,  2340,  2341,  2342,  2343,  2344,  2345,  2346,
    2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,     0,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,
    2376,  2377,  2378,  2379,  2380,  2381,  2382,  2383,  2384,  2385,
    2386,  2387,  2388,     0,  2389,  2390,  2391,  2392,  2393,  2394,
    2395,  2396,  2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,
    2405,     0,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,
    2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,  2423,
    2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2433,
    2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,
    2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,
    2454,  2455,     0,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,     0,  2471,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,
    2482,  2483,  2484,  2485,  2486,     0,  2487,  2488,  2489,  2490,
    2491,  2492,     0,  2493,     0,     0,     0,     0,  2494,  2495,
    2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,
    2506,  2507,  2508,     0,  2509,  2510,     0,  2511,     0,     0,
       0,     0,     0,     0,     0,     0,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,   635,     0,     0,     0,     0,
       0,     0,   957,     0,     0,     0,     0,     0,     0,   958,
     959,   960,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   961,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   962,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   963,   964,   965,   966,   967,   968,   969,
     970,   971,   635,     0,     0,     0,     0,     0,     0,   957,
       0,     0,     0,     0,     0,     0,   958,   959,   960,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,  1078,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
    1079,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,     0,     0,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,     0,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,     0,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
       0,     0,   395,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,     0,   408,   409,     0,
     411,     0,     0,   413,   414,   415,     0,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     447,   448,     0,   450,     0,   451,   452,   453,   454,   455,
     456,     0,   457,   458,     0,     0,   459,   460,   461,     0,
       0,   462,   463,   464,     0,   466,     0,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,     0,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,     0,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   515,   516,
       0,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,     0,   539,   540,   541,   542,   543,     0,
     545,   546,   547,   548,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,   564,   565,     0,     0,   566,     0,   568,   569,   570,
     571,   572,     0,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,   581,   582,   583,   584,   585,   586,
     587,   588,     0,     0,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,   601,
       0,   603,   604,   605,   606,     0,     0,   607,     0,     0,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   635,
       0,     0,     0,     0,     0,     0,   957,     0,     0,     0,
       0,     0,     0,   958,   959,   960,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
    1144,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,  1145,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1146,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   963,   964,   965,
     966,   967,   968,   969,   970,   971,   635,     0,     0,     0,
       0,     0,     0,   957,     0,     0,     0,     0,     0,     0,
     958,   959,   960,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,  1813,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,  1814,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,     0,     0,   355,
     356,   357,   358,     0,   359,   360,     0,   361,   362,   363,
       0,   364,   365,   366,   367,   368,     0,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,     0,   384,   385,   386,   387,   388,   389,   390,
       0,   391,     0,   392,     0,     0,   395,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
       0,   408,   409,     0,   411,     0,     0,   413,   414,   415,
       0,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,     0,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   447,   448,     0,   450,     0,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,     0,
     459,   460,   461,     0,     0,   462,   463,   464,     0,   466,
       0,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,     0,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,     0,   539,   540,
     541,   542,   543,     0,   545,   546,   547,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,     0,   564,   565,     0,     0,   566,
       0,   568,   569,   570,   571,   572,     0,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,   588,     0,     0,   589,   590,
     591,   592,   593,     0,     0,   594,   595,   596,   597,   598,
     599,   600,     0,   601,     0,   603,   604,   605,   606,     0,
       0,   607,     0,     0,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   635,     0,     0,     0,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,   958,   959,   960,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   963,   964,   965,   966,   967,   968,   969,   970,   971,
     635,     0,     0,     0,     0,     0,     0,   957,     0,     0,
       0,     0,     0,     0,   958,   959,   960,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,  3525,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,  3526,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,     0,     0,   355,   356,   357,   358,     0,   359,   360,
       0,   361,   362,   363,     0,   364,   365,   366,   367,   368,
       0,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,     0,   384,   385,   386,
     387,   388,   389,   390,     0,   391,     0,   392,     0,     0,
     395,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,     0,   408,   409,     0,   411,     0,
       0,   413,   414,   415,     0,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,     0,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   447,   448,
       0,   450,     0,   451,   452,   453,   454,   455,   456,     0,
     457,   458,     0,     0,   459,   460,   461,     0,     0,   462,
     463,   464,     0,   466,     0,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   515,   516,     0,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,     0,   539,   540,   541,   542,   543,     0,   545,   546,
     547,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,     0,   564,
     565,     0,     0,   566,     0,   568,   569,   570,   571,   572,
       0,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,   581,   582,   583,   584,   585,   586,   587,   588,
       0,     0,   589,   590,   591,   592,   593,     0,     0,   594,
     595,   596,   597,   598,   599,   600,     0,   601,     0,   603,
     604,   605,   606,     0,     0,   607,     0,     0,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   635,     0,     0,
       0,     0,     0,     0,   957,     0,     0,     0,     0,     0,
       0,   958,   959,   960,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,  5490,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,  1707,     0,     0,
       0,     0,     0,     0,     0,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1708,   244,   245,   246,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,   247,   248,   249,  1716,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,  1717,   263,   264,   265,   266,   267,   268,   269,  1718,
    1719,   270,   271,   272,   273,   274,  1720,   275,   276,   277,
     278,   279,  1721,   280,  1722,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,  1723,   291,   292,   293,   294,
     295,   296,  1724,   297,   298,   299,   300,  1725,  1726,  1727,
     301,  1728,  1729,  1730,   302,   303,   304,   305,   306,   307,
     308,   309,   310,  1731,   311,  1732,   312,   313,   314,   315,
     316,   317,   318,  1733,   319,   320,   321,   322,  1734,  1735,
     323,   324,   325,   326,   327,  1736,   328,   329,   330,  1737,
     331,   332,   333,  1738,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1739,   344,  1740,   345,   346,   347,
     348,   349,  1741,   350,  1742,   351,   352,   353,  1743,   354,
     355,   356,   357,   358,  1744,   359,   360,  1745,   361,   362,
     363,  1746,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,  1747,   374,   375,   376,   377,   378,   379,   380,
     381,  1748,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1749,   391,  1750,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
    1751,  1752,   408,   409,   410,   411,   412,  1753,   413,   414,
     415,  1754,  1755,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,  1756,   447,   448,   449,   450,  1757,
     451,   452,   453,   454,   455,   456,  1758,   457,   458,  1759,
    1760,   459,   460,   461,  1761,  1762,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,  1763,   479,   480,   481,   482,   483,   484,
     485,   486,  1764,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,  1765,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,  1766,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,  1767,   534,   535,   536,   537,   538,  1768,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1769,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1770,   564,   565,  1771,  1772,
     566,   567,   568,   569,   570,   571,   572,  1773,   573,   574,
     575,  1774,  1775,   576,   577,   578,   579,   580,  1776,   581,
     582,   583,   584,   585,   586,   587,   588,  1777,  1778,   589,
     590,   591,   592,   593,  1779,  1780,   594,   595,   596,   597,
     598,   599,   600,  1781,   601,   602,   603,   604,   605,   606,
    1782,  1783,   607,  1784,  1785,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1786,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   845,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5905,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   857,   260,   858,   859,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   860,   861,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   862,   863,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,   865,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,  2668,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,  2669,   385,
     386,   387,   388,   866,   867,     0,   868,     0,   392,   393,
     394,   395,   396,   397,     0,     0,     0,     0,   402,   403,
     404,   405,   406,   407,     0,     0,   408,     0,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   869,   435,   870,   437,   438,
     439,   440,   441,   442,   443,     0,     0,   446,     0,   447,
     448,   449,   450,     0,     0,   452,   871,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,  2670,
     462,   463,  2671,   465,   466,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   482,     0,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   872,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,  2672,   542,   543,   544,   545,
     546,   874,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     0,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   875,   876,     0,     0,   576,   577,     0,
     579,     0,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,     0,   877,  2673,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,     0,     0,     0,  3870,     0,
       0,     0,     0,     0,     0,     0,   625,   626,   627,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,  2674,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   857,   260,
     858,   859,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   860,   861,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   862,   863,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     339,   340,   341,   342,     0,     0,   344,     0,   345,   346,
     347,   865,   349,     0,   350,     0,   351,   352,   353,     0,
     354,   355,   356,   357,   358,     0,   359,     0,     0,     0,
     362,   363,     0,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,  2668,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,  2669,   385,   386,   387,   388,
     866,   867,     0,   868,     0,   392,   393,   394,   395,   396,
     397,     0,     0,     0,     0,   402,   403,   404,   405,   406,
     407,     0,     0,   408,     0,   410,   411,   412,     0,   413,
     414,   415,     0,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   869,   435,   870,   437,   438,   439,   440,   441,
     442,   443,     0,     0,   446,     0,   447,   448,   449,   450,
       0,     0,   452,   871,   454,   455,   456,     0,   457,   458,
       0,     0,   459,   460,   461,     0,  2670,   462,   463,  2671,
     465,   466,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   482,     0,
     484,   485,   486,     0,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   872,   498,   499,   500,   501,     0,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   515,   516,   517,   518,   519,   520,
     521,   522,     0,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,     0,
     539,   540,  2672,   542,   543,   544,   545,   546,   874,   548,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     0,   563,     0,   564,   565,     0,
       0,   566,   567,   568,   569,   570,   571,   572,     0,   573,
     875,   876,     0,     0,   576,   577,     0,   579,     0,     0,
     581,   582,   583,   584,   585,   586,   587,   588,     0,     0,
     589,   590,   591,   592,   593,     0,     0,   594,   595,   596,
     597,   598,     0,   877,  2673,   601,   602,   603,   604,   605,
     606,     0,     0,   607,     0,     0,   608,   609,   610,   611,
     612,   613,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   625,   626,   627,   942,     0,  1570,   694,
       0,     0,     0,     0,   755,     0,     0,     0,     0,     0,
       0,  2674,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,  2559,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1796,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,   360,     0,   361,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
       0,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
       0,   408,   409,   410,   411,   412,     0,   413,   414,   415,
       0,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   447,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,     0,   457,   458,  1797,     0,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,     0,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,     0,   564,   565,     0,     0,   566,
     567,   568,   569,   570,   571,   572,     0,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,  1798,   581,   582,
     583,   584,   585,   586,   587,   588,     0,     0,   589,   590,
     591,   592,   593,     0,     0,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,     0,
       0,   607,     0,     0,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   942,     0,  1570,   694,     0,     0,
       0,     0,   755,     0,     0,     0,     0,  1571,  1572,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    2564,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1796,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,   360,     0,   361,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,   389,   390,     0,   391,
       0,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,     0,   408,
     409,   410,   411,   412,     0,   413,   414,   415,     0,     0,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   447,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,     0,   457,   458,  1797,     0,   459,   460,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,     0,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,     0,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,     0,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,     0,   564,   565,     0,     0,   566,   567,   568,
     569,   570,   571,   572,     0,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,  1798,   581,   582,   583,   584,
     585,   586,   587,   588,     0,     0,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,     0,     0,   607,
       0,     0,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   942,     0,  1570,   694,     0,     0,     0,     0,
     755,     0,     0,     0,     0,  1571,  1572,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  3486,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1796,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,     0,   408,   409,   410,
     411,   412,     0,   413,   414,   415,     0,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     447,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,     0,   457,   458,  1797,     0,   459,   460,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,     0,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,     0,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,     0,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,   564,   565,     0,     0,   566,   567,   568,   569,   570,
     571,   572,     0,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,  1798,   581,   582,   583,   584,   585,   586,
     587,   588,     0,     0,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,     0,     0,   607,     0,     0,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     942,     0,  1570,   694,     0,     0,     0,     0,   755,     0,
       0,     0,     0,  1571,  1572,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1796,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,   360,
       0,   361,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,   389,   390,     0,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
       0,   413,   414,   415,     0,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   447,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,     0,
     457,   458,  1797,     0,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,     0,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,     0,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,     0,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,     0,   564,
     565,     0,     0,   566,   567,   568,   569,   570,   571,   572,
       0,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,  1798,   581,   582,   583,   584,   585,   586,   587,   588,
       0,     0,   589,   590,   591,   592,   593,     0,     0,   594,
     595,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,     0,     0,   607,     0,     0,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   635,     0,
       0,     0,     0,     0,     0,     0,   755,     0,     0,     0,
       0,  1571,  1572,     0,     0,   235,   236,   756,   238,   239,
     240,   241,   242,   243,   757,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   758,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     759,   348,   349,     0,   350,     0,   351,   760,     0,   761,
       0,   355,   356,   357,   358,     0,   359,   360,     0,   361,
     362,   363,     0,   364,   365,   366,   367,   368,     0,   370,
     371,   372,   373,   762,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,     0,   384,   385,   386,   387,   388,
     389,   390,     0,   391,     0,   392,     0,     0,   395,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     763,     0,     0,   408,   409,     0,   411,     0,     0,   413,
     414,   415,     0,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,     0,   436,   437,   764,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   447,   448,     0,   450,
       0,   451,   452,   453,   454,   455,   456,     0,   457,   458,
       0,     0,   459,   460,   461,     0,     0,   462,   463,   464,
       0,   466,     0,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,     0,   765,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,     0,
     502,   503,   504,   766,   506,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   515,   516,     0,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,     0,
     539,   540,   541,   542,   543,     0,   545,   546,   547,   548,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,     0,   564,   565,     0,
       0,   566,     0,   568,   569,   570,   571,   572,     0,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,     0,
     581,   582,   583,   584,   585,   586,   587,   588,     0,     0,
     589,   590,   591,   592,   593,     0,     0,   594,   595,   596,
     597,   598,   599,   600,     0,   601,     0,   603,   604,   605,
     606,     0,     0,   607,     0,     0,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   942,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   767,
     768,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     3,     4,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,   360,     0,   361,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,   389,   390,
       0,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
       0,   408,   409,   410,   411,   412,     0,   413,   414,   415,
       0,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   447,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,     0,   457,   458,     0,     0,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,     0,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,     0,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,     0,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,     0,   564,   565,     0,     0,   566,
     567,   568,   569,   570,   571,   572,     0,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,   581,   582,
     583,   584,   585,   586,   587,   588,     0,     0,   589,   590,
     591,   592,   593,     0,     0,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,     0,
       0,   607,     0,     0,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,  1021,  1707,     0,  6176,   694,     0,
       0,     0,     0,   755,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1708,   244,   245,   246,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,   247,   248,   249,  1716,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,  1717,
     263,   264,   265,   266,   267,   268,   269,  1718,  1719,   270,
     271,   272,   273,   274,  1720,   275,   276,   277,   278,   279,
    1721,   280,  1722,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,  1723,   291,   292,   293,   294,   295,   296,
    1724,   297,   298,   299,   300,  1725,  1726,  1727,   301,  1728,
    1729,  1730,   302,   303,   304,   305,   306,   307,   308,   309,
     310,  1731,   311,  1732,   312,   313,   314,   315,   316,   317,
     318,  1733,   319,   320,   321,   322,  1734,  1735,   323,   324,
     325,   326,   327,  1736,   328,   329,   330,  1737,   331,   332,
     333,  1738,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,  1739,   344,  1740,   345,   346,   347,   348,   349,
    1741,   350,  1742,   351,   352,   353,  1743,   354,   355,   356,
     357,   358,  1744,   359,   360,  1745,   361,   362,   363,  1746,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
    1747,   374,   375,   376,   377,   378,   379,   380,   381,  1748,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1749,
     391,  1750,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,  1751,  1752,
     408,   409,   410,   411,   412,  1753,   413,   414,   415,  1754,
    1755,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,  1756,   447,   448,   449,   450,  1757,   451,   452,
     453,   454,   455,   456,  1758,   457,   458,  1759,  1760,   459,
     460,   461,  1761,  1762,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,  1763,   479,   480,   481,   482,   483,   484,   485,   486,
    1764,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,  1765,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
    1766,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
    1767,   534,   535,   536,   537,   538,  1768,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1769,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1770,   564,   565,  1771,  1772,   566,   567,
     568,   569,   570,   571,   572,  1773,   573,   574,   575,  1774,
    1775,   576,   577,   578,   579,   580,  1776,   581,   582,   583,
     584,   585,   586,   587,   588,  1777,  1778,   589,   590,   591,
     592,   593,  1779,  1780,   594,   595,   596,   597,   598,   599,
     600,  1781,   601,   602,   603,   604,   605,   606,  1782,  1783,
     607,  1784,  1785,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,  1707,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1708,
     244,   245,   246,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
     247,   248,   249,  1716,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1717,   263,   264,
     265,   266,   267,   268,   269,  1718,  1719,   270,   271,   272,
     273,   274,  1720,   275,   276,   277,   278,   279,  1721,   280,
    1722,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,  1723,   291,   292,   293,   294,   295,   296,  1724,   297,
     298,   299,   300,  1725,  1726,  1727,   301,  1728,  1729,  1730,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1731,
     311,  1732,   312,   313,   314,   315,   316,   317,   318,  1733,
     319,   320,   321,   322,  1734,  1735,   323,   324,   325,   326,
     327,  1736,   328,   329,   330,  1737,   331,   332,   333,  1738,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1739,   344,  1740,   345,   346,   347,   348,   349,  1741,   350,
    1742,   351,   352,   353,  1743,   354,   355,   356,   357,   358,
    1744,   359,   360,  1745,   361,   362,   363,  1746,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  1747,   374,
     375,   376,   377,   378,   379,   380,   381,  1748,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1749,   391,  1750,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,  1751,  1752,   408,   409,
     410,   411,   412,  1753,   413,   414,   415,  1754,  1755,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
    1756,   447,   448,   449,   450,  1757,   451,   452,   453,   454,
     455,   456,  1758,   457,   458,  1759,  1760,   459,   460,   461,
    1761,  1762,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,  1763,
     479,   480,   481,   482,   483,   484,   485,   486,  1764,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,  1765,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,  1766,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,  1767,   534,
     535,   536,   537,   538,  1768,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1769,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1770,   564,   565,  1771,  1772,   566,   567,   568,   569,
     570,   571,   572,  1773,   573,   574,   575,  1774,  1775,   576,
     577,   578,   579,   580,  1776,   581,   582,   583,   584,   585,
     586,   587,   588,  1777,  1778,   589,   590,   591,   592,   593,
    1779,  1780,   594,   595,   596,   597,   598,   599,   600,  1781,
     601,   602,   603,   604,   605,   606,  1782,  1783,   607,  1784,
    1785,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,  1707,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,  3591,   241,   242,   243,  1708,   244,   245,
     246,  1709,  1710,  1711,  1712,  1713,  1714,  1715,   247,   248,
     249,  1716,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,  1717,   263,   264,   265,   266,
     267,   268,   269,  1718,  1719,   270,   271,   272,   273,   274,
    1720,   275,   276,   277,   278,   279,  1721,   280,  1722,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,  1723,
     291,   292,   293,   294,   295,   296,  1724,   297,   298,   299,
     300,  1725,  1726,  1727,   301,  1728,  1729,  1730,   302,   303,
     304,   305,   306,   307,   308,   309,   310,  1731,   311,  1732,
     312,   313,   314,   315,   316,   317,   318,  1733,   319,   320,
     321,   322,  1734,  1735,   323,   324,   325,  3592,   327,  1736,
     328,   329,   330,  1737,   331,   332,   333,  1738,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1739,   344,
    1740,   345,   346,   347,   348,   349,  1741,   350,  1742,   351,
     352,   353,  1743,   354,   355,   356,   357,   358,  1744,   359,
     360,  1745,   361,   362,   363,  1746,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,  1747,   374,   375,   376,
     377,   378,   379,   380,   381,  1748,   382,   383,   384,   385,
     386,   387,   388,   389,   390,  1749,   391,  1750,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,  1751,  1752,   408,   409,   410,   411,
     412,  1753,   413,   414,   415,  1754,  1755,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,  1756,   447,
     448,   449,   450,  1757,   451,   452,   453,   454,   455,   456,
    1758,   457,   458,  1759,  1760,   459,   460,   461,  1761,  1762,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,  1763,   479,   480,
     481,   482,   483,   484,   485,   486,  1764,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,  1765,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,  1766,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,  1767,   534,   535,   536,
     537,   538,  1768,  3593,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1769,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1770,
     564,   565,  1771,  1772,   566,   567,   568,   569,   570,   571,
     572,  1773,   573,   574,   575,  1774,  1775,   576,   577,   578,
     579,   580,  1776,   581,   582,   583,   584,   585,   586,   587,
     588,  1777,  1778,   589,   590,   591,   592,   593,  1779,  1780,
     594,   595,   596,   597,   598,   599,   600,  1781,   601,   602,
     603,   604,   605,   606,  1782,  1783,   607,  1784,  1785,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,  1256,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,  1259,     0,  1260,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,  1272,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1275,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,  1280,  1281,  1282,  1283,   402,   403,   404,   405,
     406,   407,     0,     0,   408,  1284,   410,   411,   412,     0,
     413,   414,   415,  1285,  1286,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,  1289,   446,     0,   447,   448,   449,
     450,     0,  1292,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,  1295,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,  1296,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
    1299,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,  1301,   563,     0,   564,   565,
    1302,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,  1305,   579,  1306,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,  1309,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,  1311,  1312,  1313,  1314,   619,  1315,
    1316,  1317,  1318,   624,   625,   626,   627,   234,     0,  1246,
     694,     0,  1247,  1248,     0,   755,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1252,   260,  1253,
    1254,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,  1257,  1258,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
    1268,  1269,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1273,   344,     0,   345,   346,   347,
    1274,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1277,
    1278,     0,  1279,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1287,   435,  1288,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,   449,   450,  1291,
     451,   452,  1293,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,  1297,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,   544,   545,   546,  1300,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,  1303,
    1304,     0,     0,   576,   577,   578,   579,   580,  1307,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,  1310,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   942,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   981,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,   943,   301,     0,
       0,   944,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   945,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   942,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1002,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   943,   301,     0,     0,   944,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,  1003,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   945,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,   943,   301,     0,     0,   944,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   945,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,  2935,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   942,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,   943,   301,     0,     0,   944,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,   360,  3941,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     945,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   942,     0,     0,
     694,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,  1796,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,  1797,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,  1798,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   942,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,   943,   301,     0,
       0,   944,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   945,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   942,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   943,   301,     0,     0,   944,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,  1097,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   945,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,   943,   301,     0,     0,   944,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    1139,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   945,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   942,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,   943,   301,     0,     0,   944,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1152,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     945,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,   943,
     301,     0,     0,   944,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,  1164,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,  1165,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   945,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   942,     0,     0,   694,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,  2544,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   942,     0,     0,   694,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1123,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,  1136,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1150,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1154,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,  2707,   275,
     276,   277,   278,   279,     0,     0,  2776,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,  2708,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,  2777,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,  2710,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  2778,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,  2711,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
    2712,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,  2707,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,  2708,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,  2777,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,  2710,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,  3804,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,  2711,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,  2712,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   774,   244,   775,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
     776,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,   807,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   777,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     778,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   774,
     244,   775,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   776,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
    3493,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   777,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   778,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
    2707,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,  2708,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,  2777,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,  2710,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,  2711,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,  2712,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   774,   244,   775,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,   776,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     777,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   778,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  3011,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
    2842,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
     839,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,  2843,
    2844,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1974,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,  1975,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,  1976,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,  1977,   351,   352,     0,     0,     0,  1978,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,  1979,  1980,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,  1981,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,  1982,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,  1983,   522,   523,
     524,   525,   526,   527,  1984,   529,   530,   531,   532,   533,
       0,  1985,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,  1986,   566,     0,
    1987,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,  1988,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   775,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   776,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   777,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   778,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,  2842,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,   839,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,  2843,  2844,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   995,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   996,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,   839,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  3572,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,  3573,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  3585,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,  3586,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   636,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   685,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   686,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   799,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   800,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   801,   575,     0,     0,   802,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   833,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   834,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   835,
     575,     0,     0,   836,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,   839,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,   897,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   952,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     953,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,  1115,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1357,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
    1368,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   819,
     271,   272,   273,  1369,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   822,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   823,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   824,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,  1361,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   826,   575,     0,
       0,   827,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   828,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1514,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,   839,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,  1575,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    1576,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   799,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,  3343,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
    3344,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,  3345,
     566,     0,   568,  3346,   570,  3347,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,  3348,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,   694,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,   755,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,  4150,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,  4164,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,  4818,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,  4890,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  5244,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   791,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   797,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   819,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   820,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   821,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   822,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   823,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   824,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   825,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   826,   575,     0,
       0,   827,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   828,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   851,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     977,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   987,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   990,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1006,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1063,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    1068,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1085,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,  1088,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1090,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1128,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    1156,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1158,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,  1168,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1171,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1174,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   819,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   822,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     823,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     824,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,  1361,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   826,   575,     0,     0,   827,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   828,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1839,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,  1873,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1875,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1915,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    1917,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  1919,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,  2013,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
    2660,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,     0,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   819,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   822,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   823,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   824,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,  1361,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,  2694,   569,
     570,   571,   572,     0,   573,   826,   575,     0,     0,   827,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   828,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   819,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   822,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     823,   519,   520,   521,   522,   523,   524,   525,   526,   527,
    2759,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,  2760,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   826,   575,     0,     0,  2761,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   828,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   819,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   822,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   823,   519,
     520,   521,   522,   523,   524,   525,   526,   527,  2839,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,  2760,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   826,   575,     0,     0,  2761,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   828,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   819,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     822,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   823,   519,   520,   521,
     522,   523,   524,   525,   526,   527,  2863,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,  2760,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   826,
     575,     0,     0,  2761,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     828,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  3056,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3060,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    3118,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  3504,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   819,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     822,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   823,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   824,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,  2760,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   826,
     575,     0,     0,  2761,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     828,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  3561,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3575,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
    3577,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,     0,   408,   409,     0,   411,
       0,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   447,
     448,     0,   450,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,   464,     0,   466,     0,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,     0,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   541,   542,   543,     0,   545,
     546,   547,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,     0,     0,   566,     0,   568,   569,   570,   571,
     572,     0,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,   601,     0,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,  3725,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,     0,   408,   409,     0,   411,     0,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   447,   448,     0,
     450,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
     464,     0,   466,     0,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,     0,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   541,   542,   543,     0,   545,   546,   547,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
       0,     0,   566,     0,   568,   569,   570,   571,   572,     0,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,   601,     0,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,  3765,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,     0,   408,   409,     0,   411,     0,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   447,   448,     0,   450,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,   464,     0,
     466,     0,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,     0,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   541,   542,   543,     0,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,     0,     0,
     566,     0,   568,   569,   570,   571,   572,     0,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,   601,     0,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   635,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  5003,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,     0,
     408,   409,     0,   411,     0,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   447,   448,     0,   450,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,   464,     0,   466,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,     0,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   541,
     542,   543,     0,   545,   546,   547,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,     0,     0,   566,     0,
     568,   569,   570,   571,   572,     0,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,   601,     0,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,     0,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,     0,   408,   409,
       0,   411,     0,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   447,   448,     0,   450,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,   464,     0,   466,     0,   468,   469,
     470,   471,   472,   473,   474,   475,     0,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,     0,   496,   497,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,     0,   518,   519,   520,   521,   522,   523,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   541,   542,   543,
       0,   545,   546,   547,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,     0,     0,   566,     0,   568,   569,
     570,   571,   572,     0,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
     601,     0,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   857,   260,   858,   859,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   860,   861,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   862,   863,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,   865,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,  2668,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,  2669,   385,
     386,   387,   388,   866,   867,     0,   868,     0,   392,   393,
     394,   395,   396,   397,     0,     0,     0,     0,   402,   403,
     404,   405,   406,   407,     0,     0,   408,     0,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   869,   435,   870,   437,   438,
     439,   440,   441,   442,   443,     0,     0,   446,     0,   447,
     448,   449,   450,     0,     0,   452,   871,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,  2671,   465,   466,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   482,     0,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   872,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,  2672,   542,   543,   544,   545,
     546,   874,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     0,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   875,   876,     0,     0,   576,   577,     0,
     579,     0,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,     0,   877,  2673,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   625,   626,   627,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   857,   260,   858,   859,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   860,   861,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   862,   863,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   339,   340,   341,
     342,     0,     0,   344,     0,   345,   346,   347,   865,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,     0,     0,     0,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,     0,   385,   386,   387,   388,   866,   867,     0,
     868,     0,   392,   393,   394,   395,   396,   397,     0,     0,
       0,     0,   402,   403,   404,   405,   406,   407,     0,     0,
     408,     0,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   869,
     435,   870,   437,   438,   439,   440,   441,   442,   443,     0,
       0,   446,     0,   447,   448,   449,   450,  2755,     0,   452,
     871,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,     0,   465,   466,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   482,     0,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   872,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,  2672,
     542,   543,   544,   545,   546,   874,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,     0,   563,     0,   564,   565,     0,  4529,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   875,   876,     0,
       0,   576,   577,     0,   579,     0,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,     0,
     877,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   856,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     625,   626,   627,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   857,
     260,   858,   859,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   860,   861,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   862,   863,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   865,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,     0,     0,
       0,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,     0,   385,   386,   387,
     388,   866,   867,     0,   868,     0,   392,   393,   394,   395,
     396,   397,     0,     0,     0,     0,   402,   403,   404,   405,
     406,   407,     0,     0,   408,     0,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   869,   435,   870,   437,   438,   439,   440,
     441,   442,   443,  2829,     0,   446,     0,   447,   448,   449,
     450,     0,     0,   452,   871,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
       0,   465,   466,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   482,
       0,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   872,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   873,   542,   543,   544,   545,   546,   874,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,     0,   563,     0,   564,   565,
       0,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   875,   876,     0,     0,   576,   577,     0,   579,     0,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,     0,   877,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   625,   626,   627,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   857,   260,   858,   859,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   860,
     861,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   862,   863,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   865,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
       0,   385,   386,   387,   388,   866,   867,     0,   868,     0,
     392,   393,   394,   395,   396,   397,     0,     0,     0,     0,
     402,   403,   404,   405,   406,   407,     0,     0,   408,     0,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   869,   435,   870,
     437,   438,   439,   440,   441,   442,   443,  4325,     0,   446,
       0,   447,   448,   449,   450,     0,     0,   452,   871,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,     0,   465,   466,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   482,     0,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   872,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,   873,   542,   543,
     544,   545,   546,   874,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,     0,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   875,   876,     0,     0,   576,
     577,     0,   579,     0,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,     0,   877,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   625,   626,
     627,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   857,   260,   858,
     859,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   860,   861,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     862,   863,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,     0,   344,     0,   345,   346,   347,
     865,   349,  5850,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,     0,     0,     0,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,     0,   385,   386,   387,   388,   866,
     867,     0,   868,     0,   392,   393,   394,   395,   396,   397,
       0,     0,     0,     0,   402,   403,   404,   405,   406,   407,
       0,     0,   408,     0,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   869,   435,   870,   437,   438,   439,   440,   441,   442,
     443,     0,     0,   446,     0,   447,   448,   449,   450,     0,
       0,   452,   871,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,     0,   465,
     466,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   482,     0,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   872,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,   873,   542,   543,   544,   545,   546,   874,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,     0,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   875,
     876,     0,     0,   576,   577,     0,   579,     0,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,     0,   877,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   625,   626,   627,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   857,   260,   858,   859,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   860,   861,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   862,   863,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,   865,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,     0,   385,
     386,   387,   388,   866,   867,     0,   868,     0,   392,   393,
     394,   395,   396,   397,     0,     0,     0,     0,   402,   403,
     404,   405,   406,   407,     0,     0,   408,     0,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   869,   435,   870,   437,   438,
     439,   440,   441,   442,   443,     0,     0,   446,     0,   447,
     448,   449,   450,     0,     0,   452,   871,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,     0,   465,   466,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   482,     0,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   872,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,   873,   542,   543,   544,   545,
     546,   874,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     0,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,   875,   876,     0,     0,   576,   577,     0,
     579,     0,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,     0,   877,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   625,   626,   627,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   857,   260,   858,   859,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   860,   861,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   862,   863,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   339,   340,   341,
     342,     0,     0,   344,     0,   345,   346,   347,   865,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,     0,     0,     0,   362,   363,     0,
     364,   365,   366,   367,  1130,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,     0,   385,   386,   387,   388,   866,   867,     0,
     868,     0,   392,   393,   394,   395,   396,   397,     0,     0,
       0,     0,   402,   403,   404,   405,   406,   407,     0,     0,
     408,     0,   410,   411,   412,     0,   413,   414,   415,     0,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   869,
     435,   870,   437,   438,   439,   440,   441,   442,   443,     0,
       0,   446,     0,   447,   448,   449,   450,     0,     0,   452,
     871,   454,   455,   456,     0,   457,   458,     0,     0,   459,
     460,   461,     0,     0,   462,   463,     0,   465,   466,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   482,     0,   484,   485,   486,
       0,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   872,   498,   499,   500,   501,     0,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   515,   516,   517,   518,   519,   520,   521,   522,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,     0,   539,   540,   873,
     542,   543,   544,   545,   546,   874,   548,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,     0,   563,     0,   564,   565,     0,     0,   566,   567,
     568,   569,   570,   571,   572,     0,   573,   875,   876,     0,
       0,   576,   577,     0,   579,     0,     0,   581,   582,   583,
     584,   585,   586,   587,   588,     0,     0,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,     0,
     877,     0,   601,   602,   603,   604,   605,   606,     0,     0,
     607,     0,     0,   608,   609,   610,   611,   612,   613,   856,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     625,   626,   627,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   857,
     260,   858,   859,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   860,   861,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   862,   863,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   865,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,     0,     0,
       0,   362,   363,     0,   364,   365,   366,   367,  1162,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,     0,   385,   386,   387,
     388,   866,   867,     0,   868,     0,   392,   393,   394,   395,
     396,   397,     0,     0,     0,     0,   402,   403,   404,   405,
     406,   407,     0,     0,   408,     0,   410,   411,   412,     0,
     413,   414,   415,     0,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   869,   435,   870,   437,   438,   439,   440,
     441,   442,   443,     0,     0,   446,     0,   447,   448,   449,
     450,     0,     0,   452,   871,   454,   455,   456,     0,   457,
     458,     0,     0,   459,   460,   461,     0,     0,   462,   463,
       0,   465,   466,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   482,
       0,   484,   485,   486,     0,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   872,   498,   499,   500,   501,
       0,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   515,   516,   517,   518,   519,
     520,   521,   522,     0,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
       0,   539,   540,   873,   542,   543,   544,   545,   546,   874,
     548,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,     0,   563,     0,   564,   565,
       0,     0,   566,   567,   568,   569,   570,   571,   572,     0,
     573,   875,   876,     0,     0,   576,   577,     0,   579,     0,
       0,   581,   582,   583,   584,   585,   586,   587,   588,     0,
       0,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,     0,   877,     0,   601,   602,   603,   604,
     605,   606,     0,     0,   607,     0,     0,   608,   609,   610,
     611,   612,   613,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   625,   626,   627,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   857,   260,   858,   859,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   860,
     861,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   862,   863,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   865,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
       0,   385,   386,   387,   388,   866,   867,     0,   868,     0,
     392,   393,   394,   395,   396,   397,     0,     0,     0,     0,
     402,   403,   404,   405,   406,   407,     0,     0,   408,     0,
     410,   411,   412,     0,   413,   414,   415,     0,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   869,   435,   870,
     437,   438,   439,   440,   441,   442,   443,     0,     0,   446,
       0,   447,   448,   449,   450,     0,     0,   452,   871,   454,
     455,   456,     0,   457,   458,     0,     0,   459,   460,   461,
       0,     0,   462,   463,     0,   465,   466,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   482,     0,   484,   485,   486,     0,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   872,
     498,   499,   500,   501,     0,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,     0,   515,
     516,   517,   518,   519,   520,   521,   522,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,     0,   539,   540,  2672,   542,   543,
     544,   545,   546,   874,   548,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,     0,
     563,     0,   564,   565,     0,     0,   566,   567,   568,   569,
     570,   571,   572,     0,   573,   875,   876,     0,     0,   576,
     577,     0,   579,     0,     0,   581,   582,   583,   584,   585,
     586,   587,   588,     0,     0,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,     0,   877,     0,
     601,   602,   603,   604,   605,   606,     0,     0,   607,     0,
       0,   608,   609,   610,   611,   612,   613,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   625,   626,
     627,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   857,   260,   858,
     859,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   860,   861,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     862,   863,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,     0,   344,     0,   345,   346,   347,
     865,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,     0,     0,     0,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,     0,   385,   386,   387,   388,   866,
     867,     0,   868,     0,   392,   393,   394,   395,   396,   397,
       0,     0,     0,     0,   402,   403,   404,   405,   406,   407,
       0,     0,   408,     0,   410,   411,   412,     0,   413,   414,
     415,     0,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   869,   435,   870,   437,   438,   439,   440,   441,   442,
     443,     0,     0,   446,     0,   447,   448,   449,   450,     0,
       0,   452,   871,   454,   455,   456,     0,   457,   458,     0,
       0,   459,   460,   461,     0,     0,   462,   463,     0,   465,
     466,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   482,     0,   484,
     485,   486,     0,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   872,   498,   499,   500,   501,     0,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,     0,   515,   516,   517,   518,   519,   520,   521,
     522,     0,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,     0,   539,
     540,     0,   542,   543,   544,   545,   546,   874,   548,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,     0,   563,     0,   564,   565,     0,     0,
     566,   567,   568,   569,   570,   571,   572,     0,   573,   875,
     876,     0,     0,   576,   577,     0,   579,     0,     0,   581,
     582,   583,   584,   585,   586,   587,   588,     0,     0,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,     0,   877,     0,   601,   602,   603,   604,   605,   606,
       0,     0,   607,     0,     0,   608,   609,   610,   611,   612,
     613,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   625,   626,   627,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,     0,   260,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,     0,     0,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,     0,     0,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,     0,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,     0,   385,
     386,   387,   388,     0,     0,     0,     0,     0,   392,   393,
     394,   395,   396,   397,     0,     0,     0,     0,   402,   403,
     404,   405,   406,   407,     0,     0,   408,     0,   410,   411,
     412,     0,   413,   414,   415,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   435,     0,   437,   438,
     439,   440,   441,   442,   443,     0,     0,   446,     0,   447,
     448,   449,   450,     0,     0,   452,     0,   454,   455,   456,
       0,   457,   458,     0,     0,   459,   460,   461,     0,     0,
     462,   463,     0,   465,   466,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   482,     0,   484,   485,   486,     0,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   498,   499,
     500,   501,     0,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   515,   516,   517,
     518,   519,   520,   521,   522,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,     0,   539,   540,     0,   542,   543,   544,   545,
     546,     0,   548,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     0,   563,     0,
     564,   565,     0,     0,   566,   567,   568,   569,   570,   571,
     572,     0,   573,     0,     0,     0,     0,   576,   577,     0,
     579,     0,     0,   581,   582,   583,   584,   585,   586,   587,
     588,     0,     0,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,     0,     0,     0,   601,   602,
     603,   604,   605,   606,     0,     0,   607,     0,     0,   608,
     609,   610,   611,   612,   613,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   625,   626,   627
};

static const yytype_int16 yycheck[] =
{
       6,     0,     6,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,   211,   206,     0,
      36,     0,     0,     0,    21,  1025,   214,    21,     0,   217,
     211,   988,   776,   777,   778,   917,  1016,   820,   782,   189,
     663,  1203,    22,     8,  1500,    51,  1005,   817,    28,  1142,
      15,   911,  1629,   913,   873,  1546,  2011,  1562,   695,   989,
    1014,   642,  2712,   844,  2654,   891,   810,   862,   863,  1020,
     197,  1250,  2655,  1472,  1539,  1018,   871,  1237,  1091,   876,
    3004,  1551,  3352,  1869,  3354,  3069,  3839,   827,  3179,   740,
    1546,  2676,  2677,    45,   216,  3444,    44,  1222,  3538,  2000,
    3565,  1226,   843,   929,  1229,  1230,  1065,  1697,   230,  2901,
    1069,  2036,  3645,  2019,   695,  1074,  1592,  1593,  2923,  3591,
    1596,  3593,  1080,    23,   954,  1084,  3866,  2035,  3016,   644,
    4178,  3403,  3888,  3791,   736,  2069,    36,  4494,  1096,  1098,
    1539,  4221,  4225,  3397,  2034,  3454,  4722,  2045,   731,   979,
     175,  1429,  4517,  1529,   984,  1941,   191,   741,  1882,  1664,
    1665,   742,  5200,   191,  4500,   718,    35,     2,  3418,   716,
    1129,   955,   719,    42,  3855,  4984,  4462,  4303,  2534,   732,
    4505,  4738,  2538,  4740,  5041,    50,   823,  5222,  1658,  5033,
    2571,   197,    41,  5328,  3031,  2639,  3221,  3464,  3452,   940,
     206,   207,  5028,  5242,  2641,  3402,  3306,  3404,   214,  4200,
     216,   217,  5376,  1589,   795,  1685,  3853,   914,  4504,   914,
    3012,  5610,     6,  5032,   230,  4787,   860,   861,     6,   988,
    1606,    15,    16,  5364,     0,     6,   870,  2618,   997,     0,
     938,  1025,   823,     0,     6,  4662,  5285,     6,  1007,     0,
       6,     6,  2969,    38,  2971,  2972,    15,    16,    11,  2976,
    2977,  2978,     6,  2980,  2981,  2982,  1512,   848,    54,   119,
       6,    15,    16,    11,    47,   119,     6,   225,     6,    37,
      63,   979,  2006,     6,     6,    78,   984,    85,  1029,    35,
      25,    63,     6,     6,   168,  5292,  5293,    13,  5594,     6,
      80,    91,    72,   146,   181,     6,   102,    94,   124,     6,
       0,    32,   114,   153,    13,  1059,    43,     0,   198,    43,
     168,    11,     3,   219,     5,     6,    29,   908,    11,    45,
      11,    15,   174,    36,    63,     6,  4595,  4596,  4597,    29,
    4599,  4600,  4601,  4602,  4603,    21,    29,     5,   186,    80,
     174,    29,   121,    11,    80,  1593,    21,   119,  1596,   295,
      91,   186,    78,   174,     5,    21,   176,   298,   290,     0,
      11,   174,  1848,  5832,    29,   152,     6,   290,   316,    13,
     150,    36,   301,   316,   276,  5317,  5952,   183,   190,   301,
      21,   174,  4518,   296,   316,    63,    68,   213,   281,    91,
     170,   168,    63,   316,   139,   646,   372,    51,   174,  5798,
      42,   176,   174,   174,    63,    63,   134,   174,   136,  1373,
    5246,    80,   386,   174,   385,    56,  1492,   119,  1441,   385,
    1081,   135,   198,    35,  1385,   343,   123,   198,   119,   260,
     174,   198,   258,   350,  1025,    63,   124,   198,    91,   123,
      87,   276,   342,    63,   223,   470,   165,    13,   260,   309,
     311,   263,   367,   413,   467,  4822,   350,   169,    32,   663,
    5509,  1590,  1851,  1268,  1269,   850,    69,    70,  2612,  6045,
     276,  5612,  1433,   176,   174,   174,  1429,   297,  1607,    45,
     295,   174,  1871,  5789,   337,    59,   197,   738,  1293,    29,
     450,   385,   517,   205,   174,   206,    36,  1304,   198,   213,
     415,   280,  1131,   214,   517,   198,   217,   210,  1137,   713,
     427,  5365,    78,   121,   175,    47,   235,   164,  1147,    80,
      25,   289,  1151,   220,   385,   213,  1155,   218,  1157,   661,
       6,    80,   181,   181,  1163,   667,   220,   513,   456,   513,
    1169,   153,  5941,  1172,    13,   376,   517,   679,   328,    80,
     191,   517,   280,   191,   196,   246,   449,   332,   355,   338,
      91,   812,   475,   463,   376,   513,   311,   513,    80,    13,
     513,  6147,   513,  1324,   356,   352,    45,  1371,   280,   372,
    1541,   513,  1376,  1377,   404,  5325,  1149,   489,   517,  1183,
     513,  6060,   514,   233,   276,   517,  1243,   457,    23,   285,
    1848,   388,  1353,   371,   285,   350,   141,   455,   126,    78,
     285,   517,   470,  1257,  1258,  5557,   466,   356,   424,   285,
     455,  5188,   353,   449,   124,  1430,   642,   517,  1596,   513,
     517,  6030,   432,   441,   139,  4303,   367,   427,   369,    29,
     385,   648,   648,   648,  1288,   661,   648,  1210,   648,   503,
     648,   667,  1243,   513,  1623,   427,  5797,  1626,  1221,    10,
     513,  4329,    13,   679,   444,   517,    17,    18,    19,   462,
     174,   427,   460,   456,   411,  1238,   488,   411,   356,   695,
    1648,  1649,   395,   517,   700,   356,   427,   742,   456,   705,
     378,   427,    23,   709,   710,  1635,   517,   356,   356,  6098,
     716,   432,   718,   719,   517,  1695,  1696,  5134,   511,   454,
    4473,   746,   515,   494,   495,   731,   732,   513,   513,   513,
     517,  1368,  6028,  1517,    23,   513,   742,  5734,   356,  1693,
     395,   503,   513,  1527,   741,   517,   356,  1577,   517,  6138,
     516,   504,   505,   515,   513,   516,  1515,   513,   513,   516,
    5604,  4514,  1459,  4228,  1459,   516,  1832,   917,   427,   513,
    2016,   449,  1406,  1407,   512,  4766,   756,   513,   758,   513,
     760,  5945,  5608,   513,   427,   513,   766,  1368,   517,   795,
     513,   513,  1394,   509,  1613,  1376,  1377,   494,   495,   513,
     513,  5932,  1177,  4336,   511,   770,   513,  1969,   515,  4342,
     509,   817,   818,    23,   504,   505,   513,   823,  1577,   503,
    1702,   504,   505,   504,   505,  5960,   516,   511,   517,   470,
    1614,   515,  4513,   516,  1618,  1619,  5095,   252,  5877,  1537,
     788,   517,   848,   513,   850,  1039,   504,   505,  1036,   517,
    1943,  5890,  1040,   494,  1042,   453,   517,   198,  1039,    23,
    4518,   517,   513,   504,   505,   395,    32,   873,   517,   517,
     905,  4143,   506,   507,   508,   509,   427,   905,   517,   517,
     221,    25,  3467,  1976,  3469,   513,     3,  1830,   427,   895,
     385,  1849,  1590,  3685,  3686,  1988,   844,  3031,  3690,   517,
    4154,  6032,   908,  1030,  4158,   427,   427,   517,   907,  1607,
     907,   907,   907,   907,   907,   907,   907,   907,  4018,   907,
     907,   907,   907,   907,  5486,   427,   907,  4564,   907,   907,
     907,   252,   931,   427,   456,   907,   402,   403,  3826,  5796,
     320,   466,   152,   451,   181,  4142,  4213,  4144,  1323,  5793,
     506,   507,   508,   509,   449,    21,   297,   372,  4423,   449,
     119,  1584,    23,   252,  5864,  6004,  6097,  5776,    63,  3994,
     112,    76,   821,    90,   922,  5705,   825,     6,   296,  3423,
    5710,  5711,  4422,  5792,   152,  3366,   851,  3424,    51,   937,
     174,  5348,    88,   174,   149,   139,   124,  1512,   112,   700,
     380,  6036,  6037,   418,   112,   296,   124,   135,   709,   503,
    1016,  1017,  1018,    29,   198,   716,   175,   648,   719,  1025,
       6,   515,   112,   190,  1030,  1400,   143,     6,  1812,  1035,
    1036,  3823,   447,    88,  1040,   131,  1042,  6172,    23,   419,
    1046,   421,    30,     3,  3540,   504,   505,   506,   507,   508,
     509,   372,  3769,   309,   327,  2035,  1062,   472,    64,   330,
     160,   705,   217,   419,   185,   421,    72,  2018,    25,  5355,
     504,   505,   506,   507,   508,   509,   131,   174,   176,  4329,
     385,   207,   284,   372,   301,  5942,   451,   731,   252,  5933,
     216,  1466,   162,   260,    88,   213,    28,   418,   513,  3455,
    1106,   165,  1108,  1109,   230,  6140,  5546,   124,  5548,  4549,
     741,   742,  5552,  5553,  5671,  2066,    23,   369,   134,    72,
     170,  5493,   281,  6161,   993,   994,   447,    23,   290,   418,
      90,   203,   249,  5259,  1878,  5218,  4485,   131,    91,    25,
     175,    63,   513,  1149,   290,    31,   301,    23,   513,   183,
    2093,   472,   470,   296,   316,   299,   429,   367,   447,    91,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   124,
     316,  1177,  6210,   243,   209,  2859,   296,   119,   388,   470,
     432,  6038,   139,   472,   144,    23,  1183,   353,   293,   224,
     392,   252,   513,   276,   311,   513,   213,   150,   298,   297,
     473,   457,  1985,  1986,  1210,   240,  3791,   271,   372,   376,
     354,   355,   517,  1219,  1795,  1221,   337,   170,   314,   285,
     388,  1186,   292,  1188,   513,  1190,   214,  1192,  6128,  1194,
    1195,  1196,  1238,   470,  5591,     3,  1201,  1243,     6,  6096,
     246,   385,   513,  5600,   176,   205,   427,   368,    23,  1255,
    6107,  5576,   295,   139,   418,  2939,   285,  5622,   213,   314,
    3394,   356,    10,  3397,  5017,    13,  5602,   252,   382,    17,
      18,    19,     3,   415,   905,  2745,   907,  2676,  1323,  1114,
     517,  5606,  6139,   447,  1290,  2776,   470,    25,   443,  5575,
    5030,  3015,   451,  5650,   357,    26,  3881,  1916,  5054,   285,
     517,   418,    37,   420,  3800,  1924,   285,   415,   472,  6166,
    3444,   372,     3,  1319,  1320,  1321,  4781,  1323,  3452,  5605,
     314,   449,  2063,  1906,   420,   415,   361,   470,   362,  1030,
     427,   449,  2610,  6190,   434,  1036,  5708,  1343,   280,  1040,
       0,  1042,  5023,   415,  1946,   252,   114,  3245,  3246,   513,
     470,   513,  3250,  2823,   276,  1938,   252,   418,   318,    90,
    1913,   378,  1368,  1910,  1389,   420,   153,   513,  2958,  1953,
    1376,  1377,   455,  1975,  1927,   328,   252,  1979,  1925,  5819,
      72,  1928,  1984,    43,   119,  1987,   447,  1940,  4225,  2765,
    1584,  1035,  3290,  3291,  1400,   372,   119,   175,   134,  5975,
     332,   139,  1046,   287,  5484,  1106,   335,  1108,  1109,  1444,
    1445,   472,  1447,   144,   252,   112,  1444,  1445,  1062,  1447,
    2043,  5778,   190,  1429,  3358,   311,   420,   119,   119,   198,
     372,  1978,   449,   418,   356,  1982,  1983,   369,    98,   186,
    1446,   758,   759,   760,  1450,  1451,   763,   764,   765,   367,
      10,  4723,   513,    13,   167,  4764,   773,    17,    18,    19,
    1466,    27,   447,   385,   350,   372,  1472,   198,   511,   114,
     113,  3048,   515,  4727,   205,    35,   372,   252,  4732,   186,
     435,  4735,   442,   111,    50,    29,   178,   472,   427,   149,
     450,   444,   260,   453,   449,   263,   372,   230,   430,   385,
     432,  2016,   162,   179,   436,    25,   132,  5952,   168,  4981,
     429,   418,   121,  1461,   174,  1463,   142,     6,   168,   327,
     180,   385,   418,   183,   427,    25,   385,   187,   513,   276,
     180,    31,   124,  1539,   372,   661,   513,   315,    15,    16,
     447,   667,   418,   276,   280,   190,  4530,   139,   198,   297,
     385,   447,  1183,   679,   473,  2535,    39,   217,   415,   219,
     203,   177,   285,   362,   311,   472,   301,   451,    40,   276,
     246,   447,  5929,   311,  1580,  1219,   472,   119,   517,   276,
     418,   350,    54,   243,   513,   354,  2537,   318,   280,   280,
     134,   378,   299,   285,   285,   513,   472,   372,  2612,  1598,
    6045,  5259,  3067,   350,  1603,   338,   513,  1613,   376,   447,
     323,  5694,   350,   391,   517,   260,   385,   513,   263,   139,
    1251,   429,    98,    38,  5938,  5939,  5366,   149,   415,   257,
     367,   362,   292,   261,   472,   295,   328,   513,   110,   139,
    1271,   301,  2017,   418,  2019,    60,   129,   385,   214,  4486,
    2025,   450,   344,   517,   427,   388,  2031,  2032,   517,  5707,
     121,   221,  2037,   310,  3063,   473,   342,  2610,  3067,  6026,
     457,  2046,   447,  5354,  1680,   513,   285,  2052,   256,   352,
    1679,   412,   517,   470,  1683,   311,   121,   451,  4493,  1695,
    1696,  1697,  1323,    99,  4411,  4487,   111,   472,   358,  4416,
    2700,   470,  6147,   369,   180,  6123,  1654,   494,   455,   162,
     360,   442,   449,  4012,  4013,   168,   449,   333,  4303,   450,
     488,   243,   453,  1911,   350,   494,   513,  1921,  1922,   372,
     503,   376,  4824,   325,   162,   230,  6093,   297,   513,  4831,
     212,  1922,   515,   419,  4329,   421,   461,   310,   455,   513,
     366,   411,   444,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   223,   178,   380,  6183,   432,   309,   503,   175,
     413,   447,   415,  1900,   276,    29,   511,   310,   513,   514,
     515,   276,   517,   443,   311,  6099,   201,   463,   223,  1795,
     243,   311,   255,   367,  4093,    13,    25,   470,   513,  4449,
     416,  1807,    31,   209,   276,    58,   310,   467,   232,   469,
     470,   311,  1818,  1444,  1445,   243,  1447,   280,   224,   280,
     121,   494,   385,   350,  1830,  5873,   400,   122,  1834,    83,
     350,   491,    86,   429,   240,   202,   378,   252,    92,   292,
    5593,   342,   257,   488,   517,   280,   261,  1853,   350,  2043,
     350,   301,   385,  2672,   514,  1861,   516,   517,   385,   513,
      78,   276,   268,  1869,  2807,   385,   120,  1184,   513,  2652,
    1187,  5611,  1189,   415,  1191,   128,  1193,   338,   379,    10,
    1197,   385,  1888,  4720,   372,   385,    17,    18,    19,   295,
    2833,  1897,   162,   388,  1900,   310,   174,  1903,   168,   194,
    1906,  1907,   374,   338,  1910,  1911,   207,  1913,  1914,   276,
     139,   122,  2869,   401,   415,   457,  2700,   742,   280,  1925,
     198,  1927,  1928,   285,   178,   375,   311,   311,   470,   461,
    5184,  1937,  1938,  4518,  1940,  1941,  1580,   191,   119,  5620,
     355,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     204,  2570,   494,  5393,   449,   361,  1953,   151,  6041,   394,
      10,  2919,   463,    13,   379,   350,   350,    17,    18,    19,
     795,   513,  1978,   243,   336,   276,  1982,  1983,   378,   280,
       0,   513,   122,   194,   399,    35,   513,   168,  2033,  2932,
    1955,  3946,  1957,  2009,  1959,  5086,  1961,   470,  1963,  3092,
     385,   385,  1967,  2000,  2000,  2000,   200,   355,  2000,  3964,
    2000,  2017,  2000,  2019,   517,   415,  2775,  3031,  2024,  2025,
    4154,   494,   292,   848,  4158,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,   447,   419,  2040,   421,  2042,   385,  2044,  2045,
    2046,  2047,  2048,  2049,    99,   451,  2052,  1995,  2054,  2055,
    1451,  5791,  2058,  5809,   194,  2998,    52,   457,   119,  4983,
    6143,   367,   311,   369,    13,  3464,  2072,  2073,  2074,  2075,
    2952,  2953,  2954,   354,  3980,  3474,    99,  3035,  3036,  3037,
    3038,   470,  3040,   908,   153,  2091,  4011,  2093,  3996,  2873,
    3555,  4225,  2922,  3670,  4002,   156,    45,  2881,  5022,  3278,
    2884,   350,  5574,  2847,   385,  2849,   470,  3065,  2849,  5790,
    2869,  4001,  2012,   513,  5002,  4005,  4006,  5387,    93,  2700,
     175,  5212,   342,  5214,  5256,  3084,   432,   330,   517,    78,
     191,  4029,  4030,  4031,  4032,   516,  3922,  4035,  4036,  4037,
    4038,  4039,  4040,  4041,  4042,  4043,  4044,   401,  2907,   311,
     404,   177,   175,   517,   209,    48,  3555,  1598,  3748,   379,
    5625,   136,  1603,  1807,  3754,   299,   297,  3643,  5300,   224,
    5007,   221,    80,   350,  1818,   354,   511,   311,    71,  4971,
     515,  4973,  2941,    91,   346,   240,   209,   311,   350,   121,
    1834,   470,    72,    35,  5934,   415,  1897,   193,    78,  1900,
      91,   224,   198,  4101,  4102,   338,   385,  5647,   385,  1910,
    1911,    91,  3155,   268,  2589,   494,   350,   240,   351,   280,
    2773,   289,  3692,   385,  1925,   432,   350,  1928,  4945,  2235,
    4947,  4948,  4949,  4134,   513,   511,   168,   513,  1679,   119,
     295,   121,  1683,   463,  1888,   268,   242,   297,   381,   282,
    5599,    38,     5,   179,   168,   463,   470,   311,    11,  1903,
     311,    10,  1906,  1907,    13,   311,    19,  3737,    17,    18,
      19,   378,   513,    60,   515,   207,  2282,  1978,   192,  3458,
     494,  1982,  1983,   168,    37,  5555,    35,   256,   179,  6042,
      27,  6031,   168,  1937,  1938,  2897,   350,  2899,   178,   350,
     354,  2903,   375,   517,   350,     3,   361,   192,   415,   378,
     233,   280,   203,    50,  3058,   309,   192,   259,   514,   470,
     246,   517,  1953,   149,   111,   270,  3269,   207,   462,  2335,
     256,   385,  3275,    25,   385,   427,   162,  5870,   361,   385,
     366,   111,   168,   494,   276,   378,   415,   373,   280,   294,
     457,  4485,  4486,   503,   380,   246,  5511,  3862,  3142,   451,
     513,  5516,  5517,   470,   513,   515,  3017,  5204,    80,  2000,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    91,
    3394,  5218,   415,  3397,   378,   983,   514,   494,   457,   517,
     416,   217,    90,  6198,   390,  6200,   432,     5,    90,   169,
     280,   470,  2033,    11,  1002,   285,   513,  1005,   375,   300,
    5875,  5876,   438,     5,   201,  6220,  6169,   243,   352,    11,
    2051,   415,   506,  5693,   457,   494,     5,   511,  2072,   513,
    3444,   515,    11,    22,   513,   205,   515,   470,  3452,    28,
     132,   494,   495,   514,   513,   143,   517,   139,   328,   256,
     142,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     513,   494,  3081,   457,   344,   252,   292,  3086,   512,  3088,
     257,  3353,   221,   517,   261,   301,   470,   256,  3219,  3098,
     513,   514,  3101,   516,  3103,  3104,    95,   257,  3107,   276,
     203,   261,  3111,   419,  3113,   421,   259,  3116,   508,   512,
     494,   494,   495,   513,   517,   515,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,   514,  2522,   508,   517,   513,
     513,   447,   513,   310,   515,    33,    34,  2533,   419,  2535,
     421,   295,  5997,   295,   192,   979,   300,  3139,   300,  5376,
     984,   432,  2736,  4441,  2603,  2604,  2605,  2735,   297,  2737,
    2738,   249,    87,   444,  1680,  2736,   447,   470,   511,   472,
     513,  3180,   515,   514,   444,   432,   517,  2573,   355,   463,
     514,  2577,  3697,   517,  2580,  3359,  2582,   514,  2572,  2585,
     517,  3378,  3379,  2589,   514,   375,  4720,   517,  5305,   470,
      98,   472,   379,  4727,   272,   273,   274,   275,  4732,    59,
    2056,  4735,  5439,  2059,  2610,  2732,  2612,   233,  2612,  2240,
     118,  3541,   399,   311,    33,    34,  3356,   443,    10,   311,
    6085,    13,  4577,  2629,   513,    17,    18,    19,  3258,   461,
    3260,  3261,  2638,  2639,  2035,  2036,    11,  3567,  4593,  3465,
     367,   368,   506,  5627,  2045,   153,    38,   511,   346,   513,
    2772,   515,   350,  2054,   346,   514,   354,   516,   350,  2665,
     447,   514,  2657,   419,   517,   421,  2672,   413,  3409,   514,
    2676,  2677,   517,   514,  5259,   514,   517,  2683,   517,   514,
    3475,  2687,   517,   367,   368,  2691,  2702,   385,  2704,  3851,
    3313,   494,   495,   385,  2700,  3646,  5488,   149,  4275,   514,
     392,   513,   517,   514,  5496,  5497,   517,   367,   368,  4495,
     162,  4619,  2718,  5225,  5226,  2721,   168,  4625,  4626,   295,
     418,  5991,   420,   470,   372,   472,  2732,  1853,  2734,  2735,
     514,  2737,  2738,   517,  2740,  1861,  2858,   514,   514,   514,
     517,   517,   517,  1869,   517,   514,  2752,   514,   517,   419,
     517,   421,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   134,   514,   136,   516,   217,  2772,  2773,  4273,   470,
    4275,   472,   470,   514,  4265,  2781,   517,  5868,  3359,   367,
     368,  4251,    10,  3542,   514,    13,   514,   517,  1914,   517,
     514,   243,   514,   517,  5379,   517,  2744,  2803,  2804,   514,
      59,  2807,   517,  3963,   514,   514,   514,   517,   517,   517,
     514,  5662,  5663,   517,  4213,  1941,  2938,    45,   514,  3832,
     514,   517,   513,   517,    52,  2831,  4125,  2833,  4127,   221,
    3788,  2837,   463,   514,   514,  3794,   517,   517,   346,  4309,
     292,   514,    48,   514,   517,  2851,   517,  3790,   490,   301,
      78,    98,  2858,   514,   223,  2861,   517,  5694,   515,  3618,
     514,  2867,   514,   517,   514,   517,   149,   517,  5838,  5839,
     378,   118,  3247,  5007,  6144,   514,   298,   514,   517,   162,
     517,  2887,  3519,   168,  3259,   168,  3505,  2893,  5471,   514,
    3492,   295,   517,   514,  2900,  2843,   517,  3641,    54,    55,
     514,   149,  3646,   517,   295,   297,   153,   415,  2914,   514,
     514,  2612,   517,   517,   162,   514,  2896,   298,   517,  3294,
     168,  2927,   490,  4711,   514,  4713,  2932,   517,    48,   490,
     514,  6201,  2938,   517,   217,   223,  3489,  3490,  3519,   514,
     514,   514,   517,   517,   517,   514,   506,  2578,   517,   457,
    2956,  2957,  2958,   461,   149,   173,  2962,  3576,  5795,  3578,
     243,   514,   470,  3338,   517,   193,   517,   162,   514,   217,
     198,   517,   514,   168,   514,   517,   514,   517,  4159,   517,
    4161,  2612,   514,  2989,  2990,   517,   494,   134,   513,   136,
     514,   443,  2998,   517,   514,   243,   514,   517,  3186,   517,
    3188,  3189,  4507,    10,  5928,   513,    13,   460,   513,   292,
      17,    18,    19,   160,   242,   513,    37,   514,   301,  4198,
     517,   514,   217,   513,   517,  3031,  2657,  3031,    35,   514,
     514,  2732,   517,   517,  2735,   514,  2737,  2738,   517,   514,
     514,   514,   517,   517,   292,  1461,  4502,  1463,   243,   324,
    5184,   514,    54,   301,   517,  3050,  3183,  3063,  4523,   511,
     514,  3067,   514,   515,  4226,  4227,    59,   174,  4230,   297,
    5204,   514,   514,   219,   517,   517,  3820,   514,   225,  5166,
     517,  5168,  3635,   514,  5218,    10,   517,   219,    13,   513,
    2734,   474,    17,    18,    19,   513,  2740,   292,   100,   346,
    5690,  3720,   514,   513,  3657,   517,   301,  3726,  5945,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   515,  3313,
     513,  4072,  4065,   125,  4523,   272,   273,   274,   275,   350,
     198,   378,   279,   280,   154,   515,   514,  2781,   285,   517,
    4154,   143,   154,   514,  4158,   147,   517,  3153,   514,  3155,
     514,   517,   514,   517,   514,   517,   513,   517,   295,  3796,
     443,  3798,   390,   198,  3170,   350,  3172,   169,   415,  3950,
     295,   173,   514,  3179,  4128,   517,   154,  3183,   514,  3185,
    3186,   517,  3188,  3189,  3190,   514,   188,  3971,   517,   154,
     514,   514,  3198,   517,   517,   443,   514,  3203,  6035,   517,
     514,   198,  3247,   517,  6041,   514,   514,   154,   517,   517,
     457,  4225,  3218,   514,   221,  3796,   517,  3798,   514,   295,
    4171,   517,  5120,   470,  3418,   168,   350,   154,  2629,   121,
     241,   451,   295,   513,   289,   168,  3838,   514,    72,  3245,
    3246,  3247,  5376,  3880,  3250,    38,   280,   494,   443,  3294,
     280,   474,  3258,  3259,  3260,  3261,   513,  4208,  3811,   295,
    3813,  4838,   280,  3269,   492,    48,   513,    48,  3274,  3275,
     280,  3277,   437,  3279,   280,    90,   504,   505,   506,   507,
     508,   509,   311,   285,  3290,  3291,   463,   434,  3294,   463,
     297,  3910,    87,  3912,   432,  3914,   221,  5947,   445,  3880,
     168,   154,   154,   331,   513,  5439,  6143,   154,   154,  3315,
     474,  3317,   154,  3319,   154,  4274,   511,   517,   154,   154,
     515,   154,   154,   154,   154,  4816,   154,   168,   154,   154,
    3031,   154,  3338,  3935,   336,   154,   295,   415,   513,    38,
      10,   241,   295,    13,   168,   513,  2990,    17,    18,    19,
     168,     6,  3397,  3359,     6,   513,   513,   168,   513,  4302,
     513,  4304,   513,   513,   513,    35,   134,     6,   136,   513,
       6,   513,   297,   513,   513,    45,     6,   513,   513,   513,
     513,     6,    52,   513,  4546,  4328,   513,   513,  3394,   287,
    3394,  3397,   160,  3397,  3346,  3347,  3348,   513,   513,   513,
     513,   513,   513,  3448,  3410,   513,   471,   513,    78,  3415,
     513,   513,   513,  3966,   513,  4210,   513,  4243,   513,  3050,
     307,   163,   219,   517,  3430,   281,   282,   517,    38,   102,
      38,   241,   513,    37,   425,   425,   511,   511,  3444,   427,
    3444,   427,   427,   513,   427,   174,  3452,  5402,  3452,   168,
     517,   168,   290,   292,   385,    68,   427,   225,  3464,   427,
    4419,  3467,   372,  3469,   427,  5599,   462,  4397,  3474,   427,
     372,  4485,  4486,   515,   243,   427,   427,   372,   427,    79,
     503,   427,  3183,  3489,  3490,  3186,   427,  3188,  3189,  3495,
      91,  6141,   372,   154,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   295,   272,   273,   274,   275,   377,   427,
    3516,   279,   238,  3519,  5412,   427,  3522,   285,   285,   427,
     127,   450,   378,   193,  3530,  4407,  3170,   418,   198,   316,
     295,   290,   513,   427,   427,   191,   513,    91,   367,  2665,
     127,  3185,   517,   154,  5442,  4329,  3190,   311,   198,  3555,
     451,   221,   222,   427,   451,   427,   427,  2683,   127,   415,
    5694,  2687,   427,   427,   113,  2691,   427,   427,   427,   127,
     427,    59,   242,   427,  3218,    59,   501,   502,   503,   504,
     505,   506,   507,   508,   509,  3591,  3592,  3593,   265,   299,
     427,   335,  2718,   316,   335,   335,   316,  3791,    47,    47,
     427,   457,   517,   514,   418,   427,   427,   427,   295,   518,
    3616,   427,   221,   283,   470,   427,  3247,   295,   427,  3625,
     427,  3627,   427,   427,   221,   221,  2752,   297,   221,  3635,
     300,   221,    10,   221,   437,    13,  4579,   221,   494,    17,
      18,    19,   221,   221,   221,   427,  2772,   513,    38,  4024,
     154,  3657,   295,   154,  5053,   119,   280,   513,   154,   154,
     451,  5795,   462,  3294,   154,   280,   434,    45,   295,   249,
      38,   168,    38,   233,    52,   280,   374,   445,  2804,   154,
      38,   280,   154,  4058,   154,   451,   154,  3318,   451,   427,
     284,   289,   174,  3394,   466,   265,  3397,   265,    13,   427,
      78,    10,    60,  3334,    13,  2831,  4720,   513,    17,    18,
      19,  2837,   513,  4727,   513,  3721,   425,   513,  4732,   517,
     390,  4735,   183,   513,   513,  2851,   429,   513,   191,   517,
     306,   191,  2858,   511,   514,  2861,  4111,  3743,   514,   490,
     490,  2867,  3748,  3444,   514,   376,   263,   388,  3754,   467,
     217,  3452,   514,   111,   514,   296,   514,  3763,   451,   230,
     517,  2887,   517,  3394,    38,   451,  3397,  2893,   304,    59,
     462,   514,   451,   230,  2900,   230,   513,   372,   285,   285,
     427,   427,   427,   513,  3790,  3791,   168,  4571,  2914,    48,
    3796,   285,  3798,   295,   280,   295,   241,   241,   241,   427,
     367,  2927,   394,   259,   295,  3811,   418,  3813,  4759,   127,
     517,  5945,  2938,  3444,   295,   193,   295,  3448,   198,   295,
     198,  3452,   492,   517,   350,   192,   385,  3833,   470,   382,
    4992,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     338,   427,   427,   201,  3245,  3246,   514,   301,   518,  3250,
      38,   221,   233,  3859,   334,  4674,   154,   290,   168,   503,
     451,   463,   451,    38,   242,   416,   170,   382,   154,   335,
    3865,   154,   154,   513,  3880,  3881,   513,   290,  3522,   451,
     280,    38,  4742,   280,   295,    27,  3530,   470,   295,  3290,
    3291,   233,   290,   189,   252,   189,   168,  3903,    38,   257,
     169,  6035,   233,   261,  5360,   382,  3901,  6041,   168,   295,
     198,   280,   221,   198,  4467,  4468,  3922,   198,   276,   297,
     198,  3869,   198,    59,   474,   174,   262,   470,   427,   289,
     295,   174,   456,   515,   491,  3941,   517,   301,   134,  3945,
     513,  4560,   517,   517,  4563,   307,   517,   174,   467,   514,
     514,   517,   310,   514,   517,   517,   317,   490,   514,  4109,
    3966,   256,   514,  4565,  4566,  4567,  4568,  4569,   514,   514,
     514,   279,   514,  4592,   514,   513,  3982,   514,   513,  3985,
     514,  3625,   514,  3627,  4754,  3991,   514,   514,   297,  5494,
     427,   513,   513,  5007,  4953,  4001,   512,   355,   512,  4005,
    4006,   513,  3950,   514,   174,  4011,   183,   517,   513,  6143,
     449,   494,   390,  4019,   251,  4021,   467,   457,  4024,   493,
     295,   379,  4028,  4029,  4030,  4031,  4032,  3153,    59,  4035,
    4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  4044,   295,
     298,   399,  4048,  4049,  4050,  4829,  3172,  4053,   295,   203,
     503,   513,  4058,  3179,   513,   513,   154,  4063,   211,  4065,
     285,  4067,  4107,   157,   427,   280,   154,   404,    10,  4075,
     427,    13,  4078,   427,  4080,   427,   377,  3721,   385,   154,
    5978,  5979,   154,   241,   377,    62,   377,   203,   157,   447,
     295,   503,  4098,   427,   157,  4101,  4102,   243,   451,   372,
    4106,  4107,   318,    45,   318,  4111,   157,  4113,   467,  4303,
      52,   427,   401,   448,   492,   427,   427,   372,   253,  3763,
      97,   427,  4745,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   253,   253,   372,  4329,    78,  4134,  4134,  4134,
    4146,   372,  4134,   427,  4134,   127,  4134,   427,  4154,   372,
    4154,   280,  4158,   385,  4158,   154,   514,   427,    47,   427,
     427,   427,   427,   427,   427,  4117,  4118,  4119,  4120,   514,
    5184,   514,   221,   427,   514,   221,   186,   299,   517,  4798,
     512,   158,     3,   168,  4190,   514,   514,   437,    48,   112,
    5204,   514,   501,   502,   503,   504,   505,   506,   507,   508,
     509,  4207,   168,   517,  5218,   147,    38,  4213,   513,   154,
     427,   514,   168,   154,   290,  3859,   503,   186,   195,  4225,
     154,  4225,  4841,  4842,   372,   451,   382,   451,  4972,  5628,
     152,   372,   152,   372,  3865,   372,   513,   221,   372,   145,
    4246,   221,   221,   221,   225,   221,   517,   221,   221,   221,
     221,   193,   358,   295,   511,   295,   198,    59,   295,  3903,
    4813,   238,   295,    13,   517,   462,   307,   174,   514,   514,
    3901,   279,   514,   514,   514,   444,   444,   512,   517,  5161,
     514,   514,   305,   513,   513,  4660,   514,   224,   224,   417,
     302,  4297,   513,    59,   187,   513,  4302,  4303,  4304,   276,
     242,   424,   358,   280,   456,    89,   437,   168,    38,   233,
    4912,  4913,  5194,  4915,   427,   211,  4935,  4936,   451,   451,
      59,   418,  4328,  4329,  4518,   154,    86,   401,   178,   437,
      38,   427,   377,  5910,   311,   312,   427,   157,   427,   350,
     372,  3985,   427,   427,   372,   470,    59,   514,   514,   514,
    4903,   513,    60,   513,   418,   297,   457,   168,    78,   154,
     295,   112,  5376,  4343,   437,   514,   221,  5310,  4374,   221,
     221,  4377,   221,   350,  4354,   513,   230,   354,    86,   206,
     427,   474,   359,   513,  4028,   295,   513,    38,   514,   316,
    3516,   368,   293,   517,     3,    10,   295,    44,    13,   517,
     377,   513,   437,   111,   112,   427,   517,   514,   385,  4053,
     513,   119,   382,   180,   112,   174,   181,   221,   143,   514,
     397,   285,   514,   285,   514,  5439,   285,   285,   514,   406,
      45,   174,   514,   410,    59,  4441,   514,    52,   468,  5532,
     517,  5534,   468,   231,   307,   231,  5065,  5000,   390,  5068,
    5069,   316,   514,  4154,   514,   513,   513,  4158,   513,   424,
     224,  4467,  4468,    78,   469,  4471,   290,   503,   427,  5088,
     178,   174,  4478,   437,   470,    78,  4107,   205,   192,  4485,
    4486,  4485,  4486,   192,   285,    62,   285,   503,   465,  4495,
    3616,    59,   418,   201,   427,   427,   517,   517,    72,   427,
     154,   157,   427,  4134,   221,  5667,   126,   514,   176,   513,
      38,   119,  4518,   198,   290,   513,  4511,  4523,  4524,  4525,
      97,   451,    38,  4154,  4225,   382,   280,  4158,   170,  4535,
     470,    84,   147,   290,   382,    59,   418,    38,   174,   470,
     295,   168,  5704,  5543,   252,   513,   208,   345,   219,   257,
     492,  4745,   298,   261,  5337,   517,   514,   514,   174,   514,
     513,   456,   504,   505,   506,   507,   508,   509,   276,    59,
    4576,   514,   280,  4579,    38,  5177,   398,    81,   193,   375,
      91,   158,   199,   198,   513,  5599,  5188,   135,  5750,  5751,
     295,   344,   513,   427,    38,   514,  5219,   514,   154,  4605,
     154,   427,   310,   168,   513,   513,    38,   285,   513,   513,
    4011,   513,  4618,   513,   451,   254,   513,  3743,   195,   513,
     382,   154,   514,   112,    38,   299,  4632,   242,  4029,  4030,
    4031,  4032,   174,   514,  4035,  4036,  4037,  4038,  4039,  4040,
    4041,  4042,  4043,  4044,   437,   514,   168,   355,  5271,   396,
     202,   396,   111,    38,  4660,   418,   456,  4663,   514,   466,
     513,   238,  4063,   168,   191,  4671,  4672,   513,  4674,   513,
     517,   379,  4678,  4679,   517,   513,   451,  4683,   513,   276,
    5694,   418,   297,   513,  4690,   203,   514,  4693,  4694,   295,
       6,   399,   161,   401,  4700,   474,   404,   513,   368,   276,
    4101,  4102,   368,   280,    72,   298,    72,  5260,   516,   135,
     140,   455,   470,   165,  4720,   456,  4720,   466,   470,   165,
     514,  4727,   513,  4727,   513,   517,  4732,   385,  4732,  4735,
    4736,  4735,  5675,    35,   311,   312,   255,  4743,   174,   447,
     341,  5903,  5742,   418,   285,  4146,   418,   205,  4754,   295,
     295,   382,   513,    38,    38,   298,  4762,   513,   298,  5543,
     199,  4756,  4757,  4779,   176,   176,   153,   367,   150,    59,
      59,   513,   302,   350,    38,   390,  4782,   354,   351,   423,
     514,  5795,   359,    59,  4485,  4486,   427,   405,   124,   449,
     514,   368,     6,   382,  4800,   513,  3922,  5740,   140,    35,
     377,   285,   513,  5760,   423,   513,   513,  4813,   385,  5971,
    5972,    24,   367,   517,    81,  3941,   517,   367,   303,  3945,
     397,   281,   385,   427,   174,   513,   281,  4471,   153,   406,
     396,   119,   396,   410,  4840,   517,   457,   513,   470,   176,
     470,   176,   456,  4823,   451,   457,   513,  5386,  5450,   514,
     994,  4857,  1377,  4833,  4485,   907,  4862,   456,  2907,  2816,
     947,  3359,  3567,  4869,  4302,  1682,  5485,  4277,  5894,  2933,
    2987,  3782,  5313,  5740,   993,  6012,  4465,   492,  5360,  4885,
    4511,  4275,  4275,  4962,  5336,  3496,  4892,  3129,   465,   504,
     505,   506,   507,   508,   509,  5874,  5218,  4903,  6000,  5770,
    5769,  6035,  5914,  3500,  5007,  4486,  4512,  4497,  5714,  4455,
    3001,  3001,  4297,  3592,  3830,  4481,  5001,  5343,   989,  5538,
    3874,  4548,  5640,  6108,  6213,  6195,  5327,  3790,  4934,  4520,
    5926,  5945,  5273,  5723,  5536,  1842,  5514,  5276,    18,    28,
    3939,  4576,   644,  5483,  1886,  6104,  4579,    10,  5529,  1211,
      13,  3017,  2677,  4523,  4960,  3474,  5386,  1883,  1897,  3885,
    5628,  1921,  5543,   696,  3724,  5709,  2932,  4328,  3643,  5952,
    4976,    10,  6147,  1496,    13,  4981,  4552,  4554,    17,    18,
      19,   729,    45,  2963,  2619,  6163,    38,  1795,  5480,    52,
    4758,  4205,  5867,   838,  5000,    40,    35,  1393,  1354,    40,
    3430,  5007,  4618,  5007,  3415,  2629,    45,  1454,  5855,  5687,
      62,  1453,  6012,    52,  3397,    78,  4143,  5185,  1456,  4720,
    4160,  6035,  3394,  5439,  5019,  5219,  4727,  6041,  5438,  4206,
    6125,  4732,  5651,  3394,  4735,  4736,  5849,  5982,  5674,    78,
    4441,  4067,  5416,  5418,  2527,    97,  5688,  5053,  3336,  5055,
    5689,  2528,  2047,  3318,  3199,  1410,  2962,  5432,  3316,  3306,
    3233,  4004,   895,  2533,    -1,  5259,    -1,  2617,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5271,  5453,    -1,
    5086,    -1,  5270,  5706,   147,  5460,    -1,    -1,    -1,    -1,
    5271,    -1,    -1,    -1,    -1,    -1,  4727,    -1,    -1,    -1,
      -1,  4732,    -1,    -1,  4735,    -1,   158,    -1,    -1,    -1,
      -1,  5117,    -1,    -1,  5120,    -1,    -1,  5123,  5124,  5125,
    4246,    -1,    -1,    -1,    -1,  4756,  4757,  5315,    -1,  6143,
     193,    -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   195,  5150,  5151,    -1,    -1,  5154,    -1,
      -1,    -1,  5527,  5528,   193,    -1,  4800,    -1,    -1,   198,
      -1,  5742,    -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,
      -1,    -1,    -1,    -1,  5180,    -1,    -1,    -1,  5184,   242,
    5184,   233,   221,   222,  5190,  5191,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4840,    -1,  5204,    -1,
    5204,  5207,  6182,   242,    -1,    -1,  5212,  6150,  5214,    -1,
      -1,    -1,  5218,    -1,  5218,    -1,    -1,    -1,  4862,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,
      -1,    -1,  5197,    -1,   297,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,  4374,    -1,
      -1,  4377,  6195,  5259,  5260,    -1,    -1,    -1,   297,    -1,
     312,   300,  4663,    -1,  5270,    -1,    -1,    -1,    -1,    -1,
    6213,    -1,    -1,    -1,    -1,  4976,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   354,    -1,  5310,    -1,  5007,   359,  5683,  5315,
    5685,    -1,    -1,  5894,  6196,    -1,   368,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   377,    -1,   390,    -1,    -1,
      -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   397,  5341,  6091,  6092,    -1,
      -1,   390,  4478,    -1,   406,    -1,    -1,    -1,   410,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4495,
    5376,    -1,  5376,  5379,    -1,    -1,  5995,  5372,   430,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,  5386,  5019,  5386,
    5386,  5386,  5386,  5386,  5386,  5386,  5386,    -1,  5386,  5386,
    5386,  5386,  5386,    -1,    -1,  5386,  5412,  5386,  5386,  5386,
    5416,  5055,  5418,   465,  5386,  5460,    -1,   469,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    52,  5432,  5375,    -1,   492,
      -1,  6012,    -1,  5439,    -1,  5439,  5442,    -1,    -1,    -1,
      -1,   504,   505,   506,   507,   508,   509,  5453,    -1,    -1,
    4576,    78,    -1,   492,  5460,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,    -1,    -1,    -1,    -1,   514,    -1,    -1,   517,    -1,
      -1,    -1,    -1,  5184,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5204,    -1,  5511,    -1,    -1,    -1,    -1,
    5516,  5517,  5706,    -1,    -1,  5521,    -1,  5218,    -1,    -1,
     147,  5527,  5528,  5529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5543,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5190,    -1,    -1,    -1,
      -1,    -1,    -1,  5184,    -1,    -1,     6,  5563,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5571,   193,    -1,  5574,  5270,
      -1,   198,    -1,    23,    -1,    25,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,  5599,    44,  5599,    46,    -1,    -1,    -1,
      -1,    -1,    62,    53,    54,    55,  5601,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5315,   242,    -1,    -1,    -1,    -1,
      -1,    -1,  5628,  5629,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5652,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5661,  5662,  5663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5674,  5675,
     297,    -1,  5678,    -1,    -1,  5376,    -1,  5683,    -1,  5685,
      -1,  5687,    -1,    -1,    -1,    -1,    -1,    -1,  5694,    -1,
    5694,    -1,    -1,  5881,    -1,    -1,  5691,    -1,   158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5715,
    5341,    -1,    -1,  6088,    -1,    -1,    -1,    -1,    -1,  5120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4857,    -1,    -1,  5740,   195,  5742,    -1,  5439,    -1,
      -1,  5372,    -1,  4869,    -1,    -1,    -1,   197,   198,   199,
      -1,    -1,   202,    -1,    -1,  5386,   206,    -1,   208,    -1,
      -1,   211,    -1,   390,   214,  5953,  5954,   217,    -1,    -1,
     220,    -1,   222,  5174,    -1,   225,    -1,    -1,   238,   229,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5795,
      -1,  5795,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6187,    -1,    -1,    10,   276,    -1,    13,    -1,
     280,    -1,    -1,    -1,    -1,    -1,  5832,    -1,    45,  5460,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,  5845,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5855,
      45,   311,   312,    -1,    -1,    -1,    -1,    52,    -1,  5865,
      -1,    78,  5868,    -1,    -1,   492,    -1,  5511,    -1,    -1,
    5571,    -1,  5516,  5517,    -1,  5881,    -1,   504,   505,   506,
     507,   508,   509,    78,    -1,    -1,    -1,    -1,  5894,    -1,
     350,    -1,    -1,    -1,   354,    -1,    -1,    -1,  5599,   359,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   368,    -1,
       0,    -1,    -1,    -1,    -1,    -1,    -1,   377,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,    -1,  5935,
     147,    -1,  5927,    -1,    -1,    -1,    -1,   397,    -1,  5945,
      -1,  5945,    -1,    -1,    -1,    -1,   406,  5953,  5954,    -1,
     410,    -1,   147,  5959,    -1,  5952,  5952,  5952,    -1,    -1,
    5086,    -1,  5952,    -1,  5952,    -1,    -1,    -1,  5599,    -1,
    5601,    -1,  5978,  5979,    -1,    -1,   193,    -1,    -1,    -1,
      -1,   198,    -1,    -1,    -1,  5629,    -1,    -1,    -1,    -1,
      -1,    25,    -1,  5694,    -1,    -1,    -1,    31,   193,    -1,
    6045,    -1,    -1,   198,    -1,   465,  6012,    -1,    98,    -1,
      -1,  5412,    46,    -1,    -1,  6203,  6204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,  6035,
      -1,  6035,    -1,    -1,  5678,  6041,    -1,  6041,    -1,    -1,
      -1,  5442,    76,    -1,    -1,    -1,    -1,   242,  6045,  6045,
    6045,    -1,    -1,  6059,  6060,  6045,    -1,  6045,    -1,   149,
    5691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6074,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,
     297,    -1,  6088,    -1,   174,    -1,  5212,    -1,  5214,    -1,
     180,    -1,    -1,   183,  5795,    -1,   130,   187,   132,    -1,
      -1,    -1,   297,    -1,    17,   139,    -1,    -1,   142,    -1,
      -1,    -1,    -1,    26,    -1,    -1,    -1,  6123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,  6143,    -1,  6143,
      -1,    -1,    -1,    -1,  6150,    -1,    -1,    -1,    -1,    -1,
    6147,  6147,  6147,   243,    -1,    -1,     0,  6147,    -1,  6147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   205,    -1,   390,    -1,    -1,  6182,  6183,    -1,    -1,
    5881,  6187,    -1,    -1,    -1,  6191,    -1,    -1,    -1,  6195,
      -1,    -1,    -1,   643,    -1,   390,    -1,  6203,  6204,   649,
      -1,   651,   292,   653,    -1,   295,   656,  6213,    -1,    -1,
      -1,   301,    -1,   663,    -1,    -1,    -1,    -1,   668,    -1,
     670,    -1,    -1,    -1,    -1,    -1,   676,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   276,    -1,  5945,    -1,   280,    -1,    -1,    -1,
     700,    -1,  5953,  5954,    98,    -1,   290,    -1,    -1,   709,
      -1,    -1,    -1,   713,    -1,   299,   716,    -1,   358,   719,
      -1,    -1,    -1,  5674,    -1,   492,    -1,   311,     0,    -1,
      -1,    -1,    -1,    -1,    -1,   735,    -1,   504,   505,   506,
     507,   508,   509,    -1,    -1,    -1,  5927,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,   504,
     505,   506,   507,   508,   509,    -1,   350,    -1,   162,   353,
     354,  5952,    -1,    -1,   168,   415,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,  6035,    -1,   180,    -1,   788,   183,
    6041,    -1,    -1,   187,    -1,    -1,    -1,   797,    -1,    -1,
      -1,   385,    -1,   443,    -1,    -1,    -1,    -1,  6059,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   817,   818,    -1,
     820,   821,    -1,   217,    -1,   825,    98,   467,    -1,   469,
     470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   839,
      -1,    -1,    -1,    62,   844,    -1,    -1,    -1,    -1,   243,
     850,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6045,    -1,    -1,    -1,    -1,    -1,
     454,   511,  6123,    -1,   514,   515,   516,   149,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,  6143,    -1,  5845,   895,   168,    -1,   292,    -1,
      -1,   295,   174,    -1,    -1,    -1,    -1,   301,   180,   909,
      -1,   183,    -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,
      -1,    -1,   922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6183,    -1,    -1,    10,    -1,   937,    13,   158,
    6191,    -1,    17,    18,    19,   217,    -1,    -1,    -1,    -1,
      -1,    -1,  6203,  6204,    -1,    -1,   956,    -1,    -1,    -1,
      35,   961,   962,    -1,   358,    -1,  6147,    -1,    -1,    -1,
      45,   243,    -1,    -1,    -1,    -1,   195,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   993,   994,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  1016,  1017,    -1,   238,
     292,   415,    -1,   295,    -1,    -1,    -1,  5978,  5979,   301,
    1030,    35,  1032,    -1,    -1,    -1,  1036,    -1,    -1,  1039,
    1040,    45,  1042,    -1,    -1,    -1,    -1,  1047,    52,   443,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1071,    -1,   467,    78,   469,   470,    -1,  1078,  1079,
      -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   491,    -1,    -1,
    1100,  1101,  1102,    -1,  1104,    -1,  1106,    -1,  1108,  1109,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   193,    -1,
     514,   515,   516,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,   356,    -1,    -1,
     359,    -1,  1142,   415,  1144,  1145,   221,   222,    -1,   368,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    31,   377,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   385,   242,    -1,    -1,
      -1,   443,    -1,    -1,    -1,    -1,    -1,  1177,   397,    -1,
      -1,    -1,   645,    -1,    -1,    -1,    -1,   406,    -1,   193,
      -1,   410,  5868,    -1,   198,   467,    -1,   469,   470,    -1,
      -1,    -1,    76,  1203,    -1,  1205,    -1,    -1,   283,  1209,
      -1,  1211,    -1,    -1,    -1,    -1,    -1,   221,   222,   491,
      -1,    -1,   297,    -1,    -1,   300,    -1,    -1,    -1,    -1,
      -1,    -1,   695,   696,    -1,  1235,    -1,  1237,   242,   511,
      -1,  1241,   514,   515,   516,    -1,   465,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1255,    -1,    -1,   132,    -1,
      -1,    -1,    -1,    -1,    10,   139,    -1,    13,   142,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
    1290,    -1,    -1,   297,    -1,   169,   300,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,  1319,
    1320,  1321,    -1,  1323,    -1,    -1,    -1,    10,   791,    -1,
      13,   205,    78,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,  1343,    -1,    -1,    -1,    -1,   811,    -1,
      -1,    -1,    35,    -1,    -1,    -1,   819,    -1,    -1,   822,
     823,   824,    45,    -1,    25,    -1,    -1,    -1,    -1,    52,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1382,    -1,    -1,    46,   390,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
    1400,    -1,   276,    -1,    -1,    -1,   280,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,   290,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   299,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,    -1,   311,    -1,    -1,
      -1,    -1,   517,    -1,    -1,    -1,  1446,   193,    -1,    -1,
    1450,  1451,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1461,  1462,  1463,  1464,    -1,  1466,    -1,    -1,   130,
      -1,   132,    -1,    -1,    -1,   221,   222,    -1,   139,   353,
     354,   142,    -1,    -1,    -1,    -1,    -1,    -1,   492,  1489,
      -1,    -1,    -1,    -1,    -1,    -1,   242,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,    -1,   169,    -1,
     193,   385,    -1,   517,    -1,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1524,    -1,    -1,    -1,    -1,  1529,
      -1,    -1,  1532,    -1,    -1,    -1,    -1,   283,   221,   222,
      -1,    -1,    -1,    -1,   205,  1545,  1546,    -1,    -1,    -1,
      -1,   297,    -1,    -1,  1554,    -1,    -1,  1557,    -1,   242,
      -1,    -1,  1025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    -1,    -1,    -1,  1584,    -1,  1586,    -1,    -1,  1589,
      -1,    -1,  1592,  1593,    -1,    -1,  1596,    -1,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,  1606,    -1,    -1,  1609,
      -1,    -1,  1612,    -1,   297,   276,    -1,   300,    -1,   280,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,  1636,    -1,   299,    -1,
      -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,  1654,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1666,  1667,  1668,  1669,
    1670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,    -1,   350,
      -1,    -1,   353,   354,    -1,  1695,  1696,  1697,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,  1216,    -1,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   454,  1794,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1805,    -1,    -1,    -1,   492,
      -1,    -1,    -1,  1813,  1814,    -1,    -1,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,    -1,  1829,
      -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1847,  1848,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1325,  1863,  1864,  1865,  1866,    -1,    -1,    -1,
      -1,  1334,  1872,    -1,    -1,    -1,    -1,    -1,    -1,  1879,
      -1,    -1,  1882,    -1,    -1,    -1,  1349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1897,    -1,    -1,
    1900,    -1,    -1,    38,    -1,  1368,    -1,    -1,  1371,  1372,
    1910,  1911,    -1,  1376,  1377,    -1,    -1,    -1,    -1,    -1,
      -1,  1921,  1922,    10,    -1,  1925,    13,    62,  1928,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1943,  1944,    -1,    -1,    -1,    35,    -1,
    1950,    -1,  1952,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    97,    -1,    -1,    52,    -1,    -1,    -1,  1969,
      -1,    22,    -1,    -1,    -1,    -1,  1976,    28,  1978,    -1,
      -1,  1981,  1982,  1983,    -1,  1985,  1986,    -1,  1988,    -1,
      -1,    78,    -1,    -1,    -1,  1995,    -1,    -1,    -1,    -1,
      -1,    -1,  2002,    -1,    -1,  2005,  2006,    -1,    -1,  2009,
      -1,    -1,  2012,  2013,    -1,    -1,    -1,  2017,    -1,  2019,
      -1,    -1,    -1,   158,  2024,  2025,    -1,    -1,    -1,    -1,
      -1,  2031,  2032,  2033,  2034,  2035,  2036,  2037,    -1,    -1,
    2040,    -1,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
      -1,    25,  2052,    -1,  2054,  2055,    -1,    31,  2058,    -1,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,  2073,  2074,  2075,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2091,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    76,   238,    -1,    -1,   193,    -1,     0,    -1,
      -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,  2131,    -1,    -1,   221,   222,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    -1,   280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,   132,    51,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,    61,
    1633,    -1,    -1,    -1,    -1,    -1,    -1,   312,  1641,    -1,
      -1,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      82,    -1,    84,    -1,    -1,   169,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    98,    -1,    -1,    -1,
     297,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,   354,
      -1,    -1,    -1,   115,   359,    -1,   118,    -1,    -1,    -1,
      -1,   205,    -1,   368,    -1,  2235,    -1,    -1,    -1,    -1,
      -1,   133,   377,   135,    -1,    -1,    -1,   139,    -1,    -1,
     385,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,   397,   155,    -1,    -1,    -1,    -1,    -1,    -1,
     162,   406,    -1,    -1,    -1,   410,    10,    -1,    -1,    13,
      -1,    -1,  2282,    17,    18,    19,    -1,    -1,   180,    -1,
      -1,    -1,    -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,
      -1,    35,   276,   390,    -1,   197,   280,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,   290,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,
     465,    -1,    -1,    -1,   469,  2335,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   244,   245,    -1,    -1,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,   350,    -1,    -1,   353,
     354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,    -1,    -1,  1856,    -1,    -1,    -1,  1860,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,
      -1,   385,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,    -1,    -1,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,   340,    -1,
      -1,    -1,    -1,    -1,   346,   347,    -1,   349,    -1,   193,
      -1,    -1,   354,    -1,   198,    -1,    -1,    -1,   360,    -1,
      -1,   363,    45,    -1,    -1,    -1,    -1,    -1,   370,    52,
     454,    -1,    -1,    -1,    -1,   377,   378,   221,   222,    -1,
      -1,    -1,    -1,   385,    -1,    -1,    -1,   389,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,   399,   242,    -1,
      -1,    -1,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,    -1,  2522,   415,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2532,  2533,    -1,  2535,    -1,    -1,    -1,    -1,
      -1,    -1,  2542,   435,    -1,    -1,    -1,    -1,    -1,   283,
      -1,    -1,    -1,    -1,   446,    -1,    -1,    -1,    -1,    -1,
     452,    -1,    -1,   297,    -1,   457,   300,  2030,    -1,    -1,
      -1,  2571,    -1,  2573,    51,    -1,  2576,  2577,   470,    -1,
    2580,    -1,  2582,    -1,    -1,  2585,    -1,    -1,    -1,  2589,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   494,    -1,   496,   497,   498,   499,   500,    -1,
      -1,    -1,  2612,    -1,    -1,    -1,    -1,    -1,  2618,  2619,
     193,   513,    -1,    -1,   516,   198,    -1,    -1,    -1,  2629,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2638,  2639,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,    -1,  2652,    -1,    -1,    -1,   390,    -1,    -1,    -1,
    2660,    -1,  2662,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2702,    -1,  2704,   756,    -1,   758,    -1,   760,
     283,    -1,    -1,    -1,    -1,   766,   767,   768,    -1,    -1,
      -1,  2721,    -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2732,    -1,    -1,  2735,  2736,  2737,  2738,    -1,
      -1,  2741,    -1,    -1,  2744,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,
      -1,    -1,     0,    -1,    -1,  2765,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,  2776,    -1,    -1,    -1,
     514,    -1,    20,    -1,  2784,  2785,    -1,    -1,    -1,    -1,
      -1,  2791,    -1,    31,    -1,    33,    34,    -1,    -1,    -1,
    2800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,   390,    -1,    -1,
      -1,    -1,  2822,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,  2843,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2856,    -1,    96,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,  2879,
     118,    -1,  2882,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,    -1,    -1,   955,    -1,    -1,   145,  2908,  2909,
      -1,    -1,    -1,    -1,    -1,   153,    -1,   155,    -1,   492,
      -1,    -1,    -1,  2923,   162,  2925,  2926,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,    -1,    -1,
      -1,    25,   180,    10,    -1,    -1,    13,    31,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,  2956,  2957,  2958,   197,
      -1,    -1,  2962,    -1,    -1,    -1,    -1,    -1,    35,    -1,
    2970,    -1,    -1,    -1,  1025,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,  2983,    -1,    52,    -1,    -1,    -1,  2989,
      -1,  2991,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3004,    -1,   244,   245,    -1,  3009,
      -1,    78,   250,    -1,    -1,  3015,    -1,    -1,  3018,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
    3030,  3031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3041,    -1,    -1,   282,    -1,    -1,    -1,   132,    -1,
      -1,  3051,    -1,  3053,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,   326,  2552,
      -1,    -1,  3092,    -1,  3094,    -1,  3096,    -1,    -1,    -1,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,   346,   347,
      -1,   349,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      -1,   205,   360,    -1,    -1,   363,   193,    -1,    -1,  3129,
      -1,   198,   370,    -1,    -1,    -1,    -1,    -1,    -1,   377,
     378,    -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,
      -1,   389,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,
      -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,   415,    -1,    -1,
      -1,    -1,    -1,  3183,  3184,    -1,  3186,    -1,  3188,  3189,
      -1,  3191,   276,    -1,    -1,    -1,   280,   435,  3198,    -1,
      -1,    -1,    -1,  3203,    -1,    -1,   290,    -1,   446,    -1,
      -1,    -1,    -1,    -1,   452,   299,   283,    -1,    -1,   457,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,   705,    -1,
     297,    -1,   470,   300,    -1,    -1,    -1,  2700,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3245,  3246,  3247,    -1,    -1,
    3250,    -1,    -1,    -1,   731,    -1,   494,    -1,  3258,  3259,
    3260,  3261,    -1,    -1,    -1,    -1,   350,    -1,    -1,   353,
     354,    -1,    -1,    -1,  3274,   513,    -1,  3277,   516,  3279,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3290,  3291,    -1,    -1,  3294,    -1,  2759,    -1,    -1,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3313,    -1,  3315,    -1,  3317,    -1,  3319,
    1371,    -1,    -1,   390,    -1,  1376,  1377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3338,    -1,
      -1,  3341,    -1,    -1,    -1,  3345,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1404,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,  1413,    -1,  1415,    -1,  3366,    -1,  1419,    -1,
     454,    -1,    -1,    -1,    -1,  1426,  2839,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,  3394,    -1,   873,  3397,  3398,    -1,
    2863,    -1,  3402,  3403,  3404,    76,    -1,    35,    -1,    -1,
    3410,    -1,    -1,    -1,    -1,  3415,    -1,    45,    -1,    -1,
      10,    -1,    -1,    13,    52,   492,    -1,    17,    18,    19,
    3430,    -1,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,  3444,    35,    -1,   514,  3448,    -1,
      78,  3451,  3452,    -1,  3454,    45,    -1,    -1,    -1,    -1,
      -1,   132,    52,    -1,    -1,    -1,  1517,  2930,   139,    -1,
      -1,   142,    -1,    -1,    -1,    -1,  1527,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,  3495,    -1,    -1,   169,    -1,
      -1,    -1,    -1,    -1,  2967,    -1,  2969,    -1,  2971,  2972,
      -1,    -1,    -1,  2976,  2977,  2978,    -1,  2980,  2981,  2982,
    1571,  1572,    -1,    -1,    -1,  3525,  3526,    -1,    -1,    -1,
      -1,    25,    -1,    -1,   205,    -1,    -1,    31,    -1,  1016,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1035,    -1,
      25,    -1,    -1,  1614,    -1,   193,    31,  1618,  1619,  1046,
     198,  3034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    -1,  1062,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,  3059,    -1,    -1,    -1,
      -1,    -1,    -1,   193,    -1,   276,    -1,    -1,   198,   280,
      -1,    76,    -1,    -1,   242,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,   221,   222,  3633,    -1,    -1,    -1,    -1,   132,    -1,
     311,    -1,    -1,  3643,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,   242,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   297,
      -1,    -1,   300,    -1,   139,   169,    -1,   142,    -1,   350,
      -1,    -1,   353,   354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,   297,    -1,    -1,
     300,   205,    -1,    -1,   385,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     205,    -1,  1219,    -1,    -1,    -1,    -1,    -1,  3748,    -1,
      -1,    -1,    45,    -1,  3754,    -1,    -1,    -1,    -1,    52,
      -1,  1812,   390,    -1,    -1,  3765,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,   276,   454,    13,    78,   280,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,    -1,
     390,    -1,  3802,  3803,  3804,   299,    35,    -1,    -1,    -1,
      -1,   276,    -1,    -1,    -1,   280,    45,   311,    -1,  3819,
      -1,    -1,    -1,    52,    -1,   290,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3833,   299,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    78,
      -1,  3851,  3852,  3853,    -1,    -1,   350,  3857,    -1,   353,
     354,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,  3869,
      -1,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
     508,   509,    -1,    -1,    -1,   350,   514,    -1,   353,   354,
      -1,   385,    -1,    -1,    -1,    -1,  3359,    -1,    -1,    -1,
     193,    -1,   492,    -1,    -1,   198,    -1,    -1,    -1,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     385,    -1,    -1,    -1,   514,  3925,    -1,    -1,   221,   222,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3939,
    3940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,
    3950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    -1,    -1,  3963,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,    -1,  2027,  2028,    -1,    -1,
      -1,    -1,  3982,    -1,    -1,    -1,    -1,  2038,  2039,   454,
     283,  3991,   221,   222,    -1,  1472,    -1,    -1,    -1,    -1,
      -1,  4001,    -1,    -1,   297,  4005,  4006,    -1,    -1,    -1,
      -1,  4011,    -1,   242,    -1,    -1,    -1,  2068,    -1,  4019,
      -1,  4021,    -1,    -1,  4024,    -1,    -1,    -1,    -1,  4029,
    4030,  4031,  4032,    -1,    -1,  4035,  4036,  4037,  4038,  4039,
    4040,  4041,  4042,  4043,  4044,    -1,    -1,    -1,  4048,  4049,
    4050,    -1,    -1,    -1,   283,    -1,  3519,    -1,  4058,    -1,
      -1,    -1,  1539,  4063,    -1,    -1,    -1,  4067,   297,    -1,
      -1,   300,    -1,    -1,    -1,  4075,    -1,    -1,  4078,    -1,
    4080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,  4098,    -1,
      -1,  4101,  4102,  1580,    -1,    -1,  4106,  4107,    -1,    -1,
      -1,  4111,    -1,  4113,  4114,    25,    -1,    -1,    -1,    -1,
      -1,    31,  4122,  4123,  4124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3597,    -1,  1613,    -1,    -1,    -1,
      -1,    -1,  4142,  4143,  4144,    -1,  4146,  4147,    -1,    -1,
    4150,    -1,    -1,    -1,  4154,    -1,    -1,    -1,  4158,    -1,
      -1,   390,    -1,    -1,  4164,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4190,    -1,  3655,    -1,    -1,    -1,    -1,    -1,    -1,   492,
      -1,    -1,    -1,    -1,    -1,  4205,    -1,  4207,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,  1695,  1696,
    1697,    -1,   132,    -1,    -1,  4225,  4226,  4227,    -1,   139,
    4230,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
    3723,    -1,    -1,   492,    -1,  4265,  4266,    -1,    -1,    -1,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,    -1,    -1,    -1,  4284,   514,    -1,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    28,   205,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  3769,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3781,  3782,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,  3791,    -1,
    1807,    45,    66,  3796,    -1,  3798,    -1,  4337,    52,    -1,
      -1,  1818,    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1834,    -1,    -1,
      -1,    95,    -1,    -1,    78,    -1,   276,    -1,    -1,    -1,
     280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     290,  3844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,  4392,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,   311,    31,   137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1888,    -1,    -1,   148,    -1,  3879,  3880,    -1,    -1,
      -1,    -1,    -1,   157,    10,  4425,  1903,    13,    -1,  1906,
    1907,    17,    18,    19,    -1,    -1,   170,    -1,    -1,  4439,
     350,  4441,   176,   353,   354,    -1,    -1,    76,  4448,    35,
      -1,    -1,    -1,    -1,  4454,    -1,    -1,    -1,    -1,    45,
    1937,  1938,    -1,    -1,    -1,  4465,    52,    -1,    -1,   203,
      -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,    -1,   193,
    4480,    -1,    -1,    -1,   198,  4485,  4486,    -1,    -1,    -1,
      -1,    -1,    78,  4493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4502,   132,    -1,    -1,    -1,   221,   222,    -1,
     139,    -1,  4512,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,    -1,  4524,  4525,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,    -1,  4535,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,   454,    -1,  4546,  4547,    -1,  2600,
    2601,    -1,    -1,    -1,    -1,  2606,    -1,    -1,  2035,    -1,
      -1,    -1,    -1,   297,  4564,    -1,    -1,  2044,    -1,   283,
    2047,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,   300,  2638,  2639,    -1,
      -1,    -1,    -1,    -1,    -1,  2072,    -1,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,  4605,    -1,   193,    -1,    -1,
      -1,  4074,   198,    -1,    -1,    -1,    -1,    -1,  4618,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,
      -1,   365,  4632,    -1,    -1,   221,   222,    -1,   372,    -1,
      -1,    -1,    -1,    -1,    -1,   379,    -1,   276,   382,  2700,
      -1,   280,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
    4660,   290,    -1,  4663,    -1,    -1,    -1,   401,    -1,    -1,
     299,  4671,  4672,    -1,   408,    -1,   390,    -1,  4678,  4679,
      -1,   415,   311,  4683,   418,    -1,    -1,    -1,   422,    -1,
    4690,    -1,    -1,  4693,  4694,    -1,   430,   283,    -1,    -1,
    4700,    -1,    -1,   437,  4704,  4705,  4706,  4707,    -1,    -1,
      -1,   297,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,
    4720,   350,    -1,  4723,   353,   354,    -1,  4727,    -1,   463,
      -1,    -1,  4732,  2784,    -1,  4735,  4736,    -1,  4738,    -1,
    4740,    -1,    -1,  4743,    -1,  4745,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4754,    -1,   385,    -1,  4758,    -1,
      -1,    -1,  4762,    -1,  4764,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,  4779,
      -1,    -1,  4782,    -1,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,    -1,    -1,    10,
     514,    -1,    13,    -1,   390,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4816,    -1,    -1,    -1,
    4820,    -1,  2873,    -1,    35,   454,    -1,    -1,    -1,    -1,
    2881,    -1,    -1,  2884,    45,    -1,    -1,    -1,    -1,    -1,
    4303,    52,    -1,    -1,    -1,  2896,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4329,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    28,
      -1,  4344,    -1,    -1,  4347,  4885,  4349,    -1,    -1,    -1,
      -1,    -1,  4892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4914,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    -1,    -1,    -1,    -1,   514,  4929,
      79,    80,  4395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,  4411,    -1,
      25,    -1,    -1,  4416,    -1,    -1,    31,    -1,    -1,    -1,
    4960,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4976,    -1,    -1,    -1,
      -1,    -1,   193,  4983,    -1,    -1,    -1,   198,   137,    -1,
      -1,    -1,  4992,    -1,    -1,    -1,    -1,    -1,    -1,   148,
      -1,    76,    -1,    -1,    -1,    -1,    -1,  5007,   157,    -1,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5020,   170,  5022,    -1,    -1,    -1,    -1,   176,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5048,    -1,
      -1,    -1,  4515,    -1,   203,  4518,    -1,   132,  2535,  5059,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,    -1,    -1,
      -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,   297,    -1,    -1,   300,
      -1,  3142,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5117,    -1,    -1,
    5120,    -1,    -1,  5123,  5124,  5125,    -1,    -1,    -1,    -1,
     205,  4594,  4595,  4596,  4597,    -1,  4599,  4600,  4601,  4602,
    4603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5150,  5151,    -1,    -1,  5154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5174,    -1,    -1,    -1,    -1,   390,
    5180,    -1,   331,   332,  5184,    -1,   335,    -1,  5188,    -1,
      -1,  5191,    -1,  5193,    -1,  2672,    -1,    -1,    -1,  2676,
    2677,   276,    -1,    -1,  5204,   280,    -1,  5207,    -1,    -1,
      -1,    -1,    -1,   362,    -1,   290,   365,    -1,  5218,  5219,
    5220,    -1,  5222,   372,   299,    -1,    -1,    -1,    -1,    -1,
     379,    -1,    -1,   382,    -1,    -1,   311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4712,
      -1,  4714,   401,    -1,    -1,    -1,    -1,  2734,    -1,   408,
      -1,    -1,    -1,  2740,    -1,    -1,   415,    -1,    -1,   418,
    5270,  5271,    -1,   422,    -1,   350,    -1,    -1,   353,   354,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    -1,
      -1,    -1,    -1,   514,  2781,    -1,  3357,    -1,  3359,    -1,
     385,    -1,    -1,    -1,   463,  5315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3375,    -1,    -1,  5327,    -1,    -1,
      -1,    -1,  5332,    -1,    -1,    -1,    -1,  5337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5346,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5356,    -1,    -1,    -1,
    5360,    -1,    -1,  5363,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3422,  3423,    -1,  5374,  5375,  5376,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5412,    -1,    -1,    -1,  5416,    -1,  5418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5432,    -1,    -1,    -1,    -1,    -1,    -1,  5439,
      -1,    -1,  5442,    -1,    -1,    -1,  5446,    -1,    -1,    -1,
      -1,    -1,    -1,  5453,    -1,    -1,    -1,    -1,    -1,    -1,
    5460,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4932,
    4933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2958,  4945,    -1,  4947,  4948,  4949,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2990,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5521,    -1,    -1,    -1,    -1,    -1,  5527,  5528,    -1,
      -1,    -1,  5532,  5533,  5534,  5535,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5563,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3063,    -1,    -1,  5052,
    3067,    -1,    -1,    -1,    -1,    -1,  5596,    -1,    -1,  5599,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5624,    -1,    35,    -1,    -1,    -1,
      -1,    -1,  5095,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5661,  5662,  5663,    -1,    -1,    -1,  5667,    -1,    78,
      -1,  5671,    -1,    -1,  5674,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5683,    -1,  5685,    -1,  5687,  5688,    -1,
      -1,    -1,    -1,  3170,  5694,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5704,    -1,  5706,    -1,  3185,    -1,
      -1,    -1,    -1,  3190,    -1,  5715,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3791,  3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5750,  5751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5781,    -1,    -1,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,  5795,  5259,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    -1,    -1,    -1,    -1,    20,
      -1,    22,   221,   222,    -1,    -1,    -1,    28,    -1,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5832,   242,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,  5305,    -1,    -1,  5845,    -1,    -1,    -1,  5849,
      -1,  5314,    -1,    -1,    -1,  5855,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,  5864,  5865,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
      -1,  5881,    -1,    -1,    35,    -1,    -1,    -1,   297,    -1,
      -1,   300,    -1,    -1,    45,    -1,  5896,    -1,    -1,    -1,
      -1,    52,    -1,  5903,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3971,    -1,    -1,    -1,    -1,    -1,    -1,    78,  5928,    -1,
      -1,    -1,    -1,    -1,    -1,  5935,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5945,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5953,  5954,  5955,    -1,    -1,    -1,  5959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5971,  5972,  5973,    -1,    -1,    -1,    -1,  5978,  5979,
      -1,   390,    -1,    -1,  5984,    -1,    -1,  3464,    -1,   200,
    3467,    -1,  3469,   204,    -1,    -1,    -1,  3474,    -1,    -1,
      -1,   212,    -1,    -1,   215,    -1,  6006,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6035,  6036,  6037,    -1,    -1,
      -1,  6041,   193,    -1,    -1,  3522,    -1,   198,    -1,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,  6059,
    6060,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,   222,    -1,    -1,  6074,    -1,    -1,    -1,  3555,    -1,
    5543,    -1,    -1,   492,  5547,    -1,    -1,    -1,  6088,    -1,
      -1,   242,   501,   502,   503,   504,   505,   506,   507,   508,
     509,    -1,    -1,    -1,    -1,   514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6121,  6122,  6123,  6124,  6125,    -1,    -1,  6128,    -1,
      -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6140,    -1,    -1,  6143,    -1,    -1,   297,    -1,  3625,   300,
    3627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6182,  6183,    -1,    -1,    -1,  6187,    -1,    -1,
      -1,  6191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6203,  6204,    -1,    -1,  6207,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,   390,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    45,    -1,    -1,
      -1,    -1,  4303,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3748,    -1,    -1,    -1,    -1,    -1,  3754,  4329,  5742,
      78,    -1,    -1,  5746,    -1,  5748,  3763,    -1,    -1,  5752,
    5753,    -1,  4343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3791,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    -1,
      -1,    -1,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4430,
    4431,    -1,  3859,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,  3881,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,   221,   222,    52,  3903,    -1,    -1,    -1,
      -1,    -1,   643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   654,   242,    -1,    -1,   658,    -1,    -1,
      -1,    78,    -1,    -1,   665,   666,    10,    -1,   669,    13,
     671,   672,    -1,    17,    18,    19,    -1,  4518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   686,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    45,    -1,   704,    -1,    -1,    -1,    -1,    52,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,  3985,    -1,
      -1,    -1,    -1,    -1,   725,    -1,   727,    -1,    -1,    -1,
    4571,    -1,    -1,    -1,    78,    -1,   737,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6012,
      -1,  4028,    -1,    -1,    -1,    35,    -1,    -1,    -1,   770,
      -1,    -1,    -1,    -1,    -1,    45,   193,    -1,    -1,    -1,
      -1,   198,    52,    -1,    -1,    -1,  4053,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   390,    -1,   221,   222,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,   242,    45,   214,    -1,   216,
     217,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,    -1,   193,
     851,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,    -1,
     297,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6150,   242,    -1,
    6153,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
     508,   509,    -1,   193,    -1,    -1,   514,    -1,   198,    -1,
      -1,    -1,    -1,   934,    -1,    -1,    -1,    -1,    -1,   283,
      -1,    -1,  6195,    -1,    -1,    -1,  4213,    -1,    -1,    -1,
      -1,   221,   222,   297,    -1,    -1,   300,    -1,    -1,    -1,
    6213,    -1,    -1,  6216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   242,   390,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,  4823,    -1,    -1,    -1,    -1,    -1,  4829,    -1,
      -1,    -1,  4833,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,  1008,    -1,    -1,
      -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,  4860,
    4861,    -1,    -1,   242,  4865,  4866,    -1,   297,    -1,    -1,
     300,    -1,  1033,    -1,    -1,    -1,  4303,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   390,  1048,    -1,  1050,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1060,
      -1,    -1,  4329,    -1,   283,    -1,  1067,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,   297,    -1,
      -1,   300,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,    -1,    -1,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1110,
      -1,  1112,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
     390,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,    -1,    -1,    -1,
     514,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,  1186,    -1,  1188,    -1,  1190,
      -1,  1192,    -1,  1194,  1195,  1196,    -1,    -1,    -1,    -1,
    1201,    -1,    -1,    -1,  4471,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,   508,   509,
      -1,    -1,    -1,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      -1,  4518,    -1,    -1,    -1,   642,  4523,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   661,    -1,    -1,    -1,    -1,    -1,
     667,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,    -1,   679,    -1,    -1,   514,    -1,   193,    -1,    -1,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,   695,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,   709,   710,    -1,   221,   222,    -1,    -1,   716,
      -1,   718,   719,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   732,   242,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,   742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,  1393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    10,   300,    -1,    13,  4674,   795,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,  5259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   823,    -1,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   390,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   908,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4800,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4840,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,  1585,   283,   193,    45,    -1,    -1,
      -1,   198,    -1,    -1,    52,  4862,   492,    -1,    -1,   297,
      -1,    -1,   300,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   221,   222,    -1,    -1,   514,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1018,    -1,    -1,    -1,   242,    -1,    -1,  1025,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,  1036,
      17,    18,    19,  1040,    -1,  1042,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4934,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
     297,    -1,   390,   300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5543,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,
     199,    -1,    -1,   202,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     229,    -1,  1149,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   390,   242,    -1,  5053,    -1,  5055,    -1,
      -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1803,   501,   502,   503,   504,   505,   506,   507,
     508,   509,    -1,    -1,    -1,    -1,   514,    -1,    -1,    -1,
      -1,    -1,    -1,  1210,    -1,   283,   193,    -1,    -1,    -1,
      -1,   198,    -1,    -1,  1221,    -1,    -1,  1838,    -1,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1238,    -1,    -1,   221,   222,  1243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1884,    -1,   492,    -1,    -1,    -1,    -1,
      -1,  5732,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,  1904,    -1,    -1,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,  5190,    -1,    -1,    -1,    -1,    -1,  1930,
     297,  1932,   390,   300,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  1947,    -1,  1949,    -1,
      -1,    -1,    -1,    -1,  1955,    -1,  1957,    -1,  1959,    -1,
    1961,    35,  1963,    -1,    -1,    39,  1967,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,  1368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1376,
    1377,    -1,  5259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2004,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   390,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1429,   501,   502,   503,   504,   505,   506,   507,
     508,   509,    -1,    -1,    -1,   129,   514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,  5379,    -1,    -1,    -1,    -1,    -1,    52,   193,
      -1,    -1,    -1,    -1,   198,   492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,    78,   512,    -1,   221,   222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,   242,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   651,    -1,   653,    -1,    -1,   656,    35,   705,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,   670,    -1,    -1,    -1,    52,    -1,   676,    -1,   283,
      -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,   300,    -1,    -1,    -1,
      -1,    78,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,  5511,    -1,    -1,    -1,    -1,  5516,
    5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,    -1,
      -1,    -1,    -1,  1680,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,   242,  6150,
      -1,    52,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,   283,
      35,   198,    -1,    38,  6195,    -1,    -1,   873,    -1,    -1,
      45,  5628,  5629,   297,    -1,    -1,   300,    52,    -1,    -1,
      -1,    -1,  6213,    -1,   221,   222,    -1,   451,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1795,    -1,
      -1,  5678,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   167,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   283,    -1,    -1,    -1,
      -1,    -1,    -1,  1830,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,   193,   300,    -1,    -1,   390,   198,    -1,    -1,
      -1,    -1,   207,    -1,    -1,    -1,  1853,    -1,    -1,    -1,
      -1,   216,    -1,    -1,  1861,    -1,    -1,    -1,   325,    -1,
     221,   222,  1869,    -1,    -1,   230,    -1,    -1,    -1,    -1,
      -1,    -1,   961,   962,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,  1035,
      -1,    -1,    -1,  1910,  1911,    -1,  1913,  1914,    -1,    -1,
    1046,    -1,    -1,    -1,    -1,    -1,   221,   222,  1925,    -1,
    1927,  1928,   283,   390,    -1,    -1,  1062,    -1,    -1,    -1,
      -1,    -1,    -1,  1940,  1941,    -1,   297,   242,   492,   300,
     407,    -1,    -1,  1032,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,    -1,  1047,    -1,
      -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1978,    -1,    -1,    -1,  1982,  1983,    -1,   283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1078,
    1079,    -1,   297,    -1,    -1,   300,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,   390,
      -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,    -1,  2666,  2667,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1144,  1145,    -1,   705,    -1,
      -1,    -1,    -1,    -1,  2685,  2686,    -1,  2688,  2689,    -1,
      -1,    -1,  2693,  2694,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1219,   731,   390,  2093,  2708,    -1,    -1,
      -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,  2719,  2720,
      -1,    -1,  2723,  2724,    -1,    -1,    -1,    -1,    -1,  2730,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2742,    -1,    23,    -1,    -1,    -1,    -1,    28,    -1,
      -1,   492,    -1,  2754,    -1,    -1,    -1,    -1,  2759,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    -1,
      -1,    10,    -1,  2774,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,  2783,    -1,    -1,  2786,    66,  2788,  2789,  2790,
      -1,    -1,    -1,    -1,  2795,  2796,    35,    -1,    -1,    79,
      -1,    -1,    -1,    -1,  2805,    -1,    45,   492,    -1,    -1,
    2811,    -1,    -1,    52,  2815,    95,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,  2827,  2828,    -1,    -1,
      -1,  2832,    -1,   113,    -1,    -1,    -1,  2838,  2839,    78,
      -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,    -1,    -1,
      -1,  2852,    -1,    -1,  2855,  1371,    -1,   137,    -1,    -1,
      -1,  2862,  2863,    -1,    -1,    -1,    -1,  2868,   148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,  2880,
      -1,    -1,  2883,    -1,    -1,    -1,    -1,  2888,    -1,    -1,
     170,    -1,    -1,  2894,  2895,    -1,   176,   642,    -1,    -1,
      -1,  2902,    -1,   183,    -1,  2906,    -1,    -1,    -1,  2910,
    2911,  2912,  2913,    -1,  2915,  6182,   661,    -1,    -1,    -1,
      -1,    -1,   667,   203,    -1,    -1,    -1,  2928,  2929,    -1,
    2931,    -1,    -1,    -1,   679,    -1,    -1,    10,    -1,    -1,
      13,  2942,  2943,  2944,    17,    18,    19,    -1,    -1,    -1,
     695,    -1,    -1,    -1,   193,    -1,  1472,    -1,    -1,   198,
      -1,    -1,    35,    -1,    -1,   710,    -1,    -1,    -1,    -1,
      -1,    -1,    45,   718,    -1,    -1,   256,    -1,    -1,    52,
      -1,    -1,   221,   222,    -1,    -1,    -1,   732,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,   742,  2999,    -1,
      -1,    -1,    -1,   242,    -1,    78,  3007,    -1,  1035,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,  1046,
      -1,    -1,    -1,  1539,    -1,  3026,    -1,    -1,    -1,    -1,
     310,    -1,    -1,    -1,    -1,  1062,    -1,    -1,    -1,    -1,
      -1,   321,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
     795,   331,   332,    -1,    -1,   335,    -1,    -1,   297,    -1,
      -1,   300,    -1,  1532,  1580,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,   823,    -1,
      -1,    -1,   362,    -1,    -1,   365,    -1,    -1,  1557,   369,
      -1,    -1,   372,    -1,  3095,    -1,  3097,  1613,    -1,   379,
      -1,    -1,   382,   848,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,   401,    -1,    -1,    -1,   198,    -1,    -1,   408,    -1,
      -1,    -1,    -1,    -1,    -1,   415,    -1,    -1,   418,    -1,
      -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,   221,   222,
     430,   390,   432,    -1,    -1,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,   908,    -1,    -1,    -1,  1636,    -1,   242,
     450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   463,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3192,  1219,    -1,    -1,    -1,    -1,  1666,  1667,  1668,
    1669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2610,   297,    -1,    -1,   300,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,
      -1,    -1,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,    -1,    -1,  1018,    -1,    -1,    -1,    -1,  2665,    -1,
    1025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1807,    -1,    -1,    -1,    -1,  2683,    -1,    -1,    -1,
    2687,    -1,  1818,    -1,  2691,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2700,    -1,    -1,    -1,   390,  1834,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1813,  1814,    -1,    -1,  2735,    -1,
    2737,  2738,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1829,    -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,
      -1,    -1,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2772,  2773,  1903,    -1,    -1,
    1906,  1907,    -1,    -1,  1863,  1864,  1865,  1866,    -1,    -1,
      -1,    -1,    -1,    -1,  1149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2803,  2804,    -1,   492,
    2807,  1937,  1938,    -1,    -1,    -1,    -1,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2831,  1472,  2833,    -1,    -1,    -1,
    2837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2851,  1210,    -1,    -1,    -1,    -1,
      -1,  2858,    -1,    -1,  2861,  1944,  1221,    -1,    -1,    -1,
    2867,  1950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1238,    -1,    -1,  3497,    -1,  1243,    -1,
    2887,    -1,    -1,    -1,    -1,    -1,  2893,    -1,    -1,    -1,
      -1,    -1,  1539,  2900,    -1,    -1,  3517,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2914,    -1,    -1,
      -1,    -1,    -1,  3534,    -1,    -1,    -1,  3538,    -1,    -1,
    2927,    -1,  3543,  3544,  3545,  2932,    -1,    -1,    -1,    -1,
      -1,  2938,    -1,  1580,    -1,    -1,  2072,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,  3579,  3580,
    3581,  3582,    -1,    -1,    -1,    -1,  1613,    -1,    -1,    -1,
      35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,  3609,    -1,
      -1,  2998,    -1,    -1,    -1,    -1,  3617,    -1,  3619,  3620,
    3621,    -1,    -1,  1368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1376,  1377,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,   705,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,  2131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,   731,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,  1429,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3735,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3744,    -1,    -1,    -1,    -1,   193,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3153,    -1,  3155,  3770,
    3771,    -1,    -1,    -1,  3775,    -1,   221,   222,    -1,    -1,
    1807,    -1,    -1,    -1,    -1,  3172,    -1,    -1,    -1,    -1,
      -1,  1818,  3179,    -1,    -1,    -1,  3797,   242,    -1,  3186,
      -1,  3188,  3189,    -1,    -1,    -1,    -1,  1834,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,   873,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,   283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3849,    -1,
      -1,    -1,   297,  3854,    -1,   300,    -1,   221,   222,  3860,
      -1,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1903,    -1,   242,  1906,
    1907,    -1,  3269,    -1,    -1,    -1,    -1,    -1,  3275,  3890,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1937,  1938,    -1,    -1,    -1,    -1,    -1,    -1,  3919,   283,
    3921,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,  1680,   300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,  3359,    17,    18,    19,    -1,    -1,  1035,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1046,
      -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,  1062,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2072,    -1,   492,    -1,    -1,
    1795,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1830,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3489,  3490,    -1,    -1,    -1,  2576,  1853,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1861,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1869,    -1,    -1,    -1,   492,  3516,
      -1,    -1,  3519,    -1,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,   198,    -1,  2672,    -1,    -1,    -1,
    2676,  2677,  1219,    -1,    -1,    -1,    -1,    -1,  1913,  1914,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,    -1,
      -1,    -1,  1927,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1940,  1941,    -1,   242,    -1,
      -1,    -1,    -1,    -1,  3591,  3592,  3593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2734,    -1,
      -1,    -1,    -1,    -1,  2740,    -1,    -1,    -1,  4229,  3616,
      -1,  4232,    -1,  4234,    10,    -1,    -1,    13,    -1,   283,
      -1,    17,    18,    19,    51,    -1,  4247,    -1,  3635,    -1,
      -1,    -1,    -1,   297,    -1,    -1,   300,    -1,  4259,    35,
      -1,    -1,  4263,    -1,    -1,  2781,    -1,    -1,    -1,    45,
    3657,    -1,  2741,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,  4282,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,  4300,
      -1,    -1,    78,    -1,    -1,  4306,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
    4331,    -1,    -1,    -1,  4335,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,  2093,  4350,
    4351,  4352,  4353,    -1,    -1,    78,  3743,    -1,    -1,  4360,
    4361,  4362,  4363,   705,    -1,    -1,    -1,    -1,  4369,  4370,
      -1,    -1,    -1,    -1,  4375,  4376,    -1,  4378,  4379,  4380,
    4381,  4382,  4383,  4384,    -1,    -1,    -1,    -1,    -1,   731,
      -1,    -1,    -1,  4394,    -1,    -1,    -1,  4398,  4399,  4400,
    4401,    -1,    -1,  3790,    -1,    -1,    -1,    -1,    -1,  3796,
    2879,  3798,    -1,  2882,    -1,  1472,    -1,   193,    -1,    -1,
      -1,  4422,   198,    -1,  3811,    -1,  3813,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4440,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   242,    -1,    -1,    -1,
     193,    -1,    -1,    -1,  2990,   198,    -1,    -1,    -1,    -1,
      -1,    -1,  1539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3880,    -1,    -1,    -1,    -1,   221,   222,
      -1,  2970,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,    -1,    -1,  2983,  4516,    -1,    -1,    -1,   242,
      -1,   297,  2991,  1580,   300,    -1,    -1,    -1,    -1,    -1,
      -1,   873,    -1,    -1,    -1,  3922,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3063,  4549,    -1,
      -1,  3067,    -1,    -1,  3941,  4556,  1613,  4558,  3945,    -1,
     283,  3030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   297,    -1,    -1,   300,    -1,  3966,
      -1,    -1,  3051,    -1,    -1,  4586,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3094,    -1,  3096,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2672,    -1,   423,    -1,  2676,
    2677,    -1,    -1,    -1,  3170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,  3185,
      -1,    -1,    -1,    -1,  3190,    -1,    -1,    -1,  4065,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1035,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3218,    -1,  1046,    -1,    -1,  2734,    -1,    -1,
      -1,    -1,    -1,  2740,    -1,  3184,   492,    -1,    -1,    -1,
    1062,    -1,  3191,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1807,    -1,    -1,    -1,  2781,    -1,    -1,    -1,    -1,    -1,
      -1,  1818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1834,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4801,  4802,  4803,    -1,    -1,    -1,  4807,  4808,  4809,  4810,
      -1,    -1,    -1,  4814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1903,    -1,    -1,  1906,
    1907,  4852,  4853,  4854,  4855,  4856,    -1,  4858,  4859,  4246,
      -1,    -1,    -1,    -1,    -1,  2610,    -1,    -1,    -1,  4870,
    4871,    -1,    -1,    -1,    -1,    -1,    -1,  1219,    -1,    -1,
    1937,  1938,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,   705,    -1,
      -1,    -1,    -1,  4904,    -1,    -1,    -1,    -1,    -1,    -1,
    4297,    35,    -1,    -1,    -1,  4302,    -1,  4304,    -1,    -1,
    2665,    45,    -1,    -1,   731,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2683,    -1,
      -1,  4328,  2687,    -1,    -1,    -1,  2691,    -1,  3464,    -1,
      -1,  3467,    -1,  3469,    78,  2700,    -1,    -1,  3474,    -1,
      -1,    -1,    -1,  2990,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2718,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,
    4377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5006,  3522,  2752,    -1,    -1,
      -1,    -1,    -1,    -1,  3530,  2072,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,  2773,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3063,    -1,    -1,  3555,
    3067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,  3525,  3526,  2803,  2804,
      -1,    -1,  2807,    -1,    -1,    -1,   873,    -1,    -1,   193,
    5071,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,
    4467,  4468,    -1,    -1,    -1,    -1,  2831,    -1,  2833,    -1,
      -1,  4478,  2837,    -1,    -1,    -1,    -1,   221,   222,    -1,
      -1,    -1,  5103,    -1,    -1,    -1,  2851,    -1,  4495,  3625,
      -1,  3627,    -1,  2858,    -1,    -1,  2861,    -1,   242,    -1,
      -1,    -1,  2867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2887,  3170,    -1,    -1,    -1,    -1,  2893,    -1,
      -1,    -1,    -1,    -1,    -1,  2900,    -1,    -1,  3185,   283,
      -1,    -1,    -1,  3190,    -1,    -1,    -1,    -1,    -1,  2914,
      -1,    -1,    -1,   297,    -1,    -1,   300,    -1,    -1,    -1,
      -1,    -1,  2927,    -1,    -1,    -1,    -1,  2932,    -1,  4576,
      -1,  3218,  4579,  2938,    -1,    -1,  5197,  1539,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3721,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1035,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1580,  1046,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3763,    -1,    -1,
      -1,    -1,    -1,  2998,    -1,  1062,    -1,    -1,    -1,    -1,
    5261,    -1,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,
      -1,  1613,    -1,    -1,    -1,  3791,    -1,    -1,    -1,  5280,
      -1,    -1,    -1,    -1,    -1,  5286,  5287,    -1,    -1,    -1,
      -1,   705,    -1,    -1,    -1,  5296,  3765,    -1,    -1,    -1,
      -1,    -1,  5303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5338,  5339,    -1,
      -1,    -1,    -1,  3859,    -1,    -1,    -1,    -1,    -1,    -1,
    5351,    -1,  5353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3881,    -1,  5368,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,  3903,    -1,    -1,
      -1,    -1,  5393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3153,    -1,
    3155,    -1,  1219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4813,  3172,    -1,    -1,
      -1,    -1,    -1,    -1,  3179,    -1,    -1,  3464,    -1,    -1,
    3467,    -1,  3469,    -1,    -1,    -1,    -1,  3474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3925,    -1,    -1,   873,
      -1,    -1,    -1,    -1,    -1,  1807,    -1,    -1,    -1,  3985,
    4857,    -1,    -1,    -1,  5475,    -1,  1818,    -1,    -1,    -1,
      -1,    -1,  4869,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1834,    -1,    -1,  3522,    -1,    -1,  5499,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,  5510,
      -1,    -1,  4028,    -1,    -1,    -1,  4903,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3269,    -1,    -1,    -1,  3555,    -1,
    3275,    -1,    -1,    -1,    -1,    -1,    -1,  4053,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1888,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1903,    -1,    -1,  1906,  1907,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5577,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4981,  1937,  1938,    -1,  3625,    -1,
    3627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5000,  3359,  2672,    -1,    -1,    -1,  2676,
    2677,  1035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1046,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    -1,    -1,    -1,    -1,  5647,    38,  1062,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1472,    -1,    -1,   208,    60,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2734,    -1,    -1,
     220,    -1,    -1,  2740,    -1,    76,    -1,    -1,    -1,    -1,
      -1,   231,    -1,    -1,  3721,    -1,    -1,  4213,    -1,  5086,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,    -1,    -1,    -1,  2781,    -1,  5727,    -1,    -1,    -1,
    2072,    -1,  1539,    -1,    -1,    -1,  3763,    -1,    -1,    -1,
      -1,   132,    -1,    -1,  3489,  3490,    -1,    -1,   139,    -1,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3791,    -1,    -1,    -1,    -1,    -1,
      -1,  3516,    -1,  1580,  3519,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,    -1,    -1,  5786,    -1,  4303,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1219,  1613,    -1,    -1,    -1,
     201,    -1,    -1,  4329,   205,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5212,    -1,  5214,    -1,    -1,
      -1,    -1,  3859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3591,  3592,  3593,    -1,
      -1,    -1,    -1,    -1,  3881,    -1,    -1,    -1,    -1,    -1,
     705,   252,    -1,    -1,    -1,    -1,   257,    -1,    -1,    -1,
     261,  3616,    -1,  5260,    -1,    -1,  3903,    -1,    -1,  5880,
      -1,    -1,    -1,  5270,    -1,   276,   731,    -1,    -1,   280,
    3635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,  5912,  3657,    -1,    -1,    -1,    -1,    -1,    -1,   310,
     311,    -1,  5923,  5310,    -1,    -1,    -1,    -1,  5315,    -1,
      -1,    -1,    -1,  2990,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4471,  4425,    -1,  3985,   350,
      -1,    -1,   353,   354,   355,    -1,    -1,    -1,    -1,    -1,
    4439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   379,    -1,
      -1,    -1,    -1,    -1,   385,    -1,    -1,    -1,  3743,    -1,
    1807,  4028,  4518,    -1,    -1,    -1,  3063,  4523,   399,    -1,
    3067,  1818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6025,    -1,  4053,  1834,   873,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3790,    -1,    -1,    -1,    -1,
      -1,  3796,    -1,  3798,    -1,    -1,   447,    -1,  1472,    -1,
      -1,    -1,    -1,   454,    -1,    -1,  3811,    -1,  3813,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1903,    -1,    -1,  1906,
    1907,    -1,    -1,   643,    -1,    -1,    -1,    -1,    -1,   649,
      -1,    -1,    -1,  3170,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,  1539,    -1,    -1,  3185,    -1,
    1937,  1938,    -1,  3190,    -1,  3880,    -1,    -1,    -1,    -1,
      35,    -1,  5529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,  5543,    52,  4674,    -1,
      -1,  3218,    -1,    -1,    -1,    -1,  1580,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3922,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,  4213,  5574,    -1,    -1,
    1035,    -1,    -1,    -1,    -1,    -1,  3941,    -1,    -1,  1613,
    3945,  1046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1062,    -1,    -1,
      -1,  3966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2072,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4303,    -1,    -1,   174,
     820,    -1,    -1,    -1,  4800,    -1,    -1,    -1,  5675,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   839,
      -1,    -1,  4329,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4065,    -1,    -1,    -1,  4840,    -1,   221,   222,    -1,    -1,
    2672,    -1,    -1,    -1,  2676,  2677,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4862,   242,    -1,    -1,
      -1,    -1,    -1,  5740,    -1,  5742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   909,
      -1,    -1,    -1,    -1,  1219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,
      -1,    -1,  2734,  1807,    -1,    -1,    -1,    -1,  2740,    -1,
      -1,    -1,   297,    -1,  1818,   300,    -1,  3464,    -1,    -1,
    3467,    -1,  3469,    -1,    -1,    -1,   956,  3474,  4934,    -1,
    1834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2781,
      -1,    -1,    -1,    -1,  4471,  4914,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4929,    -1,    -1,    -1,    -1,  3522,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3530,  1888,    -1,    -1,    -1,    -1,    -1,
      -1,  5868,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1903,
      -1,  4518,  1906,  1907,  5881,   390,  4523,    -1,  3555,    -1,
      -1,  4246,    -1,    -1,    -1,    -1,    -1,  5894,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1937,  1938,    -1,    -1,    -1,    -1,    -1,
      -1,  1071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5055,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5020,  4297,    -1,    -1,    -1,    -1,  4302,    -1,  4304,
    1100,  1101,  1102,    -1,    -1,    -1,  5953,  5954,  3625,    -1,
    3627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4328,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6012,    -1,  1472,    -1,  4374,
      -1,    -1,  4377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4674,  2990,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2072,    -1,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,    -1,  1209,
      -1,    -1,    -1,    -1,  5190,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1539,    -1,    -1,  1237,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,  3763,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3063,  4467,  4468,    -1,  3067,    -1,    -1,    -1,    35,
      -1,    -1,    -1,  4478,  3791,  1580,    -1,    -1,    -1,    45,
      -1,    -1,    -1,  5259,    -1,    -1,    52,    -1,    -1,    -1,
    4495,  5220,    -1,  5222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6150,    -1,    -1,    -1,    -1,  1613,    -1,
      -1,    -1,    78,  4800,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,  3859,    -1,    -1,    17,    18,    19,  6195,    -1,
      -1,    -1,    -1,  4840,    -1,    -1,  6203,  6204,    -1,    -1,
      -1,    -1,    -1,    35,  3881,    -1,  6213,    -1,  3170,    -1,
      -1,  4576,    -1,    45,  4579,  4862,    -1,    -1,    -1,    -1,
      52,    -1,  1382,  3185,    -1,    -1,  3903,    -1,  3190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,  5379,    -1,  2672,    78,    -1,    -1,  2676,
    2677,    -1,    -1,    -1,    -1,    -1,  3218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5374,    -1,  4934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,  1462,    -1,    -1,    -1,    -1,  2734,  3985,    -1,
      -1,    -1,    -1,  2740,    -1,   147,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1807,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,  4028,    -1,  1818,  2781,    -1,    -1,   283,    45,    -1,
      -1,   193,    -1,    -1,    -1,    52,   198,    -1,    -1,  1834,
      -1,   297,    -1,    -1,   300,  5511,  4053,    -1,    -1,    -1,
    5516,  5517,    -1,    -1,    -1,  1545,    -1,    -1,    -1,   221,
     222,    78,    -1,    -1,  1554,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1888,    -1,    -1,  1586,    -1,    -1,    -1,
      -1,    -1,  1592,  1593,    -1,    -1,  1596,    -1,  1903,    -1,
      -1,  1906,  1907,    -1,  5533,    -1,  5535,    -1,  4813,  1609,
      -1,   283,  1612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   390,   297,    -1,    -1,   300,    -1,
      -1,    -1,  1937,  1938,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4857,  5629,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3464,    -1,  4869,  3467,   193,  3469,    -1,    -1,
    1670,   198,  3474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,   222,  4213,    -1,  4903,    -1,
      -1,    -1,  5678,  5190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,   390,    -1,
    3522,    -1,    -1,  2990,    -1,    -1,   492,    -1,  3530,    -1,
      -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3555,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2072,    -1,    -1,
     297,    -1,  5259,   300,    -1,    -1,  4981,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4303,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1794,  5000,  3063,    -1,  2672,    -1,
    3067,    -1,  2676,  2677,    -1,  1805,    -1,    -1,    -1,    -1,
      -1,    -1,  4329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,    -1,    -1,  3625,    -1,  3627,    -1,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,   508,   509,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1847,  1848,    -1,
      -1,    -1,  5781,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2734,    -1,    -1,   390,    -1,    -1,  2740,    -1,    -1,    -1,
      -1,    -1,  1872,    -1,    -1,    -1,    -1,    -1,    -1,  1879,
      -1,  5086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3170,    -1,    -1,    -1,  2781,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3185,  3721,
      -1,    -1,    -1,  3190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3218,  1952,    -1,  4471,    -1,    -1,    -1,    -1,    -1,
      -1,  3763,    -1,    -1,    -1,   492,    -1,  5896,    -1,    -1,
      -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,    -1,    -1,  1985,  1986,    -1,    -1,  3791,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4518,  2002,    -1,    -1,  2005,  4523,  5212,    -1,  5214,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,  5511,    17,    18,    19,    -1,  5516,
    5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,  5260,    -1,  3859,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6006,    -1,  3881,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,  3903,    -1,    -1,    -1,  5310,    -1,  6036,  6037,    -1,
      -1,    -1,    -1,    35,    -1,    -1,  2990,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5629,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,  4674,    -1,    -1,
      -1,    -1,    -1,    -1,   817,   818,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,  3985,    -1,    -1,    -1,    -1,    -1,  3063,
      -1,  5678,    -1,  3067,    -1,    -1,    -1,  3464,    -1,    -1,
    3467,   193,  3469,    -1,    -1,    -1,   198,  3474,    -1,    -1,
      -1,  6140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4028,    -1,    -1,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,  4053,    -1,    -1,    -1,  3522,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   193,    -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,
      -1,    -1,    -1,  4800,    -1,    -1,    -1,    -1,  3555,    -1,
      -1,   283,    -1,    -1,    -1,    -1,  3170,    -1,    -1,   221,
     222,    -1,    -1,    -1,    -1,   297,    -1,    -1,   300,    -1,
      -1,  3185,    -1,    -1,    -1,    -1,  3190,    -1,    -1,    -1,
     242,    -1,    -1,  4840,  5529,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5543,    -1,
      -1,    -1,    -1,    -1,  3218,  4862,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3625,    -1,
    3627,   283,    -1,  1016,  1017,    -1,    -1,  2672,    -1,  5574,
      -1,  2676,  2677,    -1,    -1,   297,    -1,    -1,   300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4213,    -1,    -1,    -1,    -1,    -1,  4934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2734,
      -1,    -1,    -1,    -1,    -1,  2740,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,
    5675,    -1,    -1,    -1,    -1,    -1,  2781,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3763,    -1,    -1,    -1,
     492,  4303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,   508,   509,    -1,    -1,
      -1,    -1,    -1,    -1,  3791,    -1,    -1,  4329,    -1,    -1,
      -1,    -1,  2532,    -1,    -1,  5740,    -1,  5742,  5055,    -1,
      -1,    -1,  2542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,  2571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,   508,   509,    -1,    -1,
    3464,    -1,  3859,  3467,    -1,  3469,    -1,    -1,    -1,    -1,
    3474,    -1,  1255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3881,    -1,    -1,    -1,  2618,  2619,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3903,  1290,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3522,    -1,
      -1,    -1,  2652,    -1,    -1,    -1,  3530,    -1,    -1,    -1,
      -1,    -1,    -1,  5868,    -1,    -1,  1319,  1320,  1321,  4471,
    1323,    -1,    -1,  5190,    23,    -1,    -1,    -1,    -1,    -1,
      -1,  3555,    -1,    -1,    -1,  2990,    -1,    -1,    -1,  5894,
    1343,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4518,    66,  3985,    -1,
      -1,  4523,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5259,    -1,    -1,    -1,    95,    -1,    -1,    -1,
      -1,  3625,    -1,  3627,    -1,    -1,    -1,    -1,  3063,    -1,
      -1,  4028,  3067,    -1,   113,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2785,  4053,    -1,   137,    -1,
      -1,    -1,    -1,  1446,    -1,    -1,    -1,  1450,  1451,   148,
    2800,    -1,    -1,    -1,    -1,    -1,    -1,  6012,   157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   170,  2822,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3721,    -1,    -1,
      -1,    -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5379,    -1,    -1,  3170,    -1,    -1,    -1,    -1,
      -1,    -1,  4674,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3185,    -1,    -1,    -1,    -1,  3190,    -1,    -1,    -1,  3763,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,  2908,  2909,
      -1,    -1,    -1,  3218,    -1,    -1,    -1,  3791,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,  6150,  4213,    31,   297,    -1,
      -1,   300,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   321,    -1,    -1,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3859,   335,    -1,    -1,    -1,
    6195,    -1,    76,   342,  5511,    -1,    -1,    -1,  4800,  5516,
    5517,    -1,    -1,    -1,    -1,    -1,    -1,  3881,  6213,  3009,
      -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,
    1335,    -1,    -1,   372,    -1,    -1,    -1,   111,    -1,  3903,
     379,    -1,    -1,   382,    -1,    -1,  4303,    -1,  4840,    -1,
      -1,    -1,  1695,  1696,  1697,    -1,    -1,    -1,   132,    -1,
      -1,    -1,   401,    -1,    -1,   139,    -1,    -1,   142,   408,
    4862,    -1,  4329,    -1,    -1,    -1,   415,    -1,    -1,   418,
     419,    -1,   421,   422,    -1,  1390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,   437,    -1,
      -1,    -1,    -1,    -1,    -1,   444,    -1,    -1,   447,    -1,
      -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3985,  5629,    -1,   463,    -1,    -1,   201,    -1,    -1,
      -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,  4028,    -1,    28,    -1,    -1,  3464,
      -1,  5678,  3467,    -1,  3469,    -1,    -1,    -1,   252,  3474,
      -1,    -1,    -1,   257,    -1,    -1,    -1,   261,    -1,  4053,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   276,    -1,    66,    -1,   280,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4471,    -1,   290,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,   299,    -1,  3522,    -1,    91,
      -1,    -1,    -1,    95,    -1,  3530,   310,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3555,  4518,    -1,  5055,    -1,    -1,  4523,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   137,   350,    -1,    -1,   353,
     354,   355,    -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   379,    -1,    -1,   170,    -1,
      -1,   385,    -1,    -1,   176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,
    3625,    -1,  3627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4213,
      -1,    -1,    -1,    -1,    -1,  3345,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,   447,    -1,    -1,  3366,    -1,    -1,    -1,
     454,  2024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2033,  2034,  2035,  2036,   256,    -1,  1701,  2040,  5190,  2042,
    1705,  2044,    -1,    -1,  2047,  2048,  2049,    -1,    -1,    -1,
      -1,    -1,  2055,    -1,    -1,  2058,    -1,  4674,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,
    2073,  2074,  2075,    -1,    -1,   297,    -1,    -1,    -1,  4303,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2091,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,    -1,    -1,  4329,    -1,  5259,  3763,   331,
     332,    -1,    -1,   335,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3791,    -1,    -1,    -1,
     362,    -1,    -1,   365,    -1,    -1,    -1,   369,    -1,    -1,
     372,    -1,    -1,    -1,    -1,    -1,    -1,   379,    -1,    -1,
     382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
      -1,    -1,    -1,  4800,    -1,    -1,   408,    -1,    -1,    -1,
      -1,    -1,    -1,   415,    -1,    -1,   418,    -1,    -1,    -1,
     422,    -1,    -1,    -1,  3859,    -1,    -1,    -1,   430,    -1,
     432,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4840,    -1,    -1,  3881,  5379,    -1,    -1,
      -1,    -1,  2235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   463,    -1,    -1,    -1,  4862,    -1,  4471,  3903,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2282,
      -1,    -1,    -1,  3633,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3643,  4518,    -1,    -1,    -1,    -1,  4523,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3985,    -1,  2335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2022,    -1,  5511,
      -1,    -1,    -1,    -1,  5516,  5517,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4028,    -1,    -1,  2041,    -1,    -1,    -1,
    2045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2060,  2061,  2062,  4053,  2064,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4674,    -1,  3802,  3803,  3804,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3819,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5629,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3852,  3853,    -1,    -1,    -1,  3857,    -1,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,    -1,  2522,
      -1,    -1,    -1,    -1,    -1,    -1,  5678,    -1,    -1,    -1,
    2533,    -1,  2535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2573,    -1,    -1,  5190,  2577,    -1,  4800,  2580,    -1,  2582,
      -1,    -1,  2585,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3963,    -1,    -1,  4840,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2638,  2639,    -1,  4862,    -1,
      -1,    -1,  5259,    -1,    -1,    -1,    -1,    -1,  4303,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    -1,    -1,  4329,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
    4934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2721,    -1,
      -1,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5379,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,  4122,  4123,  4124,    -1,    -1,    -1,    -1,    -1,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,  4471,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,    -1,
      -1,  5055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4518,  2529,    -1,    -1,    -1,  4523,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   244,   245,  5511,    -1,    -1,    -1,   250,  5516,
    5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2956,  2957,  2958,    -1,    -1,    -1,  2962,
    2625,    -1,    -1,    -1,    -1,    -1,  5190,    -1,    -1,    -1,
      -1,    -1,  2637,    -1,   326,    -1,    -1,  2642,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2989,    -1,   340,    -1,
      -1,    -1,    -1,    28,   346,   347,    -1,   349,    -1,    -1,
      -1,    -1,   354,    -1,    -1,   357,    -1,    -1,   360,    -1,
      -1,   363,  5629,    -1,    -1,    -1,    -1,    -1,   370,  4674,
      -1,    -1,    -1,    -1,    -1,   377,   378,    -1,    -1,    -1,
      -1,    -1,    -1,   385,    -1,  5259,    -1,   389,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    -1,    -1,   399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,  5678,    -1,   415,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
      -1,    -1,    -1,   435,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   446,    -1,    -1,    -1,  4448,    -1,
     452,    -1,   137,    -1,    -1,   457,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,   470,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4480,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,   176,   494,    -1,    -1,  4800,    -1,    -1,   183,    -1,
      -1,    -1,    -1,    -1,    -1,  5379,    -1,    -1,    -1,    -1,
      -1,   513,  4512,    -1,   516,    -1,    -1,    -1,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3198,    -1,  4547,    -1,   234,
    3203,    -1,    -1,    -1,    -1,    -1,    -1,  4862,    -1,    -1,
      -1,    -1,    -1,    -1,  4564,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3258,    -1,  3260,  3261,    -1,
      -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3274,    -1,    -1,  3277,    -1,  3279,    -1,    -1,  4934,
      -1,    -1,    -1,    -1,    -1,    -1,   321,  5511,    -1,    -1,
      -1,    -1,  5516,  5517,    -1,    -1,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3315,    -1,  3317,    -1,  3319,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,
     365,    -1,    -1,    -1,   369,    -1,    -1,   372,    -1,    -1,
      -1,    -1,    -1,    -1,   379,    -1,    -1,   382,    -1,    -1,
      -1,    -1,    -1,    -1,  4704,  4705,  4706,  4707,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,    -1,    -1,   413,    -1,
     415,    -1,    -1,   418,    -1,    -1,    -1,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   432,    -1,    -1,
    5055,    -1,   437,    -1,    -1,  5629,    -1,  3410,    -1,    -1,
      -1,    -1,  3415,    -1,    -1,   450,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3430,   463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5678,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5190,  3201,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3221,    -1,    -1,    -1,
      -1,  3226,    -1,    -1,    -1,    -1,    -1,  3232,    -1,    -1,
      -1,    -1,  3237,  3238,    -1,  3240,    -1,    -1,    -1,    -1,
    3245,  3246,    -1,  3248,    -1,  3250,    -1,    -1,    -1,  3254,
      -1,    -1,  3257,    -1,    -1,    -1,    -1,  3262,    -1,    -1,
      -1,    -1,    -1,    -1,  5259,    -1,  3271,    -1,    -1,    -1,
      -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,  3283,  3284,
    3285,  3286,    -1,    -1,    -1,  3290,  3291,    -1,  3293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3312,    -1,  3314,
      -1,    -1,    -1,    -1,    -1,    -1,  3321,  3322,  3323,  3324,
    3325,  3326,  3327,  3328,  3329,  3330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5048,    -1,
      -1,    -1,  3367,    -1,    -1,    -1,    -1,    -1,    -1,  5059,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5379,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3748,    -1,    -1,    -1,    -1,
      -1,  3754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3833,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3510,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5511,    -1,    -1,    -1,
      -1,  5516,  5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5629,    -1,    -1,    -1,    -1,  3982,
      -1,    -1,  5332,    -1,    -1,    -1,    -1,  5337,  3991,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4001,    -1,
      -1,    -1,  4005,  4006,    -1,    -1,  5356,    -1,  4011,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4019,    -1,  4021,    -1,
      -1,    -1,    -1,  5678,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4048,  4049,  4050,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4067,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4075,    -1,    -1,  4078,    -1,  4080,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3752,  3753,    -1,
      -1,    -1,  3757,    -1,    -1,  4098,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4106,  4107,    -1,    -1,    -1,    -1,    -1,
    4113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3786,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5596,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5624,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3981,    -1,    -1,    -1,
      -1,    -1,  3987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4025,  4026,    -1,    -1,  4029,  4030,  4031,  4032,    -1,    -1,
    4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  4044,
    4045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4068,    -1,    -1,  4071,    -1,  4073,    -1,
      -1,  4076,  4077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4100,  4101,  4102,  4103,    -1,
    4105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4524,  4525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4605,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4618,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4632,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4671,  4672,
      -1,    -1,    -1,    -1,    -1,  4678,  4679,    -1,    -1,    -1,
    4683,    -1,    -1,    -1,    -1,    -1,    -1,  4690,    -1,    -1,
    4693,  4694,    -1,    -1,    -1,    -1,    -1,  4700,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4762,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4441,    -1,    -1,  4782,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4885,    -1,    -1,    -1,    -1,    -1,    -1,  4892,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4606,    -1,    -1,    -1,  4610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4960,    -1,    -1,
      -1,    -1,    -1,  4628,  4629,    -1,    -1,    -1,    -1,  4634,
    4635,  4636,  4637,    -1,    -1,    -1,  4641,  4642,  4643,  4644,
    4645,  4646,  4647,  4648,  4649,  4650,  4651,  4652,  4653,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4677,    -1,    -1,  4680,    -1,  4682,    -1,    -1,
      -1,    -1,    -1,  4688,    -1,    -1,  4691,  4692,    -1,    -1,
    4695,  4696,    -1,    -1,    -1,    -1,  4701,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4753,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4767,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5117,    -1,    -1,    -1,    -1,    -1,
    5123,  5124,  5125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5150,  5151,    -1,
      -1,  5154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5180,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5191,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5050,  5051,    -1,    -1,    -1,
      -1,    -1,    -1,  5058,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5416,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5119,  5120,    -1,  5460,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5138,    -1,  5140,    -1,    -1,    -1,  5144,
    5145,  5146,    -1,    -1,  5149,    -1,    -1,  5152,  5153,    -1,
      -1,    -1,    -1,  5158,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5521,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5281,    -1,  5283,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5652,
      -1,    -1,    -1,  5318,    -1,    -1,    -1,    -1,  5661,  5662,
    5663,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5687,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5409,    -1,  5411,  5412,  5413,  5414,
    5415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5428,  5429,  5430,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5442,    -1,    -1,
    5445,    -1,    -1,    -1,  5449,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5482,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5832,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5935,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5959,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5653,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5672,    -1,  5674,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6060,    -1,    -1,
      -1,  5726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5762,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5828,    -1,    -1,    -1,    -1,    -1,    -1,
    5835,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6182,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5879,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5978,  5979,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5992,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6033,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,  6058,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,  6069,  6070,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,  6126,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,    -1,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   504,   505,   506,    -1,    -1,    -1,    -1,
      -1,    -1,   513,   514,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,    -1,   424,   425,   426,    -1,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,    -1,    -1,   468,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,   492,    -1,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   513,   514,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,   492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   513,   514,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,    -1,    -1,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,
     505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,   514,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,   492,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,   504,   505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     513,   514,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   514,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,    -1,
      -1,    -1,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,   240,   241,   242,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,    -1,   279,    -1,   281,   282,
     283,   284,    -1,    -1,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,    -1,
     323,    -1,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,    -1,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,    -1,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,   452,
     453,   454,   455,   456,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,   514,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
      -1,   279,    -1,   281,   282,   283,   284,    -1,    -1,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,    -1,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,    -1,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
     488,   489,   490,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,   514,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,    -1,    -1,   468,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,   492,
      -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   504,   505,    -1,    -1,    -1,     3,    -1,     5,     6,
     513,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,    -1,
      -1,   468,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,   492,    -1,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,    -1,
      -1,    -1,     3,    -1,     5,     6,   513,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   504,   505,    -1,    -1,    -1,     3,    -1,
       5,     6,   513,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,    -1,    -1,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,
     505,    -1,    -1,    -1,     3,    -1,     5,     6,   513,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    36,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,    -1,   424,   425,   426,    -1,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    -1,
       3,    -1,     5,     6,   513,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,   492,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   504,   505,    -1,    -1,    -1,    -1,    -1,   511,   512,
     513,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   504,   505,   506,    -1,    -1,     3,    -1,     5,
       6,   513,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,
      -1,    -1,    -1,     3,    -1,     5,     6,   513,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    -1,     3,
      -1,     5,     6,   513,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     504,   505,    -1,    -1,    -1,     3,    -1,     5,     6,   513,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,
      -1,     3,    -1,     5,     6,   513,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   504,   505,    -1,    -1,    -1,     3,    -1,     5,
       6,   513,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,
      -1,    -1,    -1,     3,    -1,     5,     6,   513,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    -1,     3,
      -1,     5,     6,   513,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     504,   505,    -1,    -1,    -1,     3,    -1,     5,     6,   513,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,
      -1,     3,    -1,     5,     6,   513,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   504,   505,    -1,    -1,    -1,     3,    -1,     5,
       6,   513,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,
      -1,    -1,    -1,     3,    -1,     5,     6,   513,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    -1,     3,
      -1,     5,     6,   513,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     504,   505,    -1,    -1,    -1,     3,    -1,     5,     6,   513,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,
      -1,     3,    -1,     5,     6,   513,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   504,   505,    -1,    -1,    -1,     3,    -1,     5,
       6,   513,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,
      -1,    -1,    -1,     3,    -1,     5,     6,   513,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   504,   505,     3,    -1,     5,     6,
      -1,     8,     9,   513,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,    -1,   445,   446,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,   505,     3,
      -1,     5,     6,    -1,     8,     9,   513,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,     8,     9,    -1,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,   494,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   504,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,   415,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,   494,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,   415,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,
      -1,    10,    11,    -1,    -1,    -1,    -1,   513,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,    -1,   183,    -1,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,    -1,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,    -1,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
      -1,   183,    -1,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,    -1,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,   508,   509,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,    -1,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,    -1,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,    -1,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,   468,    -1,    -1,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,    -1,   489,   490,    -1,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
     508,   509,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,    -1,    -1,   429,   430,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,    -1,   445,   446,   447,   448,   449,    -1,
      -1,   452,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,   508,   509,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,    -1,    -1,   416,
      -1,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,    -1,   445,   446,
     447,   448,   449,    -1,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,   465,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,   508,   509,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,    -1,    -1,   416,    -1,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,    -1,   462,
     463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     506,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,   279,    -1,   281,
     282,   283,   284,    -1,    -1,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
      -1,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,    -1,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   506,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,   156,   157,   158,    -1,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,    -1,    -1,    -1,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,    -1,   279,    -1,   281,   282,   283,   284,
      -1,    -1,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,    -1,   323,    -1,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,    -1,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,    -1,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,    -1,    -1,   429,   430,    -1,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,    -1,
     445,   446,   447,   448,   449,    -1,    -1,   452,   453,   454,
     455,   456,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,
     475,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,     3,    -1,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,   506,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,    -1,   445,   446,
     447,   448,   449,    -1,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,   504,   505,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,    -1,   424,   425,   426,    -1,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,    -1,   445,   446,   447,   448,
     449,    -1,    -1,   452,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   504,   505,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,    -1,   424,   425,   426,    -1,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,    -1,   445,   446,   447,   448,   449,    -1,
      -1,   452,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   504,   505,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
      -1,   424,   425,   426,    -1,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,   504,   505,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,    -1,
      -1,   416,    -1,   418,   419,   420,   421,   422,    -1,   424,
     425,   426,    -1,    -1,   429,   430,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,    -1,
     445,   446,   447,   448,   449,    -1,    -1,   452,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
     465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   504,
     505,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,    -1,   424,   425,   426,
      -1,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,    -1,   445,   446,
     447,   448,   449,    -1,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,     5,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,   105,   106,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,   105,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,   105,   106,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,   105,   106,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,   105,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,   105,   106,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,   105,
     106,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    -1,    80,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,   415,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,   415,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,   415,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,   415,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,    -1,    -1,   416,    -1,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
      -1,    -1,   416,    -1,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,    -1,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,   279,    -1,   281,
     282,   283,   284,    -1,    -1,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
      -1,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,    -1,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
      -1,   279,    -1,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,    -1,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,    -1,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,    -1,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,    -1,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,    -1,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,    -1,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,    -1,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,    -1,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,   489,   490,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,    -1,    -1,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,    -1,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,    -1,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,    -1,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,    -1,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,
     490,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,    -1,   279,    -1,   281,   282,   283,   284,    -1,
      -1,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,    -1,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,    -1,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,    -1,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,    -1,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,    -1,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,   279,    -1,   281,
     282,   283,   284,    -1,    -1,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
      -1,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,   425,   426,    -1,    -1,   429,   430,    -1,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,    -1,   458,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
      -1,   279,    -1,   281,   282,   283,   284,    -1,    -1,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,    -1,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,    -1,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,    -1,   424,   425,   426,    -1,
      -1,   429,   430,    -1,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,    -1,   445,   446,   447,
     448,   449,    -1,    -1,   452,   453,   454,   455,   456,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,    -1,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,    -1,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,    -1,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,    -1,
     424,   425,   426,    -1,    -1,   429,   430,    -1,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
      -1,   445,   446,   447,   448,   449,    -1,    -1,   452,   453,
     454,   455,   456,    -1,   458,    -1,   460,   461,   462,   463,
     464,   465,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,   489,   490,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,    -1,   279,
      -1,   281,   282,   283,   284,    -1,    -1,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,    -1,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,    -1,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,    -1,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,    -1,   424,   425,   426,    -1,    -1,   429,
     430,    -1,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,    -1,   445,   446,   447,   448,   449,
      -1,    -1,   452,   453,   454,   455,   456,    -1,   458,    -1,
     460,   461,   462,   463,   464,   465,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,
     490,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,    -1,   279,    -1,   281,   282,   283,   284,    -1,
      -1,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,    -1,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,    -1,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,    -1,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,    -1,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,    -1,   424,   425,
     426,    -1,    -1,   429,   430,    -1,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,    -1,   445,
     446,   447,   448,   449,    -1,    -1,   452,   453,   454,   455,
     456,    -1,   458,    -1,   460,   461,   462,   463,   464,   465,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    -1,    54,    -1,    -1,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,    -1,    -1,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,    -1,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,    -1,   211,
     212,   213,   214,    -1,    -1,    -1,    -1,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,   279,    -1,   281,
     282,   283,   284,    -1,    -1,   287,    -1,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
      -1,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,    -1,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,    -1,   424,    -1,    -1,    -1,    -1,   429,   430,    -1,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,    -1,   445,   446,   447,   448,   449,    -1,    -1,
     452,   453,   454,   455,   456,    -1,    -1,    -1,   460,   461,
     462,   463,   464,   465,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    96,    98,   115,   118,   133,   135,   139,   145,
     153,   155,   162,   180,   197,   244,   245,   250,   264,   282,
     326,   340,   346,   347,   349,   354,   360,   363,   370,   377,
     378,   385,   389,   399,   415,   435,   446,   452,   457,   470,
     494,   496,   497,   498,   499,   500,   513,   520,   521,   522,
     523,   528,   529,   535,   536,   538,   539,   540,   541,   543,
     546,   558,   563,   564,   567,   568,   569,   587,   590,   591,
     606,   655,   658,   659,   662,   665,   666,   667,   675,   682,
     684,   685,   688,   691,   692,   696,   705,   709,   710,   711,
     714,   716,   717,   718,   719,   727,   729,   749,   753,   755,
     756,   766,   768,   775,   776,   779,   780,   781,   782,   783,
     792,   794,   796,   799,   803,   804,   814,   815,   820,   825,
     836,   868,   871,   872,   873,   878,   881,   883,   885,   887,
     888,   892,   893,   896,   898,   899,   903,   904,   905,   908,
     909,   910,   911,   912,   919,   921,   922,   923,   924,   930,
     932,   933,   939,   940,   941,   944,   945,   946,   947,   949,
     950,   952,   953,   955,   956,   958,   970,   972,   975,   977,
     978,   987,   989,   994,   999,  1007,  1011,  1012,  1013,  1014,
    1015,  1016,  1022,  1058,   429,   473,   925,    28,    79,    95,
     113,   119,   137,   148,   157,   170,   176,   183,   203,   234,
     256,   297,   321,   331,   332,   335,   362,   365,   369,   372,
     379,   382,   401,   408,   413,   415,   418,   422,   432,   437,
     450,   463,   681,   925,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    40,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    59,    60,    61,    62,    63,    64,
      67,    68,    69,    70,    71,    73,    74,    75,    76,    77,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    92,    93,    94,    95,    96,    97,    99,   100,   101,
     102,   106,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   120,   122,   123,   124,   125,   126,   127,   128,   130,
     131,   132,   133,   136,   137,   138,   139,   140,   142,   143,
     144,   146,   147,   148,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   161,   163,   164,   165,   166,   167,
     169,   171,   172,   173,   175,   176,   177,   178,   179,   181,
     182,   184,   185,   186,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   199,   200,   201,   202,   203,   204,
     205,   206,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   218,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   238,   239,
     240,   241,   242,   244,   245,   246,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   281,   282,   283,
     284,   286,   287,   288,   289,   290,   291,   293,   294,   297,
     298,   299,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   320,
     321,   322,   323,   324,   325,   326,   327,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   379,   380,   381,   382,   383,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   412,   413,   416,   417,   418,   419,
     420,   421,   422,   424,   425,   426,   429,   430,   431,   432,
     433,   435,   436,   437,   438,   439,   440,   441,   442,   445,
     446,   447,   448,   449,   452,   453,   454,   455,   456,   457,
     458,   460,   461,   462,   463,   464,   465,   468,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1119,  1203,
    1215,  1216,  1220,  1221,  1222,     3,    29,  1008,  1200,  1215,
    1220,   461,   513,   963,   295,   327,   925,    54,   513,   598,
      23,    41,    66,    79,   113,   119,   137,   148,   157,   170,
     179,   183,   246,   297,   300,   321,   335,   362,   372,   382,
     401,   408,   418,   419,   421,   422,   437,   444,   447,   450,
     607,   664,   771,   826,   837,    29,   326,  1200,  1008,    29,
     320,   380,   419,   421,     6,   233,   879,   880,  1206,    23,
      28,    66,    79,    95,   113,   137,   148,   157,   170,   176,
     183,   203,   256,   297,   310,   321,   332,   335,   362,   365,
     369,   372,   379,   382,   401,   408,   415,   418,   422,   430,
     432,   437,   450,   463,   681,   784,   786,   787,   925,  1200,
      98,   461,   513,   659,   662,   665,   958,   971,   975,   978,
     987,   994,   999,  1007,  1011,    11,    22,    29,    49,   165,
     172,   174,   198,   235,   271,   329,   348,   504,   505,   800,
     801,  1008,  1205,  1207,    29,    31,    98,   344,   378,   805,
     806,   807,  1215,   170,  1215,  1202,  1206,   415,  1025,   800,
    1215,   429,  1200,   310,   256,   513,   891,   370,  1215,    29,
     383,   425,   429,   550,   559,   560,  1215,   180,   805,   806,
    1215,   327,   925,  1215,   232,    29,   134,  1027,  1028,    67,
      92,   246,   266,   362,   372,   383,   425,   429,   476,   547,
     548,   549,   550,    29,   383,   425,   429,   550,   429,   296,
    1070,  1071,  1198,  1215,  1025,   506,  1215,   175,   513,   964,
     513,   342,  1017,  1018,  1200,  1017,     3,    53,    55,    56,
      69,    70,   116,   117,   138,   166,   215,   216,   218,   267,
     269,   288,   339,   387,   393,   425,   426,   458,  1093,  1095,
    1097,  1099,  1101,  1103,  1104,  1105,  1107,  1108,  1109,  1111,
    1112,  1216,  1220,  1027,  1028,  1029,  1211,    12,  1212,  1213,
    1215,  1212,  1212,  1012,  1013,  1016,     0,   516,   513,   963,
     149,   217,   301,   443,  1030,  1031,  1012,  1014,  1015,   124,
     213,   258,   449,   517,    35,   929,   853,  1203,   789,  1215,
     789,  1200,   330,   789,   432,  1200,   112,   415,   841,  1203,
    1215,  1222,     3,   105,   109,   384,  1208,  1209,  1217,  1220,
    1221,  1222,    29,   192,  1198,   289,   463,    10,    17,    18,
      19,    74,   161,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   875,   877,  1150,  1151,  1215,   192,  1200,   841,
    1200,    29,  1208,  1209,   841,  1200,  1200,   192,  1198,  1200,
     192,   789,  1200,   354,   385,    29,   192,  1070,  1200,   375,
    1200,   789,    29,   253,  1208,  1209,   192,  1198,   233,   121,
     223,   280,   338,   926,   927,   928,   513,   511,   515,  1176,
    1178,   491,   957,   958,   959,   960,  1217,  1198,  1200,  1215,
      28,    66,    80,    91,   113,   137,   176,   203,   234,   297,
     332,   362,   365,   408,   418,   430,   437,   784,   785,   786,
     787,  1206,   929,   974,   978,   987,   994,   999,  1011,  1198,
     259,   789,   513,   192,   789,  1200,   789,   432,   192,  1200,
     112,   415,   419,   421,  1208,  1209,   419,   421,    74,   161,
     875,   352,  1200,  1200,  1208,   192,   524,  1215,   192,  1200,
     192,   525,   789,  1200,  1200,   375,   789,   253,  1208,   342,
     379,   415,   463,   256,    95,   203,    28,    91,   176,   332,
     369,   430,   432,   436,   676,    29,  1200,  1009,   557,  1206,
    1217,   880,   259,   192,   853,   854,   192,   884,   192,  1200,
     192,   791,  1093,   432,   112,   415,   192,   840,   841,   192,
    1209,  1210,    87,   463,    74,   161,   192,   876,   877,    59,
     192,   840,   192,  1210,   192,   840,   192,  1200,   192,  1200,
     375,   884,   192,   791,   192,   253,  1210,   233,   192,   788,
     789,   192,  1199,  1200,   192,  1200,   929,   513,   976,   607,
     971,   457,   957,   963,  1207,   801,   802,    29,   802,  1207,
     802,    29,   802,  1207,   802,   802,   802,  1207,  1205,  1205,
    1008,   802,   330,   513,   413,   513,   632,   632,   632,   295,
     427,   517,   632,   372,  1070,  1072,   517,   920,  1206,   513,
     973,    59,   463,   957,   113,   203,   372,   413,   415,   889,
     890,  1215,    48,   490,   223,   515,   298,   295,   174,   298,
    1206,   427,   929,   168,   797,   295,     5,     8,     9,    10,
      12,    37,    53,    55,    56,    65,    66,    69,    70,    77,
      79,   103,   104,   105,   106,   107,   108,   109,   116,   117,
     119,   154,   159,   160,   166,   182,   184,   215,   216,   218,
     226,   227,   228,   229,   239,   247,   248,   267,   269,   278,
     280,   285,   286,   288,   297,   308,   322,   339,   367,   384,
     393,   409,   414,   425,   426,   431,   433,   434,   444,   450,
     458,   478,   479,   480,   481,   483,   484,   485,   486,   492,
     504,   505,   506,   513,  1012,  1096,  1099,  1102,  1103,  1104,
    1106,  1107,  1108,  1111,  1112,  1116,  1118,  1119,  1120,  1122,
    1146,  1147,  1148,  1152,  1170,  1175,  1192,  1195,  1196,  1203,
    1204,  1205,  1206,  1215,  1194,  1195,  1206,    29,   565,  1197,
    1198,   383,   547,   119,   556,  1206,   557,  1206,    48,    71,
     547,   490,   394,   927,   298,   174,   427,   503,    48,   490,
     223,   928,   513,  1198,   506,  1178,  1072,   957,   173,   965,
    1116,  1155,  1017,   517,   513,   966,   460,  1110,  1110,  1110,
     513,  1098,  1098,   324,   513,  1100,    69,    70,  1110,  1098,
    1095,   494,   495,   513,  1113,   513,  1113,    37,  1094,   513,
     114,   190,   260,   263,   376,   488,   513,  1114,  1115,   515,
     790,  1098,  1194,  1179,   514,   514,   522,   957,   967,   968,
     969,  1198,    29,   134,  1026,  1026,    59,  1026,   162,   168,
     243,   292,  1034,  1036,  1037,  1052,  1054,  1055,  1056,  1030,
    1031,   174,   219,   219,  1070,  1073,   513,    68,   276,   311,
     350,   385,   513,   851,   311,   346,   350,   385,   790,   311,
     350,   385,     3,    90,   143,   249,   311,   346,   350,   385,
     418,   420,   470,   558,   561,   934,   935,   936,   937,   821,
      25,   139,   311,   350,   385,   454,   574,  1200,    25,   139,
     385,   449,   542,   474,   192,  1070,    62,    97,   158,   195,
     238,   276,   280,   311,   312,   350,   359,   368,   377,   385,
     397,   406,   410,   465,   558,   562,   857,   869,   897,   513,
     838,  1178,   350,   542,   198,   154,    25,    31,    46,    76,
     132,   139,   142,   169,   205,   276,   280,   290,   299,   311,
     350,   353,   354,   385,   454,   570,   572,   573,   699,   897,
       5,   504,   505,   673,  1207,    29,   192,  1198,   789,   789,
     513,   874,   311,   385,   515,   154,   295,   311,   350,   385,
     869,   897,    25,   139,   311,   350,   385,   198,   537,   350,
     470,   494,   530,   537,   311,   350,   385,   869,   897,   295,
     311,   350,   154,    38,    60,   111,   201,   252,   257,   261,
     276,   310,   350,   355,   379,   385,   399,   447,   570,   670,
     671,   311,   350,   462,   699,   707,   154,   311,   350,   385,
      25,    90,   132,   139,   142,   311,   346,   350,   385,   392,
     560,   548,   550,   198,   154,    46,   130,   276,   350,   385,
     570,   571,   311,   350,   354,   385,    88,   131,   314,   420,
     295,    25,    31,   139,   311,   350,   385,   588,   589,   537,
     168,   350,   530,   537,   154,   350,   385,   570,  1200,   241,
     121,   296,   475,   517,   926,    29,   134,   459,   506,   514,
     846,  1116,  1156,  1157,  1216,  1116,  1177,     3,    29,    33,
      34,    35,    36,    37,    38,    39,    43,    57,    65,    66,
      72,    78,    80,    91,    98,   103,   104,   105,   107,   108,
     109,   119,   121,   129,   134,   135,   141,   145,   149,   160,
     162,   168,   170,   174,   180,   183,   187,   198,   207,   217,
     219,   236,   237,   243,   247,   248,   280,   285,   292,   295,
     296,   300,   301,   319,   328,   344,   358,   378,   384,   395,
     411,   414,   415,   423,   427,   428,   434,   443,   444,   450,
     451,   459,   466,   467,   469,   470,   506,  1201,  1218,  1220,
    1221,  1222,  1223,  1176,   514,   517,   160,   295,   434,   554,
     557,   673,   961,   451,   954,   295,   853,   513,   789,  1200,
    1093,   841,   289,    74,   161,   877,   841,   841,   168,  1093,
     789,  1200,  1200,   514,   632,  1200,    72,  1093,   280,   174,
     513,   757,   530,    38,   948,  1200,   280,   530,   474,   192,
    1198,   530,   789,   789,   757,   447,   607,   295,   168,   470,
     865,   530,   280,    48,   544,   280,   437,   706,   280,   966,
      90,   311,   683,    88,   131,   314,   420,    38,   757,   168,
     192,   530,   463,   192,  1198,   192,   660,  1198,  1198,   463,
     789,    87,   526,  1203,   432,  1203,  1203,  1200,   168,  1200,
     681,    40,    54,   110,   212,   276,   374,   154,    63,   356,
     517,   527,   154,   513,   154,   530,   154,   517,   527,   474,
     154,   517,   527,   154,   517,   192,   788,   192,   789,   192,
     789,   154,   517,   527,  1210,   154,   527,   154,   154,   527,
     154,   527,   154,    88,   131,   314,   420,   168,   154,   527,
     154,   168,   192,   154,   517,   527,   154,   517,   527,   154,
     295,  1155,   415,   514,   971,   802,  1008,   802,  1008,   802,
    1008,   802,  1008,   802,  1008,  1008,  1008,   802,  1008,   513,
     633,   634,  1215,   633,    29,   113,   137,   170,   176,   233,
     234,   313,   332,   365,   372,   379,   415,   418,   437,   810,
    1197,  1210,   807,  1200,   198,   517,   990,  1206,  1093,  1159,
      38,  1210,   526,   514,   526,   526,   526,   241,  1215,   168,
     810,  1210,   168,   370,  1215,   557,   295,   513,  1179,   511,
    1012,  1160,  1116,  1174,   513,   513,   168,   513,   513,  1012,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,  1116,   513,   513,   513,   513,   513,   513,   513,   513,
     287,   623,   513,   513,   513,   513,   513,   513,   513,   513,
    1116,  1116,  1116,  1012,  1116,  1155,  1178,  1206,   513,  1206,
       3,    10,    13,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   164,   165,   166,   167,   169,   170,   171,   172,
     173,   175,   176,   177,   178,   179,   181,   182,   184,   185,
     186,   188,   189,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   218,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   261,
     262,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   293,
     294,   296,   297,   298,   299,   300,   302,   303,   304,   305,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   461,   462,   463,
     464,   465,   466,   468,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   489,
     490,   492,   501,   502,   503,   504,   505,   506,   507,   508,
     509,  1150,  1152,  1154,  1219,  1224,   471,  1133,   307,  1116,
     163,  1134,   219,   517,  1023,   513,  1206,  1178,  1023,   122,
     194,   566,   517,    71,   119,   557,    38,     3,   119,   246,
     555,   673,  1112,  1206,  1206,    93,   136,  1128,   102,   119,
     551,   552,   554,   673,   119,   551,   241,  1198,    94,   355,
     793,   514,   963,    35,    45,    52,    78,   193,   198,   221,
     242,   297,   300,   390,   514,   517,  1018,  1199,    38,   513,
    1155,  1205,  1110,  1110,    37,  1094,   425,   425,  1205,  1205,
     511,   511,  1205,   427,   427,   427,   513,   427,  1205,  1201,
     515,  1098,   174,  1059,    15,   503,  1176,  1214,   514,   517,
     966,  1014,  1014,  1032,  1033,  1116,  1014,   165,   271,  1043,
     230,   276,   338,   388,   449,    29,  1038,  1116,   504,   505,
    1039,  1040,  1116,  1118,  1052,  1053,  1037,  1036,  1034,  1035,
     168,  1055,   290,  1057,  1034,  1052,  1073,   979,  1198,  1073,
      38,  1215,   385,  1155,    68,   427,   427,   372,   198,   210,
     301,   304,   387,   459,   506,   844,   845,   846,   848,   850,
     852,  1093,  1216,   427,   462,   427,   372,   427,   427,   372,
     243,   427,    79,   427,   418,   547,   311,   934,   936,   503,
     938,   168,   180,   198,   360,   822,   823,    72,    91,   150,
     170,   328,   444,   629,   630,    91,   119,   280,   427,    91,
     427,   119,   280,   372,    91,   132,   142,   311,   350,   754,
     372,   689,    28,    66,   137,   176,   297,   332,   365,   430,
     437,   784,   785,  1200,   154,   350,   385,   570,   295,   673,
     377,   238,   427,  1215,   427,   285,   673,   123,   220,   372,
     383,   429,   549,   789,   356,   385,   857,   870,   127,   514,
     839,   844,   427,   450,   418,  1198,    80,   150,   192,   614,
     629,  1215,    80,    91,   894,   316,   295,   367,   369,   432,
      91,   894,    32,   353,   367,   369,   432,   367,  1198,   169,
     205,   290,   789,   513,   427,   427,   191,   513,   578,    23,
     252,   418,   447,   472,   578,    91,   517,   127,     5,     5,
     311,   198,   154,   350,   385,   570,   897,   451,   451,   277,
    1093,   427,   372,   513,   875,  1200,  1198,   427,   427,   372,
     870,   127,   106,   415,   416,   906,   907,  1071,  1198,  1215,
     907,   427,   427,   757,   907,   113,   385,   561,   427,   532,
     561,   427,   427,   372,   870,   127,  1198,   427,   427,  1198,
    1095,   673,    59,   672,   673,   673,   111,   257,   261,    59,
     427,   530,   265,   372,   530,   276,   671,   427,   427,   285,
    1206,   699,   789,   427,   427,   372,   401,   335,  1206,   335,
     427,   335,   427,   335,   757,   757,   418,  1070,   316,   316,
      91,   427,   894,   372,   427,   427,   578,   578,   789,   789,
     789,   789,  1198,    47,   456,    47,    47,   427,    47,   427,
     456,   372,   513,   517,   561,   450,   715,  1209,   427,   532,
     561,  1198,   427,   894,   372,   311,   350,   338,   351,   381,
     553,   926,  1156,  1156,  1157,   514,    15,    16,   517,  1030,
    1031,   512,   518,  1198,   959,  1200,  1198,   221,  1093,   221,
     295,   221,   221,   673,   789,   789,   221,   221,   221,  1093,
     221,   221,   221,   295,   427,   174,   427,   592,   437,   513,
      38,   154,   789,   758,   759,  1218,   934,  1093,   295,   154,
     686,  1200,   280,   316,   513,   531,   771,   451,   342,   463,
    1198,    29,   907,   757,   531,   154,  1209,    98,   180,   545,
     606,   666,   729,   803,   825,   930,   154,  1206,   707,   708,
     154,   295,  1206,  1209,   249,   789,   789,   789,   789,   146,
     337,   513,   715,   280,   531,  1198,   280,   668,   670,   280,
      38,   290,   316,   513,   632,   632,   192,   663,  1198,   168,
     192,   524,  1215,   513,   761,   851,  1200,   513,   842,   842,
      38,  1093,    27,    50,   214,   730,   233,   470,   472,  1010,
     374,   854,   853,  1093,  1200,   513,   791,  1093,   840,   841,
    1210,  1209,   154,   527,   154,   451,   154,   451,   876,   877,
     527,   840,  1210,   840,  1200,  1200,  1093,   791,  1210,   715,
     154,   788,   789,  1199,  1200,  1200,   789,   514,   192,  1198,
     971,  1008,  1008,  1008,  1008,  1008,  1008,   633,   514,   517,
     514,   177,   333,   366,   380,   416,  1199,   788,   112,   382,
     840,  1199,   289,   808,   809,  1215,   840,   840,  1199,  1197,
    1197,  1199,   788,   427,   181,   470,   819,   149,   243,   712,
     713,    23,   152,   367,   388,   991,  1070,   284,   992,   514,
     517,   974,   427,  1198,  1200,  1198,   524,   805,   806,   174,
     819,   806,  1215,    28,    80,   137,   176,   234,   332,   365,
     437,   784,   785,  1155,   512,  1155,  1160,  1161,   466,  1171,
    1172,  1116,  1155,   513,  1205,  1205,     3,   114,   190,   260,
     263,   376,   488,  1162,  1163,  1206,  1155,  1155,   358,  1012,
    1013,  1116,  1181,  1184,  1191,  1181,  1116,  1118,  1156,  1184,
    1187,  1188,  1116,  1188,  1155,  1205,  1205,  1116,  1116,   875,
    1116,  1156,  1158,  1165,   367,   504,   505,   513,  1117,  1118,
    1152,  1166,   514,  1155,  1116,  1158,  1167,  1116,    57,   174,
     237,   428,  1116,  1155,  1168,   134,   280,  1012,  1155,   265,
    1118,  1116,  1126,  1127,  1128,   265,  1116,  1128,   514,   517,
    1205,  1114,  1093,  1116,  1116,  1116,  1116,  1218,   425,    43,
     411,  1180,   789,  1116,   513,  1012,  1169,   134,   136,   160,
     225,   272,   273,   274,   275,   279,   280,   285,   434,   445,
    1164,  1185,  1116,   513,  1116,   427,    52,   193,   198,   242,
     390,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,    29,    36,   395,  1149,   183,  1134,   367,   513,  1146,
     513,   306,  1138,   179,   246,   415,   419,   421,   447,  1024,
    1198,  1196,  1059,  1156,  1059,  1198,   429,   513,  1206,   517,
     514,   191,   191,   527,   969,   958,   962,  1116,   514,   256,
     280,  1019,  1155,   514,   514,   511,   490,   490,   514,   514,
    1205,   512,  1205,   514,   190,   260,  1115,   260,  1115,  1115,
    1205,   263,   514,  1201,   236,   368,   487,   513,  1012,  1060,
    1061,  1062,  1070,  1076,  1086,  1119,  1121,  1122,  1192,  1215,
     467,  1081,  1211,   969,   967,   517,    39,   129,   451,   834,
     367,   368,   504,   505,  1040,  1042,  1118,   388,   230,   296,
     517,     5,  1041,  1205,  1041,   367,   368,  1042,  1197,   284,
     392,   993,  1053,  1035,   451,   988,   119,   309,   513,   980,
    1011,    38,   451,  1215,   513,   995,   996,   997,  1215,   514,
    1209,  1200,  1200,   304,    59,  1216,   514,   846,   848,   845,
     848,  1216,   301,   514,   517,   790,  1209,  1200,  1200,  1209,
    1200,  1200,  1209,   462,  1200,  1200,   119,   554,   673,   362,
     450,   805,   372,   180,   805,   513,  1200,   451,   827,   230,
     230,   451,   623,   654,   192,  1200,   285,  1209,  1200,  1200,
    1116,   285,  1200,  1200,    32,   353,   427,   427,  1200,   427,
     690,   853,   513,  1093,   841,    74,   161,   877,   841,   841,
     168,  1093,   789,  1200,   186,   276,   311,   350,   455,   693,
     694,   695,  1070,   427,   894,   372,   285,   123,   220,  1209,
    1200,   295,  1200,   295,   514,   517,  1208,  1210,  1200,   350,
     570,   192,   614,   280,  1093,  1200,  1205,  1215,  1198,  1200,
     241,  1200,    29,   450,  1200,   192,  1200,   192,  1215,   369,
     432,   369,   432,   241,  1200,    29,   450,  1200,   241,   367,
    1198,    25,   139,   385,   700,   701,   702,   703,  1218,  1209,
    1200,   119,   175,   281,   451,   577,   580,   581,  1218,   259,
    1200,    76,   293,  1200,   573,   295,   427,   418,  1198,   427,
     894,   372,   127,  1200,  1200,   517,   514,   517,  1209,  1200,
     900,   901,  1218,   295,   350,   427,   723,  1209,  1200,  1200,
     295,  1070,   198,   517,   632,   632,  1178,  1209,  1200,  1200,
    1208,     3,    90,   144,   205,   318,   442,   450,   453,   533,
    1209,  1200,  1200,   295,   350,  1209,  1200,   350,   385,   570,
     670,   673,   789,  1200,   673,   789,  1200,   673,  1209,  1200,
     385,  1209,  1200,  1200,  1207,  1199,  1199,  1209,   865,  1200,
    1199,  1200,   350,   385,   570,   571,  1198,  1198,  1200,  1200,
    1200,  1200,  1209,  1200,    25,    31,   139,   311,   350,   385,
     311,   350,   385,   757,   350,   385,   350,   385,   350,   897,
    1085,  1215,   192,   767,  1215,   192,  1215,  1209,  1200,  1200,
    1206,  1200,   900,    25,   589,   382,  1208,   350,   385,   570,
    1200,  1200,  1200,   427,   427,    85,   441,   338,   517,  1030,
    1030,  1030,  1116,  1116,   459,  1157,   514,  1116,  1177,   954,
     285,   795,  1206,    38,   795,   137,   789,   795,   795,   221,
     451,   451,   795,   795,   795,   233,   795,   795,   795,   789,
     334,   593,   593,   203,   415,   728,  1116,  1093,   789,   514,
     517,   503,   620,  1218,  1200,    63,   174,   372,   462,   687,
     694,   695,   154,   290,   242,   608,   610,   612,   614,   626,
     629,    26,   198,   362,   412,   533,   534,   168,  1200,   463,
    1198,    38,   724,   416,   865,   524,  1215,   544,   607,   837,
    1200,   170,   789,   513,   656,   657,  1121,  1215,   335,  1206,
     757,   757,   757,   757,   513,   757,  1083,  1084,  1085,   382,
     154,   513,   154,   154,   153,  1011,   789,   290,   608,  1215,
     451,   649,   470,   579,   280,    38,   632,  1206,   280,   295,
       3,   762,   763,   757,    27,   514,   843,   844,   849,    38,
     233,   359,   430,   469,   855,   856,   857,   858,   855,   295,
     233,   290,   124,   213,   435,   449,   731,   732,  1200,   189,
     189,   168,   527,    38,   530,   169,   942,   943,   527,   527,
     788,   789,  1200,   789,  1200,   527,   527,   527,   527,   233,
     527,   382,   168,   527,   527,   295,   527,   280,   514,   634,
     198,   198,   198,   198,   198,   474,  1199,   673,   674,   517,
     515,   183,   811,   812,  1209,    59,   816,   817,  1218,   427,
     513,   174,   152,   388,   152,   388,   367,   449,   262,  1093,
    1209,   470,   661,   295,   811,   527,   174,   853,   789,  1093,
     841,   289,   841,   841,  1093,   789,  1200,   514,   512,   512,
     517,  1116,   141,  1172,  1173,    38,   514,  1116,   514,   514,
     514,   174,   514,   514,  1093,   491,  1182,  1182,   514,    21,
     285,   517,  1190,   301,  1193,   518,   456,   514,   514,    21,
     285,   517,  1189,  1189,   514,   514,   514,   514,   517,   517,
     514,   319,   514,   514,   513,  1117,  1117,  1155,    13,    17,
      18,    19,   198,   221,   297,   501,   502,   503,   504,   505,
     506,   507,   508,   509,  1152,  1117,   514,   514,   168,   174,
     390,   514,   514,    38,  1168,  1155,  1168,  1168,   174,   514,
     134,   514,  1218,   317,  1131,    38,   514,   517,  1116,  1218,
     517,  1116,  1179,  1116,   514,   490,  1117,  1117,   147,  1155,
     174,    37,   289,   371,   456,   134,   136,   160,   279,   285,
     434,   445,  1164,  1185,   279,   470,   472,  1186,   147,   875,
    1116,   411,  1180,  1116,  1169,  1116,   427,   513,  1012,   513,
    1138,   513,  1155,   467,   513,  1139,  1215,   419,   421,   419,
     421,  1198,  1025,  1025,  1025,  1081,  1030,  1081,   927,  1205,
    1114,   552,   969,   256,   513,   514,  1205,  1113,  1113,   512,
     512,   514,  1012,  1076,  1086,   174,   513,  1012,  1061,  1062,
      38,  1063,  1064,  1215,   517,    99,   175,   209,   224,   240,
     268,   361,  1067,  1064,    38,  1063,  1066,  1215,  1064,   494,
    1080,  1178,  1116,   183,  1044,  1033,   297,  1150,  1153,   493,
     835,     5,  1205,  1042,   296,   470,   449,  1039,   251,  1060,
     467,  1082,   457,   413,   450,   981,   982,   983,  1215,   295,
     984,  1215,  1061,   997,   998,   517,  1059,   503,  1179,   852,
     790,   848,   848,    59,   850,   508,  1210,  1210,   295,  1199,
     298,   295,  1116,   630,  1200,   513,   513,   513,   654,   203,
     513,   747,   154,   527,   427,  1209,  1200,   557,  1093,   789,
     789,  1093,   677,  1200,   186,   455,   427,   427,   677,   693,
     699,   350,   385,   570,  1200,  1200,  1200,   211,   285,   157,
     844,   310,   385,   427,   280,   154,   404,   618,   619,   747,
     385,    25,   139,   354,   355,   385,   574,   582,   583,   699,
     895,   377,   154,   527,   154,   527,  1200,  1200,  1200,  1200,
     377,   377,   241,   702,   703,   702,   514,   517,   704,  1206,
     203,   514,   517,   503,   515,  1200,   157,  1209,  1200,   350,
     385,   570,  1200,  1200,  1200,   295,   311,   350,   385,    25,
     139,   311,   350,   385,  1093,   277,  1093,   514,   517,   503,
    1198,   427,  1210,   451,   720,   157,   632,   372,   906,   467,
     639,   639,   632,   243,   318,   285,  1206,   318,  1210,   448,
     157,   427,   427,   372,   401,   865,   865,   865,   310,   385,
      91,   427,   894,   372,   119,   168,   584,   164,   526,   427,
     427,   253,   253,   253,   427,   427,   372,   427,   427,   372,
     427,   372,   427,   372,   427,   127,   527,  1093,   280,  1206,
     385,   895,   154,   527,   427,   427,   514,  1200,   427,   894,
     372,   427,  1209,  1200,   514,   514,   514,  1157,   512,  1093,
     789,   221,   795,  1200,  1200,  1200,   221,   402,   403,   594,
    1206,   594,   186,   514,   514,   174,   757,   759,   277,   297,
     504,   505,   673,   760,   848,  1153,  1206,  1223,    72,    78,
      91,   119,   121,   178,   207,   280,   285,   328,   344,   444,
     621,   622,   625,   153,   466,   530,   557,  1200,   557,   299,
     697,  1198,  1198,  1198,   514,   517,  1210,   183,   362,  1210,
    1205,   437,  1198,   632,     3,   168,   725,   865,    48,   544,
     415,   706,   112,   966,  1116,   174,   517,  1199,   579,   764,
     765,  1206,   514,   517,  1200,   168,   633,  1198,   660,  1198,
    1200,   661,   513,   609,  1198,   514,  1200,   470,   472,   650,
     578,    38,   154,  1011,   649,   427,   154,  1070,   503,   514,
     517,   731,   514,   517,   119,   503,   859,  1206,   557,   415,
     847,   848,   168,   864,    51,   357,   860,   861,   858,   861,
     124,   213,   378,   449,   917,  1200,   290,   295,   300,   186,
    1011,  1093,   513,   514,   517,   527,   451,   527,   451,   527,
    1200,  1200,   715,   789,   154,   372,   372,   372,   372,   372,
    1199,   517,   809,  1215,  1209,   470,   517,   813,  1209,   517,
     819,   160,   298,   434,   818,  1072,   382,   152,   152,   112,
     276,   810,   819,  1210,   221,   221,   221,   221,   673,   221,
     221,   221,   221,   221,  1160,   423,  1116,   145,  1093,   514,
    1116,  1182,   225,  1184,   295,   295,  1181,  1184,    59,  1190,
    1181,  1181,   295,   295,  1188,  1186,  1186,  1164,  1116,  1116,
     514,  1155,   517,  1093,  1117,  1117,  1117,  1117,   134,   136,
     280,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1116,  1116,  1116,  1093,   514,   514,   514,  1155,   514,
     517,    59,  1118,  1132,   514,  1218,  1127,   325,   407,  1130,
     514,   517,   462,  1123,    38,   514,  1206,  1116,    35,    35,
    1116,   514,  1116,   174,   279,  1186,   444,   444,  1116,   514,
     147,  1117,  1117,   147,   147,  1116,  1116,  1031,   514,  1155,
     517,  1116,  1140,  1215,  1025,  1025,  1025,  1025,  1198,  1198,
    1198,  1044,   514,  1044,   514,   974,   512,  1064,  1066,  1064,
     513,   482,  1118,   514,  1215,   513,  1061,   224,   305,  1068,
    1061,  1068,   224,  1067,  1068,   224,   417,  1074,   513,  1215,
     513,   302,    59,   187,  1051,   513,   835,   165,   235,   296,
     470,   424,   102,  1116,   358,   986,   456,   514,   517,  1179,
      89,   986,   295,   514,   517,   996,  1082,  1116,   514,   508,
     852,   437,   177,   366,   373,   380,   416,   438,   824,   168,
     824,   514,   513,   637,   638,   830,  1121,  1215,   633,   633,
     747,  1200,   633,   121,   207,   276,   280,   748,  1200,  1200,
      38,   451,   451,   233,   790,  1209,  1200,   427,   894,   372,
     427,   211,  1200,    59,   418,  1200,   154,   614,   119,  1215,
      86,   616,   617,   401,   178,   156,   191,   280,   578,   530,
     112,   178,   280,   401,   578,   616,   618,   671,   385,   583,
     437,  1200,  1215,   377,   701,  1200,   581,   760,  1218,  1200,
     310,   385,   427,   894,   372,   427,   157,   427,   427,   372,
     176,   297,   404,   769,   770,   176,   297,   777,   778,   427,
     427,   372,   514,   514,   514,   901,   277,   673,   848,   902,
    1153,  1206,  1223,   350,  1200,   513,   470,   721,  1200,   639,
     106,  1215,   513,   639,  1207,  1206,  1206,  1206,  1200,  1200,
    1200,  1200,  1207,    59,   418,  1200,  1200,  1200,  1200,   457,
    1200,  1200,   168,   168,   352,   168,   192,  1209,  1200,  1200,
    1209,  1200,  1200,  1200,  1200,  1200,  1200,  1200,   295,    78,
     575,   154,    27,    50,   437,  1215,  1200,  1206,   699,  1200,
    1200,  1200,  1200,  1030,   514,   221,   795,   221,   221,   221,
     795,   530,   451,   599,   600,   677,   747,   470,   472,   789,
     513,   789,  1200,  1117,    32,    59,   624,   122,   194,   121,
     285,   230,  1198,   623,   176,   332,   743,   750,   751,  1215,
     686,   513,   316,   513,   609,   627,   206,   644,   612,  1210,
    1210,  1093,   513,   579,    29,   124,   213,   378,   449,   726,
     427,   722,  1209,   192,  1198,   708,   474,   295,   514,  1060,
     657,   865,   514,   517,  1085,   697,   715,   514,   668,    38,
     290,   316,   513,   976,   611,   613,   615,   629,  1215,   316,
     645,   646,   609,   644,   578,   293,   295,   651,  1011,   663,
     661,   579,  1206,  1200,   827,   760,     3,   763,   295,   849,
    1116,  1116,   517,   513,   855,   437,   517,    44,  1116,   427,
     513,   633,  1198,   732,   677,   514,   942,   943,  1200,  1200,
     527,   382,   527,  1199,  1199,  1199,  1199,  1199,   673,   180,
     812,   819,   817,   514,  1200,   112,   174,   527,   819,   285,
     798,  1206,   798,   798,   798,   221,   798,   798,   798,   798,
     798,  1116,   514,   143,  1183,   514,   285,   285,   514,  1032,
    1184,   285,   285,  1184,  1184,   514,   514,   174,   514,  1116,
     174,   134,   136,   174,   168,   147,   514,   477,  1125,  1155,
     343,   456,    59,  1132,  1118,   468,   468,   514,  1116,   276,
    1116,   517,  1124,  1095,  1116,  1116,  1116,   231,   231,  1116,
      35,    35,  1116,  1116,   147,   514,   514,   514,  1116,   514,
     316,  1141,  1198,  1198,  1198,  1198,  1051,  1206,  1051,  1206,
     514,  1077,  1078,  1121,   513,  1131,  1063,   513,  1199,  1061,
     295,   451,  1069,  1061,   224,  1061,  1203,  1084,   513,  1084,
    1215,  1026,  1116,   469,  1135,   875,   424,   290,  1195,  1011,
     309,  1011,   983,   295,   513,   985,  1116,   503,   997,   986,
     437,   514,   427,   805,   174,   747,  1116,   514,   517,   470,
      78,   829,   833,   829,   514,   514,   514,   122,   194,   205,
     121,   453,   527,  1093,  1200,  1200,  1200,  1200,  1200,  1200,
    1200,  1210,  1200,   614,   119,  1215,   697,  1207,   624,   192,
     192,   285,   673,   624,   285,  1207,  1093,   527,   527,   503,
      59,   418,  1200,  1200,  1200,  1200,  1200,  1209,  1200,  1200,
    1205,  1205,  1093,   517,  1205,  1205,   517,  1209,  1200,  1200,
     427,  1116,    72,  1116,  1210,  1200,   427,   427,   174,   198,
     470,  1199,  1199,   789,  1199,   154,   157,   789,  1206,  1206,
    1093,   527,   527,   427,   514,   221,   795,   795,   795,   795,
     513,   595,   596,   530,   126,   176,   210,   176,  1116,   280,
     622,   119,    38,   865,   632,   865,  1203,    35,   153,   198,
     698,   702,   290,   608,   584,   151,   200,   513,   382,   451,
     633,    38,  1210,   720,   544,   280,   513,   170,  1200,   656,
    1206,   382,   579,   153,  1011,   789,   290,   608,   661,   514,
     517,   470,   620,    59,   649,   584,   645,    84,   418,   652,
     470,   931,    38,   652,   174,   295,   513,  1198,  1206,   846,
     866,   867,  1216,   861,  1093,   168,   862,  1198,   174,   427,
     886,   345,   733,   208,   678,   527,   514,   527,   527,  1200,
     298,   219,   811,   527,   798,  1200,   514,   514,   514,  1116,
     514,  1117,   174,  1116,  1116,  1116,   513,   514,   517,   514,
    1132,   514,   456,   398,   514,   202,   276,  1129,  1116,  1116,
    1116,   514,    59,  1030,  1135,  1135,   375,  1020,   514,   517,
      38,  1079,   119,  1091,  1092,  1117,    81,  1199,   514,  1116,
     513,  1061,  1069,   513,   514,  1084,   514,   101,   184,   364,
     513,  1045,  1046,  1047,  1048,  1049,  1050,  1116,  1136,  1137,
    1215,  1030,   514,  1008,   981,    91,   828,   830,   135,   466,
    1000,  1001,  1116,   811,   295,   811,   514,   199,   635,   638,
     297,   875,   789,   525,   789,   344,   635,   635,   514,   427,
     385,   992,   620,    38,   154,   154,   575,   760,  1210,  1200,
     427,   513,   841,   875,   877,   770,   513,   513,   778,  1200,
     514,   513,   514,   385,   992,  1200,  1200,   513,   513,   513,
     470,   494,   951,   352,   951,   951,   168,  1200,   575,  1200,
     795,   601,   602,  1218,    54,   100,   125,   143,   147,   169,
     173,   188,   285,   336,   597,   595,  1206,   841,    38,   882,
     882,   514,   191,   513,   451,   653,   254,   636,   653,   513,
     751,   743,   513,   514,   517,  1198,   514,   382,    29,    83,
      86,    92,   120,   178,   191,   204,   401,   404,   628,   628,
    1197,  1200,  1200,   514,  1011,   721,   154,   112,   697,   174,
    1200,    38,  1200,   661,   609,  1198,   514,   613,   299,  1215,
     650,   645,   649,   124,   139,   325,  1200,    64,    72,   246,
    1011,   789,  1070,   828,   174,   746,   848,   514,   517,   437,
     145,   523,   860,   863,  1081,   396,   396,   514,   270,   294,
     734,   735,   736,   168,   739,   677,   276,   455,   679,   680,
    1200,   819,   168,  1117,  1126,  1155,   276,   489,   202,   514,
    1155,   185,   337,   368,  1142,    58,   128,   111,  1021,  1080,
    1077,   513,  1117,   514,   517,    38,  1087,  1088,  1215,   514,
    1199,  1155,   514,   513,   386,   513,   514,   517,   517,    38,
    1035,   456,  1200,   514,   517,   281,   449,   255,   280,  1001,
     813,   824,   527,   829,   513,   865,   513,   834,   578,  1198,
     865,   865,  1200,   418,   191,   451,   576,   385,   992,  1200,
    1159,   168,   773,   773,  1159,  1159,  1116,   418,  1155,  1155,
     585,   586,  1217,   788,   789,   788,   789,  1199,   527,   514,
     517,   506,   513,   554,   603,   673,   948,  1206,   948,   280,
     285,   336,   948,   948,  1081,   882,    42,   196,   276,   631,
     513,   669,  1116,   203,   175,   315,   391,   295,   640,   641,
     642,   514,  1203,     6,   752,   702,   609,   644,  1200,   514,
     697,   161,   772,   579,   931,  1198,   474,  1060,   697,  1011,
     976,   645,   609,   644,   620,   513,   651,   649,   650,   368,
     368,    72,   298,    72,   661,   827,   514,  1198,   747,   855,
     866,  1093,   516,   135,   470,   470,   735,   367,   415,   737,
     140,   740,   466,   742,   455,   677,   697,   527,  1116,   514,
     514,   456,    52,   102,   440,  1116,  1143,  1144,  1143,  1143,
     514,   165,   165,   633,  1084,   517,  1092,  1218,   514,   517,
     168,  1093,   514,   514,  1155,   513,  1155,  1046,  1137,  1139,
    1053,  1011,  1081,   830,   385,    35,  1002,   255,   174,   633,
     653,   875,   835,   834,   632,   653,   653,  1200,   669,  1116,
     418,   514,   301,   375,   341,   774,   774,   514,   514,   514,
    1200,   514,   514,   514,   517,  1205,   951,   602,   554,   604,
     605,  1206,  1206,   285,   633,   506,   633,  1206,  1206,   205,
     670,   514,   418,   124,   449,   295,   642,   295,   641,   513,
     514,   517,   584,   382,   697,   789,    38,    38,   513,  1200,
     931,   661,   649,   584,   645,   513,   647,   648,  1121,  1215,
     652,   650,   651,   298,   298,   513,   199,   831,   168,   861,
      30,   214,   918,   176,   176,   948,   367,   400,   741,   513,
     153,  1144,   367,   167,   323,   167,   323,   150,  1145,  1145,
    1145,    59,    59,   385,   514,  1118,  1088,   302,     3,   119,
     280,   285,  1089,  1090,    38,  1065,   351,  1075,   514,  1045,
     514,   995,  1116,   423,  1002,   811,   514,   639,   514,   835,
     636,   747,   747,   992,  1200,   841,    59,   992,   427,   585,
     789,   514,   517,   633,   514,   405,  1200,    63,   276,   356,
     385,   643,   643,   514,     6,   382,  1200,   769,  1011,   697,
     650,   645,   649,  1116,   514,   517,   833,   833,   651,   652,
     828,   513,   623,   140,   281,   513,   913,   915,   919,   978,
     987,   994,  1011,  1022,   841,   841,   738,  1215,  1116,   743,
      35,   102,   183,   276,   424,   633,   633,  1215,  1131,  1117,
    1117,   285,  1090,  1215,   513,   514,  1081,   124,   135,   449,
    1003,  1004,   423,   527,   747,   640,   992,   789,   513,   605,
      24,   119,   285,  1200,   697,   931,   651,   649,   650,   514,
     648,   525,   525,   652,   514,   830,   832,   579,   367,   914,
     915,   916,  1012,  1013,   517,   517,   514,  1203,  1144,   367,
     303,   385,   385,   427,   451,    81,  1116,   281,   385,   135,
     213,  1005,   747,  1155,   632,   632,   697,   652,   650,   651,
     833,   831,   514,   517,   652,   742,   514,   516,   427,   174,
     513,  1215,  1215,  1203,  1204,  1215,  1087,   514,   995,   281,
     119,   309,   457,   513,  1006,   514,   651,   652,   525,   623,
     830,  1081,   153,   916,   396,   396,     5,   744,   745,  1205,
    1206,  1218,   513,   119,   514,   457,   981,   513,   982,   652,
     579,   743,   470,   470,   514,   517,  1156,  1204,   456,  1155,
     514,   652,  1203,   176,   176,   745,  1030,   451,  1006,   514,
     309,  1006,  1081,   513,   841,   841,   514,  1215,   981,   744,
     456,   514,  1006
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   519,   520,   520,   520,   520,   520,   520,   521,   521,
     522,   522,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   524,   524,   525,
     525,   526,   526,   527,   527,   527,   528,   529,   530,   530,
     530,   531,   531,   532,   532,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   534,   534,   534,   534,   534,   534,
     535,   536,   536,   537,   537,   538,   538,   538,   538,   539,
     539,   539,   539,   539,   539,   540,   541,   542,   542,   543,
     543,   543,   543,   544,   544,   545,   545,   545,   545,   545,
     545,   546,   546,   546,   547,   547,   547,   548,   548,   548,
     548,   549,   549,   549,   549,   549,   549,   549,   549,   549,
     549,   549,   550,   550,   551,   551,   552,   552,   553,   553,
     553,   553,   554,   554,   554,   554,   555,   555,   555,   555,
     555,   555,   555,   556,   556,   556,   557,   557,   558,   559,
     559,   559,   559,   560,   560,   561,   561,   562,   562,   563,
     563,   563,   563,   563,   564,   565,   565,   566,   566,   567,
     568,   568,   568,   568,   568,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   570,   570,   571,   571,
     571,   572,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   574,   574,   575,   575,   576,   576,   577,   577,
     577,   577,   578,   579,   579,   580,   580,   581,   581,   581,
     581,   582,   582,   583,   583,   583,   583,   584,   584,   584,
     584,   585,   586,   586,   587,   588,   588,   589,   589,   589,
     589,   590,   590,   591,   591,   592,   592,   593,   593,   594,
     594,   594,   595,   595,   596,   596,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   598,
     598,   599,   599,   600,   600,   601,   601,   602,   603,   603,
     603,   603,   603,   604,   604,   605,   606,   606,   606,   606,
     606,   606,   607,   607,   607,   607,   607,   607,   607,   607,
     608,   608,   609,   609,   610,   610,   611,   611,   612,   612,
     612,   613,   613,   614,   615,   615,   616,   616,   617,   617,
     618,   618,   619,   619,   620,   620,   621,   621,   621,   621,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   623,
     623,   623,   624,   624,   625,   625,   625,   625,   626,   627,
     627,   627,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   629,   629,   630,   630,   630,   630,   630,   630,
     630,   631,   631,   632,   632,   633,   633,   634,   635,   635,
     636,   636,   636,   636,   637,   637,   638,   638,   639,   639,
     640,   640,   640,   640,   640,   641,   642,   643,   643,   643,
     643,   643,   644,   644,   645,   645,   646,   647,   647,   648,
     648,   648,   649,   649,   650,   650,   650,   651,   651,   651,
     651,   652,   652,   653,   653,   654,   655,   655,   656,   656,
     657,   657,   657,   658,   658,   659,   659,   660,   661,   661,
     661,   662,   662,   663,   664,   664,   665,   666,   666,   667,
     667,   668,   668,   669,   669,   670,   670,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   672,   672,   673,   673,   673,   673,   674,
     674,   675,   675,   676,   676,   677,   677,   678,   678,   679,
     679,   680,   680,   681,   681,   682,   683,   683,   684,   684,
     685,   685,   686,   686,   687,   687,   687,   687,   688,   689,
     689,   690,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   691,   691,   692,   693,   693,   693,   693,
     694,   694,   695,   695,   696,   696,   697,   697,   698,   698,
     699,   700,   700,   701,   701,   701,   701,   702,   703,   704,
     705,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     709,   710,   710,   710,   710,   711,   712,   712,   713,   713,
     714,   714,   715,   715,   716,   716,   717,   718,   719,   720,
     720,   721,   721,   722,   722,   723,   723,   724,   724,   725,
     725,   726,   726,   726,   726,   726,   727,   728,   728,   729,
     729,   730,   730,   730,   731,   731,   732,   732,   732,   732,
     732,   733,   733,   734,   734,   735,   736,   736,   737,   737,
     738,   739,   739,   740,   740,   741,   741,   742,   742,   743,
     743,   744,   744,   744,   745,   745,   745,   745,   746,   746,
     747,   747,   748,   748,   748,   748,   748,   748,   749,   749,
     750,   750,   751,   752,   752,   753,   754,   754,   754,   754,
     755,   756,   756,   756,   756,   756,   756,   756,   756,   756,
     756,   756,   756,   756,   756,   756,   756,   757,   758,   758,
     759,   759,   760,   760,   760,   760,   760,   760,   761,   762,
     762,   763,   764,   764,   765,   765,   766,   766,   766,   766,
     767,   767,   768,   769,   769,   770,   770,   770,   770,   770,
     771,   771,   772,   772,   773,   773,   773,   774,   774,   775,
     776,   776,   777,   777,   778,   778,   779,   779,   780,   780,
     781,   782,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   783,   783,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   785,   785,   785,
     785,   785,   786,   786,   786,   786,   786,   786,   786,   786,
     787,   787,   787,   788,   788,   789,   789,   790,   790,   791,
     791,   792,   793,   793,   793,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   795,   795,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   797,   797,   798,   798,   799,
     799,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   800,   801,   801,   802,
     802,   803,   804,   804,   805,   805,   805,   805,   805,   806,
     806,   807,   807,   807,   807,   807,   808,   808,   809,   809,
     810,   810,   810,   810,   810,   810,   810,   810,   810,   810,
     810,   810,   810,   810,   810,   810,   810,   810,   810,   810,
     810,   811,   811,   812,   812,   813,   813,   814,   814,   815,
     815,   816,   816,   817,   818,   818,   818,   819,   819,   820,
     821,   821,   822,   822,   822,   823,   823,   823,   824,   824,
     824,   824,   824,   824,   825,   825,   826,   826,   827,   827,
     828,   828,   829,   829,   830,   830,   830,   831,   831,   832,
     832,   833,   833,   834,   834,   834,   835,   835,   835,   836,
     836,   836,   836,   837,   837,   838,   838,   839,   839,   840,
     840,   841,   841,   841,   841,   842,   842,   843,   843,   844,
     844,   844,   844,   844,   845,   845,   845,   845,   845,   846,
     847,   848,   848,   848,   849,   849,   849,   850,   851,   851,
     851,   851,   852,   852,   853,   854,   854,   855,   855,   856,
     856,   857,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   857,   857,   858,   858,
     858,   858,   858,   859,   859,   860,   861,   861,   861,   862,
     862,   863,   863,   864,   864,   865,   865,   866,   867,   867,
     868,   868,   868,   869,   869,   870,   870,   871,   871,   871,
     871,   871,   871,   872,   872,   873,   873,   874,   874,   874,
     874,   875,   875,   876,   876,   877,   878,   879,   879,   880,
     880,   881,   881,   881,   882,   882,   882,   883,   884,   884,
     885,   886,   886,   886,   886,   887,   888,   888,   888,   889,
     889,   890,   890,   891,   891,   892,   892,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   894,   894,   895,   895,   896,   896,   896,   896,
     896,   896,   897,   897,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   899,   900,   900,   901,   901,   902,   902,   902,   902,
     902,   903,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   905,   905,   905,   906,
     906,   906,   906,   906,   906,   906,   907,   907,   908,   908,
     908,   908,   909,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   911,   911,   912,   913,   913,   913,   914,   914,
     915,   915,   915,   915,   915,   916,   916,   917,   917,   917,
     917,   918,   918,   918,   919,   920,   920,   921,   922,   922,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   924,   924,   925,   925,   925,   926,   926,   926,
     926,   926,   927,   927,   927,   928,   928,   929,   929,   929,
     930,   930,   930,   930,   931,   931,   931,   931,   932,   933,
     934,   934,   935,   935,   936,   936,   936,   937,   937,   937,
     937,   937,   937,   937,   938,   938,   939,   939,   939,   939,
     940,   941,   941,   941,   941,   942,   942,   943,   944,   945,
     945,   946,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   949,   950,   950,   950,   950,   950,   950,   951,   951,
     952,   953,   953,   953,   953,   954,   954,   955,   955,   956,
     956,   957,   957,   958,   958,   959,   960,   960,   960,   961,
     961,   961,   962,   962,   963,   963,   964,   964,   965,   965,
     966,   966,   967,   968,   968,   969,   969,   970,   970,   970,
     970,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   972,   973,   973,   974,   974,   974,   974,   974,   975,
     975,   975,   976,   976,   977,   977,   977,   977,   978,   979,
     979,   980,   980,   980,   980,   980,   981,   981,   982,   982,
     983,   984,   984,   984,   985,   985,   985,   986,   986,   987,
     988,   988,   989,   990,   990,   991,   991,   991,   991,   991,
     991,   991,   991,   992,   992,   993,   993,   993,   994,   995,
     995,   996,   996,   997,   998,   998,   999,  1000,  1000,  1001,
    1001,  1001,  1001,  1001,  1002,  1002,  1003,  1004,  1005,  1005,
    1005,  1005,  1005,  1006,  1007,  1008,  1009,  1009,  1009,  1009,
    1009,  1009,  1010,  1010,  1010,  1011,  1011,  1012,  1012,  1013,
    1013,  1013,  1013,  1013,  1013,  1013,  1013,  1014,  1014,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1016,  1016,  1016,  1017,
    1017,  1018,  1019,  1019,  1019,  1020,  1020,  1020,  1021,  1021,
    1021,  1022,  1022,  1023,  1023,  1024,  1024,  1024,  1024,  1024,
    1024,  1024,  1024,  1024,  1025,  1025,  1026,  1026,  1026,  1027,
    1027,  1028,  1028,  1029,  1029,  1030,  1030,  1031,  1032,  1032,
    1033,  1033,  1034,  1034,  1034,  1034,  1035,  1035,  1036,  1036,
    1036,  1036,  1036,  1036,  1037,  1037,  1038,  1038,  1039,  1040,
    1040,  1040,  1041,  1041,  1042,  1042,  1043,  1043,  1044,  1044,
    1045,  1045,  1046,  1046,  1046,  1046,  1046,  1047,  1048,  1049,
    1050,  1051,  1051,  1052,  1052,  1053,  1053,  1054,  1054,  1055,
    1056,  1056,  1056,  1056,  1057,  1057,  1058,  1058,  1059,  1059,
    1060,  1060,  1061,  1061,  1061,  1061,  1061,  1061,  1061,  1061,
    1061,  1061,  1062,  1062,  1062,  1062,  1062,  1062,  1063,  1063,
    1063,  1063,  1064,  1064,  1065,  1065,  1066,  1066,  1066,  1066,
    1066,  1067,  1067,  1067,  1067,  1068,  1068,  1069,  1069,  1070,
    1070,  1071,  1071,  1071,  1072,  1072,  1073,  1073,  1073,  1074,
    1075,  1075,  1076,  1076,  1077,  1078,  1078,  1079,  1079,  1080,
    1080,  1081,  1081,  1082,  1082,  1082,  1083,  1083,  1084,  1084,
    1085,  1086,  1086,  1087,  1087,  1088,  1088,  1088,  1089,  1089,
    1090,  1090,  1090,  1090,  1091,  1091,  1092,  1092,  1093,  1093,
    1093,  1093,  1093,  1093,  1094,  1094,  1094,  1095,  1095,  1095,
    1095,  1095,  1095,  1095,  1096,  1096,  1096,  1096,  1097,  1097,
    1098,  1098,  1099,  1099,  1099,  1099,  1099,  1099,  1099,  1099,
    1099,  1099,  1099,  1100,  1100,  1101,  1101,  1102,  1102,  1103,
    1104,  1105,  1105,  1106,  1106,  1107,  1108,  1109,  1109,  1109,
    1109,  1109,  1109,  1110,  1110,  1111,  1111,  1111,  1111,  1112,
    1113,  1113,  1113,  1114,  1114,  1114,  1114,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1115,  1115,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,
    1118,  1118,  1119,  1119,  1119,  1119,  1119,  1119,  1119,  1120,
    1120,  1120,  1121,  1121,  1121,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1123,  1123,
    1124,  1124,  1124,  1124,  1125,  1126,  1126,  1127,  1127,  1128,
    1128,  1129,  1129,  1129,  1130,  1130,  1130,  1131,  1131,  1131,
    1131,  1132,  1132,  1133,  1133,  1134,  1134,  1135,  1135,  1136,
    1136,  1137,  1138,  1138,  1138,  1139,  1140,  1140,  1141,  1141,
    1142,  1142,  1142,  1142,  1143,  1143,  1144,  1144,  1144,  1144,
    1144,  1145,  1145,  1145,  1145,  1145,  1146,  1146,  1146,  1147,
    1147,  1148,  1149,  1149,  1149,  1150,  1150,  1151,  1151,  1151,
    1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1152,
    1152,  1153,  1153,  1154,  1154,  1154,  1154,  1154,  1154,  1155,
    1155,  1156,  1156,  1157,  1157,  1157,  1158,  1158,  1159,  1159,
    1160,  1160,  1160,  1161,  1161,  1162,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,  1163,  1164,  1164,  1164,  1164,  1165,  1165,
    1166,  1167,  1167,  1167,  1167,  1167,  1168,  1168,  1168,  1169,
    1169,  1170,  1171,  1171,  1172,  1173,  1173,  1174,  1174,  1175,
    1175,  1176,  1176,  1176,  1176,  1177,  1177,  1178,  1178,  1179,
    1179,  1180,  1180,  1181,  1182,  1182,  1183,  1183,  1184,  1184,
    1185,  1185,  1185,  1185,  1185,  1186,  1186,  1186,  1186,  1186,
    1187,  1187,  1188,  1188,  1189,  1189,  1189,  1190,  1190,  1190,
    1191,  1191,  1192,  1192,  1193,  1193,  1194,  1194,  1195,  1195,
    1196,  1196,  1196,  1196,  1197,  1197,  1198,  1198,  1199,  1199,
    1200,  1201,  1202,  1203,  1203,  1204,  1204,  1204,  1204,  1204,
    1204,  1204,  1204,  1204,  1204,  1204,  1204,  1204,  1205,  1206,
    1207,  1207,  1207,  1208,  1209,  1209,  1209,  1209,  1210,  1210,
    1211,  1212,  1213,  1213,  1214,  1214,  1215,  1215,  1215,  1216,
    1216,  1216,  1217,  1217,  1217,  1217,  1218,  1218,  1218,  1218,
    1218,  1219,  1219,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     2,     5,     1,     3,     3,     3,
       3,     1,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     1,     3,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     5,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     1,
       2,     3,     2,     1,     1,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     4,     6,     4,     6,    10,
      13,     4,     6,     4,    10,    13,     4,     6,     4,     6,
       5,     7,    11,    14,     5,     7,     1,     3,     4,     4,
       4,     3,     2,     5,     3,     6,     4,     6,     6,     5,
       7,     6,     6,     5,     5,     5,     5,     9,     4,     5,
       7,     6,     4,     8,     4,     2,     4,     3,     6,     4,
       3,     3,     3,     2,     2,     3,     4,     4,     3,     3,
       3,     3,     3,     3,     4,     4,     3,     2,     3,     2,
       2,     3,     4,     3,     2,     2,     3,     4,     4,     4,
       5,     1,     3,     2,     2,     0,     2,     0,     1,     1,
       1,     3,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     1,     2,     1,     3,     2,     3,     6,     6,    10,
       1,     2,     1,     3,     4,     1,     3,     4,     6,     4,
       8,     2,     2,    11,     9,     1,     1,     1,     0,     1,
       1,     1,     1,     3,     2,     0,     1,     1,     3,     3,
       1,     1,     3,     3,     3,     3,     4,     3,     2,     1,
       0,     3,     0,     1,     0,     1,     3,     2,     1,     1,
       1,     3,     0,     1,     3,     1,    13,    16,    12,    15,
      14,    17,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     6,     2,     4,     2,     2,     1,     0,
       2,     2,     1,     0,     2,     0,     3,     1,     1,     2,
       2,     1,     4,     4,     5,     2,     5,     7,     5,     2,
       3,     0,     1,     2,     1,     2,     2,     2,     3,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     9,     3,     9,     4,    10,
      11,     2,     0,     3,     0,     1,     3,     1,     4,     0,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       3,     3,     4,     0,     1,     0,     6,     1,     3,     3,
       3,     5,     2,     0,     2,     2,     0,     3,     4,     4,
       0,     2,     0,     4,     0,     3,     8,    11,     1,     3,
       1,     1,     3,     6,     8,     7,    10,     6,     2,     3,
       0,     8,    11,     5,     1,     0,     6,     5,     8,     4,
       6,     1,     0,     3,     0,     1,     2,     2,     2,     1,
       2,     3,     1,     2,     2,     2,     2,     3,     3,     3,
       1,     3,     1,     1,     0,     1,     2,     2,     1,     1,
       3,     6,    10,     1,     0,     1,     2,     2,     0,     2,
       2,     1,     0,     1,     0,     7,     2,     0,     3,     5,
       5,     8,     2,     0,     2,     2,     2,     1,     5,     2,
       0,     2,     6,     6,     6,    10,     6,     6,     6,     9,
       9,     6,     6,     9,     6,     7,     2,     2,     2,     2,
       1,     2,     1,     0,     7,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,    13,     2,     0,     2,     2,     1,     0,     5,     4,
       4,    11,    14,    12,    15,    11,     2,     1,     4,     0,
       8,    11,     1,     1,     7,     9,     8,    10,     8,     4,
       0,     5,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     1,     8,     1,     1,    17,
      21,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     2,     0,     1,     2,     4,     1,     1,     1,     1,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     2,     0,
       0,     2,     2,     1,     2,     2,     2,     2,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     6,     5,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     7,     5,     8,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     8,
       3,     0,    13,     1,     3,     5,     5,     3,     6,     2,
       1,     0,     2,     0,     2,     4,     0,     1,     0,     6,
       8,     8,     1,     3,     5,     5,     7,     9,     7,     9,
       5,     6,     6,     4,     6,     4,     6,     8,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     2,     2,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     2,     3,     1,
       3,     5,     2,     2,     0,     6,     6,     6,     6,     6,
       6,     6,     6,     8,     9,     8,     6,     6,     9,     9,
       9,     7,    10,     1,     1,     8,     8,     8,     8,     8,
       8,     8,     9,     8,     8,     2,     0,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     8,     8,    11,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     2,     1,     3,     1,     3,
       1,     2,     2,     4,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     5,     5,     5,     5,
       5,     1,     3,     1,     2,     3,     0,     5,     7,     6,
       9,     3,     1,     2,     1,     1,     1,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,     1,     1,     1,    16,    19,     1,     0,     2,     0,
       1,     3,     4,     5,     2,     2,     4,     4,     0,     1,
       3,     2,     0,     1,     1,     0,     2,     2,     0,     9,
      12,     7,     7,     2,     0,     3,     2,     1,     3,     1,
       3,     2,     1,     1,     2,     3,     2,     1,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     4,     5,     1,     3,     3,     1,     3,     3,
       5,     6,     1,     3,     2,     1,     3,     1,     0,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     1,     2,     2,     2,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     3,     2,     1,     4,     0,     3,
       0,     1,     1,     3,     5,     2,     0,     2,     1,     3,
       5,     5,     5,     1,     2,     1,     0,     4,     6,     4,
       6,     4,     6,     4,     6,     4,     6,     3,     5,     5,
       5,     1,     3,     1,     3,     2,     2,     1,     2,     1,
       2,    11,    10,    10,     2,     2,     0,     9,     2,     0,
      10,    11,    11,     5,     5,     8,     5,     5,     5,     1,
       1,     1,     1,     3,     0,     5,     5,     6,     6,     6,
       6,     6,     8,     8,     6,     6,     7,     9,     9,     8,
      10,     6,     6,     6,     6,     6,     6,     6,     8,     6,
       8,     6,     8,     7,     9,     6,     8,     7,     9,     8,
      10,     8,    10,     9,    11,     8,    10,     9,    11,     8,
       8,     7,     6,     6,     6,     6,     8,     8,     8,     8,
       6,     9,     1,     0,     2,     0,     8,     8,     8,    10,
       9,     8,     1,     0,     6,     6,     6,     6,     6,     6,
       6,     9,     9,     6,     6,     6,     8,     6,     8,     8,
       8,     8,     6,     8,     6,     8,     7,     9,     7,     9,
       6,     7,     1,     3,     3,     3,     1,     1,     1,     1,
       1,     7,     6,     6,     6,     6,     6,     6,     7,     7,
       6,     9,     9,     6,     6,     6,     6,     6,     6,     8,
       8,     8,     6,     7,     6,     6,     4,     7,     6,     4,
       4,     4,     3,     4,     3,     1,     1,     3,     5,     5,
       5,     5,     8,     5,     5,     6,     7,     7,     7,     4,
       4,     5,     4,     6,    13,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     0,     3,     2,     0,     2,     2,     2,
       3,     3,     3,     3,     2,     3,     2,     5,     4,     3,
       3,     3,     3,     3,     1,     1,     0,     3,     2,     2,
       1,     2,     1,     3,     2,     1,     0,     2,     3,     0,
       9,    11,    12,    14,     3,     4,     4,     0,     2,     5,
       1,     0,     1,     2,     3,     3,     3,     1,     2,     1,
       1,     1,     1,     1,     1,     0,     5,     4,     6,     6,
       4,     3,     5,     7,     9,     1,     3,     1,     5,     4,
       4,     6,     4,     6,     6,     5,     7,     9,     6,     1,
       0,     6,    11,    11,    11,    13,     9,    11,     1,     1,
      10,     4,     6,     2,     5,     2,     0,     6,     5,     3,
       5,     1,     3,     1,     1,     2,     1,     1,     1,     1,
       1,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       3,     0,     2,     1,     3,     1,     0,     2,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     3,     0,     1,     1,     1,     1,     1,     3,
       9,    12,     3,     0,     2,     3,     2,     3,     7,     1,
       3,     1,     4,     4,     7,     2,     1,     1,     1,     3,
       2,     8,     5,     0,     4,     3,     0,     2,     0,     7,
       2,     0,     5,     3,     0,     2,     2,     2,     3,     1,
       3,     1,     2,     1,     0,     1,     2,     0,     8,     1,
       3,     3,     5,     2,     1,     3,     9,     1,     2,     5,
       5,     6,     6,     7,     2,     0,     3,     1,     2,     5,
       5,     8,     3,     4,     7,     1,     0,     3,     2,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       9,     1,     2,     4,     4,     4,     2,     2,     3,     1,
       3,     9,     1,     2,     0,     7,     7,     0,    10,     6,
       0,     1,     0,     2,     0,     3,     3,     4,     4,     4,
       4,     3,     2,     1,     1,     0,     1,     1,     0,     1,
       5,     1,     0,     1,     1,     1,     0,     3,     1,     3,
       4,     3,     2,     2,     1,     1,     1,     0,     2,     4,
       5,     6,     4,     5,     2,     3,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     4,     5,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       1,     4,     3,     4,     5,     4,     5,     4,     5,     2,
       4,     1,     1,     0,     2,     0,     1,     4,     5,     4,
       0,     2,     2,     2,     1,     1,     0,     5,     2,     1,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     6,
       4,     0,     2,     6,     2,     1,     3,     4,     0,     2,
       0,     2,     0,     2,     4,     0,     1,     0,     1,     3,
       3,     7,    12,     1,     3,     2,     3,     3,     1,     2,
       2,     2,     2,     1,     1,     3,     3,     2,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     4,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     4,     1,     2,     2,     1,
       3,     3,     2,     1,     0,     5,     2,     5,     2,     1,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       3,     3,     5,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     2,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     3,     4,     4,     6,     3,     3,     4,     3,
       4,     4,     5,     4,     5,     1,     1,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     5,     6,     3,     4,     1,     1,
       2,     4,     1,     1,     1,     2,     2,     2,     2,     1,
       1,     4,     3,     5,     6,     8,     6,     6,     4,     4,
       3,     1,     1,     1,     1,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     1,     6,     4,     4,     6,     4,     4,     4,     4,
       4,     6,     5,     5,     5,     4,     6,     4,     4,     4,
       4,     5,     7,     7,     9,     5,     4,     6,     5,     7,
       7,     8,     4,     7,     4,     6,     6,     4,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     1,     2,     0,     2,     2,     0,     2,     3,     3,
       4,     2,     2,     5,     0,     5,     0,     2,     0,     1,
       3,     3,     2,     2,     0,     6,     1,     0,     3,     0,
       3,     3,     3,     0,     1,     4,     2,     2,     2,     2,
       2,     3,     2,     2,     3,     0,     4,     3,     5,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     3,     1,     0,     1,     3,
       3,     3,     2,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     7,     5,
       3,     5,     5,     3,     3,     5,     3,     2,     1,     1,
       3,     5,     1,     2,     4,     2,     0,     1,     0,     1,
       2,     2,     2,     3,     5,     1,     0,     1,     2,     0,
       2,     1,     0,     2,     3,     0,     2,     0,     3,     0,
       1,     2,     2,     2,     2,     3,     2,     3,     2,     0,
       1,     3,     3,     3,     3,     3,     0,     3,     3,     0,
       1,     3,     7,     7,     3,     0,     1,     0,     1,     3,
       3,     2,     1,     1,     1,     3,     1,     2,     1,     3,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     6,     2,     3,     5,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     3,
      10,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, core_yyscan_t yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* parse_toplevel: stmtmulti  */
#line 887 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 29092 "gram.c"
    break;

  case 3: /* parse_toplevel: MODE_TYPE_NAME Typename  */
#line 892 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 29100 "gram.c"
    break;

  case 4: /* parse_toplevel: MODE_PLPGSQL_EXPR PLpgSQL_Expr  */
#line 896 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 29109 "gram.c"
    break;

  case 5: /* parse_toplevel: MODE_PLPGSQL_ASSIGN1 PLAssignStmt  */
#line 901 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29121 "gram.c"
    break;

  case 6: /* parse_toplevel: MODE_PLPGSQL_ASSIGN2 PLAssignStmt  */
#line 909 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29133 "gram.c"
    break;

  case 7: /* parse_toplevel: MODE_PLPGSQL_ASSIGN3 PLAssignStmt  */
#line 917 "gram.y"
                        {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29145 "gram.c"
    break;

  case 8: /* stmtmulti: stmtmulti ';' toplevel_stmt  */
#line 937 "gram.y"
                                {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 29161 "gram.c"
    break;

  case 9: /* stmtmulti: toplevel_stmt  */
#line 949 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 29172 "gram.c"
    break;

  case 136: /* stmt: %empty  */
#line 1092 "gram.y"
                                { (yyval.node) = NULL; }
#line 29178 "gram.c"
    break;

  case 137: /* opt_single_name: ColId  */
#line 1099 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 29184 "gram.c"
    break;

  case 138: /* opt_single_name: %empty  */
#line 1100 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 29190 "gram.c"
    break;

  case 139: /* opt_qualified_name: any_name  */
#line 1104 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 29196 "gram.c"
    break;

  case 140: /* opt_qualified_name: %empty  */
#line 1105 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 29202 "gram.c"
    break;

  case 141: /* opt_concurrently: CONCURRENTLY  */
#line 1109 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 29208 "gram.c"
    break;

  case 142: /* opt_concurrently: %empty  */
#line 1110 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 29214 "gram.c"
    break;

  case 143: /* opt_drop_behavior: CASCADE  */
#line 1114 "gram.y"
                                                                                { (yyval.dbehavior) = DROP_CASCADE; }
#line 29220 "gram.c"
    break;

  case 144: /* opt_drop_behavior: RESTRICT  */
#line 1115 "gram.y"
                                                                                { (yyval.dbehavior) = DROP_RESTRICT; }
#line 29226 "gram.c"
    break;

  case 145: /* opt_drop_behavior: %empty  */
#line 1116 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 29232 "gram.c"
    break;

  case 146: /* CallStmt: CALL func_application  */
#line 1126 "gram.y"
                                {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 29243 "gram.c"
    break;

  case 147: /* CreateRoleStmt: CREATE ROLE RoleId opt_with OptRoleList  */
#line 1142 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29256 "gram.c"
    break;

  case 151: /* OptRoleList: OptRoleList CreateOptRoleElem  */
#line 1164 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29262 "gram.c"
    break;

  case 152: /* OptRoleList: %empty  */
#line 1165 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 29268 "gram.c"
    break;

  case 153: /* AlterOptRoleList: AlterOptRoleList AlterOptRoleElem  */
#line 1169 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29274 "gram.c"
    break;

  case 154: /* AlterOptRoleList: %empty  */
#line 1170 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 29280 "gram.c"
    break;

  case 155: /* AlterOptRoleElem: PASSWORD Sconst  */
#line 1175 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29289 "gram.c"
    break;

  case 156: /* AlterOptRoleElem: PASSWORD NULL_P  */
#line 1180 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 29297 "gram.c"
    break;

  case 157: /* AlterOptRoleElem: ENCRYPTED PASSWORD Sconst  */
#line 1184 "gram.y"
                                {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29311 "gram.c"
    break;

  case 158: /* AlterOptRoleElem: UNENCRYPTED PASSWORD Sconst  */
#line 1194 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 29323 "gram.c"
    break;

  case 159: /* AlterOptRoleElem: INHERIT  */
#line 1202 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 29331 "gram.c"
    break;

  case 160: /* AlterOptRoleElem: CONNECTION LIMIT SignedIconst  */
#line 1206 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 29339 "gram.c"
    break;

  case 161: /* AlterOptRoleElem: VALID UNTIL Sconst  */
#line 1210 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29347 "gram.c"
    break;

  case 162: /* AlterOptRoleElem: USER role_list  */
#line 1215 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29355 "gram.c"
    break;

  case 163: /* AlterOptRoleElem: IDENT  */
#line 1219 "gram.y"
                                {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 29404 "gram.c"
    break;

  case 164: /* CreateOptRoleElem: AlterOptRoleElem  */
#line 1266 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 29410 "gram.c"
    break;

  case 165: /* CreateOptRoleElem: SYSID Iconst  */
#line 1269 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 29418 "gram.c"
    break;

  case 166: /* CreateOptRoleElem: ADMIN role_list  */
#line 1273 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29426 "gram.c"
    break;

  case 167: /* CreateOptRoleElem: ROLE role_list  */
#line 1277 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29434 "gram.c"
    break;

  case 168: /* CreateOptRoleElem: IN_P ROLE role_list  */
#line 1281 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29442 "gram.c"
    break;

  case 169: /* CreateOptRoleElem: IN_P GROUP_P role_list  */
#line 1285 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29450 "gram.c"
    break;

  case 170: /* CreateUserStmt: CREATE USER RoleId opt_with OptRoleList  */
#line 1299 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29463 "gram.c"
    break;

  case 171: /* AlterRoleStmt: ALTER ROLE RoleSpec opt_with AlterOptRoleList  */
#line 1318 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29476 "gram.c"
    break;

  case 172: /* AlterRoleStmt: ALTER USER RoleSpec opt_with AlterOptRoleList  */
#line 1327 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29489 "gram.c"
    break;

  case 173: /* opt_in_database: %empty  */
#line 1338 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 29495 "gram.c"
    break;

  case 174: /* opt_in_database: IN_P DATABASE name  */
#line 1339 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 29501 "gram.c"
    break;

  case 175: /* AlterRoleSetStmt: ALTER ROLE RoleSpec opt_in_database SetResetClause  */
#line 1344 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29514 "gram.c"
    break;

  case 176: /* AlterRoleSetStmt: ALTER ROLE ALL opt_in_database SetResetClause  */
#line 1353 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29527 "gram.c"
    break;

  case 177: /* AlterRoleSetStmt: ALTER USER RoleSpec opt_in_database SetResetClause  */
#line 1362 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29540 "gram.c"
    break;

  case 178: /* AlterRoleSetStmt: ALTER USER ALL opt_in_database SetResetClause  */
#line 1371 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29553 "gram.c"
    break;

  case 179: /* DropRoleStmt: DROP ROLE role_list  */
#line 1393 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29565 "gram.c"
    break;

  case 180: /* DropRoleStmt: DROP ROLE IF_P EXISTS role_list  */
#line 1401 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29577 "gram.c"
    break;

  case 181: /* DropRoleStmt: DROP USER role_list  */
#line 1409 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29589 "gram.c"
    break;

  case 182: /* DropRoleStmt: DROP USER IF_P EXISTS role_list  */
#line 1417 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29601 "gram.c"
    break;

  case 183: /* DropRoleStmt: DROP GROUP_P role_list  */
#line 1425 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29613 "gram.c"
    break;

  case 184: /* DropRoleStmt: DROP GROUP_P IF_P EXISTS role_list  */
#line 1433 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29625 "gram.c"
    break;

  case 185: /* CreateGroupStmt: CREATE GROUP_P RoleId opt_with OptRoleList  */
#line 1451 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29638 "gram.c"
    break;

  case 186: /* AlterGroupStmt: ALTER GROUP_P RoleSpec add_drop USER role_list  */
#line 1470 "gram.y"
                                {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 29652 "gram.c"
    break;

  case 187: /* add_drop: ADD_P  */
#line 1481 "gram.y"
                                                                                        { (yyval.ival) = +1; }
#line 29658 "gram.c"
    break;

  case 188: /* add_drop: DROP  */
#line 1482 "gram.y"
                                                                                                { (yyval.ival) = -1; }
#line 29664 "gram.c"
    break;

  case 189: /* CreateSchemaStmt: CREATE SCHEMA opt_single_name AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1494 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29679 "gram.c"
    break;

  case 190: /* CreateSchemaStmt: CREATE SCHEMA ColId OptSchemaEltList  */
#line 1505 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29694 "gram.c"
    break;

  case 191: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS opt_single_name AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1516 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29714 "gram.c"
    break;

  case 192: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS ColId OptSchemaEltList  */
#line 1532 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29734 "gram.c"
    break;

  case 193: /* OptSchemaEltList: OptSchemaEltList schema_stmt  */
#line 1551 "gram.y"
                                {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 29744 "gram.c"
    break;

  case 194: /* OptSchemaEltList: %empty  */
#line 1557 "gram.y"
                                { (yyval.list) = NIL; }
#line 29750 "gram.c"
    break;

  case 201: /* VariableSetStmt: SET set_rest  */
#line 1585 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29761 "gram.c"
    break;

  case 202: /* VariableSetStmt: SET LOCAL set_rest  */
#line 1592 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 29772 "gram.c"
    break;

  case 203: /* VariableSetStmt: SET SESSION set_rest  */
#line 1599 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29783 "gram.c"
    break;

  case 204: /* set_rest: TRANSACTION transaction_mode_list  */
#line 1609 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29796 "gram.c"
    break;

  case 205: /* set_rest: SESSION CHARACTERISTICS AS TRANSACTION transaction_mode_list  */
#line 1618 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29809 "gram.c"
    break;

  case 207: /* generic_set: var_name TO var_list  */
#line 1631 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29822 "gram.c"
    break;

  case 208: /* generic_set: var_name '=' var_list  */
#line 1640 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29835 "gram.c"
    break;

  case 209: /* generic_set: var_name TO DEFAULT  */
#line 1649 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29847 "gram.c"
    break;

  case 210: /* generic_set: var_name '=' DEFAULT  */
#line 1657 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29859 "gram.c"
    break;

  case 211: /* set_rest_more: generic_set  */
#line 1667 "gram.y"
                                                                                        {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 29865 "gram.c"
    break;

  case 212: /* set_rest_more: var_name FROM CURRENT_P  */
#line 1669 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29877 "gram.c"
    break;

  case 213: /* set_rest_more: TIME ZONE zone_value  */
#line 1678 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29893 "gram.c"
    break;

  case 214: /* set_rest_more: CATALOG_P Sconst  */
#line 1690 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 29905 "gram.c"
    break;

  case 215: /* set_rest_more: SCHEMA Sconst  */
#line 1698 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29918 "gram.c"
    break;

  case 216: /* set_rest_more: NAMES opt_encoding  */
#line 1707 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29934 "gram.c"
    break;

  case 217: /* set_rest_more: ROLE NonReservedWord_or_Sconst  */
#line 1719 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29947 "gram.c"
    break;

  case 218: /* set_rest_more: SESSION AUTHORIZATION NonReservedWord_or_Sconst  */
#line 1728 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29960 "gram.c"
    break;

  case 219: /* set_rest_more: SESSION AUTHORIZATION DEFAULT  */
#line 1737 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29972 "gram.c"
    break;

  case 220: /* set_rest_more: XML_P OPTION document_or_content  */
#line 1745 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29985 "gram.c"
    break;

  case 221: /* set_rest_more: TRANSACTION SNAPSHOT Sconst  */
#line 1755 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29998 "gram.c"
    break;

  case 222: /* var_name: ColId  */
#line 1765 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30004 "gram.c"
    break;

  case 223: /* var_name: var_name '.' ColId  */
#line 1767 "gram.y"
                                { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 30010 "gram.c"
    break;

  case 224: /* var_list: var_value  */
#line 1770 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30016 "gram.c"
    break;

  case 225: /* var_list: var_list ',' var_value  */
#line 1771 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30022 "gram.c"
    break;

  case 226: /* var_value: opt_boolean_or_string  */
#line 1775 "gram.y"
                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 30028 "gram.c"
    break;

  case 227: /* var_value: NumericOnly  */
#line 1777 "gram.y"
                                { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 30034 "gram.c"
    break;

  case 228: /* iso_level: READ UNCOMMITTED  */
#line 1780 "gram.y"
                                                                                { (yyval.str) = "read uncommitted"; }
#line 30040 "gram.c"
    break;

  case 229: /* iso_level: READ COMMITTED  */
#line 1781 "gram.y"
                                                                                        { (yyval.str) = "read committed"; }
#line 30046 "gram.c"
    break;

  case 230: /* iso_level: REPEATABLE READ  */
#line 1782 "gram.y"
                                                                                        { (yyval.str) = "repeatable read"; }
#line 30052 "gram.c"
    break;

  case 231: /* iso_level: SERIALIZABLE  */
#line 1783 "gram.y"
                                                                                        { (yyval.str) = "serializable"; }
#line 30058 "gram.c"
    break;

  case 232: /* opt_boolean_or_string: TRUE_P  */
#line 1787 "gram.y"
                                                                                                { (yyval.str) = "true"; }
#line 30064 "gram.c"
    break;

  case 233: /* opt_boolean_or_string: FALSE_P  */
#line 1788 "gram.y"
                                                                                                { (yyval.str) = "false"; }
#line 30070 "gram.c"
    break;

  case 234: /* opt_boolean_or_string: ON  */
#line 1789 "gram.y"
                                                                                                { (yyval.str) = "on"; }
#line 30076 "gram.c"
    break;

  case 235: /* opt_boolean_or_string: NonReservedWord_or_Sconst  */
#line 1795 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30082 "gram.c"
    break;

  case 236: /* zone_value: Sconst  */
#line 1808 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 30090 "gram.c"
    break;

  case 237: /* zone_value: IDENT  */
#line 1812 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 30098 "gram.c"
    break;

  case 238: /* zone_value: ConstInterval Sconst opt_interval  */
#line 1816 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const	   *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 30119 "gram.c"
    break;

  case 239: /* zone_value: ConstInterval '(' Iconst ')' Sconst  */
#line 1833 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 30131 "gram.c"
    break;

  case 240: /* zone_value: NumericOnly  */
#line 1840 "gram.y"
                                                                                        { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 30137 "gram.c"
    break;

  case 241: /* zone_value: DEFAULT  */
#line 1841 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 30143 "gram.c"
    break;

  case 242: /* zone_value: LOCAL  */
#line 1842 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 30149 "gram.c"
    break;

  case 243: /* opt_encoding: Sconst  */
#line 1846 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30155 "gram.c"
    break;

  case 244: /* opt_encoding: DEFAULT  */
#line 1847 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 30161 "gram.c"
    break;

  case 245: /* opt_encoding: %empty  */
#line 1848 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 30167 "gram.c"
    break;

  case 246: /* NonReservedWord_or_Sconst: NonReservedWord  */
#line 1852 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 30173 "gram.c"
    break;

  case 247: /* NonReservedWord_or_Sconst: Sconst  */
#line 1853 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30179 "gram.c"
    break;

  case 248: /* VariableResetStmt: RESET reset_rest  */
#line 1857 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 30185 "gram.c"
    break;

  case 249: /* reset_rest: generic_reset  */
#line 1861 "gram.y"
                                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30191 "gram.c"
    break;

  case 250: /* reset_rest: TIME ZONE  */
#line 1863 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 30203 "gram.c"
    break;

  case 251: /* reset_rest: TRANSACTION ISOLATION LEVEL  */
#line 1871 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 30215 "gram.c"
    break;

  case 252: /* reset_rest: SESSION AUTHORIZATION  */
#line 1879 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 30227 "gram.c"
    break;

  case 253: /* generic_reset: var_name  */
#line 1890 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 30239 "gram.c"
    break;

  case 254: /* generic_reset: ALL  */
#line 1898 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 30250 "gram.c"
    break;

  case 255: /* SetResetClause: SET set_rest  */
#line 1908 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30256 "gram.c"
    break;

  case 256: /* SetResetClause: VariableResetStmt  */
#line 1909 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 30262 "gram.c"
    break;

  case 257: /* FunctionSetResetClause: SET set_rest_more  */
#line 1914 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30268 "gram.c"
    break;

  case 258: /* FunctionSetResetClause: VariableResetStmt  */
#line 1915 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 30274 "gram.c"
    break;

  case 259: /* VariableShowStmt: SHOW var_name  */
#line 1921 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30285 "gram.c"
    break;

  case 260: /* VariableShowStmt: SHOW TIME ZONE  */
#line 1928 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 30296 "gram.c"
    break;

  case 261: /* VariableShowStmt: SHOW TRANSACTION ISOLATION LEVEL  */
#line 1935 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 30307 "gram.c"
    break;

  case 262: /* VariableShowStmt: SHOW SESSION AUTHORIZATION  */
#line 1942 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 30318 "gram.c"
    break;

  case 263: /* VariableShowStmt: SHOW ALL  */
#line 1949 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 30329 "gram.c"
    break;

  case 264: /* ConstraintsSetStmt: SET CONSTRAINTS constraints_set_list constraints_set_mode  */
#line 1960 "gram.y"
                                {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30341 "gram.c"
    break;

  case 265: /* constraints_set_list: ALL  */
#line 1970 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 30347 "gram.c"
    break;

  case 266: /* constraints_set_list: qualified_name_list  */
#line 1971 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 30353 "gram.c"
    break;

  case 267: /* constraints_set_mode: DEFERRED  */
#line 1975 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 30359 "gram.c"
    break;

  case 268: /* constraints_set_mode: IMMEDIATE  */
#line 1976 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 30365 "gram.c"
    break;

  case 269: /* CheckPointStmt: CHECKPOINT  */
#line 1985 "gram.y"
                                {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 30375 "gram.c"
    break;

  case 270: /* DiscardStmt: DISCARD ALL  */
#line 2001 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 30386 "gram.c"
    break;

  case 271: /* DiscardStmt: DISCARD TEMP  */
#line 2008 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30397 "gram.c"
    break;

  case 272: /* DiscardStmt: DISCARD TEMPORARY  */
#line 2015 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30408 "gram.c"
    break;

  case 273: /* DiscardStmt: DISCARD PLANS  */
#line 2022 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 30419 "gram.c"
    break;

  case 274: /* DiscardStmt: DISCARD SEQUENCES  */
#line 2029 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 30430 "gram.c"
    break;

  case 275: /* AlterTableStmt: ALTER TABLE relation_expr alter_table_cmds  */
#line 2049 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30444 "gram.c"
    break;

  case 276: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2059 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30458 "gram.c"
    break;

  case 277: /* AlterTableStmt: ALTER TABLE relation_expr partition_cmd  */
#line 2069 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30472 "gram.c"
    break;

  case 278: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr partition_cmd  */
#line 2079 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30486 "gram.c"
    break;

  case 279: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2089 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30502 "gram.c"
    break;

  case 280: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2101 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30518 "gram.c"
    break;

  case 281: /* AlterTableStmt: ALTER INDEX qualified_name alter_table_cmds  */
#line 2113 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30532 "gram.c"
    break;

  case 282: /* AlterTableStmt: ALTER INDEX IF_P EXISTS qualified_name alter_table_cmds  */
#line 2123 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30546 "gram.c"
    break;

  case 283: /* AlterTableStmt: ALTER INDEX qualified_name index_partition_cmd  */
#line 2133 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30560 "gram.c"
    break;

  case 284: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2143 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30576 "gram.c"
    break;

  case 285: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2155 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30592 "gram.c"
    break;

  case 286: /* AlterTableStmt: ALTER SEQUENCE qualified_name alter_table_cmds  */
#line 2167 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30606 "gram.c"
    break;

  case 287: /* AlterTableStmt: ALTER SEQUENCE IF_P EXISTS qualified_name alter_table_cmds  */
#line 2177 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30620 "gram.c"
    break;

  case 288: /* AlterTableStmt: ALTER VIEW qualified_name alter_table_cmds  */
#line 2187 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30634 "gram.c"
    break;

  case 289: /* AlterTableStmt: ALTER VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2197 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30648 "gram.c"
    break;

  case 290: /* AlterTableStmt: ALTER MATERIALIZED VIEW qualified_name alter_table_cmds  */
#line 2207 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30662 "gram.c"
    break;

  case 291: /* AlterTableStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 2217 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30676 "gram.c"
    break;

  case 292: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 2227 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30692 "gram.c"
    break;

  case 293: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 2239 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30708 "gram.c"
    break;

  case 294: /* AlterTableStmt: ALTER FOREIGN TABLE relation_expr alter_table_cmds  */
#line 2251 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30722 "gram.c"
    break;

  case 295: /* AlterTableStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 2261 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30736 "gram.c"
    break;

  case 296: /* alter_table_cmds: alter_table_cmd  */
#line 2273 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30742 "gram.c"
    break;

  case 297: /* alter_table_cmds: alter_table_cmds ',' alter_table_cmd  */
#line 2274 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30748 "gram.c"
    break;

  case 298: /* partition_cmd: ATTACH PARTITION qualified_name PartitionBoundSpec  */
#line 2280 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30765 "gram.c"
    break;

  case 299: /* partition_cmd: DETACH PARTITION qualified_name opt_concurrently  */
#line 2294 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30782 "gram.c"
    break;

  case 300: /* partition_cmd: DETACH PARTITION qualified_name FINALIZE  */
#line 2307 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 30798 "gram.c"
    break;

  case 301: /* index_partition_cmd: ATTACH PARTITION qualified_name  */
#line 2323 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30815 "gram.c"
    break;

  case 302: /* alter_table_cmd: ADD_P columnDef  */
#line 2340 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30828 "gram.c"
    break;

  case 303: /* alter_table_cmd: ADD_P IF_P NOT EXISTS columnDef  */
#line 2350 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30841 "gram.c"
    break;

  case 304: /* alter_table_cmd: ADD_P COLUMN columnDef  */
#line 2360 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30854 "gram.c"
    break;

  case 305: /* alter_table_cmd: ADD_P COLUMN IF_P NOT EXISTS columnDef  */
#line 2370 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30867 "gram.c"
    break;

  case 306: /* alter_table_cmd: ALTER opt_column ColId alter_column_default  */
#line 2380 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30880 "gram.c"
    break;

  case 307: /* alter_table_cmd: ALTER opt_column ColId DROP NOT NULL_P  */
#line 2390 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30892 "gram.c"
    break;

  case 308: /* alter_table_cmd: ALTER opt_column ColId SET NOT NULL_P  */
#line 2399 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30904 "gram.c"
    break;

  case 309: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION  */
#line 2408 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 30916 "gram.c"
    break;

  case 310: /* alter_table_cmd: ALTER opt_column ColId DROP EXPRESSION IF_P EXISTS  */
#line 2417 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30929 "gram.c"
    break;

  case 311: /* alter_table_cmd: ALTER opt_column ColId SET STATISTICS SignedIconst  */
#line 2427 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30942 "gram.c"
    break;

  case 312: /* alter_table_cmd: ALTER opt_column Iconst SET STATISTICS SignedIconst  */
#line 2437 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30961 "gram.c"
    break;

  case 313: /* alter_table_cmd: ALTER opt_column ColId SET reloptions  */
#line 2453 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30974 "gram.c"
    break;

  case 314: /* alter_table_cmd: ALTER opt_column ColId RESET reloptions  */
#line 2463 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30987 "gram.c"
    break;

  case 315: /* alter_table_cmd: ALTER opt_column ColId SET column_storage  */
#line 2473 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31000 "gram.c"
    break;

  case 316: /* alter_table_cmd: ALTER opt_column ColId SET column_compression  */
#line 2483 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31013 "gram.c"
    break;

  case 317: /* alter_table_cmd: ALTER opt_column ColId ADD_P GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 2493 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 31033 "gram.c"
    break;

  case 318: /* alter_table_cmd: ALTER opt_column ColId alter_identity_column_option_list  */
#line 2510 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31046 "gram.c"
    break;

  case 319: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P  */
#line 2520 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31059 "gram.c"
    break;

  case 320: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P IF_P EXISTS  */
#line 2530 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31072 "gram.c"
    break;

  case 321: /* alter_table_cmd: DROP opt_column IF_P EXISTS ColId opt_drop_behavior  */
#line 2540 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31086 "gram.c"
    break;

  case 322: /* alter_table_cmd: DROP opt_column ColId opt_drop_behavior  */
#line 2551 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31100 "gram.c"
    break;

  case 323: /* alter_table_cmd: ALTER opt_column ColId opt_set_data TYPE_P Typename opt_collate_clause alter_using  */
#line 2565 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31119 "gram.c"
    break;

  case 324: /* alter_table_cmd: ALTER opt_column ColId alter_generic_options  */
#line 2581 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31132 "gram.c"
    break;

  case 325: /* alter_table_cmd: ADD_P TableConstraint  */
#line 2591 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31144 "gram.c"
    break;

  case 326: /* alter_table_cmd: ALTER CONSTRAINT name ConstraintAttributeSpec  */
#line 2600 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 31163 "gram.c"
    break;

  case 327: /* alter_table_cmd: VALIDATE CONSTRAINT name  */
#line 2616 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31175 "gram.c"
    break;

  case 328: /* alter_table_cmd: DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 2625 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31189 "gram.c"
    break;

  case 329: /* alter_table_cmd: DROP CONSTRAINT name opt_drop_behavior  */
#line 2636 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31203 "gram.c"
    break;

  case 330: /* alter_table_cmd: SET WITHOUT OIDS  */
#line 2647 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 31214 "gram.c"
    break;

  case 331: /* alter_table_cmd: CLUSTER ON name  */
#line 2655 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31226 "gram.c"
    break;

  case 332: /* alter_table_cmd: SET WITHOUT CLUSTER  */
#line 2664 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31238 "gram.c"
    break;

  case 333: /* alter_table_cmd: SET LOGGED  */
#line 2673 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 31249 "gram.c"
    break;

  case 334: /* alter_table_cmd: SET UNLOGGED  */
#line 2681 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 31260 "gram.c"
    break;

  case 335: /* alter_table_cmd: ENABLE_P TRIGGER name  */
#line 2689 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31272 "gram.c"
    break;

  case 336: /* alter_table_cmd: ENABLE_P ALWAYS TRIGGER name  */
#line 2698 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31284 "gram.c"
    break;

  case 337: /* alter_table_cmd: ENABLE_P REPLICA TRIGGER name  */
#line 2707 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31296 "gram.c"
    break;

  case 338: /* alter_table_cmd: ENABLE_P TRIGGER ALL  */
#line 2716 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31307 "gram.c"
    break;

  case 339: /* alter_table_cmd: ENABLE_P TRIGGER USER  */
#line 2724 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31318 "gram.c"
    break;

  case 340: /* alter_table_cmd: DISABLE_P TRIGGER name  */
#line 2732 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31330 "gram.c"
    break;

  case 341: /* alter_table_cmd: DISABLE_P TRIGGER ALL  */
#line 2741 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31341 "gram.c"
    break;

  case 342: /* alter_table_cmd: DISABLE_P TRIGGER USER  */
#line 2749 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31352 "gram.c"
    break;

  case 343: /* alter_table_cmd: ENABLE_P RULE name  */
#line 2757 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31364 "gram.c"
    break;

  case 344: /* alter_table_cmd: ENABLE_P ALWAYS RULE name  */
#line 2766 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31376 "gram.c"
    break;

  case 345: /* alter_table_cmd: ENABLE_P REPLICA RULE name  */
#line 2775 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31388 "gram.c"
    break;

  case 346: /* alter_table_cmd: DISABLE_P RULE name  */
#line 2784 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31400 "gram.c"
    break;

  case 347: /* alter_table_cmd: INHERIT qualified_name  */
#line 2793 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31412 "gram.c"
    break;

  case 348: /* alter_table_cmd: NO INHERIT qualified_name  */
#line 2802 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31424 "gram.c"
    break;

  case 349: /* alter_table_cmd: OF any_name  */
#line 2811 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 31438 "gram.c"
    break;

  case 350: /* alter_table_cmd: NOT OF  */
#line 2822 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 31449 "gram.c"
    break;

  case 351: /* alter_table_cmd: OWNER TO RoleSpec  */
#line 2830 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 31461 "gram.c"
    break;

  case 352: /* alter_table_cmd: SET ACCESS METHOD name  */
#line 2839 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31473 "gram.c"
    break;

  case 353: /* alter_table_cmd: SET TABLESPACE name  */
#line 2848 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31485 "gram.c"
    break;

  case 354: /* alter_table_cmd: SET reloptions  */
#line 2857 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31497 "gram.c"
    break;

  case 355: /* alter_table_cmd: RESET reloptions  */
#line 2866 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31509 "gram.c"
    break;

  case 356: /* alter_table_cmd: REPLICA IDENTITY_P replica_identity  */
#line 2875 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31521 "gram.c"
    break;

  case 357: /* alter_table_cmd: ENABLE_P ROW LEVEL SECURITY  */
#line 2884 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31532 "gram.c"
    break;

  case 358: /* alter_table_cmd: DISABLE_P ROW LEVEL SECURITY  */
#line 2892 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31543 "gram.c"
    break;

  case 359: /* alter_table_cmd: FORCE ROW LEVEL SECURITY  */
#line 2900 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31554 "gram.c"
    break;

  case 360: /* alter_table_cmd: NO FORCE ROW LEVEL SECURITY  */
#line 2908 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31565 "gram.c"
    break;

  case 361: /* alter_table_cmd: alter_generic_options  */
#line 2915 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31577 "gram.c"
    break;

  case 362: /* alter_column_default: SET DEFAULT a_expr  */
#line 2925 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 31583 "gram.c"
    break;

  case 363: /* alter_column_default: DROP DEFAULT  */
#line 2926 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 31589 "gram.c"
    break;

  case 364: /* opt_collate_clause: COLLATE any_name  */
#line 2931 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31602 "gram.c"
    break;

  case 365: /* opt_collate_clause: %empty  */
#line 2939 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 31608 "gram.c"
    break;

  case 366: /* alter_using: USING a_expr  */
#line 2943 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 31614 "gram.c"
    break;

  case 367: /* alter_using: %empty  */
#line 2944 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 31620 "gram.c"
    break;

  case 368: /* replica_identity: NOTHING  */
#line 2949 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31632 "gram.c"
    break;

  case 369: /* replica_identity: FULL  */
#line 2957 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31644 "gram.c"
    break;

  case 370: /* replica_identity: DEFAULT  */
#line 2965 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31656 "gram.c"
    break;

  case 371: /* replica_identity: USING INDEX name  */
#line 2973 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31668 "gram.c"
    break;

  case 372: /* reloptions: '(' reloption_list ')'  */
#line 2983 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 31674 "gram.c"
    break;

  case 373: /* opt_reloptions: WITH reloptions  */
#line 2986 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 31680 "gram.c"
    break;

  case 374: /* opt_reloptions: %empty  */
#line 2987 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31686 "gram.c"
    break;

  case 375: /* reloption_list: reloption_elem  */
#line 2991 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31692 "gram.c"
    break;

  case 376: /* reloption_list: reloption_list ',' reloption_elem  */
#line 2992 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31698 "gram.c"
    break;

  case 377: /* reloption_elem: ColLabel '=' def_arg  */
#line 2998 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31706 "gram.c"
    break;

  case 378: /* reloption_elem: ColLabel  */
#line 3002 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 31714 "gram.c"
    break;

  case 379: /* reloption_elem: ColLabel '.' ColLabel '=' def_arg  */
#line 3006 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 31723 "gram.c"
    break;

  case 380: /* reloption_elem: ColLabel '.' ColLabel  */
#line 3011 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 31731 "gram.c"
    break;

  case 381: /* alter_identity_column_option_list: alter_identity_column_option  */
#line 3018 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31737 "gram.c"
    break;

  case 382: /* alter_identity_column_option_list: alter_identity_column_option_list alter_identity_column_option  */
#line 3020 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31743 "gram.c"
    break;

  case 383: /* alter_identity_column_option: RESTART  */
#line 3025 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 31751 "gram.c"
    break;

  case 384: /* alter_identity_column_option: RESTART opt_with NumericOnly  */
#line 3029 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31759 "gram.c"
    break;

  case 385: /* alter_identity_column_option: SET SeqOptElem  */
#line 3033 "gram.y"
                                {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31774 "gram.c"
    break;

  case 386: /* alter_identity_column_option: SET GENERATED generated_when  */
#line 3044 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 31782 "gram.c"
    break;

  case 387: /* PartitionBoundSpec: FOR VALUES WITH '(' hash_partbound ')'  */
#line 3052 "gram.y"
                                {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31837 "gram.c"
    break;

  case 388: /* PartitionBoundSpec: FOR VALUES IN_P '(' expr_list ')'  */
#line 3105 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31852 "gram.c"
    break;

  case 389: /* PartitionBoundSpec: FOR VALUES FROM '(' expr_list ')' TO '(' expr_list ')'  */
#line 3118 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 31868 "gram.c"
    break;

  case 390: /* PartitionBoundSpec: DEFAULT  */
#line 3132 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 31881 "gram.c"
    break;

  case 391: /* hash_partbound_elem: NonReservedWord Iconst  */
#line 3144 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 31889 "gram.c"
    break;

  case 392: /* hash_partbound: hash_partbound_elem  */
#line 3151 "gram.y"
                        {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 31897 "gram.c"
    break;

  case 393: /* hash_partbound: hash_partbound ',' hash_partbound_elem  */
#line 3155 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 31905 "gram.c"
    break;

  case 394: /* AlterCompositeTypeStmt: ALTER TYPE_P any_name alter_type_cmds  */
#line 3169 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 31919 "gram.c"
    break;

  case 395: /* alter_type_cmds: alter_type_cmd  */
#line 3181 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31925 "gram.c"
    break;

  case 396: /* alter_type_cmds: alter_type_cmds ',' alter_type_cmd  */
#line 3182 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31931 "gram.c"
    break;

  case 397: /* alter_type_cmd: ADD_P ATTRIBUTE TableFuncElement opt_drop_behavior  */
#line 3188 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 31944 "gram.c"
    break;

  case 398: /* alter_type_cmd: DROP ATTRIBUTE IF_P EXISTS ColId opt_drop_behavior  */
#line 3198 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31958 "gram.c"
    break;

  case 399: /* alter_type_cmd: DROP ATTRIBUTE ColId opt_drop_behavior  */
#line 3209 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31972 "gram.c"
    break;

  case 400: /* alter_type_cmd: ALTER ATTRIBUTE ColId opt_set_data TYPE_P Typename opt_collate_clause opt_drop_behavior  */
#line 3220 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31992 "gram.c"
    break;

  case 401: /* ClosePortalStmt: CLOSE cursor_name  */
#line 3247 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32003 "gram.c"
    break;

  case 402: /* ClosePortalStmt: CLOSE ALL  */
#line 3254 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32014 "gram.c"
    break;

  case 403: /* CopyStmt: COPY opt_binary qualified_name opt_column_list copy_from opt_program copy_file_name copy_delimiter opt_with copy_options where_clause  */
#line 3290 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 32052 "gram.c"
    break;

  case 404: /* CopyStmt: COPY '(' PreparableStmt ')' TO opt_program copy_file_name opt_with copy_options  */
#line 3324 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 32076 "gram.c"
    break;

  case 405: /* copy_from: FROM  */
#line 3346 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 32082 "gram.c"
    break;

  case 406: /* copy_from: TO  */
#line 3347 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 32088 "gram.c"
    break;

  case 407: /* opt_program: PROGRAM  */
#line 3351 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 32094 "gram.c"
    break;

  case 408: /* opt_program: %empty  */
#line 3352 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 32100 "gram.c"
    break;

  case 409: /* copy_file_name: Sconst  */
#line 3361 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 32106 "gram.c"
    break;

  case 410: /* copy_file_name: STDIN  */
#line 3362 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 32112 "gram.c"
    break;

  case 411: /* copy_file_name: STDOUT  */
#line 3363 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 32118 "gram.c"
    break;

  case 412: /* copy_options: copy_opt_list  */
#line 3366 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 32124 "gram.c"
    break;

  case 413: /* copy_options: '(' copy_generic_opt_list ')'  */
#line 3367 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 32130 "gram.c"
    break;

  case 414: /* copy_opt_list: copy_opt_list copy_opt_item  */
#line 3372 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32136 "gram.c"
    break;

  case 415: /* copy_opt_list: %empty  */
#line 3373 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 32142 "gram.c"
    break;

  case 416: /* copy_opt_item: BINARY  */
#line 3378 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 32150 "gram.c"
    break;

  case 417: /* copy_opt_item: FREEZE  */
#line 3382 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 32158 "gram.c"
    break;

  case 418: /* copy_opt_item: DELIMITER opt_as Sconst  */
#line 3386 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32166 "gram.c"
    break;

  case 419: /* copy_opt_item: NULL_P opt_as Sconst  */
#line 3390 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32174 "gram.c"
    break;

  case 420: /* copy_opt_item: CSV  */
#line 3394 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 32182 "gram.c"
    break;

  case 421: /* copy_opt_item: HEADER_P  */
#line 3398 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 32190 "gram.c"
    break;

  case 422: /* copy_opt_item: QUOTE opt_as Sconst  */
#line 3402 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32198 "gram.c"
    break;

  case 423: /* copy_opt_item: ESCAPE opt_as Sconst  */
#line 3406 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32206 "gram.c"
    break;

  case 424: /* copy_opt_item: FORCE QUOTE columnList  */
#line 3410 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 32214 "gram.c"
    break;

  case 425: /* copy_opt_item: FORCE QUOTE '*'  */
#line 3414 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 32222 "gram.c"
    break;

  case 426: /* copy_opt_item: FORCE NOT NULL_P columnList  */
#line 3418 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 32230 "gram.c"
    break;

  case 427: /* copy_opt_item: FORCE NULL_P columnList  */
#line 3422 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 32238 "gram.c"
    break;

  case 428: /* copy_opt_item: ENCODING Sconst  */
#line 3426 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32246 "gram.c"
    break;

  case 429: /* opt_binary: BINARY  */
#line 3435 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 32254 "gram.c"
    break;

  case 430: /* opt_binary: %empty  */
#line 3438 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 32260 "gram.c"
    break;

  case 431: /* copy_delimiter: opt_using DELIMITERS Sconst  */
#line 3443 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32268 "gram.c"
    break;

  case 432: /* copy_delimiter: %empty  */
#line 3446 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 32274 "gram.c"
    break;

  case 435: /* copy_generic_opt_list: copy_generic_opt_elem  */
#line 3457 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32282 "gram.c"
    break;

  case 436: /* copy_generic_opt_list: copy_generic_opt_list ',' copy_generic_opt_elem  */
#line 3461 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32290 "gram.c"
    break;

  case 437: /* copy_generic_opt_elem: ColLabel copy_generic_opt_arg  */
#line 3468 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 32298 "gram.c"
    break;

  case 438: /* copy_generic_opt_arg: opt_boolean_or_string  */
#line 3474 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32304 "gram.c"
    break;

  case 439: /* copy_generic_opt_arg: NumericOnly  */
#line 3475 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 32310 "gram.c"
    break;

  case 440: /* copy_generic_opt_arg: '*'  */
#line 3476 "gram.y"
                                                                                { (yyval.node) = (Node *) makeNode(A_Star); }
#line 32316 "gram.c"
    break;

  case 441: /* copy_generic_opt_arg: '(' copy_generic_opt_arg_list ')'  */
#line 3477 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 32322 "gram.c"
    break;

  case 442: /* copy_generic_opt_arg: %empty  */
#line 3478 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 32328 "gram.c"
    break;

  case 443: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list_item  */
#line 3483 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32336 "gram.c"
    break;

  case 444: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list ',' copy_generic_opt_arg_list_item  */
#line 3487 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32344 "gram.c"
    break;

  case 445: /* copy_generic_opt_arg_list_item: opt_boolean_or_string  */
#line 3494 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32350 "gram.c"
    break;

  case 446: /* CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3508 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32372 "gram.c"
    break;

  case 447: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3528 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32394 "gram.c"
    break;

  case 448: /* CreateStmt: CREATE OptTemp TABLE qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3548 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32417 "gram.c"
    break;

  case 449: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name OF any_name OptTypedTableElementList OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3569 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32440 "gram.c"
    break;

  case 450: /* CreateStmt: CREATE OptTemp TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3590 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32463 "gram.c"
    break;

  case 451: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec OptPartitionSpec table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 3611 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32486 "gram.c"
    break;

  case 452: /* OptTemp: TEMPORARY  */
#line 3642 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32492 "gram.c"
    break;

  case 453: /* OptTemp: TEMP  */
#line 3643 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32498 "gram.c"
    break;

  case 454: /* OptTemp: LOCAL TEMPORARY  */
#line 3644 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32504 "gram.c"
    break;

  case 455: /* OptTemp: LOCAL TEMP  */
#line 3645 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32510 "gram.c"
    break;

  case 456: /* OptTemp: GLOBAL TEMPORARY  */
#line 3647 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32521 "gram.c"
    break;

  case 457: /* OptTemp: GLOBAL TEMP  */
#line 3654 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32532 "gram.c"
    break;

  case 458: /* OptTemp: UNLOGGED  */
#line 3660 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 32538 "gram.c"
    break;

  case 459: /* OptTemp: %empty  */
#line 3661 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 32544 "gram.c"
    break;

  case 460: /* OptTableElementList: TableElementList  */
#line 3665 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 32550 "gram.c"
    break;

  case 461: /* OptTableElementList: %empty  */
#line 3666 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 32556 "gram.c"
    break;

  case 462: /* OptTypedTableElementList: '(' TypedTableElementList ')'  */
#line 3670 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 32562 "gram.c"
    break;

  case 463: /* OptTypedTableElementList: %empty  */
#line 3671 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 32568 "gram.c"
    break;

  case 464: /* TableElementList: TableElement  */
#line 3676 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32576 "gram.c"
    break;

  case 465: /* TableElementList: TableElementList ',' TableElement  */
#line 3680 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32584 "gram.c"
    break;

  case 466: /* TypedTableElementList: TypedTableElement  */
#line 3687 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32592 "gram.c"
    break;

  case 467: /* TypedTableElementList: TypedTableElementList ',' TypedTableElement  */
#line 3691 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32600 "gram.c"
    break;

  case 468: /* TableElement: columnDef  */
#line 3697 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 32606 "gram.c"
    break;

  case 469: /* TableElement: TableLikeClause  */
#line 3698 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32612 "gram.c"
    break;

  case 470: /* TableElement: TableConstraint  */
#line 3699 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32618 "gram.c"
    break;

  case 471: /* TypedTableElement: columnOptions  */
#line 3703 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32624 "gram.c"
    break;

  case 472: /* TypedTableElement: TableConstraint  */
#line 3704 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32630 "gram.c"
    break;

  case 473: /* columnDef: ColId Typename opt_column_storage opt_column_compression create_generic_options ColQualList  */
#line 3708 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32656 "gram.c"
    break;

  case 474: /* columnOptions: ColId ColQualList  */
#line 3732 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32679 "gram.c"
    break;

  case 475: /* columnOptions: ColId WITH OPTIONS ColQualList  */
#line 3751 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 32702 "gram.c"
    break;

  case 476: /* column_compression: COMPRESSION ColId  */
#line 3772 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 32708 "gram.c"
    break;

  case 477: /* column_compression: COMPRESSION DEFAULT  */
#line 3773 "gram.y"
                                                                                { (yyval.str) = pstrdup("default"); }
#line 32714 "gram.c"
    break;

  case 478: /* opt_column_compression: column_compression  */
#line 3777 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 32720 "gram.c"
    break;

  case 479: /* opt_column_compression: %empty  */
#line 3778 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 32726 "gram.c"
    break;

  case 480: /* column_storage: STORAGE ColId  */
#line 3782 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 32732 "gram.c"
    break;

  case 481: /* column_storage: STORAGE DEFAULT  */
#line 3783 "gram.y"
                                                                                        { (yyval.str) = pstrdup("default"); }
#line 32738 "gram.c"
    break;

  case 482: /* opt_column_storage: column_storage  */
#line 3787 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 32744 "gram.c"
    break;

  case 483: /* opt_column_storage: %empty  */
#line 3788 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 32750 "gram.c"
    break;

  case 484: /* ColQualList: ColQualList ColConstraint  */
#line 3792 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32756 "gram.c"
    break;

  case 485: /* ColQualList: %empty  */
#line 3793 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 32762 "gram.c"
    break;

  case 486: /* ColConstraint: CONSTRAINT name ColConstraintElem  */
#line 3798 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32774 "gram.c"
    break;

  case 487: /* ColConstraint: ColConstraintElem  */
#line 3805 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 32780 "gram.c"
    break;

  case 488: /* ColConstraint: ConstraintAttr  */
#line 3806 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 32786 "gram.c"
    break;

  case 489: /* ColConstraint: COLLATE any_name  */
#line 3808 "gram.y"
                                {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32804 "gram.c"
    break;

  case 490: /* ColConstraintElem: NOT NULL_P  */
#line 3840 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32816 "gram.c"
    break;

  case 491: /* ColConstraintElem: NULL_P  */
#line 3848 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32828 "gram.c"
    break;

  case 492: /* ColConstraintElem: UNIQUE opt_unique_null_treatment opt_definition OptConsTableSpace  */
#line 3856 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32845 "gram.c"
    break;

  case 493: /* ColConstraintElem: PRIMARY KEY opt_definition OptConsTableSpace  */
#line 3869 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32861 "gram.c"
    break;

  case 494: /* ColConstraintElem: CHECK '(' a_expr ')' opt_no_inherit  */
#line 3881 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32878 "gram.c"
    break;

  case 495: /* ColConstraintElem: DEFAULT b_expr  */
#line 3894 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32892 "gram.c"
    break;

  case 496: /* ColConstraintElem: GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 3904 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 32906 "gram.c"
    break;

  case 497: /* ColConstraintElem: GENERATED generated_when AS '(' a_expr ')' STORED  */
#line 3914 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 32934 "gram.c"
    break;

  case 498: /* ColConstraintElem: REFERENCES qualified_name opt_column_list key_match key_actions  */
#line 3938 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32955 "gram.c"
    break;

  case 499: /* opt_unique_null_treatment: NULLS_P DISTINCT  */
#line 3957 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 32961 "gram.c"
    break;

  case 500: /* opt_unique_null_treatment: NULLS_P NOT DISTINCT  */
#line 3958 "gram.y"
                                                { (yyval.boolean) = false; }
#line 32967 "gram.c"
    break;

  case 501: /* opt_unique_null_treatment: %empty  */
#line 3959 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 32973 "gram.c"
    break;

  case 502: /* generated_when: ALWAYS  */
#line 3963 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 32979 "gram.c"
    break;

  case 503: /* generated_when: BY DEFAULT  */
#line 3964 "gram.y"
                                        { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 32985 "gram.c"
    break;

  case 504: /* ConstraintAttr: DEFERRABLE  */
#line 3984 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32997 "gram.c"
    break;

  case 505: /* ConstraintAttr: NOT DEFERRABLE  */
#line 3992 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33009 "gram.c"
    break;

  case 506: /* ConstraintAttr: INITIALLY DEFERRED  */
#line 4000 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33021 "gram.c"
    break;

  case 507: /* ConstraintAttr: INITIALLY IMMEDIATE  */
#line 4008 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33033 "gram.c"
    break;

  case 508: /* TableLikeClause: LIKE qualified_name TableLikeOptionList  */
#line 4020 "gram.y"
                                {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 33046 "gram.c"
    break;

  case 509: /* TableLikeOptionList: TableLikeOptionList INCLUDING TableLikeOption  */
#line 4031 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 33052 "gram.c"
    break;

  case 510: /* TableLikeOptionList: TableLikeOptionList EXCLUDING TableLikeOption  */
#line 4032 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 33058 "gram.c"
    break;

  case 511: /* TableLikeOptionList: %empty  */
#line 4033 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 33064 "gram.c"
    break;

  case 512: /* TableLikeOption: COMMENTS  */
#line 4037 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 33070 "gram.c"
    break;

  case 513: /* TableLikeOption: COMPRESSION  */
#line 4038 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 33076 "gram.c"
    break;

  case 514: /* TableLikeOption: CONSTRAINTS  */
#line 4039 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 33082 "gram.c"
    break;

  case 515: /* TableLikeOption: DEFAULTS  */
#line 4040 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 33088 "gram.c"
    break;

  case 516: /* TableLikeOption: IDENTITY_P  */
#line 4041 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 33094 "gram.c"
    break;

  case 517: /* TableLikeOption: GENERATED  */
#line 4042 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 33100 "gram.c"
    break;

  case 518: /* TableLikeOption: INDEXES  */
#line 4043 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 33106 "gram.c"
    break;

  case 519: /* TableLikeOption: STATISTICS  */
#line 4044 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 33112 "gram.c"
    break;

  case 520: /* TableLikeOption: STORAGE  */
#line 4045 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 33118 "gram.c"
    break;

  case 521: /* TableLikeOption: ALL  */
#line 4046 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 33124 "gram.c"
    break;

  case 522: /* TableConstraint: CONSTRAINT name ConstraintElem  */
#line 4056 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 33136 "gram.c"
    break;

  case 523: /* TableConstraint: ConstraintElem  */
#line 4063 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33142 "gram.c"
    break;

  case 524: /* ConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 4068 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 33160 "gram.c"
    break;

  case 525: /* ConstraintElem: UNIQUE opt_unique_null_treatment '(' columnList ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4083 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33181 "gram.c"
    break;

  case 526: /* ConstraintElem: UNIQUE ExistingIndex ConstraintAttributeSpec  */
#line 4100 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33201 "gram.c"
    break;

  case 527: /* ConstraintElem: PRIMARY KEY '(' columnList ')' opt_c_include opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 4117 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33221 "gram.c"
    break;

  case 528: /* ConstraintElem: PRIMARY KEY ExistingIndex ConstraintAttributeSpec  */
#line 4133 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33241 "gram.c"
    break;

  case 529: /* ConstraintElem: EXCLUDE access_method_clause '(' ExclusionConstraintList ')' opt_c_include opt_definition OptConsTableSpace OptWhereClause ConstraintAttributeSpec  */
#line 4151 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33263 "gram.c"
    break;

  case 530: /* ConstraintElem: FOREIGN KEY '(' columnList ')' REFERENCES qualified_name opt_column_list key_match key_actions ConstraintAttributeSpec  */
#line 4170 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 33287 "gram.c"
    break;

  case 531: /* opt_no_inherit: NO INHERIT  */
#line 4191 "gram.y"
                                                                                {  (yyval.boolean) = true; }
#line 33293 "gram.c"
    break;

  case 532: /* opt_no_inherit: %empty  */
#line 4192 "gram.y"
                                                                                        {  (yyval.boolean) = false; }
#line 33299 "gram.c"
    break;

  case 533: /* opt_column_list: '(' columnList ')'  */
#line 4196 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 33305 "gram.c"
    break;

  case 534: /* opt_column_list: %empty  */
#line 4197 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33311 "gram.c"
    break;

  case 535: /* columnList: columnElem  */
#line 4201 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33317 "gram.c"
    break;

  case 536: /* columnList: columnList ',' columnElem  */
#line 4202 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33323 "gram.c"
    break;

  case 537: /* columnElem: ColId  */
#line 4206 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 33331 "gram.c"
    break;

  case 538: /* opt_c_include: INCLUDE '(' columnList ')'  */
#line 4211 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 33337 "gram.c"
    break;

  case 539: /* opt_c_include: %empty  */
#line 4212 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33343 "gram.c"
    break;

  case 540: /* key_match: MATCH FULL  */
#line 4216 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 33351 "gram.c"
    break;

  case 541: /* key_match: MATCH PARTIAL  */
#line 4220 "gram.y"
                        {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 33363 "gram.c"
    break;

  case 542: /* key_match: MATCH SIMPLE  */
#line 4228 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33371 "gram.c"
    break;

  case 543: /* key_match: %empty  */
#line 4232 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33379 "gram.c"
    break;

  case 544: /* ExclusionConstraintList: ExclusionConstraintElem  */
#line 4238 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33385 "gram.c"
    break;

  case 545: /* ExclusionConstraintList: ExclusionConstraintList ',' ExclusionConstraintElem  */
#line 4240 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33391 "gram.c"
    break;

  case 546: /* ExclusionConstraintElem: index_elem WITH any_operator  */
#line 4244 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 33399 "gram.c"
    break;

  case 547: /* ExclusionConstraintElem: index_elem WITH OPERATOR '(' any_operator ')'  */
#line 4249 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 33407 "gram.c"
    break;

  case 548: /* OptWhereClause: WHERE '(' a_expr ')'  */
#line 4255 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 33413 "gram.c"
    break;

  case 549: /* OptWhereClause: %empty  */
#line 4256 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 33419 "gram.c"
    break;

  case 550: /* key_actions: key_update  */
#line 4261 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33433 "gram.c"
    break;

  case 551: /* key_actions: key_delete  */
#line 4271 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33447 "gram.c"
    break;

  case 552: /* key_actions: key_update key_delete  */
#line 4281 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33459 "gram.c"
    break;

  case 553: /* key_actions: key_delete key_update  */
#line 4289 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 33471 "gram.c"
    break;

  case 554: /* key_actions: %empty  */
#line 4297 "gram.y"
                                {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33487 "gram.c"
    break;

  case 555: /* key_update: ON UPDATE key_action  */
#line 4311 "gram.y"
                                {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33501 "gram.c"
    break;

  case 556: /* key_delete: ON DELETE_P key_action  */
#line 4323 "gram.y"
                                {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33509 "gram.c"
    break;

  case 557: /* key_action: NO ACTION  */
#line 4330 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33521 "gram.c"
    break;

  case 558: /* key_action: RESTRICT  */
#line 4338 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33533 "gram.c"
    break;

  case 559: /* key_action: CASCADE  */
#line 4346 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33545 "gram.c"
    break;

  case 560: /* key_action: SET NULL_P opt_column_list  */
#line 4354 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33557 "gram.c"
    break;

  case 561: /* key_action: SET DEFAULT opt_column_list  */
#line 4362 "gram.y"
                                {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33569 "gram.c"
    break;

  case 562: /* OptInherit: INHERITS '(' qualified_name_list ')'  */
#line 4371 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 33575 "gram.c"
    break;

  case 563: /* OptInherit: %empty  */
#line 4372 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33581 "gram.c"
    break;

  case 564: /* OptPartitionSpec: PartitionSpec  */
#line 4376 "gram.y"
                                { (yyval.partspec) = (yyvsp[0].partspec); }
#line 33587 "gram.c"
    break;

  case 565: /* OptPartitionSpec: %empty  */
#line 4377 "gram.y"
                                                        { (yyval.partspec) = NULL; }
#line 33593 "gram.c"
    break;

  case 566: /* PartitionSpec: PARTITION BY ColId '(' part_params ')'  */
#line 4381 "gram.y"
                                {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 33607 "gram.c"
    break;

  case 567: /* part_params: part_elem  */
#line 4392 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 33613 "gram.c"
    break;

  case 568: /* part_params: part_params ',' part_elem  */
#line 4393 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 33619 "gram.c"
    break;

  case 569: /* part_elem: ColId opt_collate opt_qualified_name  */
#line 4397 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33634 "gram.c"
    break;

  case 570: /* part_elem: func_expr_windowless opt_collate opt_qualified_name  */
#line 4408 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33649 "gram.c"
    break;

  case 571: /* part_elem: '(' a_expr ')' opt_collate opt_qualified_name  */
#line 4419 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 33664 "gram.c"
    break;

  case 572: /* table_access_method_clause: USING name  */
#line 4432 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33670 "gram.c"
    break;

  case 573: /* table_access_method_clause: %empty  */
#line 4433 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 33676 "gram.c"
    break;

  case 574: /* OptWith: WITH reloptions  */
#line 4438 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33682 "gram.c"
    break;

  case 575: /* OptWith: WITHOUT OIDS  */
#line 4439 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 33688 "gram.c"
    break;

  case 576: /* OptWith: %empty  */
#line 4440 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 33694 "gram.c"
    break;

  case 577: /* OnCommitOption: ON COMMIT DROP  */
#line 4443 "gram.y"
                                                        { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 33700 "gram.c"
    break;

  case 578: /* OnCommitOption: ON COMMIT DELETE_P ROWS  */
#line 4444 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 33706 "gram.c"
    break;

  case 579: /* OnCommitOption: ON COMMIT PRESERVE ROWS  */
#line 4445 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 33712 "gram.c"
    break;

  case 580: /* OnCommitOption: %empty  */
#line 4446 "gram.y"
                                                                                { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 33718 "gram.c"
    break;

  case 581: /* OptTableSpace: TABLESPACE name  */
#line 4449 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33724 "gram.c"
    break;

  case 582: /* OptTableSpace: %empty  */
#line 4450 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33730 "gram.c"
    break;

  case 583: /* OptConsTableSpace: USING INDEX TABLESPACE name  */
#line 4453 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33736 "gram.c"
    break;

  case 584: /* OptConsTableSpace: %empty  */
#line 4454 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 33742 "gram.c"
    break;

  case 585: /* ExistingIndex: USING INDEX name  */
#line 4457 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33748 "gram.c"
    break;

  case 586: /* CreateStatsStmt: CREATE STATISTICS opt_qualified_name opt_name_list ON stats_params FROM from_list  */
#line 4479 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33764 "gram.c"
    break;

  case 587: /* CreateStatsStmt: CREATE STATISTICS IF_P NOT EXISTS any_name opt_name_list ON stats_params FROM from_list  */
#line 4492 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33780 "gram.c"
    break;

  case 588: /* stats_params: stats_param  */
#line 4512 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 33786 "gram.c"
    break;

  case 589: /* stats_params: stats_params ',' stats_param  */
#line 4513 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 33792 "gram.c"
    break;

  case 590: /* stats_param: ColId  */
#line 4517 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 33802 "gram.c"
    break;

  case 591: /* stats_param: func_expr_windowless  */
#line 4523 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 33812 "gram.c"
    break;

  case 592: /* stats_param: '(' a_expr ')'  */
#line 4529 "gram.y"
                                {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 33822 "gram.c"
    break;

  case 593: /* AlterStatsStmt: ALTER STATISTICS any_name SET STATISTICS SignedIconst  */
#line 4546 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33835 "gram.c"
    break;

  case 594: /* AlterStatsStmt: ALTER STATISTICS IF_P EXISTS any_name SET STATISTICS SignedIconst  */
#line 4555 "gram.y"
                                {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33848 "gram.c"
    break;

  case 595: /* CreateAsStmt: CREATE OptTemp TABLE create_as_target AS SelectStmt opt_with_data  */
#line 4577 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33866 "gram.c"
    break;

  case 596: /* CreateAsStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS SelectStmt opt_with_data  */
#line 4591 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33884 "gram.c"
    break;

  case 597: /* create_as_target: qualified_name opt_column_list table_access_method_clause OptWith OnCommitOption OptTableSpace  */
#line 4609 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33900 "gram.c"
    break;

  case 598: /* opt_with_data: WITH DATA_P  */
#line 4623 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33906 "gram.c"
    break;

  case 599: /* opt_with_data: WITH NO DATA_P  */
#line 4624 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 33912 "gram.c"
    break;

  case 600: /* opt_with_data: %empty  */
#line 4625 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 33918 "gram.c"
    break;

  case 601: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW create_mv_target AS SelectStmt opt_with_data  */
#line 4638 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33936 "gram.c"
    break;

  case 602: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW IF_P NOT EXISTS create_mv_target AS SelectStmt opt_with_data  */
#line 4652 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33954 "gram.c"
    break;

  case 603: /* create_mv_target: qualified_name opt_column_list table_access_method_clause opt_reloptions OptTableSpace  */
#line 4669 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33970 "gram.c"
    break;

  case 604: /* OptNoLog: UNLOGGED  */
#line 4682 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33976 "gram.c"
    break;

  case 605: /* OptNoLog: %empty  */
#line 4683 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33982 "gram.c"
    break;

  case 606: /* RefreshMatViewStmt: REFRESH MATERIALIZED VIEW opt_concurrently qualified_name opt_with_data  */
#line 4696 "gram.y"
                                {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33995 "gram.c"
    break;

  case 607: /* CreateSeqStmt: CREATE OptTemp SEQUENCE qualified_name OptSeqOptList  */
#line 4717 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34010 "gram.c"
    break;

  case 608: /* CreateSeqStmt: CREATE OptTemp SEQUENCE IF_P NOT EXISTS qualified_name OptSeqOptList  */
#line 4728 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34025 "gram.c"
    break;

  case 609: /* AlterSeqStmt: ALTER SEQUENCE qualified_name SeqOptList  */
#line 4742 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34038 "gram.c"
    break;

  case 610: /* AlterSeqStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SeqOptList  */
#line 4751 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34051 "gram.c"
    break;

  case 611: /* OptSeqOptList: SeqOptList  */
#line 4762 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34057 "gram.c"
    break;

  case 612: /* OptSeqOptList: %empty  */
#line 4763 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34063 "gram.c"
    break;

  case 613: /* OptParenthesizedSeqOptList: '(' SeqOptList ')'  */
#line 4766 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 34069 "gram.c"
    break;

  case 614: /* OptParenthesizedSeqOptList: %empty  */
#line 4767 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34075 "gram.c"
    break;

  case 615: /* SeqOptList: SeqOptElem  */
#line 4770 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34081 "gram.c"
    break;

  case 616: /* SeqOptList: SeqOptList SeqOptElem  */
#line 4771 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34087 "gram.c"
    break;

  case 617: /* SeqOptElem: AS SimpleTypename  */
#line 4775 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 34095 "gram.c"
    break;

  case 618: /* SeqOptElem: CACHE NumericOnly  */
#line 4779 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34103 "gram.c"
    break;

  case 619: /* SeqOptElem: CYCLE  */
#line 4783 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34111 "gram.c"
    break;

  case 620: /* SeqOptElem: NO CYCLE  */
#line 4787 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 34119 "gram.c"
    break;

  case 621: /* SeqOptElem: INCREMENT opt_by NumericOnly  */
#line 4791 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34127 "gram.c"
    break;

  case 622: /* SeqOptElem: LOGGED  */
#line 4795 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("logged", NULL, (yylsp[0]));
				}
#line 34135 "gram.c"
    break;

  case 623: /* SeqOptElem: MAXVALUE NumericOnly  */
#line 4799 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34143 "gram.c"
    break;

  case 624: /* SeqOptElem: MINVALUE NumericOnly  */
#line 4803 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34151 "gram.c"
    break;

  case 625: /* SeqOptElem: NO MAXVALUE  */
#line 4807 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 34159 "gram.c"
    break;

  case 626: /* SeqOptElem: NO MINVALUE  */
#line 4811 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 34167 "gram.c"
    break;

  case 627: /* SeqOptElem: OWNED BY any_name  */
#line 4815 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34175 "gram.c"
    break;

  case 628: /* SeqOptElem: SEQUENCE NAME_P any_name  */
#line 4819 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34183 "gram.c"
    break;

  case 629: /* SeqOptElem: START opt_with NumericOnly  */
#line 4823 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34191 "gram.c"
    break;

  case 630: /* SeqOptElem: RESTART  */
#line 4827 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 34199 "gram.c"
    break;

  case 631: /* SeqOptElem: RESTART opt_with NumericOnly  */
#line 4831 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34207 "gram.c"
    break;

  case 632: /* SeqOptElem: UNLOGGED  */
#line 4835 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("unlogged", NULL, (yylsp[0]));
				}
#line 34215 "gram.c"
    break;

  case 635: /* NumericOnly: FCONST  */
#line 4845 "gram.y"
                                                                                        { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34221 "gram.c"
    break;

  case 636: /* NumericOnly: '+' FCONST  */
#line 4846 "gram.y"
                                                                                { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34227 "gram.c"
    break;

  case 637: /* NumericOnly: '-' FCONST  */
#line 4848 "gram.y"
                                {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 34238 "gram.c"
    break;

  case 638: /* NumericOnly: SignedIconst  */
#line 4854 "gram.y"
                                                                                { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 34244 "gram.c"
    break;

  case 639: /* NumericOnly_list: NumericOnly  */
#line 4857 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34250 "gram.c"
    break;

  case 640: /* NumericOnly_list: NumericOnly_list ',' NumericOnly  */
#line 4858 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34256 "gram.c"
    break;

  case 641: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name  */
#line 4871 "gram.y"
                        {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 34276 "gram.c"
    break;

  case 642: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE name HANDLER handler_name opt_inline_handler opt_validator  */
#line 4888 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34292 "gram.c"
    break;

  case 643: /* opt_trusted: TRUSTED  */
#line 4902 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 34298 "gram.c"
    break;

  case 644: /* opt_trusted: %empty  */
#line 4903 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 34304 "gram.c"
    break;

  case 645: /* handler_name: name  */
#line 4911 "gram.y"
                                                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34310 "gram.c"
    break;

  case 646: /* handler_name: name attrs  */
#line 4912 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 34316 "gram.c"
    break;

  case 647: /* opt_inline_handler: INLINE_P handler_name  */
#line 4916 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34322 "gram.c"
    break;

  case 648: /* opt_inline_handler: %empty  */
#line 4917 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34328 "gram.c"
    break;

  case 649: /* validator_clause: VALIDATOR handler_name  */
#line 4921 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 34334 "gram.c"
    break;

  case 650: /* validator_clause: NO VALIDATOR  */
#line 4922 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 34340 "gram.c"
    break;

  case 651: /* opt_validator: validator_clause  */
#line 4926 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34346 "gram.c"
    break;

  case 652: /* opt_validator: %empty  */
#line 4927 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34352 "gram.c"
    break;

  case 655: /* CreateTableSpaceStmt: CREATE TABLESPACE name OptTableSpaceOwner LOCATION Sconst opt_reloptions  */
#line 4943 "gram.y"
                                {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34366 "gram.c"
    break;

  case 656: /* OptTableSpaceOwner: OWNER RoleSpec  */
#line 4954 "gram.y"
                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34372 "gram.c"
    break;

  case 657: /* OptTableSpaceOwner: %empty  */
#line 4955 "gram.y"
                                                                { (yyval.rolespec) = NULL; }
#line 34378 "gram.c"
    break;

  case 658: /* DropTableSpaceStmt: DROP TABLESPACE name  */
#line 4969 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34390 "gram.c"
    break;

  case 659: /* DropTableSpaceStmt: DROP TABLESPACE IF_P EXISTS name  */
#line 4977 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34402 "gram.c"
    break;

  case 660: /* CreateExtensionStmt: CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 4995 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34415 "gram.c"
    break;

  case 661: /* CreateExtensionStmt: CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 5004 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34428 "gram.c"
    break;

  case 662: /* create_extension_opt_list: create_extension_opt_list create_extension_opt_item  */
#line 5016 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34434 "gram.c"
    break;

  case 663: /* create_extension_opt_list: %empty  */
#line 5018 "gram.y"
                                { (yyval.list) = NIL; }
#line 34440 "gram.c"
    break;

  case 664: /* create_extension_opt_item: SCHEMA name  */
#line 5023 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34448 "gram.c"
    break;

  case 665: /* create_extension_opt_item: VERSION_P NonReservedWord_or_Sconst  */
#line 5027 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34456 "gram.c"
    break;

  case 666: /* create_extension_opt_item: FROM NonReservedWord_or_Sconst  */
#line 5031 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 34467 "gram.c"
    break;

  case 667: /* create_extension_opt_item: CASCADE  */
#line 5038 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34475 "gram.c"
    break;

  case 668: /* AlterExtensionStmt: ALTER EXTENSION name UPDATE alter_extension_opt_list  */
#line 5050 "gram.y"
                                {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34487 "gram.c"
    break;

  case 669: /* alter_extension_opt_list: alter_extension_opt_list alter_extension_opt_item  */
#line 5061 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34493 "gram.c"
    break;

  case 670: /* alter_extension_opt_list: %empty  */
#line 5063 "gram.y"
                                { (yyval.list) = NIL; }
#line 34499 "gram.c"
    break;

  case 671: /* alter_extension_opt_item: TO NonReservedWord_or_Sconst  */
#line 5068 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34507 "gram.c"
    break;

  case 672: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_name name  */
#line 5081 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 34521 "gram.c"
    break;

  case 673: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop object_type_any_name any_name  */
#line 5091 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34535 "gram.c"
    break;

  case 674: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop AGGREGATE aggregate_with_argtypes  */
#line 5101 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34549 "gram.c"
    break;

  case 675: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'  */
#line 5111 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 34563 "gram.c"
    break;

  case 676: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop DOMAIN_P Typename  */
#line 5121 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34577 "gram.c"
    break;

  case 677: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FUNCTION function_with_argtypes  */
#line 5131 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34591 "gram.c"
    break;

  case 678: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR operator_with_argtypes  */
#line 5141 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34605 "gram.c"
    break;

  case 679: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR CLASS any_name USING name  */
#line 5151 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34619 "gram.c"
    break;

  case 680: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR FAMILY any_name USING name  */
#line 5161 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34633 "gram.c"
    break;

  case 681: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop PROCEDURE function_with_argtypes  */
#line 5171 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34647 "gram.c"
    break;

  case 682: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop ROUTINE function_with_argtypes  */
#line 5181 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34661 "gram.c"
    break;

  case 683: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TRANSFORM FOR Typename LANGUAGE name  */
#line 5191 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 34675 "gram.c"
    break;

  case 684: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TYPE_P Typename  */
#line 5201 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34689 "gram.c"
    break;

  case 685: /* CreateFdwStmt: CREATE FOREIGN DATA_P WRAPPER name opt_fdw_options create_generic_options  */
#line 5220 "gram.y"
                                {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34702 "gram.c"
    break;

  case 686: /* fdw_option: HANDLER handler_name  */
#line 5231 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34708 "gram.c"
    break;

  case 687: /* fdw_option: NO HANDLER  */
#line 5232 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 34714 "gram.c"
    break;

  case 688: /* fdw_option: VALIDATOR handler_name  */
#line 5233 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34720 "gram.c"
    break;

  case 689: /* fdw_option: NO VALIDATOR  */
#line 5234 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 34726 "gram.c"
    break;

  case 690: /* fdw_options: fdw_option  */
#line 5238 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34732 "gram.c"
    break;

  case 691: /* fdw_options: fdw_options fdw_option  */
#line 5239 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34738 "gram.c"
    break;

  case 692: /* opt_fdw_options: fdw_options  */
#line 5243 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34744 "gram.c"
    break;

  case 693: /* opt_fdw_options: %empty  */
#line 5244 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 34750 "gram.c"
    break;

  case 694: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name opt_fdw_options alter_generic_options  */
#line 5255 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34763 "gram.c"
    break;

  case 695: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name fdw_options  */
#line 5264 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34776 "gram.c"
    break;

  case 696: /* create_generic_options: OPTIONS '(' generic_option_list ')'  */
#line 5276 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34782 "gram.c"
    break;

  case 697: /* create_generic_options: %empty  */
#line 5277 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 34788 "gram.c"
    break;

  case 698: /* generic_option_list: generic_option_elem  */
#line 5282 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34796 "gram.c"
    break;

  case 699: /* generic_option_list: generic_option_list ',' generic_option_elem  */
#line 5286 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34804 "gram.c"
    break;

  case 700: /* alter_generic_options: OPTIONS '(' alter_generic_option_list ')'  */
#line 5293 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34810 "gram.c"
    break;

  case 701: /* alter_generic_option_list: alter_generic_option_elem  */
#line 5298 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34818 "gram.c"
    break;

  case 702: /* alter_generic_option_list: alter_generic_option_list ',' alter_generic_option_elem  */
#line 5302 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34826 "gram.c"
    break;

  case 703: /* alter_generic_option_elem: generic_option_elem  */
#line 5309 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34834 "gram.c"
    break;

  case 704: /* alter_generic_option_elem: SET generic_option_elem  */
#line 5313 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 34843 "gram.c"
    break;

  case 705: /* alter_generic_option_elem: ADD_P generic_option_elem  */
#line 5318 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 34852 "gram.c"
    break;

  case 706: /* alter_generic_option_elem: DROP generic_option_name  */
#line 5323 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 34860 "gram.c"
    break;

  case 707: /* generic_option_elem: generic_option_name generic_option_arg  */
#line 5330 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34868 "gram.c"
    break;

  case 708: /* generic_option_name: ColLabel  */
#line 5336 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 34874 "gram.c"
    break;

  case 709: /* generic_option_arg: Sconst  */
#line 5341 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34880 "gram.c"
    break;

  case 710: /* CreateForeignServerStmt: CREATE SERVER name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5353 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34896 "gram.c"
    break;

  case 711: /* CreateForeignServerStmt: CREATE SERVER IF_P NOT EXISTS name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 5366 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34912 "gram.c"
    break;

  case 712: /* opt_type: TYPE_P Sconst  */
#line 5380 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34918 "gram.c"
    break;

  case 713: /* opt_type: %empty  */
#line 5381 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 34924 "gram.c"
    break;

  case 714: /* foreign_server_version: VERSION_P Sconst  */
#line 5386 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34930 "gram.c"
    break;

  case 715: /* foreign_server_version: VERSION_P NULL_P  */
#line 5387 "gram.y"
                                                        { (yyval.str) = NULL; }
#line 34936 "gram.c"
    break;

  case 716: /* opt_foreign_server_version: foreign_server_version  */
#line 5391 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 34942 "gram.c"
    break;

  case 717: /* opt_foreign_server_version: %empty  */
#line 5392 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 34948 "gram.c"
    break;

  case 718: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version alter_generic_options  */
#line 5403 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34962 "gram.c"
    break;

  case 719: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version  */
#line 5413 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34975 "gram.c"
    break;

  case 720: /* AlterForeignServerStmt: ALTER SERVER name alter_generic_options  */
#line 5422 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34987 "gram.c"
    break;

  case 721: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5442 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35010 "gram.c"
    break;

  case 722: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 5463 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35033 "gram.c"
    break;

  case 723: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5484 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35057 "gram.c"
    break;

  case 724: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList PartitionBoundSpec SERVER name create_generic_options  */
#line 5506 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35081 "gram.c"
    break;

  case 725: /* ImportForeignSchemaStmt: IMPORT_P FOREIGN SCHEMA name import_qualification FROM SERVER name INTO name create_generic_options  */
#line 5539 "gram.y"
                        {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 35097 "gram.c"
    break;

  case 726: /* import_qualification_type: LIMIT TO  */
#line 5553 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 35103 "gram.c"
    break;

  case 727: /* import_qualification_type: EXCEPT  */
#line 5554 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 35109 "gram.c"
    break;

  case 728: /* import_qualification: import_qualification_type '(' relation_expr_list ')'  */
#line 5559 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 35121 "gram.c"
    break;

  case 729: /* import_qualification: %empty  */
#line 5567 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 35132 "gram.c"
    break;

  case 730: /* CreateUserMappingStmt: CREATE USER MAPPING FOR auth_ident SERVER name create_generic_options  */
#line 5583 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35146 "gram.c"
    break;

  case 731: /* CreateUserMappingStmt: CREATE USER MAPPING IF_P NOT EXISTS FOR auth_ident SERVER name create_generic_options  */
#line 5593 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35160 "gram.c"
    break;

  case 732: /* auth_ident: RoleSpec  */
#line 5605 "gram.y"
                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35166 "gram.c"
    break;

  case 733: /* auth_ident: USER  */
#line 5606 "gram.y"
                                                        { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 35172 "gram.c"
    break;

  case 734: /* DropUserMappingStmt: DROP USER MAPPING FOR auth_ident SERVER name  */
#line 5619 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35185 "gram.c"
    break;

  case 735: /* DropUserMappingStmt: DROP USER MAPPING IF_P EXISTS FOR auth_ident SERVER name  */
#line 5628 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35198 "gram.c"
    break;

  case 736: /* AlterUserMappingStmt: ALTER USER MAPPING FOR auth_ident SERVER name alter_generic_options  */
#line 5646 "gram.y"
                                {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35211 "gram.c"
    break;

  case 737: /* CreatePolicyStmt: CREATE POLICY name ON qualified_name RowSecurityDefaultPermissive RowSecurityDefaultForCmd RowSecurityDefaultToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5673 "gram.y"
                                {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35228 "gram.c"
    break;

  case 738: /* AlterPolicyStmt: ALTER POLICY name ON qualified_name RowSecurityOptionalToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5690 "gram.y"
                                {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35243 "gram.c"
    break;

  case 739: /* RowSecurityOptionalExpr: USING '(' a_expr ')'  */
#line 5703 "gram.y"
                                                { (yyval.node) = (yyvsp[-1].node); }
#line 35249 "gram.c"
    break;

  case 740: /* RowSecurityOptionalExpr: %empty  */
#line 5704 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 35255 "gram.c"
    break;

  case 741: /* RowSecurityOptionalWithCheck: WITH CHECK '(' a_expr ')'  */
#line 5708 "gram.y"
                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 35261 "gram.c"
    break;

  case 742: /* RowSecurityOptionalWithCheck: %empty  */
#line 5709 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 35267 "gram.c"
    break;

  case 743: /* RowSecurityDefaultToRole: TO role_list  */
#line 5713 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35273 "gram.c"
    break;

  case 744: /* RowSecurityDefaultToRole: %empty  */
#line 5714 "gram.y"
                                                        { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 35279 "gram.c"
    break;

  case 745: /* RowSecurityOptionalToRole: TO role_list  */
#line 5718 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35285 "gram.c"
    break;

  case 746: /* RowSecurityOptionalToRole: %empty  */
#line 5719 "gram.y"
                                                        { (yyval.list) = NULL; }
#line 35291 "gram.c"
    break;

  case 747: /* RowSecurityDefaultPermissive: AS IDENT  */
#line 5724 "gram.y"
                                {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 35309 "gram.c"
    break;

  case 748: /* RowSecurityDefaultPermissive: %empty  */
#line 5737 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 35315 "gram.c"
    break;

  case 749: /* RowSecurityDefaultForCmd: FOR row_security_cmd  */
#line 5741 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 35321 "gram.c"
    break;

  case 750: /* RowSecurityDefaultForCmd: %empty  */
#line 5742 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 35327 "gram.c"
    break;

  case 751: /* row_security_cmd: ALL  */
#line 5746 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 35333 "gram.c"
    break;

  case 752: /* row_security_cmd: SELECT  */
#line 5747 "gram.y"
                                                { (yyval.str) = "select"; }
#line 35339 "gram.c"
    break;

  case 753: /* row_security_cmd: INSERT  */
#line 5748 "gram.y"
                                                { (yyval.str) = "insert"; }
#line 35345 "gram.c"
    break;

  case 754: /* row_security_cmd: UPDATE  */
#line 5749 "gram.y"
                                                { (yyval.str) = "update"; }
#line 35351 "gram.c"
    break;

  case 755: /* row_security_cmd: DELETE_P  */
#line 5750 "gram.y"
                                                { (yyval.str) = "delete"; }
#line 35357 "gram.c"
    break;

  case 756: /* CreateAmStmt: CREATE ACCESS METHOD name TYPE_P am_type HANDLER handler_name  */
#line 5761 "gram.y"
                                {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 35370 "gram.c"
    break;

  case 757: /* am_type: INDEX  */
#line 5772 "gram.y"
                                                { (yyval.chr) = AMTYPE_INDEX; }
#line 35376 "gram.c"
    break;

  case 758: /* am_type: TABLE  */
#line 5773 "gram.y"
                                                { (yyval.chr) = AMTYPE_TABLE; }
#line 35382 "gram.c"
    break;

  case 759: /* CreateTrigStmt: CREATE opt_or_replace TRIGGER name TriggerActionTime TriggerEvents ON qualified_name TriggerReferencing TriggerForSpec TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5787 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 35407 "gram.c"
    break;

  case 760: /* CreateTrigStmt: CREATE opt_or_replace CONSTRAINT TRIGGER name AFTER TriggerEvents ON qualified_name OptConstrFromTable ConstraintAttributeSpec FOR EACH ROW TriggerWhen EXECUTE FUNCTION_or_PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5811 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 35437 "gram.c"
    break;

  case 761: /* TriggerActionTime: BEFORE  */
#line 5839 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 35443 "gram.c"
    break;

  case 762: /* TriggerActionTime: AFTER  */
#line 5840 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 35449 "gram.c"
    break;

  case 763: /* TriggerActionTime: INSTEAD OF  */
#line 5841 "gram.y"
                                                                                { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 35455 "gram.c"
    break;

  case 764: /* TriggerEvents: TriggerOneEvent  */
#line 5846 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 35461 "gram.c"
    break;

  case 765: /* TriggerEvents: TriggerEvents OR TriggerOneEvent  */
#line 5848 "gram.y"
                                {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 35484 "gram.c"
    break;

  case 766: /* TriggerOneEvent: INSERT  */
#line 5870 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 35490 "gram.c"
    break;

  case 767: /* TriggerOneEvent: DELETE_P  */
#line 5872 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 35496 "gram.c"
    break;

  case 768: /* TriggerOneEvent: UPDATE  */
#line 5874 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 35502 "gram.c"
    break;

  case 769: /* TriggerOneEvent: UPDATE OF columnList  */
#line 5876 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 35508 "gram.c"
    break;

  case 770: /* TriggerOneEvent: TRUNCATE  */
#line 5878 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 35514 "gram.c"
    break;

  case 771: /* TriggerReferencing: REFERENCING TriggerTransitions  */
#line 5882 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35520 "gram.c"
    break;

  case 772: /* TriggerReferencing: %empty  */
#line 5883 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35526 "gram.c"
    break;

  case 773: /* TriggerTransitions: TriggerTransition  */
#line 5887 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35532 "gram.c"
    break;

  case 774: /* TriggerTransitions: TriggerTransitions TriggerTransition  */
#line 5888 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35538 "gram.c"
    break;

  case 775: /* TriggerTransition: TransitionOldOrNew TransitionRowOrTable opt_as TransitionRelName  */
#line 5893 "gram.y"
                                {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 35551 "gram.c"
    break;

  case 776: /* TransitionOldOrNew: NEW  */
#line 5904 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 35557 "gram.c"
    break;

  case 777: /* TransitionOldOrNew: OLD  */
#line 5905 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 35563 "gram.c"
    break;

  case 778: /* TransitionRowOrTable: TABLE  */
#line 5909 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 35569 "gram.c"
    break;

  case 779: /* TransitionRowOrTable: ROW  */
#line 5918 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 35575 "gram.c"
    break;

  case 780: /* TransitionRelName: ColId  */
#line 5922 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 35581 "gram.c"
    break;

  case 781: /* TriggerForSpec: FOR TriggerForOptEach TriggerForType  */
#line 5927 "gram.y"
                                {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 35589 "gram.c"
    break;

  case 782: /* TriggerForSpec: %empty  */
#line 5931 "gram.y"
                                {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 35601 "gram.c"
    break;

  case 785: /* TriggerForType: ROW  */
#line 5946 "gram.y"
                                                                                                        { (yyval.boolean) = true; }
#line 35607 "gram.c"
    break;

  case 786: /* TriggerForType: STATEMENT  */
#line 5947 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 35613 "gram.c"
    break;

  case 787: /* TriggerWhen: WHEN '(' a_expr ')'  */
#line 5951 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 35619 "gram.c"
    break;

  case 788: /* TriggerWhen: %empty  */
#line 5952 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 35625 "gram.c"
    break;

  case 791: /* TriggerFuncArgs: TriggerFuncArg  */
#line 5961 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35631 "gram.c"
    break;

  case 792: /* TriggerFuncArgs: TriggerFuncArgs ',' TriggerFuncArg  */
#line 5962 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35637 "gram.c"
    break;

  case 793: /* TriggerFuncArgs: %empty  */
#line 5963 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 35643 "gram.c"
    break;

  case 794: /* TriggerFuncArg: Iconst  */
#line 5968 "gram.y"
                                {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 35651 "gram.c"
    break;

  case 795: /* TriggerFuncArg: FCONST  */
#line 5971 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35657 "gram.c"
    break;

  case 796: /* TriggerFuncArg: Sconst  */
#line 5972 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35663 "gram.c"
    break;

  case 797: /* TriggerFuncArg: ColLabel  */
#line 5973 "gram.y"
                                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35669 "gram.c"
    break;

  case 798: /* OptConstrFromTable: FROM qualified_name  */
#line 5977 "gram.y"
                                                                                        { (yyval.range) = (yyvsp[0].range); }
#line 35675 "gram.c"
    break;

  case 799: /* OptConstrFromTable: %empty  */
#line 5978 "gram.y"
                                                                                                { (yyval.range) = NULL; }
#line 35681 "gram.c"
    break;

  case 800: /* ConstraintAttributeSpec: %empty  */
#line 5983 "gram.y"
                                { (yyval.ival) = 0; }
#line 35687 "gram.c"
    break;

  case 801: /* ConstraintAttributeSpec: ConstraintAttributeSpec ConstraintAttributeElem  */
#line 5985 "gram.y"
                                {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 35715 "gram.c"
    break;

  case 802: /* ConstraintAttributeElem: NOT DEFERRABLE  */
#line 6011 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 35721 "gram.c"
    break;

  case 803: /* ConstraintAttributeElem: DEFERRABLE  */
#line 6012 "gram.y"
                                                                        { (yyval.ival) = CAS_DEFERRABLE; }
#line 35727 "gram.c"
    break;

  case 804: /* ConstraintAttributeElem: INITIALLY IMMEDIATE  */
#line 6013 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 35733 "gram.c"
    break;

  case 805: /* ConstraintAttributeElem: INITIALLY DEFERRED  */
#line 6014 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 35739 "gram.c"
    break;

  case 806: /* ConstraintAttributeElem: NOT VALID  */
#line 6015 "gram.y"
                                                                                { (yyval.ival) = CAS_NOT_VALID; }
#line 35745 "gram.c"
    break;

  case 807: /* ConstraintAttributeElem: NO INHERIT  */
#line 6016 "gram.y"
                                                                        { (yyval.ival) = CAS_NO_INHERIT; }
#line 35751 "gram.c"
    break;

  case 808: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6031 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35765 "gram.c"
    break;

  case 809: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel WHEN event_trigger_when_list EXECUTE FUNCTION_or_PROCEDURE func_name '(' ')'  */
#line 6043 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35779 "gram.c"
    break;

  case 810: /* event_trigger_when_list: event_trigger_when_item  */
#line 6056 "gram.y"
                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35785 "gram.c"
    break;

  case 811: /* event_trigger_when_list: event_trigger_when_list AND event_trigger_when_item  */
#line 6058 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35791 "gram.c"
    break;

  case 812: /* event_trigger_when_item: ColId IN_P '(' event_trigger_value_list ')'  */
#line 6063 "gram.y"
                        { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 35797 "gram.c"
    break;

  case 813: /* event_trigger_value_list: SCONST  */
#line 6068 "gram.y"
                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35803 "gram.c"
    break;

  case 814: /* event_trigger_value_list: event_trigger_value_list ',' SCONST  */
#line 6070 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35809 "gram.c"
    break;

  case 815: /* AlterEventTrigStmt: ALTER EVENT TRIGGER name enable_trigger  */
#line 6075 "gram.y"
                                {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 35821 "gram.c"
    break;

  case 816: /* enable_trigger: ENABLE_P  */
#line 6085 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 35827 "gram.c"
    break;

  case 817: /* enable_trigger: ENABLE_P REPLICA  */
#line 6086 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 35833 "gram.c"
    break;

  case 818: /* enable_trigger: ENABLE_P ALWAYS  */
#line 6087 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 35839 "gram.c"
    break;

  case 819: /* enable_trigger: DISABLE_P  */
#line 6088 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_DISABLED; }
#line 35845 "gram.c"
    break;

  case 820: /* CreateAssertionStmt: CREATE ASSERTION any_name CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 6100 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 35857 "gram.c"
    break;

  case 821: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name aggr_args definition  */
#line 6119 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35873 "gram.c"
    break;

  case 822: /* DefineStmt: CREATE opt_or_replace AGGREGATE func_name old_aggr_definition  */
#line 6131 "gram.y"
                                {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35890 "gram.c"
    break;

  case 823: /* DefineStmt: CREATE OPERATOR any_operator definition  */
#line 6144 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35905 "gram.c"
    break;

  case 824: /* DefineStmt: CREATE TYPE_P any_name definition  */
#line 6155 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35920 "gram.c"
    break;

  case 825: /* DefineStmt: CREATE TYPE_P any_name  */
#line 6166 "gram.y"
                                {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35936 "gram.c"
    break;

  case 826: /* DefineStmt: CREATE TYPE_P any_name AS '(' OptTableFuncElementList ')'  */
#line 6178 "gram.y"
                                {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35949 "gram.c"
    break;

  case 827: /* DefineStmt: CREATE TYPE_P any_name AS ENUM_P '(' opt_enum_val_list ')'  */
#line 6187 "gram.y"
                                {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35961 "gram.c"
    break;

  case 828: /* DefineStmt: CREATE TYPE_P any_name AS RANGE definition  */
#line 6195 "gram.y"
                                {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35973 "gram.c"
    break;

  case 829: /* DefineStmt: CREATE TEXT_P SEARCH PARSER any_name definition  */
#line 6203 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35987 "gram.c"
    break;

  case 830: /* DefineStmt: CREATE TEXT_P SEARCH DICTIONARY any_name definition  */
#line 6213 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36001 "gram.c"
    break;

  case 831: /* DefineStmt: CREATE TEXT_P SEARCH TEMPLATE any_name definition  */
#line 6223 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36015 "gram.c"
    break;

  case 832: /* DefineStmt: CREATE TEXT_P SEARCH CONFIGURATION any_name definition  */
#line 6233 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36029 "gram.c"
    break;

  case 833: /* DefineStmt: CREATE COLLATION any_name definition  */
#line 6243 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36043 "gram.c"
    break;

  case 834: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name definition  */
#line 6253 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36058 "gram.c"
    break;

  case 835: /* DefineStmt: CREATE COLLATION any_name FROM any_name  */
#line 6264 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 36072 "gram.c"
    break;

  case 836: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name FROM any_name  */
#line 6274 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36087 "gram.c"
    break;

  case 837: /* definition: '(' def_list ')'  */
#line 6286 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 36093 "gram.c"
    break;

  case 838: /* def_list: def_elem  */
#line 6289 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36099 "gram.c"
    break;

  case 839: /* def_list: def_list ',' def_elem  */
#line 6290 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36105 "gram.c"
    break;

  case 840: /* def_elem: ColLabel '=' def_arg  */
#line 6294 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36113 "gram.c"
    break;

  case 841: /* def_elem: ColLabel  */
#line 6298 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 36121 "gram.c"
    break;

  case 842: /* def_arg: func_type  */
#line 6304 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 36127 "gram.c"
    break;

  case 843: /* def_arg: reserved_keyword  */
#line 6305 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 36133 "gram.c"
    break;

  case 844: /* def_arg: qual_all_Op  */
#line 6306 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 36139 "gram.c"
    break;

  case 845: /* def_arg: NumericOnly  */
#line 6307 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 36145 "gram.c"
    break;

  case 846: /* def_arg: Sconst  */
#line 6308 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36151 "gram.c"
    break;

  case 847: /* def_arg: NONE  */
#line 6309 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 36157 "gram.c"
    break;

  case 848: /* old_aggr_definition: '(' old_aggr_list ')'  */
#line 6312 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 36163 "gram.c"
    break;

  case 849: /* old_aggr_list: old_aggr_elem  */
#line 6315 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36169 "gram.c"
    break;

  case 850: /* old_aggr_list: old_aggr_list ',' old_aggr_elem  */
#line 6316 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36175 "gram.c"
    break;

  case 851: /* old_aggr_elem: IDENT '=' def_arg  */
#line 6325 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36183 "gram.c"
    break;

  case 852: /* opt_enum_val_list: enum_val_list  */
#line 6331 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 36189 "gram.c"
    break;

  case 853: /* opt_enum_val_list: %empty  */
#line 6332 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 36195 "gram.c"
    break;

  case 854: /* enum_val_list: Sconst  */
#line 6336 "gram.y"
                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36201 "gram.c"
    break;

  case 855: /* enum_val_list: enum_val_list ',' Sconst  */
#line 6338 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36207 "gram.c"
    break;

  case 856: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst  */
#line 6349 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36223 "gram.c"
    break;

  case 857: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst BEFORE Sconst  */
#line 6361 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36239 "gram.c"
    break;

  case 858: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst AFTER Sconst  */
#line 6373 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36255 "gram.c"
    break;

  case 859: /* AlterEnumStmt: ALTER TYPE_P any_name RENAME VALUE_P Sconst TO Sconst  */
#line 6385 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 36271 "gram.c"
    break;

  case 860: /* opt_if_not_exists: IF_P NOT EXISTS  */
#line 6398 "gram.y"
                                                { (yyval.boolean) = true; }
#line 36277 "gram.c"
    break;

  case 861: /* opt_if_not_exists: %empty  */
#line 6399 "gram.y"
                                                       { (yyval.boolean) = false; }
#line 36283 "gram.c"
    break;

  case 862: /* CreateOpClassStmt: CREATE OPERATOR CLASS any_name opt_default FOR TYPE_P Typename USING name opt_opfamily AS opclass_item_list  */
#line 6417 "gram.y"
                                {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36299 "gram.c"
    break;

  case 863: /* opclass_item_list: opclass_item  */
#line 6431 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36305 "gram.c"
    break;

  case 864: /* opclass_item_list: opclass_item_list ',' opclass_item  */
#line 6432 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36311 "gram.c"
    break;

  case 865: /* opclass_item: OPERATOR Iconst any_operator opclass_purpose opt_recheck  */
#line 6437 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36328 "gram.c"
    break;

  case 866: /* opclass_item: OPERATOR Iconst operator_with_argtypes opclass_purpose opt_recheck  */
#line 6451 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36342 "gram.c"
    break;

  case 867: /* opclass_item: FUNCTION Iconst function_with_argtypes  */
#line 6461 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 36355 "gram.c"
    break;

  case 868: /* opclass_item: FUNCTION Iconst '(' type_list ')' function_with_argtypes  */
#line 6470 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36369 "gram.c"
    break;

  case 869: /* opclass_item: STORAGE Typename  */
#line 6480 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36381 "gram.c"
    break;

  case 870: /* opt_default: DEFAULT  */
#line 6489 "gram.y"
                                                                { (yyval.boolean) = true; }
#line 36387 "gram.c"
    break;

  case 871: /* opt_default: %empty  */
#line 6490 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 36393 "gram.c"
    break;

  case 872: /* opt_opfamily: FAMILY any_name  */
#line 6493 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 36399 "gram.c"
    break;

  case 873: /* opt_opfamily: %empty  */
#line 6494 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 36405 "gram.c"
    break;

  case 874: /* opclass_purpose: FOR SEARCH  */
#line 6497 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 36411 "gram.c"
    break;

  case 875: /* opclass_purpose: FOR ORDER BY any_name  */
#line 6498 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 36417 "gram.c"
    break;

  case 876: /* opclass_purpose: %empty  */
#line 6499 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 36423 "gram.c"
    break;

  case 877: /* opt_recheck: RECHECK  */
#line 6503 "gram.y"
                                {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 36441 "gram.c"
    break;

  case 878: /* opt_recheck: %empty  */
#line 6516 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 36447 "gram.c"
    break;

  case 879: /* CreateOpFamilyStmt: CREATE OPERATOR FAMILY any_name USING name  */
#line 6522 "gram.y"
                                {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36459 "gram.c"
    break;

  case 880: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name ADD_P opclass_item_list  */
#line 6533 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36473 "gram.c"
    break;

  case 881: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING name DROP opclass_drop_list  */
#line 6543 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36487 "gram.c"
    break;

  case 882: /* opclass_drop_list: opclass_drop  */
#line 6555 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36493 "gram.c"
    break;

  case 883: /* opclass_drop_list: opclass_drop_list ',' opclass_drop  */
#line 6556 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36499 "gram.c"
    break;

  case 884: /* opclass_drop: OPERATOR Iconst '(' type_list ')'  */
#line 6561 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36512 "gram.c"
    break;

  case 885: /* opclass_drop: FUNCTION Iconst '(' type_list ')'  */
#line 6570 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36525 "gram.c"
    break;

  case 886: /* DropOpClassStmt: DROP OPERATOR CLASS any_name USING name opt_drop_behavior  */
#line 6583 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36540 "gram.c"
    break;

  case 887: /* DropOpClassStmt: DROP OPERATOR CLASS IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6594 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36555 "gram.c"
    break;

  case 888: /* DropOpFamilyStmt: DROP OPERATOR FAMILY any_name USING name opt_drop_behavior  */
#line 6608 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36570 "gram.c"
    break;

  case 889: /* DropOpFamilyStmt: DROP OPERATOR FAMILY IF_P EXISTS any_name USING name opt_drop_behavior  */
#line 6619 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36585 "gram.c"
    break;

  case 890: /* DropOwnedStmt: DROP OWNED BY role_list opt_drop_behavior  */
#line 6642 "gram.y"
                                {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36597 "gram.c"
    break;

  case 891: /* ReassignOwnedStmt: REASSIGN OWNED BY role_list TO RoleSpec  */
#line 6653 "gram.y"
                                {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 36609 "gram.c"
    break;

  case 892: /* DropStmt: DROP object_type_any_name IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6672 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36624 "gram.c"
    break;

  case 893: /* DropStmt: DROP object_type_any_name any_name_list opt_drop_behavior  */
#line 6683 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36639 "gram.c"
    break;

  case 894: /* DropStmt: DROP drop_type_name IF_P EXISTS name_list opt_drop_behavior  */
#line 6694 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36654 "gram.c"
    break;

  case 895: /* DropStmt: DROP drop_type_name name_list opt_drop_behavior  */
#line 6705 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36669 "gram.c"
    break;

  case 896: /* DropStmt: DROP object_type_name_on_any_name name ON any_name opt_drop_behavior  */
#line 6716 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36684 "gram.c"
    break;

  case 897: /* DropStmt: DROP object_type_name_on_any_name IF_P EXISTS name ON any_name opt_drop_behavior  */
#line 6727 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36699 "gram.c"
    break;

  case 898: /* DropStmt: DROP TYPE_P type_name_list opt_drop_behavior  */
#line 6738 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36714 "gram.c"
    break;

  case 899: /* DropStmt: DROP TYPE_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6749 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36729 "gram.c"
    break;

  case 900: /* DropStmt: DROP DOMAIN_P type_name_list opt_drop_behavior  */
#line 6760 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36744 "gram.c"
    break;

  case 901: /* DropStmt: DROP DOMAIN_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6771 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36759 "gram.c"
    break;

  case 902: /* DropStmt: DROP INDEX CONCURRENTLY any_name_list opt_drop_behavior  */
#line 6782 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36774 "gram.c"
    break;

  case 903: /* DropStmt: DROP INDEX CONCURRENTLY IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6793 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36789 "gram.c"
    break;

  case 904: /* object_type_any_name: TABLE  */
#line 6807 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TABLE; }
#line 36795 "gram.c"
    break;

  case 905: /* object_type_any_name: SEQUENCE  */
#line 6808 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36801 "gram.c"
    break;

  case 906: /* object_type_any_name: VIEW  */
#line 6809 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_VIEW; }
#line 36807 "gram.c"
    break;

  case 907: /* object_type_any_name: MATERIALIZED VIEW  */
#line 6810 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36813 "gram.c"
    break;

  case 908: /* object_type_any_name: INDEX  */
#line 6811 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 36819 "gram.c"
    break;

  case 909: /* object_type_any_name: FOREIGN TABLE  */
#line 6812 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36825 "gram.c"
    break;

  case 910: /* object_type_any_name: COLLATION  */
#line 6813 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_COLLATION; }
#line 36831 "gram.c"
    break;

  case 911: /* object_type_any_name: CONVERSION_P  */
#line 6814 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36837 "gram.c"
    break;

  case 912: /* object_type_any_name: STATISTICS  */
#line 6815 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 36843 "gram.c"
    break;

  case 913: /* object_type_any_name: TEXT_P SEARCH PARSER  */
#line 6816 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36849 "gram.c"
    break;

  case 914: /* object_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6817 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36855 "gram.c"
    break;

  case 915: /* object_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6818 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36861 "gram.c"
    break;

  case 916: /* object_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6819 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36867 "gram.c"
    break;

  case 917: /* object_type_name: drop_type_name  */
#line 6829 "gram.y"
                                                                                        { (yyval.objtype) = (yyvsp[0].objtype); }
#line 36873 "gram.c"
    break;

  case 918: /* object_type_name: DATABASE  */
#line 6830 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_DATABASE; }
#line 36879 "gram.c"
    break;

  case 919: /* object_type_name: ROLE  */
#line 6831 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_ROLE; }
#line 36885 "gram.c"
    break;

  case 920: /* object_type_name: SUBSCRIPTION  */
#line 6832 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 36891 "gram.c"
    break;

  case 921: /* object_type_name: TABLESPACE  */
#line 6833 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36897 "gram.c"
    break;

  case 922: /* drop_type_name: ACCESS METHOD  */
#line 6837 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 36903 "gram.c"
    break;

  case 923: /* drop_type_name: EVENT TRIGGER  */
#line 6838 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36909 "gram.c"
    break;

  case 924: /* drop_type_name: EXTENSION  */
#line 6839 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36915 "gram.c"
    break;

  case 925: /* drop_type_name: FOREIGN DATA_P WRAPPER  */
#line 6840 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FDW; }
#line 36921 "gram.c"
    break;

  case 926: /* drop_type_name: opt_procedural LANGUAGE  */
#line 6841 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36927 "gram.c"
    break;

  case 927: /* drop_type_name: PUBLICATION  */
#line 6842 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36933 "gram.c"
    break;

  case 928: /* drop_type_name: SCHEMA  */
#line 6843 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36939 "gram.c"
    break;

  case 929: /* drop_type_name: SERVER  */
#line 6844 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36945 "gram.c"
    break;

  case 930: /* object_type_name_on_any_name: POLICY  */
#line 6849 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_POLICY; }
#line 36951 "gram.c"
    break;

  case 931: /* object_type_name_on_any_name: RULE  */
#line 6850 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_RULE; }
#line 36957 "gram.c"
    break;

  case 932: /* object_type_name_on_any_name: TRIGGER  */
#line 6851 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TRIGGER; }
#line 36963 "gram.c"
    break;

  case 933: /* any_name_list: any_name  */
#line 6855 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 36969 "gram.c"
    break;

  case 934: /* any_name_list: any_name_list ',' any_name  */
#line 6856 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 36975 "gram.c"
    break;

  case 935: /* any_name: ColId  */
#line 6859 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36981 "gram.c"
    break;

  case 936: /* any_name: ColId attrs  */
#line 6860 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36987 "gram.c"
    break;

  case 937: /* attrs: '.' attr_name  */
#line 6864 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36993 "gram.c"
    break;

  case 938: /* attrs: attrs '.' attr_name  */
#line 6866 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36999 "gram.c"
    break;

  case 939: /* type_name_list: Typename  */
#line 6870 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 37005 "gram.c"
    break;

  case 940: /* type_name_list: type_name_list ',' Typename  */
#line 6871 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 37011 "gram.c"
    break;

  case 941: /* TruncateStmt: TRUNCATE opt_table relation_expr_list opt_restart_seqs opt_drop_behavior  */
#line 6883 "gram.y"
                                {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37024 "gram.c"
    break;

  case 942: /* opt_restart_seqs: CONTINUE_P IDENTITY_P  */
#line 6894 "gram.y"
                                                        { (yyval.boolean) = false; }
#line 37030 "gram.c"
    break;

  case 943: /* opt_restart_seqs: RESTART IDENTITY_P  */
#line 6895 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 37036 "gram.c"
    break;

  case 944: /* opt_restart_seqs: %empty  */
#line 6896 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 37042 "gram.c"
    break;

  case 945: /* CommentStmt: COMMENT ON object_type_any_name any_name IS comment_text  */
#line 6907 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37055 "gram.c"
    break;

  case 946: /* CommentStmt: COMMENT ON COLUMN any_name IS comment_text  */
#line 6916 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37068 "gram.c"
    break;

  case 947: /* CommentStmt: COMMENT ON object_type_name name IS comment_text  */
#line 6925 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37081 "gram.c"
    break;

  case 948: /* CommentStmt: COMMENT ON TYPE_P Typename IS comment_text  */
#line 6934 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37094 "gram.c"
    break;

  case 949: /* CommentStmt: COMMENT ON DOMAIN_P Typename IS comment_text  */
#line 6943 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37107 "gram.c"
    break;

  case 950: /* CommentStmt: COMMENT ON AGGREGATE aggregate_with_argtypes IS comment_text  */
#line 6952 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37120 "gram.c"
    break;

  case 951: /* CommentStmt: COMMENT ON FUNCTION function_with_argtypes IS comment_text  */
#line 6961 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37133 "gram.c"
    break;

  case 952: /* CommentStmt: COMMENT ON OPERATOR operator_with_argtypes IS comment_text  */
#line 6970 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37146 "gram.c"
    break;

  case 953: /* CommentStmt: COMMENT ON CONSTRAINT name ON any_name IS comment_text  */
#line 6979 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37159 "gram.c"
    break;

  case 954: /* CommentStmt: COMMENT ON CONSTRAINT name ON DOMAIN_P any_name IS comment_text  */
#line 6988 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37177 "gram.c"
    break;

  case 955: /* CommentStmt: COMMENT ON object_type_name_on_any_name name ON any_name IS comment_text  */
#line 7002 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37190 "gram.c"
    break;

  case 956: /* CommentStmt: COMMENT ON PROCEDURE function_with_argtypes IS comment_text  */
#line 7011 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37203 "gram.c"
    break;

  case 957: /* CommentStmt: COMMENT ON ROUTINE function_with_argtypes IS comment_text  */
#line 7020 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37216 "gram.c"
    break;

  case 958: /* CommentStmt: COMMENT ON TRANSFORM FOR Typename LANGUAGE name IS comment_text  */
#line 7029 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37229 "gram.c"
    break;

  case 959: /* CommentStmt: COMMENT ON OPERATOR CLASS any_name USING name IS comment_text  */
#line 7038 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37242 "gram.c"
    break;

  case 960: /* CommentStmt: COMMENT ON OPERATOR FAMILY any_name USING name IS comment_text  */
#line 7047 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37255 "gram.c"
    break;

  case 961: /* CommentStmt: COMMENT ON LARGE_P OBJECT_P NumericOnly IS comment_text  */
#line 7056 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37268 "gram.c"
    break;

  case 962: /* CommentStmt: COMMENT ON CAST '(' Typename AS Typename ')' IS comment_text  */
#line 7065 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37281 "gram.c"
    break;

  case 963: /* comment_text: Sconst  */
#line 7076 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 37287 "gram.c"
    break;

  case 964: /* comment_text: NULL_P  */
#line 7077 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 37293 "gram.c"
    break;

  case 965: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_any_name any_name IS security_label  */
#line 7093 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37307 "gram.c"
    break;

  case 966: /* SecLabelStmt: SECURITY LABEL opt_provider ON COLUMN any_name IS security_label  */
#line 7104 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37321 "gram.c"
    break;

  case 967: /* SecLabelStmt: SECURITY LABEL opt_provider ON object_type_name name IS security_label  */
#line 7115 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37335 "gram.c"
    break;

  case 968: /* SecLabelStmt: SECURITY LABEL opt_provider ON TYPE_P Typename IS security_label  */
#line 7126 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37349 "gram.c"
    break;

  case 969: /* SecLabelStmt: SECURITY LABEL opt_provider ON DOMAIN_P Typename IS security_label  */
#line 7137 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37363 "gram.c"
    break;

  case 970: /* SecLabelStmt: SECURITY LABEL opt_provider ON AGGREGATE aggregate_with_argtypes IS security_label  */
#line 7148 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37377 "gram.c"
    break;

  case 971: /* SecLabelStmt: SECURITY LABEL opt_provider ON FUNCTION function_with_argtypes IS security_label  */
#line 7159 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37391 "gram.c"
    break;

  case 972: /* SecLabelStmt: SECURITY LABEL opt_provider ON LARGE_P OBJECT_P NumericOnly IS security_label  */
#line 7170 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37405 "gram.c"
    break;

  case 973: /* SecLabelStmt: SECURITY LABEL opt_provider ON PROCEDURE function_with_argtypes IS security_label  */
#line 7181 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37419 "gram.c"
    break;

  case 974: /* SecLabelStmt: SECURITY LABEL opt_provider ON ROUTINE function_with_argtypes IS security_label  */
#line 7192 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37433 "gram.c"
    break;

  case 975: /* opt_provider: FOR NonReservedWord_or_Sconst  */
#line 7203 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 37439 "gram.c"
    break;

  case 976: /* opt_provider: %empty  */
#line 7204 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 37445 "gram.c"
    break;

  case 977: /* security_label: Sconst  */
#line 7207 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 37451 "gram.c"
    break;

  case 978: /* security_label: NULL_P  */
#line 7208 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 37457 "gram.c"
    break;

  case 979: /* FetchStmt: FETCH fetch_args  */
#line 7219 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 37468 "gram.c"
    break;

  case 980: /* FetchStmt: MOVE fetch_args  */
#line 7226 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 37479 "gram.c"
    break;

  case 981: /* fetch_args: cursor_name  */
#line 7235 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37492 "gram.c"
    break;

  case 982: /* fetch_args: from_in cursor_name  */
#line 7244 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37505 "gram.c"
    break;

  case 983: /* fetch_args: NEXT opt_from_in cursor_name  */
#line 7253 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37518 "gram.c"
    break;

  case 984: /* fetch_args: PRIOR opt_from_in cursor_name  */
#line 7262 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37531 "gram.c"
    break;

  case 985: /* fetch_args: FIRST_P opt_from_in cursor_name  */
#line 7271 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37544 "gram.c"
    break;

  case 986: /* fetch_args: LAST_P opt_from_in cursor_name  */
#line 7280 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 37557 "gram.c"
    break;

  case 987: /* fetch_args: ABSOLUTE_P SignedIconst opt_from_in cursor_name  */
#line 7289 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37570 "gram.c"
    break;

  case 988: /* fetch_args: RELATIVE_P SignedIconst opt_from_in cursor_name  */
#line 7298 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37583 "gram.c"
    break;

  case 989: /* fetch_args: SignedIconst opt_from_in cursor_name  */
#line 7307 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37596 "gram.c"
    break;

  case 990: /* fetch_args: ALL opt_from_in cursor_name  */
#line 7316 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37609 "gram.c"
    break;

  case 991: /* fetch_args: FORWARD opt_from_in cursor_name  */
#line 7325 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37622 "gram.c"
    break;

  case 992: /* fetch_args: FORWARD SignedIconst opt_from_in cursor_name  */
#line 7334 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37635 "gram.c"
    break;

  case 993: /* fetch_args: FORWARD ALL opt_from_in cursor_name  */
#line 7343 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37648 "gram.c"
    break;

  case 994: /* fetch_args: BACKWARD opt_from_in cursor_name  */
#line 7352 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37661 "gram.c"
    break;

  case 995: /* fetch_args: BACKWARD SignedIconst opt_from_in cursor_name  */
#line 7361 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37674 "gram.c"
    break;

  case 996: /* fetch_args: BACKWARD ALL opt_from_in cursor_name  */
#line 7370 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37687 "gram.c"
    break;

  case 1001: /* GrantStmt: GRANT privileges ON privilege_target TO grantee_list opt_grant_grant_option opt_granted_by  */
#line 7397 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37705 "gram.c"
    break;

  case 1002: /* RevokeStmt: REVOKE privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7415 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37724 "gram.c"
    break;

  case 1003: /* RevokeStmt: REVOKE GRANT OPTION FOR privileges ON privilege_target FROM grantee_list opt_granted_by opt_drop_behavior  */
#line 7431 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37743 "gram.c"
    break;

  case 1004: /* privileges: privilege_list  */
#line 7458 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 37749 "gram.c"
    break;

  case 1005: /* privileges: ALL  */
#line 7460 "gram.y"
                                { (yyval.list) = NIL; }
#line 37755 "gram.c"
    break;

  case 1006: /* privileges: ALL PRIVILEGES  */
#line 7462 "gram.y"
                                { (yyval.list) = NIL; }
#line 37761 "gram.c"
    break;

  case 1007: /* privileges: ALL '(' columnList ')'  */
#line 7464 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37773 "gram.c"
    break;

  case 1008: /* privileges: ALL PRIVILEGES '(' columnList ')'  */
#line 7472 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37785 "gram.c"
    break;

  case 1009: /* privilege_list: privilege  */
#line 7481 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 37791 "gram.c"
    break;

  case 1010: /* privilege_list: privilege_list ',' privilege  */
#line 7482 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 37797 "gram.c"
    break;

  case 1011: /* privilege: SELECT opt_column_list  */
#line 7486 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37809 "gram.c"
    break;

  case 1012: /* privilege: REFERENCES opt_column_list  */
#line 7494 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37821 "gram.c"
    break;

  case 1013: /* privilege: CREATE opt_column_list  */
#line 7502 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37833 "gram.c"
    break;

  case 1014: /* privilege: ALTER SYSTEM_P  */
#line 7510 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 37844 "gram.c"
    break;

  case 1015: /* privilege: ColId opt_column_list  */
#line 7517 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37856 "gram.c"
    break;

  case 1016: /* parameter_name_list: parameter_name  */
#line 7528 "gram.y"
                        {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 37864 "gram.c"
    break;

  case 1017: /* parameter_name_list: parameter_name_list ',' parameter_name  */
#line 7532 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 37872 "gram.c"
    break;

  case 1018: /* parameter_name: ColId  */
#line 7539 "gram.y"
                        {
				(yyval.str) = (yyvsp[0].str);
			}
#line 37880 "gram.c"
    break;

  case 1019: /* parameter_name: parameter_name '.' ColId  */
#line 7543 "gram.y"
                        {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 37888 "gram.c"
    break;

  case 1020: /* privilege_target: qualified_name_list  */
#line 7554 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37901 "gram.c"
    break;

  case 1021: /* privilege_target: TABLE qualified_name_list  */
#line 7563 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37914 "gram.c"
    break;

  case 1022: /* privilege_target: SEQUENCE qualified_name_list  */
#line 7572 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37927 "gram.c"
    break;

  case 1023: /* privilege_target: FOREIGN DATA_P WRAPPER name_list  */
#line 7581 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37940 "gram.c"
    break;

  case 1024: /* privilege_target: FOREIGN SERVER name_list  */
#line 7590 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37953 "gram.c"
    break;

  case 1025: /* privilege_target: FUNCTION function_with_argtypes_list  */
#line 7599 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37966 "gram.c"
    break;

  case 1026: /* privilege_target: PROCEDURE function_with_argtypes_list  */
#line 7608 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37979 "gram.c"
    break;

  case 1027: /* privilege_target: ROUTINE function_with_argtypes_list  */
#line 7617 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37992 "gram.c"
    break;

  case 1028: /* privilege_target: DATABASE name_list  */
#line 7626 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38005 "gram.c"
    break;

  case 1029: /* privilege_target: DOMAIN_P any_name_list  */
#line 7635 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38018 "gram.c"
    break;

  case 1030: /* privilege_target: LANGUAGE name_list  */
#line 7644 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38031 "gram.c"
    break;

  case 1031: /* privilege_target: LARGE_P OBJECT_P NumericOnly_list  */
#line 7653 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38044 "gram.c"
    break;

  case 1032: /* privilege_target: PARAMETER parameter_name_list  */
#line 7662 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38056 "gram.c"
    break;

  case 1033: /* privilege_target: SCHEMA name_list  */
#line 7670 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38069 "gram.c"
    break;

  case 1034: /* privilege_target: TABLESPACE name_list  */
#line 7679 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38082 "gram.c"
    break;

  case 1035: /* privilege_target: TYPE_P any_name_list  */
#line 7688 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38095 "gram.c"
    break;

  case 1036: /* privilege_target: ALL TABLES IN_P SCHEMA name_list  */
#line 7697 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38108 "gram.c"
    break;

  case 1037: /* privilege_target: ALL SEQUENCES IN_P SCHEMA name_list  */
#line 7706 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38121 "gram.c"
    break;

  case 1038: /* privilege_target: ALL FUNCTIONS IN_P SCHEMA name_list  */
#line 7715 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38134 "gram.c"
    break;

  case 1039: /* privilege_target: ALL PROCEDURES IN_P SCHEMA name_list  */
#line 7724 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38147 "gram.c"
    break;

  case 1040: /* privilege_target: ALL ROUTINES IN_P SCHEMA name_list  */
#line 7733 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38160 "gram.c"
    break;

  case 1041: /* grantee_list: grantee  */
#line 7745 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 38166 "gram.c"
    break;

  case 1042: /* grantee_list: grantee_list ',' grantee  */
#line 7746 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 38172 "gram.c"
    break;

  case 1043: /* grantee: RoleSpec  */
#line 7750 "gram.y"
                                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38178 "gram.c"
    break;

  case 1044: /* grantee: GROUP_P RoleSpec  */
#line 7751 "gram.y"
                                                                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38184 "gram.c"
    break;

  case 1045: /* opt_grant_grant_option: WITH GRANT OPTION  */
#line 7756 "gram.y"
                                          { (yyval.boolean) = true; }
#line 38190 "gram.c"
    break;

  case 1046: /* opt_grant_grant_option: %empty  */
#line 7757 "gram.y"
                                    { (yyval.boolean) = false; }
#line 38196 "gram.c"
    break;

  case 1047: /* GrantRoleStmt: GRANT privilege_list TO role_list opt_granted_by  */
#line 7768 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38211 "gram.c"
    break;

  case 1048: /* GrantRoleStmt: GRANT privilege_list TO role_list WITH grant_role_opt_list opt_granted_by  */
#line 7779 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38226 "gram.c"
    break;

  case 1049: /* RevokeRoleStmt: REVOKE privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7793 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38242 "gram.c"
    break;

  case 1050: /* RevokeRoleStmt: REVOKE ColId OPTION FOR privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7805 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38261 "gram.c"
    break;

  case 1051: /* grant_role_opt_list: grant_role_opt_list ',' grant_role_opt  */
#line 7822 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38267 "gram.c"
    break;

  case 1052: /* grant_role_opt_list: grant_role_opt  */
#line 7823 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38273 "gram.c"
    break;

  case 1053: /* grant_role_opt: ColLabel grant_role_opt_value  */
#line 7828 "gram.y"
                        {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 38281 "gram.c"
    break;

  case 1054: /* grant_role_opt_value: OPTION  */
#line 7834 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(true); }
#line 38287 "gram.c"
    break;

  case 1055: /* grant_role_opt_value: TRUE_P  */
#line 7835 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(true); }
#line 38293 "gram.c"
    break;

  case 1056: /* grant_role_opt_value: FALSE_P  */
#line 7836 "gram.y"
                                        { (yyval.node) = (Node *) makeBoolean(false); }
#line 38299 "gram.c"
    break;

  case 1057: /* opt_granted_by: GRANTED BY RoleSpec  */
#line 7839 "gram.y"
                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38305 "gram.c"
    break;

  case 1058: /* opt_granted_by: %empty  */
#line 7840 "gram.y"
                                                                                                        { (yyval.rolespec) = NULL; }
#line 38311 "gram.c"
    break;

  case 1059: /* AlterDefaultPrivilegesStmt: ALTER DEFAULT PRIVILEGES DefACLOptionList DefACLAction  */
#line 7851 "gram.y"
                                {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38323 "gram.c"
    break;

  case 1060: /* DefACLOptionList: DefACLOptionList DefACLOption  */
#line 7861 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38329 "gram.c"
    break;

  case 1061: /* DefACLOptionList: %empty  */
#line 7862 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 38335 "gram.c"
    break;

  case 1062: /* DefACLOption: IN_P SCHEMA name_list  */
#line 7867 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38343 "gram.c"
    break;

  case 1063: /* DefACLOption: FOR ROLE role_list  */
#line 7871 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38351 "gram.c"
    break;

  case 1064: /* DefACLOption: FOR USER role_list  */
#line 7875 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38359 "gram.c"
    break;

  case 1065: /* DefACLAction: GRANT privileges ON defacl_privilege_target TO grantee_list opt_grant_grant_option  */
#line 7887 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 38376 "gram.c"
    break;

  case 1066: /* DefACLAction: REVOKE privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7901 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38394 "gram.c"
    break;

  case 1067: /* DefACLAction: REVOKE GRANT OPTION FOR privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7916 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38412 "gram.c"
    break;

  case 1068: /* defacl_privilege_target: TABLES  */
#line 7932 "gram.y"
                                                { (yyval.ival) = OBJECT_TABLE; }
#line 38418 "gram.c"
    break;

  case 1069: /* defacl_privilege_target: FUNCTIONS  */
#line 7933 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 38424 "gram.c"
    break;

  case 1070: /* defacl_privilege_target: ROUTINES  */
#line 7934 "gram.y"
                                                { (yyval.ival) = OBJECT_FUNCTION; }
#line 38430 "gram.c"
    break;

  case 1071: /* defacl_privilege_target: SEQUENCES  */
#line 7935 "gram.y"
                                                { (yyval.ival) = OBJECT_SEQUENCE; }
#line 38436 "gram.c"
    break;

  case 1072: /* defacl_privilege_target: TYPES_P  */
#line 7936 "gram.y"
                                                { (yyval.ival) = OBJECT_TYPE; }
#line 38442 "gram.c"
    break;

  case 1073: /* defacl_privilege_target: SCHEMAS  */
#line 7937 "gram.y"
                                                { (yyval.ival) = OBJECT_SCHEMA; }
#line 38448 "gram.c"
    break;

  case 1074: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently opt_single_name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 7952 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38482 "gram.c"
    break;

  case 1075: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently IF_P NOT EXISTS name ON relation_expr access_method_clause '(' index_params ')' opt_include opt_unique_null_treatment opt_reloptions OptTableSpace where_clause  */
#line 7984 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38516 "gram.c"
    break;

  case 1076: /* opt_unique: UNIQUE  */
#line 8016 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 38522 "gram.c"
    break;

  case 1077: /* opt_unique: %empty  */
#line 8017 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 38528 "gram.c"
    break;

  case 1078: /* access_method_clause: USING name  */
#line 8021 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 38534 "gram.c"
    break;

  case 1079: /* access_method_clause: %empty  */
#line 8022 "gram.y"
                                                                                                { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 38540 "gram.c"
    break;

  case 1080: /* index_params: index_elem  */
#line 8025 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38546 "gram.c"
    break;

  case 1081: /* index_params: index_params ',' index_elem  */
#line 8026 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38552 "gram.c"
    break;

  case 1082: /* index_elem_options: opt_collate opt_qualified_name opt_asc_desc opt_nulls_order  */
#line 8032 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38568 "gram.c"
    break;

  case 1083: /* index_elem_options: opt_collate any_name reloptions opt_asc_desc opt_nulls_order  */
#line 8044 "gram.y"
                {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38584 "gram.c"
    break;

  case 1084: /* index_elem: ColId index_elem_options  */
#line 8063 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 38593 "gram.c"
    break;

  case 1085: /* index_elem: func_expr_windowless index_elem_options  */
#line 8068 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 38602 "gram.c"
    break;

  case 1086: /* index_elem: '(' a_expr ')' index_elem_options  */
#line 8073 "gram.y"
                                {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 38611 "gram.c"
    break;

  case 1087: /* opt_include: INCLUDE '(' index_including_params ')'  */
#line 8079 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 38617 "gram.c"
    break;

  case 1088: /* opt_include: %empty  */
#line 8080 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38623 "gram.c"
    break;

  case 1089: /* index_including_params: index_elem  */
#line 8083 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38629 "gram.c"
    break;

  case 1090: /* index_including_params: index_including_params ',' index_elem  */
#line 8084 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38635 "gram.c"
    break;

  case 1091: /* opt_collate: COLLATE any_name  */
#line 8087 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38641 "gram.c"
    break;

  case 1092: /* opt_collate: %empty  */
#line 8088 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38647 "gram.c"
    break;

  case 1093: /* opt_asc_desc: ASC  */
#line 8092 "gram.y"
                                                                        { (yyval.ival) = SORTBY_ASC; }
#line 38653 "gram.c"
    break;

  case 1094: /* opt_asc_desc: DESC  */
#line 8093 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DESC; }
#line 38659 "gram.c"
    break;

  case 1095: /* opt_asc_desc: %empty  */
#line 8094 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DEFAULT; }
#line 38665 "gram.c"
    break;

  case 1096: /* opt_nulls_order: NULLS_LA FIRST_P  */
#line 8097 "gram.y"
                                                        { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 38671 "gram.c"
    break;

  case 1097: /* opt_nulls_order: NULLS_LA LAST_P  */
#line 8098 "gram.y"
                                                                        { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 38677 "gram.c"
    break;

  case 1098: /* opt_nulls_order: %empty  */
#line 8099 "gram.y"
                                                                                { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 38683 "gram.c"
    break;

  case 1099: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS func_return opt_createfunc_opt_list opt_routine_body  */
#line 8117 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38700 "gram.c"
    break;

  case 1100: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS TABLE '(' table_func_column_list ')' opt_createfunc_opt_list opt_routine_body  */
#line 8131 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38718 "gram.c"
    break;

  case 1101: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8146 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38735 "gram.c"
    break;

  case 1102: /* CreateFunctionStmt: CREATE opt_or_replace PROCEDURE func_name func_args_with_defaults opt_createfunc_opt_list opt_routine_body  */
#line 8160 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38752 "gram.c"
    break;

  case 1103: /* opt_or_replace: OR REPLACE  */
#line 8175 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 38758 "gram.c"
    break;

  case 1104: /* opt_or_replace: %empty  */
#line 8176 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 38764 "gram.c"
    break;

  case 1105: /* func_args: '(' func_args_list ')'  */
#line 8179 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 38770 "gram.c"
    break;

  case 1106: /* func_args: '(' ')'  */
#line 8180 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38776 "gram.c"
    break;

  case 1107: /* func_args_list: func_arg  */
#line 8184 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38782 "gram.c"
    break;

  case 1108: /* func_args_list: func_args_list ',' func_arg  */
#line 8185 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38788 "gram.c"
    break;

  case 1109: /* function_with_argtypes_list: function_with_argtypes  */
#line 8189 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38794 "gram.c"
    break;

  case 1110: /* function_with_argtypes_list: function_with_argtypes_list ',' function_with_argtypes  */
#line 8191 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38800 "gram.c"
    break;

  case 1111: /* function_with_argtypes: func_name func_args  */
#line 8196 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38813 "gram.c"
    break;

  case 1112: /* function_with_argtypes: type_func_name_keyword  */
#line 8210 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38825 "gram.c"
    break;

  case 1113: /* function_with_argtypes: ColId  */
#line 8218 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38837 "gram.c"
    break;

  case 1114: /* function_with_argtypes: ColId indirection  */
#line 8226 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38850 "gram.c"
    break;

  case 1115: /* func_args_with_defaults: '(' func_args_with_defaults_list ')'  */
#line 8241 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 38856 "gram.c"
    break;

  case 1116: /* func_args_with_defaults: '(' ')'  */
#line 8242 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38862 "gram.c"
    break;

  case 1117: /* func_args_with_defaults_list: func_arg_with_default  */
#line 8246 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38868 "gram.c"
    break;

  case 1118: /* func_args_with_defaults_list: func_args_with_defaults_list ',' func_arg_with_default  */
#line 8248 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38874 "gram.c"
    break;

  case 1119: /* func_arg: arg_class param_name func_type  */
#line 8263 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38888 "gram.c"
    break;

  case 1120: /* func_arg: param_name arg_class func_type  */
#line 8273 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38902 "gram.c"
    break;

  case 1121: /* func_arg: param_name func_type  */
#line 8283 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38916 "gram.c"
    break;

  case 1122: /* func_arg: arg_class func_type  */
#line 8293 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38930 "gram.c"
    break;

  case 1123: /* func_arg: func_type  */
#line 8303 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38944 "gram.c"
    break;

  case 1124: /* arg_class: IN_P  */
#line 8315 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 38950 "gram.c"
    break;

  case 1125: /* arg_class: OUT_P  */
#line 8316 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 38956 "gram.c"
    break;

  case 1126: /* arg_class: INOUT  */
#line 8317 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38962 "gram.c"
    break;

  case 1127: /* arg_class: IN_P OUT_P  */
#line 8318 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38968 "gram.c"
    break;

  case 1128: /* arg_class: VARIADIC  */
#line 8319 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 38974 "gram.c"
    break;

  case 1130: /* func_return: func_type  */
#line 8330 "gram.y"
                                {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 38986 "gram.c"
    break;

  case 1131: /* func_type: Typename  */
#line 8344 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 38992 "gram.c"
    break;

  case 1132: /* func_type: type_function_name attrs '%' TYPE_P  */
#line 8346 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39002 "gram.c"
    break;

  case 1133: /* func_type: SETOF type_function_name attrs '%' TYPE_P  */
#line 8352 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39013 "gram.c"
    break;

  case 1134: /* func_arg_with_default: func_arg  */
#line 8362 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39021 "gram.c"
    break;

  case 1135: /* func_arg_with_default: func_arg DEFAULT a_expr  */
#line 8366 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39030 "gram.c"
    break;

  case 1136: /* func_arg_with_default: func_arg '=' a_expr  */
#line 8371 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39039 "gram.c"
    break;

  case 1137: /* aggr_arg: func_arg  */
#line 8379 "gram.y"
                                {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39054 "gram.c"
    break;

  case 1138: /* aggr_args: '(' '*' ')'  */
#line 8421 "gram.y"
                                {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 39062 "gram.c"
    break;

  case 1139: /* aggr_args: '(' aggr_args_list ')'  */
#line 8425 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 39070 "gram.c"
    break;

  case 1140: /* aggr_args: '(' ORDER BY aggr_args_list ')'  */
#line 8429 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 39078 "gram.c"
    break;

  case 1141: /* aggr_args: '(' aggr_args_list ORDER BY aggr_args_list ')'  */
#line 8433 "gram.y"
                                {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 39087 "gram.c"
    break;

  case 1142: /* aggr_args_list: aggr_arg  */
#line 8440 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39093 "gram.c"
    break;

  case 1143: /* aggr_args_list: aggr_args_list ',' aggr_arg  */
#line 8441 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39099 "gram.c"
    break;

  case 1144: /* aggregate_with_argtypes: func_name aggr_args  */
#line 8446 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 39112 "gram.c"
    break;

  case 1145: /* aggregate_with_argtypes_list: aggregate_with_argtypes  */
#line 8457 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39118 "gram.c"
    break;

  case 1146: /* aggregate_with_argtypes_list: aggregate_with_argtypes_list ',' aggregate_with_argtypes  */
#line 8459 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39124 "gram.c"
    break;

  case 1148: /* opt_createfunc_opt_list: %empty  */
#line 8464 "gram.y"
                                    { (yyval.list) = NIL; }
#line 39130 "gram.c"
    break;

  case 1149: /* createfunc_opt_list: createfunc_opt_item  */
#line 8469 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39136 "gram.c"
    break;

  case 1150: /* createfunc_opt_list: createfunc_opt_list createfunc_opt_item  */
#line 8470 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39142 "gram.c"
    break;

  case 1151: /* common_func_opt_item: CALLED ON NULL_P INPUT_P  */
#line 8478 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 39150 "gram.c"
    break;

  case 1152: /* common_func_opt_item: RETURNS NULL_P ON NULL_P INPUT_P  */
#line 8482 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 39158 "gram.c"
    break;

  case 1153: /* common_func_opt_item: STRICT_P  */
#line 8486 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39166 "gram.c"
    break;

  case 1154: /* common_func_opt_item: IMMUTABLE  */
#line 8490 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 39174 "gram.c"
    break;

  case 1155: /* common_func_opt_item: STABLE  */
#line 8494 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 39182 "gram.c"
    break;

  case 1156: /* common_func_opt_item: VOLATILE  */
#line 8498 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 39190 "gram.c"
    break;

  case 1157: /* common_func_opt_item: EXTERNAL SECURITY DEFINER  */
#line 8502 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 39198 "gram.c"
    break;

  case 1158: /* common_func_opt_item: EXTERNAL SECURITY INVOKER  */
#line 8506 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 39206 "gram.c"
    break;

  case 1159: /* common_func_opt_item: SECURITY DEFINER  */
#line 8510 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 39214 "gram.c"
    break;

  case 1160: /* common_func_opt_item: SECURITY INVOKER  */
#line 8514 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39222 "gram.c"
    break;

  case 1161: /* common_func_opt_item: LEAKPROOF  */
#line 8518 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39230 "gram.c"
    break;

  case 1162: /* common_func_opt_item: NOT LEAKPROOF  */
#line 8522 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39238 "gram.c"
    break;

  case 1163: /* common_func_opt_item: COST NumericOnly  */
#line 8526 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39246 "gram.c"
    break;

  case 1164: /* common_func_opt_item: ROWS NumericOnly  */
#line 8530 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39254 "gram.c"
    break;

  case 1165: /* common_func_opt_item: SUPPORT any_name  */
#line 8534 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39262 "gram.c"
    break;

  case 1166: /* common_func_opt_item: FunctionSetResetClause  */
#line 8538 "gram.y"
                                {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 39271 "gram.c"
    break;

  case 1167: /* common_func_opt_item: PARALLEL ColId  */
#line 8543 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39279 "gram.c"
    break;

  case 1168: /* createfunc_opt_item: AS func_as  */
#line 8550 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39287 "gram.c"
    break;

  case 1169: /* createfunc_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8554 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39295 "gram.c"
    break;

  case 1170: /* createfunc_opt_item: TRANSFORM transform_type_list  */
#line 8558 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39303 "gram.c"
    break;

  case 1171: /* createfunc_opt_item: WINDOW  */
#line 8562 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39311 "gram.c"
    break;

  case 1172: /* createfunc_opt_item: common_func_opt_item  */
#line 8566 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 39319 "gram.c"
    break;

  case 1173: /* func_as: Sconst  */
#line 8571 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39325 "gram.c"
    break;

  case 1174: /* func_as: Sconst ',' Sconst  */
#line 8573 "gram.y"
                                {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 39333 "gram.c"
    break;

  case 1175: /* ReturnStmt: RETURN a_expr  */
#line 8579 "gram.y"
                                {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 39344 "gram.c"
    break;

  case 1176: /* opt_routine_body: ReturnStmt  */
#line 8589 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39352 "gram.c"
    break;

  case 1177: /* opt_routine_body: BEGIN_P ATOMIC routine_body_stmt_list END_P  */
#line 8593 "gram.y"
                                {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 39366 "gram.c"
    break;

  case 1178: /* opt_routine_body: %empty  */
#line 8603 "gram.y"
                                {
					(yyval.node) = NULL;
				}
#line 39374 "gram.c"
    break;

  case 1179: /* routine_body_stmt_list: routine_body_stmt_list routine_body_stmt ';'  */
#line 8610 "gram.y"
                                {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 39386 "gram.c"
    break;

  case 1180: /* routine_body_stmt_list: %empty  */
#line 8618 "gram.y"
                                {
					(yyval.list) = NIL;
				}
#line 39394 "gram.c"
    break;

  case 1183: /* transform_type_list: FOR TYPE_P Typename  */
#line 8629 "gram.y"
                                            { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 39400 "gram.c"
    break;

  case 1184: /* transform_type_list: transform_type_list ',' FOR TYPE_P Typename  */
#line 8630 "gram.y"
                                                                      { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 39406 "gram.c"
    break;

  case 1185: /* opt_definition: WITH definition  */
#line 8634 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39412 "gram.c"
    break;

  case 1186: /* opt_definition: %empty  */
#line 8635 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39418 "gram.c"
    break;

  case 1187: /* table_func_column: param_name func_type  */
#line 8639 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39432 "gram.c"
    break;

  case 1188: /* table_func_column_list: table_func_column  */
#line 8652 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 39440 "gram.c"
    break;

  case 1189: /* table_func_column_list: table_func_column_list ',' table_func_column  */
#line 8656 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 39448 "gram.c"
    break;

  case 1190: /* AlterFunctionStmt: ALTER FUNCTION function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8671 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39461 "gram.c"
    break;

  case 1191: /* AlterFunctionStmt: ALTER PROCEDURE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8680 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39474 "gram.c"
    break;

  case 1192: /* AlterFunctionStmt: ALTER ROUTINE function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 8689 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39487 "gram.c"
    break;

  case 1193: /* alterfunc_opt_list: common_func_opt_item  */
#line 8701 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39493 "gram.c"
    break;

  case 1194: /* alterfunc_opt_list: alterfunc_opt_list common_func_opt_item  */
#line 8702 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39499 "gram.c"
    break;

  case 1197: /* RemoveFuncStmt: DROP FUNCTION function_with_argtypes_list opt_drop_behavior  */
#line 8726 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39514 "gram.c"
    break;

  case 1198: /* RemoveFuncStmt: DROP FUNCTION IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8737 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39529 "gram.c"
    break;

  case 1199: /* RemoveFuncStmt: DROP PROCEDURE function_with_argtypes_list opt_drop_behavior  */
#line 8748 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39544 "gram.c"
    break;

  case 1200: /* RemoveFuncStmt: DROP PROCEDURE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8759 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39559 "gram.c"
    break;

  case 1201: /* RemoveFuncStmt: DROP ROUTINE function_with_argtypes_list opt_drop_behavior  */
#line 8770 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39574 "gram.c"
    break;

  case 1202: /* RemoveFuncStmt: DROP ROUTINE IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 8781 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39589 "gram.c"
    break;

  case 1203: /* RemoveAggrStmt: DROP AGGREGATE aggregate_with_argtypes_list opt_drop_behavior  */
#line 8795 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39604 "gram.c"
    break;

  case 1204: /* RemoveAggrStmt: DROP AGGREGATE IF_P EXISTS aggregate_with_argtypes_list opt_drop_behavior  */
#line 8806 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39619 "gram.c"
    break;

  case 1205: /* RemoveOperStmt: DROP OPERATOR operator_with_argtypes_list opt_drop_behavior  */
#line 8820 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39634 "gram.c"
    break;

  case 1206: /* RemoveOperStmt: DROP OPERATOR IF_P EXISTS operator_with_argtypes_list opt_drop_behavior  */
#line 8831 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39649 "gram.c"
    break;

  case 1207: /* oper_argtypes: '(' Typename ')'  */
#line 8845 "gram.y"
                                {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 39661 "gram.c"
    break;

  case 1208: /* oper_argtypes: '(' Typename ',' Typename ')'  */
#line 8853 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 39667 "gram.c"
    break;

  case 1209: /* oper_argtypes: '(' NONE ',' Typename ')'  */
#line 8855 "gram.y"
                                        { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 39673 "gram.c"
    break;

  case 1210: /* oper_argtypes: '(' Typename ',' NONE ')'  */
#line 8857 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 39679 "gram.c"
    break;

  case 1211: /* any_operator: all_Op  */
#line 8862 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39685 "gram.c"
    break;

  case 1212: /* any_operator: ColId '.' any_operator  */
#line 8864 "gram.y"
                                        { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 39691 "gram.c"
    break;

  case 1213: /* operator_with_argtypes_list: operator_with_argtypes  */
#line 8868 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39697 "gram.c"
    break;

  case 1214: /* operator_with_argtypes_list: operator_with_argtypes_list ',' operator_with_argtypes  */
#line 8870 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39703 "gram.c"
    break;

  case 1215: /* operator_with_argtypes: any_operator oper_argtypes  */
#line 8875 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 39715 "gram.c"
    break;

  case 1216: /* DoStmt: DO dostmt_opt_list  */
#line 8894 "gram.y"
                                {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 39726 "gram.c"
    break;

  case 1217: /* dostmt_opt_list: dostmt_opt_item  */
#line 8903 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39732 "gram.c"
    break;

  case 1218: /* dostmt_opt_list: dostmt_opt_list dostmt_opt_item  */
#line 8904 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39738 "gram.c"
    break;

  case 1219: /* dostmt_opt_item: Sconst  */
#line 8909 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 39746 "gram.c"
    break;

  case 1220: /* dostmt_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 8913 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39754 "gram.c"
    break;

  case 1221: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH FUNCTION function_with_argtypes cast_context  */
#line 8926 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 39769 "gram.c"
    break;

  case 1222: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITHOUT FUNCTION cast_context  */
#line 8938 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 39784 "gram.c"
    break;

  case 1223: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH INOUT cast_context  */
#line 8950 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 39799 "gram.c"
    break;

  case 1224: /* cast_context: AS IMPLICIT_P  */
#line 8962 "gram.y"
                                                                { (yyval.ival) = COERCION_IMPLICIT; }
#line 39805 "gram.c"
    break;

  case 1225: /* cast_context: AS ASSIGNMENT  */
#line 8963 "gram.y"
                                                                                { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 39811 "gram.c"
    break;

  case 1226: /* cast_context: %empty  */
#line 8964 "gram.y"
                                                                                        { (yyval.ival) = COERCION_EXPLICIT; }
#line 39817 "gram.c"
    break;

  case 1227: /* DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior  */
#line 8969 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39832 "gram.c"
    break;

  case 1228: /* opt_if_exists: IF_P EXISTS  */
#line 8981 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 39838 "gram.c"
    break;

  case 1229: /* opt_if_exists: %empty  */
#line 8982 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 39844 "gram.c"
    break;

  case 1230: /* CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'  */
#line 8993 "gram.y"
                                {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 39859 "gram.c"
    break;

  case 1231: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9006 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 39867 "gram.c"
    break;

  case 1232: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9010 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 39875 "gram.c"
    break;

  case 1233: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 9014 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 39883 "gram.c"
    break;

  case 1234: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 9018 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 39891 "gram.c"
    break;

  case 1235: /* DropTransformStmt: DROP TRANSFORM opt_if_exists FOR Typename LANGUAGE name opt_drop_behavior  */
#line 9025 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39905 "gram.c"
    break;

  case 1236: /* ReindexStmt: REINDEX opt_reindex_option_list reindex_target_relation opt_concurrently qualified_name  */
#line 9047 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39922 "gram.c"
    break;

  case 1237: /* ReindexStmt: REINDEX opt_reindex_option_list SCHEMA opt_concurrently name  */
#line 9060 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39939 "gram.c"
    break;

  case 1238: /* ReindexStmt: REINDEX opt_reindex_option_list reindex_target_all opt_concurrently opt_single_name  */
#line 9073 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39956 "gram.c"
    break;

  case 1239: /* reindex_target_relation: INDEX  */
#line 9087 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 39962 "gram.c"
    break;

  case 1240: /* reindex_target_relation: TABLE  */
#line 9088 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 39968 "gram.c"
    break;

  case 1241: /* reindex_target_all: SYSTEM_P  */
#line 9091 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 39974 "gram.c"
    break;

  case 1242: /* reindex_target_all: DATABASE  */
#line 9092 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 39980 "gram.c"
    break;

  case 1243: /* opt_reindex_option_list: '(' utility_option_list ')'  */
#line 9095 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 39986 "gram.c"
    break;

  case 1244: /* opt_reindex_option_list: %empty  */
#line 9096 "gram.y"
                                                                                        { (yyval.list) = NULL; }
#line 39992 "gram.c"
    break;

  case 1245: /* AlterTblSpcStmt: ALTER TABLESPACE name SET reloptions  */
#line 9107 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 40006 "gram.c"
    break;

  case 1246: /* AlterTblSpcStmt: ALTER TABLESPACE name RESET reloptions  */
#line 9117 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 40020 "gram.c"
    break;

  case 1247: /* RenameStmt: ALTER AGGREGATE aggregate_with_argtypes RENAME TO name  */
#line 9135 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40034 "gram.c"
    break;

  case 1248: /* RenameStmt: ALTER COLLATION any_name RENAME TO name  */
#line 9145 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40048 "gram.c"
    break;

  case 1249: /* RenameStmt: ALTER CONVERSION_P any_name RENAME TO name  */
#line 9155 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40062 "gram.c"
    break;

  case 1250: /* RenameStmt: ALTER DATABASE name RENAME TO name  */
#line 9165 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40076 "gram.c"
    break;

  case 1251: /* RenameStmt: ALTER DOMAIN_P any_name RENAME TO name  */
#line 9175 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40090 "gram.c"
    break;

  case 1252: /* RenameStmt: ALTER DOMAIN_P any_name RENAME CONSTRAINT name TO name  */
#line 9185 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 40104 "gram.c"
    break;

  case 1253: /* RenameStmt: ALTER FOREIGN DATA_P WRAPPER name RENAME TO name  */
#line 9195 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40118 "gram.c"
    break;

  case 1254: /* RenameStmt: ALTER FUNCTION function_with_argtypes RENAME TO name  */
#line 9205 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40132 "gram.c"
    break;

  case 1255: /* RenameStmt: ALTER GROUP_P RoleId RENAME TO RoleId  */
#line 9215 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40146 "gram.c"
    break;

  case 1256: /* RenameStmt: ALTER opt_procedural LANGUAGE name RENAME TO name  */
#line 9225 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40160 "gram.c"
    break;

  case 1257: /* RenameStmt: ALTER OPERATOR CLASS any_name USING name RENAME TO name  */
#line 9235 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40174 "gram.c"
    break;

  case 1258: /* RenameStmt: ALTER OPERATOR FAMILY any_name USING name RENAME TO name  */
#line 9245 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40188 "gram.c"
    break;

  case 1259: /* RenameStmt: ALTER POLICY name ON qualified_name RENAME TO name  */
#line 9255 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40203 "gram.c"
    break;

  case 1260: /* RenameStmt: ALTER POLICY IF_P EXISTS name ON qualified_name RENAME TO name  */
#line 9266 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40218 "gram.c"
    break;

  case 1261: /* RenameStmt: ALTER PROCEDURE function_with_argtypes RENAME TO name  */
#line 9277 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40232 "gram.c"
    break;

  case 1262: /* RenameStmt: ALTER PUBLICATION name RENAME TO name  */
#line 9287 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40246 "gram.c"
    break;

  case 1263: /* RenameStmt: ALTER ROUTINE function_with_argtypes RENAME TO name  */
#line 9297 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40260 "gram.c"
    break;

  case 1264: /* RenameStmt: ALTER SCHEMA name RENAME TO name  */
#line 9307 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40274 "gram.c"
    break;

  case 1265: /* RenameStmt: ALTER SERVER name RENAME TO name  */
#line 9317 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40288 "gram.c"
    break;

  case 1266: /* RenameStmt: ALTER SUBSCRIPTION name RENAME TO name  */
#line 9327 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40302 "gram.c"
    break;

  case 1267: /* RenameStmt: ALTER TABLE relation_expr RENAME TO name  */
#line 9337 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40317 "gram.c"
    break;

  case 1268: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9348 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40332 "gram.c"
    break;

  case 1269: /* RenameStmt: ALTER SEQUENCE qualified_name RENAME TO name  */
#line 9359 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40347 "gram.c"
    break;

  case 1270: /* RenameStmt: ALTER SEQUENCE IF_P EXISTS qualified_name RENAME TO name  */
#line 9370 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40362 "gram.c"
    break;

  case 1271: /* RenameStmt: ALTER VIEW qualified_name RENAME TO name  */
#line 9381 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40377 "gram.c"
    break;

  case 1272: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9392 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40392 "gram.c"
    break;

  case 1273: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME TO name  */
#line 9403 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40407 "gram.c"
    break;

  case 1274: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 9414 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40422 "gram.c"
    break;

  case 1275: /* RenameStmt: ALTER INDEX qualified_name RENAME TO name  */
#line 9425 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40437 "gram.c"
    break;

  case 1276: /* RenameStmt: ALTER INDEX IF_P EXISTS qualified_name RENAME TO name  */
#line 9436 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40452 "gram.c"
    break;

  case 1277: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME TO name  */
#line 9447 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40467 "gram.c"
    break;

  case 1278: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 9458 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40482 "gram.c"
    break;

  case 1279: /* RenameStmt: ALTER TABLE relation_expr RENAME opt_column name TO name  */
#line 9469 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40498 "gram.c"
    break;

  case 1280: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9481 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40514 "gram.c"
    break;

  case 1281: /* RenameStmt: ALTER VIEW qualified_name RENAME opt_column name TO name  */
#line 9493 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40530 "gram.c"
    break;

  case 1282: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9505 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40546 "gram.c"
    break;

  case 1283: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME opt_column name TO name  */
#line 9517 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40562 "gram.c"
    break;

  case 1284: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 9529 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40578 "gram.c"
    break;

  case 1285: /* RenameStmt: ALTER TABLE relation_expr RENAME CONSTRAINT name TO name  */
#line 9541 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40593 "gram.c"
    break;

  case 1286: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME CONSTRAINT name TO name  */
#line 9552 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40608 "gram.c"
    break;

  case 1287: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME opt_column name TO name  */
#line 9563 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40624 "gram.c"
    break;

  case 1288: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 9575 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40640 "gram.c"
    break;

  case 1289: /* RenameStmt: ALTER RULE name ON qualified_name RENAME TO name  */
#line 9587 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40655 "gram.c"
    break;

  case 1290: /* RenameStmt: ALTER TRIGGER name ON qualified_name RENAME TO name  */
#line 9598 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40670 "gram.c"
    break;

  case 1291: /* RenameStmt: ALTER EVENT TRIGGER name RENAME TO name  */
#line 9609 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 40683 "gram.c"
    break;

  case 1292: /* RenameStmt: ALTER ROLE RoleId RENAME TO RoleId  */
#line 9618 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40697 "gram.c"
    break;

  case 1293: /* RenameStmt: ALTER USER RoleId RENAME TO RoleId  */
#line 9628 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40711 "gram.c"
    break;

  case 1294: /* RenameStmt: ALTER TABLESPACE name RENAME TO name  */
#line 9638 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40725 "gram.c"
    break;

  case 1295: /* RenameStmt: ALTER STATISTICS any_name RENAME TO name  */
#line 9648 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40739 "gram.c"
    break;

  case 1296: /* RenameStmt: ALTER TEXT_P SEARCH PARSER any_name RENAME TO name  */
#line 9658 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40753 "gram.c"
    break;

  case 1297: /* RenameStmt: ALTER TEXT_P SEARCH DICTIONARY any_name RENAME TO name  */
#line 9668 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40767 "gram.c"
    break;

  case 1298: /* RenameStmt: ALTER TEXT_P SEARCH TEMPLATE any_name RENAME TO name  */
#line 9678 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40781 "gram.c"
    break;

  case 1299: /* RenameStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name RENAME TO name  */
#line 9688 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40795 "gram.c"
    break;

  case 1300: /* RenameStmt: ALTER TYPE_P any_name RENAME TO name  */
#line 9698 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40809 "gram.c"
    break;

  case 1301: /* RenameStmt: ALTER TYPE_P any_name RENAME ATTRIBUTE name TO name opt_drop_behavior  */
#line 9708 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40826 "gram.c"
    break;

  case 1304: /* opt_set_data: SET DATA_P  */
#line 9726 "gram.y"
                                                                                { (yyval.ival) = 1; }
#line 40832 "gram.c"
    break;

  case 1305: /* opt_set_data: %empty  */
#line 9727 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 40838 "gram.c"
    break;

  case 1306: /* AlterObjectDependsStmt: ALTER FUNCTION function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9738 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40852 "gram.c"
    break;

  case 1307: /* AlterObjectDependsStmt: ALTER PROCEDURE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9748 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40866 "gram.c"
    break;

  case 1308: /* AlterObjectDependsStmt: ALTER ROUTINE function_with_argtypes opt_no DEPENDS ON EXTENSION name  */
#line 9758 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40880 "gram.c"
    break;

  case 1309: /* AlterObjectDependsStmt: ALTER TRIGGER name ON qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9768 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40895 "gram.c"
    break;

  case 1310: /* AlterObjectDependsStmt: ALTER MATERIALIZED VIEW qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9779 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40909 "gram.c"
    break;

  case 1311: /* AlterObjectDependsStmt: ALTER INDEX qualified_name opt_no DEPENDS ON EXTENSION name  */
#line 9789 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40923 "gram.c"
    break;

  case 1312: /* opt_no: NO  */
#line 9800 "gram.y"
                                                { (yyval.boolean) = true; }
#line 40929 "gram.c"
    break;

  case 1313: /* opt_no: %empty  */
#line 9801 "gram.y"
                                        { (yyval.boolean) = false;	}
#line 40935 "gram.c"
    break;

  case 1314: /* AlterObjectSchemaStmt: ALTER AGGREGATE aggregate_with_argtypes SET SCHEMA name  */
#line 9812 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40949 "gram.c"
    break;

  case 1315: /* AlterObjectSchemaStmt: ALTER COLLATION any_name SET SCHEMA name  */
#line 9822 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40963 "gram.c"
    break;

  case 1316: /* AlterObjectSchemaStmt: ALTER CONVERSION_P any_name SET SCHEMA name  */
#line 9832 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40977 "gram.c"
    break;

  case 1317: /* AlterObjectSchemaStmt: ALTER DOMAIN_P any_name SET SCHEMA name  */
#line 9842 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40991 "gram.c"
    break;

  case 1318: /* AlterObjectSchemaStmt: ALTER EXTENSION name SET SCHEMA name  */
#line 9852 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41005 "gram.c"
    break;

  case 1319: /* AlterObjectSchemaStmt: ALTER FUNCTION function_with_argtypes SET SCHEMA name  */
#line 9862 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41019 "gram.c"
    break;

  case 1320: /* AlterObjectSchemaStmt: ALTER OPERATOR operator_with_argtypes SET SCHEMA name  */
#line 9872 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41033 "gram.c"
    break;

  case 1321: /* AlterObjectSchemaStmt: ALTER OPERATOR CLASS any_name USING name SET SCHEMA name  */
#line 9882 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41047 "gram.c"
    break;

  case 1322: /* AlterObjectSchemaStmt: ALTER OPERATOR FAMILY any_name USING name SET SCHEMA name  */
#line 9892 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41061 "gram.c"
    break;

  case 1323: /* AlterObjectSchemaStmt: ALTER PROCEDURE function_with_argtypes SET SCHEMA name  */
#line 9902 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41075 "gram.c"
    break;

  case 1324: /* AlterObjectSchemaStmt: ALTER ROUTINE function_with_argtypes SET SCHEMA name  */
#line 9912 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41089 "gram.c"
    break;

  case 1325: /* AlterObjectSchemaStmt: ALTER TABLE relation_expr SET SCHEMA name  */
#line 9922 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41103 "gram.c"
    break;

  case 1326: /* AlterObjectSchemaStmt: ALTER TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 9932 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41117 "gram.c"
    break;

  case 1327: /* AlterObjectSchemaStmt: ALTER STATISTICS any_name SET SCHEMA name  */
#line 9942 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41131 "gram.c"
    break;

  case 1328: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH PARSER any_name SET SCHEMA name  */
#line 9952 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41145 "gram.c"
    break;

  case 1329: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH DICTIONARY any_name SET SCHEMA name  */
#line 9962 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41159 "gram.c"
    break;

  case 1330: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH TEMPLATE any_name SET SCHEMA name  */
#line 9972 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41173 "gram.c"
    break;

  case 1331: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name SET SCHEMA name  */
#line 9982 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41187 "gram.c"
    break;

  case 1332: /* AlterObjectSchemaStmt: ALTER SEQUENCE qualified_name SET SCHEMA name  */
#line 9992 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41201 "gram.c"
    break;

  case 1333: /* AlterObjectSchemaStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10002 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41215 "gram.c"
    break;

  case 1334: /* AlterObjectSchemaStmt: ALTER VIEW qualified_name SET SCHEMA name  */
#line 10012 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41229 "gram.c"
    break;

  case 1335: /* AlterObjectSchemaStmt: ALTER VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10022 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41243 "gram.c"
    break;

  case 1336: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW qualified_name SET SCHEMA name  */
#line 10032 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41257 "gram.c"
    break;

  case 1337: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 10042 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41271 "gram.c"
    break;

  case 1338: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE relation_expr SET SCHEMA name  */
#line 10052 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41285 "gram.c"
    break;

  case 1339: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 10062 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41299 "gram.c"
    break;

  case 1340: /* AlterObjectSchemaStmt: ALTER TYPE_P any_name SET SCHEMA name  */
#line 10072 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41313 "gram.c"
    break;

  case 1341: /* AlterOperatorStmt: ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'  */
#line 10091 "gram.y"
                                {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41325 "gram.c"
    break;

  case 1342: /* operator_def_list: operator_def_elem  */
#line 10100 "gram.y"
                                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41331 "gram.c"
    break;

  case 1343: /* operator_def_list: operator_def_list ',' operator_def_elem  */
#line 10101 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41337 "gram.c"
    break;

  case 1344: /* operator_def_elem: ColLabel '=' NONE  */
#line 10105 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 41343 "gram.c"
    break;

  case 1345: /* operator_def_elem: ColLabel '=' operator_def_arg  */
#line 10107 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 41349 "gram.c"
    break;

  case 1346: /* operator_def_arg: func_type  */
#line 10112 "gram.y"
                                                                                { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 41355 "gram.c"
    break;

  case 1347: /* operator_def_arg: reserved_keyword  */
#line 10113 "gram.y"
                                                                        { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 41361 "gram.c"
    break;

  case 1348: /* operator_def_arg: qual_all_Op  */
#line 10114 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 41367 "gram.c"
    break;

  case 1349: /* operator_def_arg: NumericOnly  */
#line 10115 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 41373 "gram.c"
    break;

  case 1350: /* operator_def_arg: Sconst  */
#line 10116 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 41379 "gram.c"
    break;

  case 1351: /* AlterTypeStmt: ALTER TYPE_P any_name SET '(' operator_def_list ')'  */
#line 10129 "gram.y"
                                {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41391 "gram.c"
    break;

  case 1352: /* AlterOwnerStmt: ALTER AGGREGATE aggregate_with_argtypes OWNER TO RoleSpec  */
#line 10145 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41404 "gram.c"
    break;

  case 1353: /* AlterOwnerStmt: ALTER COLLATION any_name OWNER TO RoleSpec  */
#line 10154 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41417 "gram.c"
    break;

  case 1354: /* AlterOwnerStmt: ALTER CONVERSION_P any_name OWNER TO RoleSpec  */
#line 10163 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41430 "gram.c"
    break;

  case 1355: /* AlterOwnerStmt: ALTER DATABASE name OWNER TO RoleSpec  */
#line 10172 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41443 "gram.c"
    break;

  case 1356: /* AlterOwnerStmt: ALTER DOMAIN_P any_name OWNER TO RoleSpec  */
#line 10181 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41456 "gram.c"
    break;

  case 1357: /* AlterOwnerStmt: ALTER FUNCTION function_with_argtypes OWNER TO RoleSpec  */
#line 10190 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41469 "gram.c"
    break;

  case 1358: /* AlterOwnerStmt: ALTER opt_procedural LANGUAGE name OWNER TO RoleSpec  */
#line 10199 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41482 "gram.c"
    break;

  case 1359: /* AlterOwnerStmt: ALTER LARGE_P OBJECT_P NumericOnly OWNER TO RoleSpec  */
#line 10208 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41495 "gram.c"
    break;

  case 1360: /* AlterOwnerStmt: ALTER OPERATOR operator_with_argtypes OWNER TO RoleSpec  */
#line 10217 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41508 "gram.c"
    break;

  case 1361: /* AlterOwnerStmt: ALTER OPERATOR CLASS any_name USING name OWNER TO RoleSpec  */
#line 10226 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41521 "gram.c"
    break;

  case 1362: /* AlterOwnerStmt: ALTER OPERATOR FAMILY any_name USING name OWNER TO RoleSpec  */
#line 10235 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41534 "gram.c"
    break;

  case 1363: /* AlterOwnerStmt: ALTER PROCEDURE function_with_argtypes OWNER TO RoleSpec  */
#line 10244 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41547 "gram.c"
    break;

  case 1364: /* AlterOwnerStmt: ALTER ROUTINE function_with_argtypes OWNER TO RoleSpec  */
#line 10253 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41560 "gram.c"
    break;

  case 1365: /* AlterOwnerStmt: ALTER SCHEMA name OWNER TO RoleSpec  */
#line 10262 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41573 "gram.c"
    break;

  case 1366: /* AlterOwnerStmt: ALTER TYPE_P any_name OWNER TO RoleSpec  */
#line 10271 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41586 "gram.c"
    break;

  case 1367: /* AlterOwnerStmt: ALTER TABLESPACE name OWNER TO RoleSpec  */
#line 10280 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41599 "gram.c"
    break;

  case 1368: /* AlterOwnerStmt: ALTER STATISTICS any_name OWNER TO RoleSpec  */
#line 10289 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41612 "gram.c"
    break;

  case 1369: /* AlterOwnerStmt: ALTER TEXT_P SEARCH DICTIONARY any_name OWNER TO RoleSpec  */
#line 10298 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41625 "gram.c"
    break;

  case 1370: /* AlterOwnerStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name OWNER TO RoleSpec  */
#line 10307 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41638 "gram.c"
    break;

  case 1371: /* AlterOwnerStmt: ALTER FOREIGN DATA_P WRAPPER name OWNER TO RoleSpec  */
#line 10316 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41651 "gram.c"
    break;

  case 1372: /* AlterOwnerStmt: ALTER SERVER name OWNER TO RoleSpec  */
#line 10325 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41664 "gram.c"
    break;

  case 1373: /* AlterOwnerStmt: ALTER EVENT TRIGGER name OWNER TO RoleSpec  */
#line 10334 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41677 "gram.c"
    break;

  case 1374: /* AlterOwnerStmt: ALTER PUBLICATION name OWNER TO RoleSpec  */
#line 10343 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41690 "gram.c"
    break;

  case 1375: /* AlterOwnerStmt: ALTER SUBSCRIPTION name OWNER TO RoleSpec  */
#line 10352 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41703 "gram.c"
    break;

  case 1376: /* CreatePublicationStmt: CREATE PUBLICATION name opt_definition  */
#line 10380 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41715 "gram.c"
    break;

  case 1377: /* CreatePublicationStmt: CREATE PUBLICATION name FOR ALL TABLES opt_definition  */
#line 10388 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 41728 "gram.c"
    break;

  case 1378: /* CreatePublicationStmt: CREATE PUBLICATION name FOR pub_obj_list opt_definition  */
#line 10397 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 41742 "gram.c"
    break;

  case 1379: /* PublicationObjSpec: TABLE relation_expr opt_column_list OptWhereClause  */
#line 10423 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 41755 "gram.c"
    break;

  case 1380: /* PublicationObjSpec: TABLES IN_P SCHEMA ColId  */
#line 10432 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41766 "gram.c"
    break;

  case 1381: /* PublicationObjSpec: TABLES IN_P SCHEMA CURRENT_SCHEMA  */
#line 10439 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41776 "gram.c"
    break;

  case 1382: /* PublicationObjSpec: ColId opt_column_list OptWhereClause  */
#line 10445 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 41807 "gram.c"
    break;

  case 1383: /* PublicationObjSpec: ColId indirection opt_column_list OptWhereClause  */
#line 10472 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 41821 "gram.c"
    break;

  case 1384: /* PublicationObjSpec: extended_relation_expr opt_column_list OptWhereClause  */
#line 10483 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 41834 "gram.c"
    break;

  case 1385: /* PublicationObjSpec: CURRENT_SCHEMA  */
#line 10492 "gram.y"
                                {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41844 "gram.c"
    break;

  case 1386: /* pub_obj_list: PublicationObjSpec  */
#line 10500 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 41850 "gram.c"
    break;

  case 1387: /* pub_obj_list: pub_obj_list ',' PublicationObjSpec  */
#line 10502 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 41856 "gram.c"
    break;

  case 1388: /* AlterPublicationStmt: ALTER PUBLICATION name SET definition  */
#line 10524 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41868 "gram.c"
    break;

  case 1389: /* AlterPublicationStmt: ALTER PUBLICATION name ADD_P pub_obj_list  */
#line 10532 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 41882 "gram.c"
    break;

  case 1390: /* AlterPublicationStmt: ALTER PUBLICATION name SET pub_obj_list  */
#line 10542 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 41896 "gram.c"
    break;

  case 1391: /* AlterPublicationStmt: ALTER PUBLICATION name DROP pub_obj_list  */
#line 10552 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 41910 "gram.c"
    break;

  case 1392: /* CreateSubscriptionStmt: CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_definition  */
#line 10571 "gram.y"
                                {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41924 "gram.c"
    break;

  case 1393: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET definition  */
#line 10590 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41938 "gram.c"
    break;

  case 1394: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name CONNECTION Sconst  */
#line 10600 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41952 "gram.c"
    break;

  case 1395: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 10610 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41966 "gram.c"
    break;

  case 1396: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ADD_P PUBLICATION name_list opt_definition  */
#line 10620 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41981 "gram.c"
    break;

  case 1397: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DROP PUBLICATION name_list opt_definition  */
#line 10631 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41996 "gram.c"
    break;

  case 1398: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET PUBLICATION name_list opt_definition  */
#line 10642 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42011 "gram.c"
    break;

  case 1399: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ENABLE_P  */
#line 10653 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42026 "gram.c"
    break;

  case 1400: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DISABLE_P  */
#line 10664 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42041 "gram.c"
    break;

  case 1401: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SKIP definition  */
#line 10675 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42055 "gram.c"
    break;

  case 1402: /* DropSubscriptionStmt: DROP SUBSCRIPTION name opt_drop_behavior  */
#line 10693 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 42068 "gram.c"
    break;

  case 1403: /* DropSubscriptionStmt: DROP SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 10702 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 42081 "gram.c"
    break;

  case 1404: /* RuleStmt: CREATE opt_or_replace RULE name AS ON event TO qualified_name where_clause DO opt_instead RuleActionList  */
#line 10721 "gram.y"
                                {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42098 "gram.c"
    break;

  case 1405: /* RuleActionList: NOTHING  */
#line 10736 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42104 "gram.c"
    break;

  case 1406: /* RuleActionList: RuleActionStmt  */
#line 10737 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42110 "gram.c"
    break;

  case 1407: /* RuleActionList: '(' RuleActionMulti ')'  */
#line 10738 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 42116 "gram.c"
    break;

  case 1408: /* RuleActionMulti: RuleActionMulti ';' RuleActionStmtOrEmpty  */
#line 10744 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 42126 "gram.c"
    break;

  case 1409: /* RuleActionMulti: RuleActionStmtOrEmpty  */
#line 10750 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 42136 "gram.c"
    break;

  case 1415: /* RuleActionStmtOrEmpty: RuleActionStmt  */
#line 10766 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42142 "gram.c"
    break;

  case 1416: /* RuleActionStmtOrEmpty: %empty  */
#line 10767 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 42148 "gram.c"
    break;

  case 1417: /* event: SELECT  */
#line 10770 "gram.y"
                                                                                        { (yyval.ival) = CMD_SELECT; }
#line 42154 "gram.c"
    break;

  case 1418: /* event: UPDATE  */
#line 10771 "gram.y"
                                                                                                { (yyval.ival) = CMD_UPDATE; }
#line 42160 "gram.c"
    break;

  case 1419: /* event: DELETE_P  */
#line 10772 "gram.y"
                                                                                                { (yyval.ival) = CMD_DELETE; }
#line 42166 "gram.c"
    break;

  case 1420: /* event: INSERT  */
#line 10773 "gram.y"
                                                                                                { (yyval.ival) = CMD_INSERT; }
#line 42172 "gram.c"
    break;

  case 1421: /* opt_instead: INSTEAD  */
#line 10777 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 42178 "gram.c"
    break;

  case 1422: /* opt_instead: ALSO  */
#line 10778 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 42184 "gram.c"
    break;

  case 1423: /* opt_instead: %empty  */
#line 10779 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 42190 "gram.c"
    break;

  case 1424: /* NotifyStmt: NOTIFY ColId notify_payload  */
#line 10792 "gram.y"
                                {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42202 "gram.c"
    break;

  case 1425: /* notify_payload: ',' Sconst  */
#line 10802 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 42208 "gram.c"
    break;

  case 1426: /* notify_payload: %empty  */
#line 10803 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 42214 "gram.c"
    break;

  case 1427: /* ListenStmt: LISTEN ColId  */
#line 10807 "gram.y"
                                {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42225 "gram.c"
    break;

  case 1428: /* UnlistenStmt: UNLISTEN ColId  */
#line 10817 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42236 "gram.c"
    break;

  case 1429: /* UnlistenStmt: UNLISTEN '*'  */
#line 10824 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42247 "gram.c"
    break;

  case 1430: /* TransactionStmt: ABORT_P opt_transaction opt_transaction_chain  */
#line 10844 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42260 "gram.c"
    break;

  case 1431: /* TransactionStmt: START TRANSACTION transaction_mode_list_or_empty  */
#line 10853 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42272 "gram.c"
    break;

  case 1432: /* TransactionStmt: COMMIT opt_transaction opt_transaction_chain  */
#line 10861 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42285 "gram.c"
    break;

  case 1433: /* TransactionStmt: ROLLBACK opt_transaction opt_transaction_chain  */
#line 10870 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42298 "gram.c"
    break;

  case 1434: /* TransactionStmt: SAVEPOINT ColId  */
#line 10879 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42310 "gram.c"
    break;

  case 1435: /* TransactionStmt: RELEASE SAVEPOINT ColId  */
#line 10887 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42322 "gram.c"
    break;

  case 1436: /* TransactionStmt: RELEASE ColId  */
#line 10895 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42334 "gram.c"
    break;

  case 1437: /* TransactionStmt: ROLLBACK opt_transaction TO SAVEPOINT ColId  */
#line 10903 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42346 "gram.c"
    break;

  case 1438: /* TransactionStmt: ROLLBACK opt_transaction TO ColId  */
#line 10911 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42358 "gram.c"
    break;

  case 1439: /* TransactionStmt: PREPARE TRANSACTION Sconst  */
#line 10919 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42370 "gram.c"
    break;

  case 1440: /* TransactionStmt: COMMIT PREPARED Sconst  */
#line 10927 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42382 "gram.c"
    break;

  case 1441: /* TransactionStmt: ROLLBACK PREPARED Sconst  */
#line 10935 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42394 "gram.c"
    break;

  case 1442: /* TransactionStmtLegacy: BEGIN_P opt_transaction transaction_mode_list_or_empty  */
#line 10946 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42406 "gram.c"
    break;

  case 1443: /* TransactionStmtLegacy: END_P opt_transaction opt_transaction_chain  */
#line 10954 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42419 "gram.c"
    break;

  case 1447: /* transaction_mode_item: ISOLATION LEVEL iso_level  */
#line 10971 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 42426 "gram.c"
    break;

  case 1448: /* transaction_mode_item: READ ONLY  */
#line 10974 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 42433 "gram.c"
    break;

  case 1449: /* transaction_mode_item: READ WRITE  */
#line 10977 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42440 "gram.c"
    break;

  case 1450: /* transaction_mode_item: DEFERRABLE  */
#line 10980 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 42447 "gram.c"
    break;

  case 1451: /* transaction_mode_item: NOT DEFERRABLE  */
#line 10983 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42454 "gram.c"
    break;

  case 1452: /* transaction_mode_list: transaction_mode_item  */
#line 10990 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42460 "gram.c"
    break;

  case 1453: /* transaction_mode_list: transaction_mode_list ',' transaction_mode_item  */
#line 10992 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 42466 "gram.c"
    break;

  case 1454: /* transaction_mode_list: transaction_mode_list transaction_mode_item  */
#line 10994 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42472 "gram.c"
    break;

  case 1456: /* transaction_mode_list_or_empty: %empty  */
#line 11000 "gram.y"
                                        { (yyval.list) = NIL; }
#line 42478 "gram.c"
    break;

  case 1457: /* opt_transaction_chain: AND CHAIN  */
#line 11004 "gram.y"
                                                { (yyval.boolean) = true; }
#line 42484 "gram.c"
    break;

  case 1458: /* opt_transaction_chain: AND NO CHAIN  */
#line 11005 "gram.y"
                                        { (yyval.boolean) = false; }
#line 42490 "gram.c"
    break;

  case 1459: /* opt_transaction_chain: %empty  */
#line 11006 "gram.y"
                                        { (yyval.boolean) = false; }
#line 42496 "gram.c"
    break;

  case 1460: /* ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11020 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42513 "gram.c"
    break;

  case 1461: /* ViewStmt: CREATE OR REPLACE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 11034 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42530 "gram.c"
    break;

  case 1462: /* ViewStmt: CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11048 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42552 "gram.c"
    break;

  case 1463: /* ViewStmt: CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 11067 "gram.y"
                                {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42574 "gram.c"
    break;

  case 1464: /* opt_check_option: WITH CHECK OPTION  */
#line 11087 "gram.y"
                                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42580 "gram.c"
    break;

  case 1465: /* opt_check_option: WITH CASCADED CHECK OPTION  */
#line 11088 "gram.y"
                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42586 "gram.c"
    break;

  case 1466: /* opt_check_option: WITH LOCAL CHECK OPTION  */
#line 11089 "gram.y"
                                                        { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 42592 "gram.c"
    break;

  case 1467: /* opt_check_option: %empty  */
#line 11090 "gram.y"
                                                                { (yyval.ival) = NO_CHECK_OPTION; }
#line 42598 "gram.c"
    break;

  case 1468: /* LoadStmt: LOAD file_name  */
#line 11101 "gram.y"
                                {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42609 "gram.c"
    break;

  case 1469: /* CreatedbStmt: CREATE DATABASE name opt_with createdb_opt_list  */
#line 11118 "gram.y"
                                {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42621 "gram.c"
    break;

  case 1470: /* createdb_opt_list: createdb_opt_items  */
#line 11128 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 42627 "gram.c"
    break;

  case 1471: /* createdb_opt_list: %empty  */
#line 11129 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 42633 "gram.c"
    break;

  case 1472: /* createdb_opt_items: createdb_opt_item  */
#line 11133 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42639 "gram.c"
    break;

  case 1473: /* createdb_opt_items: createdb_opt_items createdb_opt_item  */
#line 11134 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42645 "gram.c"
    break;

  case 1474: /* createdb_opt_item: createdb_opt_name opt_equal NumericOnly  */
#line 11139 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 42653 "gram.c"
    break;

  case 1475: /* createdb_opt_item: createdb_opt_name opt_equal opt_boolean_or_string  */
#line 11143 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 42661 "gram.c"
    break;

  case 1476: /* createdb_opt_item: createdb_opt_name opt_equal DEFAULT  */
#line 11147 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 42669 "gram.c"
    break;

  case 1477: /* createdb_opt_name: IDENT  */
#line 11164 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 42675 "gram.c"
    break;

  case 1478: /* createdb_opt_name: CONNECTION LIMIT  */
#line 11165 "gram.y"
                                                                        { (yyval.str) = pstrdup("connection_limit"); }
#line 42681 "gram.c"
    break;

  case 1479: /* createdb_opt_name: ENCODING  */
#line 11166 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42687 "gram.c"
    break;

  case 1480: /* createdb_opt_name: LOCATION  */
#line 11167 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42693 "gram.c"
    break;

  case 1481: /* createdb_opt_name: OWNER  */
#line 11168 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42699 "gram.c"
    break;

  case 1482: /* createdb_opt_name: TABLESPACE  */
#line 11169 "gram.y"
                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42705 "gram.c"
    break;

  case 1483: /* createdb_opt_name: TEMPLATE  */
#line 11170 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42711 "gram.c"
    break;

  case 1486: /* AlterDatabaseStmt: ALTER DATABASE name WITH createdb_opt_list  */
#line 11190 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42723 "gram.c"
    break;

  case 1487: /* AlterDatabaseStmt: ALTER DATABASE name createdb_opt_list  */
#line 11198 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42735 "gram.c"
    break;

  case 1488: /* AlterDatabaseStmt: ALTER DATABASE name SET TABLESPACE name  */
#line 11206 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 42748 "gram.c"
    break;

  case 1489: /* AlterDatabaseStmt: ALTER DATABASE name REFRESH COLLATION VERSION_P  */
#line 11215 "gram.y"
                                 {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 42759 "gram.c"
    break;

  case 1490: /* AlterDatabaseSetStmt: ALTER DATABASE name SetResetClause  */
#line 11225 "gram.y"
                                {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42771 "gram.c"
    break;

  case 1491: /* DropdbStmt: DROP DATABASE name  */
#line 11243 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42784 "gram.c"
    break;

  case 1492: /* DropdbStmt: DROP DATABASE IF_P EXISTS name  */
#line 11252 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42797 "gram.c"
    break;

  case 1493: /* DropdbStmt: DROP DATABASE name opt_with '(' drop_option_list ')'  */
#line 11261 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42810 "gram.c"
    break;

  case 1494: /* DropdbStmt: DROP DATABASE IF_P EXISTS name opt_with '(' drop_option_list ')'  */
#line 11270 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42823 "gram.c"
    break;

  case 1495: /* drop_option_list: drop_option  */
#line 11282 "gram.y"
                                {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 42831 "gram.c"
    break;

  case 1496: /* drop_option_list: drop_option_list ',' drop_option  */
#line 11286 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 42839 "gram.c"
    break;

  case 1497: /* drop_option: FORCE  */
#line 11297 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 42847 "gram.c"
    break;

  case 1498: /* AlterCollationStmt: ALTER COLLATION any_name REFRESH VERSION_P  */
#line 11309 "gram.y"
                                {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 42858 "gram.c"
    break;

  case 1499: /* AlterSystemStmt: ALTER SYSTEM_P SET generic_set  */
#line 11327 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42869 "gram.c"
    break;

  case 1500: /* AlterSystemStmt: ALTER SYSTEM_P RESET generic_reset  */
#line 11334 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42880 "gram.c"
    break;

  case 1501: /* CreateDomainStmt: CREATE DOMAIN_P any_name opt_as Typename ColQualList  */
#line 11351 "gram.y"
                                {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 42894 "gram.c"
    break;

  case 1502: /* AlterDomainStmt: ALTER DOMAIN_P any_name alter_column_default  */
#line 11365 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42907 "gram.c"
    break;

  case 1503: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP NOT NULL_P  */
#line 11375 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42919 "gram.c"
    break;

  case 1504: /* AlterDomainStmt: ALTER DOMAIN_P any_name SET NOT NULL_P  */
#line 11384 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42931 "gram.c"
    break;

  case 1505: /* AlterDomainStmt: ALTER DOMAIN_P any_name ADD_P TableConstraint  */
#line 11393 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42944 "gram.c"
    break;

  case 1506: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT name opt_drop_behavior  */
#line 11403 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42959 "gram.c"
    break;

  case 1507: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 11415 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42974 "gram.c"
    break;

  case 1508: /* AlterDomainStmt: ALTER DOMAIN_P any_name VALIDATE CONSTRAINT name  */
#line 11427 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42987 "gram.c"
    break;

  case 1511: /* AlterTSDictionaryStmt: ALTER TEXT_P SEARCH DICTIONARY any_name definition  */
#line 11450 "gram.y"
                                {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42999 "gram.c"
    break;

  case 1512: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ADD_P MAPPING FOR name_list any_with any_name_list  */
#line 11461 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43015 "gram.c"
    break;

  case 1513: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list any_with any_name_list  */
#line 11473 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43031 "gram.c"
    break;

  case 1514: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING REPLACE any_name any_with any_name  */
#line 11485 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43047 "gram.c"
    break;

  case 1515: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list REPLACE any_name any_with any_name  */
#line 11497 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43063 "gram.c"
    break;

  case 1516: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING FOR name_list  */
#line 11509 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43077 "gram.c"
    break;

  case 1517: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING IF_P EXISTS FOR name_list  */
#line 11519 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43091 "gram.c"
    break;

  case 1520: /* CreateConversionStmt: CREATE opt_default CONVERSION_P any_name FOR Sconst TO Sconst FROM any_name  */
#line 11548 "gram.y"
                        {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 43106 "gram.c"
    break;

  case 1521: /* ClusterStmt: CLUSTER opt_verbose qualified_name cluster_index_specification  */
#line 11572 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 43121 "gram.c"
    break;

  case 1522: /* ClusterStmt: CLUSTER '(' utility_option_list ')' qualified_name cluster_index_specification  */
#line 11584 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43134 "gram.c"
    break;

  case 1523: /* ClusterStmt: CLUSTER opt_verbose  */
#line 11593 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 43149 "gram.c"
    break;

  case 1524: /* ClusterStmt: CLUSTER opt_verbose name ON qualified_name  */
#line 11605 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43164 "gram.c"
    break;

  case 1525: /* cluster_index_specification: USING name  */
#line 11618 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43170 "gram.c"
    break;

  case 1526: /* cluster_index_specification: %empty  */
#line 11619 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 43176 "gram.c"
    break;

  case 1527: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose opt_analyze opt_vacuum_relation_list  */
#line 11632 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43201 "gram.c"
    break;

  case 1528: /* VacuumStmt: VACUUM '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11653 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43214 "gram.c"
    break;

  case 1529: /* AnalyzeStmt: analyze_keyword opt_verbose opt_vacuum_relation_list  */
#line 11664 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43230 "gram.c"
    break;

  case 1530: /* AnalyzeStmt: analyze_keyword '(' utility_option_list ')' opt_vacuum_relation_list  */
#line 11676 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43243 "gram.c"
    break;

  case 1531: /* utility_option_list: utility_option_elem  */
#line 11688 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 43251 "gram.c"
    break;

  case 1532: /* utility_option_list: utility_option_list ',' utility_option_elem  */
#line 11692 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 43259 "gram.c"
    break;

  case 1535: /* utility_option_elem: utility_option_name utility_option_arg  */
#line 11704 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43267 "gram.c"
    break;

  case 1536: /* utility_option_name: NonReservedWord  */
#line 11710 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 43273 "gram.c"
    break;

  case 1537: /* utility_option_name: analyze_keyword  */
#line 11711 "gram.y"
                                                                                        { (yyval.str) = "analyze"; }
#line 43279 "gram.c"
    break;

  case 1538: /* utility_option_name: FORMAT_LA  */
#line 11712 "gram.y"
                                                                                                { (yyval.str) = "format"; }
#line 43285 "gram.c"
    break;

  case 1539: /* utility_option_arg: opt_boolean_or_string  */
#line 11716 "gram.y"
                                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43291 "gram.c"
    break;

  case 1540: /* utility_option_arg: NumericOnly  */
#line 11717 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43297 "gram.c"
    break;

  case 1541: /* utility_option_arg: %empty  */
#line 11718 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 43303 "gram.c"
    break;

  case 1542: /* opt_analyze: analyze_keyword  */
#line 11722 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 43309 "gram.c"
    break;

  case 1543: /* opt_analyze: %empty  */
#line 11723 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43315 "gram.c"
    break;

  case 1544: /* opt_verbose: VERBOSE  */
#line 11727 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 43321 "gram.c"
    break;

  case 1545: /* opt_verbose: %empty  */
#line 11728 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43327 "gram.c"
    break;

  case 1546: /* opt_full: FULL  */
#line 11731 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 43333 "gram.c"
    break;

  case 1547: /* opt_full: %empty  */
#line 11732 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43339 "gram.c"
    break;

  case 1548: /* opt_freeze: FREEZE  */
#line 11735 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 43345 "gram.c"
    break;

  case 1549: /* opt_freeze: %empty  */
#line 11736 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 43351 "gram.c"
    break;

  case 1550: /* opt_name_list: '(' name_list ')'  */
#line 11740 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43357 "gram.c"
    break;

  case 1551: /* opt_name_list: %empty  */
#line 11741 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43363 "gram.c"
    break;

  case 1552: /* vacuum_relation: qualified_name opt_name_list  */
#line 11746 "gram.y"
                                {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 43371 "gram.c"
    break;

  case 1553: /* vacuum_relation_list: vacuum_relation  */
#line 11753 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43377 "gram.c"
    break;

  case 1554: /* vacuum_relation_list: vacuum_relation_list ',' vacuum_relation  */
#line 11755 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43383 "gram.c"
    break;

  case 1555: /* opt_vacuum_relation_list: vacuum_relation_list  */
#line 11759 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 43389 "gram.c"
    break;

  case 1556: /* opt_vacuum_relation_list: %empty  */
#line 11760 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43395 "gram.c"
    break;

  case 1557: /* ExplainStmt: EXPLAIN ExplainableStmt  */
#line 11774 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 43407 "gram.c"
    break;

  case 1558: /* ExplainStmt: EXPLAIN analyze_keyword opt_verbose ExplainableStmt  */
#line 11782 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43422 "gram.c"
    break;

  case 1559: /* ExplainStmt: EXPLAIN VERBOSE ExplainableStmt  */
#line 11793 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43434 "gram.c"
    break;

  case 1560: /* ExplainStmt: EXPLAIN '(' utility_option_list ')' ExplainableStmt  */
#line 11801 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43446 "gram.c"
    break;

  case 1571: /* PrepareStmt: PREPARE name prep_type_clause AS PreparableStmt  */
#line 11831 "gram.y"
                                {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43459 "gram.c"
    break;

  case 1572: /* prep_type_clause: '(' type_list ')'  */
#line 11841 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43465 "gram.c"
    break;

  case 1573: /* prep_type_clause: %empty  */
#line 11842 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 43471 "gram.c"
    break;

  case 1579: /* ExecuteStmt: EXECUTE name execute_param_clause  */
#line 11861 "gram.y"
                                {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43483 "gram.c"
    break;

  case 1580: /* ExecuteStmt: CREATE OptTemp TABLE create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 11870 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43504 "gram.c"
    break;

  case 1581: /* ExecuteStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 11888 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43525 "gram.c"
    break;

  case 1582: /* execute_param_clause: '(' expr_list ')'  */
#line 11906 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 43531 "gram.c"
    break;

  case 1583: /* execute_param_clause: %empty  */
#line 11907 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43537 "gram.c"
    break;

  case 1584: /* DeallocateStmt: DEALLOCATE name  */
#line 11918 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 43548 "gram.c"
    break;

  case 1585: /* DeallocateStmt: DEALLOCATE PREPARE name  */
#line 11925 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 43559 "gram.c"
    break;

  case 1586: /* DeallocateStmt: DEALLOCATE ALL  */
#line 11932 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 43570 "gram.c"
    break;

  case 1587: /* DeallocateStmt: DEALLOCATE PREPARE ALL  */
#line 11939 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 43581 "gram.c"
    break;

  case 1588: /* InsertStmt: opt_with_clause INSERT INTO insert_target insert_rest opt_on_conflict returning_clause  */
#line 11957 "gram.y"
                                {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 43593 "gram.c"
    break;

  case 1589: /* insert_target: qualified_name  */
#line 11974 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 43601 "gram.c"
    break;

  case 1590: /* insert_target: qualified_name AS ColId  */
#line 11978 "gram.y"
                                {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 43610 "gram.c"
    break;

  case 1591: /* insert_rest: SelectStmt  */
#line 11986 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43620 "gram.c"
    break;

  case 1592: /* insert_rest: OVERRIDING override_kind VALUE_P SelectStmt  */
#line 11992 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43631 "gram.c"
    break;

  case 1593: /* insert_rest: '(' insert_column_list ')' SelectStmt  */
#line 11999 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43641 "gram.c"
    break;

  case 1594: /* insert_rest: '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt  */
#line 12005 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43652 "gram.c"
    break;

  case 1595: /* insert_rest: DEFAULT VALUES  */
#line 12012 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 43662 "gram.c"
    break;

  case 1596: /* override_kind: USER  */
#line 12020 "gram.y"
                                        { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 43668 "gram.c"
    break;

  case 1597: /* override_kind: SYSTEM_P  */
#line 12021 "gram.y"
                                        { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 43674 "gram.c"
    break;

  case 1598: /* insert_column_list: insert_column_item  */
#line 12026 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43680 "gram.c"
    break;

  case 1599: /* insert_column_list: insert_column_list ',' insert_column_item  */
#line 12028 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43686 "gram.c"
    break;

  case 1600: /* insert_column_item: ColId opt_indirection  */
#line 12033 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43698 "gram.c"
    break;

  case 1601: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO UPDATE SET set_clause_list where_clause  */
#line 12044 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 43711 "gram.c"
    break;

  case 1602: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO NOTHING  */
#line 12054 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 43724 "gram.c"
    break;

  case 1603: /* opt_on_conflict: %empty  */
#line 12063 "gram.y"
                                {
					(yyval.onconflict) = NULL;
				}
#line 43732 "gram.c"
    break;

  case 1604: /* opt_conf_expr: '(' index_params ')' where_clause  */
#line 12070 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 43744 "gram.c"
    break;

  case 1605: /* opt_conf_expr: ON CONSTRAINT name  */
#line 12079 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 43756 "gram.c"
    break;

  case 1606: /* opt_conf_expr: %empty  */
#line 12087 "gram.y"
                                {
					(yyval.infer) = NULL;
				}
#line 43764 "gram.c"
    break;

  case 1607: /* returning_clause: RETURNING target_list  */
#line 12093 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43770 "gram.c"
    break;

  case 1608: /* returning_clause: %empty  */
#line 12094 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 43776 "gram.c"
    break;

  case 1609: /* DeleteStmt: opt_with_clause DELETE_P FROM relation_expr_opt_alias using_clause where_or_current_clause returning_clause  */
#line 12107 "gram.y"
                                {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 43791 "gram.c"
    break;

  case 1610: /* using_clause: USING from_list  */
#line 12120 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43797 "gram.c"
    break;

  case 1611: /* using_clause: %empty  */
#line 12121 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43803 "gram.c"
    break;

  case 1612: /* LockStmt: LOCK_P opt_table relation_expr_list opt_lock opt_nowait  */
#line 12133 "gram.y"
                                {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43816 "gram.c"
    break;

  case 1613: /* opt_lock: IN_P lock_type MODE  */
#line 12143 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival); }
#line 43822 "gram.c"
    break;

  case 1614: /* opt_lock: %empty  */
#line 12144 "gram.y"
                                                                                { (yyval.ival) = AccessExclusiveLock; }
#line 43828 "gram.c"
    break;

  case 1615: /* lock_type: ACCESS SHARE  */
#line 12147 "gram.y"
                                                                { (yyval.ival) = AccessShareLock; }
#line 43834 "gram.c"
    break;

  case 1616: /* lock_type: ROW SHARE  */
#line 12148 "gram.y"
                                                                                { (yyval.ival) = RowShareLock; }
#line 43840 "gram.c"
    break;

  case 1617: /* lock_type: ROW EXCLUSIVE  */
#line 12149 "gram.y"
                                                                        { (yyval.ival) = RowExclusiveLock; }
#line 43846 "gram.c"
    break;

  case 1618: /* lock_type: SHARE UPDATE EXCLUSIVE  */
#line 12150 "gram.y"
                                                                { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 43852 "gram.c"
    break;

  case 1619: /* lock_type: SHARE  */
#line 12151 "gram.y"
                                                                                { (yyval.ival) = ShareLock; }
#line 43858 "gram.c"
    break;

  case 1620: /* lock_type: SHARE ROW EXCLUSIVE  */
#line 12152 "gram.y"
                                                                { (yyval.ival) = ShareRowExclusiveLock; }
#line 43864 "gram.c"
    break;

  case 1621: /* lock_type: EXCLUSIVE  */
#line 12153 "gram.y"
                                                                                { (yyval.ival) = ExclusiveLock; }
#line 43870 "gram.c"
    break;

  case 1622: /* lock_type: ACCESS EXCLUSIVE  */
#line 12154 "gram.y"
                                                                        { (yyval.ival) = AccessExclusiveLock; }
#line 43876 "gram.c"
    break;

  case 1623: /* opt_nowait: NOWAIT  */
#line 12157 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 43882 "gram.c"
    break;

  case 1624: /* opt_nowait: %empty  */
#line 12158 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 43888 "gram.c"
    break;

  case 1625: /* opt_nowait_or_skip: NOWAIT  */
#line 12162 "gram.y"
                                                                                { (yyval.ival) = LockWaitError; }
#line 43894 "gram.c"
    break;

  case 1626: /* opt_nowait_or_skip: SKIP LOCKED  */
#line 12163 "gram.y"
                                                                        { (yyval.ival) = LockWaitSkip; }
#line 43900 "gram.c"
    break;

  case 1627: /* opt_nowait_or_skip: %empty  */
#line 12164 "gram.y"
                                                                                { (yyval.ival) = LockWaitBlock; }
#line 43906 "gram.c"
    break;

  case 1628: /* UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias SET set_clause_list from_clause where_or_current_clause returning_clause  */
#line 12180 "gram.y"
                                {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 43922 "gram.c"
    break;

  case 1629: /* set_clause_list: set_clause  */
#line 12194 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43928 "gram.c"
    break;

  case 1630: /* set_clause_list: set_clause_list ',' set_clause  */
#line 12195 "gram.y"
                                                                { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 43934 "gram.c"
    break;

  case 1631: /* set_clause: set_target '=' a_expr  */
#line 12200 "gram.y"
                                {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 43943 "gram.c"
    break;

  case 1632: /* set_clause: '(' set_target_list ')' '=' a_expr  */
#line 12205 "gram.y"
                                {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 43968 "gram.c"
    break;

  case 1633: /* set_target: ColId opt_indirection  */
#line 12229 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43980 "gram.c"
    break;

  case 1634: /* set_target_list: set_target  */
#line 12239 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43986 "gram.c"
    break;

  case 1635: /* set_target_list: set_target_list ',' set_target  */
#line 12240 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 43992 "gram.c"
    break;

  case 1636: /* MergeStmt: opt_with_clause MERGE INTO relation_expr_opt_alias USING table_ref ON a_expr merge_when_list  */
#line 12256 "gram.y"
                                {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 44008 "gram.c"
    break;

  case 1637: /* merge_when_list: merge_when_clause  */
#line 12270 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44014 "gram.c"
    break;

  case 1638: /* merge_when_list: merge_when_list merge_when_clause  */
#line 12271 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 44020 "gram.c"
    break;

  case 1639: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN merge_update  */
#line 12276 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44031 "gram.c"
    break;

  case 1640: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN merge_delete  */
#line 12283 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44042 "gram.c"
    break;

  case 1641: /* merge_when_clause: WHEN NOT MATCHED opt_merge_when_condition THEN merge_insert  */
#line 12290 "gram.y"
                                {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44053 "gram.c"
    break;

  case 1642: /* merge_when_clause: WHEN MATCHED opt_merge_when_condition THEN DO NOTHING  */
#line 12297 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 44067 "gram.c"
    break;

  case 1643: /* merge_when_clause: WHEN NOT MATCHED opt_merge_when_condition THEN DO NOTHING  */
#line 12307 "gram.y"
                                {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 44081 "gram.c"
    break;

  case 1644: /* opt_merge_when_condition: AND a_expr  */
#line 12319 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44087 "gram.c"
    break;

  case 1645: /* opt_merge_when_condition: %empty  */
#line 12320 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 44093 "gram.c"
    break;

  case 1646: /* merge_update: UPDATE SET set_clause_list  */
#line 12325 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 44107 "gram.c"
    break;

  case 1647: /* merge_delete: DELETE_P  */
#line 12338 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 44121 "gram.c"
    break;

  case 1648: /* merge_insert: INSERT merge_values_clause  */
#line 12351 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44134 "gram.c"
    break;

  case 1649: /* merge_insert: INSERT OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12360 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44147 "gram.c"
    break;

  case 1650: /* merge_insert: INSERT '(' insert_column_list ')' merge_values_clause  */
#line 12369 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44160 "gram.c"
    break;

  case 1651: /* merge_insert: INSERT '(' insert_column_list ')' OVERRIDING override_kind VALUE_P merge_values_clause  */
#line 12378 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44173 "gram.c"
    break;

  case 1652: /* merge_insert: INSERT DEFAULT VALUES  */
#line 12387 "gram.y"
                                {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 44186 "gram.c"
    break;

  case 1653: /* merge_values_clause: VALUES '(' expr_list ')'  */
#line 12399 "gram.y"
                                {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 44194 "gram.c"
    break;

  case 1654: /* DeclareCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR SelectStmt  */
#line 12411 "gram.y"
                                {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44208 "gram.c"
    break;

  case 1655: /* cursor_name: name  */
#line 12422 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44214 "gram.c"
    break;

  case 1656: /* cursor_options: %empty  */
#line 12425 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 44220 "gram.c"
    break;

  case 1657: /* cursor_options: cursor_options NO SCROLL  */
#line 12426 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 44226 "gram.c"
    break;

  case 1658: /* cursor_options: cursor_options SCROLL  */
#line 12427 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 44232 "gram.c"
    break;

  case 1659: /* cursor_options: cursor_options BINARY  */
#line 12428 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 44238 "gram.c"
    break;

  case 1660: /* cursor_options: cursor_options ASENSITIVE  */
#line 12429 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 44244 "gram.c"
    break;

  case 1661: /* cursor_options: cursor_options INSENSITIVE  */
#line 12430 "gram.y"
                                                        { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 44250 "gram.c"
    break;

  case 1662: /* opt_hold: %empty  */
#line 12433 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 44256 "gram.c"
    break;

  case 1663: /* opt_hold: WITH HOLD  */
#line 12434 "gram.y"
                                                                                { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 44262 "gram.c"
    break;

  case 1664: /* opt_hold: WITHOUT HOLD  */
#line 12435 "gram.y"
                                                                        { (yyval.ival) = 0; }
#line 44268 "gram.c"
    break;

  case 1667: /* select_with_parens: '(' select_no_parens ')'  */
#line 12488 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 44274 "gram.c"
    break;

  case 1668: /* select_with_parens: '(' select_with_parens ')'  */
#line 12489 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 44280 "gram.c"
    break;

  case 1669: /* select_no_parens: simple_select  */
#line 12504 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44286 "gram.c"
    break;

  case 1670: /* select_no_parens: select_clause sort_clause  */
#line 12506 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44297 "gram.c"
    break;

  case 1671: /* select_no_parens: select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12513 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44309 "gram.c"
    break;

  case 1672: /* select_no_parens: select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12521 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44321 "gram.c"
    break;

  case 1673: /* select_no_parens: with_clause select_clause  */
#line 12529 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 44333 "gram.c"
    break;

  case 1674: /* select_no_parens: with_clause select_clause sort_clause  */
#line 12537 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44345 "gram.c"
    break;

  case 1675: /* select_no_parens: with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 12545 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44357 "gram.c"
    break;

  case 1676: /* select_no_parens: with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 12553 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44369 "gram.c"
    break;

  case 1677: /* select_clause: simple_select  */
#line 12563 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44375 "gram.c"
    break;

  case 1678: /* select_clause: select_with_parens  */
#line 12564 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44381 "gram.c"
    break;

  case 1679: /* simple_select: SELECT opt_all_clause opt_target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12599 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44399 "gram.c"
    break;

  case 1680: /* simple_select: SELECT distinct_clause target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 12615 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44418 "gram.c"
    break;

  case 1681: /* simple_select: values_clause  */
#line 12629 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44424 "gram.c"
    break;

  case 1682: /* simple_select: TABLE relation_expr  */
#line 12631 "gram.y"
                                {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 44447 "gram.c"
    break;

  case 1683: /* simple_select: select_clause UNION set_quantifier select_clause  */
#line 12650 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44455 "gram.c"
    break;

  case 1684: /* simple_select: select_clause INTERSECT set_quantifier select_clause  */
#line 12654 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44463 "gram.c"
    break;

  case 1685: /* simple_select: select_clause EXCEPT set_quantifier select_clause  */
#line 12658 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44471 "gram.c"
    break;

  case 1686: /* with_clause: WITH cte_list  */
#line 12673 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44482 "gram.c"
    break;

  case 1687: /* with_clause: WITH_LA cte_list  */
#line 12680 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44493 "gram.c"
    break;

  case 1688: /* with_clause: WITH RECURSIVE cte_list  */
#line 12687 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 44504 "gram.c"
    break;

  case 1689: /* cte_list: common_table_expr  */
#line 12696 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44510 "gram.c"
    break;

  case 1690: /* cte_list: cte_list ',' common_table_expr  */
#line 12697 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44516 "gram.c"
    break;

  case 1691: /* common_table_expr: name opt_name_list AS opt_materialized '(' PreparableStmt ')' opt_search_clause opt_cycle_clause  */
#line 12701 "gram.y"
                        {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 44533 "gram.c"
    break;

  case 1692: /* opt_materialized: MATERIALIZED  */
#line 12716 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeAlways; }
#line 44539 "gram.c"
    break;

  case 1693: /* opt_materialized: NOT MATERIALIZED  */
#line 12717 "gram.y"
                                                                                { (yyval.ival) = CTEMaterializeNever; }
#line 44545 "gram.c"
    break;

  case 1694: /* opt_materialized: %empty  */
#line 12718 "gram.y"
                                                                                        { (yyval.ival) = CTEMaterializeDefault; }
#line 44551 "gram.c"
    break;

  case 1695: /* opt_search_clause: SEARCH DEPTH FIRST_P BY columnList SET ColId  */
#line 12723 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44565 "gram.c"
    break;

  case 1696: /* opt_search_clause: SEARCH BREADTH FIRST_P BY columnList SET ColId  */
#line 12733 "gram.y"
                        {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44579 "gram.c"
    break;

  case 1697: /* opt_search_clause: %empty  */
#line 12743 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 44587 "gram.c"
    break;

  case 1698: /* opt_cycle_clause: CYCLE columnList SET ColId TO AexprConst DEFAULT AexprConst USING ColId  */
#line 12750 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 44603 "gram.c"
    break;

  case 1699: /* opt_cycle_clause: CYCLE columnList SET ColId USING ColId  */
#line 12762 "gram.y"
                        {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 44619 "gram.c"
    break;

  case 1700: /* opt_cycle_clause: %empty  */
#line 12774 "gram.y"
                        {
				(yyval.node) = NULL;
			}
#line 44627 "gram.c"
    break;

  case 1701: /* opt_with_clause: with_clause  */
#line 12780 "gram.y"
                                                                                        { (yyval.with) = (yyvsp[0].with); }
#line 44633 "gram.c"
    break;

  case 1702: /* opt_with_clause: %empty  */
#line 12781 "gram.y"
                                                                                        { (yyval.with) = NULL; }
#line 44639 "gram.c"
    break;

  case 1703: /* into_clause: INTO OptTempTableName  */
#line 12786 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 44654 "gram.c"
    break;

  case 1704: /* into_clause: %empty  */
#line 12797 "gram.y"
                                { (yyval.into) = NULL; }
#line 44660 "gram.c"
    break;

  case 1705: /* OptTempTableName: TEMPORARY opt_table qualified_name  */
#line 12806 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44669 "gram.c"
    break;

  case 1706: /* OptTempTableName: TEMP opt_table qualified_name  */
#line 12811 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44678 "gram.c"
    break;

  case 1707: /* OptTempTableName: LOCAL TEMPORARY opt_table qualified_name  */
#line 12816 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44687 "gram.c"
    break;

  case 1708: /* OptTempTableName: LOCAL TEMP opt_table qualified_name  */
#line 12821 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44696 "gram.c"
    break;

  case 1709: /* OptTempTableName: GLOBAL TEMPORARY opt_table qualified_name  */
#line 12826 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44708 "gram.c"
    break;

  case 1710: /* OptTempTableName: GLOBAL TEMP opt_table qualified_name  */
#line 12834 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44720 "gram.c"
    break;

  case 1711: /* OptTempTableName: UNLOGGED opt_table qualified_name  */
#line 12842 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 44729 "gram.c"
    break;

  case 1712: /* OptTempTableName: TABLE qualified_name  */
#line 12847 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44738 "gram.c"
    break;

  case 1713: /* OptTempTableName: qualified_name  */
#line 12852 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44747 "gram.c"
    break;

  case 1716: /* set_quantifier: ALL  */
#line 12863 "gram.y"
                                                                                                        { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 44753 "gram.c"
    break;

  case 1717: /* set_quantifier: DISTINCT  */
#line 12864 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 44759 "gram.c"
    break;

  case 1718: /* set_quantifier: %empty  */
#line 12865 "gram.y"
                                                                                                { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 44765 "gram.c"
    break;

  case 1719: /* distinct_clause: DISTINCT  */
#line 12872 "gram.y"
                                                                                                { (yyval.list) = list_make1(NIL); }
#line 44771 "gram.c"
    break;

  case 1720: /* distinct_clause: DISTINCT ON '(' expr_list ')'  */
#line 12873 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 44777 "gram.c"
    break;

  case 1723: /* opt_distinct_clause: distinct_clause  */
#line 12882 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44783 "gram.c"
    break;

  case 1724: /* opt_distinct_clause: opt_all_clause  */
#line 12883 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 44789 "gram.c"
    break;

  case 1725: /* opt_sort_clause: sort_clause  */
#line 12887 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 44795 "gram.c"
    break;

  case 1726: /* opt_sort_clause: %empty  */
#line 12888 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44801 "gram.c"
    break;

  case 1727: /* sort_clause: ORDER BY sortby_list  */
#line 12892 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 44807 "gram.c"
    break;

  case 1728: /* sortby_list: sortby  */
#line 12896 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 44813 "gram.c"
    break;

  case 1729: /* sortby_list: sortby_list ',' sortby  */
#line 12897 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 44819 "gram.c"
    break;

  case 1730: /* sortby: a_expr USING qual_all_Op opt_nulls_order  */
#line 12901 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 44832 "gram.c"
    break;

  case 1731: /* sortby: a_expr opt_asc_desc opt_nulls_order  */
#line 12910 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 44845 "gram.c"
    break;

  case 1732: /* select_limit: limit_clause offset_clause  */
#line 12923 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 44854 "gram.c"
    break;

  case 1733: /* select_limit: offset_clause limit_clause  */
#line 12928 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 44863 "gram.c"
    break;

  case 1734: /* select_limit: limit_clause  */
#line 12933 "gram.y"
                                {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 44871 "gram.c"
    break;

  case 1735: /* select_limit: offset_clause  */
#line 12937 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44884 "gram.c"
    break;

  case 1736: /* opt_select_limit: select_limit  */
#line 12948 "gram.y"
                                                                                { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 44890 "gram.c"
    break;

  case 1737: /* opt_select_limit: %empty  */
#line 12949 "gram.y"
                                                                                { (yyval.selectlimit) = NULL; }
#line 44896 "gram.c"
    break;

  case 1738: /* limit_clause: LIMIT select_limit_value  */
#line 12954 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44909 "gram.c"
    break;

  case 1739: /* limit_clause: LIMIT select_limit_value ',' select_offset_value  */
#line 12963 "gram.y"
                                {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 44922 "gram.c"
    break;

  case 1740: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows ONLY  */
#line 12979 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44935 "gram.c"
    break;

  case 1741: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows WITH TIES  */
#line 12988 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44948 "gram.c"
    break;

  case 1742: /* limit_clause: FETCH first_or_next row_or_rows ONLY  */
#line 12997 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44961 "gram.c"
    break;

  case 1743: /* limit_clause: FETCH first_or_next row_or_rows WITH TIES  */
#line 13006 "gram.y"
                                {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44974 "gram.c"
    break;

  case 1744: /* offset_clause: OFFSET select_offset_value  */
#line 13018 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44980 "gram.c"
    break;

  case 1745: /* offset_clause: OFFSET select_fetch_first_value row_or_rows  */
#line 13021 "gram.y"
                                { (yyval.node) = (yyvsp[-1].node); }
#line 44986 "gram.c"
    break;

  case 1746: /* select_limit_value: a_expr  */
#line 13025 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44992 "gram.c"
    break;

  case 1747: /* select_limit_value: ALL  */
#line 13027 "gram.y"
                                {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 45001 "gram.c"
    break;

  case 1748: /* select_offset_value: a_expr  */
#line 13034 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45007 "gram.c"
    break;

  case 1749: /* select_fetch_first_value: c_expr  */
#line 13054 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45013 "gram.c"
    break;

  case 1750: /* select_fetch_first_value: '+' I_or_F_const  */
#line 13056 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 45019 "gram.c"
    break;

  case 1751: /* select_fetch_first_value: '-' I_or_F_const  */
#line 13058 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 45025 "gram.c"
    break;

  case 1752: /* I_or_F_const: Iconst  */
#line 13062 "gram.y"
                                                                                                { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 45031 "gram.c"
    break;

  case 1753: /* I_or_F_const: FCONST  */
#line 13063 "gram.y"
                                                                                                { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 45037 "gram.c"
    break;

  case 1754: /* row_or_rows: ROW  */
#line 13067 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 45043 "gram.c"
    break;

  case 1755: /* row_or_rows: ROWS  */
#line 13068 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 45049 "gram.c"
    break;

  case 1756: /* first_or_next: FIRST_P  */
#line 13071 "gram.y"
                                                                                { (yyval.ival) = 0; }
#line 45055 "gram.c"
    break;

  case 1757: /* first_or_next: NEXT  */
#line 13072 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 45061 "gram.c"
    break;

  case 1758: /* group_clause: GROUP_P BY set_quantifier group_by_list  */
#line 13098 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 45073 "gram.c"
    break;

  case 1759: /* group_clause: %empty  */
#line 13106 "gram.y"
                                {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 45085 "gram.c"
    break;

  case 1760: /* group_by_list: group_by_item  */
#line 13116 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45091 "gram.c"
    break;

  case 1761: /* group_by_list: group_by_list ',' group_by_item  */
#line 13117 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 45097 "gram.c"
    break;

  case 1762: /* group_by_item: a_expr  */
#line 13121 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45103 "gram.c"
    break;

  case 1763: /* group_by_item: empty_grouping_set  */
#line 13122 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45109 "gram.c"
    break;

  case 1764: /* group_by_item: cube_clause  */
#line 13123 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45115 "gram.c"
    break;

  case 1765: /* group_by_item: rollup_clause  */
#line 13124 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45121 "gram.c"
    break;

  case 1766: /* group_by_item: grouping_sets_clause  */
#line 13125 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 45127 "gram.c"
    break;

  case 1767: /* empty_grouping_set: '(' ')'  */
#line 13130 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 45135 "gram.c"
    break;

  case 1768: /* rollup_clause: ROLLUP '(' expr_list ')'  */
#line 13143 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45143 "gram.c"
    break;

  case 1769: /* cube_clause: CUBE '(' expr_list ')'  */
#line 13150 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45151 "gram.c"
    break;

  case 1770: /* grouping_sets_clause: GROUPING SETS '(' group_by_list ')'  */
#line 13157 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45159 "gram.c"
    break;

  case 1771: /* having_clause: HAVING a_expr  */
#line 13163 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45165 "gram.c"
    break;

  case 1772: /* having_clause: %empty  */
#line 13164 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 45171 "gram.c"
    break;

  case 1773: /* for_locking_clause: for_locking_items  */
#line 13168 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45177 "gram.c"
    break;

  case 1774: /* for_locking_clause: FOR READ ONLY  */
#line 13169 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45183 "gram.c"
    break;

  case 1775: /* opt_for_locking_clause: for_locking_clause  */
#line 13173 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45189 "gram.c"
    break;

  case 1776: /* opt_for_locking_clause: %empty  */
#line 13174 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45195 "gram.c"
    break;

  case 1777: /* for_locking_items: for_locking_item  */
#line 13178 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45201 "gram.c"
    break;

  case 1778: /* for_locking_items: for_locking_items for_locking_item  */
#line 13179 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 45207 "gram.c"
    break;

  case 1779: /* for_locking_item: for_locking_strength locked_rels_list opt_nowait_or_skip  */
#line 13184 "gram.y"
                                {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 45220 "gram.c"
    break;

  case 1780: /* for_locking_strength: FOR UPDATE  */
#line 13195 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORUPDATE; }
#line 45226 "gram.c"
    break;

  case 1781: /* for_locking_strength: FOR NO KEY UPDATE  */
#line 13196 "gram.y"
                                                                                { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 45232 "gram.c"
    break;

  case 1782: /* for_locking_strength: FOR SHARE  */
#line 13197 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORSHARE; }
#line 45238 "gram.c"
    break;

  case 1783: /* for_locking_strength: FOR KEY SHARE  */
#line 13198 "gram.y"
                                                                                { (yyval.ival) = LCS_FORKEYSHARE; }
#line 45244 "gram.c"
    break;

  case 1784: /* locked_rels_list: OF qualified_name_list  */
#line 13202 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 45250 "gram.c"
    break;

  case 1785: /* locked_rels_list: %empty  */
#line 13203 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45256 "gram.c"
    break;

  case 1786: /* values_clause: VALUES '(' expr_list ')'  */
#line 13214 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45267 "gram.c"
    break;

  case 1787: /* values_clause: values_clause ',' '(' expr_list ')'  */
#line 13221 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45278 "gram.c"
    break;

  case 1788: /* from_clause: FROM from_list  */
#line 13239 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45284 "gram.c"
    break;

  case 1789: /* from_clause: %empty  */
#line 13240 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45290 "gram.c"
    break;

  case 1790: /* from_list: table_ref  */
#line 13244 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45296 "gram.c"
    break;

  case 1791: /* from_list: from_list ',' table_ref  */
#line 13245 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45302 "gram.c"
    break;

  case 1792: /* table_ref: relation_expr opt_alias_clause  */
#line 13252 "gram.y"
                                {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 45311 "gram.c"
    break;

  case 1793: /* table_ref: relation_expr opt_alias_clause tablesample_clause  */
#line 13257 "gram.y"
                                {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 45324 "gram.c"
    break;

  case 1794: /* table_ref: func_table func_alias_clause  */
#line 13266 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45336 "gram.c"
    break;

  case 1795: /* table_ref: LATERAL_P func_table func_alias_clause  */
#line 13274 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45349 "gram.c"
    break;

  case 1796: /* table_ref: xmltable opt_alias_clause  */
#line 13283 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45360 "gram.c"
    break;

  case 1797: /* table_ref: LATERAL_P xmltable opt_alias_clause  */
#line 13290 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45372 "gram.c"
    break;

  case 1798: /* table_ref: select_with_parens opt_alias_clause  */
#line 13298 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45385 "gram.c"
    break;

  case 1799: /* table_ref: LATERAL_P select_with_parens opt_alias_clause  */
#line 13307 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45398 "gram.c"
    break;

  case 1800: /* table_ref: joined_table  */
#line 13316 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 45406 "gram.c"
    break;

  case 1801: /* table_ref: '(' joined_table ')' alias_clause  */
#line 13320 "gram.y"
                                {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 45415 "gram.c"
    break;

  case 1802: /* joined_table: '(' joined_table ')'  */
#line 13346 "gram.y"
                                {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 45423 "gram.c"
    break;

  case 1803: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 13350 "gram.y"
                                {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 45441 "gram.c"
    break;

  case 1804: /* joined_table: table_ref join_type JOIN table_ref join_qual  */
#line 13364 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45466 "gram.c"
    break;

  case 1805: /* joined_table: table_ref JOIN table_ref join_qual  */
#line 13385 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45492 "gram.c"
    break;

  case 1806: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 13407 "gram.y"
                                {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45509 "gram.c"
    break;

  case 1807: /* joined_table: table_ref NATURAL JOIN table_ref  */
#line 13420 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45527 "gram.c"
    break;

  case 1808: /* alias_clause: AS ColId '(' name_list ')'  */
#line 13437 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45537 "gram.c"
    break;

  case 1809: /* alias_clause: AS ColId  */
#line 13443 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45546 "gram.c"
    break;

  case 1810: /* alias_clause: ColId '(' name_list ')'  */
#line 13448 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45556 "gram.c"
    break;

  case 1811: /* alias_clause: ColId  */
#line 13454 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45565 "gram.c"
    break;

  case 1812: /* opt_alias_clause: alias_clause  */
#line 13460 "gram.y"
                                                                        { (yyval.alias) = (yyvsp[0].alias); }
#line 45571 "gram.c"
    break;

  case 1813: /* opt_alias_clause: %empty  */
#line 13461 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 45577 "gram.c"
    break;

  case 1814: /* opt_alias_clause_for_join_using: AS ColId  */
#line 13472 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 45587 "gram.c"
    break;

  case 1815: /* opt_alias_clause_for_join_using: %empty  */
#line 13477 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 45593 "gram.c"
    break;

  case 1816: /* func_alias_clause: alias_clause  */
#line 13486 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 45601 "gram.c"
    break;

  case 1817: /* func_alias_clause: AS '(' TableFuncElementList ')'  */
#line 13490 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 45609 "gram.c"
    break;

  case 1818: /* func_alias_clause: AS ColId '(' TableFuncElementList ')'  */
#line 13494 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45620 "gram.c"
    break;

  case 1819: /* func_alias_clause: ColId '(' TableFuncElementList ')'  */
#line 13501 "gram.y"
                                {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45631 "gram.c"
    break;

  case 1820: /* func_alias_clause: %empty  */
#line 13508 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 45639 "gram.c"
    break;

  case 1821: /* join_type: FULL opt_outer  */
#line 13513 "gram.y"
                                                                                { (yyval.jtype) = JOIN_FULL; }
#line 45645 "gram.c"
    break;

  case 1822: /* join_type: LEFT opt_outer  */
#line 13514 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_LEFT; }
#line 45651 "gram.c"
    break;

  case 1823: /* join_type: RIGHT opt_outer  */
#line 13515 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_RIGHT; }
#line 45657 "gram.c"
    break;

  case 1824: /* join_type: INNER_P  */
#line 13516 "gram.y"
                                                                                                { (yyval.jtype) = JOIN_INNER; }
#line 45663 "gram.c"
    break;

  case 1827: /* join_qual: USING '(' name_list ')' opt_alias_clause_for_join_using  */
#line 13537 "gram.y"
                                {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 45671 "gram.c"
    break;

  case 1828: /* join_qual: ON a_expr  */
#line 13541 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45679 "gram.c"
    break;

  case 1829: /* relation_expr: qualified_name  */
#line 13549 "gram.y"
                                {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45690 "gram.c"
    break;

  case 1830: /* relation_expr: extended_relation_expr  */
#line 13556 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45698 "gram.c"
    break;

  case 1831: /* extended_relation_expr: qualified_name '*'  */
#line 13563 "gram.y"
                                {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45709 "gram.c"
    break;

  case 1832: /* extended_relation_expr: ONLY qualified_name  */
#line 13570 "gram.y"
                                {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45720 "gram.c"
    break;

  case 1833: /* extended_relation_expr: ONLY '(' qualified_name ')'  */
#line 13577 "gram.y"
                                {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45731 "gram.c"
    break;

  case 1834: /* relation_expr_list: relation_expr  */
#line 13587 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 45737 "gram.c"
    break;

  case 1835: /* relation_expr_list: relation_expr_list ',' relation_expr  */
#line 13588 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 45743 "gram.c"
    break;

  case 1836: /* relation_expr_opt_alias: relation_expr  */
#line 13602 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45751 "gram.c"
    break;

  case 1837: /* relation_expr_opt_alias: relation_expr ColId  */
#line 13606 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 45763 "gram.c"
    break;

  case 1838: /* relation_expr_opt_alias: relation_expr AS ColId  */
#line 13614 "gram.y"
                                {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45775 "gram.c"
    break;

  case 1839: /* tablesample_clause: TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause  */
#line 13628 "gram.y"
                                {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 45790 "gram.c"
    break;

  case 1840: /* opt_repeatable_clause: REPEATABLE '(' a_expr ')'  */
#line 13641 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 45796 "gram.c"
    break;

  case 1841: /* opt_repeatable_clause: %empty  */
#line 13642 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 45802 "gram.c"
    break;

  case 1842: /* func_table: func_expr_windowless opt_ordinality  */
#line 13658 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45817 "gram.c"
    break;

  case 1843: /* func_table: ROWS FROM '(' rowsfrom_list ')' opt_ordinality  */
#line 13669 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45832 "gram.c"
    break;

  case 1844: /* rowsfrom_item: func_expr_windowless opt_col_def_list  */
#line 13682 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 45838 "gram.c"
    break;

  case 1845: /* rowsfrom_list: rowsfrom_item  */
#line 13686 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 45844 "gram.c"
    break;

  case 1846: /* rowsfrom_list: rowsfrom_list ',' rowsfrom_item  */
#line 13687 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 45850 "gram.c"
    break;

  case 1847: /* opt_col_def_list: AS '(' TableFuncElementList ')'  */
#line 13690 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45856 "gram.c"
    break;

  case 1848: /* opt_col_def_list: %empty  */
#line 13691 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45862 "gram.c"
    break;

  case 1849: /* opt_ordinality: WITH_LA ORDINALITY  */
#line 13694 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 45868 "gram.c"
    break;

  case 1850: /* opt_ordinality: %empty  */
#line 13695 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 45874 "gram.c"
    break;

  case 1851: /* where_clause: WHERE a_expr  */
#line 13700 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45880 "gram.c"
    break;

  case 1852: /* where_clause: %empty  */
#line 13701 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 45886 "gram.c"
    break;

  case 1853: /* where_or_current_clause: WHERE a_expr  */
#line 13706 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 45892 "gram.c"
    break;

  case 1854: /* where_or_current_clause: WHERE CURRENT_P OF cursor_name  */
#line 13708 "gram.y"
                                {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 45905 "gram.c"
    break;

  case 1855: /* where_or_current_clause: %empty  */
#line 13716 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 45911 "gram.c"
    break;

  case 1856: /* OptTableFuncElementList: TableFuncElementList  */
#line 13721 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45917 "gram.c"
    break;

  case 1857: /* OptTableFuncElementList: %empty  */
#line 13722 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45923 "gram.c"
    break;

  case 1858: /* TableFuncElementList: TableFuncElement  */
#line 13727 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45931 "gram.c"
    break;

  case 1859: /* TableFuncElementList: TableFuncElementList ',' TableFuncElement  */
#line 13731 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45939 "gram.c"
    break;

  case 1860: /* TableFuncElement: ColId Typename opt_collate_clause  */
#line 13737 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 45962 "gram.c"
    break;

  case 1861: /* xmltable: XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 13762 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 45977 "gram.c"
    break;

  case 1862: /* xmltable: XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ',' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 13774 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 45992 "gram.c"
    break;

  case 1863: /* xmltable_column_list: xmltable_column_el  */
#line 13786 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45998 "gram.c"
    break;

  case 1864: /* xmltable_column_list: xmltable_column_list ',' xmltable_column_el  */
#line 13787 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46004 "gram.c"
    break;

  case 1865: /* xmltable_column_el: ColId Typename  */
#line 13792 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 46022 "gram.c"
    break;

  case 1866: /* xmltable_column_el: ColId Typename xmltable_column_option_list  */
#line 13806 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 46083 "gram.c"
    break;

  case 1867: /* xmltable_column_el: ColId FOR ORDINALITY  */
#line 13863 "gram.y"
                                {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 46098 "gram.c"
    break;

  case 1868: /* xmltable_column_option_list: xmltable_column_option_el  */
#line 13877 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 46104 "gram.c"
    break;

  case 1869: /* xmltable_column_option_list: xmltable_column_option_list xmltable_column_option_el  */
#line 13879 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 46110 "gram.c"
    break;

  case 1870: /* xmltable_column_option_el: IDENT b_expr  */
#line 13884 "gram.y"
                                { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 46116 "gram.c"
    break;

  case 1871: /* xmltable_column_option_el: DEFAULT b_expr  */
#line 13886 "gram.y"
                                { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 46122 "gram.c"
    break;

  case 1872: /* xmltable_column_option_el: NOT NULL_P  */
#line 13888 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 46128 "gram.c"
    break;

  case 1873: /* xmltable_column_option_el: NULL_P  */
#line 13890 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 46134 "gram.c"
    break;

  case 1874: /* xml_namespace_list: xml_namespace_el  */
#line 13895 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46140 "gram.c"
    break;

  case 1875: /* xml_namespace_list: xml_namespace_list ',' xml_namespace_el  */
#line 13897 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46146 "gram.c"
    break;

  case 1876: /* xml_namespace_el: b_expr AS ColLabel  */
#line 13902 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46158 "gram.c"
    break;

  case 1877: /* xml_namespace_el: DEFAULT b_expr  */
#line 13910 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46170 "gram.c"
    break;

  case 1878: /* Typename: SimpleTypename opt_array_bounds  */
#line 13930 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 46179 "gram.c"
    break;

  case 1879: /* Typename: SETOF SimpleTypename opt_array_bounds  */
#line 13935 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 46189 "gram.c"
    break;

  case 1880: /* Typename: SimpleTypename ARRAY '[' Iconst ']'  */
#line 13942 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 46198 "gram.c"
    break;

  case 1881: /* Typename: SETOF SimpleTypename ARRAY '[' Iconst ']'  */
#line 13947 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 46208 "gram.c"
    break;

  case 1882: /* Typename: SimpleTypename ARRAY  */
#line 13953 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 46217 "gram.c"
    break;

  case 1883: /* Typename: SETOF SimpleTypename ARRAY  */
#line 13958 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 46227 "gram.c"
    break;

  case 1884: /* opt_array_bounds: opt_array_bounds '[' ']'  */
#line 13967 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 46233 "gram.c"
    break;

  case 1885: /* opt_array_bounds: opt_array_bounds '[' Iconst ']'  */
#line 13969 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 46239 "gram.c"
    break;

  case 1886: /* opt_array_bounds: %empty  */
#line 13971 "gram.y"
                                        {  (yyval.list) = NIL; }
#line 46245 "gram.c"
    break;

  case 1887: /* SimpleTypename: GenericType  */
#line 13975 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46251 "gram.c"
    break;

  case 1888: /* SimpleTypename: Numeric  */
#line 13976 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46257 "gram.c"
    break;

  case 1889: /* SimpleTypename: Bit  */
#line 13977 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46263 "gram.c"
    break;

  case 1890: /* SimpleTypename: Character  */
#line 13978 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46269 "gram.c"
    break;

  case 1891: /* SimpleTypename: ConstDatetime  */
#line 13979 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46275 "gram.c"
    break;

  case 1892: /* SimpleTypename: ConstInterval opt_interval  */
#line 13981 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 46284 "gram.c"
    break;

  case 1893: /* SimpleTypename: ConstInterval '(' Iconst ')'  */
#line 13986 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46294 "gram.c"
    break;

  case 1894: /* ConstTypename: Numeric  */
#line 14005 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46300 "gram.c"
    break;

  case 1895: /* ConstTypename: ConstBit  */
#line 14006 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46306 "gram.c"
    break;

  case 1896: /* ConstTypename: ConstCharacter  */
#line 14007 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46312 "gram.c"
    break;

  case 1897: /* ConstTypename: ConstDatetime  */
#line 14008 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46318 "gram.c"
    break;

  case 1898: /* GenericType: type_function_name opt_type_modifiers  */
#line 14020 "gram.y"
                                {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46328 "gram.c"
    break;

  case 1899: /* GenericType: type_function_name attrs opt_type_modifiers  */
#line 14026 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 46338 "gram.c"
    break;

  case 1900: /* opt_type_modifiers: '(' expr_list ')'  */
#line 14033 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 46344 "gram.c"
    break;

  case 1901: /* opt_type_modifiers: %empty  */
#line 14034 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46350 "gram.c"
    break;

  case 1902: /* Numeric: INT_P  */
#line 14041 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46359 "gram.c"
    break;

  case 1903: /* Numeric: INTEGER  */
#line 14046 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46368 "gram.c"
    break;

  case 1904: /* Numeric: SMALLINT  */
#line 14051 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46377 "gram.c"
    break;

  case 1905: /* Numeric: BIGINT  */
#line 14056 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46386 "gram.c"
    break;

  case 1906: /* Numeric: REAL  */
#line 14061 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46395 "gram.c"
    break;

  case 1907: /* Numeric: FLOAT_P opt_float  */
#line 14066 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46404 "gram.c"
    break;

  case 1908: /* Numeric: DOUBLE_P PRECISION  */
#line 14071 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46413 "gram.c"
    break;

  case 1909: /* Numeric: DECIMAL_P opt_type_modifiers  */
#line 14076 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46423 "gram.c"
    break;

  case 1910: /* Numeric: DEC opt_type_modifiers  */
#line 14082 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46433 "gram.c"
    break;

  case 1911: /* Numeric: NUMERIC opt_type_modifiers  */
#line 14088 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46443 "gram.c"
    break;

  case 1912: /* Numeric: BOOLEAN_P  */
#line 14094 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46452 "gram.c"
    break;

  case 1913: /* opt_float: '(' Iconst ')'  */
#line 14101 "gram.y"
                                {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 46477 "gram.c"
    break;

  case 1914: /* opt_float: %empty  */
#line 14122 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 46485 "gram.c"
    break;

  case 1915: /* Bit: BitWithLength  */
#line 14132 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46493 "gram.c"
    break;

  case 1916: /* Bit: BitWithoutLength  */
#line 14136 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46501 "gram.c"
    break;

  case 1917: /* ConstBit: BitWithLength  */
#line 14144 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46509 "gram.c"
    break;

  case 1918: /* ConstBit: BitWithoutLength  */
#line 14148 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46518 "gram.c"
    break;

  case 1919: /* BitWithLength: BIT opt_varying '(' expr_list ')'  */
#line 14156 "gram.y"
                                {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46531 "gram.c"
    break;

  case 1920: /* BitWithoutLength: BIT opt_varying  */
#line 14168 "gram.y"
                                {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46549 "gram.c"
    break;

  case 1921: /* Character: CharacterWithLength  */
#line 14189 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46557 "gram.c"
    break;

  case 1922: /* Character: CharacterWithoutLength  */
#line 14193 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46565 "gram.c"
    break;

  case 1923: /* ConstCharacter: CharacterWithLength  */
#line 14199 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46573 "gram.c"
    break;

  case 1924: /* ConstCharacter: CharacterWithoutLength  */
#line 14203 "gram.y"
                                {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46588 "gram.c"
    break;

  case 1925: /* CharacterWithLength: character '(' Iconst ')'  */
#line 14216 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 46598 "gram.c"
    break;

  case 1926: /* CharacterWithoutLength: character  */
#line 14224 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46610 "gram.c"
    break;

  case 1927: /* character: CHARACTER opt_varying  */
#line 14234 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46616 "gram.c"
    break;

  case 1928: /* character: CHAR_P opt_varying  */
#line 14236 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46622 "gram.c"
    break;

  case 1929: /* character: VARCHAR  */
#line 14238 "gram.y"
                                                                                { (yyval.str) = "varchar"; }
#line 46628 "gram.c"
    break;

  case 1930: /* character: NATIONAL CHARACTER opt_varying  */
#line 14240 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46634 "gram.c"
    break;

  case 1931: /* character: NATIONAL CHAR_P opt_varying  */
#line 14242 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46640 "gram.c"
    break;

  case 1932: /* character: NCHAR opt_varying  */
#line 14244 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46646 "gram.c"
    break;

  case 1933: /* opt_varying: VARYING  */
#line 14248 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 46652 "gram.c"
    break;

  case 1934: /* opt_varying: %empty  */
#line 14249 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 46658 "gram.c"
    break;

  case 1935: /* ConstDatetime: TIMESTAMP '(' Iconst ')' opt_timezone  */
#line 14257 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46671 "gram.c"
    break;

  case 1936: /* ConstDatetime: TIMESTAMP opt_timezone  */
#line 14266 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46683 "gram.c"
    break;

  case 1937: /* ConstDatetime: TIME '(' Iconst ')' opt_timezone  */
#line 14274 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46696 "gram.c"
    break;

  case 1938: /* ConstDatetime: TIME opt_timezone  */
#line 14283 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46708 "gram.c"
    break;

  case 1939: /* ConstInterval: INTERVAL  */
#line 14294 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46717 "gram.c"
    break;

  case 1940: /* opt_timezone: WITH_LA TIME ZONE  */
#line 14301 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 46723 "gram.c"
    break;

  case 1941: /* opt_timezone: WITHOUT_LA TIME ZONE  */
#line 14302 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 46729 "gram.c"
    break;

  case 1942: /* opt_timezone: %empty  */
#line 14303 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 46735 "gram.c"
    break;

  case 1943: /* opt_interval: YEAR_P  */
#line 14308 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 46741 "gram.c"
    break;

  case 1944: /* opt_interval: MONTH_P  */
#line 14310 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 46747 "gram.c"
    break;

  case 1945: /* opt_interval: DAY_P  */
#line 14312 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 46753 "gram.c"
    break;

  case 1946: /* opt_interval: HOUR_P  */
#line 14314 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 46759 "gram.c"
    break;

  case 1947: /* opt_interval: MINUTE_P  */
#line 14316 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 46765 "gram.c"
    break;

  case 1948: /* opt_interval: interval_second  */
#line 14318 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 46771 "gram.c"
    break;

  case 1949: /* opt_interval: YEAR_P TO MONTH_P  */
#line 14320 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 46780 "gram.c"
    break;

  case 1950: /* opt_interval: DAY_P TO HOUR_P  */
#line 14325 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 46789 "gram.c"
    break;

  case 1951: /* opt_interval: DAY_P TO MINUTE_P  */
#line 14330 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46799 "gram.c"
    break;

  case 1952: /* opt_interval: DAY_P TO interval_second  */
#line 14336 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46811 "gram.c"
    break;

  case 1953: /* opt_interval: HOUR_P TO MINUTE_P  */
#line 14344 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46820 "gram.c"
    break;

  case 1954: /* opt_interval: HOUR_P TO interval_second  */
#line 14349 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46831 "gram.c"
    break;

  case 1955: /* opt_interval: MINUTE_P TO interval_second  */
#line 14356 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46841 "gram.c"
    break;

  case 1956: /* opt_interval: %empty  */
#line 14362 "gram.y"
                                { (yyval.list) = NIL; }
#line 46847 "gram.c"
    break;

  case 1957: /* interval_second: SECOND_P  */
#line 14367 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 46855 "gram.c"
    break;

  case 1958: /* interval_second: SECOND_P '(' Iconst ')'  */
#line 14371 "gram.y"
                                {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46864 "gram.c"
    break;

  case 1959: /* a_expr: c_expr  */
#line 14406 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46870 "gram.c"
    break;

  case 1960: /* a_expr: a_expr TYPECAST Typename  */
#line 14408 "gram.y"
                                        { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46876 "gram.c"
    break;

  case 1961: /* a_expr: a_expr COLLATE any_name  */
#line 14410 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46889 "gram.c"
    break;

  case 1962: /* a_expr: a_expr AT TIME ZONE a_expr  */
#line 14419 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 46900 "gram.c"
    break;

  case 1963: /* a_expr: '+' a_expr  */
#line 14435 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46906 "gram.c"
    break;

  case 1964: /* a_expr: '-' a_expr  */
#line 14437 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46912 "gram.c"
    break;

  case 1965: /* a_expr: a_expr '+' a_expr  */
#line 14439 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46918 "gram.c"
    break;

  case 1966: /* a_expr: a_expr '-' a_expr  */
#line 14441 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46924 "gram.c"
    break;

  case 1967: /* a_expr: a_expr '*' a_expr  */
#line 14443 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46930 "gram.c"
    break;

  case 1968: /* a_expr: a_expr '/' a_expr  */
#line 14445 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46936 "gram.c"
    break;

  case 1969: /* a_expr: a_expr '%' a_expr  */
#line 14447 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46942 "gram.c"
    break;

  case 1970: /* a_expr: a_expr '^' a_expr  */
#line 14449 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46948 "gram.c"
    break;

  case 1971: /* a_expr: a_expr '<' a_expr  */
#line 14451 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46954 "gram.c"
    break;

  case 1972: /* a_expr: a_expr '>' a_expr  */
#line 14453 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46960 "gram.c"
    break;

  case 1973: /* a_expr: a_expr '=' a_expr  */
#line 14455 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46966 "gram.c"
    break;

  case 1974: /* a_expr: a_expr LESS_EQUALS a_expr  */
#line 14457 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46972 "gram.c"
    break;

  case 1975: /* a_expr: a_expr GREATER_EQUALS a_expr  */
#line 14459 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46978 "gram.c"
    break;

  case 1976: /* a_expr: a_expr NOT_EQUALS a_expr  */
#line 14461 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46984 "gram.c"
    break;

  case 1977: /* a_expr: a_expr qual_Op a_expr  */
#line 14464 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46990 "gram.c"
    break;

  case 1978: /* a_expr: qual_Op a_expr  */
#line 14466 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46996 "gram.c"
    break;

  case 1979: /* a_expr: a_expr AND a_expr  */
#line 14469 "gram.y"
                                { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47002 "gram.c"
    break;

  case 1980: /* a_expr: a_expr OR a_expr  */
#line 14471 "gram.y"
                                { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47008 "gram.c"
    break;

  case 1981: /* a_expr: NOT a_expr  */
#line 14473 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47014 "gram.c"
    break;

  case 1982: /* a_expr: NOT_LA a_expr  */
#line 14475 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47020 "gram.c"
    break;

  case 1983: /* a_expr: a_expr LIKE a_expr  */
#line 14478 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47029 "gram.c"
    break;

  case 1984: /* a_expr: a_expr LIKE a_expr ESCAPE a_expr  */
#line 14483 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47042 "gram.c"
    break;

  case 1985: /* a_expr: a_expr NOT_LA LIKE a_expr  */
#line 14492 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47051 "gram.c"
    break;

  case 1986: /* a_expr: a_expr NOT_LA LIKE a_expr ESCAPE a_expr  */
#line 14497 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47064 "gram.c"
    break;

  case 1987: /* a_expr: a_expr ILIKE a_expr  */
#line 14506 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47073 "gram.c"
    break;

  case 1988: /* a_expr: a_expr ILIKE a_expr ESCAPE a_expr  */
#line 14511 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47086 "gram.c"
    break;

  case 1989: /* a_expr: a_expr NOT_LA ILIKE a_expr  */
#line 14520 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47095 "gram.c"
    break;

  case 1990: /* a_expr: a_expr NOT_LA ILIKE a_expr ESCAPE a_expr  */
#line 14525 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47108 "gram.c"
    break;

  case 1991: /* a_expr: a_expr SIMILAR TO a_expr  */
#line 14535 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 47121 "gram.c"
    break;

  case 1992: /* a_expr: a_expr SIMILAR TO a_expr ESCAPE a_expr  */
#line 14544 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47134 "gram.c"
    break;

  case 1993: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr  */
#line 14553 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47147 "gram.c"
    break;

  case 1994: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr ESCAPE a_expr  */
#line 14562 "gram.y"
                                {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 47160 "gram.c"
    break;

  case 1995: /* a_expr: a_expr IS NULL_P  */
#line 14581 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47173 "gram.c"
    break;

  case 1996: /* a_expr: a_expr ISNULL  */
#line 14590 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47186 "gram.c"
    break;

  case 1997: /* a_expr: a_expr IS NOT NULL_P  */
#line 14599 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47199 "gram.c"
    break;

  case 1998: /* a_expr: a_expr NOTNULL  */
#line 14608 "gram.y"
                                {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47212 "gram.c"
    break;

  case 1999: /* a_expr: row OVERLAPS row  */
#line 14617 "gram.y"
                                {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47233 "gram.c"
    break;

  case 2000: /* a_expr: a_expr IS TRUE_P  */
#line 14634 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47246 "gram.c"
    break;

  case 2001: /* a_expr: a_expr IS NOT TRUE_P  */
#line 14643 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47259 "gram.c"
    break;

  case 2002: /* a_expr: a_expr IS FALSE_P  */
#line 14652 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47272 "gram.c"
    break;

  case 2003: /* a_expr: a_expr IS NOT FALSE_P  */
#line 14661 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47285 "gram.c"
    break;

  case 2004: /* a_expr: a_expr IS UNKNOWN  */
#line 14670 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47298 "gram.c"
    break;

  case 2005: /* a_expr: a_expr IS NOT UNKNOWN  */
#line 14679 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47311 "gram.c"
    break;

  case 2006: /* a_expr: a_expr IS DISTINCT FROM a_expr  */
#line 14688 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47319 "gram.c"
    break;

  case 2007: /* a_expr: a_expr IS NOT DISTINCT FROM a_expr  */
#line 14692 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47327 "gram.c"
    break;

  case 2008: /* a_expr: a_expr BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 14696 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47339 "gram.c"
    break;

  case 2009: /* a_expr: a_expr NOT_LA BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 14704 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47351 "gram.c"
    break;

  case 2010: /* a_expr: a_expr BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 14712 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47363 "gram.c"
    break;

  case 2011: /* a_expr: a_expr NOT_LA BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 14720 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47375 "gram.c"
    break;

  case 2012: /* a_expr: a_expr IN_P in_expr  */
#line 14728 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 47400 "gram.c"
    break;

  case 2013: /* a_expr: a_expr NOT_LA IN_P in_expr  */
#line 14749 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 47427 "gram.c"
    break;

  case 2014: /* a_expr: a_expr subquery_Op sub_type select_with_parens  */
#line 14772 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47443 "gram.c"
    break;

  case 2015: /* a_expr: a_expr subquery_Op sub_type '(' a_expr ')'  */
#line 14784 "gram.y"
                                {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 47454 "gram.c"
    break;

  case 2016: /* a_expr: UNIQUE opt_unique_null_treatment select_with_parens  */
#line 14791 "gram.y"
                                {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 47474 "gram.c"
    break;

  case 2017: /* a_expr: a_expr IS DOCUMENT_P  */
#line 14807 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47483 "gram.c"
    break;

  case 2018: /* a_expr: a_expr IS NOT DOCUMENT_P  */
#line 14812 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47493 "gram.c"
    break;

  case 2019: /* a_expr: a_expr IS NORMALIZED  */
#line 14818 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47504 "gram.c"
    break;

  case 2020: /* a_expr: a_expr IS unicode_normal_form NORMALIZED  */
#line 14825 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 47515 "gram.c"
    break;

  case 2021: /* a_expr: a_expr IS NOT NORMALIZED  */
#line 14832 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47527 "gram.c"
    break;

  case 2022: /* a_expr: a_expr IS NOT unicode_normal_form NORMALIZED  */
#line 14840 "gram.y"
                                {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 47539 "gram.c"
    break;

  case 2023: /* a_expr: a_expr IS json_predicate_type_constraint json_key_uniqueness_constraint_opt  */
#line 14849 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 47549 "gram.c"
    break;

  case 2024: /* a_expr: a_expr IS NOT json_predicate_type_constraint json_key_uniqueness_constraint_opt  */
#line 14868 "gram.y"
                                {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 47559 "gram.c"
    break;

  case 2025: /* a_expr: DEFAULT  */
#line 14886 "gram.y"
                                {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47578 "gram.c"
    break;

  case 2026: /* b_expr: c_expr  */
#line 14912 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 47584 "gram.c"
    break;

  case 2027: /* b_expr: b_expr TYPECAST Typename  */
#line 14914 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47590 "gram.c"
    break;

  case 2028: /* b_expr: '+' b_expr  */
#line 14916 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47596 "gram.c"
    break;

  case 2029: /* b_expr: '-' b_expr  */
#line 14918 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47602 "gram.c"
    break;

  case 2030: /* b_expr: b_expr '+' b_expr  */
#line 14920 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47608 "gram.c"
    break;

  case 2031: /* b_expr: b_expr '-' b_expr  */
#line 14922 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47614 "gram.c"
    break;

  case 2032: /* b_expr: b_expr '*' b_expr  */
#line 14924 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47620 "gram.c"
    break;

  case 2033: /* b_expr: b_expr '/' b_expr  */
#line 14926 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47626 "gram.c"
    break;

  case 2034: /* b_expr: b_expr '%' b_expr  */
#line 14928 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47632 "gram.c"
    break;

  case 2035: /* b_expr: b_expr '^' b_expr  */
#line 14930 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47638 "gram.c"
    break;

  case 2036: /* b_expr: b_expr '<' b_expr  */
#line 14932 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47644 "gram.c"
    break;

  case 2037: /* b_expr: b_expr '>' b_expr  */
#line 14934 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47650 "gram.c"
    break;

  case 2038: /* b_expr: b_expr '=' b_expr  */
#line 14936 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47656 "gram.c"
    break;

  case 2039: /* b_expr: b_expr LESS_EQUALS b_expr  */
#line 14938 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47662 "gram.c"
    break;

  case 2040: /* b_expr: b_expr GREATER_EQUALS b_expr  */
#line 14940 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47668 "gram.c"
    break;

  case 2041: /* b_expr: b_expr NOT_EQUALS b_expr  */
#line 14942 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47674 "gram.c"
    break;

  case 2042: /* b_expr: b_expr qual_Op b_expr  */
#line 14944 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47680 "gram.c"
    break;

  case 2043: /* b_expr: qual_Op b_expr  */
#line 14946 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47686 "gram.c"
    break;

  case 2044: /* b_expr: b_expr IS DISTINCT FROM b_expr  */
#line 14948 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47694 "gram.c"
    break;

  case 2045: /* b_expr: b_expr IS NOT DISTINCT FROM b_expr  */
#line 14952 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47702 "gram.c"
    break;

  case 2046: /* b_expr: b_expr IS DOCUMENT_P  */
#line 14956 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47711 "gram.c"
    break;

  case 2047: /* b_expr: b_expr IS NOT DOCUMENT_P  */
#line 14961 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47721 "gram.c"
    break;

  case 2048: /* c_expr: columnref  */
#line 14976 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47727 "gram.c"
    break;

  case 2049: /* c_expr: AexprConst  */
#line 14977 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 47733 "gram.c"
    break;

  case 2050: /* c_expr: PARAM opt_indirection  */
#line 14979 "gram.y"
                                {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 47754 "gram.c"
    break;

  case 2051: /* c_expr: '(' a_expr ')' opt_indirection  */
#line 14996 "gram.y"
                                {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 47771 "gram.c"
    break;

  case 2052: /* c_expr: case_expr  */
#line 15009 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 47777 "gram.c"
    break;

  case 2053: /* c_expr: func_expr  */
#line 15011 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 47783 "gram.c"
    break;

  case 2054: /* c_expr: select_with_parens  */
#line 15013 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47799 "gram.c"
    break;

  case 2055: /* c_expr: select_with_parens indirection  */
#line 15025 "gram.y"
                                {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 47828 "gram.c"
    break;

  case 2056: /* c_expr: EXISTS select_with_parens  */
#line 15050 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47844 "gram.c"
    break;

  case 2057: /* c_expr: ARRAY select_with_parens  */
#line 15062 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47860 "gram.c"
    break;

  case 2058: /* c_expr: ARRAY array_expr  */
#line 15074 "gram.y"
                                {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47872 "gram.c"
    break;

  case 2059: /* c_expr: explicit_row  */
#line 15082 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47887 "gram.c"
    break;

  case 2060: /* c_expr: implicit_row  */
#line 15093 "gram.y"
                                {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47902 "gram.c"
    break;

  case 2061: /* c_expr: GROUPING '(' expr_list ')'  */
#line 15104 "gram.y"
                          {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 47914 "gram.c"
    break;

  case 2062: /* func_application: func_name '(' ')'  */
#line 15114 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 47924 "gram.c"
    break;

  case 2063: /* func_application: func_name '(' func_arg_list opt_sort_clause ')'  */
#line 15120 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47937 "gram.c"
    break;

  case 2064: /* func_application: func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15129 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47951 "gram.c"
    break;

  case 2065: /* func_application: func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 15139 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47965 "gram.c"
    break;

  case 2066: /* func_application: func_name '(' ALL func_arg_list opt_sort_clause ')'  */
#line 15149 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 47982 "gram.c"
    break;

  case 2067: /* func_application: func_name '(' DISTINCT func_arg_list opt_sort_clause ')'  */
#line 15162 "gram.y"
                                {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 47996 "gram.c"
    break;

  case 2068: /* func_application: func_name '(' '*' ')'  */
#line 15172 "gram.y"
                                {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 48019 "gram.c"
    break;

  case 2069: /* func_expr: func_application within_group_clause filter_clause over_clause  */
#line 15203 "gram.y"
                                {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 48059 "gram.c"
    break;

  case 2070: /* func_expr: json_aggregate_func filter_clause over_clause  */
#line 15239 "gram.y"
                                {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 48073 "gram.c"
    break;

  case 2071: /* func_expr: func_expr_common_subexpr  */
#line 15249 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 48079 "gram.c"
    break;

  case 2072: /* func_expr_windowless: func_application  */
#line 15259 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 48085 "gram.c"
    break;

  case 2073: /* func_expr_windowless: func_expr_common_subexpr  */
#line 15260 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 48091 "gram.c"
    break;

  case 2074: /* func_expr_windowless: json_aggregate_func  */
#line 15261 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 48097 "gram.c"
    break;

  case 2075: /* func_expr_common_subexpr: COLLATION FOR '(' a_expr ')'  */
#line 15269 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48108 "gram.c"
    break;

  case 2076: /* func_expr_common_subexpr: CURRENT_DATE  */
#line 15276 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 48116 "gram.c"
    break;

  case 2077: /* func_expr_common_subexpr: CURRENT_TIME  */
#line 15280 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 48124 "gram.c"
    break;

  case 2078: /* func_expr_common_subexpr: CURRENT_TIME '(' Iconst ')'  */
#line 15284 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48132 "gram.c"
    break;

  case 2079: /* func_expr_common_subexpr: CURRENT_TIMESTAMP  */
#line 15288 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 48140 "gram.c"
    break;

  case 2080: /* func_expr_common_subexpr: CURRENT_TIMESTAMP '(' Iconst ')'  */
#line 15292 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48148 "gram.c"
    break;

  case 2081: /* func_expr_common_subexpr: LOCALTIME  */
#line 15296 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 48156 "gram.c"
    break;

  case 2082: /* func_expr_common_subexpr: LOCALTIME '(' Iconst ')'  */
#line 15300 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48164 "gram.c"
    break;

  case 2083: /* func_expr_common_subexpr: LOCALTIMESTAMP  */
#line 15304 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 48172 "gram.c"
    break;

  case 2084: /* func_expr_common_subexpr: LOCALTIMESTAMP '(' Iconst ')'  */
#line 15308 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48180 "gram.c"
    break;

  case 2085: /* func_expr_common_subexpr: CURRENT_ROLE  */
#line 15312 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 48188 "gram.c"
    break;

  case 2086: /* func_expr_common_subexpr: CURRENT_USER  */
#line 15316 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 48196 "gram.c"
    break;

  case 2087: /* func_expr_common_subexpr: SESSION_USER  */
#line 15320 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 48204 "gram.c"
    break;

  case 2088: /* func_expr_common_subexpr: SYSTEM_USER  */
#line 15324 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 48215 "gram.c"
    break;

  case 2089: /* func_expr_common_subexpr: USER  */
#line 15331 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 48223 "gram.c"
    break;

  case 2090: /* func_expr_common_subexpr: CURRENT_CATALOG  */
#line 15335 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 48231 "gram.c"
    break;

  case 2091: /* func_expr_common_subexpr: CURRENT_SCHEMA  */
#line 15339 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 48239 "gram.c"
    break;

  case 2092: /* func_expr_common_subexpr: CAST '(' a_expr AS Typename ')'  */
#line 15343 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 48245 "gram.c"
    break;

  case 2093: /* func_expr_common_subexpr: EXTRACT '(' extract_list ')'  */
#line 15345 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48256 "gram.c"
    break;

  case 2094: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ')'  */
#line 15352 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48267 "gram.c"
    break;

  case 2095: /* func_expr_common_subexpr: NORMALIZE '(' a_expr ',' unicode_normal_form ')'  */
#line 15359 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 48278 "gram.c"
    break;

  case 2096: /* func_expr_common_subexpr: OVERLAY '(' overlay_list ')'  */
#line 15366 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48289 "gram.c"
    break;

  case 2097: /* func_expr_common_subexpr: OVERLAY '(' func_arg_list_opt ')'  */
#line 15373 "gram.y"
                                {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48304 "gram.c"
    break;

  case 2098: /* func_expr_common_subexpr: POSITION '(' position_list ')'  */
#line 15384 "gram.y"
                                {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48322 "gram.c"
    break;

  case 2099: /* func_expr_common_subexpr: SUBSTRING '(' substr_list ')'  */
#line 15398 "gram.y"
                                {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48336 "gram.c"
    break;

  case 2100: /* func_expr_common_subexpr: SUBSTRING '(' func_arg_list_opt ')'  */
#line 15408 "gram.y"
                                {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48351 "gram.c"
    break;

  case 2101: /* func_expr_common_subexpr: TREAT '(' a_expr AS Typename ')'  */
#line 15419 "gram.y"
                                {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 48371 "gram.c"
    break;

  case 2102: /* func_expr_common_subexpr: TRIM '(' BOTH trim_list ')'  */
#line 15435 "gram.y"
                                {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48385 "gram.c"
    break;

  case 2103: /* func_expr_common_subexpr: TRIM '(' LEADING trim_list ')'  */
#line 15445 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48396 "gram.c"
    break;

  case 2104: /* func_expr_common_subexpr: TRIM '(' TRAILING trim_list ')'  */
#line 15452 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48407 "gram.c"
    break;

  case 2105: /* func_expr_common_subexpr: TRIM '(' trim_list ')'  */
#line 15459 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48418 "gram.c"
    break;

  case 2106: /* func_expr_common_subexpr: NULLIF '(' a_expr ',' a_expr ')'  */
#line 15466 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 48426 "gram.c"
    break;

  case 2107: /* func_expr_common_subexpr: COALESCE '(' expr_list ')'  */
#line 15470 "gram.y"
                                {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 48438 "gram.c"
    break;

  case 2108: /* func_expr_common_subexpr: GREATEST '(' expr_list ')'  */
#line 15478 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48451 "gram.c"
    break;

  case 2109: /* func_expr_common_subexpr: LEAST '(' expr_list ')'  */
#line 15487 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48464 "gram.c"
    break;

  case 2110: /* func_expr_common_subexpr: XMLCONCAT '(' expr_list ')'  */
#line 15496 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48472 "gram.c"
    break;

  case 2111: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ')'  */
#line 15500 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 48480 "gram.c"
    break;

  case 2112: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'  */
#line 15504 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 48488 "gram.c"
    break;

  case 2113: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'  */
#line 15508 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 48496 "gram.c"
    break;

  case 2114: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'  */
#line 15512 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 48504 "gram.c"
    break;

  case 2115: /* func_expr_common_subexpr: XMLEXISTS '(' c_expr xmlexists_argument ')'  */
#line 15516 "gram.y"
                                {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48517 "gram.c"
    break;

  case 2116: /* func_expr_common_subexpr: XMLFOREST '(' xml_attribute_list ')'  */
#line 15525 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 48525 "gram.c"
    break;

  case 2117: /* func_expr_common_subexpr: XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'  */
#line 15529 "gram.y"
                                {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 48539 "gram.c"
    break;

  case 2118: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ')'  */
#line 15539 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 48547 "gram.c"
    break;

  case 2119: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ',' a_expr ')'  */
#line 15543 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48555 "gram.c"
    break;

  case 2120: /* func_expr_common_subexpr: XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'  */
#line 15547 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48564 "gram.c"
    break;

  case 2121: /* func_expr_common_subexpr: XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename xml_indent_option ')'  */
#line 15552 "gram.y"
                                {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 48579 "gram.c"
    break;

  case 2122: /* func_expr_common_subexpr: JSON_OBJECT '(' func_arg_list ')'  */
#line 15563 "gram.y"
                                {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 48589 "gram.c"
    break;

  case 2123: /* func_expr_common_subexpr: JSON_OBJECT '(' json_name_and_value_list json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt json_output_clause_opt ')'  */
#line 15572 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48604 "gram.c"
    break;

  case 2124: /* func_expr_common_subexpr: JSON_OBJECT '(' json_output_clause_opt ')'  */
#line 15583 "gram.y"
                                {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48619 "gram.c"
    break;

  case 2125: /* func_expr_common_subexpr: JSON_ARRAY '(' json_value_expr_list json_array_constructor_null_clause_opt json_output_clause_opt ')'  */
#line 15598 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48633 "gram.c"
    break;

  case 2126: /* func_expr_common_subexpr: JSON_ARRAY '(' select_no_parens json_format_clause_opt json_output_clause_opt ')'  */
#line 15613 "gram.y"
                                {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48648 "gram.c"
    break;

  case 2127: /* func_expr_common_subexpr: JSON_ARRAY '(' json_output_clause_opt ')'  */
#line 15626 "gram.y"
                                {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48662 "gram.c"
    break;

  case 2128: /* xml_root_version: VERSION_P a_expr  */
#line 15641 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 48668 "gram.c"
    break;

  case 2129: /* xml_root_version: VERSION_P NO VALUE_P  */
#line 15643 "gram.y"
                                { (yyval.node) = makeNullAConst(-1); }
#line 48674 "gram.c"
    break;

  case 2130: /* opt_xml_root_standalone: ',' STANDALONE_P YES_P  */
#line 15647 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 48680 "gram.c"
    break;

  case 2131: /* opt_xml_root_standalone: ',' STANDALONE_P NO  */
#line 15649 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 48686 "gram.c"
    break;

  case 2132: /* opt_xml_root_standalone: ',' STANDALONE_P NO VALUE_P  */
#line 15651 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 48692 "gram.c"
    break;

  case 2133: /* opt_xml_root_standalone: %empty  */
#line 15653 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 48698 "gram.c"
    break;

  case 2134: /* xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'  */
#line 15656 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 48704 "gram.c"
    break;

  case 2135: /* xml_attribute_list: xml_attribute_el  */
#line 15659 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48710 "gram.c"
    break;

  case 2136: /* xml_attribute_list: xml_attribute_list ',' xml_attribute_el  */
#line 15660 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48716 "gram.c"
    break;

  case 2137: /* xml_attribute_el: a_expr AS ColLabel  */
#line 15664 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48728 "gram.c"
    break;

  case 2138: /* xml_attribute_el: a_expr  */
#line 15672 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 48740 "gram.c"
    break;

  case 2139: /* document_or_content: DOCUMENT_P  */
#line 15681 "gram.y"
                                                                        { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 48746 "gram.c"
    break;

  case 2140: /* document_or_content: CONTENT_P  */
#line 15682 "gram.y"
                                                                                                { (yyval.ival) = XMLOPTION_CONTENT; }
#line 48752 "gram.c"
    break;

  case 2141: /* xml_indent_option: INDENT  */
#line 15685 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 48758 "gram.c"
    break;

  case 2142: /* xml_indent_option: NO INDENT  */
#line 15686 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 48764 "gram.c"
    break;

  case 2143: /* xml_indent_option: %empty  */
#line 15687 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 48770 "gram.c"
    break;

  case 2144: /* xml_whitespace_option: PRESERVE WHITESPACE_P  */
#line 15690 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 48776 "gram.c"
    break;

  case 2145: /* xml_whitespace_option: STRIP_P WHITESPACE_P  */
#line 15691 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 48782 "gram.c"
    break;

  case 2146: /* xml_whitespace_option: %empty  */
#line 15692 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 48788 "gram.c"
    break;

  case 2147: /* xmlexists_argument: PASSING c_expr  */
#line 15698 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48796 "gram.c"
    break;

  case 2148: /* xmlexists_argument: PASSING c_expr xml_passing_mech  */
#line 15702 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 48804 "gram.c"
    break;

  case 2149: /* xmlexists_argument: PASSING xml_passing_mech c_expr  */
#line 15706 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48812 "gram.c"
    break;

  case 2150: /* xmlexists_argument: PASSING xml_passing_mech c_expr xml_passing_mech  */
#line 15710 "gram.y"
                                {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 48820 "gram.c"
    break;

  case 2153: /* within_group_clause: WITHIN GROUP_P '(' sort_clause ')'  */
#line 15725 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 48826 "gram.c"
    break;

  case 2154: /* within_group_clause: %empty  */
#line 15726 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 48832 "gram.c"
    break;

  case 2155: /* filter_clause: FILTER '(' WHERE a_expr ')'  */
#line 15730 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 48838 "gram.c"
    break;

  case 2156: /* filter_clause: %empty  */
#line 15731 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 48844 "gram.c"
    break;

  case 2157: /* window_clause: WINDOW window_definition_list  */
#line 15739 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 48850 "gram.c"
    break;

  case 2158: /* window_clause: %empty  */
#line 15740 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 48856 "gram.c"
    break;

  case 2159: /* window_definition_list: window_definition  */
#line 15744 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 48862 "gram.c"
    break;

  case 2160: /* window_definition_list: window_definition_list ',' window_definition  */
#line 15746 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 48868 "gram.c"
    break;

  case 2161: /* window_definition: ColId AS window_specification  */
#line 15751 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 48879 "gram.c"
    break;

  case 2162: /* over_clause: OVER window_specification  */
#line 15760 "gram.y"
                                { (yyval.windef) = (yyvsp[0].windef); }
#line 48885 "gram.c"
    break;

  case 2163: /* over_clause: OVER ColId  */
#line 15762 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 48903 "gram.c"
    break;

  case 2164: /* over_clause: %empty  */
#line 15776 "gram.y"
                                { (yyval.windef) = NULL; }
#line 48909 "gram.c"
    break;

  case 2165: /* window_specification: '(' opt_existing_window_name opt_partition_clause opt_sort_clause opt_frame_clause ')'  */
#line 15781 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 48928 "gram.c"
    break;

  case 2166: /* opt_existing_window_name: ColId  */
#line 15807 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 48934 "gram.c"
    break;

  case 2167: /* opt_existing_window_name: %empty  */
#line 15808 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 48940 "gram.c"
    break;

  case 2168: /* opt_partition_clause: PARTITION BY expr_list  */
#line 15811 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 48946 "gram.c"
    break;

  case 2169: /* opt_partition_clause: %empty  */
#line 15812 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 48952 "gram.c"
    break;

  case 2170: /* opt_frame_clause: RANGE frame_extent opt_window_exclusion_clause  */
#line 15821 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48964 "gram.c"
    break;

  case 2171: /* opt_frame_clause: ROWS frame_extent opt_window_exclusion_clause  */
#line 15829 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48976 "gram.c"
    break;

  case 2172: /* opt_frame_clause: GROUPS frame_extent opt_window_exclusion_clause  */
#line 15837 "gram.y"
                                {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48988 "gram.c"
    break;

  case 2173: /* opt_frame_clause: %empty  */
#line 15845 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49001 "gram.c"
    break;

  case 2174: /* frame_extent: frame_bound  */
#line 15856 "gram.y"
                                {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 49023 "gram.c"
    break;

  case 2175: /* frame_extent: BETWEEN frame_bound AND frame_bound  */
#line 15874 "gram.y"
                                {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 49065 "gram.c"
    break;

  case 2176: /* frame_bound: UNBOUNDED PRECEDING  */
#line 15920 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49078 "gram.c"
    break;

  case 2177: /* frame_bound: UNBOUNDED FOLLOWING  */
#line 15929 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49091 "gram.c"
    break;

  case 2178: /* frame_bound: CURRENT_P ROW  */
#line 15938 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49104 "gram.c"
    break;

  case 2179: /* frame_bound: a_expr PRECEDING  */
#line 15947 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49117 "gram.c"
    break;

  case 2180: /* frame_bound: a_expr FOLLOWING  */
#line 15956 "gram.y"
                                {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49130 "gram.c"
    break;

  case 2181: /* opt_window_exclusion_clause: EXCLUDE CURRENT_P ROW  */
#line 15967 "gram.y"
                                                { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 49136 "gram.c"
    break;

  case 2182: /* opt_window_exclusion_clause: EXCLUDE GROUP_P  */
#line 15968 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 49142 "gram.c"
    break;

  case 2183: /* opt_window_exclusion_clause: EXCLUDE TIES  */
#line 15969 "gram.y"
                                                        { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 49148 "gram.c"
    break;

  case 2184: /* opt_window_exclusion_clause: EXCLUDE NO OTHERS  */
#line 15970 "gram.y"
                                                        { (yyval.ival) = 0; }
#line 49154 "gram.c"
    break;

  case 2185: /* opt_window_exclusion_clause: %empty  */
#line 15971 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 49160 "gram.c"
    break;

  case 2186: /* row: ROW '(' expr_list ')'  */
#line 15985 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 49166 "gram.c"
    break;

  case 2187: /* row: ROW '(' ')'  */
#line 15986 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 49172 "gram.c"
    break;

  case 2188: /* row: '(' expr_list ',' a_expr ')'  */
#line 15987 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49178 "gram.c"
    break;

  case 2189: /* explicit_row: ROW '(' expr_list ')'  */
#line 15990 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 49184 "gram.c"
    break;

  case 2190: /* explicit_row: ROW '(' ')'  */
#line 15991 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 49190 "gram.c"
    break;

  case 2191: /* implicit_row: '(' expr_list ',' a_expr ')'  */
#line 15994 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49196 "gram.c"
    break;

  case 2192: /* sub_type: ANY  */
#line 15997 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 49202 "gram.c"
    break;

  case 2193: /* sub_type: SOME  */
#line 15998 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 49208 "gram.c"
    break;

  case 2194: /* sub_type: ALL  */
#line 15999 "gram.y"
                                                                                                { (yyval.ival) = ALL_SUBLINK; }
#line 49214 "gram.c"
    break;

  case 2195: /* all_Op: Op  */
#line 16002 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 49220 "gram.c"
    break;

  case 2196: /* all_Op: MathOp  */
#line 16003 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 49226 "gram.c"
    break;

  case 2197: /* MathOp: '+'  */
#line 16006 "gram.y"
                                                                                        { (yyval.str) = "+"; }
#line 49232 "gram.c"
    break;

  case 2198: /* MathOp: '-'  */
#line 16007 "gram.y"
                                                                                                { (yyval.str) = "-"; }
#line 49238 "gram.c"
    break;

  case 2199: /* MathOp: '*'  */
#line 16008 "gram.y"
                                                                                                { (yyval.str) = "*"; }
#line 49244 "gram.c"
    break;

  case 2200: /* MathOp: '/'  */
#line 16009 "gram.y"
                                                                                                { (yyval.str) = "/"; }
#line 49250 "gram.c"
    break;

  case 2201: /* MathOp: '%'  */
#line 16010 "gram.y"
                                                                                                { (yyval.str) = "%"; }
#line 49256 "gram.c"
    break;

  case 2202: /* MathOp: '^'  */
#line 16011 "gram.y"
                                                                                                { (yyval.str) = "^"; }
#line 49262 "gram.c"
    break;

  case 2203: /* MathOp: '<'  */
#line 16012 "gram.y"
                                                                                                { (yyval.str) = "<"; }
#line 49268 "gram.c"
    break;

  case 2204: /* MathOp: '>'  */
#line 16013 "gram.y"
                                                                                                { (yyval.str) = ">"; }
#line 49274 "gram.c"
    break;

  case 2205: /* MathOp: '='  */
#line 16014 "gram.y"
                                                                                                { (yyval.str) = "="; }
#line 49280 "gram.c"
    break;

  case 2206: /* MathOp: LESS_EQUALS  */
#line 16015 "gram.y"
                                                                                        { (yyval.str) = "<="; }
#line 49286 "gram.c"
    break;

  case 2207: /* MathOp: GREATER_EQUALS  */
#line 16016 "gram.y"
                                                                                        { (yyval.str) = ">="; }
#line 49292 "gram.c"
    break;

  case 2208: /* MathOp: NOT_EQUALS  */
#line 16017 "gram.y"
                                                                                        { (yyval.str) = "<>"; }
#line 49298 "gram.c"
    break;

  case 2209: /* qual_Op: Op  */
#line 16021 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49304 "gram.c"
    break;

  case 2210: /* qual_Op: OPERATOR '(' any_operator ')'  */
#line 16023 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 49310 "gram.c"
    break;

  case 2211: /* qual_all_Op: all_Op  */
#line 16028 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49316 "gram.c"
    break;

  case 2212: /* qual_all_Op: OPERATOR '(' any_operator ')'  */
#line 16030 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 49322 "gram.c"
    break;

  case 2213: /* subquery_Op: all_Op  */
#line 16035 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49328 "gram.c"
    break;

  case 2214: /* subquery_Op: OPERATOR '(' any_operator ')'  */
#line 16037 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 49334 "gram.c"
    break;

  case 2215: /* subquery_Op: LIKE  */
#line 16039 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~")); }
#line 49340 "gram.c"
    break;

  case 2216: /* subquery_Op: NOT_LA LIKE  */
#line 16041 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~")); }
#line 49346 "gram.c"
    break;

  case 2217: /* subquery_Op: ILIKE  */
#line 16043 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~*")); }
#line 49352 "gram.c"
    break;

  case 2218: /* subquery_Op: NOT_LA ILIKE  */
#line 16045 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~*")); }
#line 49358 "gram.c"
    break;

  case 2219: /* expr_list: a_expr  */
#line 16057 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49366 "gram.c"
    break;

  case 2220: /* expr_list: expr_list ',' a_expr  */
#line 16061 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49374 "gram.c"
    break;

  case 2221: /* func_arg_list: func_arg_expr  */
#line 16068 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49382 "gram.c"
    break;

  case 2222: /* func_arg_list: func_arg_list ',' func_arg_expr  */
#line 16072 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49390 "gram.c"
    break;

  case 2223: /* func_arg_expr: a_expr  */
#line 16078 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49398 "gram.c"
    break;

  case 2224: /* func_arg_expr: param_name COLON_EQUALS a_expr  */
#line 16082 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49412 "gram.c"
    break;

  case 2225: /* func_arg_expr: param_name EQUALS_GREATER a_expr  */
#line 16092 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49426 "gram.c"
    break;

  case 2226: /* func_arg_list_opt: func_arg_list  */
#line 16103 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 49432 "gram.c"
    break;

  case 2227: /* func_arg_list_opt: %empty  */
#line 16104 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 49438 "gram.c"
    break;

  case 2228: /* type_list: Typename  */
#line 16107 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 49444 "gram.c"
    break;

  case 2229: /* type_list: type_list ',' Typename  */
#line 16108 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 49450 "gram.c"
    break;

  case 2230: /* array_expr: '[' expr_list ']'  */
#line 16112 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49458 "gram.c"
    break;

  case 2231: /* array_expr: '[' array_expr_list ']'  */
#line 16116 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49466 "gram.c"
    break;

  case 2232: /* array_expr: '[' ']'  */
#line 16120 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 49474 "gram.c"
    break;

  case 2233: /* array_expr_list: array_expr  */
#line 16125 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49480 "gram.c"
    break;

  case 2234: /* array_expr_list: array_expr_list ',' array_expr  */
#line 16126 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49486 "gram.c"
    break;

  case 2235: /* extract_list: extract_arg FROM a_expr  */
#line 16132 "gram.y"
                                {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 49494 "gram.c"
    break;

  case 2236: /* extract_arg: IDENT  */
#line 16141 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 49500 "gram.c"
    break;

  case 2237: /* extract_arg: YEAR_P  */
#line 16142 "gram.y"
                                                                                                { (yyval.str) = "year"; }
#line 49506 "gram.c"
    break;

  case 2238: /* extract_arg: MONTH_P  */
#line 16143 "gram.y"
                                                                                                { (yyval.str) = "month"; }
#line 49512 "gram.c"
    break;

  case 2239: /* extract_arg: DAY_P  */
#line 16144 "gram.y"
                                                                                                { (yyval.str) = "day"; }
#line 49518 "gram.c"
    break;

  case 2240: /* extract_arg: HOUR_P  */
#line 16145 "gram.y"
                                                                                                { (yyval.str) = "hour"; }
#line 49524 "gram.c"
    break;

  case 2241: /* extract_arg: MINUTE_P  */
#line 16146 "gram.y"
                                                                                                { (yyval.str) = "minute"; }
#line 49530 "gram.c"
    break;

  case 2242: /* extract_arg: SECOND_P  */
#line 16147 "gram.y"
                                                                                                { (yyval.str) = "second"; }
#line 49536 "gram.c"
    break;

  case 2243: /* extract_arg: Sconst  */
#line 16148 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 49542 "gram.c"
    break;

  case 2244: /* unicode_normal_form: NFC  */
#line 16152 "gram.y"
                                                                                                        { (yyval.str) = "NFC"; }
#line 49548 "gram.c"
    break;

  case 2245: /* unicode_normal_form: NFD  */
#line 16153 "gram.y"
                                                                                                { (yyval.str) = "NFD"; }
#line 49554 "gram.c"
    break;

  case 2246: /* unicode_normal_form: NFKC  */
#line 16154 "gram.y"
                                                                                                { (yyval.str) = "NFKC"; }
#line 49560 "gram.c"
    break;

  case 2247: /* unicode_normal_form: NFKD  */
#line 16155 "gram.y"
                                                                                                { (yyval.str) = "NFKD"; }
#line 49566 "gram.c"
    break;

  case 2248: /* overlay_list: a_expr PLACING a_expr FROM a_expr FOR a_expr  */
#line 16161 "gram.y"
                                {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49575 "gram.c"
    break;

  case 2249: /* overlay_list: a_expr PLACING a_expr FROM a_expr  */
#line 16166 "gram.y"
                                {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49584 "gram.c"
    break;

  case 2250: /* position_list: b_expr IN_P b_expr  */
#line 16174 "gram.y"
                                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 49590 "gram.c"
    break;

  case 2251: /* substr_list: a_expr FROM a_expr FOR a_expr  */
#line 16196 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49598 "gram.c"
    break;

  case 2252: /* substr_list: a_expr FOR a_expr FROM a_expr  */
#line 16200 "gram.y"
                                {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 49607 "gram.c"
    break;

  case 2253: /* substr_list: a_expr FROM a_expr  */
#line 16205 "gram.y"
                                {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49622 "gram.c"
    break;

  case 2254: /* substr_list: a_expr FOR a_expr  */
#line 16216 "gram.y"
                                {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 49643 "gram.c"
    break;

  case 2255: /* substr_list: a_expr SIMILAR a_expr ESCAPE a_expr  */
#line 16233 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49651 "gram.c"
    break;

  case 2256: /* trim_list: a_expr FROM expr_list  */
#line 16238 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 49657 "gram.c"
    break;

  case 2257: /* trim_list: FROM expr_list  */
#line 16239 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 49663 "gram.c"
    break;

  case 2258: /* trim_list: expr_list  */
#line 16240 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 49669 "gram.c"
    break;

  case 2259: /* in_expr: select_with_parens  */
#line 16244 "gram.y"
                                {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 49681 "gram.c"
    break;

  case 2260: /* in_expr: '(' expr_list ')'  */
#line 16251 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 49687 "gram.c"
    break;

  case 2261: /* case_expr: CASE case_arg when_clause_list case_default END_P  */
#line 16262 "gram.y"
                                {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 49702 "gram.c"
    break;

  case 2262: /* when_clause_list: when_clause  */
#line 16276 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49708 "gram.c"
    break;

  case 2263: /* when_clause_list: when_clause_list when_clause  */
#line 16277 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49714 "gram.c"
    break;

  case 2264: /* when_clause: WHEN a_expr THEN a_expr  */
#line 16282 "gram.y"
                                {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 49727 "gram.c"
    break;

  case 2265: /* case_default: ELSE a_expr  */
#line 16293 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 49733 "gram.c"
    break;

  case 2266: /* case_default: %empty  */
#line 16294 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 49739 "gram.c"
    break;

  case 2267: /* case_arg: a_expr  */
#line 16297 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 49745 "gram.c"
    break;

  case 2268: /* case_arg: %empty  */
#line 16298 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 49751 "gram.c"
    break;

  case 2269: /* columnref: ColId  */
#line 16302 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 49759 "gram.c"
    break;

  case 2270: /* columnref: ColId indirection  */
#line 16306 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 49767 "gram.c"
    break;

  case 2271: /* indirection_el: '.' attr_name  */
#line 16313 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 49775 "gram.c"
    break;

  case 2272: /* indirection_el: '.' '*'  */
#line 16317 "gram.y"
                                {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 49783 "gram.c"
    break;

  case 2273: /* indirection_el: '[' a_expr ']'  */
#line 16321 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49796 "gram.c"
    break;

  case 2274: /* indirection_el: '[' opt_slice_bound ':' opt_slice_bound ']'  */
#line 16330 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49809 "gram.c"
    break;

  case 2275: /* opt_slice_bound: a_expr  */
#line 16341 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 49815 "gram.c"
    break;

  case 2276: /* opt_slice_bound: %empty  */
#line 16342 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 49821 "gram.c"
    break;

  case 2277: /* indirection: indirection_el  */
#line 16346 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49827 "gram.c"
    break;

  case 2278: /* indirection: indirection indirection_el  */
#line 16347 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49833 "gram.c"
    break;

  case 2279: /* opt_indirection: %empty  */
#line 16351 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 49839 "gram.c"
    break;

  case 2280: /* opt_indirection: opt_indirection indirection_el  */
#line 16352 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49845 "gram.c"
    break;

  case 2283: /* json_value_expr: a_expr json_format_clause_opt  */
#line 16362 "gram.y"
                        {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 49855 "gram.c"
    break;

  case 2284: /* json_format_clause_opt: FORMAT_LA JSON json_encoding_clause_opt  */
#line 16371 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, (yyvsp[0].ival), (yylsp[-2]));
				}
#line 49863 "gram.c"
    break;

  case 2285: /* json_format_clause_opt: %empty  */
#line 16375 "gram.y"
                                {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 49871 "gram.c"
    break;

  case 2286: /* json_encoding_clause_opt: ENCODING name  */
#line 16381 "gram.y"
                                                                        { (yyval.ival) = makeJsonEncoding((yyvsp[0].str)); }
#line 49877 "gram.c"
    break;

  case 2287: /* json_encoding_clause_opt: %empty  */
#line 16382 "gram.y"
                                                                        { (yyval.ival) = JS_ENC_DEFAULT; }
#line 49883 "gram.c"
    break;

  case 2288: /* json_output_clause_opt: RETURNING Typename json_format_clause_opt  */
#line 16387 "gram.y"
                                {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 49896 "gram.c"
    break;

  case 2289: /* json_output_clause_opt: %empty  */
#line 16395 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 49902 "gram.c"
    break;

  case 2290: /* json_predicate_type_constraint: JSON  */
#line 16399 "gram.y"
                                                                                                { (yyval.ival) = JS_TYPE_ANY; }
#line 49908 "gram.c"
    break;

  case 2291: /* json_predicate_type_constraint: JSON VALUE_P  */
#line 16400 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ANY; }
#line 49914 "gram.c"
    break;

  case 2292: /* json_predicate_type_constraint: JSON ARRAY  */
#line 16401 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_ARRAY; }
#line 49920 "gram.c"
    break;

  case 2293: /* json_predicate_type_constraint: JSON OBJECT_P  */
#line 16402 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_OBJECT; }
#line 49926 "gram.c"
    break;

  case 2294: /* json_predicate_type_constraint: JSON SCALAR  */
#line 16403 "gram.y"
                                                                                        { (yyval.ival) = JS_TYPE_SCALAR; }
#line 49932 "gram.c"
    break;

  case 2295: /* json_key_uniqueness_constraint_opt: WITH UNIQUE KEYS  */
#line 16408 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 49938 "gram.c"
    break;

  case 2296: /* json_key_uniqueness_constraint_opt: WITH UNIQUE  */
#line 16409 "gram.y"
                                                                                                { (yyval.boolean) = true; }
#line 49944 "gram.c"
    break;

  case 2297: /* json_key_uniqueness_constraint_opt: WITHOUT UNIQUE KEYS  */
#line 16410 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 49950 "gram.c"
    break;

  case 2298: /* json_key_uniqueness_constraint_opt: WITHOUT UNIQUE  */
#line 16411 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 49956 "gram.c"
    break;

  case 2299: /* json_key_uniqueness_constraint_opt: %empty  */
#line 16412 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 49962 "gram.c"
    break;

  case 2300: /* json_name_and_value_list: json_name_and_value  */
#line 16417 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49968 "gram.c"
    break;

  case 2301: /* json_name_and_value_list: json_name_and_value_list ',' json_name_and_value  */
#line 16419 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49974 "gram.c"
    break;

  case 2302: /* json_name_and_value: c_expr VALUE_P json_value_expr  */
#line 16429 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 49980 "gram.c"
    break;

  case 2303: /* json_name_and_value: a_expr ':' json_value_expr  */
#line 16432 "gram.y"
                                { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 49986 "gram.c"
    break;

  case 2304: /* json_object_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 16437 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 49992 "gram.c"
    break;

  case 2305: /* json_object_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 16438 "gram.y"
                                                                                { (yyval.boolean) = true; }
#line 49998 "gram.c"
    break;

  case 2306: /* json_object_constructor_null_clause_opt: %empty  */
#line 16439 "gram.y"
                                                                                { (yyval.boolean) = false; }
#line 50004 "gram.c"
    break;

  case 2307: /* json_array_constructor_null_clause_opt: NULL_P ON NULL_P  */
#line 16443 "gram.y"
                                                                                        { (yyval.boolean) = false; }
#line 50010 "gram.c"
    break;

  case 2308: /* json_array_constructor_null_clause_opt: ABSENT ON NULL_P  */
#line 16444 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 50016 "gram.c"
    break;

  case 2309: /* json_array_constructor_null_clause_opt: %empty  */
#line 16445 "gram.y"
                                                                                        { (yyval.boolean) = true; }
#line 50022 "gram.c"
    break;

  case 2310: /* json_value_expr_list: json_value_expr  */
#line 16449 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50028 "gram.c"
    break;

  case 2311: /* json_value_expr_list: json_value_expr_list ',' json_value_expr  */
#line 16450 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 50034 "gram.c"
    break;

  case 2312: /* json_aggregate_func: JSON_OBJECTAGG '(' json_name_and_value json_object_constructor_null_clause_opt json_key_uniqueness_constraint_opt json_output_clause_opt ')'  */
#line 16460 "gram.y"
                                {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50051 "gram.c"
    break;

  case 2313: /* json_aggregate_func: JSON_ARRAYAGG '(' json_value_expr json_array_aggregate_order_by_clause_opt json_array_constructor_null_clause_opt json_output_clause_opt ')'  */
#line 16478 "gram.y"
                                {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50067 "gram.c"
    break;

  case 2314: /* json_array_aggregate_order_by_clause_opt: ORDER BY sortby_list  */
#line 16492 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 50073 "gram.c"
    break;

  case 2315: /* json_array_aggregate_order_by_clause_opt: %empty  */
#line 16493 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 50079 "gram.c"
    break;

  case 2316: /* opt_target_list: target_list  */
#line 16502 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 50085 "gram.c"
    break;

  case 2317: /* opt_target_list: %empty  */
#line 16503 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 50091 "gram.c"
    break;

  case 2318: /* target_list: target_el  */
#line 16507 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 50097 "gram.c"
    break;

  case 2319: /* target_list: target_list ',' target_el  */
#line 16508 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 50103 "gram.c"
    break;

  case 2320: /* target_el: a_expr AS ColLabel  */
#line 16512 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 50115 "gram.c"
    break;

  case 2321: /* target_el: a_expr BareColLabel  */
#line 16520 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 50127 "gram.c"
    break;

  case 2322: /* target_el: a_expr  */
#line 16528 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 50139 "gram.c"
    break;

  case 2323: /* target_el: '*'  */
#line 16536 "gram.y"
                                {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 50156 "gram.c"
    break;

  case 2324: /* qualified_name_list: qualified_name  */
#line 16558 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 50162 "gram.c"
    break;

  case 2325: /* qualified_name_list: qualified_name_list ',' qualified_name  */
#line 16559 "gram.y"
                                                                 { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 50168 "gram.c"
    break;

  case 2326: /* qualified_name: ColId  */
#line 16571 "gram.y"
                                {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 50176 "gram.c"
    break;

  case 2327: /* qualified_name: ColId indirection  */
#line 16575 "gram.y"
                                {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 50184 "gram.c"
    break;

  case 2328: /* name_list: name  */
#line 16581 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50190 "gram.c"
    break;

  case 2329: /* name_list: name_list ',' name  */
#line 16583 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 50196 "gram.c"
    break;

  case 2330: /* name: ColId  */
#line 16587 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50202 "gram.c"
    break;

  case 2331: /* attr_name: ColLabel  */
#line 16589 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50208 "gram.c"
    break;

  case 2332: /* file_name: Sconst  */
#line 16591 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50214 "gram.c"
    break;

  case 2333: /* func_name: type_function_name  */
#line 16602 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50220 "gram.c"
    break;

  case 2334: /* func_name: ColId indirection  */
#line 16604 "gram.y"
                                        {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 50229 "gram.c"
    break;

  case 2335: /* AexprConst: Iconst  */
#line 16615 "gram.y"
                                {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 50237 "gram.c"
    break;

  case 2336: /* AexprConst: FCONST  */
#line 16619 "gram.y"
                                {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50245 "gram.c"
    break;

  case 2337: /* AexprConst: Sconst  */
#line 16623 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50253 "gram.c"
    break;

  case 2338: /* AexprConst: BCONST  */
#line 16627 "gram.y"
                                {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50261 "gram.c"
    break;

  case 2339: /* AexprConst: XCONST  */
#line 16631 "gram.y"
                                {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50274 "gram.c"
    break;

  case 2340: /* AexprConst: func_name Sconst  */
#line 16640 "gram.y"
                                {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50286 "gram.c"
    break;

  case 2341: /* AexprConst: func_name '(' func_arg_list opt_sort_clause ')' Sconst  */
#line 16648 "gram.y"
                                {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50322 "gram.c"
    break;

  case 2342: /* AexprConst: ConstTypename Sconst  */
#line 16680 "gram.y"
                                {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 50330 "gram.c"
    break;

  case 2343: /* AexprConst: ConstInterval Sconst opt_interval  */
#line 16684 "gram.y"
                                {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 50341 "gram.c"
    break;

  case 2344: /* AexprConst: ConstInterval '(' Iconst ')' Sconst  */
#line 16691 "gram.y"
                                {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50353 "gram.c"
    break;

  case 2345: /* AexprConst: TRUE_P  */
#line 16699 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 50361 "gram.c"
    break;

  case 2346: /* AexprConst: FALSE_P  */
#line 16703 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 50369 "gram.c"
    break;

  case 2347: /* AexprConst: NULL_P  */
#line 16707 "gram.y"
                                {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 50377 "gram.c"
    break;

  case 2348: /* Iconst: ICONST  */
#line 16712 "gram.y"
                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 50383 "gram.c"
    break;

  case 2349: /* Sconst: SCONST  */
#line 16713 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50389 "gram.c"
    break;

  case 2350: /* SignedIconst: Iconst  */
#line 16715 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 50395 "gram.c"
    break;

  case 2351: /* SignedIconst: '+' Iconst  */
#line 16716 "gram.y"
                                                                                        { (yyval.ival) = + (yyvsp[0].ival); }
#line 50401 "gram.c"
    break;

  case 2352: /* SignedIconst: '-' Iconst  */
#line 16717 "gram.y"
                                                                                        { (yyval.ival) = - (yyvsp[0].ival); }
#line 50407 "gram.c"
    break;

  case 2353: /* RoleId: RoleSpec  */
#line 16722 "gram.y"
                                {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 50450 "gram.c"
    break;

  case 2354: /* RoleSpec: NonReservedWord  */
#line 16763 "gram.y"
                                {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 50482 "gram.c"
    break;

  case 2355: /* RoleSpec: CURRENT_ROLE  */
#line 16791 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 50490 "gram.c"
    break;

  case 2356: /* RoleSpec: CURRENT_USER  */
#line 16795 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 50498 "gram.c"
    break;

  case 2357: /* RoleSpec: SESSION_USER  */
#line 16799 "gram.y"
                                {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 50506 "gram.c"
    break;

  case 2358: /* role_list: RoleSpec  */
#line 16805 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 50512 "gram.c"
    break;

  case 2359: /* role_list: role_list ',' RoleSpec  */
#line 16807 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 50518 "gram.c"
    break;

  case 2360: /* PLpgSQL_Expr: opt_distinct_clause opt_target_list from_clause where_clause group_clause having_clause window_clause opt_sort_clause opt_select_limit opt_for_locking_clause  */
#line 16824 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 50549 "gram.c"
    break;

  case 2361: /* PLAssignStmt: plassign_target opt_indirection plassign_equals PLpgSQL_Expr  */
#line 16857 "gram.y"
                                {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50564 "gram.c"
    break;

  case 2362: /* plassign_target: ColId  */
#line 16869 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50570 "gram.c"
    break;

  case 2363: /* plassign_target: PARAM  */
#line 16870 "gram.y"
                                                                                        { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 50576 "gram.c"
    break;

  case 2366: /* ColId: IDENT  */
#line 16891 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50582 "gram.c"
    break;

  case 2367: /* ColId: unreserved_keyword  */
#line 16892 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50588 "gram.c"
    break;

  case 2368: /* ColId: col_name_keyword  */
#line 16893 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50594 "gram.c"
    break;

  case 2369: /* type_function_name: IDENT  */
#line 16898 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50600 "gram.c"
    break;

  case 2370: /* type_function_name: unreserved_keyword  */
#line 16899 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50606 "gram.c"
    break;

  case 2371: /* type_function_name: type_func_name_keyword  */
#line 16900 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50612 "gram.c"
    break;

  case 2372: /* NonReservedWord: IDENT  */
#line 16905 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50618 "gram.c"
    break;

  case 2373: /* NonReservedWord: unreserved_keyword  */
#line 16906 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50624 "gram.c"
    break;

  case 2374: /* NonReservedWord: col_name_keyword  */
#line 16907 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50630 "gram.c"
    break;

  case 2375: /* NonReservedWord: type_func_name_keyword  */
#line 16908 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50636 "gram.c"
    break;

  case 2376: /* ColLabel: IDENT  */
#line 16914 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 50642 "gram.c"
    break;

  case 2377: /* ColLabel: unreserved_keyword  */
#line 16915 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50648 "gram.c"
    break;

  case 2378: /* ColLabel: col_name_keyword  */
#line 16916 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50654 "gram.c"
    break;

  case 2379: /* ColLabel: type_func_name_keyword  */
#line 16917 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50660 "gram.c"
    break;

  case 2380: /* ColLabel: reserved_keyword  */
#line 16918 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50666 "gram.c"
    break;

  case 2381: /* BareColLabel: IDENT  */
#line 16924 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 50672 "gram.c"
    break;

  case 2382: /* BareColLabel: bare_label_keyword  */
#line 16925 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50678 "gram.c"
    break;


#line 50682 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 17897 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node	   *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

   return (Node *) n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBoolAConst(bool state, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.boolval.type = T_Boolean;
	n->val.boolval.boolval = state;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.bsval.type = T_BitString;
	n->val.bsval.bsval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeNullAConst(int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->isnull = true;
	n->location = location;

	return (Node *) n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node	   *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				errcode(ERRCODE_SYNTAX_ERROR),
				errmsg("invalid publication object list"),
				errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				parser_errposition(pubobj->location));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid table name"),
						parser_errposition(pubobj->location));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("WHERE clause not allowed for schema"),
						parser_errposition(pubobj->location));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("column specification not allowed for schema"),
						parser_errposition(pubobj->location));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid schema name"),
						parser_errposition(pubobj->location));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
